/* FILE: add_gc_pushs.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			 Revised/UNIX January 25, 1988
			 June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
*/


/* File: psgc.c, being converted 12/25/87, 04:48:55PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  --
.LABEL [<++PSAIL PROCEDURE: ADD!GC!PUSHS>]
.INDEX ++PSAIL PROCEDURE: ADD!GC!PUSHS
DESCRIPTION:
	If doing /GCCODE, then enclose the argument x within 
		GC_PUSHS(x)
unless it either has an existing GC_EPOPS(x) or is a string procedure
name since string procedures automatically do the GC_PUSHS(x) when
they do the GC_RETURN(x).

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:
	It will NOT generate the GC_PUSHS() if the token is FSM10 or
FSM71 since these are procedure argument FSM's. There could be
problems with other FSMs which need to abort the GC_PUSHS.

.ENDLABEL [<++PSAIL PROCEDURE: ADD!GC!PUSHS>]
*/
/*  ---------------------------------------------------- */
void add_gc_pushs(x)
	STRING *x;
{/* ADD!GC!PUSHS */
  STRING 
    s, 
    s1, 
    moretext, 
    id;
  INTEGER 
    isidflag,
    dw, 
    fsm, 
    idx;

  GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
  GC_NOTESTRING(x); /* for G.C. */
  GC_NOTESTRING(s); /* for G.C. */
  GC_NOTESTRING(s1); /* for G.C. */
  GC_NOTESTRING(moretext); /* for G.C. */
  GC_NOTESTRING(id); /* for G.C. */

  GC_EPOPS(dbug(20000000L,catlist(4L,GC_PUSHS("[ADD!GC!PUSHS] x=\'"),
				  GC_PUSHS(*x),
				  GC_PUSHS("\' useGCflag="),
				  pbool(usegcflag))));

  if (usegcflag)
    {/* check what to add since /GCcode */
      if (*(*x)=='G' &&
	  equ(*subsr(GC_PUSHS(*x),1L,9L),GC_PUSHS("GC_EPOPS(")))
	s= subst(GC_PUSHS(*x),10L,length(*x)-1L);
                                      /*  -- optimize 
					  -- 'GC_PUSHS(GC_EPOPS(x))' to
					  -- 'x' since already in PDL */
      else if (*(*x)==*quote ||

/*
 # # @V.53.90 -- NEED to ADD following test so can parse J32S4.SAI
 # # # 	which fails if x is 	'(be) ? "..." : "..."'
 # # #	Pass 'INTEGER dwType' with the call (must modify all calls)
 # # # 	so that we can add:
 # # # 		(x="(" And GDW!pType(dwType)=CODEstring) And
 # # # 		 (dwType Land DW!reference)=0) Or
 # # # 	so as to pick up this case.
 # # # @V.56.151 - added check for FSM10 (CVS etc optimization).
 # # #
*/
	       (*((id= GC_EPOPS(get_c_token(&(s1= *x),
					    &(moretext= PNULL)))))&&
		((isidflag= chk_id(GC_PUSHS(id))) &&
		 ((dw= (*aChkI(decldw,1L,idx=
			       (*aChkI(dwptr,1L,hash_c(GC_PUSHS(id))))))) &
		  0777777677777L) &&
		 (((fsm= ((*aChkI(declfsm,1L,idx))&0777))!=10) &&
		  (fsm!=71)) ||
		 (!isidflag)))) s= catlist(3L,GC_PUSHS("GC_PUSHS("),
					   GC_PUSHS(*x),GC_PUSHS(")"));
      else s= *x;

      GC_EPOPS(dbug(20000000L,catlist(8L,GC_PUSHS("[ADD!GC!PUSHS].1 s=\'"),
				GC_PUSHS(s),
				GC_PUSHS("\' x=\'"),GC_PUSHS(*x),
				GC_PUSHS("\' id=\'"),
				GC_PUSHS(id),GC_PUSHS("\' fsm="),
				cvs(fsm))));
      *x= s;				/*  -- replace it */
    }/* check what to add since /GCcode */

  {GC_UNMARKSSTKFRAME;}
}/* ADD!GC!PUSHS */
