/* FILE: chk_expr_list.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    April 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pschek.c, being converted 12/25/87, 02:41:52PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */

/*  --
.LABEL [<++PSAIL PROCEDURE: CHK!EXPR!LIST>]
.INDEX ++PSAIL PROCEDURE: CHK!EXPR!LIST
DESCRIPTION:
	If s contains a list of SAIL expressions separated by commas,
then Return TRUE. By definition, an expression has matching (), []
and {}.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:
	@V.53.50 - TROUBLE ALERT! What if the delimiters are inside
of a quoted string? Need to scan away the quoted string args...

.ENDLABEL [<++PSAIL PROCEDURE: CHK!EXPR!LIST>]
 */
/*  ----------------------------------------------------- */
INTEGER chk_expr_list(s)
	STRING s;
{/* CHK!EXPR!LIST */
  INTEGER
    val, 
    ch, 
    parencnt, 
    brktcnt, 
    squigglecnt;


  /*  # # DBUG('2000000,"[CHK!EXPR!LIST] s="&s) */

  GC_POPS(s); /* from GC string PDL */
  GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
  GC_NOTESTRING(s); /* for G.C. */
  val= FALSE;
  squigglecnt= parencnt= brktcnt= 0;
  while ((ch= LOP(s))!='\0')
    {/* Count parens and brkts looking for comma */
      if (ch=='(')
	++parencnt; 
      else if (ch==')')
	--parencnt;
      else if (ch=='[')
	++brktcnt; 
      else if (ch==']')
	--brktcnt;
      else if (ch=='{')
	++squigglecnt; 
      else if (ch=='}') 
	--squigglecnt; 
      else if (ch==','&&parencnt==0 &&brktcnt==0 && squigglecnt==0)
	{/* yes, is EXPR list! */
	  val= TRUE;
	  break;
	}/* yes, is EXPR list! */
    }/* Count parens and brkts looking for comma */

  GC_EPOPS(dbug(02000000L,catlist(4L,GC_PUSHS("[CHK!EXPR!LIST].1 val="),
				  pbool(val),
				  GC_PUSHS(" s="),GC_PUSHS(s))));

  GC_NRETURN(val)
}/* CHK!EXPR!LIST */

