/* FILE: chk_iconst.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    April 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pschek.c, being converted 12/25/87, 02:41:52PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  --
.LABEL [<++PSAIL PROCEDURE: CHK!ICONST>]
.INDEX ++PSAIL PROCEDURE: CHK!ICONST
DESCRIPTION:
	Return TRUE is 'sArg' is a simple decimal INTEGER constant 
or a macro which has an INTEGER constant value (whether it is
a macro fragment or not).

SIDE-EFFECTS:
	If true, then FOLD!CONST!EXPR the integer constant and return
its value in iVal.

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: CHK!ICONST>]
 */
/*  --------------------------------------------------- */
INTEGER chk_iconst(sarg,ival)
	STRING sarg;
	INTEGER *ival;
{/* CHK!ICONST */
  STRING 
    s;
  INTEGER 
    idx,
    flag;


  /*  # # DBUG('2000000,"[CHK!ICONST] sArg='"&sArg&"'") */

  GC_POPS(sarg); /* from GC string PDL */
  GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
  GC_NOTESTRING(sarg); /* for G.C. */
  GC_NOTESTRING(s); /* for G.C. */
  s= GC_EPOPS(remove_white_ends(GC_PUSHS(sarg)));

  GC_EPOPS(rmv_integer_cast(GC_PUSHS(s))); /* look at 'clean' integer 
					    * constants */

  if (isalpha(GC_PUSHS(s)) && 
      (idx= (*aChkI(dwptr,1L,hash_c(GC_PUSHS(s))))) &&
      ((*aChkI(decldw,1L,idx))&02000L) && ((*aChkI(declnargs,1L,idx))<=0))
    {/* Expand SAIL fragment */
      /*  # # DBUG('2000000,"[CHK!ICONST].1 declCsym[idx]='"&
	  declCsym[idx]&"'"&CRLF&"  declSize[idx]='"&
	  declSize[idx]&"'") */
      s= (*aChkC(declsize,1L,idx));    /* if declar is const-no problem */
      /*  # # DBUG('2000000,"[CHK!ICONST].1.1 s='"&s&"'") */
    }/* Expand SAIL fragment */

  flag= chk_integer(GC_PUSHS(s));   /* Save some time if integer already! */
  if (!flag)
    {/* try to make it one */
      pushnumber(usefoldingflag); 
      usefoldingflag= TRUE;
      s= GC_EPOPS(fold_const_expr(GC_PUSHS(s))); /* Do the best we can! */
      popnumber(&usefoldingflag);
      flag= chk_integer(GC_PUSHS(s));
    }/* try to make it one */
  if (flag)
    *ival= cvd(GC_PUSHS(s)); 
  else *ival= FALSE;
  GC_EPOPS(dbug(02000000L,catlist(8L,GC_PUSHS("[CHK!ICONST].2 sArg=\'"),
				  GC_PUSHS(sarg),
				  GC_PUSHS("\'"),GC_PUSHS(crlf),
				  GC_PUSHS("  iVal="),cvs(*ival),
				  GC_PUSHS(" flag="),pbool(flag))));


  GC_NRETURN(flag)
}/* CHK!ICONST */
