/* FILE: chk_integer.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    April 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pschek.c, being converted 12/25/87, 02:41:52PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */

/*  --
.LABEL [<++PSAIL PROCEDURE: CHK!INTEGER>]
.INDEX ++PSAIL PROCEDURE: CHK!INTEGER
DESCRIPTION:
	Return TRUE is 'token' is a simple decimal INTEGER. Leading
'+' or '-' is allowed.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: CHK!INTEGER>]
 */

/*  --------------------------------------------------- */
INTEGER chk_integer(token)
	STRING token;
{/* CHK!INTEGER */
  STRING
    s;
  INTEGER
    ch,
    val;


  GC_EPOPS(dbug(02000000L,catlist(3L,GC_PUSHS("[CHK!INTEGER] token=\'"),
				  GC_PUSHS(token), GC_PUSHS("\'"))));
  GC_POPS(token); /* from GC string PDL */
  GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
  GC_NOTESTRING(token); /* for G.C. */
  GC_NOTESTRING(s); /* for G.C. */
  s= token;
  val= TRUE;
  if ((*s=='+') ||(*s=='-')) 
    ch= LOP(s);			/* eat the leading SIGN! */

  while ((ch= LOP(s))!='\0')
    if (!isdigit(ch)) 
      {/* no */
	val= 0L;
	break;
      }/* no */

  GC_EPOPS(dbug(02000000L,catlist(4L,GC_PUSHS("[CHK!INTEGER].1 token=\'"),
				  GC_PUSHS(token),
				  GC_PUSHS("\' val="),pbool(val))));

  GC_NRETURN(val)
}/* CHK!INTEGER */
