/* FILE: chk_name_map.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    April 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pschek.c, being converted 12/25/87, 02:41:52PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  --------------------------------------------------- */
/*INTERNAL*/  STRING chk_name_map(token)
	STRING token;
/*  --------------------------------------------------- */
{/* CHK!NAME!MAP */
/*  --
.LABEL [<++PSAIL PROCEDURE: CHK!NAME!MAP>]
.INDEX ++PSAIL PROCEDURE: CHK!NAME!MAP
DESCRIPTION:
	Check the 'token' against the 'wrdMap[]' hash table. If it is
found there, then map the name by adding a 'P' to it. Test it again,
if we are still in trouble, then give a TRASH!GRAPHIC warning and go
with the original name. The mapped name is returned.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:
	A TRASH-GRAHIC <6>  warning of the form:
	   WARNING!!! Your symbol 'token' and attempted name-map
	   symbol '<generated-symbol>' conflicts with target system
	   library function names. change the name of your symbol!

.ENDLABEL [<++PSAIL PROCEDURE: CHK!NAME!MAP>]
 */
STRING s, 
	s1, 
	s2;
INTEGER h;

;

/*  # # DBUG('10000000,"[CHK!NAME!MAP] token='"&token&"'") */
GC_POPS(token); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(token); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
if (!usenamemapflag) GC_SRETURN(token)	/*  -- not enabled for name mapping */
s= token;			/*  -- default */

h= cv5hash(GC_PUSHS(token));
GC_EPOPS(dbug(010000000L,catlist(4L,GC_PUSHS("[CHK!NAME!MAP].1 token=\'"),GC_PUSHS(token),
        GC_PUSHS("\' h="),cvs(h))));

if ((h!=0))
	{/* try to map it */
	s1= catlist(2L,GC_PUSHS("P"),GC_PUSHS(token));
	if ((h= cv5hash(GC_PUSHS(s1)))==0) s= s1; 
	else 	{/* oops no-can-do */
		s= catlist(2L,GC_PUSHS(s),GC_PUSHS(crlf));
		err_deathwish(&s,
catlist(9L,GC_PUSHS("WARNING!!! Your symbol \'"),GC_PUSHS(token),
        GC_PUSHS("\' and attempted name-map"),GC_PUSHS(crlf),
        GC_PUSHS("symbol\'"),GC_PUSHS(s1),
        GC_PUSHS("\' conflicts with target system library"),
        GC_PUSHS(crlf),
        GC_PUSHS("function names. change the name of your symbol!")),
				6L,(INTEGER)'\0');
		}/* oops no-can-do */
	}/* try to map it */

GC_EPOPS(dbug(010000000L,catlist(4L,GC_PUSHS("[CHK!NAME!MAP].2 s=\'"),GC_PUSHS(s),
        GC_PUSHS("\' h="),cvs(h))));
;
GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 's2'=<L0> string                              */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/


}/* CHK!NAME!MAP */
