/* FILE: chk_number.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    April 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pschek.c, being converted 12/25/87, 02:41:52PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  --------------------------------------------------- */
/*INTERNAL*/  INTEGER chk_number(token)
	STRING token;
/*  --------------------------------------------------- */
{/* CHK!NUMBER */
/*  --
.LABEL [<++PSAIL PROCEDURE: CHK!NUMBER>]
.INDEX ++PSAIL PROCEDURE: CHK!NUMBER
DESCRIPTION:
	Return TRUE is SAIL 'token' is a simple decimal number of the
BNF form:

	<number>::=  <integer> | <real>
	<unsigned>::= <unsigned><digit> | <digit>
	<integer>::= <unsigned> | + <unsigned> | - <unsigned>
	<float>::=   <unsigned> . | <unsigned> . <unsigned> | 
		     . <unsigned>
	<signed-float>::= <float> | + <float> | - <float>
	<E>::=       E | e | @
	<real>::=    <signed-float> | <signed-float> <E> <integer> | 
		     <E> <integer>

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: CHK!NUMBER>]
 */
STRING trash, 
	s;
INTEGER ch, 
	ch1;
INTEGER val;


/*  # # DBUG('2000000,"[CHK!NUMBER] token="&token) */
GC_POPS(token); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(token); /* for G.C. */
GC_NOTESTRING(trash); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
s= token;
val= 1L;
ch= 0;					/*  -- so trap BINARY + or - */
while ((*s!='\0'))
	if (isdigit((INTEGER)*s) ||(*s=='.') ||
	   ( (*s=='E'||*s=='e' ||*s=='@') &&
	     ((ch1= (*(s+2-1)))=='+'||ch1=='-' ||isdigit(ch1))
	   ) ||
	   ((*s=='+'||*s=='-') &&ch==0)) ch= LOP(s); 
	else	{/* no */
		val= 0L;
		break;
		}/* no */
GC_EPOPS(dbug(02000000L,catlist(4L,GC_PUSHS("[CHK!NUMBER].1 token=\'"),GC_PUSHS(token),
        GC_PUSHS("\' val="),pbool(val))));

;
GC_NRETURN(val)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'trash'=<L0> string                           */
/*************************************************/
}/* CHK!NUMBER */
