/* FILE: chk_real.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    April 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pschek.c, being converted 12/25/87, 02:41:52PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  --------------------------------------------------- */
/*INTERNAL*/  INTEGER chk_real(token)
	STRING token;
/*  --------------------------------------------------- */
{/* CHK!REAL */
/*  --
.LABEL [<++PSAIL PROCEDURE: CHK!REAL>]
.INDEX ++PSAIL PROCEDURE: CHK!REAL
DESCRIPTION:
	Return TRUE is 'token' is a simple decimal REAL.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: CHK!REAL>]
 */
STRING trash, 
	s;
INTEGER ch;
INTEGER val, 
	sawdecpt;

/*  # # DBUG('2000000,"[CHK!REAL] token="&token) */
GC_POPS(token); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(token); /* for G.C. */
GC_NOTESTRING(trash); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
s= token;
sawdecpt= 0L;
val= 1L;
while ((*s!='\0'))
	if ((*s=='.'))
		{/* saw decimal point */
		sawdecpt= 1L;
		ch= LOP(s);
		}/* saw decimal point */
	else if ((!isdigit((INTEGER)*s)) &&(*s!='E') &&(*s!='.') &&
		 (*s!='+') &&(*s!='-') &&(*s!='@') &&
		 (*s!='e')) 
		{/* no */
		val= 0L;
		break;
		}/* no */
	else ch= LOP(s);
GC_EPOPS(dbug(02000000L,catlist(6L,GC_PUSHS("[CHK!REAL].1 token=\'"),GC_PUSHS(token),
        GC_PUSHS("\' val="),pbool(val),GC_PUSHS(" sawDecPt="),
        pbool(sawdecpt))));
val=val&&sawdecpt;

;
GC_NRETURN(val)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'trash'=<L0> string                           */
/*************************************************/
}/* CHK!REAL */
