/* FILE: chk_sconst.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    April 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pschek.c, being converted 12/25/87, 02:41:52PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  --------------------------------------------------- */
/*INTERNAL*/  INTEGER chk_sconst(sarg,sval,cvtbslashascii)
	STRING sarg;
	STRING *sval;
	INTEGER cvtbslashascii;
/*  --------------------------------------------------- */
{/* CHK!SCONST */
/*  --
.LABEL [<++PSAIL PROCEDURE: CHK!SCONST>]
.INDEX ++PSAIL PROCEDURE: CHK!SCONST
DESCRIPTION:
	Return TRUE is 'sArg' is a simple quoted STRING constant or a
macro which has an evaled STRING constant value. The string is
returned without enclosing quotes. If switch 'cvtBslashASCII' is true
then convert any '\nnn' codes to the actual ASCII character and any
other '\c' codes map to 'c'.

SIDE-EFFECTS:
	If true, then returns the string in sVal. Added code to be
able to optimize '&' strings
eg.
	"ABC" & "XYZ"  ==> "ABCXYZ"
and 
	Define pdq={" and "}
	"ABC" & pdq & "XYZ" ==> "ABC and XYZ"

	Now test and remove any 'GC_PUSHS()' around strings before
test if a string constant.

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: CHK!SCONST>]
 */
STRING s, 
	s1, 
	s2, 
	moretxt;
INTEGER ch, 
	ih, 
	i, 
	atype, 
	acode;
INTEGER flag;

;

/*  # # DBUG('2000000,"[CHK!SCONST] sArg='"&sArg&"'"&CRLF&" cvtBslashASCII="&PBOOL(cvtBslashASCII)) */

GC_POPS(sarg); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(sarg); /* for G.C. */
GC_NOTESTRING(sval); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(moretxt); /* for G.C. */
flag= 1L;		/*  -- default that we will do it */
s= GC_EPOPS(remove_white_ends(GC_PUSHS(sarg)));

if (*s=='G'&&equ(subsr(GC_PUSHS(s),1L,9L),GC_PUSHS("GC_PUSHS("))) s= subst(GC_PUSHS(s),10L,length(s)-1L);	/*  -- Remove it!!! */

if (*s!=*quote)
	{/* See if symbol */
	i= find_symbol(GC_PUSHS(s),&ch,&ih);
	atype= (*aChkI(decldw,1L,i));
	}/* See if symbol */

else 	{/* a quoted string */
	i= 0;
	atype= 0;
	pdw_ptype(atype,codestring);
	}/* a quoted string */
acode= (((ps_itrash_= (atype&037))>0) ? (ps_itrash_+0140L)
				:0L);
/*  # # DBUG('2000000,"[CHK!SCONST].1 i='"&CVS(i)&"' aCode='"&(ps!sTrash!_aCode)&"'"&CRLF&"  aType='"&CVTYPES(aType)&"'") */

if (i &&(atype&02000L) &&(acode==codestring) &&
	((*aChkI(declnargs,1L,i))==0))
		{/* Expand SAIL fragment */
/*  # # DBUG('2000000,"[CHK!SCONST].1.1 declCsym[i]='"&declCsym[i]&"'"&CRLF&"  declSize[i]='"&declSize[i]&"'") */
		/*  -- if declar is constant no problem */
		if (((*aChkI(decldw,1L,i))&01000L)) flag= 
		0L; else s= (*aChkC(declsize,1L,i));   /*  -- abort on FRAGMENTS! */
/*  # # DBUG('2000000,"[CHK!SCONST].1.2 s='"&s&"'"&CRLF&" flag="&PBOOL(flag)) */
		}/* Expand SAIL fragment */

else if (fast_equ(GC_PUSHS(s),GC_PUSHS("PNULL"))) s= catlist(3L,GC_PUSHS(quote),GC_PUSHS("\\000"),GC_PUSHS(quote)); else if ((acode==codestring) &&((*aChkI(declfsm,1L,i))&0177777)==73) s= GC_EPOPS(fsm73(ih)  )/*  -- eg for COMPILER!BANNER and other
			    -- wierd string which will map here! */; 
else if (*s!=*quote) flag= 0L;	/*  -- sorry */
/*  # # DBUG('2000000,"[CHK!SCONST].1.3 flag="&PBOOL(flag)&CRLF&" |s|="&CVS(s)&" s='"&s&"'") */


s2= s;				/*  -- test for '("...")' then remove () */
if ((ch= LOP(s2))=='('&&*s2==*quote &&(*(s2+length(s2)-1))==')' &&
   *((s1= GC_EPOPS(get_c_token(&s2,&moretxt= PNULL))))==*quote &&((INTEGER)*s2==(INTEGER)')')) s= s1;		/*  -- trash () */
/*  # # DBUG('2000000,"[CHK!SCONST].1.4 s='"&s&"' s1='"&s1&"'") */

s1= s;				/*  -- backup copy */
if (!flag) *sval= PNULL; 
else if ((*s==*quote))
	{/* check if single quoted string */
	moretxt= PNULL;
	moretxt= GC_EPOPS(get_c_token(&s,&moretxt));   /*  -- get entire quoted string */
	if (*s=='\0') 
		{/* YEP! */
		*sval= subst(GC_PUSHS(s1),2L,length(s1)-1L);   /*  -- trash enclosing quotes */
/*  # # DBUG('2000000,"[CHK!SCONST].1.5 sVal='"&sVal&"'") */
		if (cvtbslashascii) map_bkslash_str(sval);
/*  # # DBUG('2000000,"[CHK!SCONST].1.5.1 MAPPED sVal='"&sVal&"'") */
		flag= 1L;
		}/* YEP! */
	else flag= 0L;
	}/* check if single quoted string */
GC_EPOPS(dbug(02000000L,catlist(10L,GC_PUSHS("[CHK!SCONST].2 sArg=\'"),GC_PUSHS(sarg),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  |sVal|="),
        cvs(length(GC_PUSHS(*sval))),GC_PUSHS(" sVal=\'"),
        GC_PUSHS(*sval),GC_PUSHS("\' flag="),pbool(flag))));

;
GC_NRETURN(flag)
}/* CHK!SCONST */
