/* FILE: chk_str_dryrot.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    April 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pschek.c, being converted 12/25/87, 02:41:52PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */



/*  ----------------------------------------------------- */
/*INTERNAL*/  INTEGER chk_str_dryrot(s,msg)
	STRING s;
	STRING msg;
/*  ----------------------------------------------------- */
{/* CHK!STR!DRYROT */
/*  --
.LABEL [<++PSAIL PROCEDURE: CHK!STR!DRYROT>]
.INDEX ++PSAIL PROCEDURE: CHK!STR!DRYROT
DESCRIPTION:
	If the SAIL LENGTH(s) Neq the length of s computed ignoring
NULLs then we have DRYROT error which will be found by observing the
DBUG trace from this point!. If s has DRYROT, then return TRUE else
FALSE. This type of error can only occur using the original SAIL
compiler and may be removed in the portable PSAIL compiler since C
strings are the only type which can exist. NOTE: If LENGTH(s)=0,
then do not bother testing |s|.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: CHK!STR!DRYROT>]
 */
INTEGER val, 
	i, 
	j, 
	lth, 
	ch;
STRING stest;

/*  # # DBUG('2000000,"[CHK!STR!DRYROT] s='"&s&"' LENGTH(s)="&CVS(LENGTH(s))) */
GC_POPS(msg); /* from GC string PDL */
GC_POPS(s); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(msg); /* for G.C. */
GC_NOTESTRING(stest); /* for G.C. */
val= 0L;
if ((lth= length(GC_PUSHS(s)))>0)
	{/* test lengths */
	stest= s;
	j= 0;
	for (i=1;i<=lth;i++)
		if ((ch= LOP(stest))) ++j;
	if (lth!=j)
		{/* DRYROT! */
		val= 1L;
		err_hlr(catlist(28L,GC_PUSHS("[CHK!STR!DRYROT] s=\'"),GC_PUSHS(s),GC_PUSHS(
        "\'"),GC_PUSHS(crlf),GC_PUSHS(" Occured in "),GC_PUSHS(msg),
        GC_PUSHS(crlf),GC_PUSHS(" LENGTH(s)="),
        cvs(length(GC_PUSHS(s))),GC_PUSHS(", |s|="),cvs(j),
        GC_PUSHS(crlf),GC_PUSHS(" blockLevel="),cvs(blocklevel),
        GC_PUSHS(crlf),GC_PUSHS(" rdLevel="),cvs(rdlevel),
        GC_PUSHS(crlf),GC_PUSHS(" rrLevel="),cvs(rrlevel),
        GC_PUSHS(crlf),GC_PUSHS(" saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" cStatement=\'"),GC_PUSHS(cstatement),GC_PUSHS(
        "\'")));
		}/* DRYROT! */
/*  # # DBUG('2000000,"[CHK!STR!DRYROT].1 s='"&s&"' LENGTH(s)="&CVS(LENGTH(s))&" |s|="&CVS(j)) */
	}/* test lengths */

GC_NRETURN(val)
}/* CHK!STR!DRYROT */
