/* FILE: chk_switches.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    April 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pschek.c, being converted 12/25/87, 02:41:52PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  --------------------------------------------------- */
/*INTERNAL*/  void chk_switches(ss)
	STRING ss;
/*  --------------------------------------------------- */
{/* CHK!SWITCHES */
/*  --
.LABEL [<++PSAIL PROCEDURE: CHK!SWITCHES>]
.INDEX ++PSAIL PROCEDURE: CHK!SWITCHES
DESCRIPTION:
	Set specified global boolean switch variables from string
'ss', Note that the initial values were specified in PSMAIN.SAI.

SIDE-EFFECTS:
	Sets boolean variables and also may set other parameters.
Some procedure calls may also be made with various other side
effects.

PROBLEMS/KNOWN-BUGS:
	Can not handle UNIX style switches at this time. This will be
chaged when we are up and running on a UNIX machine.

.ENDLABEL [<++PSAIL PROCEDURE: CHK!SWITCHES>]
 */
	/*  -- We need the following special macro to debug the switch
	  -- that turns on debugging into the output file!!! To enable
	  -- debugging take # # # out otherwise insert in front
	  -- of the PRINT() statement */
/* IFC EVAL(is_sail)=0 */
 /* THENC <<<FAILED!!!>>>

define dbug1(c,s)=\Begin "DBUG1"
# # # 		PRINT("{{{"&(s)&"}}}"&CRLF);
		DBUG((c),(s));
		End "DBUG1"\;
  */ /* ENDC */

/* IFC EVAL(is_psail)=1 */
/* THENC */

#define dbug1(c,s) {"DBUG1"\
/*  _2 _2 		print("{{{"&(s)&"}}}"&crlf) */\
		GC_EPOPS(dbug(c,GC_PUSHS(s)));\
		}/* DBUG1 */
  /* ENDC */ /*  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

STRING ss1, 
	ss2, 
	ss3, 
	tok, 
	sw, 
	sw1;
INTEGER ii, 
	jj, 
	kk, 
	vtrue, 
	vfalse, 
	h, 
	opsw;
#define maxsw 46	/*  -- NOTE WELL - keep sorted alphabetically */
 static STRING /*ARRAY*/ 
/******************************************************************/
/* WARNING! Can't have OWN STRING declarations in non-MAIN module */
/* or inner blocks! Suggest you move 'STRING swname' declaration  */
/* to global level in MAIN module and recompile.                  */
/******************************************************************//*N.P.*/
/***************************/
/*<7>    ..                */
/*      .                  */
/*   /----------\          */
/*   | o         _______/  */
/*   |__         -------\  */
/*   \----------/          */
/*                         */
/*   A GROSS MOBY          */
/***************************/

P_swname[26+(46-0+1L)] = { 
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, PNULL,
   		/*  -- failure -- */
   	"BA",		/*  -- /BAIL -- */
   	"BI",		/*  -- /BIts:<letter-list> -- */
   	"BL",		/*  -- /BLockWarning -- */
   	"CA",		/*  -- /CAlltrace -- */
   	"CH",		/*  -- /CHeckarray -- */
   	"CL",		/*  -- /CLutter -- */
   	"COE",		/*  -- /COErce -- */
   	"COM",		/*  -- /COMment -- */
   	"CONC",		/*  -- /CONCat -- */
   	"COND",		/*  -- /CONDitional eval -- */
   	"COU",		/*  -- /COUntFSM:NOW -- */
   	"CR",		/*  -- /CRlf -- */
   	"DEB",		/*  -- /DEBug:0nnnn -- */
   	"DEF",		/*  -- /DEFine:<id>=<const> -- */
   	"DO",		/*  -- /DOuble -- */
   	"ER",		/*  -- /ERror:<opt Backtrace> -- */
   	"EV",		/*  -- /EVal conditionals -- */
   	"EX",		/*  -- /EXtensions -- */
   	"F",		/*  -- /FoldConstExpr -- */
   	"G",		/*  -- /GCcode -- */
   	"HE",		/*  -- /HElp -- */
   	"LE",		/*  -- /LEap -- */
   	"LOC",		/*  -- /LOCalFile -- */
   	"LOG",		/*  -- /LOGo -- */
   	"MAINSAIL",	/*  -- /MAINSAIL -- */
   	"MAK",		/*  -- /MAKeRequireFile:<opt.Filename> -- */
   	"MAT",		/*  -- /MATh -- */
   	"NA",		/*  -- /NAmeMap:f1,f2,...fN -- */
   	"NU",		/*  -- /NUl: -- */
   	"MO",		/*  -- /MODule -- */
   	"O",		/*  -- /OutputSAIL -- */
   	"PRE",		/*  -- /PREttyPrint:w,n -- */
   	"PROC",		/*  -- /PROCesses -- */
   	"PROF",		/*  -- /PROFiling -- */
   	"PSAI",		/*  -- /PSAILlLibrary:[PPN] -- */
   	"REA",		/*  -- /REAl:<type> -- */
   	"REP",		/*  -- /REPort:now -- */
   	"REQ",		/*  -- /REQuire -- */
   	"SC",		/*  -- /SCreen -- */
   	"SL",		/*  -- /SLob -- */
   	"ST",		/*  -- /STringStackFrameFactor:f -- */
   	"T",		/*  -- /Timer -- */
   	"UND",		/*  -- /UNDf -- */
   	"UNI",		/*  -- /UNIque:n -- */
   	"W",		/*  -- /WarningBits:0nnnn -- */
   	"#" };
 static STRING /*ARRAY*/ 
/******************************************************************/
/* WARNING! Can't have OWN STRING declarations in non-MAIN module */
/* or inner blocks! Suggest you move 'STRING swname' declaration  */
/* to global level in MAIN module and recompile.                  */
/******************************************************************//*N.P.*/
/***************************/
/*<7>    ..                */
/*      .                  */
/*   /----------\          */
/*   | o         _______/  */
/*   |__         -------\  */
/*   \----------/          */
/*                         */
/*   A GROSS MOBY          */
/***************************/

*swname  /* [0:maxsw] */ ;


/* #define get_a_number(x,s) begin\
			  trash_left_ws(s);\
			  x:=(if s neq "0" then cvd(s) else cvo(s));\
			  end ====> PSAIL!EVAL */

;

GC_POPS(ss); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(ss); /* for G.C. */
GC_NOTESTRING(ss1); /* for G.C. */
GC_NOTESTRING(ss2); /* for G.C. */
GC_NOTESTRING(ss3); /* for G.C. */
GC_NOTESTRING(tok); /* for G.C. */
GC_NOTESTRING(sw); /* for G.C. */
GC_NOTESTRING(sw1); /* for G.C. */
GC_NOTEASTRING(swname);	/* for G.C. */
swname = aryHdrC(P_swname,1,0,46,"swname",'c');	/* Dynamic Array */
ss= GC_EPOPS(cvupcase(GC_PUSHS(ss)));	/*  -- Only test upper case so map to upper case */
GC_EPOPS(dbug1(02000000L,catlist(3L,GC_PUSHS("[CHK!SWITCHES] String ss=\'"),GC_PUSHS(ss),
        GC_PUSHS("\'"))));

sw= GC_EPOPS(scan(&ss,21L,&jj));  		/*  -- Scan for '/'. Trash <left> stuff  */
while ((*ss!='\0'))
	{/* test switches */
/*  # # DBUG1(('2000000,"[CHK!SWITCHES].1 ss='"&ss&"'") */
	sw= GC_EPOPS(scan(&ss,21L,&jj));  /*  -- Scan for NEXT '/'. */
/*  # # DBUG1(('2000000,"[CHK!SWITCHES].1.1 sw='"&sw&"' ss='"&ss&"'") */
	if (*sw=='\0') continue;
	vtrue= 1L;		/*  -- Default values */
	vfalse= 0L;
	if (equ(subsr(GC_PUSHS(sw),1L,2L),GC_PUSHS("NO")))
		{/* /NO reverse TRUE and FALSE */
		vtrue= 0L;
		vfalse= 1L;
		sw= subst(GC_PUSHS(sw),3L,length(sw));	/*  -- set up for pattern match */
		while ((*sw!='\0') &&iswhitespace((INTEGER)*sw)) ps_itrash_= LOP(sw);
		}/* /NO reverse TRUE and FALSE */
	opsw= 0;		/*  -- default as no switch */
	for (jj=1;jj<=46L;jj++)
		if (equ(GC_PUSHS((*aChkC(swname,1L,jj))),subsr(GC_PUSHS(sw),1L,length(GC_PUSHS((*aChkC(swname,1L,jj)))))))
			{/* found it */
			opsw= jj;
			break;
			}/* found it */

		ss1= GC_EPOPS(scan(&sw,13L,&jj));	/*  -- Set 'sw' to start at arg
					     after ':' if any */
/*  # # DBUG1(('2000000,"[CHK!SWITCHES].1.2 opSW="&CVS(opSW)&" swName[opSW]='"&swName[opSW]&"'"&CRLF&" vTRUE="&PBOOL(vTRUE)&" sw='"&sw&"'") */

	switch (opsw)
		{/* Gigundous Switch list */
/*--no-op--*/	case 0: break;  

/*/BAIL*/		case 1: bailswitch= vtrue; break;

/*/BITS:<letter-list>*/	case 2: {/* /BITS:<letter-list> */
		bitspsail= 0L;		/*  -- default is NO bits set!! */
			/*  -- 'sw' arg set for <letter-list> */
		while (((jj= LOP(sw))!='\0'))
			if ('A'<=jj && jj<='Z') bitspsail=bitspsail|(LSH(1L,('Z'-jj)));; break;
		}/* /BITS:<letter-list> */

/*/BLockWarning*/	case 3: noblocklabelwarningflag= vfalse; break;

/*/CAlltrace*/	case 4: {/* /CAllTrace all procedure calls to <saiFile>.TRC */
		if (vfalse)
			{/* close it */
			if ((ctrchan!=-1)) release(1L,ctrchan);
			ctrchan= -1L;
			}/* close it */
		else if (ctrchan==-1)
			{/* open trace file */
			ctrchan= PSgetchan();  /*  -- was -1 ==> /NOcallTrace */
			ss2= ctrfile;	/*  -- build <saiFile>&'.trc'  */
			ctrfile= GC_EPOPS(scan(&ss2,11L,&jj));    /*  -- for . or [  */
			ctrfile= catlist(2L,GC_PUSHS(ctrfile),GC_PUSHS(".trc"));
			PSopen(ctrchan,GC_PUSHS("DSK"),0L,0L,1L,&(ctrcount= 256L),
						&ctrbrk,&ctreof);
			enter(ctrchan,GC_PUSHS(ctrfile),&ctrerr);
			if (ctrerr)
				{/* error abort it */
				release(1L,ctrchan);
				ctrchan= -1L;
				}/* error abort it */
			ss2= catlist(5L,GC_PUSHS("/CHECKTRACE:"),GC_PUSHS(ctrfile),GC_PUSHS(" "),
        todays_date(),GC_PUSHS(crlf));
			PSprintf("%s",GC_PUSHS(ss2));	/*  -- echo to terminal */
			out(ctrchan,GC_PUSHS(ss2));	/*  -- ==> .TRC file */
			}/* open trace file */; break;
		}/* /CAllTrace all procedure calls to <saiFile>.TRC */
/*/CHeck*/	case 5: usechkflag= vtrue; break;

/*/CLutter*/	case 6: useclutterflag= vtrue; break;

/*/COErce*/	case 7: usecoerceflag= vtrue; break;

/*/COMment*/	case 8: usecommentflag= vtrue; break;

/*/CONCat*/	case 9: useconcatflag= vtrue; break;

/*/CONDitional eval*/	case 10: useifcevalflag= vtrue; break;

/*/COUNTFSM:NOW*/	case 11: {/* /COUNTFSM:NOW */
		if (0L) continue;
		usereportflag= usecntfsmflag= vtrue; /*/COUNTFSM*/
		 /*  -- 'sw' arg, check if NOW option */
		if (*sw=='N') err_report();  /*  -- do it NOW!!!! */; break;
		}/* /COUNTFSM:NOW */

/*/CRlf*/		case 12: usecrlfflag= vtrue; break;

/*/DEBug:0nnnn*/	case 13: {/* /DEBUG:0nnnn - get code */
		if (0L) continue;
		debugswitch= vtrue; /*/DEBug*/
		/*  -- 'sw' arg scanned to : */
		if (equ(subsr(GC_PUSHS(sw),1L,3L),GC_PUSHS("OFF"))  ||vfalse)
			{/* shut off the bugger */
			debugswitch= 0L;
			outputsailswitch= 0L; /*/NOOutputSail*/
			dbugcode= 0L;
			PSprintf("%s",catlist(3L,GC_PUSHS(crlf),
			GC_PUSHS("DEBUGGING is disabled!"),
			        GC_PUSHS(crlf)));
			}/* shut off the bugger */
		else 	if (vtrue)
			{/* Enable debugging */
			{while ((*sw!='\0') &&iswhitespace((INTEGER)*sw)) ps_itrash_= LOP(sw);
			  dbugcode= ((*sw!='0') ? cvd(GC_PUSHS(sw)) : cvo(GC_PUSHS(sw)));
			  }
			PSprintf("%s",GC_PUSHS(
			        				catlist(GC_PUSHS(crlf),
			        GC_PUSHS("Enabling DEBUGGING with DBUG code=0"),cvos(
			        dbugcode),GC_PUSHS(crlf))));
			outputsailswitch= vtrue;
			}/* Enable debugging */; break;
		}/* /DEBUG:0nnnn - get code */

/*/DOuble*/	case 14: promotedouble= ((vtrue) ?  
				"(double)" : PNULL); break;

/*/DEFine:<id>=<const>*/	case 15: {/* /DEFine:<id>=<const> */
		/*  -- 'sw' arg set to <id> */
		ss1= catlist(4L,GC_PUSHS("define "),cvlower(GC_PUSHS(sw)),GC_PUSHS(";"),
        GC_PUSHS(crlf));
		if (lineoneflag==-1)
			{/* insert it into the preDefList */
			if (*predeflist=='\0') predeflist= ss1; 
			else predeflist= catlist(2L,GC_PUSHS(ss1),GC_PUSHS(predeflist));
			}/* insert it into the preDefList */
		else	{/* insert it into the saiStatement */
			if (*saistatement=='\0') saistatement= ss1; 
			else saistatement= catlist(2L,GC_PUSHS(ss1),GC_PUSHS(saistatement));
			}/* insert it into the saiStatement */; break;
		}/* /DEFine:<id>=<const> */

/*/ERror:B*/	case 16: {/* /ERror:<opt. BACKTRACE> */
		yeserrorflag= vfalse;
		/*  -- 'sw' arg set, check if BACKTRACE option */
		usebacktraceflag= (*sw=='B');; break;
		}/* /ERror:<opt. BACKTRACE> */

/*/EVal conditionals*/	case 17: evalmacros= vtrue; break;

/*/EXtensions*/	case 18: {/* /EXtensions */
		useextensionsflag= vtrue; /*/EXtensions*/ 
		if (useextensionsflag &&(dclsymptr>0)) 
			{/* load up EXTENSIONS symbols */
/*  # # DBUG1(('2000000,"[CHK!SWITCHES].2 useEXTENSIONSflag="&PBOOL(useEXTENSIONSflag)) */
			set_extensions(useextensionsflag);
			}/* load up EXTENSIONS symbols */
		else if (!useextensionsflag)
			{/* REMOVE THEM! */
			PSprintf("%s",GC_PUSHS(
			        		catlist(GC_PUSHS(crlf),
			        GC_PUSHS("---> No /NOEXTENSIONS allowed at this time!!!")
			,
			        GC_PUSHS(crlf))));
			}/* REMOVE THEM! */; break;
		}/* /EXtensions */

/*/FoldConstExpr*/	case 19: usefoldingflag= vtrue; break;

/*/GCcode*/	case 20: usegcflag= vtrue; break;

/*/HElp*/		case 21: {/* /HElp */
		PSprintf("%s",readfile(GC_PUSHS("PSHELP.TXT")));
		saifile= PNULL; /*Force new question*/; break;
		}/* /HElp */

/*/LEap*/		case 22: ps__leap_= ((vtrue) ?  
				"/*LEAP*/" : PNULL); break;

/*/LOCalFile*/	case 23: uselocalfilesflag= vtrue; break;

/*/LOGo*/		case 24: {/* /LOGo */
		nologoflag= vfalse; /*/LOgo*/
		if (vfalse) (*aChkC(deathwish,1L,0L))= PNULL;  /*  -- just this one */; break;
		}/* /LOGo */

/*/MAINSAIL*/	case 25: {/* /MAINSAIL */
/*  -- NOTE: we only set the flag here. The USE of the flag in other
parts of PSAIL is controlled by the PARSEMAINSAIL macro defined in
parameter file PSPARAM.REQ.
 */
		mainsailflag= vtrue;; break;
		}/* /MAINSAIL */

/*/MAKeReqFile:<opt.F>*/	case 26: {/* /MAKeRequireFile:<opt. file> */
		/*  -- use make require file */
		usemkrfileflag= vtrue;
		/*  -- 'sw' arg set, look for filename  */
		while ((*sw!='\0') &&iswhitespace((INTEGER)*sw)) ps_itrash_= LOP(sw);
		if (jj==':') mkrfile= sw; 
		else mkrfile= catlist(2L,scan(&(ss3= saifile),11L,&jj) ,GC_PUSHS(".RQU"));
		PSprintf("%s",catlist(4L,GC_PUSHS("Making /REQUIRE file: "),
		GC_PUSHS(mkrfile),
		        GC_PUSHS(oppn),GC_PUSHS(crlf)));; break;
		}/* /MAKeRequireFile:<opt. file> */

/*/MATh*/		case 27: {/* /MATh - use <psrun9.c> */
		usepmathflag= vtrue;	/*  -- /MATH */
		promotedouble= ((vtrue) ?  
				"(float)" 
			       : "(double)");; break;
		}/* /MATh - use <psrun9.c> */

/*/NAmeMap:<fLst>*/	case 28: {/* /NAmeMap:f1,...,fn */
		usenamemapflag= vtrue;
		if (usenamemapflag)
			{/* set up Fresh name-map hash table */
			/*  -- 'sw' set to list of files if any */
			GC_EPOPS(remove_white_ends(GC_PUSHS(ss)));
			if (*sw=='\0') ss= "PSNAME.MAP"; /*  -- default */
			arrclr(wrdmap,0L);	/*  -- clear hash table */
			while ((*sw!='\0'))
				{/* add next file */
				ss3= GC_EPOPS(scan(&sw,6L,&jj));  /*  -- for ',' no WS */
				while ((*sw!='\0') &&iswhitespace((INTEGER)*sw)) ps_itrash_= LOP(sw);
				ss2= GC_EPOPS(readfile(GC_PUSHS(ss3)));
				if (*ss2=='?') PSprintf("%s",GC_PUSHS(ss2)); 
				else while ((*ss2!='\0'))
					{/* add to hash table */
					if (*ss2=='<')
						{/* get title */
						ss3= 
        						   catlist(GC_PUSHS(LOP(ss2)),scan(&ss2,23L,&jj),
        GC_PUSHS(">")); /*  -- up
							to the '>' */
						}/* get title */
					while ((*ss2!='\0') &&iswhitespace((INTEGER)*ss2)) ps_itrash_= LOP(ss2);
					ss3= PNULL;
					tok= GC_EPOPS(get_c_token(&ss2,&ss3));
					if (*tok!='\0')
						{/* add it */
						h= cv5hash(GC_PUSHS(tok));
						if (h==0) 
						   (*aChkI(wrdmap,1L,lasthfree))= cv5int(GC_PUSHS(tok));
						}/* add it */
					}/* add to hash table */
				}/* add next file */
			}/* set up Fresh name-map hash table */; break;
		}/* /NAmeMap:f1,...,fn */

/*/NUl*/	case 29: (*aChkI(reqoutput,1L,reqlevel))= nuldevflag= vtrue; break;	/*  -- /NUl  */

/*/MOdule*/	case 30: usemoduleflag= vtrue; break;

/*/OutputSAIL*/	case 31: outputsailswitch= vtrue; break;

/*/PREttyPrint:w,n*/	case 32: {/* /PREttyPrint:w,n - set up parameters */
		prttyprintflag= vtrue; /*/PREtty print*/
		maxlinelthpp= 72L;	/*  -- default char/line */
		lthwspp= 2L;	/*  -- default spaces/block-level */
		/*  -- 'sw' set to args if any  */
		ss1= GC_EPOPS(scan(&sw,19L,&jj));	/*  -- scan first number  */
		while ((*ss1!='\0') &&iswhitespace((INTEGER)*ss1)) ps_itrash_= LOP(ss1);
		ss2= GC_EPOPS(scan(&sw,19L,&jj));  	/*  -- scan second number  */
		while ((*ss2!='\0') &&iswhitespace((INTEGER)*ss2)) ps_itrash_= LOP(ss2);
		{while ((*ss1!='\0') &&iswhitespace((INTEGER)*ss1)) ps_itrash_= LOP(ss1);
			  kk= ((*ss1!='0') ? cvd(GC_PUSHS(ss1)) : cvo(GC_PUSHS(ss1)));
			  }
		if (isdigit((INTEGER)*ss1)) maxlinelthpp= MAX(20L,(MIN(kk,256L)));
		{while ((*ss2!='\0') &&iswhitespace((INTEGER)*ss2)) ps_itrash_= LOP(ss2);
			  kk= ((*ss2!='0') ? cvd(GC_PUSHS(ss2)) : cvo(GC_PUSHS(ss2)));
			  }
		if (isdigit((INTEGER)*ss2)) lthwspp= (MAX(1L,(MIN(kk,20L))));
		PSprintf("%s",GC_PUSHS(
		        			catlist(GC_PUSHS("Pretty-printing max line length="),
		        cvs(maxlinelthpp),GC_PUSHS(", spaces/block-level="),
		        cvs(lthwspp),GC_PUSHS(crlf))));; break;
		}/* /PREttyPrint:w,n - set up parameters */

/*/PROCesses*/	case 33: useprocessesflag= vtrue; break;

/*/PROFiling*/	case 34: useprfileflag= vtrue; break;

/*/PSAIlLibrary:[ppn]*/	case 35: {/* /PSAIlLibrary:[ppn] */
		/*  -- change the PSAIL library account */
		/*  -- 'sw' set to new library name arg */
		while ((*sw!='\0') &&iswhitespace((INTEGER)*sw)) ps_itrash_= LOP(sw);
		usepsaillibrary= sw;
		PSprintf("%s",catlist(3L,GC_PUSHS("Use PSAIL library on "),
		GC_PUSHS(usepsaillibrary)
		        ,GC_PUSHS(crlf)));; break;
		}/* /PSAIlLibrary:[ppn] */

/*/REAL:<type>*/	case 36: {/* /REAL:<type> */
		INTEGER idx, 
		hs, 
		code;
		hs= hash_c(GC_PUSHS("real"));
		/*  -- 'sw' set to <type> arg */
		while ((*sw!='\0') &&iswhitespace((INTEGER)*sw)) ps_itrash_= LOP(sw);
		if (*sw=='D') userealflag= vfalse; 
		else if (*sw=='F'||*sw=='S') userealflag= vtrue;
		if (hs!=0)
			{/* update SYMTAB */
			idx= (*aChkI(dwptr,1L,hs));
			ss3= ((userealflag) ?  
				"float" : "double");
			code= ((userealflag) ?  
				codereal : codedouble);
			pdw_ptype((*aChkI(decldw,1L,idx)),code);
			(*aChkC(declcsym,1L,idx))= ss3;
			}/* update SYMTAB */; break;
		}/* /REAL:<type> */

/*/REPORT:NOW*/	case 37: {/* /REPORT:NOW */
		usereportflag= vtrue; /*/REPorts*/
		/*  -- 'sw' set to arg, check if NOW option */
		if (*sw=='N') err_report();  /*  -- do it NOW!!!! */; break;
		}/* /REPORT:NOW */

/*/REQuire*/	case 38: userequireflag= vtrue; break;

/*/SCreen*/	case 39: screenflag= vtrue; break;

/*/SLob*/		case 40: {/* /SLob - no WARNING!!! */
		slobflag= vtrue; /*/SLob*/
		if (vtrue)
			{/* set warnings */
			ps__leap_= "/*LEAP*/";
			ps__undf_= "/*UNDF*/";
			ps_warning_= "/*WARNING*/";
			warnlevel= 01777L;  /*  -- set all bits */
			if (warnlevel!=01777) readtrash_graphics(&deathwish,
							GC_PUSHS("PSAIL.TGF"));
			}/* set warnings */
		else	{/* clear warnings */
			ps__leap_= PNULL;
			ps__undf_= "/*UNDF*/";
			ps_warning_= PNULL;
			warnlevel= 0L;
			}/* clear warnings */; break;
		}/* /SLob - no WARNING!!! */

/*/STringStackFrameFactor:f*/	case 41: {/* /STringStackFrameFactor:f */
		/*  -- 'sw' set to arg, get arg f */
		ssffactor= realscan(&sw,&jj);
		if (ssffactor<=0) ssffactor= 0.01;; break;
		}/* /STringStackFrameFactor:f */

/*/Timer*/	case 42: usetimerflag= vtrue; break;

/*/UNDf*/		case 43: ps__undf_= ((vtrue) ?  
				"/*UNDF*/" : PNULL); break;

/*/UNIque:n*/	case 44: {/* /UNIque:n - get size */
		uniqflag= vtrue; /*/UNIque:n*/
		/*  -- 'sw' set to arg, get n arg if any  */
		{while ((*sw!='\0') &&iswhitespace((INTEGER)*sw)) ps_itrash_= LOP(sw);
			  uniqwidth= ((*sw!='0') ? cvd(GC_PUSHS(sw)) : cvo(GC_PUSHS(sw)));
			  }
		if (uniqwidth==0) uniqwidth= 8L;	/*  -- n<0 means also
						 list symbols */; break;
		}/* /UNIque:n - get size */

/*/WarningBits:0nnnn*/	case 45: {/* /WarningBits:0nnnn - get warning level */
		/*  -- 'sw' set to arg, get nnnn arg if any */
		{while ((*sw!='\0') &&iswhitespace((INTEGER)*sw)) ps_itrash_= LOP(sw);
			  warnlevel= ((*sw!='0') ? cvd(GC_PUSHS(sw)) : cvo(GC_PUSHS(sw)));
			  }
		warnlevel=warnlevel&01777;; break;
		}/* /WarningBits:0nnnn - get warning level */

/*/#*/		case 46: {/* /# - enable # as symbol */
		INTEGER idx, 
		cn, 
		hn, 
		oldflag;
		oldflag= nbrcmtflag;
		nbrcmtflag= vtrue; /*/#*/ 
		if (nbrcmtflag)
			{/* make # */
			if (dclsymptr>0) add_builtin(GC_PUSHS("L0:#,comment,10,"));
				/*  -- to existing symtab */
			}/* make # */
		else if (oldflag &&
			((idx= find_symbol(GC_PUSHS("#"),&cn,&hn))!=0) &&
			((*aChkI(declfsm,1L,idx))&017777)==10)
			{/* delete # */
			GC_EPOPS(rem_symbols(idx,idx));
			}/* delete # */; break;
		}/* /# - enable # as symbol */
		}/* Gigundous Switch list */
	}/* test switches */

if (!ismacroflag)
	emitenableflag= (usegcflag ||usechkflag ||useleapflag ||
		useprfileflag);		/*  -- ok to EMIT!LOC!CODE
					in PROCESS!TOKEN... */
;
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'ii'=<L0> integer                             */
/* 'sw1'=<L0> string                             */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/
#undef maxsw
#undef dbug1
{GC_UNMARKSSTKFRAME;}
}/* CHK!SWITCHES */
