/* FILE: chk_type.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    April 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pschek.c, being converted 12/25/87, 02:41:52PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  --------------------------------------------------- */
/*INTERNAL*/  INTEGER chk_type(id)
	STRING id;
/*  --------------------------------------------------- */
{/* CHK!TYPE */
/*  --
.LABEL [<++PSAIL PROCEDURE: CHK!TYPE>]
.INDEX ++PSAIL PROCEDURE: CHK!TYPE
DESCRIPTION:
	Return DW (descriptor word) 'SAIL declaration' type of 'id'.
Recursively EVAL until discover the type. Try to do it without doing
a full blown R!D as in R!D!EXPR!MAP.

SIDE-EFFECTS:
	May call GETID, RIGHTID, HASH!C, COPY!OMIT.

PROBLEMS/KNOWN-BUGS:
	Very slow - find other ways to test a type if possible.

.ENDLABEL [<++PSAIL PROCEDURE: CHK!TYPE>]
 */

STRING s, 
	s1;
INTEGER idx, 
	h, 
	ch, 
	dw, 
	type;

;

/*  # # DBUG('2000000,"[CHK!TYPE] String id="&id) */
GC_POPS(id); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(id); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
s1= PNULL;
type= h= idx= 0;
if (*id==*quote||fast_equ(GC_PUSHS(id),GC_PUSHS("null"))) pdw_ptype(type,codestring); 

	else if (*id==*singlequote||chk_integer(GC_PUSHS(id)) ||
		fast_equ(GC_PUSHS(id),GC_PUSHS("true")) ||fast_equ(GC_PUSHS(id),GC_PUSHS("false"))) pdw_ptype(type,codeinteger); 

	else if (chk_real(GC_PUSHS(id))) pdw_ptype(type,codereal); 

	else if (!chk_id(GC_PUSHS(id))) 
		{/* peal off first id */
		s1= id;
		if (isalpha(GC_PUSHS(id))) id= GC_EPOPS(getid(&s1,&ch)
		); else	{/* get past ('s etc */
			while ((*s1!='\0') &&!isvariable((INTEGER)*s1)) ch= LOP(s1);
			id= GC_EPOPS(rightid(&s1));
			}/* get past ('s etc */
		}/* peal off first id */

if ((((ps_itrash_= (type&037))>0) ? (ps_itrash_+0140L)
				:0L)==0)
	{/* keep testing */
	if ((idx= (*aChkI(dwptr,1L,h= hash_c(GC_PUSHS(id)))))>0) 
		{/* symbol in user symtab */
		type= (*aChkI(decldw,1L,idx));
/*  # # DBUG('2000000,"[CHK!TYPE].1 idx="&CVS(idx)&CRLF&" type='"&CVTYPES(type)&"'") */
		if ((idx>0) &&(dw&02000L)) 
			{/* eval macro definition */
/*  # # @V.52.181		id_declCsym[idx] */  /*  -- Get macro defn */
			id= (*aChkC(declsize,1L,idx));  /*  -- Get macro defn */
/*  # # DBUG('2000000,"[CHK!TYPE].1.1 id="&id&" h="&CVS(h)) */
			type= chk_type(GC_PUSHS(id));
			}/* eval macro definition */
/*  # # DBUG('2000000,"[CHK!TYPE].1.2 type="&CVTYPES(type)&CRLF&" h="&CVS(h)) */

/*  # # @V.44.86 PROBLEM: id may only be a single token keyword - i.e.
not the complete expression! */
		if (h==hif||h==hcase)
			{/* Get type of EXPR */
			push(GC_PUSHS(saistatement));
			saistatement= s1;
/*  # # DBUG('2000000,"[CHK!TYPE].2.1 <expr> s1="&s1&" h="&CVS(h)) */
			if (h==hif) 
				{/* get THEN expr */
				s1= GC_EPOPS(copy_omit(GC_PUSHS("then")));
				while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
				id= GC_EPOPS(rightid(&saistatement));
				}/* get THEN expr */
			else if (h==hcase) 
				{/* get CASE expr */
				s1= GC_EPOPS(copy_omit(GC_PUSHS("of")));
				s1= GC_EPOPS(copy_omit(GC_PUSHS(",)")));
				id= GC_EPOPS(rightid(&s1));
				while ((*id!='\0') &&iswhitespace((INTEGER)*id)) ps_itrash_= LOP(id);
				}/* get CASE expr */
			pop(&saistatement);
/*  # # DBUG('2000000,"[CHK!TYPE].2.2 TYPE="&TYPE) */
			push(GC_PUSHS(id)); push(GC_PUSHS(s1));
			type= chk_type(GC_PUSHS(id));   /*  -- recursive call */
			pop(&s1); pop(&id);
/*  # # DBUG('2000000,"[CHK!TYPE].2.3 type='"CVOS(type)&"'(8)='"&CVTYPES(type)&"'"&CRLF&"  h="&CVS(h)) */
			}/* Get type of EXPR */
		}/* symbol in user symtab */

	else if (h>0) 
		{/* --- BUG??? should not need this--- */
		type= (*aChkI(decldw,1L,idx));
GC_EPOPS(dbug(02000000L,catlist(4L,GC_PUSHS("[CHK!TYPE].2.4 DRYROT type=\'"),cvos(type),
        GC_PUSHS("\' h="),cvs(h))));
		}/* --- BUG??? should not need this--- */

/*  # # @V.52.62 	Else	If ISSTRFCT(id)
		Then PDW!pType(type,CODEstring)
	 */}/* keep testing */
GC_EPOPS(dbug(02000000L,catlist(10L,GC_PUSHS("[CHK!TYPE].3 id=\'"),GC_PUSHS(id),
        GC_PUSHS("\' idx="),cvs(idx),GC_PUSHS(" h="),cvs(h),
        GC_PUSHS(crlf),GC_PUSHS(" type=\'"),cvtypes(type),
        GC_PUSHS("\'"))));

GC_NRETURN(type)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 's'=<L0> string                               */
/*************************************************/
}/* CHK!TYPE */
