/* FILE: cv5hash.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pscvt.c, being converted 12/25/87, 03:15:56PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------ */
 /*INTERNAL*/ INTEGER cv5hash(token)
	STRING token;
/*  ------------------------------------------------------ */
{/* CV5HASH */
/*  --
.LABEL [<++PSAIL PROCEDURE: CV5HASH>]
.INDEX ++PSAIL PROCEDURE: CV5HASH
DESCRIPTION:
	Lookup the 5-bit hash index (if it exists) of the up to 6
characters of the 'token'. If not found set the global 'lastHfree' to
the first free hash table index so we can save it elsewhere.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: CV5HASH>]
 */
STRING s, 
	s1;
INTEGER h, 
	h0, 
	wt, 
	wh;

/*  # # DBUG('10000000,"[CV5HASH] token='"&token&"'") */
	GC_POPS(token); /* from GC string PDL */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(token); /* for G.C. */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	wt= cv5int(GC_PUSHS(token));		/*  -- get 5-bit code */
	h= h0= MAX((wt %547L),1L);	/*  -- initial hash code */
	lasthfree= lasthcnt= 0L;	/*  -- init counters */
/*  # # DBUG('10000000,"[CV5HASH].1 token='"&token&"' h0="&CVS(h0)) */

	while ((h!=0) &&(lasthcnt<547L))
		{/* find match */
		++lasthcnt;
		lasthfree= h;	/*  -- in case will save it later */
		if ((wh= (*aChkI(wrdmap,1L,h)))==wt) break; 
		else h= (h+h0) %547L;	/*  -- keep probing */
		}/* find match */

if ((lasthfree==0&&lasthcnt<547L))
  err_hlr(catlist(10L, GC_PUSHS("[CV5HASH] DRYROT! CV5HASH("),
		  GC_PUSHS(token),
		  GC_PUSHS(")]=0 & table NOT full!"),GC_PUSHS(crlf),
		  GC_PUSHS(" lastHcnt="),cvs(lasthcnt),
		  GC_PUSHS(" lastHfree="),
		  cvs(lasthfree),GC_PUSHS(" h="),cvs(h)));
/*  # # If Not (0 < h < maxWdMap)
	Then DBUG('10000000,"[CV5HASH].2 ILLEGAL token='"&token&
	"' h="&CVS(h)&" |token|="&CVS(LENGTH(token))) */

GC_NRETURN(h)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 's1'=<L0> string                              */
/* 's'=<L0> string                               */
/*************************************************/

}/* CV5HASH */
