/* FILE: cv5int.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pscvt.c, being converted 12/25/87, 03:15:56PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------ */
 /*INTERNAL*/ INTEGER cv5int(token)
	STRING token;
/*  ------------------------------------------------------ */
{/* CV5INT */
/*  --
.LABEL [<++PSAIL PROCEDURE: CV5INT>]
.INDEX ++PSAIL PROCEDURE: CV5INT
DESCRIPTION:
	Convert the alpanumeric 'token' up to 6 characters to a 5-bit
encoded integer as follows. NOTE: This encoding is not unique!
	a) Each letter is mapped to a 5-bit code.
	b) Each code is packed in a 32-bit word with byte 1 on the left
	   and byte 6 on the right.
	c) Null characters are set to 0.
	d) [a:z] and [A:Z] are mapped to 1:26.
	e) [0:3] are mapped to 27:30.
	f) Characters not in [a:z,A:Z,0:3] are set to 31.
		----------------------------------
		|00| c1 | c2 | c3 | c4 | c5 | c6 |
		----------------------------------

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: CV5INT>]
 */
STRING s;
INTEGER i, 
	w, 
	ch;

GC_POPS(token); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(token); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
w= 0;
s= token;
for (i=1;i<=6;i++)
	{/* create 5-bit word */
	w=LSH(w,5L);
	ch= LOP(s);
	if ('a'<=ch && ch<='z') w=w|(ch-0142L); 
	else if ('A'<=ch && ch<='Z') w=w|(ch-0102L); 
	else if ('0'<=ch && ch<='3') w=w|(ch-0113L); 
	else if (ch!='\0') w=w|31;
	}/* create 5-bit word */

GC_EPOPS(dbug(010000000L,catlist(4L,GC_PUSHS("[CV5INT] s=\'"),
				 GC_PUSHS(s),GC_PUSHS("\' w=0"),
				 cvos(w))));

GC_NRETURN(w)
}/* CV5INT */
