/* FILE: cvdwi.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pscvt.c, being converted 12/25/87, 03:15:56PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------ */
/*INTERNAL*/  STRING cvdwi(dwbits)
	INTEGER dwbits;
/*  ------------------------------------------------------ */
{/* CVDWI */
/*  --
.LABEL [<++PSAIL PROCEDURE: CVDWI>]
.INDEX ++PSAIL PROCEDURE: CVDWI
DESCRIPTION:
	Map the integer DW (descriptor word) into an internal
declaration string descriptor.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: CVDWI>]
 */
STRING s;
INTEGER typec, 
	itemtype, 
	dwltype, 
	ch;


GC_EPOPS(dbug(02000000L,catlist(6L,GC_PUSHS("[CVDWI] dwBits=0"),
				cvos(dwbits),GC_PUSHS(crlf),
				GC_PUSHS("  dwBits=\'"),cvtypes(dwbits),
				GC_PUSHS("\'"))));

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
s= "@";			/*  -- prep preface character */

if ((dwbits&020000L) &&
	((itemtype= gdw_itemtype(dwbits))>0) &&/*   -- LEAP itemtype */
	((dwltype= cvltypep(itemtype))>0) &&/*   -- leap subtype==>DW */
	((ch= (((ps_itrash_= (dwltype&037))>0) ? (ps_itrash_+0140L)
				:0L))>0)  /*   -- get leap subtype==>CODE */) 
	{/* cvt itemType to primitive type CODE */
	s= catlist(2L,GC_PUSHS(s),makstr(ch));
/*  # # DBUG('2000000,"[CVDWI].1 LEAP s='"&s&"' dwLtype='"&
    CVTYPES(dwLtype)&"'")
*/
	}/* cvt itemType to primitive type CODE */
if (dwbits&0200L) s= catlist(2L,GC_PUSHS(s),makstr(codearray));
if ((dwbits&0200000L)) s= catlist(2L,GC_PUSHS(s),makstr(codecarray));
if (dwbits&02000L) s= catlist(2L,GC_PUSHS(s),makstr(codemacro));
if (dwbits&0100000L) s= catlist(2L,GC_PUSHS(s),makstr(codeprocedure));
if (dwbits&010000000L) s= catlist(2L,GC_PUSHS(s),makstr(codereference));
if (dwbits&0400000L) s= catlist(2L,GC_PUSHS(s),makstr(codesafe));

typec= (((ps_itrash_= (dwbits&037))>0) ? (ps_itrash_+0140L)
				:0L);
/*  # # DBUG('2000000,"[CVDWI].2 s='"&s&"' typeC='"&(ps!sTrash!_typeC)&"'") */

if (('a'<=typec && typec<=0177L)) s= catlist(2L,GC_PUSHS(s),makstr(typec));

typec= LOP(s);				/*  -- trash '@' preface char */

GC_EPOPS(dbug(02000000L,catlist(3L,GC_PUSHS("[CVDWI].3 s=\'"),GC_PUSHS(s),
				GC_PUSHS("\'"))));

GC_SRETURN(s)
}/* CVDWI */
