/* FILE: cvevalquote.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pscvt.c, being converted 12/25/87, 03:15:56PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------ */
 /*INTERNAL*/ STRING cvevalquote(txt)
	STRING txt;
/*  ------------------------------------------------------ */
{/* CVEVALQUOTE */
/*  --
.LABEL [<++PSAIL PROCEDURE: CVEVALQUOTE>]
.INDEX ++PSAIL PROCEDURE: CVEVALQUOTE
DESCRIPTION:
	Convert the String to EVALQUOTE of the string. The '_'
character is is mapped to ':=' and embedded '!' to '_', '$' to '_1',
'#' to '_', @ to E, ** to ^, A:Z to a:z.
NOTE: the mapping of leq to <=, geq to >=, and neq to != is done in
FSM38.
@V.37.03	NOTE: Should also not map if START!CODE, QUICK!CODE
or C!CODE to corresponding END.
@V.51.70 NOTE: if a token is a macro fragment with an argument list,
then make sure that we have the complete arg list before calling
EXPAND!MACRO - since it can not help us if we are short...

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: CVEVALQUOTE>]
 */
STRING s, 
	s1, 
	s2, 
	s3, 
	cvline, 
	tsttok, 
	mapchar, 
	oldtsttok, 
	smacroargs;
INTEGER ch, 
	oldch, 
	h, 
	idx, 
	startdelim, 
	parencnt, 
	brktcnt,
	lthtsttok, 
	delimcnt, 
	dw;
INTEGER sawdoublequote, 
	isidchar, 
	instart_codeflag;


GC_POPS(txt); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(txt); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(s3); /* for G.C. */
GC_NOTESTRING(cvline); /* for G.C. */
GC_NOTESTRING(tsttok); /* for G.C. */
GC_NOTESTRING(mapchar); /* for G.C. */
GC_NOTESTRING(oldtsttok); /* for G.C. */
GC_NOTESTRING(smacroargs); /* for G.C. */
++rcvlevel;		/*  -- bump recursive EVVALQUOTE level */
s1= txt;
GC_EPOPS(dbug(02L,catlist(20L,GC_PUSHS("{"),cvs(rcvlevel),GC_PUSHS(
        "}[CVEVALQUOTE] s1=\'"),GC_PUSHS(s1),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" condStatementFlag="),
        pbool(condstatementflag),GC_PUSHS(" isCOPY!TOflag="),
        pbool(iscopy_toflag),GC_PUSHS(crlf),
        GC_PUSHS(" isMACROflag="),pbool(ismacroflag),
        GC_PUSHS(" sawDefineFlag="),pbool(sawdefineflag),
        GC_PUSHS(" saiLbodyDelim=\'"),GC_PUSHS(sailbodydelim),
        GC_PUSHS("\' saiRbodyDelim=\'"),GC_PUSHS(sairbodydelim),
        GC_PUSHS("\'"))));

/*  # # @V.53.04 PUSH(saiRbodyDelim) */
/*  # # @V.53.04 PUSH(saiLbodyDelim) */
pushnumber(iscvevalflag); iscvevalflag= 1L;
cvline= "@";
instart_codeflag= 0L;
oldch= (INTEGER)'\0';
h= parencnt= brktcnt= 0;		/*  -- count () and []  */
/*  # # @V.51.14 sawDefineFlag_FALSE */  /* --- was previously LOCAL variable */
tsttok= PNULL;
/* NO-OP */;

while ((*s1!='\0'))
	{/* test it */
/*  # # DBUG('2,"{"&CVS(rcvLevel)&"}[CVEVALQUOTE].0.1 tstTok='"&tstTok&
    "' |s1|="&CVS(LENGTH(s1))&" s1='"&s1&"'"&CRLF&"  sawDefineFlag="&
    PBOOL(sawDefineFlag)&" cvLine='"&cvLine&"'") */
	if ((*s1==*quote) ||(*quote!=*s1&&*s1==*sailbodydelim &&
			  sawdefineflag))
		{/* Suck in the quoted string */
/*  --		SAIL can parse the following:
			"abc"
			"a""c"
			"""abc"""
			"""ab""cde""".
			<lMacroDelim>abc"xyz<rMacroDelim>
 */
		delimcnt= 1;
		startdelim= LOP(s1);	/*  -- strip off first quote */
		cvline= catlist(2L,GC_PUSHS(cvline),makstr(startdelim));
		                 /*strip off first quote*/

/*  # # DBUG('2,"{"&CVS(rcvLevel)&"}[CVEVALQUOTE].0.2 startDelim='"&
    (s_startDelim)&"' isFRAGMENTflag="&PBOOL(isFRAGMENTflag)&CRLF&
    "  isMACROflag="&PBOOL(isMACROflag)&" saiLbodyDelim='"&
    saiLbodyDelim&"' saiRbodyDelim='"&saiRbodyDelim&"'") */
		while ((!saieof &&(delimcnt>0) &&
		       !isfragmentflag))
			{/* copy quoted string */
			sawdoublequote= 0L;
			if ((*s1=='\0'))
				{/* null string */
				if (!ismacroflag) s1= GC_EPOPS(get_input()); 
				    else err_hlr(GC_PUSHS(
			"[CVEVALQUOTE] Missing \" in string"));
				if (isfragmentflag)
					{
					ch= LOP(cvline); /*  -- Trash '@' */
					--rcvlevel;
					popnumber(&iscvevalflag);
/*  # # @V.53.04				POP(saiLbodyDelim) */
/*  # # @V.53.04				POP(saiRbodyDelim) */
					{GC_ADJSTKFRAME(4);
					 GC_SRETURN(cvline);}
					}
/*  # # DBUG('2,"{"&CVS(rcvLevel)&"}[CVEVALQUOTE].0.3 sawDefineFlag="&
    PBOOL(sawDefineFlag)&CRLF&" cvLine='"&CvLine&"'"&CRLF&" s1='"&s1&"'") */
				}/* null string */
			ch= LOP(s1);
			if ((ch==*quote) &&
			      (!sawdefineflag ||
			         (startdelim==*quote&&sawdefineflag)
			      ))
				{/* found another quote */
				if ((*s1!=*quote)) 
					{/* must be quote */
					if (startdelim==*quote) --delimcnt;
					}/* must be quote */
				else 	{/* get double quote */
					sawdoublequote= 1L;
					cvline= catlist(2L,GC_PUSHS(cvline),
							GC_PUSHS(LOP(s1)));
					 /*  -- get it now! */
					}/* get double quote */
				}/* found another quote */
			else if ((startdelim!=*quote) &&
				(ch==*sailbodydelim) &&
				(*sailbodydelim!=*sairbodydelim))
			       ++delimcnt; else if ((startdelim!=*quote) &&
				(ch==*sairbodydelim) &&
			        sawdefineflag) --delimcnt;
			cvline= catlist(2L,GC_PUSHS(cvline),makstr(ch));
			             /*  -- build string */
			oldch= ch;	/*  -- backup char */
/*  # # DBUG('2,"[CVEVALQUOTE].1 DOINGquote cvLine='"&cvLine&"'"&CRLF&
    " s1='"&s1&"'"&CRLF&"  sawDoubleQuote="&PBOOL(sawDoubleQuote)&
    " delimCnt="&CVS(delimCnt)) */
			}/* copy quoted string */
/*  # # DBUG('2,"[CVEVALQUOTE].2 ENDquote s1='"&s1&"'"&CRLF&"  cvLine='"&
    cvLine&"'") */

		if (saieof &&(delimcnt!=0))
			err_hlr(GC_PUSHS(catlist(GC_PUSHS(
		        "[CVEVALQUOTE] Missing end \" in string constant"),
		        GC_PUSHS(crlf),GC_PUSHS("\'"),GC_PUSHS(cvline),
		        GC_PUSHS("\'"))));
		}/* Suck in the quoted string */

		else 
		{/* cvt to lower */
/*  # # DBUG('2,"[CVEVALQUOTE].3 tstTok='"&tstTok&"' before CVT cvLine='"&
    cvLine&"'"&CRLF&" s1='"&s1&"'") */
/*  NOTE: @V.37.03 add traps for START!CODE, QUICK!CODE and CCODE to
not map until END */
/*  NOTE: @V.46.191 count balanced () & [] to force new GET!INPUT calls */
		ch= LOP(s1);
		/*  -- If not in START!CODE or QUICK!CODE or xxDEFINE
		  Then Do simple mappings of
	if /EXTENSIONS	'<ch>'	to	"<ch>"
	else		'	to	0
			**	to	^
			@	to	E
			_	to	:=
			!	to	_
			$	to	_1
			#	to	_2
	if MAINSAIL	#	to	_2,  '#<space>', add <SC> @ EOL
			A:Z	to	a:z
	if MAINSAIL	.+	to	+=
	if MAINSAIL	.-	to	-=
---- Removed @V.49.81---	leq	to	<=
---- Removed @V.49.81---	geq	to	>=
---- Removed @V.45.42---	neq	to	!=
		 */
		if (ch=='(')
		  ++parencnt;
		else if (ch==')')
		  --parencnt;
		else if (ch=='[')
		  ++brktcnt;
		else if (ch==']')
		  --brktcnt;
		else if (ch==';')
		  sawdefineflag= 0L; /*  -- don't need
							it HOT any more

		 */if (instart_codeflag 
/*  # # @V.52.193 Or sawDefineFlag  */)
		   mapchar= (*aChkC(charmap,1L,ch+128L)); 
		else 
		  {/* try to do mapping */
		  mapchar= "\000";
/* IFC EVAL(parsemainsail)=1 */
/* THENC */

 /* MESSAGE: " <Parsing MAINSAIL code>"  */;
/*  # # DBUG('2,"[CVEVALQUOTE].3.0.1 ch='"&(ps!sTrash!_ch)&"'") */
		  if (mainsailflag)
		  {/* additional MAINSAIL mappings */
		  if (ch=='.')
			{/* map .<opr> to <opr>= */
			if (*s1=='+')
			  {/* '+=' ie. charMap['26] */
			     ch= LOP(s1);
			     ch= 026;
			   }/* '+=' ie. charMap['26] */
			else if (*s1=='-')
			  {/* '-=' ie. charMap['27] */
			    ch= LOP(s1);
			    ch= 027;
			  }/* '-=' ie. charMap['27] */
			}/* map .<opr> to <opr>= */
		else if (ch=='#')
			{/* then add ; at end of line if not there */
			STRING sline;
			INTEGER brk;
/*  # # DBUG('2,"[CVEVALQUOTE].3.0.2 s1='"&s1&"'") */
			GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
			GC_NOTESTRING(sline); /* for G.C. */
			sline= GC_EPOPS(scan(&s1,1L,&brk));
			if ((*(sline+length(sline)-1))!=';')
				{/* add it on */
				if (*sline=='\0') sline= " ;"; 
				else sline= catlist(3L,GC_PUSHS(" "),
						    GC_PUSHS(sline),GC_PUSHS(";"));
				}/* add it on */
			s1= ((*s1=='\0') ? catlist(2L,GC_PUSHS(sline),
						   GC_PUSHS(crlf))
			                 : catlist(3L,GC_PUSHS(sline),
						   GC_PUSHS(crlf),
						   GC_PUSHS(s1)));
/*  # # @V.57.07		mapChar_"comment " & s1 */
/*  # # @V.57.07		If brk=LF
# # # @V.57.07			Then mapChar_mapChar & CRLF */
GC_EPOPS(dbug(02L,catlist(11L,GC_PUSHS("[CVEVALQUOTE].3.0.3 mapChar=\'"),
			  GC_PUSHS(
        mapchar),GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" sLine=\'"),
        GC_PUSHS(sline),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" s1=\'"),GC_PUSHS(s1),GC_PUSHS("\'"))));
			{GC_UNMARKSSTKFRAME;}
		    }/* then add ; at end of line if not there */
		  }/* additional MAINSAIL mappings */
    /* ENDC */
/*  # # DBUG('2,"[CVEVALQUOTE].3.0.4 ch='"&(ps!sTrash!_ch)&"' |s1|="&
    CVS(length(s1))&" useEXTENSIONSflag="&PBOOL(useExtensionsFlag)&
    CRLF&" s1='"&s1&"'") */
		if (ch==('\''/*WARNING*/)&&useextensionsflag &&
		    (*(s1+2-1))==('\''/*WARNING*/))
		  {/* map character constants to strings */
		    mapchar= catlist(3L,GC_PUSHS(quote),
				     GC_PUSHS(LOP(s1)),GC_PUSHS(quote));
					/*  -- get the character and
					     embed in double quotes
					     replacing ' with " */
			ch= LOP(s1);	/*  -- trash 2nd '  */
/*  # # DBUG('2,"[CVEVALQUOTE].3.0.4.1 mapChar='"&mapChar&
    "' |s1|="&CVS(length(s1))&" s1='"&s1&"'") */
		  }/* map character constants to strings */
		  else if (ch=='*'&&*s1=='*') 
			{/* special mapping for '*' */
			mapchar= "^";
			ch= LOP(s1);	/*  -- trash 2nd *  */
			}/* special mapping for '*' */
		  else if (*mapchar==0) mapchar= (*aChkC(charmap,1L,ch));
		  }/* try to do mapping */
		isidchar= (*aChkI(charisid,1L,ch));
		                 /*  -- flag TRUE if <id> legal */
/*  # # DBUG('2,"[CVEVALQUOTE].3.1 tstTok='"&tstTok&"' isMACROflag="&
    PBOOL(isMACROflag)&CRLF&"   mapChar='"&mapChar&"' isIDchar="&
    PBOOL(isIDchar)&" s1='"&s1&"'") */
		if (isidchar)
			{/* build tstTok */
			if (*tsttok=='\0')
			  tsttok= mapchar; 
			else tsttok= catlist(2L,GC_PUSHS(tsttok),
					     GC_PUSHS(mapchar));
		    }/* build tstTok */
		else if (*tsttok=='\0')
		  cvline= catlist(2L,GC_PUSHS(cvline),GC_PUSHS(mapchar));
		else if (*tsttok!='\0')
			{/* see if expand macro fragment! */
/*  # # DBUG('2,"[CVEVALQUOTE].3.2 tstTok='"&tstTok&"' isMACROflag="&
    PBOOL(isMACROflag)&CRLF&" |tstTok|="&CVS(lthTstTok)&" parenCnt="&
    CVS(parenCnt)&" brktCnt="&CVS(brktCnt)) */
			oldtsttok= tsttok;	/*  -- backup for later */
			if (!isdigit((INTEGER)*tsttok) &&
			    chk_c_keyword(GC_PUSHS(tsttok)))
			  tsttok= catlist(2L,GC_PUSHS("_"),
					  GC_PUSHS(tsttok)); /*  -- Fake out
						C compiler keyword */
			if ((*tsttok!='\0') &&
			   (!ismacroflag) &&
			   (!iscopy_toflag) &&
			   (!isdigit((INTEGER)*tsttok)) &&
			   ((idx= (*aChkI(dwptr,1L,
					  h= hash_c(GC_PUSHS(tsttok)))))>0)) 
				{/* save SAIL fragment */
				if (h==hthenc||h==helsec)
				  condstatementflag= 1L;
				else if (h==hendc)
				  condstatementflag= 0L;
				else if (h==hstart_code||h==hquick_code)
				  instart_codeflag=1L; 
				else if (h==hend&&instart_codeflag)
				  instart_codeflag=0L; 
				else if (h==hdefine||h==hredefine ||
				         h==hevaldefine ||h==hevalredefine) 
					{/* set macro define flag */
/*  # # @V.53.04				Integer brk */
/*  # # @V.53.04				String s1,s2 */
/*  # # @V.53.04				s1_saiStatement */
/*  # # @V.53.04				s2_SCAN(s1,5,brk) */  /*  -- for '=' */
/*  # # @V.53.04				s1_SCAN(s2,20,brk) */  /*  -- for '"' */
/*  # # @V.53.04				If brk=quote
# # # @V.53.04					Then
# # # @V.53.04					Begin "switch DELIMS"
# # # @V.53.04					saiLbodyDelim_LOP(s2) */
/*  # # @V.53.04					saiRbodyDelim_LOP(s2) */
/*  # # DBUG('2,"[CVEVALQUOTE].3.2.1 NEW saiLbodyDelim='"&saiLbodyDelim&
    "' saiRbodyDelim='"&saiRbodyDelim&"'") */
/*  # # @V.53.04					End "switch DELIMS" */
					sawdefineflag= 1L;
					}/* set macro define flag */
				   else if (h==hnomac) sawdefineflag= 1L;
/*  # # @V.51.03 Taking the condStatementFlag test out below may get us
# # # @V.51.03 into trouble with nested IFC tests
 *//*  # # @V.52.109 Even if condStatementFlag is true, need to test if
# # # @V.52.109 it is a macro which expands to COMMENT then Expand! */
/*  # # @V.56.130 NOTE: need to remove forward ref on macros here! */
				if ((!sawdefineflag) &&
				   ((dw= (*aChkI(decldw,1L,idx)))&02000L) &&
				   ((*aChkI(decldw,1L,idx))=
				              dw&0777775777777L) &&
				   (dw&01000L) &&
			   	   (!condstatementflag ||
				    equ(GC_PUSHS("comment"),
					cvlower(GC_PUSHS(
				         GC_EPOPS(remove_white_ends(GC_PUSHS(
					    (*aChkC(declsize,1L,idx)))))))))) 
				   {/* Expand SAIL Macro string */
				   INTEGER oldnpdlptr, 
				   oldspdlptr;
/*  # # @V.49.27			   lthTstTok_LENGTH(oldTstTok) */
				   oldnpdlptr= npdlptr; /*  -- test DRYROT */
				   oldspdlptr= spdlptr;
/*  # # DBUG('2,"{"&CVS(rcvLevel)&"}[CVEVALQUOTE].3.3 mapChar='"&
    mapChar&"'"&CRLF&" oldNpdlPtr="&CVS(oldNpdlPtr)&" oldSpdlPtr="&
    CVS(oldSpdlPtr)&CRLF&" cvLine='"&cvLine&"'"&CRLF&" s1='"&s1&"'"&
    " tstTok='"&tstTok&"' lthTstTok="&CVS(lthTstTok)&" parenCnt="&
    CVS(parenCnt)&PRT!NODE(h)) */
				   if (ch=='('&&parencnt>0 &&
				      ((*aChkI(declnargs,1L,idx))>0))
				     --parencnt;
/*  # # @V.49.27			   cvLine_
				     cvLine[1 to inf-lthTstTok] */
				   if (*mapchar!='\0') 
					{/* put it back */
					if (*s1=='\0')
					  s1= mapchar; 
					else s1= catlist(2L,GC_PUSHS(mapchar),
							 GC_PUSHS(s1));
					}/* put it back */

/*  # # DBUG('2,"{"&CVS(rcvLevel)&"}[CVEVALQUOTE].3.4 s1='"&s1&"'"&CRLF&
    " tstTok='"&tstTok&"' condStatementFlag="&PBOOL(condStatementFlag)&CRLF&
    "  cvLine='"&cvLine&"'"&CRLF&" saiStatement='"&saiStatement&"'"&CRLF&
    " line='"&line&"'") */
				   smacroargs= s1;
				   while ((*s1!='\0') &&
					  iswhitespace((INTEGER)*s1))
				     ps_itrash_= LOP(s1);
				   if (*s1=='('&&!ismacroflag) 
					{/* get complete arg list */
/*  @V.50.97 -- We need to scan for ')' here since COPY!EITHER
-- recursion can kill us */
					INTEGER pcnt, 
					ch;
					STRING ss;
					GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
					GC_NOTESTRING(ss); /* for G.C. */
					do  {/* get full arg list */
					   ss= s1;  /*  -- test () count */
					   pcnt= 0;
					   while ((ch= LOP(ss))!='\0')
					     if (ch=='(')
					       ++pcnt;
					     else if (ch==')')
					       --pcnt;
					   if (pcnt!=0)
					     s1= catlist(2L,GC_PUSHS(s1),get_input());
					   }/* get full arg list */
					 while (!((pcnt<=0) ||saieof));
					smacroargs= s1;
/*  # # DBUG('2,"{"&CVS(rcvLevel)&"}[CVEVALQUOTE].3.4.1 sMacroArgs='"
    &sMacroArgs&"'") */
					{GC_UNMARKSSTKFRAME;}
				      }/* get complete arg list */
/*  # # DBUG('2,"{"&CVS(rcvLevel)&"}[CVEVALQUOTE].3.4.2 sMacroArgs='"&
    sMacroArgs&"'"&CRLF&"  saiStatement='"&saiStatement&"'"&CRLF&
    "  line='"&line&"'"&CRLF&"  nPDLptr="&CVS(nPDLptr)&" sPDLptr="&
    CVS(sPDLptr)) */
			if ((oldnpdlptr!=npdlptr) ||
			   (oldspdlptr!=spdlptr)) err_hlr(GC_PUSHS(
   catlist(11L,
           GC_PUSHS("[CVEVALQUOTE] DRYROT in PSAIL PDLs - after COPY!APPEND")
           ,GC_PUSHS(crlf),GC_PUSHS(" initial nPDLptr="),
           cvs(oldnpdlptr),GC_PUSHS(" final nPDLptr="),cvs(npdlptr),
           GC_PUSHS(crlf),GC_PUSHS(" initial sPDLptr="),
           cvs(oldspdlptr),GC_PUSHS(" final sPDLptr="),cvs(spdlptr))));

			/*  -- Push the state since we are going to R!D */
				   push(GC_PUSHS(cvline));
				   push(GC_PUSHS(oldtsttok));
				   push(GC_PUSHS(s2));
				   pushnumber(brktcnt);
				   pushnumber(instart_codeflag);
				   pushnumber(lthtsttok);
				   pushnumber(parencnt);
				   pushnumber(sawdefineflag); pushnumber(h);
				   pushnumber(idx);

				   s1= GC_EPOPS(expand_macro(
						 GC_PUSHS(smacroargs),idx));
				   tsttok= PNULL;  /*  -- prep for next one */
				   h= 0;	   /*  -- next go around... */

				   popnumber(&idx);
				   popnumber(&h); popnumber(&sawdefineflag);
				   popnumber(&parencnt);
				   popnumber(&lthtsttok);
				   popnumber(&instart_codeflag);
				   popnumber(&brktcnt);
				   pop(&s2);
				   pop(&oldtsttok); pop(&cvline);

					/*  -- use SAIL MACRO 'FRAGMENT' */
				   if (*mapchar=='(')
				     --parencnt;
				   else if (*mapchar=='[')
				     --brktcnt; 
							/*  -- BKUP
 *//*  # # DBUG('2,"[CVEVALQUOTE].3.5 Exp!Mac cvLine='"&cvLine&"'"&CRLF&
       " s1='"&s1&"'"&CRLF&" parenCnt="&CVS(parenCnt)&" brktCnt="&
       CVS(brktCnt)&" mapChar='"&mapChar&"'") */
			if ((oldnpdlptr!=npdlptr) ||
			   (oldspdlptr!=spdlptr))
			  err_hlr(GC_PUSHS(
   catlist(11L,
     GC_PUSHS("[CVEVALQUOTE] DRYROT in PSAIL PDLs - after EXPAND!MACRO,"),
           GC_PUSHS(crlf),GC_PUSHS(" initial nPDLptr="),
           cvs(oldnpdlptr),GC_PUSHS(" final nPDLptr="),cvs(npdlptr),
           GC_PUSHS(crlf),GC_PUSHS(" initial sPDLptr="),
           cvs(oldspdlptr),GC_PUSHS(" final sPDLptr="),cvs(spdlptr))));
				   mapchar= PNULL;
				   continue;    /*  -- go RE-EVAL s1 */
				   }/* Expand SAIL Macro string */
				else cvline= catlist(GC_PUSHS(cvline),
						     GC_PUSHS(tsttok));
				               /*  -- just copy */
				}/* save SAIL fragment */
			else cvline= catlist(2L,GC_PUSHS(cvline),
					     GC_PUSHS(tsttok));
			                   /*  -- just copy */
			if (*mapchar!='\0') cvline= catlist(2L,GC_PUSHS(cvline),GC_PUSHS(mapchar));
/*  # # DBUG('2,"[CVEVALQUOTE].3.6 mapChar='"&mapChar&"' saiSym[h]='"&
    saiSym[h]&"'"&CRLF&"  |s1|="&CVS(LENGTH(s1))&" s1='"&s1&"'"&CRLF&
    "  cvLine='"&cvLine&"'") */

			tsttok= PNULL;	/*  -- prep for next one */
			if (h==hcomment)
				{/* found comment */
				INTEGER brk, 
				lthcmt;
				STRING scmt, 
				sc;
				GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
				GC_NOTESTRING(scmt); /* for G.C. */
				GC_NOTESTRING(sc); /* for G.C. */
				scmt= "@";
				lthcmt= 1;
				do  {/* copy to end of comment */
/*  # # DBUG('2,"[CVEVALQUOTE].4 lthCmt="&CVS(lthCmt)&CRLF&" cvLine='"&
    cvLine&"'"&CRLF&" s1='"&s1&"'") */
				   if ((*s1=='\0')) 
					{/* new cvLine */
					if (ismacroflag)
					  break; /*  -- with 
							the comment... */
					s1= GC_EPOPS(get_input());
					}/* new cvLine */
				   sc= GC_EPOPS(scan(&s1,10L,&ch));
				          /*  -- break on <SC> */
				   if ((*sc!='\0')
/*  # # @V.52.147				 And (Not ignoreFlag)  */)
					{/* add on sC */
					scmt= catlist(2L,GC_PUSHS(scmt),
						      GC_PUSHS(sc));
					lthcmt = lthcmt+length(GC_PUSHS(sc));
					}/* add on sC */
				   if ((ch==';')
/*  # # @V.52.147		      Or (ch Neq NULL And Not ignoreFlag) */)
					{/* add on ch */
					scmt= catlist(2L,GC_PUSHS(scmt),
						      makstr(ch));
					++lthcmt;
					}/* add on ch */
/*  # # @V.52.147			   If (RMVLARGECOMMENT Neq 0) And
# # # @V.52.147			      (lthCmt>RMVLARGECOMMENT)
# # # @V.52.147				Then ignoreFlag_TRUE */
				  }/* copy to end of comment */
				 while (!(saieof ||ch==';'));
				if (lthcmt>1000L)
					{/* map HUGE comments */
					INTEGER i, 
					j;
					j= 0;
					for (i=1;i<=50L;i++)
					  if (*((*aChkC(hugecmtpdl,1L,i)))==
					       '\0')
					    {/* alloc */
						j= i;
						break;
					    }/* alloc */
					scmt= subst(GC_PUSHS(scmt),2L,
						    length(scmt)-1L); 
						/*eliminate  '@...;' */
					(*aChkC(hugecmtpdl,1L,j))= scmt;
/*  # # DBUG('2,"[CVEVALQUOTE].4.0.1 HugeCMT nHugeCMTS="&CVS(nHugeCMTS)&
    CRLF&" orignal sCmt='"&sCmt&"'") */
					scmt= catlist(3L,
						      GC_PUSHS("@ \7hugeCMT"),
						      cvs(j),GC_PUSHS(";"));
					++nhugecmts;
					{/* MAXSTAT */
					 if (usereportflag)
					   (*aChkI(errstatistics,1L,35L))=
					 MAX((*aChkI(errstatistics,1L,35L)),
					     nhugecmts);
				        }/* MAXSTAT */
/*  # # DBUG('2,"[CVEVALQUOTE].4.0.2 HugeCMT nHugeCMTS="&CVS(nHugeCMTS)&
    CRLF&" cvLine='"&cvLine&"'"&CRLF&" sCmt='"&sCmt&"'") */
					}/* map HUGE comments */
/*  # # @V.52.147			If lthCmt>RMVLARGECOMMENT
					Then sCmt_sCmt & CRLF &
"Comment ***********************************************************
* Sorry, |COMMENT| > " & CVS(RMVLARGECOMMENT) & 
			" characters was truncated. *
************************************************************" & 
					semiColon & CRLF */
				brk= LOP(scmt);    /*  -- trash '@' */
				cvline= catlist(2L,GC_PUSHS(cvline),
						GC_PUSHS(scmt));
				oldch= ch;	/*  -- backup char */
/*  # # DBUG('2,"[CVEVALQUOTE].4.1 ENDcomment cvLine='"&cvLine&"'"&CRLF&
    " s1='"&s1&"'"&CRLF&" oldCh='"&(s2_oldCh)&"'") */
				{GC_UNMARKSSTKFRAME;}}/* found comment */
			h= 0;	/*  -- clear so force new one */
			}/* see if expand macro fragment! */

/*  # # @V.49.81	If ( ((s2_cvLine[inf-2 for 3])="l" And EQU(s2,"leq")) Or
# # # @V.49.81	    FAST!EQU(s2,"geq")) And
# # # @V.49.81	   (Not ISVARIABLE(cvLine[inf-3 for 1])) And
# # # @V.49.81	   (Not ISVARIABLE(s1))
# # # @V.49.81		Then
# # # @V.49.81		Begin "map LEQ/GEQ to <=/>= "
# # # @V.49.81		cvLine_cvLine[1 to inf-3] &
# # # @V.49.81		     (If s2="l" Then "<=" Else ">=")
 *//*  # # @V.49.81		End "map LEQ/GEQ to <=/>= " */
		oldch= ch;	/*  -- backup char */
/*  # # DBUG('2,"[CVEVALQUOTE].5 tstTok="&tstTok&" after CVT cvLine="&
    cvLine&CRLF&" s1="&s1) */
		}/* cvt to lower */
	/* NO-OP */;
	if (*s1=='\0'&&!ismacroflag &&(parencnt>0||brktcnt>0) &&
	   (!isfragmentflag) &&(!saieof)) 
		{/* get some more data */
/*  # # DBUG('2,"[CVEVALQUOTE].6 parenCnt="&CVS(parenCnt)&" brktCnt="&
    CVS(brktCnt)&CRLF&" cvLine='"&cvLine&"'") */
		s1= GC_EPOPS(get_input());
		}/* get some more data */
	}/* test it */
if (*tsttok!='\0') cvline= catlist(2L,GC_PUSHS(cvline),GC_PUSHS(tsttok));	/*  -- we must add it on */

ch= LOP(cvline); 			/*  -- Trash '@' */
/*  # # DBUG('2,"{"&CVS(rcvLevel)&"}[CVEVALQUOTE].7 final cvLine='"&
    cvLine&"'"&CRLF&"  parenCnt="&CVS(parenCnt)&" brktCnt="&CVS(brktCnt)&
    " condStatementFlag="&PBOOL(condStatementFlag)) */
	/* NO-OP */;
GC_EPOPS(dbug(02L,catlist(9L,GC_PUSHS("{"),cvs(rcvlevel),
        GC_PUSHS("}[CVEVALQUOTE].7.1 tstTok=\'"),GC_PUSHS(tsttok),
        GC_PUSHS("\'  |s1|="),cvs(length(GC_PUSHS(s1))),
        GC_PUSHS(" s1=\'"),GC_PUSHS(s1),GC_PUSHS("\'"))));
--rcvlevel;
popnumber(&iscvevalflag);
/*  # # @V.53.04 (saiLbodyDelim) */
/*  # # @V.53.04 (saiRbodyDelim) */
;
GC_SRETURN(cvline)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 's3'=<L0> string                              */
/* 's'=<L0> string                               */
/*************************************************/

}/* CVEVALQUOTE */
