/* FILE: cvidw.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pscvt.c, being converted 12/25/87, 03:15:56PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------ */
 /*INTERNAL*/ INTEGER cvidw(idecltype)
	STRING idecltype;
/*  ------------------------------------------------------ */
{/* CVIDW */
/*  --
.LABEL [<++PSAIL PROCEDURE: CVIDW>]
.INDEX ++PSAIL PROCEDURE: CVIDW
DESCRIPTION:
	Convert the String PSAIL internal declaration to
corresponding PSAIL integer DESCRIPTOR WORD code. Return 0 if no
match.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: CVIDW>]
 */
INTEGER ch, 
	dw, 
	itype;



GC_EPOPS(dbug(02L,catlist(3L,GC_PUSHS("[CVIDW] iDeclType=\'"),
			  GC_PUSHS(idecltype),
        GC_PUSHS("\'"))));
GC_POPS(idecltype); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(idecltype); /* for G.C. */
dw= 0;

while ((ch= LOP(idecltype))!='\0')
	{/* Eat up code */
	if (isleapcode(ch)) dw=dw|020000L;

	if (ch==codearray) dw=dw|0200L; 
	else if (ch==codecarray) dw=dw|0606710; 
	else if (ch==codeitemarray) 
		{/* set item array bit in LEAP descriptor field */
		itype= gdw_itemtype(dw);
		if (itype<20) pdw_itemtype(dw,(itype+20L));
		}/* set item array bit in LEAP descriptor field */
	else if (ch==codemacro) dw=dw|02000L; 
	else if (ch==codeprocedure) dw=dw|0100000L; 
	else if (ch==codereference) dw=dw|010000000L; 
	else if (ch==codesafe) dw=dw|0400000L; 
	else	{/* it is a primary data type */
		pdw_ptype(dw,ch);
GC_EPOPS(dbug(02L,catlist(7L,GC_PUSHS("[CVIDW].1 iDeclType=\'"),
			  GC_PUSHS(idecltype),
        GC_PUSHS("\' ch=\'"),
        GC_PUSHS(ps_strash_= GC_EPOPS(makstr(ch))),GC_PUSHS(
        " dw=0\'"),cvos(dw),GC_PUSHS("\'"))));
		}/* it is a primary data type */
/*  # # DBUG('2,"[CVIDW].1.1 iDeclType='"&iDeclType&"' ch='"&
    (ps!sTrash!_ch)&" dw=0'"&CVOS(dw)&"'") */
	}/* Eat up code */

GC_EPOPS(dbug(02L,catlist(2L,GC_PUSHS("[CVIDW].2 dw=0"),cvos(dw))));


GC_NRETURN(dw)
}/* CVIDW */
