/* FILE: cvlower.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pscvt.c, being converted 12/25/87, 03:15:56PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------ */
 /*INTERNAL*/ STRING cvlower(ss)
	STRING ss;
/*  ------------------------------------------------------ */
{/* CVLOWER */
/*  --
.LABEL [<++PSAIL PROCEDURE: CVLOWER>]
.INDEX ++PSAIL PROCEDURE: CVLOWER
DESCRIPTION:
	Convert the C String to lower case if and only if it is not
part of a quoted String or a comment (which is denoted by the word
'comment').

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: CVLOWER>]
 */
STRING s1, 
	sl;
INTEGER ch, 
	oldch, 
	oldoldch;

;

GC_POPS(ss); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(ss); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(sl); /* for G.C. */
midofquote= midofcomment= 0L;
s1= ss;
oldoldch= oldch= (INTEGER)'\0';
sl= "@";				/*  -- use guard character */

while ((*s1!='\0'))
	{/* eat and cvt string */
	oldoldch= oldch;		/*  -- save for COMMENT test */
	oldch= ch;
	ch= LOP(s1);
	if (('A'<=ch && ch<='Z') &&(!(midofquote ||midofcomment)))
	  ch= (ch-0242L);   /*  -- map CAP letter */;

	sl= catlist(2L,GC_PUSHS(sl),makstr(ch));      	/*  -- build new string */
	if ((oldch=='t') &&(oldoldch=='n') &&
   	   (!isvariable(ch)) &&
	   equ(subst(GC_PUSHS(sl),length(sl)-7L,length(sl)-1L),GC_PUSHS("comment"))) midofcomment= 
	1L; else if (midofcomment &&*sl==';') midofcomment= 
	0L; else if (ch==*quote) midofquote= !midofquote;
	}/* eat and cvt string */
/*  # # DBUG('2,"[CVLOWER] sL="&sL) */

ch= LOP(sl);			/*  -- trash the guard character */

GC_SRETURN(sl)
}/* CVLOWER */
