/* FILE: cvltypep.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pscvt.c, being converted 12/25/87, 03:15:56PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------ */
 /*INTERNAL*/ INTEGER cvltypep(lcode)
	INTEGER lcode;
/*  ------------------------------------------------------ */
{/* CVLTYPEP */
/*  --
.LABEL [<++PSAIL PROCEDURE: CVLTYPEP>]
.INDEX ++PSAIL PROCEDURE: CVLTYPEP
DESCRIPTION:
	Convert the LEAP type lCode to a DW primary type code word.
C.F. Appendix SYMTAB table 4.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: CVLTYPEP>]
 */

INTEGER dw, 
	i;
 static INTEGER /*ARRAY*/ P_lmapp[13+(16-0+1L)] = { 
   0,0,0,0,0,0,0,0,0,0,0,0,0, 0,
    		/*  -- 0 item deleted or never allocated */
   0, 		/*  -- 1 untyped -- No LEAP type */
   codeitemvar,	/*  -- 2 Bracketed triple */
   codestring,	/*  -- 3 String */
   codereal,	/*  -- 4 Real */
   codeinteger,	/*  -- 5 Integer */
   codeset,	/*  -- 6 Set */
   codelist,	/*  -- 7 List */
   codeprocedure,	/*  -- 8 procedure item */
   codeprocedure,	/*  -- 9 process item */
   codeevent,	/*  -- 10 event item */
   0,		/*  -- 11 context item === not implemented */
   codereference,	/*  -- 12 reference item */
   coderecptr,	/*  -- 13 record pointer item */
   codelabel,	/*  -- 14 label */
   coderecclass,	/*  -- 15 record!class */
   0 };
 static INTEGER /*ARRAY*/ *lmapp  /* [0:16] */ ;



GC_EPOPS(dbug(02L,catlist(3L,GC_PUSHS("[CVLTYPEP] lCode=0\'"),
			  cvos(lcode),GC_PUSHS("\'"))));
lmapp = aryHdrI(P_lmapp,1,0,16,"lmapp",'i');	/* Dynamic Array */
dw= 0;
if (lcode<0) lcode= 
1L; else if ((lcode>20))
	{/* is XXX Array */
	if (lcode>36) lcode= 
		16L; else lcode -= 20;	/*  OVER 36 is undefined... */
	dw= 0200L;
	}/* is XXX Array */
pdw_ptype(dw,(*aChkI(lmapp,1L,lcode)));


GC_EPOPS(dbug(02L,catlist(3L,GC_PUSHS("[CVLTYPEP].1 dw=\'"),cvtypes(dw),GC_PUSHS("\'"))));


return(dw);
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'i'=<L0> integer                              */
/*************************************************/
}/* CVLTYPEP */
