/* FILE: cvptypel.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pscvt.c, being converted 12/25/87, 03:15:56PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------ */
 /*INTERNAL*/ INTEGER cvptypel(dw)
	INTEGER dw;
/*  ------------------------------------------------------ */
{/* CVPTYPEL */
/*  --
.LABEL [<++PSAIL PROCEDURE: CVPTYPEL>]
.INDEX ++PSAIL PROCEDURE: CVPTYPEL
DESCRIPTION:
	Convert the primary type dw to a lCode LEAP type code word
C.F. Appendix SYMTAB table 4 for documentation.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: CVPTYPEL>]
 */
INTEGER lcode, 
	i;
 static INTEGER /*ARRAY*/ P_pmapl[13+(31-0+1L)] = { 
   0,0,0,0,0,0,0,0,0,0,0,0,0, 1,	/*  untyped = 0 NULL 'NULL' */
   0,	/*  NONE = 1** array 'a' */
   0,	/*  NONE = 2 interrupt 'b' */
   3,	/*  String = 3 string 'c' */
   4,	/*  REAL = 4 double 'd' */
   10,	/*  EVENT = 5 event 'e' */
   4,	/*  REAL = 6 real 'f' */
   14,	/*  LABEL = 7 label 'g' */
   0,	/*  NONE = 8 lisp!atom 'h' */
   5,	/*  INTEGER = 9 integer 'i' */
   0,	/*  NONE = 10 object 'j' */
   0,	/*  NONE = 11 lisp!S!expr 'k' */
   7,	/*  LIST = 12 list 'l' */
   0,	/*  NONE = 13** macro 'm' */
   8,	/*  PROCEDURE ITEM = 14 void 'n' */
   0,	/*  NONE = 15** optional 'o' */
   8,	/*  PROCEDURE ITEM = 16 process 'p' */
   13,	/*  RECORD!POINTER ITEM = 17 record!pointer 'q' */
   12,	/*  REFERENCE ITEM =  18** reference 'r' */
   6,	/*  SET = 19 set 's' */
   15,	/*  RECORD!CLASS = 20 record!class 't' */
   0,	/*  NONE = 21 unspecified 'u' */
   1,	/*  UNTYPED ITEM = 22 itemvar 'v' */
   0,	/*  NONE = 23** own(static) 'w' */
   1,	/*  UNTYPED ITEM = 24 item 'x' */
   0,	/*  NONE = 25 record!field 'y' */
   0,	/*  NONE = 26** safe 'z' */
   0,	/*  NONE = 27** Item!array '{' */
   5,	/*  NONE = 28** short '|' */
   5,	/*  NONE = 29** byte '}' */
   0,	/*  NONE = 30** C!array '~' */
   5 };
 static INTEGER /*ARRAY*/ *pmapl  /* [0:31] */ ;



GC_EPOPS(dbug(02L,catlist(5L,GC_PUSHS("[CVPTYPEL] dw=0\'"),cvos(dw),
        GC_PUSHS("\' pType=\'"),GC_PUSHS(((ps_itrash_= (dw&037))>0) 
        ? GC_EPOPS(makstr((ps_itrash_+0140L)
        				)):0L),GC_PUSHS("\'"))));

pmapl = aryHdrI(P_pmapl,1,0,31,"pmapl",'i');	/* Dynamic Array */
i= (((ps_itrash_= (dw&037))>0) ? (ps_itrash_+0140L) :0L);
if (i!=0)
  i = i-0142L;

lcode= (*aChkI(pmapl,1L,i));   /*  -- map internal PSAIL code to 
				   TYPEIT LEAP code */

if (dw&0200L) lcode = lcode+20L;   /*  -- Add offset if  array ITEM TYPE */

GC_EPOPS(dbug(02L,catlist(5L,GC_PUSHS("[CVPTYPEL].1 i="),cvs(i),
			  GC_PUSHS(" lCode=0\'"),
			  cvos(lcode),GC_PUSHS("\'"))));
return(lcode);
}/* CVPTYPEL */
