/* FILE: cvstype.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pscvt.c, being converted 12/25/87, 03:15:56PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------ */
 /*INTERNAL*/ INTEGER cvstype(stype)
	STRING stype;
/*  ------------------------------------------------------ */
{/* CVSTYPE */
/*  --
.LABEL [<++PSAIL PROCEDURE: CVSTYPE>]
.INDEX ++PSAIL PROCEDURE: CVSTYPE
DESCRIPTION:
	Convert the String declaration SAIL (lower case) keyword to the
corresponding PSAIL DESCRIPTOR WORD. Return 0 if no match.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: CVSTYPE>]
 */
STRING s, 
	s1, 
	s2, 
	token;
INTEGER ch, 
	i, 
	dw, 
	foundprimarytype, 
	h;


/*  # # DBUG('2,"[CVSTYPE] |sType|="&CVS(LENGTH(sType))&" sType='"&sType&"'") */
GC_POPS(stype); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(stype); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(token); /* for G.C. */
ch= 0;
dw= 0;
foundprimarytype= 0L;		/*  -- so we can handle things like 
					'INTEGER ARRAY...' */
s1= stype;

while ((*s1!='\0') &&iswhitespace((INTEGER)*s1)) ps_itrash_= LOP(s1);
while (*s1!='\0')
	{/* Eat up token */
	token= GC_EPOPS(getid(&s1,&ch));
	while ((*s1!='\0') &&iswhitespace((INTEGER)*s1)) ps_itrash_= LOP(s1);
	h= hash_c(GC_PUSHS(token));
/*  # # DBUG('2,"[CVSTYPE].1 token='"&token&"' h="&CVS(h)&" dw=0"&CVOS(dw)&" s1='"&s1&"'") */
	if (h==hreference) dw=dw|010000000L; 
	else if (h==hprocedure) dw=dw|0100000L; 
	else if (fast_equ(GC_PUSHS(token),GC_PUSHS("array"))) dw=dw|0200L; 
	else if (h==hc_array) dw=dw|0606710; 
	else if (h==hsafe) dw=dw|0400000L; 
	else if (h==hlong)
		{/* test LONG REAL */
		token= GC_EPOPS(getid(&s1,&ch));
		if (fast_equ(GC_PUSHS(token),GC_PUSHS("real"))) token= "double";
		}/* test LONG REAL */

	ch= 0;
	for (i=1;i<=31;i++)
		{/* check ith primary type */
		s2= (*aChkC(scvtype,1L,i));
/*  # # DBUG('2,"[CVSTYPE].2 sCVtype[i="&CVS(i)&"=0"&CVOS(i)&"='"&(s_i+"a"-1)&"']='"&s2&"'") */
		if (fast_equ(GC_PUSHS(s2),GC_PUSHS(token)) &&(!foundprimarytype)) 
			{/* found it */
			foundprimarytype= 1L;	/*  -- so don't set 2ndary
					     	     types like ARRAY. */
			ch= (i-1L) +(INTEGER)'a'; 
			pdw_ptype(dw,ch);
/*  # # DBUG('2,"[CVSTYPE].2.1 ch='"&(ps!sTrash!_ch)&"' i="&CVS(i)&"=0"&CVOS(i)&CRLF&" dw=0"&CVOS(dw)&" ch='"&(s2_ch)&"'") */
			if (isleapcode(ch)) dw=dw|020000L;
/*  # # DBUG('2,"[CVSTYPE].2.2 dw=0"&CVOS(dw)&"="&CRLF&"  '"&CVTYPES(dw)&"'") */
			goto PS0001 /* check ith primary type */;
			}/* found it */
		}/* check ith primary type */
PS0001: 

	;}/* Eat up token */

GC_EPOPS(dbug(02L,catlist(10L,GC_PUSHS("[CVSTYPE].3 sType=\'"),GC_PUSHS(stype),
        GC_PUSHS("\' foundPrimaryType="),pbool(foundprimarytype),
        GC_PUSHS(crlf),GC_PUSHS("  dw=0"),cvos(dw),GC_PUSHS("\'=\'")
        ,cvtypes(dw),GC_PUSHS("\'"))));

;
GC_NRETURN(dw)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 's'=<L0> string                               */
/*************************************************/

}/* CVSTYPE */
