/* FILE: cvcvt_any_to_char.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pscvt.c, being converted 12/25/87, 03:15:56PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------ */
 /*INTERNAL*/ STRING cvt_any_to_chr(s,breakstr,tochr)
	STRING s;
	STRING breakstr;
	INTEGER tochr;
/*  ------------------------------------------------------ */
{/* CVT!ANY!TO!CHR */
/*  --
.LABEL [<++PSAIL PROCEDURE: CVT!ANY!TO!CHR>]
.INDEX ++PSAIL PROCEDURE: CVT!ANY!TO!CHR
DESCRIPTION:
	Map any character which is a break character to the specified
target character if it occurs in the input string and return the
mapped string.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: CVT!ANY!TO!CHR>]
 */
STRING s1, 
	s2;
INTEGER ch;


GC_EPOPS(dbug(02L,catlist(7L,GC_PUSHS("[CVT!ANY!TO!CHR] s=\'"),GC_PUSHS(s),
        GC_PUSHS("\' breakStr=\'"),GC_PUSHS(breakstr),
        GC_PUSHS("\' toChr=\'"),
        GC_PUSHS(ps_strash_= GC_EPOPS(makstr(tochr))),GC_PUSHS("\'"))));
GC_POPS(breakstr); /* from GC string PDL */
GC_POPS(s); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(breakstr); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
setbreak(25L,GC_PUSHS(b25= breakstr),GC_PUSHS(PNULL),GC_PUSHS("INS")); 	/*  -- note also used by
						DEFINE [FSM1] */
s1= "@";				/*  -- prefix */
while (*s!='\0')
	{/* scan for break char and map if found */
	s2= GC_EPOPS(scan(&s,25L,&ch));
	if (*s2!='\0') s1= catlist(2L,GC_PUSHS(s1),GC_PUSHS(s2));
	if (ch!='\0') s1= catlist(2L,GC_PUSHS(s1),makstr(tochr));	/*  -- map it */
	}/* scan for break char and map if found */
ch= LOP(s1);		/*  -- trash '@'  */
GC_EPOPS(dbug(02L,catlist(3L,GC_PUSHS("[CVT!ANY!TO!CHR].1 s1=\'"),GC_PUSHS(s1),
        GC_PUSHS("\'"))));


GC_SRETURN(s1)
}/* CVT!ANY!TO!CHR */
