/* FILE: cvt_sail_to_c.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psparse.c, being converted 12/25/87, 09:34:41PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ----------------------------------------------------- */
/*INTERNAL*/ void cvt_sail_to_c()
/*  ----------------------------------------------------- */
{/* CVT!SAIL!TO!C */
/*  --
.LABEL [<++PSAIL PROCEDURE: CVT!SAIL!TO!C>]
.INDEX ++PSAIL PROCEDURE: CVT!SAIL!TO!C
DESCRIPTION:
	Convert the .SAI input file to .C output file until EOF.
Do special testing of first line to determine what type of intial
code to emit and to set the notMainFlag if we see 'ENTRY'.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: CVT!SAIL!TO!C>]
 */
STRING s, 
	s1, 
	trash, 
	mystars, 
	fileldelim, 
	filerdelim;
INTEGER h, 
	ht, 
	ishfilebeingcompiled;

/*    - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/*    Run time code to be emitted in front of .C file	    */
/*    - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* NEW SAIL MACRO DELIMITERS=[{}{}] */
#define sairun_c catlist(9L,\
        GC_PUSHS("\n\
\n\
/* SAIRUN.H PSAIL runtime package and macro definitions used in    */\n\
/* evaluating some SAIL converted forms:                           */\n\
#ifndef HASCONFIG\n\
#include "\
         /*N.P.*/),GC_PUSHS(fileldelim),GC_PUSHS("config.h"),\
        GC_PUSHS(filerdelim),\
        GC_PUSHS("	/* Declares the type of machine we are on */\n\
#endif\n\
#ifndef SAI_RUN\n\
#include "\
        /*N.P.*/),GC_PUSHS(fileldelim),GC_PUSHS("sairun.h"),\
        GC_PUSHS(filerdelim),\
        GC_PUSHS("	/* SAIL compatibility runtime package */\n\
#endif\n\
/*	 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */\n\
\n\
"\
        /*N.P.*/))

#define psrung_c catlist(5L,\
        GC_PUSHS("\n\
/* psrunG.h - used by SAIL-style String Garbage Collector:        */\n\
#ifndef GC_RUN\n\
#include "\
         /*N.P.*/),GC_PUSHS(fileldelim),GC_PUSHS("psrung.h"),\
        GC_PUSHS(filerdelim),\
        GC_PUSHS("		/* Garbage collector header file */\n\
#endif\n\
/*	 . . . . . . . . . . . . . . . . . . . . . . . . . . . . */\n\
"\
        /*N.P.*/))

#define psrunl_c catlist(5L,\
        GC_PUSHS("\n\
/* psrunL.h - used by SAIL-style LEAP run time package:          */\n\
#ifndef LEAP_RUN\n\
#include "\
         /*N.P.*/),GC_PUSHS(fileldelim),GC_PUSHS("psrunl.h"),\
        GC_PUSHS(filerdelim),\
        GC_PUSHS("		/* LEAP run time header file */\n\
ITEM any = -2;			/* LEAP special item */\n\
ITEM bindit = -3;		/* LEAP special item */\n\
#endif\n\
/*	   . . . . . . . . . . . . . . . . . . . . . . . . . */\n\
"\
        /*N.P.*/))

#define psrunx_c catlist(5L,\
        GC_PUSHS("\n\
/* psrunX.h - used by SAIL Extended Math functions runtime package */\n\
#ifndef XMTH_RUN\n\
#include "\
         /*N.P.*/),GC_PUSHS(fileldelim),GC_PUSHS("psrunX.h"),\
        GC_PUSHS(filerdelim),\
        GC_PUSHS("		/* extended math run time header file */\n\
#endif\n\
/*	. . . . . . . . . . . . . . . . . . . . . . . . . . . . */\n\
"\
        /*N.P.*/))

#define psrunp_c catlist(5L,\
        GC_PUSHS("\n\
/* psrunP.h - used by SAIL-style PROCESSES run time package: */\n\
#ifndef PRCS_RUN\n\
#include "\
         /*N.P.*/),GC_PUSHS(fileldelim),GC_PUSHS("psrunP.h"),\
        GC_PUSHS(filerdelim),\
        GC_PUSHS("		/* PROCESS run time header file */\n\
#endif\n\
/*	. . . . . . . . . . . . . . . . . . . . . . . . . . . . . */\n\
"\
        /*N.P.*/))

#define psrunw_c catlist(5L,\
        GC_PUSHS("\n\
/* psrunW.h - macros used by SAIL-style PROFILE run time        */\n\
/* package:                                                     */\n\
#ifndef PROF_RUN\n\
#include "\
         /*N.P.*/),GC_PUSHS(fileldelim),GC_PUSHS("psrunw.h"),\
        GC_PUSHS(filerdelim),\
        GC_PUSHS("		/* PROFILE run time header file */\n\
#endif\n\
/*	. . . . . . . . . . . . . . . . . . . . . . . . . . . . */\n\
"\
        /*N.P.*/))
/* NEW SAIL MACRO DELIMITERS=[\\\\] */
/*  - - - - E N D  O F  M A C R O S - - - */


;

GC_EPOPS(dbug(020000L,GC_PUSHS("[CVT!SAIL!TO!C]")));
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(trash); /* for G.C. */
GC_NOTESTRING(mystars); /* for G.C. */
GC_NOTESTRING(fileldelim); /* for G.C. */
GC_NOTESTRING(filerdelim); /* for G.C. */
mystars= subsr(GC_PUSHS(stars),1L,60L);
fileldelim= ((uselocalfilesflag) ?  quote : "<");
filerdelim= ((uselocalfilesflag) ?  quote : ">");

/*  -- NOTE: @V.54.85 need to insert BEGIN/END and treat file as ENTRY
file when compiling SAIL '.REQ' (i.e. C '.h') file in isolation.
 */
ishfilebeingcompiled= equ(subst(GC_PUSHS(cfile),length(cfile)-1L,length(cfile)),GC_PUSHS(".h"));
notmainflag= ishfilebeingcompiled;	/*  -- normally defaults to 
					MAIN (i.e. false) */
if (ishfilebeingcompiled) saistatement= "begin ";	/*  -- FAKE OUT PSAIL !!!
					here and see GET!INPUT
					also inserts the 'END'
					on seeing the final EOF. */

while (!saieof)
	{/* next statement */
/* 	Map statements from SAIL to C */

/*  -------------------------------------------------------------- */
/*  . . . . INITIALIZE GLOBAL FLAGS AND VARIABLES  to aid RESYNC.  */
/*  -------------------------------------------------------------- */
	GC_EPOPS(set_static(blocklevel));  /*  -- set dcStaticD.. & lastDecl.. */
	classize= PNULL;  /*  -- total RECORD!CLASS declaration size which
			  is the sum of the words used by its members */
	cstatement= PNULL;
	douniquetest= 0L;
	firstiftoken= isifexpr= 0L;
	genericname= PNULL;
	incaseflag= 0L;
	isarrayadrflag= 0L;
	isckeywordflag= 0L;
	iscopy_toflag= 0L;
	iscvevalflag= 0L;
	isforeachflag= 0L;
	isfragmentflag= 0L;
	isifcflag= 0L;
	ismacroflag= 0L;
	ismakeflag= 0L;
	ispreload_withflag= 0L;
	isrcdclassflag= 0L;
	isrcdptrflag= 0L;
	issailkeywordflag= 0L;
	lastmappedtoken= PNULL;
	lastrclass= 0L;
	laststatement= PNULL;
	lasttype= 0L;
	locleapptr= 0L;		/*  -- FOREACH local stack! */
	midofexpr= 0L;
	nomacflag= 0L;
	rcvlevel= 0L;	/*  -- Recursive descent level for CVEVALQUOTE */
	rdlevel= 0L;	/*  -- Recursive descent level used by DBUG and
			 set by R!D!EXPR!MAP */
	revalflag= 0L;	/*  -- Will be reset to TRUE if doing a
				recursive evaluation by 
				call to R!D!EXPR!MAP */
	rrlevel= 0L;	/*Recursive descent level used by RIGHTSTATEMENT*/
	sawdefineflag= 0L;	/*  -- reset in case screwup CVEVALQUOTE */
	uniqstuff= PNULL;

/*  -------------------------------------------------------------- */
/*  . . . .   GET NEXT STATEMENT TO PARSE . . . .			 */
/*  -------------------------------------------------------------- */
	get_next_statement(); 	/*  -- into String 'saiStatement'  */
	(*aChkC(errline,1L,0L))= saistatement;  /*  -- Save what we have now so that
				error reporting procedure ERR!HLR(msg)
				will be able to locate the offending
				SAIL source code */
	(*aChkC(errfsm,1L,0L))= "@"; 		/*  -- list of FSMs we will have used. */
	if (usetimerflag) cstatement= GC_EPOPS(run_time());  /*  -- If /TIMER then start of
					with HH:MM:SS or runtime
					used for optimizing the
					compiler by analyzing which
					statements eat of the clock! */


/*  -------------------------------------------------------------- */
/*  . . . IF FIRST LINE OF PROGRAM TEST IF MAIN OR PROCEDURE PKG   */
/*  -------------------------------------------------------------- */
	if (lineoneflag==1)
		{/* process first line of program */
GC_EPOPS(dbug(020000L,catlist(9L,GC_PUSHS("[CVT!SAIL!TO!C].0.1 notMainFlag="),
        pbool(notmainflag),GC_PUSHS(crlf),
        GC_PUSHS(" isHfileBeingCompiled="),pbool(
        ishfilebeingcompiled),GC_PUSHS(crlf),
        GC_PUSHS(" saiStatement=\'"),GC_PUSHS(saistatement),
        GC_PUSHS("\'"))));
		while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
		if (equ(subsr(GC_PUSHS(saistatement),1L,5L),GC_PUSHS("entry"))) 
			{/* Procedure pkg - not MAIN... */
			notmainflag= 1L;
			cstatement= catlist(2L,GC_PUSHS("/* ENTRY (procedure pkg) */"),GC_PUSHS(crlf));
			trash= GC_EPOPS(copy_omit(GC_PUSHS(";")));
			}/* Procedure pkg - not MAIN... */

		else if (ishfilebeingcompiled)
			cstatement= catlist(4L,GC_PUSHS("/* Compiling HEADER file \'"),GC_PUSHS(cfile),
        GC_PUSHS("\' */"),GC_PUSHS(crlf)); else cstatement= catlist(2L,
        GC_PUSHS("#define ISMAIN 1	/* used if program is MAIN module */")
        ,GC_PUSHS(crlf));


		/*  -- Now Barf RUN TIME 'includes'  */
		cstatement= catlist(8L,GC_PUSHS(cstatement),GC_PUSHS(crlf),
        GC_PUSHS("#define LOCALFILE 1     /* use "),GC_PUSHS(quote),
        GC_PUSHS("file"),GC_PUSHS(quote),GC_PUSHS(" not <file> */"),
        GC_PUSHS(crlf));
		cstatement= 
        				catlist(GC_PUSHS(cstatement),GC_PUSHS(sairun_c));    	/*  -- include special
						runtimes needed for
						SAIL emulation */
			if (usegcflag) cstatement= 
        					catlist(GC_PUSHS(cstatement),GC_PUSHS(psrung_c)); /*  -- include STRING
						Garbage Collector stuff */
			if (useleapflag) cstatement= 
        					catlist(GC_PUSHS(cstatement),GC_PUSHS(psrunl_c)); /*  -- include 
						LEAP stuff */
			if (usepmathflag) cstatement= 
        						catlist(GC_PUSHS(cstatement),GC_PUSHS(psrunx_c)); /*  -- include 
						Portable math stuff */
			if (useprocessesflag) cstatement= 
        						catlist(GC_PUSHS(cstatement),GC_PUSHS(psrunp_c)); /*  -- include
					Portable PROCESSES stuff */
			if (useprfileflag) cstatement= 
        						catlist(GC_PUSHS(cstatement),GC_PUSHS(psrunw_c)); /*  -- include
					Portable PROFILING stuff */
/* 	******* NOTE: Put new runtime '#include barfs'  H E R E ****** */
GC_EPOPS(dbug(020000L,catlist(7L,GC_PUSHS("[CVT!SAIL!TO!C].0.2 saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" cStatement=\'"),GC_PUSHS(cstatement),GC_PUSHS(
        "\'"))));
		if (*cstatement!='\0'&&!nuldevflag) out(cchan,GC_PUSHS(cstatement)); /*  -- do it only
					to the file since the /SCREEN
					does not normally look at
					this stuff... */
		cstatement= PNULL; 	/*  -- clean it out since no
					longer needed */

		if (*predeflist!='\0') saistatement= catlist(2L,GC_PUSHS(predeflist),GC_PUSHS(saistatement));
				/*  -- i.e. set up /DEFINE:<id>=<const>
				by using regular PSAIL parser after
				first line. */
GC_EPOPS(dbug(020000L,catlist(6L,GC_PUSHS("[CVT!SAIL!TO!C].1 notMainFlag="),pbool(
        notmainflag),GC_PUSHS(crlf),GC_PUSHS(" saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"))));
		}/* process first line of program */


/*  -------------------------------------------------------------- */
/*  . . . PROCESS STATEMENT TOKEN BY TOKEN . . .			 */
/*  -------------------------------------------------------------- */
	++stmntcnbr;		/*  -- This .C file */
	if (outputsailswitch)
		{/* print line */
		out_both(catlist(11L,GC_PUSHS(crlf),GC_PUSHS("/*{SAI} ["),cvs(stmntcnbr),
        GC_PUSHS("]"),GC_PUSHS(mystars),GC_PUSHS(crlf),
        GC_PUSHS(saistatement),GC_PUSHS(crlf),GC_PUSHS(minuses),
        GC_PUSHS(" */"),GC_PUSHS(crlf)));
		}/* print line */

	map_whitespace(&cstatement);
	lastidflag= 0L;	/*  -- set TRUE if previous token was
				     VARIABLE ID */
	if ((lineoneflag==-1))
		{/* saw logical EOF so just copy input==>output */
		if (*cstatement=='\0') cstatement= crlf; 
		else cstatement= catlist(2L,GC_PUSHS(cstatement),GC_PUSHS(crlf));
		s= crlf;
		if ((INTEGER)*saistatement) s= catlist(2L,GC_PUSHS(s),GC_PUSHS(saistatement));
		if ((INTEGER)*line) s= catlist(2L,GC_PUSHS(s),GC_PUSHS(line));
		line= saistatement= PNULL;
		while (!saieof) s= catlist(2L,GC_PUSHS(s),get_input());
/*  # # DBUG('20000,"[CVT!SAIL!TO!C].1.1 s='"&s&"'") */
		while ((*s!='\0') &&iswhitespace((INTEGER)*s)) ps_itrash_= LOP(s);
		if (*s!='\0') cstatement= 
        				  catlist(GC_PUSHS(cstatement),GC_PUSHS("/* "),GC_PUSHS(
        s),GC_PUSHS("*/"),GC_PUSHS(crlf));
		}/* saw logical EOF so just copy input==>output */

	else while ((*saistatement!='\0'))
		{/* Map token */
		s= GC_EPOPS(process_token()); /*parse tokens in sail statement*/
		if ((*s!='\0')
/*  # # @V.54.57  And (Not NULdevFlag)   */) 
			{/* build output string */
			if (*cstatement=='\0') cstatement= s; 
			else cstatement= catlist(2L,GC_PUSHS(cstatement),GC_PUSHS(s));
			}/* build output string */

/*  ------------------------------------------------------------- */
/*  . . . . <within Statement> CLEANUP PHASE FOR STRINGS. . .     */
/*  ------------------------------------------------------------- */
GC_EPOPS(dbug(020000L,catlist(14L,GC_PUSHS("[CVT!SAIL!TO!C].2 sawStrFCT="),pbool(sawstrfct),
        GC_PUSHS(" isEMITGCflag="),pbool(isemitgcflag),
        GC_PUSHS(crlf),GC_PUSHS(" didMainEmit="),pbool(didmainemit),
        GC_PUSHS(" didLOCemit="),pbool(didlocemit),
        GC_PUSHS(" oldToken=\'"),GC_PUSHS(oldtoken),
        GC_PUSHS("\' oldTypeStatement=\'"),
        GC_PUSHS(oldtypestatement),GC_PUSHS("\'"))));
		if (usegcflag &&sawstrfct &&
		   isemitgcflag) s= catlist(2L,GC_PUSHS(s),emit_cleanup_code());
/*  # # @V.48.163 ---> what about in nested blocks??? <--- */
/*  # # NOTE: @V.56.40 added EMIT!BLK!EXIT which handles this and is
called by anything doing a block exit.
 */
GC_EPOPS(dbug(020000L,catlist(7L,GC_PUSHS("[CVT!SAIL!TO!C].3 cStatement=\'"),
        GC_PUSHS(cstatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" saiStatement=\'"),GC_PUSHS(saistatement),
        GC_PUSHS("\'"))));
/*  # # DBUG('20000,"[CVT!SAIL!TO!C].3.1 sPDLptr="&CVS(sPDLptr)&" nPDLptr="&CVS(nPDLptr)&" blockLevel="&CVS(blockLevel)) */
		}/* Map token */


/*  -------------------------------------------------------------- */
/*  . . . MAIN CODE AND DYNAMIC ALLOCATION FOR STRINGS OR ARRAYS .  */
/*  -------------------------------------------------------------- */
GC_EPOPS(dbug(020000L,catlist(26L,GC_PUSHS("[CVT!SAIL!TO!C].4 oldTypeStatement=\'"),
        GC_PUSHS(oldtypestatement),GC_PUSHS("\' h="),cvs(h),
        GC_PUSHS(crlf),GC_PUSHS("  oldToken=\'"),GC_PUSHS(oldtoken),
        GC_PUSHS("\' hT="),cvs(ht),GC_PUSHS(" blockLevel="),
        cvs(blocklevel),GC_PUSHS(crlf),GC_PUSHS("  notMainFlag="),
        pbool(notmainflag),GC_PUSHS(" didMAINemit="),
        pbool(didmainemit),GC_PUSHS(" firstMAINxct="),
        pbool(firstmainxct),GC_PUSHS(crlf),GC_PUSHS(" didLOCemit="),
        pbool(didlocemit),GC_PUSHS(" firstLOCxct="),pbool(
        firstlocxct),GC_PUSHS(crlf),GC_PUSHS("  isFRAGMENTflag="),
        pbool(isfragmentflag))));
	if (firstlocxct &&(!didlocemit))
		{/* Go EMIT either MAIN or LOC code */
		/*  -- NOTE: 11/19/83 - EMIT after 'END' of last
		procedure, trash outer Begin End... Define 'main(){'
		on seeing first non-procedure statement at top level. */
		if (isfragmentflag) firstlocxct= 
		0L; else if ((!notmainflag) &&(!didmainemit) &&
		   (blocklevel<=1)) 
			{/* go emit main code */
GC_EPOPS(dbug(020000L,catlist(13L,GC_PUSHS("[CVT!SAIL!TO!C].5 blockLevel="),cvs(blocklevel),
        GC_PUSHS(" locIptr="),cvs(lociptr),GC_PUSHS(" locSptr="),
        cvs(locsptr),GC_PUSHS(" locAptr="),cvs(locaptr),GC_PUSHS(
        crlf),GC_PUSHS("  firstLOCxct="),pbool(firstlocxct),
        GC_PUSHS(" didLOCemit="),pbool(didlocemit))));
			s= GC_EPOPS(emit_main_code());
			cstatement= catlist(2L,GC_PUSHS(s),GC_PUSHS(cstatement));   /*  -- insert BEFORE */
GC_EPOPS(dbug(020000L,catlist(5L,GC_PUSHS("[CVT!SAIL!TO!C].5.1 s="),GC_PUSHS(s),GC_PUSHS(
        crlf),GC_PUSHS(" New cStatement="),GC_PUSHS(cstatement))));
			}/* go emit main code */
		else if ((!didmainemit) &&
			(usegcflag ||usechkflag ||useleapflag ||
			 useprfileflag)) 
			{/* go emit dynamic allocation code */
/*  -- @V.52.78 NOTE: Need to work in 'isEMITGCflag' into test */
/*  # # DBUG('20000,"[CVT!SAIL!TO!C].5.2 blockLevel="&CVS(blockLevel)&" locIptr="&CVS(locIptr)&" locSptr="&CVS(locSptr)&" locAptr="&CVS(locAptr)&CRLF&"  firstLOCxct="&PBOOL(firstLOCxct)&" didLOCemit="&PBOOL(didLOCemit)) */
			s= GC_EPOPS(emit_loc_code());
			cstatement= catlist(2L,GC_PUSHS(s),GC_PUSHS(cstatement));   /*  -- insert BEFORE */
GC_EPOPS(dbug(020000L,catlist(5L,GC_PUSHS("[CVT!SAIL!TO!C].5.3 s="),GC_PUSHS(s),GC_PUSHS(
        crlf),GC_PUSHS(" New cStatement="),GC_PUSHS(cstatement))));
			}/* go emit dynamic allocation code */
		firstlocxct= 0L;	/*  -- SO NEVER NEVER COME AGAIN */
		}/* Go EMIT either MAIN or LOC code */


/*  -------------------------------------------------------------- */
/*  . . . CHECK FOR ('BELL'&'hugeCMTnnn) THEN EXPAND COMMENT . .   */
/*  -------------------------------------------------------------- */
/*  -- NOTE: CVEVALQUOTE will map all HUGE comments to 
	07 & "hugeCMT" & CVS(index) 
 as the comment. We must find the index in order to look up 
 the comment. After we map it, we free the comment space by
 clearing it.
 */
	s1= cstatement;
	s= GC_EPOPS(scan(&s1,34L,&saibrk));		/*  -- scan for 07 or BELL  */
	if ((saibrk==07) &&equ(subsr(GC_PUSHS(s1),1L,7L),GC_PUSHS("hugeCMT")))
		{/* Go get HUGE COMMENT index nnn and expand it */
		INTEGER index;
GC_EPOPS(dbug(020000L,catlist(14L,GC_PUSHS("[CVT!SAIL!TO!C].5.4 HUGE CMT nHugeCMTS="),
        cvs(nhugecmts),GC_PUSHS(crlf),GC_PUSHS(" s=\'"),GC_PUSHS(s),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" s1=\'"),
        GC_PUSHS(s1),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" cStatement=\'"),GC_PUSHS(cstatement),GC_PUSHS(
        "\'"))));
		cstatement= "@";
		if (*s!='\0') cstatement= catlist(2L,GC_PUSHS(cstatement),GC_PUSHS(s));
		s1= subst(GC_PUSHS(s1),8L,length(s1));	/*  -- move past 'hugeCMT'  */
		index= intscan(&s1,&saibrk);	/*  -- get the index */
GC_EPOPS(dbug(020000L,catlist(11L,GC_PUSHS("[CVT!SAIL!TO!C].5.4.1 index=\'"),cvs(index),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" s1=\'"),
        GC_PUSHS(s1),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" cStatement=\'"),GC_PUSHS(cstatement),GC_PUSHS(
        "\'"))));
		cstatement= catlist(3L,GC_PUSHS(cstatement),GC_PUSHS(*aChkC(hugecmtpdl,1L,index)),
        GC_PUSHS(s1));
		saibrk= LOP(cstatement);		/*  -- trash '@'  */
		(*aChkC(hugecmtpdl,1L,index))= PNULL;  	/*  -- free it up */
		--nhugecmts;
GC_EPOPS(dbug(020000L,catlist(6L,GC_PUSHS("[CVT!SAIL!TO!C].5.4.2 nHugeCMTS="),cvs(nhugecmts)
        ,GC_PUSHS(crlf),GC_PUSHS(" cStatement=\'"),
        GC_PUSHS(cstatement),GC_PUSHS("\'"))));
		}/* Go get HUGE COMMENT index nnn and expand it */


/*  -------------------------------------------------------------- */
/*  . . . .   MAKE IT PRETTY IF THEY ASK YOU /PRETTYPRINT		 */
/*  -------------------------------------------------------------- */
GC_EPOPS(dbug(020004L,catlist(3L,GC_PUSHS("[CVT!SAIL!TO!C].6 PreP!P cStatement=\'"),
        GC_PUSHS(cstatement),GC_PUSHS("\'P!PerP"))));
/*  -- Note: if we are not going to save the output then why waste time
cleaning it up just before we trash it? */
	if (prttyprintflag &&!nuldevflag) cstatement= GC_EPOPS(pretty_print(GC_PUSHS(cstatement)));

GC_EPOPS(dbug(020000L,catlist(7L,GC_PUSHS("[CVT!SAIL!TO!C].6.1 NULdevFlag="),pbool(
        nuldevflag),GC_PUSHS(" ["),cvs(stmntcnbr),
        GC_PUSHS("] FINAL cStatement=\'"),GC_PUSHS(cstatement),
        GC_PUSHS("\'"))));
GC_EPOPS(dbug(020000L,catlist(16L,GC_PUSHS("[CVT!SAIL!TO!C].6.1.1 blockLevel="),
        cvs(blocklevel),GC_PUSHS(" firstMAINxct="),pbool(
        firstmainxct),GC_PUSHS(" didMainEmit="),pbool(didmainemit),
        GC_PUSHS(crlf),GC_PUSHS(" firstLOCxct="),pbool(firstlocxct),
        GC_PUSHS(crlf),GC_PUSHS(" didLOCemit="),pbool(didlocemit),
        GC_PUSHS(" oldTypeStatement="),GC_PUSHS(oldtypestatement),
        GC_PUSHS(" isFragmentFlag="),pbool(isfragmentflag))));

/*  -------------------------------------------------------------- */
/*  . . . .  OUTPUT THE TRANSLATED C CODE TO OUTPUT FILE		 */
/*  -------------------------------------------------------------- */
	out_both(GC_PUSHS(cstatement));	/*  -- Finally! OUTPUT ==> .C file  */


/*  -------------------------------------------------------------- */
/*  . . . TEST FOR PORTABILITY /UNIQUENESS:n TEST . . .		 */
/*  -------------------------------------------------------------- */
	if (*uniqstuff!='\0') out_both(GC_PUSHS(uniqstuff));
	if (lineoneflag!=-1) lineoneflag= 0L;	/*  -- set not first line but
					  also not EOF */
	}/* next statement */

;
#undef psrunw_c
#undef psrunp_c
#undef psrunx_c
#undef psrunl_c
#undef psrung_c
#undef sairun_c
{GC_UNMARKSSTKFRAME;}
}/* CVT!SAIL!TO!C */
