/* FILE: cvtypes.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pscvt.c, being converted 12/25/87, 03:15:56PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------ */
 /*INTERNAL*/ STRING cvtypes(dw)
	INTEGER dw;
/*  ------------------------------------------------------ */
{/* CVTYPES */
/*  --
.LABEL [<++PSAIL PROCEDURE: CVTYPES>]
.INDEX ++PSAIL PROCEDURE: CVTYPES
DESCRIPTION:
	Convert the PSAIL (lower case) character internal coded
declaration keyword to to the corresponding SAIL keyword declaration
string (lower case). Return NULL if no match.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: CVTYPES>]
 */
STRING s, 
	s1;
INTEGER ch, 
	i, 
	typec, 
	itemcode;

 static STRING /*ARRAY*/ 
/*******************************************************************/
/* WARNING! Can't have OWN STRING declarations in non-MAIN module  */
/* or inner blocks! Suggest you move 'STRING itemname' declaration */
/* to global level in MAIN module and recompile.                   */
/*******************************************************************//*N.P.*/
/***************************/
/*<7>    ..                */
/*      .                  */
/*   /----------\          */
/*   | o         _______/  */
/*   |__         -------\  */
/*   \----------/          */
/*                         */
/*   A GROSS MOBY          */
/***************************/

P_itemname[26+(16-0+1L)] = { 
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, "nil!item",
   		/*  -- 0 */
   "untyped!item",		/*  -- 1 */
   "brkted!triple",	/*  -- 2 */
   "string",		/*  -- 3 */
   "real",			/*  -- 4 */
   "integer",		/*  -- 5 */
   "set",			/*  -- 6 */
   "list",			/*  -- 7 */
   "procedure",		/*  -- 8 */
   "process",		/*  -- 9 */
   "event",		/*  -- 10 */
   "context",		/*  -- 11 */
   "reference!item",	/*  -- 12 */
   "record!pointer",	/*  -- 13 */
   "label",		/*  -- 14 */
   "record!class" };
 static STRING /*ARRAY*/ 
/*******************************************************************/
/* WARNING! Can't have OWN STRING declarations in non-MAIN module  */
/* or inner blocks! Suggest you move 'STRING itemname' declaration */
/* to global level in MAIN module and recompile.                   */
/*******************************************************************//*N.P.*/
/***************************/
/*<7>    ..                */
/*      .                  */
/*   /----------\          */
/*   | o         _______/  */
/*   |__         -------\  */
/*   \----------/          */
/*                         */
/*   A GROSS MOBY          */
/***************************/

*itemname  /* [0:16] */ ;


#define maxdw 17
 static STRING /*ARRAY*/ 
/******************************************************************/
/* WARNING! Can't have OWN STRING declarations in non-MAIN module */
/* or inner blocks! Suggest you move 'STRING dwname' declaration  */
/* to global level in MAIN module and recompile.                  */
/******************************************************************//*N.P.*/
/***************************/
/*<7>    ..                */
/*      .                  */
/*   /----------\          */
/*   | o         _______/  */
/*   |__         -------\  */
/*   \----------/          */
/*                         */
/*   A GROSS MOBY          */
/***************************/

P_dwname[26+(17-1+1L)] = { 
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, "array",
   	"c!array",
   	"external",
   	"forward",
   	"formalArg",
   	"fragment",
   	"fsm",
   	"genericProc",
   	"item!array",
   	"leap",
   	"internal",
   	"macro",
   	"procedure",
   	"reference",
   	"record!mem",
   	"safe",
   	"static" };
 static STRING /*ARRAY*/ 
/******************************************************************/
/* WARNING! Can't have OWN STRING declarations in non-MAIN module */
/* or inner blocks! Suggest you move 'STRING dwname' declaration  */
/* to global level in MAIN module and recompile.                  */
/******************************************************************//*N.P.*/
/***************************/
/*<7>    ..                */
/*      .                  */
/*   /----------\          */
/*   | o         _______/  */
/*   |__         -------\  */
/*   \----------/          */
/*                         */
/*   A GROSS MOBY          */
/***************************/

*dwname  /* [1:maxdw] */ ;


 static INTEGER /*ARRAY*/ P_dwbits[13+(17-1+1L)] = { 
   0,0,0,0,0,0,0,0,0,0,0,0,0, dw_array,
   	dw_carray,
   	dw_external,
   	dw_forwardref,
   	dw_formalarg,
   	dw_fragment,
   	dw_fsm,
   	dw_genericproc,
   	dw_itemarray,
   	dw_leap,
   	dw_internal,
   	dw_macro,
   	dw_procedure,
   	dw_reference,
   	dw_recmem,
   	dw_safe,
   	dw_static };
 static INTEGER /*ARRAY*/ *dwbits  /* [1:maxdw] */ ;


;

/*  # # DBUG('2,"[CVTYPES] dw=0'"&CVOS(dw)&"'") */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTEASTRING(itemname);	/* for G.C. */
GC_NOTEASTRING(dwname);	/* for G.C. */
itemname = aryHdrC(P_itemname,1,0,16,"itemname",'c');	/* Dynamic Array */
dwname = aryHdrC(P_dwname,1,1,17,"dwname",'c');	/* Dynamic Array */
dwbits = aryHdrI(P_dwbits,1,1,17,"dwbits",'i');	/* Dynamic Array */
s= catlist(3L,GC_PUSHS("<L"),cvs(gdw_sublanguage(dw)),GC_PUSHS(">"));

itemcode= gdw_itemtype(dw);		/*  -- GET LEAP TYPEIT() code */
if (itemcode!=0)
	{/* prefix with LEAP primary type */
	if (itemcode>20&&itemcode<40) itemcode -= 20;
	if (itemcode<=16) s= catlist(3L,GC_PUSHS(s),GC_PUSHS(" "),GC_PUSHS(*aChkC(itemname,1L,
        itemcode))); else s= catlist(7L,GC_PUSHS(s),GC_PUSHS(" "),GC_PUSHS("(ERR itemCode="),
        cvs(itemcode),GC_PUSHS(" DW=0"),cvos(dw),GC_PUSHS(")"));
	}/* prefix with LEAP primary type */

for (i=1;i<=17L;i++)
	if ((dw&(*aChkI(dwbits,1L,i)))!=0) s= catlist(3L,GC_PUSHS(s),GC_PUSHS(" "),GC_PUSHS(*aChkC(dwname,1L,i)));

typec= (((ps_itrash_= (dw&037))>0) ? (ps_itrash_+0140L)
				:0L);
/*  # # DBUG('2,"[CVTYPES].1 typeC=0"&CVOS(typeC)&"='"&(s1_typeC)&"' (dw Land '37)="&CVOS(dw Land '37)) */
if (('a'<=typec && typec<=0177L))
		{/* make expanded name */
		i= (typec-(INTEGER)'a')+1L;
		s= catlist(3L,GC_PUSHS(s),GC_PUSHS(" "),GC_PUSHS(*aChkC(scvtype,1L,i)));
		}/* make expanded name */

/*  # # DBUG('2,"[CVTYPES].2 dw=0"&CVOS(dw)&" s='"&s&"'") */


GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'ch'=<L0> integer                             */
/* 's1'=<L0> string                              */
/*************************************************/

#undef maxdw
}/* CVTYPES */
