/* FILE: dbug_it.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psdbug.c, being converted 12/25/87, 01:13:54PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/* IFC EVAL(usemacros=1)=1 */
/* THENC */

/*  ---------------------------------------------  */
/*INTERNAL*/   void dbug_it(code,x)
	INTEGER code;
	STRING x;
/*  ---------------------------------------------  */
{/* DBUG!IT */
/*  --
.LABEL [<++PSAIL PROCEDURE: DBUG!IT>]
.INDEX ++PSAIL PROCEDURE: DBUG!IT
DESCRIPTION:
	Print Debugging information message if 'debugSwitch' is set
and any of the 'code' bit(s) specified is in 'dBugCode' are set.
This is tested in DBUG(code,x) macro in PSMACRO.REQ as:
	 'debugSwitch And (code Land dBugCode)'
The debugging information is then printed using the recursive descent
level and message 'x' in a special format:
	{rdLevel} <<DBUG:: {x} >> {CRLF} 
Where:
	{rdLevel} is 1 for the outer block 2 for procedure bodies etc.
	{x} is the message pased to this procedure,


SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: DBUG!IT>]
 */

STRING s;

GC_POPS(x); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(x); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */

s= catlist(5L,cvs(rdlevel) ,GC_PUSHS("<<DBUG::"),GC_PUSHS(x),
	   GC_PUSHS(">>"),GC_PUSHS(crlf));

/*  --	If an output .C file exists (i.e. /NONUL: switch) then print
to that. If /SCREEN was set, then also print to the terminal.
 */
if (!nuldevflag) out(cchan,GC_PUSHS(s));
if (screenflag) PSprintf("%s",GC_PUSHS(s));

/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'code'=<L0> formalArg integer                 */
/*************************************************/

{GC_UNMARKSSTKFRAME;}
}/* DBUG!IT */
   /* ENDC */
