#!/bin/csh
echo 'File: distribute.do  3-10-87 @V.56.40'
# P. Lemkin
# Distribute the kermit files in the current directory to the
# appropriate ~/psail directories.
# After bringing the PSAIL files over to the uVAX $TMP directory using
# KERMIT, we need to do some things. If $TMP is not defined, we define it.
#
#
# [0] Put use into kermit directory
if(! -f $TMP) setenv TMP ~/psail/junk
cd $TMP
ls -l
if(! -f pspara.h) then
  echo 'BAD $TMP DIRECTORY FOR PSAIL'
  exit()
  endif
  #
echo '[1] Remove any nulls in files inserted by TOPS10 KERMIT.'
foreach i (./*)
	tr < $i > tmp ; mv tmp $i
end
#
echo '[2] Rename problem TOPS10 files to full UNIX file names.'
mv pspara.h psparam.h
mv psmacr.h psmacros.h
mv pspars.c psparse.c
mv pspars.h psparse.h
mv pssymt.c pssymtab.c
mv pssymt.h pssymtab.h
#
echo '[3] Move the RUNTIME files to ~/psail/runtim'
cp psr*.c ~/psail/runtim
cp psr*.h ~/psail/runtim
cp sairun.* ~/psail/runtim
cp conf*.h ~/psail/runtim
# -- Also move some of the headers into /module as well.
cp gogtab.h ~/psail/runtim
cp sairun.h ~/psail/module
cp config.h ~/psail/module
cp psrung.h ~/psail/module
rm psr*.c psr*.h sairun.* config.h confg2.h gogtab.h
#
echo '[4] Move the MODULE files to ~/psail/module'
cp ps*.c ~/psail/module
cp ps*.h ~/psail/module
rm ps*.c ps*.h
#
echo '[5] Move the run time input files to ~/psail/runfiles'
cp *.cod ~/psail/runfiles
cp *.txt ~/psail/runfiles
cp *.tgf ~/psail/runfiles
cp *.ini ~/psail/runfiles
cp *.map ~/psail/runfiles
if(! -f demo.std) cp demo.std ~/psail/runfiles
rm *.cod *.txt *.tgf *.ini *.map demo.std
#
echo '[6] Move the makefile to ~/psail'
cp psail.mak ~/psail
cp psail.mak ~/psail/Makefile
rm psail.mak
#
echo '[7] Move documentation files - if they exist!'
if(!-f *.nf) cp *.nf ~/psail/doc
if(!-f *.new) cp *.new ~/psail/doc
if(!-f *.doc) cp *.doc ~/psail/doc
if(!-f *.mem) cp *.mem ~/psail/mem
if(!-f *.prp) cp *.prp ~/psail/prp
rm *.nf *.new *.doc *.mem *.prp
#
echo '[8] the directory should be null!'
ls -l
#
echo ' ---> FINISHED! You can now run lint, or make etc.'
# -- the end ---
