/* FILE: emit_loc_code.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psgc.c, being converted 12/25/87, 04:48:55PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ---------------------------------------------------- */
/*INTERNAL*/  STRING emit_loc_code()
/*  ---------------------------------------------------- */
{/* EMIT!LOC!CODE */
/*   --
.LABEL [<++PSAIL PROCEDURE: EMIT!LOC!CODE>]
.INDEX ++PSAIL PROCEDURE: EMIT!LOC!CODE
DESCRIPTION:
	Output the local block code. The String G.C. names are in the
locStrName[1:locSptr] String array. An entry of 0 at location i
indicates that
		the name is at i+2,
		the size of the string array is at i+1.

The dynamic array names are in the locAryName[1:locAptr] string
array. Entries are one of the following forms:
	1. For non-PRELOADED non-OWN dynamic arrays:
		@<varname>,nArgs,LB1,UB1,...,LBn,UBn,"varname",'type'
	to generate 
		<varname>=arymk(...)
or
	2. For PRELOADED OWN dynamic arrays. Note that even though it
	   is OWN we do not pre-allocate it like C, but rather
	   test whether we call arymk() other than the first time!:
		!<varname>,nArgs,LB1,UB1,...,LBn,UBn,"varname",'type'
	to generate 
		if(<varname>==0) <varname>=arymk(...)
or
	3. For PRELOADED static arrays which may be OWN or not:
		#P_<varname>,nArgs,LB1,UB1,...,LBn,UBn,"varname",'type'
	to generate 
		<varname>=aryHdr(...)
or
	4. For LEAP item initialization:
		?<varname>,<octal declaration word>
	to generate if(<varname> < 0) <varname>=mkItem(...).

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: EMIT!LOC!CODE>]
 */
STRING s, 
	s1, 
	s2, 
	s3, 
	xname, 
	wspreface, 
	id;
INTEGER i, 
	j, 
	k, 
	m, 
	n, 
	h, 
	ch, 
	brk, 
	dw, 
	idx, 
	code;

;
GC_EPOPS(dbug(040000000L,catlist(14L,GC_PUSHS("[EMIT!LOC!CODE] blockLevel="),cvs(blocklevel),
        GC_PUSHS(crlf),GC_PUSHS(" locIptr="),cvs(lociptr),
        GC_PUSHS(" locSptr="),cvs(locsptr),GC_PUSHS(" locAptr="),
        cvs(locaptr),GC_PUSHS(crlf),GC_PUSHS(" firstLOCxct="),
        pbool(firstlocxct),GC_PUSHS(" didLOCemit="),pbool(didlocemit))));
GC_EPOPS(dbug(040000000L,catlist(14L,GC_PUSHS("[EMIT!LOC!CODE].0.1 blkSPDLptr[blockLevel]="),
        cvs((*aChkI(blkspdlptr,1L,blocklevel))),
        GC_PUSHS(" locSptr="),cvs(locsptr),GC_PUSHS(crlf),
        GC_PUSHS(" blkAPDLptr[blockLevel]="),cvs((*aChkI(blkapdlptr,
        1L,blocklevel))),GC_PUSHS(" locAptr="),cvs(locaptr),
        GC_PUSHS(crlf),GC_PUSHS(" blkIPDLptr[blockLevel]="),
        cvs((*aChkI(blkipdlptr,1L,blocklevel))),
        GC_PUSHS(" locIptr="),cvs(lociptr))));
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(s3); /* for G.C. */
GC_NOTESTRING(xname); /* for G.C. */
GC_NOTESTRING(wspreface); /* for G.C. */
GC_NOTESTRING(id); /* for G.C. */
for (i=0;i<=blocklevel;i++) GC_EPOPS(dbug(040000000L,catlist(8L,GC_PUSHS("[EMIT!LOC!CODE].0.2 blkSPDLptr["),cvs(i),
        GC_PUSHS("]="),cvs((*aChkI(blkspdlptr,1L,i))),
        GC_PUSHS(" blkAPDLptr["),cvs(i),GC_PUSHS("]="),
        cvs((*aChkI(blkapdlptr,1L,i))))));

firstlocxct= 1L;	/*First executable statement at this level!*/
if ((blocklevel<=1) &&!didmainemit) 
	{/* save the call for later from EMIT!MAIN!CODE */
	if (ismacroflag) 
		{/* Not MAIN emit!!! */
		firstlocxct= 0L;
	   	if ((usegcflag &&((*aChkI(blkspdlptr,1L,blocklevel))<locsptr)) ||
		   (usechkflag &&((*aChkI(blkapdlptr,1L,blocklevel))<locaptr)) ||
		   (useleapflag &&((*aChkI(blkipdlptr,1L,blocklevel))<lociptr))) isfragmentflag= 1L;
		}/* Not MAIN emit!!! */
GC_EPOPS(dbug(040000000L,catlist(6L,GC_PUSHS("[EMIT!LOC!CODE].0.3 SAVE FOR MAIN"),
        GC_PUSHS(crlf),GC_PUSHS("  isFRAGMENTflag="),
        pbool(isfragmentflag),GC_PUSHS(" firstLOCxct="),
        pbool(firstlocxct))));
	{GC_UNMARKSSTKFRAME;
	 GC_SRETURN(PNULL);}
	}/* save the call for later from EMIT!MAIN!CODE */

if (didlocemit)
	{/* was here already - don't do anything! */
	err_hlr(catlist(19L,GC_PUSHS("[EMIT!LOC!CODE] DRYROT - here before!"),
        GC_PUSHS(crlf),GC_PUSHS(" blockLevel="),cvs(blocklevel),
        GC_PUSHS(" locAptr="),cvs(locaptr),GC_PUSHS(" locIptr="),
        cvs(lociptr),GC_PUSHS(" locSptr="),cvs(locsptr),GC_PUSHS(
        crlf),GC_PUSHS(" didLOCemit="),pbool(didlocemit),
        GC_PUSHS(" firstLOCxct="),pbool(firstlocxct),GC_PUSHS(crlf),
        GC_PUSHS(" sEmit=\'"),GC_PUSHS(semit),GC_PUSHS("\'")));
	{GC_UNMARKSSTKFRAME;
	 GC_SRETURN(semit);}	/*  -- just keep doing the same thing */
	}/* was here already - don't do anything! */

didlocemit= 1L;	/*So never do it again!*/
s1= s= "@";			/*  -- set dummy prefix */

set_preface(&wspreface); /*  -- set wsPreface := SPACE|TAB W.S. to left */
if (usegcflag &&((j= (*aChkI(blkspdlptr,1L,blocklevel)))<locsptr))
	{/* barf out the STRING GC code */
	/*  -- NOTE: we emit GC_POPS() for the temporary string
	variable PDL for all actual args.
	 */
	m= 0;		/*  - pop counter */
	for (i=locsptr;i<=((j+1L));i--)
		{/* POP any non-REFERENCE formal arg */
		xname= (*aChkC(locstrname,1L,i));  /*  -- get name */
		if ((dw= (*aChkI(decldw,1L,idx= (*aChkI(dwptr,1L,h= hash_c(GC_PUSHS(xname))))))) &&
		   (dw&040000L) &&
		   (dw&046113720)==0 &&
		   (((ps_itrash_= (dw&037))>0) ? (ps_itrash_+0140L)
				:0L)==codestring &&
		   (*aChkI(declblklvl,1L,idx))==blocklevel) 
			{/* gen it */
			s3= catlist(4L,GC_PUSHS("GC_POPS("),GC_PUSHS(xname),
        GC_PUSHS("); /* from GC string PDL */"),GC_PUSHS(wspreface));
			s1= catlist(2L,GC_PUSHS(s1),GC_PUSHS(s3));	/*  -- add it on */
			++m;   /*  -- count pops */
			}/* gen it */
GC_EPOPS(dbug(040000000L,catlist(22L,GC_PUSHS("[EMIT!LOC!CODE].1 locStrName["),cvs(i),
        GC_PUSHS("]=\'"),GC_PUSHS(xname),GC_PUSHS("\'"),GC_PUSHS(
        crlf),GC_PUSHS(" dw=\'"),cvtypes(dw),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" declBlkLvl[idx]="),
        cvs((*aChkI(declblklvl,1L,idx))),GC_PUSHS(" m="),cvs(m),
        GC_PUSHS(crlf),GC_PUSHS(" s1=\'"),GC_PUSHS(s1),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" s3=\'"),
        GC_PUSHS(s3),GC_PUSHS("\'"))));
		}/* POP any non-REFERENCE formal arg */

GC_EPOPS(dbug(040000000L,catlist(16L,GC_PUSHS("[EMIT!LOC!CODE].1.1 m="),cvs(m),GC_PUSHS(" n="),
        cvs(n),GC_PUSHS(crlf),GC_PUSHS(" s1=\'"),GC_PUSHS(s1),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" s2=\'"),
        GC_PUSHS(s2),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" s3=\'"),GC_PUSHS(s3),GC_PUSHS("\'"))));
	s= s1;	/*  -- ok, use the mess */
GC_EPOPS(dbug(040000000L,catlist(20L,GC_PUSHS("[EMIT!LOC!CODE].1.2 m="),cvs(m),GC_PUSHS(" n="),
        cvs(n),GC_PUSHS(crlf),GC_PUSHS(" s1=\'"),GC_PUSHS(s1),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" s2=\'"),
        GC_PUSHS(s2),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" s3=\'"),GC_PUSHS(s3),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" s=\'"),GC_PUSHS(s),GC_PUSHS("\'"))));

	s= catlist(3L,GC_PUSHS(s),
        GC_PUSHS("GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */"),
        GC_PUSHS(wspreface));

	for (i=j+1L;i<=locsptr;i++)
		{/* barf out local string variable ptrs */
		xname= (*aChkC(locstrname,1L,i));
GC_EPOPS(dbug(040000000L,catlist(5L,GC_PUSHS("[EMIT!LOC!CODE].1.1 locStrName["),cvs(i),
        GC_PUSHS("]=\'"),GC_PUSHS(xname),GC_PUSHS("\'"))));
		if (!fast_equ(GC_PUSHS(xname),GC_PUSHS("0"))) s= catlist(5L,GC_PUSHS(s),GC_PUSHS("GC_NOTESTRING("),GC_PUSHS(xname),
        GC_PUSHS("); /* for G.C. */"),GC_PUSHS(wspreface)); else 	{/* get array */
			xname= (*aChkC(locstrname,1L,++i));
			s= catlist(7L,GC_PUSHS(s),GC_PUSHS("GC_NOTEASTRING("),GC_PUSHS(xname),
        GC_PUSHS(");"),GC_PUSHS(tab),GC_PUSHS("/* for G.C. */"),
        GC_PUSHS(wspreface));
			}/* get array */
		}/* barf out local string variable ptrs */
	}/* barf out the STRING GC code */

if (usechkflag &&((j= (*aChkI(blkapdlptr,1L,blocklevel)))<locaptr))
	{/* barf out the ARRAY allocation code */
	for (i=j+1L;i<=locaptr;i++)
		{/* barf out local array variable ptrs */
		xname= (*aChkC(locaryname,1L,i));
		code= LOP(xname);	/*  -- will be ! or @ or #  */
		id= GC_EPOPS(scan(&xname,2L,&brk));	/*  -- get array name */
		dw= (*aChkI(decldw,1L,(*aChkI(dwptr,1L,hash_c(GC_PUSHS(id)))))); /*  -- type CHR */
		s2= ((((ps_itrash_= (dw&037))>0) ? GC_EPOPS(makstr((ps_itrash_+0140L)
				)):0L))-GC_EPOPS(makstr(0242L));   /*  -- type upper CHAR */
GC_EPOPS(dbug(040000000L,catlist(21L,GC_PUSHS("[EMIT!LOC!CODE].2 locAryName["),cvs(i),
        GC_PUSHS("]=\'"),GC_PUSHS(*aChkC(locaryname,1L,i)),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" dw=\'"),cvtypes(dw)
        ,GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" idx="),cvs(idx),
        GC_PUSHS(" h="),cvs(h),GC_PUSHS(" code=\'"),
        GC_PUSHS(ps_strash_= GC_EPOPS(makstr(code))),
        GC_PUSHS("\' id=\'"),GC_PUSHS(id),GC_PUSHS("\' s2=\'"),
        GC_PUSHS(s2),GC_PUSHS("\'"))));
		if (code=='@'||code=='!')
			{/* Dynamic array declaration */
			if (code=='!') s1= catlist(4L,GC_PUSHS("if ("),GC_PUSHS(id),GC_PUSHS("==0) "),GC_PUSHS(s1));
			s2= (((INTEGER)*(s2 )) ? catlist(2L,GC_PUSHS(s2),GC_PUSHS("(")): "(" );
			s1= catlist(3L,GC_PUSHS(id),GC_PUSHS(" = arymk"),GC_PUSHS(s2));
GC_EPOPS(dbug(040000000L,catlist(3L,GC_PUSHS("[EMIT!LOC!CODE].2.1 s1=\'"),GC_PUSHS(s1),
        GC_PUSHS("\'"))));
			}/* Dynamic array declaration */

		else if (code=='#')
			{/* static array HEADER declaration */
			s1= catlist(6L,GC_PUSHS(id),GC_PUSHS(" = aryHdr"),GC_PUSHS(s2),
        GC_PUSHS("(P_"),GC_PUSHS(id),GC_PUSHS(","));
GC_EPOPS(dbug(040000000L,catlist(3L,GC_PUSHS("[EMIT!LOC!CODE].2.2 s1=\'"),GC_PUSHS(s1),
        GC_PUSHS("\'"))));
			}/* static array HEADER declaration */
		s1= catlist(6L,GC_PUSHS(s1),GC_PUSHS(xname),GC_PUSHS(");"),GC_PUSHS(tab),
        GC_PUSHS("/* Dynamic Array */"),GC_PUSHS(wspreface));
GC_EPOPS(dbug(040000000L,catlist(3L,GC_PUSHS("[EMIT!LOC!CODE].2.3 s1=\'"),GC_PUSHS(s1),
        GC_PUSHS("\'"))));
		s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s1));
		}/* barf out local array variable ptrs */
	}/* barf out the ARRAY allocation code */

if (useleapflag &&((j= (*aChkI(blkipdlptr,1L,blocklevel)))<lociptr))
	{/* barf out the LEAP item allocation code */
	for (i=j+1L;i<=lociptr;i++)
		{/* barf out local LEAP variable ptrs */
		xname= (*aChkC(locitemname,1L,i));
GC_EPOPS(dbug(040000000L,catlist(5L,GC_PUSHS("[EMIT!LOC!CODE].3 locItemName["),cvs(i),
        GC_PUSHS("]=\'"),GC_PUSHS(xname),GC_PUSHS("\'"))));
		if (*xname=='?')
			{/* Dynamic LEAP ITEM declaration */
			ch= LOP(xname);	  /*  -- Trash '?' marker */
			s2= xname;
			s1= GC_EPOPS(scan(&s2,2L,&brk));     /*  -- to ',' get array id */
			s= catlist(9L,GC_PUSHS(s),GC_PUSHS("if ("),GC_PUSHS(s1),
        GC_PUSHS("<0) mkItem(&"),GC_PUSHS(xname),GC_PUSHS(");"),
        GC_PUSHS(tab),GC_PUSHS("/* LEAP ITEM initialization */"),
        GC_PUSHS(wspreface));
			}/* Dynamic LEAP ITEM declaration */
		}/* barf out local LEAP variable ptrs */
	}/* barf out the LEAP item allocation code */

if (useprfileflag &&(blocklevel<=2)) s= 
        		catlist(GC_PUSHS(s),GC_PUSHS("PROFIL_ON("),GC_PUSHS(quote)
        ,cvupcase(GC_PUSHS(lastprocedure)),GC_PUSHS(quote),
        GC_PUSHS(");	/* enable profiling */"),GC_PUSHS(wspreface));
ch= LOP(s);				/*  -- Trash '@' prefix */

if (ismacroflag &&(*s!='\0')) 
	{/* forget it - do it later... */
	isfragmentflag= 1L;
	s= PNULL;
	}/* forget it - do it later... */
GC_EPOPS(dbug(040000000L,catlist(13L,GC_PUSHS("[EMIT!LOC!CODE].4 locAptr="),cvs(locaptr),
        GC_PUSHS(" locIptr="),cvs(lociptr),GC_PUSHS(" locSptr="),
        cvs(locsptr),GC_PUSHS(crlf),GC_PUSHS(" s=\'"),GC_PUSHS(s),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" isFRAGMENTflag="),
        pbool(isfragmentflag))));
;
GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'k'=<L0> integer                              */
/*************************************************/
}/* EMIT!LOC!CODE */
