/* FILE: emit_main_code.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987
     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psgc.c, being converted 12/25/87, 04:48:55PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ---------------------------------------------------- */
/*INTERNAL*/  STRING emit_main_code()
/*  ---------------------------------------------------- */
{/* EMIT!MAIN!CODE */
/*  --
.LABEL [<++PSAIL PROCEDURE: EMIT!MAIN!CODE>]
.INDEX ++PSAIL PROCEDURE: EMIT!MAIN!CODE
DESCRIPTION:
	Output the main() code. Also output any remaining STRING or
ARRAY stuff.
	If /PROFILE is set then read in "PROFIL.COD".
	If /GCCODE is set then define 
		#define GC_STKFSTRMAX
		#define GC_STRPDLMAX
		#define GC_ACTIVESIZEMAX
	and then read in "GCCODE.COD".
	Then read in "MAIN.COD".
	If /GCCODE then emit 'gc_init()' to initialize the GC.
	If /PROFILE then emit 'PROFILE_START' to initialize profiling.
	If /LEAP then "LEAP.COD".
	If ever did any allocation then do EMIT!LOC!CODE to set up
	global arrays, strings, etc.
	If /VERSION or REQUIRE-VERSION then emit 'chkversion(...)'.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: EMIT!MAIN!CODE>]
 */
STRING s, 
	s1, 
	s2, 
	xname, 
	dsize;
INTEGER i,
	j, 
	ch;

;

GC_EPOPS(dbug(040000000L,catlist(17L,GC_PUSHS("[EMIT!MAIN!CODE] blockLevel="),cvs(blocklevel),
        GC_PUSHS(crlf),GC_PUSHS(" blkSPDLptr[blockLevel]="),
        cvs((*aChkI(blkspdlptr,1L,blocklevel))),
        GC_PUSHS(" locSptr="),cvs(locsptr),GC_PUSHS(crlf),
        GC_PUSHS(" blkAPDLptr[blockLevel]="),cvs((*aChkI(blkapdlptr,
        1L,blocklevel))),GC_PUSHS(" locAptr="),cvs(locaptr),
        GC_PUSHS(crlf),GC_PUSHS(" blkIPDLptr[blockLevel]="),
        cvs((*aChkI(blkipdlptr,1L,blocklevel))),
        GC_PUSHS(" locIptr="),cvs(lociptr))));
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(xname); /* for G.C. */
GC_NOTESTRING(dsize); /* for G.C. */
didmainemit= 1L;	/*  -- So never do it again! */
firstmainxct= 1L;	/*  -- So never do it again! */
s= crlf;
i= 0;

if (useprfileflag)
	{/* barf out the PROFILE code */
	s= catlist(2L,GC_PUSHS(s),readfile(GC_PUSHS("PROFIL.COD")));
	}/* barf out the PROFILE code */


if (usegcflag)
	{/* barf out the GC code */
	maxstkfstr= ssffactor*(MAX(1L,nprocedures))*maxgcactivesize;
	s1= catlist(9L,GC_PUSHS("#define GC_STKFSTRMAX "),cvs(maxstkfstr),
        GC_PUSHS(crlf),GC_PUSHS("#define GC_STRPDLMAX "),
        cvs(maxstrpdl),GC_PUSHS(crlf),
        GC_PUSHS("#define GC_ACTIVESIZEMAX "),cvs(maxgcactivesize),
        GC_PUSHS(crlf));
	s2= GC_EPOPS(readfile(GC_PUSHS("GCCODE.COD")));
	do {s= catlist(3L,GC_PUSHS(s),scan(&s2,1L,&ch),GC_PUSHS(crlf));} while (!(*s2=='I'||*s2=='\0'));   /*  -- look for 'INTEGER' column 1, eg.
				      'INTEGER gc_sizes[10] = { ...'
				  */
	s= catlist(3L,GC_PUSHS(s),GC_PUSHS(s1),GC_PUSHS(s2));	/*  -- insert MACROs BEFORE array declarations!! */
	}/* barf out the GC code */


s= catlist(2L,GC_PUSHS(s),readfile(GC_PUSHS("MAIN.COD")));

if (usegcflag) s= catlist(6L,GC_PUSHS(s),GC_PUSHS(crlf),GC_PUSHS("gc_init()"),
        GC_PUSHS(semicolon),GC_PUSHS("	/* INITIALIZE G.C. */"),
        GC_PUSHS(crlf));

if (useprfileflag) s= 
           catlist(GC_PUSHS(s),
        GC_PUSHS("PROFIL_START;	/* Enable PROFILE statistics gathering */")
        ,GC_PUSHS(crlf));

if (useleapflag)
	{/* barf out the Leap code */
	s= catlist(2L,GC_PUSHS(s),readfile(GC_PUSHS("LEAPRN.COD")));
	}/* barf out the Leap code */
if (!didlocemit &&
   ((usegcflag &&locsptr>0) ||(usechkflag &&locaptr>0) ||
    (useleapflag &&lociptr>0)))
	{/* OK emit string or array stuff */
GC_EPOPS(dbug(040000000L,catlist(3L,GC_PUSHS("[EMIT!MAIN!CODE].1 s=\'"),GC_PUSHS(s),
        GC_PUSHS("\'"))));
	s= catlist(2L,GC_PUSHS(s),emit_loc_code());
	}/* OK emit string or array stuff */

if (sawversionflag) 
	{/* do version number */
	vlist= GC_EPOPS(cvlower(GC_PUSHS(vlist)));
	s1= catlist(3L,GC_PUSHS("chkversion("),GC_PUSHS(vlist),
        GC_PUSHS("); /* VERSION number runtime CHECK */"));
	s1= GC_EPOPS(justify_text(GC_PUSHS(tab),GC_PUSHS(PNULL),GC_PUSHS(s1)));
s2= 
        	catlist(GC_PUSHS(
        "/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */")
        ,GC_PUSHS(crlf));
	s= catlist(5L,GC_PUSHS(s),GC_PUSHS(s2),GC_PUSHS(s1),GC_PUSHS(crlf),
        GC_PUSHS(s2));
	}/* do version number */

GC_EPOPS(dbug(040000000L,catlist(3L,GC_PUSHS("[EMIT!MAIN!CODE].2 s=\'"),GC_PUSHS(s),
        GC_PUSHS("\'"))));

;
GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'j'=<L0> integer                              */
/* 'dsize'=<L0> string                           */
/* 'xname'=<L0> string                           */
/*************************************************/

}/* EMIT!MAIN!CODE */
