/* FILE: err_deathwish.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psdbug.c, being converted 12/25/87, 01:13:54PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*   --------------------------------------- */
/*INTERNAL*/  void err_deathwish(si,msg,dwishindex,n_p_flag)
	STRING *si;
	STRING msg;
	INTEGER dwishindex;
	INTEGER n_p_flag;
/*   --------------------------------------- */
{/* ERR!DEATHWISH */
/*  --
.LABEL [<++PSAIL PROCEDURE: ERR!DEATHWISH>]
.INDEX ++PSAIL PROCEDURE: ERR!DEATHWISH
DESCRIPTION:
	NOTE: Count errors both as individual 'death wishes' and as
WARNINGS.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: ERR!DEATHWISH>]
 */

INTEGER k, 
	m, 
	brk, 
	usetg;
STRING s, 
	s1, 
	s2, 
	s3;

GC_EPOPS(dbug(040000000L,catlist(12L,GC_PUSHS("[ERR!DEATHWISH] sI=\'"),
				 GC_PUSHS(*si),
				 GC_PUSHS("\'"),GC_PUSHS(crlf),
				 GC_PUSHS("  msg=\'"),
				 GC_PUSHS(msg),GC_PUSHS("\'"),
				 GC_PUSHS(crlf),
				 GC_PUSHS("  dWishIndex="),cvs(dwishindex),
				 GC_PUSHS(" n!p!flag="),cvs(n_p_flag))));
/* NO-OP */;
GC_POPS(msg); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(si); /* for G.C. */
GC_NOTESTRING(msg); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(s3); /* for G.C. */

if (slobflag)
  GC_RETURN
if (*msg=='\0'||!(1<=dwishindex && dwishindex<=35L))
	usererr(0L,0L,
		catlist(12L,GC_PUSHS("[ERR!DEATHWISH] DRYROT - sI=\'"),
			GC_PUSHS(*si),
			GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" msg=\'"),
			GC_PUSHS(msg),GC_PUSHS("\'"),GC_PUSHS(crlf),
			GC_PUSHS(" dWishIndex="),cvs(dwishindex),
			GC_PUSHS(" n!p!flag="),cvs(n_p_flag))); 
else {/* INCSTAT */
      if (usereportflag)
	++(*aChkI(errstatistics,1L,dwishindex));
     }/* INCSTAT */

k= 0;
s3= msg;

/*  -- first find max length k */
while ((*s3!='\0'))
	{/* find max length of msg lines */
	s2= GC_EPOPS(scan(&s3,1L,&brk));	/*  -- up to CRLF */
	k=MAX(k,length(GC_PUSHS(s2)));
	}/* find max length of msg lines */
/*  # # DBUG('40000000,"[ERR!DEATHWISH].1 max lth(msg)== k ="&CVS(k)) */

/*  -- now insert the  and  stuff */
s= "@";
s3= msg;
while ((*s3!='\0'))
	{/* build equ-length msg lines */
	s2= GC_EPOPS(scan(&s3,1L,&brk));	/*  -- up to CRLF */
	m= length(GC_PUSHS(s2));
	if (m==0) continue;
	if (m>=k)
	  s1= s2; 
	else s1= catlist(2L,GC_PUSHS(s2),
			 subsr(GC_PUSHS(ps_spaces),1L,(k-m))); 
	                                         /*  -- extend it */
	s1= catlist(4L,GC_PUSHS("/* "),GC_PUSHS(s1),GC_PUSHS(" */"),
		    GC_PUSHS(crlf));
	s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s1));
	}/* build equ-length msg lines */
/*  # # DBUG('40000000,"[ERR!DEATHWISH].1.1 s='"&s&"'") */

if (!((INTEGER)*s==(INTEGER)'@')) 
	{/* add the stars */
	brk= LOP(s);		/*  -- trash the '@'  */
	s= catlist(8L,GC_PUSHS("@/**"),subsr(GC_PUSHS(stars),1L,k),
        GC_PUSHS("**/"),GC_PUSHS(crlf),GC_PUSHS(s),GC_PUSHS("/**"),
        subsr(GC_PUSHS(stars),1L,k),GC_PUSHS("**/"));
	}/* add the stars */
/*  # # DBUG('40000000,"[ERR!DEATHWISH].2 s='"&s&"'") */

{/* INCSTAT */
if (usereportflag)
  (*aChkI(errstatistics,1L,30L))++;
}/* INCSTAT */		/*  -- use for total WARNINGS! */
/*  # # DBUG('40000000,"[ERR!DEATHWISH].3 after N.P. s='"&s&"'") */

if (n_p_flag!=0) err_n_p(&s);

usetg= (warnlevel&(LSH(1L,(dwishindex-1L))));    /*  -- see if OK */
/*  # # DBUG('40000000,"[ERR!DEATHWISH].4 useTG=0"&CVOS(useTG)&CRLF&
    "  warnLevel=0"&CVOS(warnLevel)&" dWishIndex="&CVS(dWishIndex)&CRLF&
    " deathWish[dWishIndex]='"&deathWish[dWishIndex]&"'")
*/
if (usetg)
  s= catlist(2L,GC_PUSHS(s),GC_PUSHS(*aChkC(deathwish,1L,dwishindex)));
else s= catlist(2L,GC_PUSHS(s),GC_PUSHS(crlf));

brk= LOP(s);			/*  -- Trash the '@' */
/*  # # DBUG('40000000,"[ERR!DEATHWISH].5 s='"&s&"'") */

if (*(*si)=='\0') *si= s; 
	else *si= catlist(2L,GC_PUSHS(*si),GC_PUSHS(s));	  	/*  -- pass this mess back */
/*  # # DBUG('40000000,"[ERR!DEATHWISH].6 sI='"&sI&"'") */
{GC_UNMARKSSTKFRAME;}
}/* ERR!DEATHWISH */
