/* FILE: err_hlr.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psdbug.c, being converted 12/25/87, 01:13:54PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------ */
/*INTERNAL*/  void err_hlr(msg)
	STRING msg;
/*  ------------------------------------------------ */
{/* ERR!HLR */
/*  --
.LABEL [<++PSAIL PROCEDURE: ERR!HLR>]
.INDEX ++PSAIL PROCEDURE: ERR!HLR
DESCRIPTION:
	Report fatal error and give user control to decide whether to
continue or not. Note that the LEFT-PART of the errLine is
forced to lower-case and the RIGHT-PART to UPPER CASE. If we are
doing a Macro declaration then an error is used to define a FRAGMENT
so we do NOT print the message but rather set the 'isFragmentFlag'.

NOTE: We can remove the name of the procedure calling ERR!HLR since
by convention it is always indicated in the front of the message by
'[name]'. The PSPARAM.REQ macro RMVERRSQBRKTS is set true if we do
NOT want this name.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: ERR!HLR>]
 */

STRING s, 
	s0, 
	s1, 
	s2, 
	s3, 
	s4, 
	errstr, 
	fsmlist;
INTEGER i, 
	k, 
	ch, 
	errnbr;



/*  # # @V.52.45 errStr_lastStatement */  /*  problem is too GLOBAL... */
GC_POPS(msg); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(msg); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s0); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(s3); /* for G.C. */
GC_NOTESTRING(s4); /* for G.C. */
GC_NOTESTRING(errstr); /* for G.C. */
GC_NOTESTRING(fsmlist); /* for G.C. */

if (usebacktraceflag)
  errstr= (*aChkC(errline,1L,rdlevel)); 
else errstr= laststatement;	/*  -- should be local enough but for
				some reason (i.e. a BUG) it is not 
				what we want... needs work */

if (ismacroflag)
  {/* found fragment!!! */
   isfragmentflag= 1L;
   GC_EPOPS(dbug(040000000L,catlist(9L,GC_PUSHS("[ERR!HLR] fragment!"),
				    GC_PUSHS(crlf),
				    GC_PUSHS(" msg="),GC_PUSHS(msg),
				    GC_PUSHS(crlf),
				    GC_PUSHS(" saiStatement="),
				    GC_PUSHS(saistatement),
				    GC_PUSHS(" cStatement="),
				    GC_PUSHS(cstatement))));
   {GC_UNMARKSSTKFRAME;
    GC_RETURN;
   }
}/* found fragment!!! */

if (0L)
   {/* remove '[name]' from front of msg */
    s1= msg;			/*  -- save it in case fail */
    s= GC_EPOPS(scan(&msg,14L,&ch));   /*  -- scan up to and including ']' */
    if (ch!=']')
      msg= s1;	/*  -- Sorry, failed. Restore it */
   }/* remove '[name]' from front of msg */
errnbr= (*aChkI(errstatistics,1L,0L))++ ; /*  for /REPORT */

setformat(0L,0L);
s0= catlist(15L,GC_PUSHS(crlf),GC_PUSHS(crlf),
        GC_PUSHS("####### E R R O R {"),cvs(errnbr),
        GC_PUSHS("} #######"),GC_PUSHS(crlf),GC_PUSHS(msg),
        GC_PUSHS(crlf),GC_PUSHS("In ["),GC_PUSHS(*aChkC(reqfile,1L,
        reqlevel)),GC_PUSHS("] Line/Page: "),cvs(linecount),
        GC_PUSHS("/"),cvs(pagecount),GC_PUSHS(crlf));
if (errnbr<20L)
  (*aChkC(croaklist,1L,errnbr))= s0;	/*  -- save the CROAK! */

s1= s2= s3= PNULL;
k= length(GC_PUSHS(errstr))-MAX(length(GC_PUSHS(saistatement)),0L);
if (k>0)
    {/* cvt to lower */
    for (i=1;i<=k;i++)
	if (('A'<=(ch= LOP(errstr)) && ch<='Z'))
	  s1= catlist(2L,GC_PUSHS(s1),makstr(ch-0242L));
	else s1= catlist(2L,GC_PUSHS(s1),makstr(ch));
	}/* cvt to lower */

while (*errstr!='\0')
  if (('a'<=(ch= LOP(errstr)) && ch<='z'))
    s2= catlist(2L,GC_PUSHS(s2),makstr(ch-0242L))
      ; else s2= catlist(2L,GC_PUSHS(s2),makstr(ch));

s4= s1;				/*  -- Compute underline WS */
while ((*s4!='\0')) 
	s3= GC_EPOPS(scan(&s4,1L,&ch));  /*  -- get last line */
s3= catlist(3L,subst(GC_PUSHS(ps_spaces),1L,
		     (MAX((length(GC_PUSHS(s3))-8L),1L))),
	    GC_PUSHS("----^----"),GC_PUSHS(crlf));
if ((*(s1+length(s1)-1))!=*lf)
  s3= catlist(2L,GC_PUSHS(crlf),GC_PUSHS(s3));	
                              /*  -- force ----^---- on NEW LINE! */

if (usebacktraceflag) for (i=rdlevel;i<=0;i--)
  {/* add backtrace to the error message */
    if (*((errstr= (*aChkC(errline,1L,i))))=='@')
      ch= LOP(errstr);	/*  -- get error string and
			    -- trash '@' preface char */ 
    while ((*fsmlist!='\0') &&iswhitespace((INTEGER)*fsmlist))
      ps_itrash_= LOP(fsmlist);
	if (*((fsmlist= (*aChkC(errfsm,1L,i))))=='@')
	  ch= LOP(fsmlist);	/*  -- get current FSM trace,
				    -- trash '@' preface char */ 
/*  # # DBUG('40000000,"[ERR!HLR].1 fsmList='"&fsmList&"'") */
    fsmlist= catlist(14L,GC_PUSHS(crlf),
	     GC_PUSHS("/* BACKTRACE-PSAIL FSM\'s called at R!D level["),
		     cvs(i),GC_PUSHS("]:"),GC_PUSHS(fsmlist),
		     GC_PUSHS(" */"),
		     GC_PUSHS(crlf),
		     GC_PUSHS("/* BACKTRACE-PSAIL source-code R!D level["),
		     cvs(i),GC_PUSHS("]:"),GC_PUSHS(crlf),
		     GC_PUSHS(tab),GC_PUSHS(errstr),GC_PUSHS(" */"));
/*  # # DBUG('40000000,"[ERR!HLR].1.1 fsmList='"&fsmList&"'") */
	fsmlist= GC_EPOPS(justify_text(GC_PUSHS(PNULL),GC_PUSHS(PNULL),
				       GC_PUSHS(fsmlist)));
/*  # # DBUG('40000000,"[ERR!HLR].1.2 fsmList["&CVS(i)&"]='"&fsmList&"'") */
	s3= catlist(3L,GC_PUSHS(s3),GC_PUSHS(crlf),GC_PUSHS(fsmlist));
	}/* add backtrace to the error message */
s= catlist(10L,GC_PUSHS(s0),GC_PUSHS(s1),GC_PUSHS(s2),GC_PUSHS(s3),
        GC_PUSHS(crlf),GC_PUSHS("/* @@@@@@@@@@  END  OF  ERROR {"),
        cvs(errnbr),GC_PUSHS("} @@@@@@@@@@@*/"),GC_PUSHS(crlf),
        GC_PUSHS(crlf));		/*  -- So on separate line! */

if (!nuldevflag)
  out(cchan,GC_PUSHS(s));
PSprintf("%s",GC_PUSHS(s));
PSprintf("%s",GC_PUSHS("Continue (Yes/No/All)?"));
if (yeserrorflag)
  PSprintf("%s%s",GC_PUSHS((s= "ALL")),GC_PUSHS(crlf)); 
else s= GC_EPOPS(inchwl());
if ((*s=='A'||*s=='a'))
  yeserrorflag= 1L;    	/*  -- set it on forever more... */
if ((*s=='Y'||*s=='y') ||(*s=='A'||*s=='a'))
  { {GC_UNMARKSSTKFRAME;
     GC_RETURN;
    }
  }else {/* done */
	  PSclose(1L,cchan);	/*Close out the channel*/
	  PSprintf("%s%s%c%s",GC_PUSHS("...Forget it... Closing file["),
		   GC_PUSHS(cfile),']',GC_PUSHS(crlf));
	  callsys(0L,GC_PUSHS("EXIT"));
	}/* done */

{GC_UNMARKSSTKFRAME;}
}/* ERR!HLR */
