/* FILE: err_report.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psdbug.c, being converted 12/25/87, 01:13:54PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------ */
/*INTERNAL*/ void err_report()
/*  ------------------------------------------------ */
{/* ERR!REPORT */
/*  --
.LABEL [<++PSAIL PROCEDURE: ERR!REPORT>]
.INDEX ++PSAIL PROCEDURE: ERR!REPORT
DESCRIPTION:
	Report error statistics of compiler by creating a table
embedded in a C comment..

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: ERR!REPORT>]
 */

extern  INTEGER /*ARRAY*/ *gogtab  /* [0:256] */ ;   /*  -- SAIL USER TABLE --- N.P. */
#define sgccnt 0112		/*  -- index to number times called */
#define sgctotal 0113		/*  -- index to total CPU time used if
				     SAIL compiler was built to track
				     it, our version 8 compiler was not */

STRING s;
INTEGER i, 
	j;

 STRING /*ARRAY*/ *msgs  /* [0:maxstatistics] */ ;

/* IFC EVAL(docntfsm)=1 */
/* THENC */

  STRING /*ARRAY*/ *fsmname  /* [-1:maxfsms] */ ;
   /* ENDC */

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTEASTRING(msgs);	/* for G.C. */
GC_NOTEASTRING(fsmname);	/* for G.C. */
msgs = arymkC(1L,0L,35L,"msgs",'c');	/* Dynamic Array */
fsmname = arymkC(1L,-1L,73L,"fsmname",'c');	/* Dynamic Array */

s= GC_EPOPS(readfile(GC_PUSHS("PSREPT.TXT")));	
                           /*  -- keep titles here to save space */
i= 0;
while ((*s!='\0')) 
  (*aChkC(msgs,1L,(++i)-1L))= GC_EPOPS(scan(&s,1L,&j));
                        		/*  -- one/line */

/* IFC EVAL(docntfsm)=1 */
/* THENC */

s= GC_EPOPS(readfile(GC_PUSHS("PSFSMN.TXT")));	
                        /*  -- keep titles here to save space */
i= -1;
while ((*s!='\0')) 
  (*aChkC(fsmname,1L,(++i)-1L))= GC_EPOPS(scan(&s,1L,&j)); 
                          		/*  -- one/line */
   /* ENDC */

/*  -- Compute some DECsystem-10 SAIL compiler statistics while porting
PSAIL -- N.P. !!! */
(*aChkI(errstatistics,1L,11L))= (*aChkI(gogtab,1L,0112L));	/*  -- number of times GC called */
(*aChkI(errstatistics,1L,12L))= 100.0*(*aChkI(gogtab,1L,0113L))/
                                (timstoprun-timstartrun);
				/*  -- Percent of time GC called */
(*aChkI(errstatistics,1L,22L))= maxsymbols -(*aChkI(errstatistics,1L,21L));
			 /*  -- what would be left in worst case */
s= catlist(5L,GC_PUSHS("/* "),GC_PUSHS(minuses),
        GC_PUSHS("\15\12\
*	P S A I L     C O M P I L E R     S T A T I S T I C S\15\12\
* "
        /*N.P.*/),GC_PUSHS(minuses),GC_PUSHS(crlf));
out_both(GC_PUSHS(s));

setformat(6L,0L);
for (i=0;i<=35L;i++)
  if (*((*aChkC(msgs,1L,i)))!='\0')
	{/* barf out statistics... */
	s= catlist(5L,GC_PUSHS("*	# "),
		   cvs((*aChkI(errstatistics,1L,i))),
		   GC_PUSHS("  "),GC_PUSHS(*aChkC(msgs,1L,i)),
		   GC_PUSHS(crlf));
	out_both(GC_PUSHS(s));
	}/* barf out statistics... */

/* IFC EVAL(docntfsm)=1 */
/* THENC */

  if (usecntfsmflag)
	{/* add FSM counts */
	s= catlist(6L,GC_PUSHS(crlf),GC_PUSHS("/* "),GC_PUSHS(minuses),
		   GC_PUSHS("\15\12\
*	N U M B E R    T I M E S    F S M S \'    C A L L E D\15\12\
* "
        /*N.P.*/),GC_PUSHS(minuses),GC_PUSHS(crlf));
	out_both(GC_PUSHS(s));

	setformat(6L,0L);
	/*  -- NOTE: start from -1 because FSM4a is at -1 --- CLUDGE! */
	for (i=-1;i<=73L;i++)
	  if (*((*aChkC(fsmname,1L,i)))!='\0')
	    {/* barf out FSM call statistics... */
	      s= catlist(5L,GC_PUSHS("*	# "),
			 cvs((*aChkI(cntfsms,1L,i))),GC_PUSHS("  "),
			 GC_PUSHS(*aChkC(fsmname,1L,i)),GC_PUSHS(crlf));
	      out_both(GC_PUSHS(s));
	    }/* barf out FSM call statistics... */
      }/* add FSM counts */
   /* ENDC */

s= catlist(2L,GC_PUSHS("*/"),GC_PUSHS(crlf));
out_both(GC_PUSHS(s));
if (((j= (MIN((*aChkI(errstatistics,1L,0L)),20L)))>0))
  for (i=1;i<=j;i++)
    out_both(GC_PUSHS((*aChkC(croaklist,1L,i)))); /*print the CROAK-LIST*/
setformat(0L,0L);			/*  -- restore it */

#undef sgctotal
#undef sgccnt
{aryfree(gogtab,(INTEGER *)msgs,(INTEGER *)fsmname,
        (INTEGER *)0);  /* Free List of Dynamic Arrays */
GC_UNMARKSSTKFRAME;}
}/* ERR!REPORT */
