/* FILE: err_undf.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psdbug.c, being converted 12/25/87, 01:13:54PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*   --------------------------------------- */
/*INTERNAL*/  void err_undf(s,id)
	STRING *s;
	STRING id;
/*   --------------------------------------- */
{/* ERR!UNDF */
/*  --
.LABEL [<++PSAIL PROCEDURE: ERR!UNDF>]
.INDEX ++PSAIL PROCEDURE: ERR!UNDF
DESCRIPTION:
	NOTE: Count undefined symbol errors WARNINGS and add the UNDF
comment after the string.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: ERR!UNDF>]
 */
GC_POPS(id); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(id); /* for G.C. */
if (*ps__undf_=='\0') 
  {/* fatal error */
    err_hlr(catlist(3L,GC_PUSHS("[ERR!UNDF] Undefined symbol \'"),
		    GC_PUSHS(id),GC_PUSHS("\'")));
    {GC_UNMARKSSTKFRAME;
     GC_RETURN;
    }
  }/* fatal error */

*s= ((*(*s)=='\0') ? ps__undf_
                   : *catlist(2L,GC_PUSHS(s),GC_PUSHS(ps__undf_)));
{/* INCSTAT */
    if (usereportflag)
      (*aChkI(errstatistics,1L,29L))= (*aChkI(errstatistics,1L,29L))+1L;
}/* INCSTAT */			/*  -- for /REPORT */
{GC_UNMARKSSTKFRAME;}
}/* ERR!UNDF */
