/* FILE: expand_macro.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pslex.c, being converted 12/25/87, 08:38:10PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING expand_macro(,idx)
	STRING instr;
	INTEGER idx;
/*  ------------------------------------------------------- */
{/* EXPAND!MACRO */
/*   --
.LABEL [<++PSAIL PROCEDURE: EXPAND!MACRO>]
.INDEX ++PSAIL PROCEDURE: EXPAND!MACRO
DESCRIPTION:
	Expand the macro (idx in symbol table) by analyzing 'inStr'
for arguments. Then prefix the expanded macro-body to inStr. The
composed string is returned.

NOTE: PSAIL!EVAL macros with args are stored both with C code in 
	declSize[idx] if not a FRAGMENT and un-CVEVALed SAIL code
	in declSize[idx] with the actual arg names (eg. (p,d,q)
	mapped to ` prefixed letters eg (`a,`b,`c). Note: ` is not a
	character in C. I.e. the SAIL macro body is stored with the
	(p,d,q) mapped to the `a,`b,`c wherever they appear. The ` is
	coded as ``.
	This is done in the DEFINE FSM1 procedure. This routine then
	must:
	1) check whether the macro name which caused it to be invoked
	   is followed by arguments and if so, then build a list of 
	   the actual arguments.
	2) Then Scan the macro body for `j using the j as an index
	   of the actual arg table to replace the `j.
	3) The declNargs[idx] value contains the actual number of 
	   arguments and is set up by FSM1.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: EXPAND!MACRO>]
 */
STRING s, 
	s1, 
	s2, 
	s3, 
	macrobody, 
	arglist, 
	brkstr, 
	copymacrobody,
	copyinstr;
STRING /*ARRAY*/ *actualarg  /* [1:maxmacroargs] */ ;
INTEGER ch, 
	i, 
	j, 
	nactualarg, 
	nexpectedarg, 
	dw, 
	parencnt, 
	brktcnt;

;

GC_EPOPS(dbug(01000L,catlist(10L,GC_PUSHS("[EXPAND!MACRO] saiSym["),GC_PUSHS(*aChkC(saisym,
        1L,(*aChkI(declhash,1L,idx)))),GC_PUSHS("] idx="),cvs(idx),
        GC_PUSHS(" isCVEVALflag="),pbool(iscvevalflag),
        GC_PUSHS(crlf),GC_PUSHS("  inStr=\'"),GC_PUSHS(instr),
        GC_PUSHS("\'"))));
/* NO-OP */;
/*  # # DBUG('1000,"[EXPAND!MACRO].0.1 NODE["&saiSym[declHash[idx]]&"]="&PRT!NODE(declHash[idx])) */
GC_POPS(instr); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(instr); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(s3); /* for G.C. */
GC_NOTESTRING(macrobody); /* for G.C. */
GC_NOTESTRING(arglist); /* for G.C. */
GC_NOTESTRING(brkstr); /* for G.C. */
GC_NOTESTRING(copymacrobody); /* for G.C. */
GC_NOTESTRING(copyinstr); /* for G.C. */
GC_NOTEASTRING(actualarg);	/* for G.C. */
actualarg = arymkC(1L,1L,20L,"actualarg",'c');	/* Dynamic Array */
if (idx==0) 
	{/* NULL BODY! */
	macrobody= PNULL;
	}/* NULL BODY! */
else	{/* get macro body */
	if (((dw= (*aChkI(decldw,1L,idx)))&02000L)==0) err_hlr(GC_PUSHS(
        			catlist(GC_PUSHS("[EXPAND!MACRO] DRYROT - \'"),
        GC_PUSHS(*aChkC(saisym,1L,(*aChkI(declhash,1L,idx)))),
        GC_PUSHS("\' is not a macro symbol,"),GC_PUSHS(crlf),
        GC_PUSHS(" Its declaration=\'"),cvtypes(dw),GC_PUSHS("\'"))));
	macrobody= ((iscvevalflag ||(dw&01000L)==0) ? 
			(*aChkC(declsize,1L,idx))
			: (*aChkC(declcsym,1L,idx)));
	}/* get macro body */
copymacrobody= macrobody;		/*  -- in case ERR!HLR */
copyinstr= instr;			/*  -- in case ERR!HLR */
nexpectedarg= (*aChkI(declnargs,1L,idx));
/*  # # DBUG('1000,"[EXPAND!MACRO].1 macroBody='"&macroBody&"'"&CRLF&"  declSize[idx]='"&declSize[idx]&"'"&CRLF&"  declCsym[idx]='"&declCsym[idx]&"'"&CRLF&"  nExpectedArg="&CVS(nExpectedArg)&" declDW[idx]='"&CVTYPES(declDW[idx])) */

/*  ---------------------------------------- */
/*  . . . BUILD 'ACTUAL ARGUMENT LIST . . .  */
/*  ---------------------------------------- */
if (nexpectedarg>0&&*instr=='(')
	{/* problem, we must do Argument replacement! */
	pushnumber(midofexpr); midofexpr= 1L;
	push(GC_PUSHS(macrobody)); pushnumber(nexpectedarg);
	ch= LOP(instr);			/*  -- ignore initial '('  */
	push(GC_PUSHS(saistatement));
	saistatement= instr;		/*  -- prep args */

	nactualarg= 0;
	arglist= PNULL;
	b32= "&(),[]";			/*  -- initial break table */
	if (*sailargdelim!=*quote) b32= catlist(3L,GC_PUSHS(b32),GC_PUSHS("&(),[]"),GC_PUSHS(sailargdelim));
	if (*sailargdelim==*sairargdelim) b32= catlist(2L,GC_PUSHS(b32),GC_PUSHS(sairargdelim));   /*  -- need both */
	setbreak(32L,GC_PUSHS(b32),GC_PUSHS(PNULL),GC_PUSHS("INS"));
	do 	{/* build actual Arg list */
		if (nactualarg==20L)
			{/* error */
			s1= catlist(4L,GC_PUSHS(" Actual arglist=\'"),GC_PUSHS(copyinstr),
        GC_PUSHS("\'"),GC_PUSHS(crlf));
			for (i=1;i<=20L;i++)
				s1= catlist(7L,GC_PUSHS(s1),GC_PUSHS(crlf),GC_PUSHS(" Parsed Arg["),cvs(i)
        ,GC_PUSHS("]=\'"),GC_PUSHS(*aChkC(actualarg,1L,i)),
        GC_PUSHS("\'"));
    err_hlr(catlist(5L,
        GC_PUSHS("[EXPAND!MACRO] >20 actual args in PSAIL!EVAL of macro [")
        ,GC_PUSHS(*aChkC(saisym,1L,(*aChkI(declhash,1L,idx)))),
        GC_PUSHS("]"),GC_PUSHS(crlf),GC_PUSHS(s)));
			}/* error */
	 	else ++nactualarg;
		brktcnt= 0;		/*  -- brkt counter WITHIN ARG */
		parencnt= 0;		/*  -- paren counter WITHIN ARG */
		s2= "@";			/*  -- set preface character  */
		do  {/* build this arg */
		   while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
		   if (*saistatement==*quote)
			{/* get quoted arg */
			pushnumber(iscopy_toflag); iscopy_toflag= 1L;
			ch= LOP(saistatement);  /*  -- trash first quote */
			s2= catlist(2L,GC_PUSHS(s2),map_quotes(&saistatement));
			popnumber(&iscopy_toflag);
			while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
			ch= LOP(saistatement);  /*  -- get pseudo brk chr */
			s3= PNULL;
/*  # # DBUG('1000,"[EXPAND!MACRO].1.1 SCAN-IT ch='"&(ps!sTrash!_ch)&"' |s2|="&CVS(LENGTH(s2))&" s2='"&s2&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
			}/* get quoted arg */
		   else	{/* scan it */
/*  # # DBUG('1000,"[EXPAND!MACRO].1.2 SCAN-IT saiStatement='"&saiStatement&"'") */
			s3= GC_EPOPS(scan(&saistatement,32L,&ch));
/*  # # DBUG('1000,"[EXPAND!MACRO].1.2.1 SCAN-IT ch='"&(ps!sTrash!_ch)&"' |s3|="&CVS(LENGTH(s3))&" s3='"&s3&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
			if (ch==*sailargdelim)
				{/* get delimited arg part */
				if (*s3!='\0') s2= catlist(2L,GC_PUSHS(s2),GC_PUSHS(s3));
/*  # # DBUG('1000,"[EXPAND!MACRO].1.3 SCAN-DELIM |s2|="&CVS(length(s2))&" s2='"&s2&"'") */
				if (*b33!=*sairargdelim) 
					setbreak(33L,GC_PUSHS(b33= sairargdelim),
							GC_PUSHS(PNULL),GC_PUSHS("INS"));
				s3= GC_EPOPS(scan(&saistatement,33L,&ch));
/*  # # DBUG('1000,"[EXPAND!MACRO].1.3.1 SCAN-DELIM ch='"&(ps!sTrash!_ch)&"' |s3|="&CVS(length(s3))&" s3='"&s3&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
				while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
				ch= LOP(saistatement); 
						/*  -- pseudo brkchr */
/*  # # DBUG('1000,"[EXPAND!MACRO].1.4 SCAN-DELIM ch='"&(ps!sTrash!_ch)&"' |s3|="&CVS(length(s3))&" s3='"&s3&"'"&CRLF&" |s2|="&CVS(length(s2))&" s2='"&s2&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
				}/* get delimited arg part */
			}/* scan it */
/*  # # DBUG('1000,"[EXPAND!MACRO].1.5  parenCnt="&CVS(parenCnt)&" brktCnt="&CVS(brktCnt)&" ch='"&(ps!sTrash!_ch)&"'"&CRLF&"  |s3|="&CVS(length(s3))&" s3='"&s3&"'"&CRLF&" |s2|="&CVS(length(s2))&" s2='"&s2&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
		    if (ch=='(') ++parencnt; else if (ch==')') --parencnt; else if (ch=='[') ++brktcnt; else if (ch==']') --brktcnt;
		    if (*s3!='\0') s2= catlist(2L,GC_PUSHS(s2),GC_PUSHS(s3));
		    if ((ch!='\0') &&
		       ((ch!=',') ||
		        (ch==','&&(parencnt>0||brktcnt>0))
		       ) &&(parencnt>=0)) s2= catlist(2L,GC_PUSHS(s2),makstr(ch));
/*  # # DBUG('1000,"[EXPAND!MACRO].1.6  parenCnt="&CVS(parenCnt)&" brktCnt="&CVS(brktCnt)&" ch='"&(ps!sTrash!_ch)&"'"&CRLF&"  |s3|="&CVS(length(s3))&" s3='"&s3&"'"&CRLF&" |s2|="&CVS(length(s2))&" s2='"&s2&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
		   }/* build this arg */
		 while (!((ch==','&&parencnt<=0 &&brktcnt<=0) ||
		      (ch==')'&&parencnt<=-1) ||
		      (*saistatement=='\0')));
/*  # # DBUG('1000,"[EXPAND!MACRO].1.7 parenCnt="&CVS(parenCnt)&" brktCnt="&CVS(brktCnt)&" ch='"&(ps!sTrash!_ch)&"'"&CRLF&" |s3|="&CVS(length(s3))&" s3='"&s3&"'"&CRLF&" |s2|="&CVS(length(s2))&" s2='"&s2&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
		j= LOP(s2);		/*  -- trash the '@' */
		s2= GC_EPOPS(remove_white_ends(GC_PUSHS(s2)));
		(*aChkC(actualarg,1L,nactualarg))= s2;
/* NO-OP */;
GC_EPOPS(dbug(01000L,catlist(13L,GC_PUSHS("[EXPAND!MACRO].2 actual Arg["),cvs(nactualarg),
        GC_PUSHS("]=\'"),GC_PUSHS(s2),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" ch=\'"),
        GC_PUSHS(ps_strash_= GC_EPOPS(makstr(ch))),GC_PUSHS(
        "\' parenCnt="),cvs(parencnt),GC_PUSHS(" saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"))));
		}/* build actual Arg list */
	 while (!((ch==','&&parencnt<=0 &&brktcnt<=0) ||
		      (ch==')'&&parencnt<=-1) ||
		      (*saistatement=='\0')));
	instr= saistatement;
	pop(&saistatement);		/*  -- Restore it */
	popnumber(&nexpectedarg); pop(&macrobody);
/*  # # DBUG('1000,"[EXPAND!MACRO].2.1 inStr='"&inStr&"'"&CRLF&"  saiStatement='"&saiStatement&"'") */

/*   ---------------------------------------------------------- */
/*  . . . TEST IF ACTUAL == EXPECTED NUMBER OF ARGUMENTS  . . . */
/*   ---------------------------------------------------------- */
if ((nactualarg!=nexpectedarg)) 
    err_hlr(catlist(13L,GC_PUSHS("[EXPAND!MACRO] for MACRO["),
        GC_PUSHS(*aChkC(saisym,1L,(*aChkI(declhash,1L,idx)))),
        GC_PUSHS("]"),GC_PUSHS(crlf),GC_PUSHS(" # actual args ["),
        cvs(nactualarg),GC_PUSHS("] NEQ # expected args ["),
        cvs(nexpectedarg),GC_PUSHS("]"),GC_PUSHS(crlf),
        GC_PUSHS(" Actual arglist=\'"),GC_PUSHS(copyinstr),
        GC_PUSHS("\'")));

/*  ------------------------------------------------------ */
/*  . . . MAP ACTUAL ARGUMENTS TO EXPECTED ARGUMENTS . . . */
/*  ------------------------------------------------------ */
	s1= macrobody;		/*  -- Add what's left to macro string */
	macrobody= PNULL;		/*  -- Start fresh! */
	while ((ch= LOP(s1))!='\0')
		{/* build mapped string */
		if (ch=='`')
			{/* map actual Arg */
			ch= LOP(s1);		/*  -- Get arg 'name' */
			j= (ch-(INTEGER)'a') +1L;		/*  -- Map to index */
			if (!(0<j && j<21L) &&
			   (ch!='`'))
				err_hlr(GC_PUSHS(
	catlist(15L,GC_PUSHS("[EXPAND!MACRO] DRYROT - in expanding \'"),
	        GC_PUSHS(*aChkC(saisym,1L,(*aChkI(declhash,1L,idx)))),
	        GC_PUSHS("\' j="),cvs(j),GC_PUSHS(" not in [1:"),
	        GC_PUSHS("20"),GC_PUSHS("] for macro body="),GC_PUSHS(crlf)
	        ,GC_PUSHS("\'"),GC_PUSHS(copymacrobody),GC_PUSHS("\'"),
	        GC_PUSHS(crlf),GC_PUSHS(" Actual arglist=\'"),
	        GC_PUSHS(copyinstr),GC_PUSHS("\'"))));
			macrobody= catlist(2L,GC_PUSHS(macrobody),GC_PUSHS((ch!='`') ? (*aChkC(actualarg,
        1L,j))
        						: ch));
/*  # # DBUG('1000,"[EXPAND!MACRO].3 use Actual-Arg j="&CVS(j)&" s1='"&s1&"'"&CRLF&" macroBody='"&macroBody&"'") */
			}/* map actual Arg */
			else macrobody= catlist(2L,GC_PUSHS(macrobody),makstr(ch));
/*  # # DBUG('1000,"[EXPAND!MACRO].4 s1='"&s1&"'"&CRLF&" macroBody='"&macroBody&"'") */
		}/* build mapped string */
	popnumber(&midofexpr);
	}/* problem, we must do Argument replacement! */

GC_EPOPS(dbug(01000L,catlist(11L,GC_PUSHS("[EXPAND!MACRO].4.1 macroBody=\'"),
        GC_PUSHS(macrobody),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" inStr=\'"),GC_PUSHS(instr),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"))));
if (*macrobody=='\0') s= instr; 
else s= catlist(2L,GC_PUSHS(macrobody),GC_PUSHS(instr));
GC_EPOPS(dbug(01000L,catlist(3L,GC_PUSHS("[EXPAND!MACRO].5 s=\'"),GC_PUSHS(s),GC_PUSHS("\'"))));

/* NO-OP */;
;
{aryfree((INTEGER *)actualarg,
        (INTEGER *)0);  /* Free List of Dynamic Arrays */
 GC_SRETURN(s);}
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'brkstr'=<L0> string                          */
/*************************************************/

}/* EXPAND!MACRO */
