/* FILE: find_rc_symbol.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pssymt.c, being converted 12/25/87, 02:03:55PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  INTEGER find_rc_symbol(s,hmem,hclass)
	STRING s;
	INTEGER *hmem;
	INTEGER hclass;
/*  ------------------------------------------------------- */
{/* FIND!RC!SYMBOL */
/*  --
.LABEL [<++PSAIL PROCEDURE: FIND!RC!SYMBOL>]
.INDEX ++PSAIL PROCEDURE: FIND!RC!SYMBOL
DESCRIPTION:
	Search the symbol table backwards for a symbol with hash hMem
and which is a member in hash hClass saved in declRclass[]. If not
found, return 0. Otherwise, return index into decl[idx] where match
occured. Also set hMem to the HASH!C(s).

!!! @V.48.89. LATER - change this HOG to a linked list chasing scheme!!

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: FIND!RC!SYMBOL>]
 */
INTEGER i, 
	idx;

;

GC_POPS(s); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
*hmem= hash_c(GC_PUSHS(s));
GC_EPOPS(dbug(20000000L,catlist(11L,GC_PUSHS("[FIND!RC!SYMBOL] s=\'"),GC_PUSHS(s),
        GC_PUSHS("\' saiSym[hClass]=\'"),GC_PUSHS(*aChkC(saisym,1L,
        hclass)),GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  hMem="),
        cvs(*hmem),GC_PUSHS(" saiSym[hMem]=\'"),
        GC_PUSHS(*aChkC(saisym,1L,*hmem)),GC_PUSHS("\'"))));

/*  --	Note: symbols have highest block level at end of list */
idx= 0;				/*  -- Default is no match */
for (i=dclsymptr;i<=1;i--)
	if ((*hmem==(*aChkI(declhash,1L,i))))
	   {/* test if X is the one we want */
GC_EPOPS(dbug(20000000L,catlist(3L,GC_PUSHS("[FIND!RC!SYMBOL].2 i="),cvs(i),prt_node(-i))));
	   if (((*aChkI(declrclass,1L,i))==hclass||(*aChkI(declrclass,1L,i))==hany_class) &&
	      ((*aChkI(declhash,1L,i))!=hclass) &&((*aChkI(decldw,1L,i))&01000000L))
		{/* found it */
		idx= i;
		(*aChkI(decldw,1L,idx))= (*aChkI(decldw,1L,idx))&0777775777777L;
				/*  -- mark the sucker as USED... so as
				  to not call it CLUTTER */
		break;
		}/* found it */
	   }/* test if X is the one we want */
GC_EPOPS(dbug(20000000L,catlist(2L,GC_PUSHS("[FIND!RC!SYMBOL].3 idx="),cvs(idx))));

;
GC_NRETURN(idx)
}/* FIND!RC!SYMBOL */
