/* FILE: find_symbol.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pssymt.c, being converted 12/25/87, 02:03:55PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  INTEGER find_symbol(s,classsym,hsym)
	STRING s;
	INTEGER *classsym;
	INTEGER *hsym;
/*  ------------------------------------------------------- */
{/* FIND!SYMBOL */
/*  --
.LABEL [<++PSAIL PROCEDURE: FIND!SYMBOL>]
.INDEX ++PSAIL PROCEDURE: FIND!SYMBOL
DESCRIPTION:
	Search ALL of the symbol tables in order and return the hash
index h if found otherwise set h to 0. The value returned is the
SYMBOL table index if found else 0. Set the class if found else
return 0.

	The class codes are as follows:
		'D' = USER defined DUMMY (formal) variable in symtab.
		'F' = FSM exists for variable.
		'M' = USER defined PSAIL!EVAL MACRO variable in symtab.
		'U' = USER defined variable in symtab.
		 0  = indicates undefined symbol.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: FIND!SYMBOL>]
 */
INTEGER blvl, 
	idx, 
	dw;
STRING s1;

;

/*  # # DBUG(20000000,"[FIND!SYMBOL] s='"&s&"'") */
	GC_POPS(s); /* from GC string PDL */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	dw= 0;			/*  -- descriptor word */

if ((*hsym= hash_c(GC_PUSHS(s))) &&(idx= (*aChkI(dwptr,1L,*hsym))))
	{/* found local */
	*classsym= (INTEGER)'U';
	dw= (*aChkI(decldw,1L,idx));
	if ((dw&0100000L)==0) (*aChkI(decldw,1L,idx))= dw&0777775777777L;
			/*  -- mark the sucker as USED so as not to call
			  it CLUTTER... */
	blvl= (*aChkI(declblklvl,1L,idx));
	if ((dw&01000L)) *classsym= (INTEGER)'M'; 
	else if ((dw&040000L)) *classsym= (INTEGER)'D';

	if ((dw&0100L))
		{/* found FSM */
		if ((blvl==0) ||(dw&0100L) ||
		   (*classsym=='U'&&(dw&0100000L)) ||
		   (*classsym=='M'&&(dw&01000L))) *classsym= (INTEGER)'F';
		}/* found FSM */

	}/* found local */

else	*hsym = idx = *classsym = 0L;			/*  -- failed -- */

GC_EPOPS(dbug(20000000L,catlist(16L,GC_PUSHS("[FIND!SYMBOL].1 s=\'"),GC_PUSHS(s),
        GC_PUSHS("\' classSym=\'"),
        GC_PUSHS(s1= GC_EPOPS(makstr(*classsym))),
        GC_PUSHS("\' idx="),cvs(idx),GC_PUSHS(" hSym="),cvs(*hsym),
        GC_PUSHS(" bLvl="),cvs(blvl),GC_PUSHS(" FSM="),
        cvs((*aChkI(declfsm,1L,idx))),GC_PUSHS(crlf),
        GC_PUSHS(" dw=\'"),cvtypes(dw),GC_PUSHS("\'"))));


GC_NRETURN(idx)
}/* FIND!SYMBOL */
