/* FILE: fsm11.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmb.c, being converted 12/25/87, 06:01:03PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  -------------------------------------------------------- */
 static INTEGER fsm11_keyword(h1,fsmn2,dcode2,lasttype,nvars,itemcode,
			      didx2,s1,s)
	INTEGER h1;
	INTEGER *fsmn2;
	INTEGER *dcode2;
	INTEGER *lasttype;
	INTEGER *nvars;
	INTEGER *itemcode;
	INTEGER *didx2;
	STRING s1;
	STRING *s;
{/* FSM11!KEYWORD */

/*  --
.LABEL [<++PSAIL PROCEDURE: FSM11!KEYWORD>]
.INDEX ++PSAIL PROCEDURE: FSM11!KEYWORD
	Scan and analyze FSM11 keywords. Return TRUE if match and
update 's'.
Return:		0 = no match
		1 = match but not procedure
		2 = procedure match.
.ENDLABEL [<++PSAIL PROCEDURE: FSM11!KEYWORD>]
 */
INTEGER rvalue;		/*  -- return value */
INTEGER pdw;		/*  -- temp variable */
INTEGER ptype;		/*  -- temp variable */

GC_EPOPS(dbug(040000L,catlist(19L,GC_PUSHS("[FSM11!KEYWORD] s1=\'"),
			      GC_PUSHS(s1),
			      GC_PUSHS("\' dIdx2="),cvs(*didx2),
			      GC_PUSHS(" h1="),cvs(h1),
			      GC_PUSHS(" fsmN2="),cvs(*fsmn2),
			      GC_PUSHS(" dCode2=\'"),
			      GC_PUSHS(ps_strash_= GC_EPOPS(makstr(*dcode2))),
			      GC_PUSHS("\'"),GC_PUSHS(crlf),
			      GC_PUSHS(" lastType=\'"),
			      cvtypes(*lasttype),GC_PUSHS("\'"),
			      prt_node(h1),
			      GC_PUSHS(" s=\'"),GC_PUSHS(*s),
			      GC_PUSHS("\'"))));

GC_POPS(s1); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */

rvalue= 0;		/*  -- default */

if (h1==hcomment)
	{/* map comments */
	*s= catlist(2L,GC_PUSHS(*s),fsm8(hcomment));
	rvalue= 1;
	}/* map comments */

else if ((*s1==*quote))
	{/* map comments */
	push(GC_PUSHS(oldtoken));
	oldtoken= "declaration"; /*fake it*/
	midofexpr= 0L;
	*s= catlist(2L,GC_PUSHS(*s),fsm9(hquote));
	pop(&oldtoken);
	rvalue= 1;
	}/* map comments */

else if (iswhitespace((INTEGER)*s1))
	{/* trash whitespace in decl list */
	*s= catlist(2L,GC_PUSHS(*s),GC_PUSHS(s1));  /*  -- Pass W.S. on through */
	rvalue= 1;
	}/* trash whitespace in decl list */

else if (*fsmn2==72)
	{/* map GENERIC(<proc-name>) */
	*s= catlist(2L,GC_PUSHS(*s),fsm67(h1));
	rvalue= 1;
	}/* map GENERIC(<proc-name>) */

else if (h1==hsimple||h1==hrecursive) 
	{/* ignore it */
	*s= catlist(2L,GC_PUSHS(*s),simple_map(h1));
	rvalue= 1;
	}/* ignore it */

else if (h1==hintrnal||h1==hexternal) 
	{/* INTERNAL/EXTERNAL */
	if ((lastdeclaration&0400L)==0)
	  *s= catlist(2L,GC_PUSHS(" "),GC_PUSHS(*s));
	else *s= subst(GC_PUSHS(*s),7L,length(*s));  /*  -- del 'static' */
	*s= catlist(2L,simple_map(h1),GC_PUSHS(*s));  /*  -- add PREFACE */
	lastdeclaration= (lastdeclaration&0777777777377L)|((h1==hexternal) ? 
			  04000L:010000L);
	rvalue= 1;
	}/* INTERNAL/EXTERNAL */

else if (fast_equ(GC_PUSHS(s1),GC_PUSHS("array")) ||h1==hc_array) 
	{/* ignore ARRAY */
/*  -- NOTE: The following handles:
	...Array Itemvar ABC
Or,
	... Array Itemvar Array PDQ[a:b]  
Or,
	... Itemvar Array XYZ[a:b]  
NOTE: if ITEMVAR, then clears DW!array and sets DW!itemArray.
NOTE: use EQU('array') instead of hArray since we may unbind it with
new sublanguges.
NOTE: @V.56.61 If 'PARSEMAINSAIL' Then need to remap 'saiStatement'
of form:
	... ARRAY (lb1 to ub1, ...) id'
to
	... ARRAY id[lb1:ub1, ...] id'
and also conditionaly map lbj (no 'to ubj') to '1:1' if lbj='*' and
lbj:ubj to 'lbj:lbj' if ubj='*'. We currently do this by doing R!D to
[FSM62] with special ARRAY rules. In the future this will be done by
a call to REMAP from [FSM62].
 */

/*  # # DBUG('40000,"[FSM11!KEYWORD].1 ARRAY NODE["&saiSym[h1]&"]="&
    PRT!NODE(h1)&" s='"&s&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
  *s= catlist(2L,GC_PUSHS(*s),
	      GC_PUSHS((useextensionsflag)
		       ? GC_EPOPS(map_expr(h1) )
		       : GC_EPOPS(simple_map(h1))));
/*  -- NOTE: this will map to [FSM1] for standard PSAIL and to [FSM62] if
non-standard.
 */
/*  # # DBUG('40000,"[FSM11!KEYWORD].2 s='"&s&"'"&CRLF&" saiStatement='"&
        saiStatement&"'"&" s1='"&s1&"'="&PRT!NODE(h1)) */
        lastdeclaration=lastdeclaration|dw_array |
                 ((h1==hc_array) ?  0200000L : 0L);
        rvalue= 1; /*ignore it*/
	}/* ignore ARRAY */

else if ((*fsmn2==11&&
		 (*dcode2==codeitemvar||
		  *dcode2==codeitem ||
		  *dcode2==codeset ||
		  *dcode2==codelist)))
	{/* force ITEMVAR type */
	itemtype= PNULL;
	if ((lastdeclaration&0200L))
          lastdeclaration= (lastdeclaration&0777777777577L)|040L;
/*  -- i.e. we changed DW!array to an DW!itemArray. */
	while (length(GC_PUSHS(*s))>1)
	  if (equ(*subst(GC_PUSHS(*s),1L,8L),GC_PUSHS("/*LEAP*/")))
              *s= subst(GC_PUSHS(*s),9L,length(*s)); 
	  else itemtype= catlist(2L,GC_PUSHS(itemtype),GC_PUSHS(LOP(*s)));
/*  # # DBUG('40000,"[FSM11!KEYWORD].3 s1="&s1&CRLF&"  lastDeclaration=0"&CVOS(lastDeclaration)&"='"&CVTYPES(lastDeclaration)) */
	lastdeclaration=lastdeclaration|020000L;
	*itemcode= cvptypel(lastdeclaration);
	pdw_itemtype(lastdeclaration,*itemcode);
	pdw= cvstype(GC_PUSHS(s1));
	ptype= (((ps_itrash_= (pdw&037))>0) ? (ps_itrash_+0140L)
				:0L);
	pdw_ptype(lastdeclaration,ptype);
/*  # # DBUG('40000,"[FSM11!KEYWORD].4 itemCode="&CVS(itemCode)&" pType='"&
    (ps!sTrash!_pType)&"'"&CRLF&"  lastDeclaration=0"&CVOS(lastDeclaration)&
    "='"&CVTYPES(lastDeclaration)&CRLF&"  pDW='"&CVTYPES(pDW)&"'") */
	if (fast_equ(subsr(GC_PUSHS(*s),1L,6L),GC_PUSHS("static")))
     *s= subst(GC_PUSHS(*s),7L,length(*s));
/*  -- So we don't put STATIC inside of comment */
	itemtype= GC_EPOPS(map_embedded_comments(GC_PUSHS(itemtype)));
	*s= catlist(4L,GC_PUSHS("/*"),GC_PUSHS(itemtype),GC_PUSHS("*/ "),
        simple_map(h1));
	if (*ps__leap_!='\0')
           *s= catlist(2L,GC_PUSHS(*s),GC_PUSHS(ps__leap_));
	if ((!isrcdclassflag) &&
	   (lastdeclaration&027660)==0)
		{/* force it STATIC */
		*s= catlist(2L,GC_PUSHS("static "),GC_PUSHS(*s));
		lastdeclaration=lastdeclaration|0400L;
		}/* force it STATIC */
	rvalue= 1; /*ignore it*/
	}/* force ITEMVAR type */

else if ((*fsmn2==67)	/*  -- i.e. SAFE */) 
	{/* ignore SAFE */
	*s= catlist(2L,GC_PUSHS(*s),simple_map(hsafe));
	lastdeclaration=lastdeclaration|0400000L;
	rvalue= 1; /*ignore it*/
	}/* ignore SAFE */

else if ((*fsmn2==12))
	{/* reparse as PROCEDURE */
	push(GC_PUSHS(*s));
	s1= GC_EPOPS(fsm12(hprocedure));
	pop(s);
	*s= catlist(2L,GC_PUSHS(*s),GC_PUSHS(s1));
	*++nvars;
	rvalue= 2;	/*  -- i.e. DONE */
	}/* reparse as PROCEDURE */

GC_EPOPS(dbug(040000L,catlist(9L,GC_PUSHS("[FSM11!KEYWORD].5 rValue="),
        cvs(rvalue),
        GC_PUSHS(" s=\'"),GC_PUSHS(*s),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" lastDeclaration=\'"),cvtypes(lastdeclaration),
        GC_PUSHS("\'"))));

GC_NRETURN(rvalue)
}/* FSM11!KEYWORD */



/*  -------------------------------------------------------- */
/*INTERNAL*/  STRING fsm11(h)
	INTEGER h;
{/* FSM11 */
STRING s, 
	s1, 
	s2, 
	s3, 
	id, 
	slabel, 
	lastarrayspec, 
	wspreface;
INTEGER i, 
	j, 
	h1, 
	isleapdeclarflag, 
	nvars, 
	chkarryspecflag, 
	bk1, 
	bk2,
	bk3, 
	itemcode, 
	ptype, 
	pdw, 
	didx, 
	fsmn, 
	dcode;
/* LABEL  reparsearrayspec */		/*  -- in PROCESS ARRAY BOUNDS */

{/* INCFSM */
 if (usecntfsmflag)
   (*aChkI(cntfsms,1L,11L))= (*aChkI(cntfsms,1L,11L))+1L;
}/* INCFSM */

/*[11] <declaration list>*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM11>]
.INDEX ++PSAIL PROCEDURE: FSM11
	Scan for id's in an declaration list. If there is a [ then
process as array declaration. Push info into symbol tables for GC and
UNIQUE processing later.

@V.56.163 NOTE: disabled the 'isMACROflag' to let macros with
declarations compile to C. However, there may be some side effects
which need to be investigated and this option re-evaluated at that
time.
.ENDLABEL [<++PSAIL PROCEDURE: FSM11>]
 */
GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM11] \'rule\' NODE["),
			      GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*  # # DBUG('40000,"[FSM11].0.1  blockLevel="&CVS(blockLevel)&CRLF&
    "  oldLastProcedure='"&oldLastProcedure&"' lastProcedure='"&
    lastProcedure&"'"&CRLF&"  dcStaticDeclaration='"&
    dcStaticDeclaration&"'"&CRLF&"  lastDeclaration='"&
    CVTYPES(lastDeclaration)&"'") */
/*  # # DBUG('40000,"[FSM11].0.2 locAptr="&CVS(locAptr)&" locIptr="&
    CVS(locIptr)&" locSptr="&CVS(locSptr)) */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(s2); /* for G.C. */
	GC_NOTESTRING(s3); /* for G.C. */
	GC_NOTESTRING(id); /* for G.C. */
	GC_NOTESTRING(slabel); /* for G.C. */
	GC_NOTESTRING(lastarrayspec); /* for G.C. */
	GC_NOTESTRING(wspreface); /* for G.C. */
	if (FALSE /*  # # @V.56.161 isMacroFlag  */)
		{/* do MACROS a favor! */
		isfragmentflag= 1L;  /*  -- Always do PSAIL!EVAL */
		lasttype= 0L;   /*  -- protect decl symtab entry */
;
		{GC_UNMARKSSTKFRAME;
		 GC_SRETURN(saitoken);} "do MACROs a favor..."
		}/* do MACROS a favor! */
	lastformal= PNULL;   /*  -- symtab procedure FORMAL args */
	lastsublang= 0L;	   /*  -- User symbols are in L0 - for now */
	lastarrayspec= PNULL;	/*  -- in case missing [...]  */
	nvars= 0;	/*  -- Number of variables declared */
	wspreface= PNULL;	   /*  -- just in case several <ids> */
	isleapdeclarflag= 0L;
	id= PNULL;	/*  -- will get id name */

	didx= (*aChkI(dwptr,1L,h));	/*  -- get working symbol values */
	fsmn= ((*aChkI(declfsm,1L,didx))&07777);
	lasttype= (*aChkI(decldw,1L,didx));
	dcode= (((ps_itrash_= (lasttype&037))>0) ? (ps_itrash_+0140L)
				:0L);
/*  # # DBUG('40000,"[FSM11].0.2.1 dIdx="&CVS(dIdx)&" h="&CVS(h)&
    " fsmN="&CVS(fsmN)&" dCode='"&(PS!sTrash!_dCode)&"'"&CRLF&
    " lastType='"&CVTYPES(lastType)&"'") */

	if (dcode==codedouble)
		{/* Eat up redundent 'REAL' */
		while ((*saistatement!='\0') &&
		       iswhitespace((INTEGER)*saistatement))
		  ps_itrash_= LOP(saistatement);
	        if (equ(subst(GC_PUSHS(saistatement),1L,4L),
			GC_PUSHS("real")))
		  saistatement= subst(GC_PUSHS(saistatement),5L,
				      length(saistatement)); 
		else saistatement= catlist(2L,GC_PUSHS(" "),
					   GC_PUSHS(saistatement));
				  /*  -- LONG REAL==>double */
		}/* Eat up redundent 'REAL' */

	oldtoken= saitoken;
	chkarryspecflag= 0L; /*  -- check for [] on ARRAY decl. */
/*  # # @V.56.99	If h=hBOOLEAN
		Then saiToken_"integer" */
	lastdeclaration=lastdeclaration&0554566613400L;
/*  # # @V.56.136		pDW_CVSTYPE(saiToken) */
/*  # # @V.56.136		pType_GDW!pType(pDW) */
	pdw= lasttype;
	ptype= dcode;
	pdw_ptype(lastdeclaration,ptype);
			 /*  -- code it as PSAIL internal code */
/*  # # DBUG('40000,"[FSM11].0.3 dcStaticDeclaration='"&
    dcStaticDeclaration&"'"&CRLF&"  pDW='"&CVTYPES(pDW)&"'"&CRLF
    &"  lastDeclaration='"&CVTYPES(lastDeclaration)&"'") */
	if (!isleapcode(lastdeclaration)) itemtype= PNULL; 
	else 	{/* is LEAP declaration */
		isleapdeclarflag= 1L;
		itemtype= saitoken;	/*  -- Note LEAP type */
		lastdeclaration=lastdeclaration|020000L;
		if ((!isrcdclassflag) &&
		   (lastdeclaration&027660)==0)
			{/* force STATIC */
			lastdeclaration=lastdeclaration|0400L;
			dcstaticdeclaration= "static ";
			}/* force STATIC */
		if (ptype==codeset) itemcode= 
		6L; else if (ptype==codelist) itemcode= 
		7L; else itemcode= 1;	/*  -- UNtyped!!! */
/*  # # DBUG('40000,"[FSM11].0.3.1 itemCode="&CVS(itemCode)&
    " lastDeclaration=0"&CVOS(lastDeclaration)&CRLF&
    " lastDeclaration='"&CVTYPES(lastDeclaration)&"'") */
		pdw_itemtype(lastdeclaration,itemcode);
/*  # # DBUG('40000,"[FSM11].0.3.2 itemCode="&CVS(itemCode)&
    " lastDeclaration=0"&CVOS(lastDeclaration)&CRLF&
    " lastDeclaration='"&CVTYPES(lastDeclaration)&"'") */
		}/* is LEAP declaration */

	if (isrcdptrflag) pdw_ptype(lastdeclaration,coderecptr);

	if (h==hlabel)
		{/* just map to comment */
		slabel= catlist(2L,GC_PUSHS("comment LABEL "),
				GC_PUSHS(saistatement));
		pdw_ptype(lastdeclaration,codelabel);
		}/* just map to comment */
	else slabel= PNULL;

	if (/*  # # @V.49.40 (blockLevel Leq 1) And --- */
	   (*dcstaticdeclaration!='\0') &&
	   ((lastdeclaration&027660)==0) &&
	   (!isrcdclassflag) &&(!isrcdptrflag)) s= dcstaticdeclaration;  
	else s= " "; 	/*  -- Do Not declare local var static */
	dcstaticdeclaration= PNULL; /*  -- Reset it */
/*  # # DBUG('40000,"[FSM11].0.4 lastDeclaration='"&
    CVTYPES(lastDeclaration)&"'"&CRLF&" lastType='"&CVTYPES(lastType)&"'") */

/*  # # @V.56.103		If FAST!EQU(saiToken,"double")
# # # @V.56.103			Then s_s & saiToken
# # # @V.56.103		Else */
	if (!isrcdptrflag)
		{/* map main declar type */
		lasttype= 0L;	/*  -- so don't change it */
		s= catlist(2L,GC_PUSHS(s),simple_map(h)); /*  -- Declar. type,
				If RECORD!POINTER then FSM41
				will insert the C code */
		}/* map main declar type */
/*  # # DBUG('40000,"[FSM11].0.5 initial saiToken="&PRT!NODE(h)) */
	while ((*s!='\0') &&iswhitespace((INTEGER)*s)) ps_itrash_= LOP(s);     /*  -- get rid of leading WS if any */
	GC_EPOPS(map_ws_comments(&s,0L));	/*  -- Map any comments */

	if (isleapdeclarflag &&*ps__leap_!='\0')
            s= catlist(2L,GC_PUSHS(s),GC_PUSHS(ps__leap_));

/*  --------------------------------------------------------------- */
/*  . . . . . ANALYZE DECLARATION DESCRIPTORS TO MAKE DW WORD . . . */
/*  --------------------------------------------------------------- */
	do  	{/* Analyze SAIL descriptor list */
		INTEGER fsmn2, 
		didx2, 
		dcode2;
		oldtypestatement= "%%declaration";
/*  -- NOTE: to hold off GET!NUMBER conversion of variables of the form
E<digits> to scientific notation!
 */
		s1= GC_EPOPS(get_token(&saistatement)); /*for token
				also expand macro if needed*/
		saibrk= (INTEGER)'\0';
/*  # # DBUG('40000,"[FSM11].1 s1='"&s1&"' s='"&s&"'"&CRLF&
    "  saiStatement='"&saiStatement&"'"&CRLF&"  lastDeclaration='"&
    CVTYPES(lastDeclaration)&"'"&CRLF&"  chkArrySpecFlag="&
    PBOOL(chkArrySpecFlag)&" lastArraySpec='"&lastArraySpec&"'") */
		if (isleapdeclar(GC_PUSHS(s1))) isleapdeclarflag= 1L;
		h1= hash_c(GC_PUSHS(s1));  /*  -- for speedup... */
		didx2= (*aChkI(dwptr,1L,h1));
		fsmn2= ((*aChkI(declfsm,1L,didx2))&07777);
		lasttype= (*aChkI(decldw,1L,didx2));
		dcode2= (((ps_itrash_= (lasttype&037))>0)
                                ? (ps_itrash_+0140L)
				: 0L);
/*  # # DBUG('40000,"[FSM11].1.0.1.0 s1='"&s1&"' dIdx2="&CVS(dIdx2)&
    " h1="&CVS(h1)&" fsmN2="&CVS(fsmN2)&" dCode2='"&(PS!sTrash!_dCode2)&
    "'"&CRLF&" lastType='"&CVTYPES(lastType)&"'"&PRT!NODE(h1)&CRLF&
    " s='"&s&"'") */

		j= fsm11_keyword(h1, &fsmn2, &dcode2, &lasttype, &nvars,
					&itemcode, &didx2, GC_PUSHS(s1), &s);
		switch (j)
			{/* handle recognized keywords */
		/*0*/	case 0: 0L break;      /*  -- keep going - is new id */
		/*1*/	case 1: continue; break; /* -- keep looking 
		  for keywords */
		/*2*/	case 2: break; break;  /*  -- was PROCEDURE keyword */
			}/* handle recognized keywords */

		id= s1;		/*  -- copy without possible prefix */
/*  # # DBUG('40000,"[FSM11].1.2.0 s='"&s1&"'"&CRLF&" s1='"&s1&"' id='"&id&"'") */
		if (isalpha(GC_PUSHS(s1)))
			{/* try to save <identifier> */
/*  ----------------------------------------- */
/*  . . . . SAVE THIS DECLARATION . . . . . . */
/*  ----------------------------------------- */
			id= s1;	/*  -- set up id */
/*  # # DBUG('40000,"[FSM11].1.2.0.1 id='"&id&"'") */
			if (TRUE  /*  # # @V.56.163 (Not isMacroFlag)  */)
				{/* Save declaration variable */
				lastasize= "1";
				chkarryspecflag= ((lastdeclaration&0200L)!=0);
/*  # # DBUG('40000,"[FSM11].1.2.1 s='"&s&"'"&CRLF&"  s1='"&s1&"' saiBrk='"&(ps!sTrash!_saiBrk)&"'"&CRLF&" lastDeclaration='"&CVTYPES(lastDeclaration)&"'") */
				if (isrcdclassflag)
				   {/* update DW */
				   lastdeclaration=lastdeclaration|01000000L;
				   }/* update DW */
				lastcsym= s1;	/*  -- map 1:1  */
				if (lastdeclaration&020000L)
				  lastsublang= 1L; /*  -- <L1> */
				lastdeclaration=lastdeclaration|02000000L;
/*  -- To catch CLUTTER when delete symbol */
				oldtoken= s1=
				  GC_EPOPS(map_declar(GC_PUSHS(s1)));
				if (blocklevel<2)
				  {/* INCSTAT */
				    if (usereportflag)
				      (*aChkI(errstatistics,1L,13L))++;
				  }/* INCSTAT */
				else {/* INCSTAT */
				    if (usereportflag) 
				      (*aChkI(errstatistics,1L,14L))++;
				     }/* INCSTAT */ /*  -- for /REPORT */
				if (ispreload_withflag)
					{/* check for OWN */
					if (usechkflag)
					  s1= catlist(2L,GC_PUSHS("*P_"),
						      GC_PUSHS(s1));
					if ((lastdeclaration&0400L)==0 &&
					   (blocklevel>1))
					  err_hlr(GC_PUSHS(
		         catlist(3L,
				 GC_PUSHS("[FSM11] PRELOADed ARRAY \'"),
				 GC_PUSHS(oldtoken),
				 GC_PUSHS("\' must be declared OWN"))));
					}/* check for OWN */
				else if (usechkflag &&
				        (lastdeclaration&0200L)) 
				  s1= catlist(2L,GC_PUSHS("*"),
					      GC_PUSHS(s1));
				else if ((lastdeclaration&0200L) &&
					 isrcdclassflag &&
					 !usechkflag)
				  s1= catlist(2L,GC_PUSHS(s1),GC_PUSHS("[]"));
				while ((*saistatement!='\0') &&
				       iswhitespace((INTEGER)*saistatement))
				  ps_itrash_= LOP(saistatement);
/*  -- In case WS between id and possible '[' */
				}/* Save declaration variable */

			++nvars;
		        if (*classize=='\0') classize= lastasize; 
			else classize= catlist(3L,GC_PUSHS(classize),
					       GC_PUSHS("+"),
					       GC_PUSHS(lastasize));
				/*  -- used to compute total size
				when building a RECORD!CLASS */
		   }/* try to save <identifier> */
/*  # # DBUG('40000,"[FSM11].1.2.2 s='"&s&"'"&CRLF&" id='"&id&"' s1='"&s1&
    "' saiBrk='"&(ps!sTrash!_saiBrk)&"'"&CRLF&" lastDeclaration='"&
    CVTYPES(lastDeclaration)&"'"&CRLF&" useGCflag="&PBOOL(useGCflag)&
    " isMACROflag="&CVS(isMACROflag)&" locSptr="&CVS(locSptr)) */

/*  -------------------------------------------------- */
/*  . . . . . SAVE POINTERS IF DOING STRING G.C. . . . */
/*  -------------------------------------------------- */
		if (usegcflag &&isalpha(GC_PUSHS(id)) &&
		   (((ps_itrash_= (lastdeclaration&037))>0)
		                     ? (ps_itrash_+0140L)
				     : 0L)==codestring &&
		    TRUE  /*   # # @V.56.163 Not isMacroFlag  */)
			{/* save string name for G.C. */
/*  # # DBUG('40000,"[FSM11].1.2.3 saiStatement='"&saiStatement&"'") */
			if ((notmainflag ||blocklevel>1) &&
			   (lastdeclaration&0400L) &&
			   (lastdeclaration&04000L)==0)
				{/* trouble */
				s= catlist(2L,GC_PUSHS(s),GC_PUSHS(crlf));
				err_deathwish(&s,
 catlist(7L,
  GC_PUSHS("WARNING! Can\'t have OWN STRING declarations in non-MAIN module"),
        GC_PUSHS(crlf),
        GC_PUSHS("or inner blocks! Suggest you move \'STRING "),
        GC_PUSHS(id),GC_PUSHS("\' declaration"),GC_PUSHS(crlf),
        GC_PUSHS("to global level in MAIN module and recompile.")),
					 7L, (INTEGER)('N'));
				}/* trouble */
			if (*saistatement=='[')
				{/* String array */
/*  -- NOTE: if the sucker is a string array, then we a) note this by a
"0" as the first element in the PDL, then b) push the name of the
string array.
 */
				{/* PUSH!STRNAME */ 
			if ((++locsptr)>300L) 
    err_hlr(GC_PUSHS("[PUSH!STRNAME] locAryName[] OVERFLOW! on \'0\'"));
			(*aChkC(locstrname,1L,locsptr))= ("0");
			{/* MAXSTAT */
			  if (usereportflag)
			    (*aChkI(errstatistics,1L,28L))=
			      MAX((*aChkI(errstatistics,1L,28L)),locsptr);
			}/* MAXSTAT */  /*  -- for /REPORT */
		      }/* PUSH!STRNAME */
			    }/* String array */
			{/* PUSH!STRNAME */ 
			if ((++locsptr)>300L) 
    err_hlr(catlist(3L,GC_PUSHS("[PUSH!STRNAME] locAryName[] OVERFLOW! on \'"),
        GC_PUSHS(id),GC_PUSHS("\'")));
			(*aChkC(locstrname,1L,locsptr))= id;
			{/* MAXSTAT */
			  if (usereportflag)
			    (*aChkI(errstatistics,1L,28L))=
			      MAX((*aChkI(errstatistics,1L,28L)),locsptr);
		        }/* MAXSTAT */  /*  -- for /REPORT */
			}/* PUSH!STRNAME */   /*  -- and the NAME */
/*  # # DBUG('40000,"[FSM11].1.2.3.1 locSptr="&CVS(locSptr)&" s1='"&s1&
    "' id='"&id&"'") */
			}/* save string name for G.C. */

		if (*saistatement=='(')
			err_hlr(GC_PUSHS(
catlist(5L,GC_PUSHS("[FSM11] Saw \'(\' in \'"),GC_PUSHS(oldtoken),
        GC_PUSHS("\' declaration. Probably"),GC_PUSHS(crlf),
        GC_PUSHS("	forgot PROCEDURE keyword."))));

/*  -------------------------------------- */
/*  . . . . PROCESS ARRAY BOUNDS . . . . . */
/*  -------------------------------------- */
reparsearrayspec:
/*  -- Note: may come here from PROCESS DECL LIST if there was a
missing [...] spec which it supplied and asks us to now reparse.
 */
		if (*saistatement=='[') 
			{/* array declaration */
			STRING ssv1;
/*  -- NOTE: save saiStatement for generating bounds comment */
			GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
			GC_NOTESTRING(ssv1); /* for G.C. */
			ssv1= saistatement;
			if (usechkflag &&notmainflag &&
			   (blocklevel==1) &&
			   (lastdeclaration&04000L)==0)
				{/* trouble */
				err_deathwish(&s,
 catlist(5L,
        GC_PUSHS("WARNING! Can\'t have global dynamic ARRAY declarations in")
        ,GC_PUSHS(crlf),
        GC_PUSHS("non-MAIN modules! Suggest you move decl. to global level in")
        ,GC_PUSHS(crlf),GC_PUSHS("MAIN module and recompile.")),
					 7L, (INTEGER)('N'/*WARNING*/));
				}/* trouble */
			saibrk= LOP(saistatement);
			if (*s1!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s1));
/*  # # DBUG('40000,"[FSM11].1.3 s='"&s&"' s1='"&s1&"' saiBrk='"&
    (ps!sTrash!_saiBrk)&"'") */
			/*  -- Update G.C list array size... */
			if ((lastdeclaration&0200L)==0)
				{/* check if LEAP */
				if ((lastdeclaration&040L))
					{/* change back */
					INTEGER itype;
					lastdeclaration=
					  (lastdeclaration&0777777777737L) |
					                0200L;
					itype=gdw_itemtype(lastdeclaration);
					if (itype>20) 
					   pdw_itemtype(
					      lastdeclaration,
						(itype-20L));
/*  # # DBUG('40000,"[FSM11].1.3.0 iType="&CVS(iType)&CRLF&
    "  lastDeclaration='"&CVTYPES(lastDeclaration)&"'") */
					}/* change back */
				else err_hlr(GC_PUSHS(
	"[FSM11] No \'ARRAY\' keyword on array declaration."));
				}/* check if LEAP */
			chkarryspecflag= 0L;
			oldtypestatement= "%%declaration";
			oldaryspec= s3= GC_EPOPS(fsm4a(hleftbracket));
			ssv1= catlist(GC_PUSHS("  /* "),
				      subsr(GC_PUSHS(ssv1),1L,
					    (length(GC_PUSHS(ssv1)) -
					     length(GC_PUSHS(saistatement)))),
				      GC_PUSHS(" */ ")); 
			               /*  -- compute BOUNDS comment */
/*  # # DBUG('40000,"[FSM11].1.3.1 After FSM4a s3='"&s3&"'"&CRLF&
    "  lastAsize='"&lastAsize&"'") */
/*  -- NOTE: will have '@', '!' or '#' prefix if the /CHECK switch is
active with an entry of the form:
	 @aName,n,LB1,UB1,...,LBn,UBn,"aName",'type'
for dynamic arrays
	 !aName,n,LB1,UB1,...,LBn,UBn,"aName",'type'
for OWN dynamic arrays
or
	 #aName,n,LB1,UB1,...,LBn,UBn,"aName",'type'
for static PRELOADed checked arrays.
 */
/*  # # DBUG('40000,"[FSM11].1.3.2 useCHKflag="&PBOOL(useCHKflag)&
    " blockLevel="&CVS(blockLevel)&CRLF&" lastDeclaration='"&
    CVTYPES(lastDeclaration)&"'"&CRLF&" s3='"&s3&"'") */
			if (usechkflag &&
			   (*s3=='@'||*s3=='#' ||*s3=='!') &&
			   (((blocklevel>1) &&
	     			((lastdeclaration&04000L)==0)) ||
	  		    	    ((!notmainflag) &&
			     (blocklevel<=1)))) {/* PUSH!ARYNAME */ 
			if ((++locaptr)>300L) 
    err_hlr(catlist(3L,GC_PUSHS("[PUSH!ARYNAME] locAryName[] OVERFLOW! on \'"),
        GC_PUSHS(s3),GC_PUSHS("\'")));
			(*aChkC(locaryname,1L,locaptr))= s3;
			{/* MAXSTAT */
			  if (usereportflag)
			    (*aChkI(errstatistics,1L,26L))=
			      MAX((*aChkI(errstatistics,1L,26L)),locaptr);
		        }/* MAXSTAT */  /*  -- for /REPORT */
			}/* PUSH!ARYNAME */
/*  # # DBUG('40000,"[FSM11].1.3.3 locAptr="&CVS(locAptr)&
    " locSptr="&CVS(locSptr)) */

			if (*s3=='@'&&((!notmainflag) || (blocklevel>1)))
			   {/* update FREE ARRY list */
/*  -- NOTE: Do not free OWN or preloaded dynamic arrays. */
/*  # # DBUG('40000,"[FSM11].1.4 s3='"&s3&"'") */
			   i= LOP(s3);    /*  -- Trash '@' */
			   s2= GC_EPOPS(scan(&s3,2L,&i));   /*  -- get 'id' */
			   if ((((ps_itrash_= (lastdeclaration&037))>0)
				? (ps_itrash_+0140L)
				: 0L)!=codeinteger) 
			     s2= catlist(2L,GC_PUSHS("(INTEGER *)"),
					 GC_PUSHS(s2));
/*  -- NOTE: need to cast it to INTEGER pointer since that is what
aryfree() expects.
*/
			   s3= catlist(2L,GC_PUSHS(s2),GC_PUSHS(","));
			   s2= (*aChkC(blkfrearylist,1L,blocklevel));
			   s2= catlist(2L,GC_PUSHS(s2),GC_PUSHS(s3));
			   (*aChkC(blkfrearylist,1L,blocklevel))= s2;
/*  # # DBUG('40000,"[FSM11].2 s3='"&s3&"'"&CRLF&
    "  blkFreAryList[blockLevel]='"&blkFreAryList[blockLevel]&"'") */
			   }/* update FREE ARRY list */
			else if ((*s3!='@') &&
				(*s3!='#') &&(*s3!='!')) 
			  s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s3));

			s= catlist(2L,GC_PUSHS(s),GC_PUSHS(ssv1));	
			            /*  -- add BOUNDS comment */
			if (TRUE  /*  # # @V.56.163 Not isMacroFlag  */) 
			  (*aChkC(declsize,1L,dclsymptr))=
			    catlist(4L,
				    GC_PUSHS(*aChkC(declsize,1L,dclsymptr)),
				    GC_PUSHS("*("),
				    GC_PUSHS(lastasize),GC_PUSHS(")"));
			continue;
			{GC_UNMARKSSTKFRAME;}
		      }/* array declaration */
/*  # # DBUG('40000,"[FSM11].3 s1='"&s1&"' s='"&s&"' saiBrk='"&
    (s3_saiBrk)&"'"&CRLF&" lastArraySpec='"&lastArraySpec&
    "' chkArrySpecFlag="&PBOOL(chkArrySpecFlag)) */

/*  ----------------------------------------------------------------- */
/*  . . . . PROCESS DECLARATION LIST IF IT IS A ',' or '<SC>' . . . . */
/*  ----------------------------------------------------------------- */
		if (*s1=='\0'&&
		   (*saistatement==';'||*saistatement==','))
		  s1= GC_EPOPS(makstr(LOP(saistatement))); /*  -- eat it */

		if ((*s1==';'||*s1==',')) 
			{/* build string */
			saibrk= (INTEGER)*s1;  /*  -- copy it */
			if (chkarryspecflag)
				{/* found array ID no bounds */
/*  # # DBUG('40000,"[FSM11].3.1 s1='"&s1&"' s='"&s&"'"&CRLF&
    "  saiBrk='"&(s3_saiBrk)&"' saiStatement='"&saiStatement&"'"&CRLF&
    " lastArraySpec='"&lastArraySpec&"'") */
				if (saibrk==';')
				  lastarrayspec= PNULL; 
				else if (*lastarrayspec=='\0')
					{/* get [..] */
/*  # # DBUG('40000,"[FSM11].3.2 oldToken='"&oldToken&"'"&CRLF&
    " saiStatement='"&saiStatement&"'") */
					s2= saistatement;
					s3= GC_EPOPS(scan(&s2,10L,&bk1)); /*;*/
					setbreak(24L, GC_PUSHS("]["), 
						 GC_PUSHS(PNULL), 
						 GC_PUSHS("INS"));
					s2= GC_EPOPS(scan(&s3,24L,&bk3)); /*[*/
					lastarrayspec= GC_EPOPS(
						    scan(&s3,24L,&bk2)); /*]*/
/*  # # DBUG('40000,"[FSM11].3.3 lastArraySpec='"&lastArraySpec&"'") */
					}/* get [..] */
				if (*lastarrayspec!='\0')
				   {/* backup with [..] */
				   saistatement= catlist(4L,GC_PUSHS("["),
						   GC_PUSHS(lastarrayspec),
						   GC_PUSHS("],"),
						   GC_PUSHS(saistatement));
				   s1= PNULL; /*  -- so do not add the ',' */
				   goto reparsearrayspec; 
					/*  -- ie. REPARSE it */
				   }/* backup with [..] */

				else if (!isrcdclassflag) err_hlr(GC_PUSHS(
	"[FSM11] No [<bounds>] found in array declaration."));
/*  # # DBUG('40000,"[FSM11].3.3.1 s1='"&s1&"' s='"&s&"'")
				 */s1= catlist(2L,GC_PUSHS(s1),GC_PUSHS("[]"));
				}/* found array ID no bounds */
			chkarryspecflag= ((lastdeclaration&0200L)!=0);
/*  # # DBUG('40000,"[FSM11].3.4 s1='"&s1&"' s='"&s&"' saiBrk='"&
    (s3_saiBrk)&"'"&CRLF&"  saiStatement='"&saiStatement&"'"&CRLF&
    "  lastArraySpec='"&lastArraySpec&"' chkArrySpecFlag="&
    PBOOL(chkArrySpecFlag)) */

/*  -------------------------------------------------------------------- */
/*  . . . ADD INITIALIZERS FOR GLOBAL OR STATIC LOCALS WHERE NEEDED. . . */
/*  -------------------------------------------------------------------- */
/*   -- The following table summarizes the conditions under which it is
legal to emit a zero initializer...
	<condition>  \  Global block level |  Local block level
	-------------------------------------------------------
	auto	    |       YES		   |    NO
	-------------------------------------------------------
	static	    |       YES		   |    YES
	-------------------------------------------------------
	INTERNAL    |       YES		   |    <illegal!>
	-------------------------------------------------------
	EXTERNAL    |       NO 		   |    NO
	-------------------------------------------------------
	PROCEDURE   |       NO 		   |    NO
	-------------------------------------------------------
	RECORD!CLASS|       NO 		   |    NO
	-------------------------------------------------------
	C array     |       NO 		   |    NO
	-------------------------------------------------------
        /CHECK array|       YES		   |    YES
	-------------------------------------------------------

and the type must be in 
	{INTEGER, REAL, BOOLEAN, LONG REAL, ITEM, SET, LIST}
 */
	
			i= (((ps_itrash_= (lastdeclaration&037))>0)
			        ? (ps_itrash_+0140L)
				: 0L);
			j= (useinitializersswitch &&
			   (saibrk==';'||(i==codeitem||
				i==codeset ||i==codelist)) &&
			   (lastdeclaration&057144) &&
			   (((lastdeclaration&0200L)
				 && usechkflag) ||
			    ((lastdeclaration&0200L)==0)) &&
			   ((((ps_itrash_= (lastdeclaration&037))>0)
			         ? (ps_itrash_+0140L)
				 : 0L)!=coderecclass) &&
			   (lastdeclaration&0307640)==0
			   );
/*  # # DBUG('40000,"[FSM11].3.4.1 j="&PBOOL(j)&" i="&CVS(i)&
    " useCHKflag="&PBOOL(useCHKflag)&CRLF&" lastDeclaration=0"&
    CVOS(lastDeclaration)&"(8)='"&CVTYPES(lastDeclaration)&"'") */
			if (j) 
				{/* ZERO initializer */
				if ((lastdeclaration&0200L))
				  s= catlist(2L,GC_PUSHS(s),
					     GC_PUSHS(" = 0"));
				else if (i==codestring) 
				        s= catlist(2L,GC_PUSHS(s),
						   GC_PUSHS(" = PNULL"));
				else if (i==codereal||
					i==codedouble) 
				  s= catlist(2L,GC_PUSHS(s),
					     GC_PUSHS(" = 0.0")); 
				else if ((i==codeitem||
					i==codeset ||i==codelist))
					{/* ITEM init */
					INTEGER ii;
					s= catlist(3L,GC_PUSHS(s),
						   GC_PUSHS(" = -"),
						   cvs(itemstart));
					++itemstart;
					ii= 0;
					pdw_ptype(ii,codeinteger);
					s3=catlist(GC_PUSHS("0"),
						   cvos(lastdeclaration));
					s3= GC_EPOPS(cvactual_to_expected(
						    ii,ii,GC_PUSHS(s3)));
					s3= catlist(4L,GC_PUSHS("?"),
						    GC_PUSHS(oldtoken),
						    GC_PUSHS(","),
						    GC_PUSHS(s3));
					if (useleapflag)
					   {/* PUSH!ITEMNAME */ 
			if ((++lociptr)>300L) 
    err_hlr(catlist(3L,
		    GC_PUSHS("[PUSH!ITEMNAME] locItemName[] OVERFLOW! on \'"),
        GC_PUSHS(s3),GC_PUSHS("\'")));
			(*aChkC(locitemname,1L,lociptr))= s3;
			{/* MAXSTAT */
			    if (usereportflag)
			      (*aChkI(errstatistics,1L,27L))=
				MAX((*aChkI(errstatistics,1L,27L)),lociptr);
		        }/* MAXSTAT */  /*  -- for /REPORT */
			}/* PUSH!ITEMNAME */
/*  # # DBUG('40000,"[FSM11].3.4.1 locIptr="&CVS(locIptr)&" s3='"&s3&
    "'"&CRLF&"  itemStart="&CVS(itemStart)&" useLEAPflag="&
    PBOOL(useLEAPflag)&"  s1='"&s1&"'") */
					}/* ITEM init */
				else s= catlist(2L,GC_PUSHS(s),
						GC_PUSHS(" = 0"));
				      /*  -- ADD C ZERO initializer */
/*  # # DBUG('40000,"[FSM11].3.4.2 s='"&s&"'") */
				}/* ZERO initializer */
			if (saibrk==';'&&
			  (*saistatement==*space||*saistatement==*tab))
			  saistatement= catlist(2L,GC_PUSHS(crlf),
						GC_PUSHS(saistatement));
						/*  -- So layout is nicer */
			if (saibrk==',') 
				{/* more stuff coming */
				if (*wspreface=='\0')
				  set_preface(&wspreface);
				if (fast_equ(GC_PUSHS(wspreface),
					     GC_PUSHS(crlf)))
				  wspreface= catlist(2L,GC_PUSHS(crlf),
						     GC_PUSHS(tab));
				midofexpr= 1L;
				s3= PNULL;
				GC_EPOPS(map_ws_comments(&s3,0L));
				if (*s3!='\0') s= catlist(2L,GC_PUSHS(s),
							  GC_PUSHS(s3));
				GC_EPOPS(scan(&s3,1L,&bk2)); /*  -- for LF */
				insert_before_white(&s,GC_PUSHS(","));
				if (bk2!=*lf) s= catlist(2L,GC_PUSHS(s),
							 GC_PUSHS(wspreface));
				}/* more stuff coming */
			else 	{/* done with list */
				++stmntcnbr;
				s= catlist(2L,GC_PUSHS(s),GC_PUSHS(";"));
				}/* done with list */
			}/* build string */

		else s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s1));
		while ((*s!='\0') &&iswhitespace((INTEGER)*s))
		  ps_itrash_= LOP(s);
/*  # # DBUG('40000,"[FSM11].4 locAptr="&CVS(locAptr)&" locIptr="&
    CVS(locIptr)&" locSptr="&CVS(locSptr)&CRLF&" saiBrk='"&
    (ps!sTrash!_saiBrk)&"' "&CRLF&" s='"&s&"'"&PRT!NODE(HASH!C(oldToken))) */
		}/* Analyze SAIL descriptor list */
	 while (!(saibrk==';'||(*saistatement=='\0')));

	if (nvars==0) err_hlr(GC_PUSHS(
		"[FSM11] No declaration variables specified"));

	lasttype= ((ispreload_withflag)
			? lastdeclaration
		        : 0L);  /*  -- so MAP!EXPR doesn't change it */
/*  -- NOTE: BUT - pass lastDeclaration just in case someone (i.e.
[FSM22] eg PRELOAD wants to check it out.
 */
/*  # # DBUG('40000,"[FSM11].4.2 lastDeclaration='"&
    CVTYPES(lastDeclaration)&"'") */
	GC_EPOPS(set_static(blocklevel));
/*  -- NOTE: reset dcStaticDlaration and lastDeclaration if blockLevel
less than 2.
*/
	firstiftoken= isifexpr= 0L;
	midofexpr= 0L;

/*  # # @V.44.54	If Not slobFlag And
# # # @V.44.54	   (blockLevel>2) And (ps!WARNING! Neq NULL)
# # # @V.44.54		Then ERR!DEATHWISH(s,
# # # @V.44.54	"WARNING!!! some C compilers do not allow nested declarations",
# # # @V.44.54			err5WARNING,0) */
	if (*slabel!='\0')
		{/* reparse label as a comment! */
		saistatement= slabel;
		s= PNULL;
		}/* reparse label as a comment! */
	oldtypestatement= "%%declaration";
/*  # # DBUG('40000,"[FSM11].5 locAptr="&CVS(locAptr)&" locIptr="&
    CVS(locIptr)&" locSptr="&CVS(locSptr)) */
/*  # # DBUG('40000,"[FSM11].5.1 s='"&s&"'"&CRLF&" lastType='"&
    CVTYPES(lastType)&"'") */
GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM11].6 s=\'"),
			      GC_PUSHS(s),GC_PUSHS("\'"),
			      prt_node(h1))));

	GC_SRETURN(s)
}/* FSM11 */
