/* FILE: fsm14.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmb.c, being converted 12/25/87, 06:01:03PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  -------------------------------------------------------- */
/*INTERNAL*/  STRING fsm14(h)
	INTEGER h;
{/* FSM14 */
STRING s, 
	s1, 
	s2, 
	s3, 
	rexpr, 
	lexpr;
INTEGER newcode, 
	ch, 
	chinf, 
	unaryoprflag, 
	rtype, 
	ltype, 
	autoindexflag,
	autoassignflag, 
	rcode, 
	lcode, 
	oprexptype, 
	oprtcode,
	codetype, 
	bytetype;


{/* INCFSM */
 if (usecntfsmflag)
 (*aChkI(cntfsms,1L,14L))= (*aChkI(cntfsms,1L,14L))+1L;
}/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM14] \'rule\' NODE["),
			      GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[14] infixOP*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM14>]
.INDEX ++PSAIL PROCEDURE: FSM14
	 Do simple 1:1 map of most unary operators, do not test
	for special cases. Do type conversion if needed.
	NOTE: arithmetic (binary and unary) operators
		+, -, *, /, ~, NOT, OR, AND, LNOT, MOD
	can end up being evaled here...

	NOTE: @V.47.155 if /EXTENSIONS then implement 1:1 mapping for
	following operators:

	++, --
		as unary operators rather than binary oprs.
	+=, -=, *=, /=, MOD=
		as assignment operator by call to FSM35.
	NOTE: @V.48.197 Eat up UNARY '+' since some C compilers can
	not digest them...
	NOTE: @V.51.91 If the '*' is used in R!D such that 
	<lValue>*<rValue>
	      AND the <lValue> is NOT a legitimate <lValue> (i.e. it
	      is an operator such as '(', '+', or '* ' then this is a 
	      no-op - just return.
	NOTE: @V.53.03 If (x MOD y) and x is float type then call the
	<sairun.h> C-macro Pfmod(x,y).
.ENDLABEL [<++PSAIL PROCEDURE: FSM14>]
 */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(s3); /* for G.C. */
GC_NOTESTRING(rexpr); /* for G.C. */
GC_NOTESTRING(lexpr); /* for G.C. */
oprexptype= (*aChkI(decldw,1L,(*aChkI(dwptr,1L,h))));
                               /*  -- expected type of expression */
oprtcode= (((ps_itrash_= (oprexptype&037))>0) ? (ps_itrash_+0140L)
				:0L);
/*  # # DBUG('40000,"[FSM14].0.1 cStatement='"&cStatement&"'"&CRLF&
    "  saiStatement='"&saiStatement&"'"&CRLF&" lastType='"&
    CVTYPES(lastType)&"'"&CRLF&" oprExpType='"&CVTYPES(oprExpType)) */
/*  # # DBUG('40000,"[FSM14].0.2 oldToken='"&oldToken&
    "' oldTypeStatement='"&oldTypeStatement&"'") */
	midofexpr= 1L;
	if (*saitoken=='*'&&*cstatement=='\0') 
		{/* is special case of C '*<id>' ref */
/*  # # DBUG('40000,"[FSM14].0.3 Special case of C '*<rValue>' REF"&
    CRLF&"  cStatement='"&cStatement&"'"&CRLF&"  saiStatement='"&
    saiStatement&"'"&CRLF&" lastType='"&CVTYPES(lastType)&"'") */
		{GC_UNMARKSSTKFRAME;
		 GC_SRETURN(saitoken);}
		}/* is special case of C '*<id>' ref */

	ltype= lasttype;		/*  -- local memory */
		autoassignflag= autoindexflag= unaryoprflag= 0L;
	ch= (INTEGER)*((*aChkC(saisym,1L,h)));
                            	/*  -- copy for following tests */
	if ((ch=='+'&&ch==*saistatement) ||
	   (ch=='-'&&ch==*saistatement))
          autoindexflag= 1L;
        else if ((*saistatement=='=') &&
		(ch=='+'||ch=='-' ||ch=='*' ||ch=='/' ||
		 ch=='%' ||
		 (h==hmod&&(((ps_itrash_= (lasttype&037))>0) 
                                ? (ps_itrash_+0140L)
				: 0L)==codeinteger)))
              autoassignflag=1L;
	else if ((h==hnot||h==hlnot) ||
		((h==hminus||ch=='+') &&
		   (*cstatement=='\0'||
		    ((chinf= (*(cstatement+length(cstatement)-1)))=='(') ||
		     chinf==','
		   )
		)) unaryoprflag=1L; 
	else if ((h==hmod&&(((ps_itrash_= (lasttype&037))>0)
			    ? (ps_itrash_+0140L)
			    : 0L)==codereal))
		{/* map x MOD y  to Pfmod(x,y) */
		s= GC_EPOPS(fsm19(hash_c(GC_PUSHS("pfmod"))));
/*  # # DBUG('40000,"[FSM14].0.3.1 s='"&s&"'"&CRLF&" lastType='"&
    CVTYPES(lastType)) */
		;
		{GC_UNMARKSSTKFRAME;
		 GC_SRETURN(s);}
		}/* map x MOD y  to Pfmod(x,y) */

/*  # # DBUG('40000,"[FSM14].0.4 unaryOPRflag='"&PBOOL(unaryOPRflag)&"'"&
    CRLF&"  autoIndexFlag="&PBOOL(autoIndexFlag)&CRLF&"  autoAssignFlag="&
    PBOOL(autoAssignFlag)&CRLF&"  cStatement='"&cStatement&"'"&CRLF&
    "  saiStatement='"&saiStatement&"'"&CRLF&"  lType='"&CVTYPES(lType)&
    CRLF&"  oprExpType='"&CVTYPES(oprExpType)&"'"&CRLF&"  oldToken='"&
    oldToken&"'") */
	bytetype= 0;
	pdw_ptype(bytetype,codebyte);	/*  -- set up for later */
	if ((!unaryoprflag) &&
	   (!autoindexflag) &&
	   (!autoassignflag) &&
	   (!isunaryscalartype(ltype)) &&
	   (!(*oldtoken==':'&&equ(GC_PUSHS(oldtoken),GC_PUSHS(":="))) ||
	     h==hand ||h==hor)
/*   # # @V.52.133	   	And 
	   ((lCode_GDW!pType(lType)) Neq oprTcode And
	    oprTcode Neq CODEuntyped)
	---  */)
		{/* change <lExpr> to INTEGER */
		lexpr= GC_EPOPS(left_expr(&cstatement,1L)); /*  -- skip 
						left comments */
/*  # # DBUG('40000,"[FSM14].0.5 lExpr='"&lExpr&"'"&CRLF&"  lType="&
    CVTYPES(lType)&"'"&CRLF&"  byteType="&CVTYPES(byteType)&"'") */
		lasttype= 0L;
		pdw_ptype(lasttype,codeinteger);
		codetype= (((lcode= (((ps_itrash_= (ltype&037))>0)
				     ? (ps_itrash_+0140L)
				     : 0L))==codestring)
			                      ? bytetype
			                      : lasttype);
		s= GC_EPOPS(cvactual_to_expected(codetype,ltype,
						 GC_PUSHS(lexpr)));
		ltype= lasttype;
		}/* change <lExpr> to INTEGER */
	else lexpr = s = PNULL;

	s1= GC_EPOPS(simple_map(h));
/*  # # DBUG('40000,"[FSM14].1 s1='"&s1&"' s='"&s&"'"&CRLF&
    "  lastType='"&CVTYPES(lastType)&"'") */

	if (autoindexflag)
		{/* is ++ or -- UNARY opr */
		if (!useextensionsflag)
			err_hlr(GC_PUSHS(
	catlist(4L,GC_PUSHS("[FSM14] Illegal operator \'"),GC_PUSHS(s1),
	        GC_PUSHS(s1),GC_PUSHS("\' with /NOEXTENSIONS"))));
		s1= catlist(2L,GC_PUSHS(s1),GC_PUSHS(LOP(saistatement))); 
		                   /*  -- make it! */
		/*  -- If '<operand>++' or '<operand>--'
		then do NOT eval the 2nd <operand>. */
/*  # # DBUG('40000,"[FSM14].1.1 /EXT s1='"&s1&"' unaryOPRflag="&
    PBOOL(unaryOPRflag)) */
		}/* is ++ or -- UNARY opr */

	else if (autoassignflag)
		{/* <opr>= ASSIGNMENT OPR */
		if (!useextensionsflag)
			err_hlr(GC_PUSHS(
	catlist(3L,GC_PUSHS("[FSM14] Illegal \'"),GC_PUSHS(s1),
	        GC_PUSHS("=\' operator with /NOEXTENSIONS"))));
		s1= catlist(2L,GC_PUSHS(s1),GC_PUSHS(LOP(saistatement)));
		                      /*  -- Copy '=' */
		s2= GC_EPOPS(rightexpr(&saistatement));
/*  # # DBUG('40000,"[FSM14].1.2 /EXT s2='"&s2&"'") */
		pushnumber(h);
		pushnumber(unaryoprflag);
		pushnumber(autoindexflag);
		pushnumber(autoassignflag);
		push(GC_PUSHS(s)); push(GC_PUSHS(s1)); pushnumber(lasttype);
		s2= GC_EPOPS(r_d_expr_map(GC_PUSHS(s2))); 
		                     /*  -- assignment */
		rtype= lasttype;
		popnumber(&lasttype); pop(&s1); pop(&s);
		popnumber(&autoassignflag);
		popnumber(&autoindexflag);
		popnumber(&unaryoprflag);
		popnumber(&h);
		codetype= (((((ps_itrash_= (rtype&037))>0)
			         ? (ps_itrash_+0140L)
				 : 0L)==codestring)
			               ? bytetype
			               : lasttype);
		if (!isscalartype(lasttype,rtype))
		  s2= GC_EPOPS(cvactual_to_expected(codetype,
						    rtype,GC_PUSHS(s2)));
		s1= catlist(2L,GC_PUSHS(s1),GC_PUSHS(s2));
 		                            /*  -- Do assignment */
		if (h==hmod) {/* TRASH!RIGHT!WS */
		   while((*cstatement!='\0') &&
			 (ps_itrash_=(*(cstatement+length(cstatement)-1)))&&
			 iswhitespace(ps_itrash_)) 
		     cstatement= subst(GC_PUSHS(cstatement),1L,
				       length(cstatement)-1L);
			}/* TRASH!RIGHT!WS */
/*  # # DBUG('40000,"[FSM14].1.2.1 /EXT s1='"&s1&"'"&CRLF&"  rType="&
    CVTYPES(rType)) */
		}/* <opr>= ASSIGNMENT OPR */

	oldtoken= saitoken= (*aChkC(saisym,1L,h));
	while (iswhitespace((INTEGER)*saistatement))
		if (*saistatement==*cr) map_whitespace(&s1); 
		else ch= LOP(saistatement);   /*  -- trash all
						  white space except 
						  WS starting with CRLF */
	if (*s=='\0') s= s1; 
	else s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s1));
/*  # # DBUG('40000,"[FSM14].1.3 unaryOPRflag="&PBOOL(unaryOPRflag)&CRLF&
    " lType='"&CVTYPES(lType)&"' lastType='"&CVTYPES(lastType)&"'"&CRLF&
    " s='"&s&"'"&CRLF&" lExpr='"&lExpr&"'"&CRLF&" oprExpType='"&
    CVTYPES(oprExpType)&"'") */

	if (!unaryoprflag &&!autoindexflag &&
	   !autoassignflag)
		{/* Eval the <rValue> */
		pushnumber(h);
		push(GC_PUSHS(s)); pushnumber(lasttype);
		rexpr= GC_EPOPS(rightexpr(&saistatement));
/*  # # DBUG('40000,"[FSM14].2 rExpr='"&rExpr&"'"&CRLF&" lastType='"&
    CVTYPES(lastType)&"'") */
		rexpr= GC_EPOPS(r_d_expr_map(GC_PUSHS(rexpr)));
		rtype= lasttype;
		popnumber(&lasttype); pop(&s); 
		popnumber(&h);
/*  # # DBUG('40000,"[FSM14].2.1 rType='"&CVTYPES(rType)&"'"&CRLF&
    "  lastType='"&CVTYPES(lastType)&"'"&CRLF&"  rExpr='"&rExpr&"'") */
		rcode= (((ps_itrash_= (rtype&037))>0) 
			         ? (ps_itrash_+0140L)
				 : 0L);   /*  -- progress type */
		lcode= (((ps_itrash_= (lasttype&037))>0)
			        ? (ps_itrash_+0140L)
				: 0L);
		newcode= arithcvtypecode(lcode,rcode);
/*  # # DBUG('40000,"[FSM14].2.2 rType='"&CVTYPES(rType)&"'"&CRLF&
    "  lastType='"&CVTYPES(lastType)&"'"&CRLF&"  rExpr='"&rExpr&"'"&
    CRLF&" newCode='"&(ps!sTrash!_newCode)&"' lCode='"&(ps!sTrash!_lCode)&
    "' rCode='"&(ps!sTrash!_rCode)&"'") */
		if (newcode!=lcode)
		    {/* coerce <exprValue> */
		    pdw_ptype(lasttype,newcode); /*  -- priority */
/*  # # DBUG('40000,"[FSM14].2.2.1 NEW lastType='"&CVTYPES(lastType)&"'") */
		    }/* coerce <exprValue> */
		if (!isscalartype(lasttype,rtype))
		    {/* coerce <rValue> */
		    codetype= (((rcode==codestring)) ? 
					bytetype
			      : lasttype);
		    rexpr= GC_EPOPS(cvactual_to_expected(codetype,
					rtype,GC_PUSHS(rexpr)));
/*  # # DBUG('40000,"[FSM14].2.2.2 rExpr='"&rExpr&"'") */
		    }/* coerce <rValue> */
		if (*s=='\0') s= rexpr; 
		else s= catlist(2L,GC_PUSHS(s),GC_PUSHS(rexpr));
		}/* Eval the <rValue> */
	else if (unaryoprflag &&*((*aChkC(saisym,1L,h)))=='+') s= PNULL;	/*  -- EAT UP '+' ...
 */
/*  # # DBUG('40000,"[FSM14].3 lastType='"&CVTYPES(lastType)&CRLF&
    "' rExpr='"&rExpr&"'") */

	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 's3'=<L0> string                              */
/*************************************************/
}/* FSM14 */
