/* FILE: fsm16.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmb.c, being converted 12/25/87, 06:01:03PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  -------------------------------------------------------- */
/*INTERNAL*/  STRING fsm16(h)
	INTEGER h;
{/* FSM16 */
INTEGER ch, 
	idx, 
	cn, 
	hn, 
	ptypel, 
	addrtype;
STRING s, 
	type, 
	rexpr, 
	brkstr;

;
{/* INCFSM */
 if (usecntfsmflag)
   (*aChkI(cntfsms,1L,16L))= (*aChkI(cntfsms,1L,16L))+1L;
}/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM16] \'rule\' NODE["),
			      GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[16] MEMORY*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM16>]
.INDEX ++PSAIL PROCEDURE: FSM16
	 Map SAIL:	MEMORY[a,type]
	     to C:	(*(a)) 
.ENDLABEL [<++PSAIL PROCEDURE: FSM16>]
 */
/*  # # @V.52.16	If isMACROflag
		Then isFRAGMENTflag_TRUE */

	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(type); /* for G.C. */
	GC_NOTESTRING(rexpr); /* for G.C. */
	GC_NOTESTRING(brkstr); /* for G.C. */
	oldtoken= saitoken;
	while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement))
         ps_itrash_= LOP(saistatement);
	lasttype= 0L;
	if (*saistatement=='[') ch= LOP(saistatement); 
		else
		err_hlr(GC_PUSHS(
	"[FSM16] Missing \'[\' in MEMORY[] syntax"));
	rexpr= GC_EPOPS(copy_either(GC_PUSHS(",]"),&brkstr));
	if (*brkstr==',')
		{/* get the type */
		type= GC_EPOPS(copy_omit(GC_PUSHS("]")));
		GC_EPOPS(remove_white_ends(GC_PUSHS(type)));
		if (issaideclar(GC_PUSHS(type))) 
			{/* lookup the type */
			lasttype= cvstype(GC_PUSHS(type));
/*  # # DBUG('40000,"[FSM16].0.1 CVSTYPE()++ type='"&type&"'"&CRLF&
    " lastType='"&CVTYPES(lastType)&"'") */
			}/* lookup the type */
		else pdw_ptype(lasttype,codeinteger); /*no type*/
		}/* get the type */
	else 	{/* default as integer */
		pdw_ptype(lasttype,codeinteger);
		type= "integer";
		}/* default as integer */
/*  # # DBUG('40000,"[FSM16].1 type='"&type&"' rExpr='"&rExpr&"'"&CRLF&
    " lastType='"&CVTYPES(lastType)&"'") */

	pushnumber(lasttype); push(GC_PUSHS(type));
	rexpr= GC_EPOPS(r_d_expr_map(GC_PUSHS(rexpr))); 
                            /*  -- CVT ptr to integer! */
	addrtype= lasttype;
	lasttype= 0L; pdw_ptype(lasttype,codeinteger);
	rexpr= GC_EPOPS(cvactual_to_expected(lasttype,addrtype,
					     GC_PUSHS(rexpr)));
	pop(&type); popnumber(&lasttype);

	if (!chk_id(GC_PUSHS(rexpr))) s= catlist(3L,GC_PUSHS("(*("),
						 GC_PUSHS(rexpr),
						 GC_PUSHS("))"));
	else s= catlist(3L,GC_PUSHS("(*"),GC_PUSHS(rexpr),GC_PUSHS(")"));
                                             /*  -- Do NOT use extra 
						 (..) if ID */

	ptypel= (((ps_itrash_= (lasttype&037))>0)
		                    ? (ps_itrash_+0140L)
				    : 0L);
	if ((!slobflag) &&(!ismacroflag) &&
	           !(ptypel==codeinteger||ptypel==codereal)) 
		{/* trouble */
		s= catlist(4L,GC_PUSHS(s),GC_PUSHS("/* Illegal type="),
			   GC_PUSHS(type),
			   GC_PUSHS(" */"));
		err_warning(&s);
		pdw_ptype(lasttype,codeinteger);  /*  -- force it */
		}/* trouble */
/*  # # DBUG('40000,"[FSM16].2 s='"&s&"'"&CRLF&"  lastType='"&
    CVTYPES(lastType)&"'"&CRLF&"  pTypeL='"&(ps!sTrash!_pTypeL)&"'") */

	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'hn'=<L0> integer                             */
/* 'cn'=<L0> integer                             */
/* 'idx'=<L0> integer                            */
/*************************************************/

}/* FSM16 */
