/* FILE: fsm19.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmb.c, being converted 12/25/87, 06:01:03PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  -------------------------------------------------------- */
/*INTERNAL*/  STRING fsm19(h)
	INTEGER h;
{/* FSM19 */
INTEGER lcode, 
	rcode, 
	rtype, 
	idx, 
	isswapflag, 
	dotypechk;
STRING s, 
	s1, 
	opr, 
	rexpr, 
	lexpr;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,19L))= (*aChkI(cntfsms,1L,19L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(11L,GC_PUSHS("[FSM19] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h),GC_PUSHS(" cStatement=\'")
        ,GC_PUSHS(cstatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" lastType=\'"),cvtypes(lasttype),GC_PUSHS("\'"))));
/*[19] BINOP*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM 19>]
.INDEX ++PSAIL PROCEDURE: FSM 19
	Map SAIL:	 'a BINOP b'
	to C:		 'declCsym[h](a,b)'.
	If Not LEAP '-' then do FSM14('-').
	Note: set oldToken to name of LEAP opr if exits
	Else to 'BINOP'
	NOTE: FSM35 will short circuit LEAP types and end up upon
	reeval of the '-' to here. Eg.
	<leap id> := <leap id> - <another leap id>
	NOTE: If the BINOP's declNargs[idx] is Geq 0 then do argument
	coercion when calling INFIX!TO!PREFIX().
.ENDLABEL [<++PSAIL PROCEDURE: FSM 19>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(opr); /* for G.C. */
	GC_NOTESTRING(rexpr); /* for G.C. */
	GC_NOTESTRING(lexpr); /* for G.C. */
	isswapflag= 0L;
	if ((h==hminus||h==hin) &&isleapcode(lasttype))
		{/* Check for SET or LIST <rValue> LEAP type */
/*  # # DBUG('40000,"[FSM19].1 oldToken='"&oldToken&"'"&CRLF&"  lastType='"&CVTYPES(lastType)&"'") */
		pushnumber(lasttype); pushnumber(h);
		s1= GC_EPOPS(rightexpr(&saistatement));
		oldtoken= (*aChkC(saisym,1L,h));	/*  -- in case need it */
		rexpr= GC_EPOPS(r_d_expr_map(GC_PUSHS(s1)));  /*  -- so we can TYPE it */
		rtype= lasttype;
		popnumber(&h); popnumber(&lasttype);
/*  # # DBUG('40000,"[FSM19].2 rExpr='"&rExpr&"'"&CRLF&"  rType='"&CVTYPES(rType)&"'") */
		lcode= (((ps_itrash_= (lasttype&037))>0) ? (ps_itrash_+0140L)
				:0L);
		rcode= (((ps_itrash_= (rtype&037))>0) ? (ps_itrash_+0140L)
				:0L);
		if (!((rcode==codeset) ||(rcode==codelist))) err_hlr(GC_PUSHS(
				
				        				catlist(GC_PUSHS("[FSM19] right expression \'"),
				        GC_PUSHS(rexpr),
				        GC_PUSHS("\' must be SET or LIST for \'"),GC_PUSHS(
				        *aChkC(saisym,1L,h)),GC_PUSHS("\' opr."))));
		if (h==hminus)
			{/* check minus */
			if ((lcode==codeset)) opr= "setDiff"; 
			else if (lcode==codelist) opr= "listDiff"; 
			else opr= "leapDiff";
			}/* check minus */
		else if (h==hin)
			{/* check IN opr */
			/*  -- NOTE: whether it is SET or LIST 
			  depends on the <rExpr> type */
			lasttype= 0L;
			pdw_ptype(lasttype,codeinteger);
			if ((rcode==codeset)) opr= "inSET"; 
			else if (rcode==codelist) opr= "inLIST"; 
			else opr= "inLEAP";  /*  -- default */
			}/* check IN opr */
		if (*ps__leap_!='\0') opr= catlist(2L,GC_PUSHS(opr),GC_PUSHS(ps__leap_));
		oldtoken= (*aChkC(saisym,1L,h));
		lexpr= GC_EPOPS(left_expr(&cstatement,1L));  /*  -- skip
						left comments */
		s= catlist(6L,GC_PUSHS(opr),GC_PUSHS("("),GC_PUSHS(lexpr),GC_PUSHS(","),
        GC_PUSHS(rexpr),GC_PUSHS(")"));
		if (isforeachflag) s= GC_EPOPS(chk_leap_optimize(GC_PUSHS(s),GC_PUSHS(lexpr),GC_PUSHS(rexpr),GC_PUSHS(PNULL)));
		}/* Check for SET or LIST <rValue> LEAP type */

	else if (h==hminus)
	 	{/* simple minus */
		s= GC_EPOPS(fsm14(h));	/*  -- Go eval there */
		}/* simple minus */

	else 	{/* hodge podge lodge */
/*  # # DBUG('40000,"[FSM19].3 saiToken='"&saiToken&"' saiSym[h]='"&saiSym[h]&"'"&CRLF&"  lastType='"&CVTYPES(lastType)&"'") */
		  /*  -- If SWAP then append C, D, F, I type */
		if (fast_equ(GC_PUSHS(saitoken),GC_PUSHS("swap")))
			{/* make GENERIC macro */
			isswapflag= 1L;
			lcode= (((ps_itrash_= (lasttype&037))>0) ? (ps_itrash_+0140L)
				:0L);
/*  # # DBUG('40000,"[FSM19].3.1 lCode='"&(ps!sTrash!_lCode)&"'") */
			if ((lcode==codestring) ||
			   isunaryscalartype(lasttype)) opr= catlist(2L,GC_PUSHS("SWAP"),cvupcase(makstr(lcode))); else {/* Not found */
			     opr= GC_EPOPS(simple_map(h));
			     err_warning(&opr);
			}/* Not found */
/*  # # DBUG('40000,"[FSM19].3.2 opr='"&opr&"'") */
			(*aChkI(declnargs,1L,(*aChkI(dwptr,1L,h))))= 2;  
					/*  -- force typechk */
			}/* make GENERIC macro */
		else opr= GC_EPOPS(simple_map(h));  /*  -- Do other oprs */
		if ((h==hunion||h==hinter)) 
			{/* LEAP */
			oldtoken= (*aChkC(saisym,1L,h));
			if (*ps__leap_!='\0') opr= catlist(2L,GC_PUSHS(opr),GC_PUSHS(ps__leap_));
			}/* LEAP */
		else oldtoken= "binop";
		/*  -- doTypeChk does the following type checking
			doTypeChk	function
			---------	---------
			0	   No type check done,
			+1	   Coerce arg2 to lastType,
				-1	   If arg2 Not then WARNING.
		 */
		dotypechk= (isswapflag) ? 
				
			  -1L: (((*aChkI(declnargs,1L,idx= (*aChkI(dwptr,1L,h))))>=0) &&(idx>0)) ? 
				
			  1L:0L;
		s= GC_EPOPS(infix_to_prefix(lasttype,GC_PUSHS(opr),GC_PUSHS(PNULL),dotypechk));
	 	}/* hodge podge lodge */
GC_EPOPS(dbug(040000L,catlist(7L,GC_PUSHS("[FSM19].4 s=\'"),GC_PUSHS(s),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS("  lastType=\'"),cvtypes(lasttype),
        GC_PUSHS("\'"))));
;
	GC_SRETURN(s)
}/* FSM19 */
