/* FILE: fsm2.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised December 29, 1987
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsma.c, being converted 12/25/87, 05:15:20PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  -------------------------------------------------------- */
/*INTERNAL*/  STRING fsm2(h)
	INTEGER h;
{/* FSM2 */
STRING s, 
	s1, 
	s2, 
	s3, 
	s4, 
	id, 
	expr;
INTEGER levelcaseblock, 
	n, 
	iscaseexprflag, 
	ch, 
	brk, 
	trash, 
	i,
	nelements, 
	atype, 
	typebyte, 
	typeinteger;


{/* INCFSM */
if (usecntfsmflag)
    (*aChkI(cntfsms,1L,2L))++;
}/* INCFSM */

GC_EPOPS(dbug(01040000L,catlist(6L,GC_PUSHS("[FSM2] \'rule\' NODE["),
				GC_PUSHS(*aChkC(saisym,1L,h)),
				GC_PUSHS("]="),prt_node(h),
				GC_PUSHS(" sPDLptr="),
				cvs(spdlptr))));
/*[2] CASE-statement*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM2>]
.INDEX ++PSAIL PROCEDURE: FSM2
	NOTE: This only handles CASE-statements.
		CASE-expressions are handled by FSM47 */
	/* Map SAI: CASE <expr> of
			Begin
			<statement 0>;
				...
			<statement i>;
			End;
	  To C:   switch (<exp>)
			{
			case <const expr 0>: <statement 0>;break;
				...
			case <const expr i>: <statement i>;break;
			}
.ENDLABEL [<++PSAIL PROCEDURE: FSM2>]
*/

/*  ----------------------------------------------- */
/* 	. . . .  GET INDEX VALUE OF CASE . . . .  */
/*  ----------------------------------------------- */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(s3); /* for G.C. */
GC_NOTESTRING(s4); /* for G.C. */
GC_NOTESTRING(id); /* for G.C. */
GC_NOTESTRING(expr); /* for G.C. */
midofexpr= 1L;
expr= GC_EPOPS(remove_white_ends(copy_omit(GC_PUSHS("of"))));
oldtoken= saitoken;
pushnumber(incaseflag);
pushnumber(lasttype); 

lasttype= 0L;
pdw_ptype(lasttype,codeinteger);       /*  -- aid EVAL */
typeinteger= typebyte;

pdw_ptype(typebyte,codebyte);	       /*  -- in case need it */

pushnumber(iscaseexprflag);
expr= GC_EPOPS(r_d_expr_map(GC_PUSHS(expr)));
popnumber(&iscaseexprflag);
atype= lasttype;		       /*  -- remember it */
popnumber(&lasttype);

map_be(&expr,&atype);                  /*  -- map to ((INTEGER)be)  */
s= catlist(2L,GC_PUSHS("switch "),GC_PUSHS(expr));
nelements= 0;		               /*  -- i.e. number of cases */

/*  ------------------------------------------------------------------ */
/* 	. . . .  TEST WHETHER CASE<statement> OR CASE<expr> . . . .  */
/*  ------------------------------------------------------------------ */
GC_EPOPS(map_ws_comments(&s,0L));      /*  -- Get upto '(' | 'BEGIN'  */
id= GC_EPOPS(get_token(&saistatement)); /*  -- get begin */
iscaseexprflag= 0L;
/*  # # DBUG('1040000,"[FSM2].1 id='"&id&"' expr='"&expr&
    "' blockLevel="&CVS(blockLevel)&CRLF&" s='"&s&"'"&CRLF&
    " saiStatement="&saiStatement) */
if (*id=='(')
  {/* CASE-expression */
   while ((*s!='\0') && iswhitespace((INTEGER)*s)) 
     ps_itrash_= LOP(s);
   iscaseexprflag= 1L;
   saistatement= catlist(3L,GC_PUSHS(expr),GC_PUSHS("```"),
			 GC_PUSHS(saistatement));    /*  -- backup */
   s= GC_EPOPS(fsm47(h)); 	     /*  -- Do CASE-expr */
   popnumber(&incaseflag);
   pop(&lastmappedtoken);            /*  -- trash old */
   lastmappedtoken= "CASE-expr";
   push(GC_PUSHS(lastmappedtoken));  /*  -- redefine it */
/* # # # DBUG('1040000,"[FSM2].1.1 After CASE-expr eval s="&s); */
   {GC_UNMARKSSTKFRAME;
    GC_SRETURN(s);}
   }/* CASE-expression */

/*  ------------------------------------------------- */
/* 	. . . .  EVALUATE CASE<statement>  . . . .  */
/*  ------------------------------------------------- */
if ((!iscaseexprflag) &&
    !fast_equ(GC_PUSHS(id),GC_PUSHS("begin")))
  err_hlr(GC_PUSHS("[FSM2] Missing \'BEGIN\' from CASE-statement"));

/*  ---------------------------------------------------------------- */
/* 	. . . . FORCE 'saiStatement' to have entire CASE-STATEMENT */
/*  ---------------------------------------------------------------- */
/* (added @V.46.5) when OPTIMIZING <case-statement>   */
if (iswhitespace((INTEGER)*saistatement))
   saistatement= catlist(2L,GC_PUSHS("begin"),GC_PUSHS(saistatement));
 else saistatement= catlist(2L,GC_PUSHS("begin "),
			    GC_PUSHS(saistatement)); /*  -- backup */
/*  # # DBUG('1040000,"[FSM2].1.2 BEFORE get entire <CASE-stmnt> time="&
    RUN!TIME&CRLF&" saiStatement='"&saiStatement&"'") */
s1= GC_EPOPS(rightstatement());	  /*  -- get the whole damn thing! */
if (*saistatement=='\0')
  saistatement= s1; 
else saistatement= catlist(2L,GC_PUSHS(s1),GC_PUSHS(saistatement));
                                  /*  -- put it in front! */
/*  # # DBUG('1040000,"[FSM2].1.2.1 AFTER get entire <CASE-stmnt> time="&
    RUN!TIME&CRLF&" saiStatement='"&saiStatement&"'") */
saitoken= id= GC_EPOPS(getid(&saistatement,&saibrk));
                                  /*  -- get 'begin' again */
s1= GC_EPOPS(fsm24(hbegin)); 	  /*  -- map 'begin'  */
s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s1));
/*  # # DBUG('1040000,"[FSM2].1.3 s1='"&s1&"' s='"&s&"'"&CRLF&
    "  saiStatement='"&saiStatement&"'") */
s1= PNULL;		          /*  -- in case G.C. later */
incaseflag= 1L;
levelcaseblock= blocklevel;       /*  -- save new level! */
n= 0;			          /*  -- case number generator */
push(GC_PUSHS(cstatement)); cstatement= PNULL;   /*  -- since build it
						     for each element */
push(GC_PUSHS(s)); s= PNULL;      /*  -- Save outer (0) string for
				  later to build KILLER string */

setformat(0L,0L);		  /*  -- No spaces with GENSYM #'s  */
do  {/* Process cases */
     midofexpr= 0L; 	/*  -- each element is statement */
 /*  # # DBUG('1040000,"[FSM2].2 blockLevel="&CVS(blockLevel)&" s="&s&CRLF&
     " saiStatement="&saiStatement) */
     GC_EPOPS(map_ws_comments(&s,0L));  /* -- WS, Comments, "..", Labels */
/*  # # DBUG('1040000,"[FSM2].3 sPDLptr="&CVS(sPDLptr)&" s='"&s&"'"&CRLF&
    " saiStatement='"&saiStatement&"'"&CRLF&
    " lastType='"&CVTYPES(lastType)&"'"&CRLF&" line='"&line&"'") */

     if (*saistatement=='[')
       while ((*saistatement=='['))
	 {/* use [n] label */
	   ch= LOP(saistatement);
	   s1= GC_EPOPS(scan(&saistatement,14L,&brk));  /*-- scan to ']' */
	   pushnumber(iscopy_toflag);
	   iscopy_toflag= 1L;
	   lasttype= typeinteger;       /*  -- must be Integer */
	   s1= GC_EPOPS(r_d_expr_map(GC_PUSHS(s1)));
	   if (!isdigit((INTEGER)*s1))
	     s1= GC_EPOPS(cvactual_to_expected(typebyte,lasttype,
					       GC_PUSHS(s1)));
/*  # # DBUG('1040000,"[FSM2].3.1 (BYTE) casted s1='"&s1&"'"&CRLF&
    " lastType='"&CVTYPES(lastType)&"'"&CRLF&" s='"&s&"'"&CRLF&
    " line='"&line&"'") */
	   popnumber(&iscopy_toflag);
	   s= catlist(4L,GC_PUSHS(s),GC_PUSHS("case "),GC_PUSHS(s1),
		      GC_PUSHS(": "));
	   GC_EPOPS(map_ws_comments(&s,0L));
         }/* use [n] label */
     else s= catlist(4L,GC_PUSHS(s),GC_PUSHS("case "),cvs(n--),
		     GC_PUSHS(": "));
 /*  # # DBUG('1040000,"[FSM2].4 blockLevel="&CVS(blockLevel)&" s1='"&s1&
     "' s='"&s&"'"&CRLF&" saiStatement='"&saiStatement&"'"&CRLF&
     " lastType='"&CVTYPES(lastType)&"'") */

     pushnumber(nelements);	        /*  -- in case recursive */
     firstiftoken= isifexpr= 0L;
     s3= GC_EPOPS(rightstatement());   	/*  -- from saiStatement */
/*  # # DBUG('1040000,"[FSM2].4.1 BEFORE EVAL expr time="&RUN!TIME&CRLF&
    "  s3='"&s3&"'"&CRLF&"  s='"&s&"'"&CRLF&
    " saiStatement='"&saiStatement&"'"&CRLF&" line='"&line&"'") */
     pushnumber(levelcaseblock);
     push(GC_PUSHS(s));
     s4= GC_EPOPS(r_d_expr_map(GC_PUSHS(s3)));
     pop(&s);
     popnumber(&levelcaseblock);
     popnumber(&nelements);
     s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s4));
 /*  # # DBUG('1040000,"[FSM2].5 AFTER EVAL expr time="&RUN!TIME&CRLF&
     " oldToken='"&oldToken&"' blockLevel="&CVS(blockLevel)&
     " s='"&s&"'"&CRLF&" saiStatement='"&saiStatement&"'"&CRLF&
     " line='"&line&"'") */
     if (blocklevel!=levelcaseblock) 
       {/* bad NEWS! */
	 err_hlr(GC_PUSHS(catlist(12L,
				  GC_PUSHS("[FSM2] Illegal CASE element \'"),
				  GC_PUSHS(s3),
				  GC_PUSHS("\'"),
				  GC_PUSHS(" Mapped to C \'"),GC_PUSHS(s4),
				  GC_PUSHS("\'"),GC_PUSHS(crlf),
				  GC_PUSHS(" Expected block level="),
				  cvs(levelcaseblock),
				  GC_PUSHS(crlf),
				  GC_PUSHS(" Actual block level="),
				  cvs(blocklevel))));
	 blocklevel= levelcaseblock;  /*  -- RECOVER?? */
       }/* bad NEWS! */

     ++nelements;
     if (fast_equ(GC_PUSHS(oldtoken),GC_PUSHS("end"))) 
       {/* fix up END w/o ';' */
	   s1= PNULL;
	   do  {/* Backup */
	        s1= catlist(2L,makstr(*(s+length(s)-1)),GC_PUSHS(s1));
		s= subst(GC_PUSHS(s),1L,length(s)-1L); 	/*  -- trash '}'*/
	       }/* Backup */
	   while (!(*s1=='}'||*s=='\0'));
/*  # # @V.56.142	INSERT!BEFORE!WHITE(s," break"&semiColon) */
/*  # # @V.56.163 -- NOTE causes double SEMICOLON!
 # # # @V.56.163   INSERT!BEFORE!WHITE(s,semiColon&" break"&semiColon) */
	   s4= (((*(s+length(s)-1))==';') ? " break;" : "; break;");
	   insert_before_white(&s,GC_PUSHS(s4));
	   s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s1));
 /*  # # DBUG('1040000,"[FSM2].5.1 oldToken='"&oldToken&
     "' s='"&s&"'"&CRLF&" nElements="&CVS(nElements)) */
         }/* fix up END w/o ';' */
     else insert_before_white(&s,GC_PUSHS(" break;"));
 /*  # # DBUG('1040000,"[FSM2].5.2 oldToken='"&oldToken&
     "' s='"&s&"'"&CRLF&" nElements="&CVS(nElements)) */
     
     push(GC_PUSHS(s)); s= PNULL;      /*  -- Save <nElements>'th case for
					   later to build the KILLER string! */
     if ((*saistatement=='\0') &&(!ismacroflag) &&
	 (rdlevel<1)) get_next_statement(); /*  -- more input? */
     GC_EPOPS(map_ws_comments(&s,0L));
     s2= saistatement;
     s1= GC_EPOPS(getid(&s2,&ch));     /*  -- look for the end! */
     /*  # # DBUG('1040000,"[FSM2].6 blockLevel="&CVS(blockLevel)&
	 " levelCaseBlock="&CVS(levelCaseBlock)&CRLF&
	 " nElements="&CVS(nElements)&" sPDLptr="&CVS(sPDLptr)&
	 " s='"&s&"'"&CRLF&"' s1='"&s1&"'"&CRLF&
	 " saiStatement='"&saiStatement&"'") */
   }/* Process cases */
while (!(*s1=='}'||*s=='\0'));

if ((levelcaseblock>blocklevel) ||
    !fast_equ(GC_PUSHS(s1),GC_PUSHS("end")) ||
    ((*saistatement=='\0') &&ismacroflag))
  err_hlr(GC_PUSHS(catlist(3L,
       GC_PUSHS("[FSM2] Illegal <case-statement> termination syntax \'"),
			   GC_PUSHS(s1),GC_PUSHS("\'"))));

if (fast_equ(GC_PUSHS(s1),GC_PUSHS("end"))) 
  {/* Flush END keyword */
      s1= saistatement= subst(GC_PUSHS(saistatement),4L,
			      length(saistatement));
				    /*  -- fix it  up here as well! */
      while ((*s1!='\0') &&iswhitespace((INTEGER)*s1))
	ps_itrash_= LOP(s1);        /*  -- test if end block label */
      if (*s1!=*quote &&
	  *((*aChkC(blkname,1L,blocklevel)))!='\0')
	(*aChkC(blkname,1L,blocklevel))= PNULL;  
				    /*  -- Ignore for POP!BLOCK!NAME
					testing purposes! This is
					because the quoted comment
					associated with the 0'th case
					statement was attached to
					the BEGIN block-label */
/*  # # DBUG('1040000,"[FSM2].7 saiStatement='"&saiStatement&"'"&CRLF&
    "  blkName[blockLevel="&CVS(blockLevel)&"]='"&blkName[blockLevel]&"'") */
      pushnumber(didblkexit);
      didblkexit= 1L;                /* -- inhibit MAK!BLK!EXIT since a
					CASE-end is not a legitimate 'END' */
      s= catlist(2L,GC_PUSHS(s),fsm25(hend)); /*  -- Flush END keyword */
      popnumber(&didblkexit);
    }/* Flush END keyword */
/*  # # DBUG('1040000,"[FSM2].7.1 blockLevel="&CVS(blockLevel)&
    " levelCaseBlock="&CVS(levelCaseBlock)&CRLF&
    " nElements="&CVS(nElements)&" sPDLptr="&CVS(sPDLptr)&
    " s='"&s&"'"&CRLF&CRLF&" s1='"&s1&"'"&CRLF&
    " saiStatement="&saiStatement&"'") */

for (i=0;i<=nelements;i++)
  {/* BUILD the KILLER string! */
    pop(&s1);
    s= catlist(2L,GC_PUSHS(s1),GC_PUSHS(s));
  }/* BUILD the KILLER string! */

pop(&cstatement);
popnumber(&incaseflag);
GC_EPOPS(dbug(01040000L,catlist(9L,GC_PUSHS("[FSM2].8 sPDLptr="),
				cvs(spdlptr),
				GC_PUSHS(" s=\'"),GC_PUSHS(s),
				GC_PUSHS("\'"),GC_PUSHS(crlf),
				GC_PUSHS(" saiStatement=\'"),
				GC_PUSHS(saistatement),
				GC_PUSHS("\'"))));
oldtypestatement= "case";
midofexpr= 0L;

GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'trash'=<L0> integer                          */
/*************************************************/

}/* FSM2 */
