/* FILE: fsm20.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmc.c, being converted 12/25/87, 06:54:53PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm20(h)
	INTEGER h;
{/* FSM20 */
INTEGER ch, 
	i, 
	atype, 
	lval, 
	rval, 
	thistype;
STRING s, 
	ws, 
	lexpr, 
	rexpr;
INTEGER ovfflag;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,20L))= (*aChkI(cntfsms,1L,20L))+1L;
		     }/* INCFSM */
GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM20] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[20] <LOGICAL oprs and test for >32-bits>*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM20>]
.INDEX ++PSAIL PROCEDURE: FSM20
	MAP SAIL:	a <shift-opr> b
	to C:		<mapped-shift-opr>(a,b)
	 	1) Check that <lvalue> and <rValue> are scalars
		else CVT to optimized octal integer value.
	2) Semantic check if number that it is <= 32-bits.
	   else DEATHWISH warning!
	3) Type of the EXPR is that of <lValue>.
.ENDLABEL [<++PSAIL PROCEDURE: FSM20>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(ws); /* for G.C. */
	GC_NOTESTRING(lexpr); /* for G.C. */
	GC_NOTESTRING(rexpr); /* for G.C. */
	s= GC_EPOPS(simple_map(h));
	ws= PNULL;
	map_whitespace(&ws);	/*  -- copy WS */
	thistype= 0;
	pdw_ptype(thistype,codeinteger);
	ovfflag= 0L;
	oldtoken= (*aChkC(saisym,1L,h));
	lexpr= GC_EPOPS(left_expr(&cstatement,1L)); /*  -- skip left
					comments */
	if (isdigit((INTEGER)*lexpr) &&!chk_32bit_integer(GC_PUSHS(lexpr))) ovfflag= 1L;  /*  -- check for overflow */

	if (!isunaryscalartype(lasttype)) 
		{/* sorry, wrong type */
		lexpr= GC_EPOPS(cvactual_to_expected(thistype,
					lasttype,GC_PUSHS(lexpr)));
		pdw_ptype(lasttype,codeinteger);
		}/* sorry, wrong type */

	push(GC_PUSHS(ws)); push(GC_PUSHS(s)); push(GC_PUSHS(lexpr)); pushnumber(lasttype);
	rexpr= GC_EPOPS(rightexpr(&saistatement));
	if (isdigit((INTEGER)*rexpr) &&!chk_32bit_integer(GC_PUSHS(rexpr))) ovfflag= 1L;  /*  -- check for overflow */
	pushnumber(ovfflag);
	rexpr= GC_EPOPS(r_d_expr_map(GC_PUSHS(rexpr)));
	atype= lasttype;
	popnumber(&ovfflag);
	popnumber(&lasttype); pop(&lexpr); pop(&s); pop(&ws);

	if ((((ps_itrash_= (lasttype&037))>0) ? (ps_itrash_+0140L)
				:0L)!=codeinteger) 
		rexpr= GC_EPOPS(cvactual_to_expected(thistype,
					atype,GC_PUSHS(rexpr)));
	if ((h==hland||h==hlor ||h==hxor)) 
		{/* Optimize of map to infix notation */
GC_EPOPS(dbug(040000L,catlist(5L,GC_PUSHS("[FSM20].1 lExpr=\'"),GC_PUSHS(lexpr),
        GC_PUSHS("\' rExpr=\'"),GC_PUSHS(rexpr),GC_PUSHS("\'"))));
		if (chk_iconst(GC_PUSHS(lexpr),&lval) &&
		   chk_iconst(GC_PUSHS(rexpr),&rval))
			{/* optimize the sucker */
GC_EPOPS(dbug(040000L,catlist(5L,GC_PUSHS("[FSM20].1.1 lVal="),cvs(lval),GC_PUSHS(" rVal="),
        cvs(rval),GC_PUSHS(""))));
			if (h==hland) i= (lval&rval); 
			else if (h==hlor) i= (lval|rval); 
			else if (h==hxor) i= (lval^rval);
			s= catlist(2L,GC_PUSHS("0"),cvos(i));  /*  -- OCTAL is nicer! */
			}/* optimize the sucker */
		else s= catlist(3L,GC_PUSHS(lexpr),GC_PUSHS(s),GC_PUSHS(rexpr));
GC_EPOPS(dbug(040000L,catlist(3L,GC_PUSHS("[FSM20].1.2 After Optimize s=\'"),GC_PUSHS(s),
        GC_PUSHS("\'"))));
		}/* Optimize of map to infix notation */
	else	{/* setup a call */
		lexpr= GC_EPOPS(cvactual_to_expected(lasttype,lasttype,
							GC_PUSHS(lexpr)));
		rexpr= GC_EPOPS(cvactual_to_expected(lasttype,lasttype,
							GC_PUSHS(rexpr)));
		s= catlist(6L,GC_PUSHS(s),GC_PUSHS("("),GC_PUSHS(lexpr),GC_PUSHS(","),
        GC_PUSHS(rexpr),GC_PUSHS(")"));
		}/* setup a call */
/*  # # @V.56.04	If ws Neq NULL
		Then s_ws & s */
	if (ovfflag &&!slobflag) 
		{/* error */
		s= catlist(2L,GC_PUSHS(s),GC_PUSHS(crlf));	/*  -- force new line */
		err_deathwish(&s,
	GC_PUSHS("WARNING! Logical operations > 32-bits are not portable"),
					5L,(INTEGER)('N'/*WARNING*/));
		}/* error */
/*  # # DBUG('40000,"[FSM20].2 s='"&s&"'") */
;
	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'ch'=<L0> integer                             */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/


}/* FSM20 */
