/* FILE: fsm22.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmc.c, being converted 12/25/87, 06:54:53PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm22(h)
	INTEGER h;
{/* FSM22 */
STRING s, 
	s1, 
	s2, 
	s3, 
	s4, 
	valist, 
	wspreface, 
	wspace1, 
	wspace2,
	oldwspreface, 
	expectedtypestatement;
INTEGER ch, 
	i, 
	j, 
	m, 
	n, 
	idc, 
	idh, 
	typearray, 
	typedata;
#define hdrspace 10	/*  -- @V.43.10 extra space in the <sairun.c>
		  array headers which must be changed HERE if it
		  is ever changed in <sairun.c> */

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,22L))= (*aChkI(cntfsms,1L,22L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM22] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[22] PRELOAD!WITH*/
/*
.LABEL [<++PSAIL PROCEDURE: FSM22>]
.INDEX ++PSAIL PROCEDURE: FSM22
	 Map SAI: PRELOAD!WITH n1,n2,...,nk; DECL abc[1:k];
	or	 Map SAI: PRESET!WITH n1,n2,...,nk; DECL abc[1:k];
	 to    C: DECL abc[k+1] = { 0,n1,n2,...,nk };

	It also handle preload count fields eg.
	SAIL:	...1, 2, [3]123, 4, ...
	to
	C:	...1, 2, 123, 123, 123, 4, ...
	NOTE: it is non-portable to have a PRELOADED global array at
	block level 1 in a NON-MAIN module (file) - issue a
	trash-graphic warning if (/CHECKARRAY) dynamic arrays.
.ENDLABEL [<++PSAIL PROCEDURE: FSM22>]
*/
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(s2); /* for G.C. */
	GC_NOTESTRING(s3); /* for G.C. */
	GC_NOTESTRING(s4); /* for G.C. */
	GC_NOTESTRING(valist); /* for G.C. */
	GC_NOTESTRING(wspreface); /* for G.C. */
	GC_NOTESTRING(wspace1); /* for G.C. */
	GC_NOTESTRING(wspace2); /* for G.C. */
	GC_NOTESTRING(oldwspreface); /* for G.C. */
	GC_NOTESTRING(expectedtypestatement); /* for G.C. */
	midofexpr= 1L;
	GC_EPOPS(map_ws_comments(&wspace1,0L));  
				/*Scan for LEADING comment---;.
				Then map all comments in
				between to C comments back
				into saiStatement*/

/*  ------------------------------------------------------------------ */
/*  . . GET THE DATA LIST FOR EVALING AFTER EVAL ARRAY DECLARATION . . */
/*  ------------------------------------------------------------------ */
	s1= GC_EPOPS(rightstatement()); 	/*  -- No 'semiColon' at end of
					value list */
	valist= (((*(s1+length(s1)-1))==';') ? subst(GC_PUSHS(s1),1L,length(s1)-1L) 
		: s1);	/*  -- trash semicolon */
/*  # # DBUG('40000,"[FSM22].1 wSpace1='"&wSpace1&"'"&CRLF&" vaList='"&vaList&"'") */

/*  ------------------------------------------------------------- */
/*  . . . GET THE ARRAY DECLARATION WHICH FOLLOWS DATA LIST . . . */
/*  ------------------------------------------------------------- */
	if ((*saistatement=='\0') &&(!ismacroflag) &&
	   (rdlevel<1)	/*   # # @V.56.158 -- why this test????  */) get_next_statement(); /*  -- i.e. get the 
					   declaration */
	while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
	GC_EPOPS(map_ws_comments(&wspace2,0L));
	set_preface(&oldwspreface);
	wspreface= oldwspreface;
	while (*wspace1==*space||*wspace1==*tab) 
		wspreface= catlist(2L,GC_PUSHS(wspreface),GC_PUSHS(LOP(wspace1)));  /*  -- put the
				white space before the data
				with the WS for JUSTIFYing */
	if (equ(GC_PUSHS(wspreface),GC_PUSHS(crlf))) wspreface= catlist(2L,GC_PUSHS(wspreface),GC_PUSHS("   "));  /*  -- indent */
/*  # # DBUG('40000,"[FSM22].2 wSpace1='"&wSpace1&"'"&CRLF&" wSpace2='"&wSpace2&"'"&CRLF&" wsPreface='"&wsPreface&"'") */

/*  -------------------------------------- */
/*  . . . EVAL THE ARRAY DECLARATION . . . */
/*  -------------------------------------- */
	oldtoken= "preload_with";  /*  -- Map PRESET to PRELOAD */
	s1= GC_EPOPS(copy_omit(GC_PUSHS(semicolon)));   /*  -- Get entire declaration */
	pushnumber(ispreload_withflag); ispreload_withflag= 1L;
	midofexpr= 0L;	/*  -- now allow quoted comments */
	pushnumber(usecoerceflag); usecoerceflag= 0L;
	lasttype= 0L;
	s1= GC_EPOPS(r_d_expr_map(GC_PUSHS(s1)));   /*  -- Recursively EVAL declar.
				BEFORE tacking on the preload
				data in a =begin...data...end
				block. NOTE: do not map
					"c" to 'c' ... */
	expectedtypestatement= oldtypestatement; /*  -- for test
					further on... */
/*  # # @V.56.107		typeArray_lastType */
/*  # # @V.56.129		typeArray_lastDeclaration */
		typearray= lasttype; /*  -- @V.56.130 Make up
				your mind already on how to
				pass the last declaration
				type passed from [FSM11]!!! */
		lasttype= 0L;	/*  -- set to 0 so don't screwup 
				the MAP!EXPR return */
			/*  -- THIS IS IT!!! - Use this
			  type when evaling data list! */
	popnumber(&usecoerceflag); popnumber(&ispreload_withflag);
/*  # # DBUG('40000,"[FSM22].2.1 lastAsize='"&lastAsize&"'"&CRLF&" s1='"&s1&"'"&CRLF&" oldTypeStatement='"&oldTypeStatement&"'"&CRLF&" oldArySpec='"&oldArySpec&"'"&CRLF&" typeArray='"&CVTYPES(typeArray)&"'") */

/*  ------------------------------------------------------------------- */
/*  . . EVAL THE DATA LIST GIVEN THE TYPE OF THE ARRAY DECLARATION . .  */
/*  ------------------------------------------------------------------- */
/*  -- COERCE data since the type of the data is specified by typeArray
declaration. We thus looked ahead to the declaration to get the type
and do checking and coercion using this information.
 */
	lasttype= typearray;	/*  -- TELL it what to expect! */
	pushnumber(usecoerceflag); usecoerceflag= 0L; 
	midofexpr= 1L;		/*  -- disallow quoted comments */
	oldtypestatement= "preload_with";    /*  -- Set so handle
						[]REPEAT counts */
	valist= GC_EPOPS(r_d_expr_map(GC_PUSHS(valist)));   /*  -- Eval <expr-list> */
		typedata= lasttype;
	popnumber(&usecoerceflag);

		/*  -- Build a '={ ,,,}' data list */
	insert_before_white(&valist, GC_PUSHS(" };"));

/*  # # DBUG('40000,"[FSM22].2.1.1 typeData='"&CVTYPES(typeData)&"'"&" vaList='"&vaList&"'") */

/*  -------------------------------------------------------------- */
/*  . . . GENERATE FULL C-STYLE DECLARATION WITH INITIALIZER . . . */
/*  -------------------------------------------------------------- */
	if (usechkflag)
		{/* /CHECK preload adjust HEADER */
	/*  -- NOTE: Generate:  
	<decl> P_<var>[HDRsize+aSize]={[HDRSize]0, vaList} 
	<decl> *<var>
	 and later <var>=aryHdr(P_<var>,...)
	 in [EMIT!LOC!CODE].
	 Where HDRsize is the same as that computed by arymk(). I.e.
	   (sizeof(INTEGER)/sizeof(declar)) * (3*n+hdrSpace) 
	- see <sairun.c>...
	! ! ! ! THIS IS <sairun.c> VERSION DEPENDENT ! ! ! ! 
	 NOTE: [FSM11] will change the id name to
	      P_<var>.
@V.56.02 Constant fold the array size if /FOLD is set.
	 */
		INTEGER i, 
		n, 
		ch;
		STRING hdrlist, 
		asize, 
		a, 
		b;
		GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
		GC_NOTESTRING(hdrlist); /* for G.C. */
		GC_NOTESTRING(asize); /* for G.C. */
		GC_NOTESTRING(a); /* for G.C. */
		GC_NOTESTRING(b); /* for G.C. */
		s4= subst(GC_PUSHS(oldaryspec),2L,length(oldaryspec));  /*  -- '#<var>,...'  */
		s3= GC_EPOPS(scan(&s4,8L,&i));  /*  -- scan <var> to ','  */
/*  # # DBUG('40000,"[FSM22].3 lastAsize='"&lastAsize&"'"&CRLF&" s1='"&s1&"'"&CRLF&" typeArray='"&CVTYPES(typeArray)&"'"&CRLF&" oldTypeStatement='"&oldTypeStatement&"'"&" s3='"&s3&"'"&CRLF&" oldArySpec='"&oldArySpec&"'") */
		if ((!equ(GC_PUSHS(expectedtypestatement),GC_PUSHS(
				"%%declaration")) ||
		    ((*aChkI(decldw,1L,find_symbol(GC_PUSHS(s3),&idc,&idh)))&0200L)==0)) err_hlr(GC_PUSHS(
	"[FSM22] Need ARRAY declaration after PRELOAD/PRESET"));

		oldtypestatement= "preload_with"; /*  -- Set it
					to final value */
		s3= s1;		/*  -- copy declaration P_<var> */
		/*  -- NOTE: [FSM11] inserts the last array spec
		  from its call to [FSM4a] in GLOBAL variable
		  'oldArySpec' and it has the form:
	#<varname>,nArgs,LB1,UB1,...,LBn,UBn,"varname",'type'
		We need nArgs (i.e. n here) in order to
		compute the amount of header space required.
		  */
/*  # # DBUG('40000,"[FSM22].3.1 oldArySpec='"&oldArySpec&"'") */
		s4= GC_EPOPS(scan(&oldaryspec,8L,&i));
				  /*  -- from FSM11-for ',' */
		s4= GC_EPOPS(scan(&oldaryspec,8L,&i));  /*  -- s STRING n */
		n= cvd(GC_PUSHS(s4));	/*  -- make a computable number */
/*  # # DBUG('40000,"[FSM22].3.2 n="&CVS(n)&CRLF&" typeArray='"&CVTYPES(typeArray)&"'") */
/*  -- NOTE: Assume all data types are same size as INTEGER except
STRING arrays. Possible problem with double arrays for some machines
which use 64-bits/double.
 */
		if ((((ps_itrash_= (typearray&037))>0) ? (ps_itrash_+0140L)
				:0L)==codestring) m= 
		2L; else m= 1;
/*  -- NOTE: @V.53.40 we need long (i.e. sizeof(INTEGER)) words for the
array header and thus will force at least the amount of space we need
since a 'char *' may have less bits than a 'long'. The aryHdr()
routine must check the sizeof() these two types and do the right
thing so that we return the pointer to the start of the data area.
The factor of 2 assumes that
	sizeof(long)/sizeof(char *) 
will ALWAYS BE <= 2. If not then we may have to allocate more space
by increasing the 2 to 3 or 4.
 */
/*  # # DBUG('40000,"[FSM22].3.3 factor m="&CVS(m)&CRLF&" typeArray='"&CVTYPES(typeArray)&"'"&CRLF&" lastType='"&CVTYPES(lastType)&"'") */
		hdrlist= "0,";	/*  -- do one here, so start at 2 */
		for (i=2;i<=(m*(3*n+10L));i++) 
				hdrlist= catlist(2L,GC_PUSHS(hdrlist),GC_PUSHS("0,"));
		asize= "1";
		for (i=1;i<=n;i++)
			{/* make size */
			/*  -- trash casts */
			GC_EPOPS(rmv_integer_cast(GC_PUSHS(oldaryspec)));
			a= GC_EPOPS(scan(&oldaryspec,8L,&ch));
			GC_EPOPS(rmv_integer_cast(GC_PUSHS(a)));
			GC_EPOPS(rmv_integer_cast(GC_PUSHS(oldaryspec)));
			b= GC_EPOPS(scan(&oldaryspec,8L,&ch));
			GC_EPOPS(rmv_integer_cast(GC_PUSHS(b)));
			if (*a=='-'||!chk_integer(GC_PUSHS(a))
			   &&!chk_id(GC_PUSHS(a))) a= catlist(3L,GC_PUSHS("("),GC_PUSHS(a),GC_PUSHS(")"));
			if (*b=='-'||!chk_integer(GC_PUSHS(b))
			   &&!chk_id(GC_PUSHS(b))) b= catlist(3L,GC_PUSHS("("),GC_PUSHS(b),GC_PUSHS(")"));
			asize= catlist(6L,GC_PUSHS(asize),GC_PUSHS("*("),GC_PUSHS(b),GC_PUSHS("-"),
        GC_PUSHS(a),GC_PUSHS("+1L)"));
			}/* make size */
		if (*asize=='1'&&equ(subsr(GC_PUSHS(asize),1L,2L),GC_PUSHS("1*"))) asize= subst(GC_PUSHS(asize),3L,length(asize));
/*  # # DBUG('40000,"[FSM22].3.4 aSize='"&aSize&"'"&CRLF&" s1='"&s1&"'") */
/*  # # @V.52.139 <BUG??>		If useFOLDINGflag
				Then aSize_FOLD!CONST!EXPR(aSize) */
		valist= catlist(3L,GC_PUSHS(hdrlist),GC_PUSHS(" "),GC_PUSHS(valist));
/*  # # DBUG('40000,"[FSM22].3.4.1 wsPreface='"&wsPreface&"'"&CRLF&" PRE-JUS vaList='"&vaList&"'") */
		valist= GC_EPOPS(justify_text(GC_PUSHS(wspreface),GC_PUSHS(wspreface),GC_PUSHS(valist)));
		valist= catlist(2L,GC_PUSHS(valist),GC_PUSHS(oldwspreface)); /*  -- at least
							CRLF */
/*  # # DBUG('40000,"[FSM22].3.4.2 vaList='"&vaList&"'") */
		/*  -- Remove the '*' in  s1's '*P_<id>'. Also
		     remove spaces after the <id> and remove 
		     the bounds comment */
		j= i= length(GC_PUSHS(s1))-1L;
		do 	{/* find limits */
			--i;
			if ((*(s1+i-1))==*space) j= i-1L;   /*  -- last space */
			}/* find limits */
		 while (!((i==1||equ(subsr(GC_PUSHS(s1),i,3L),GC_PUSHS("*P_")))));
/*  # # @V.54.70		s1_s1[1 to i-1] & s1[i+1 to inf] */  /*  -- del '*' */
/*  # # DBUG('40000,"[FSM22].3.5 i="&CVS(i)&" j="&CVS(j)&CRLF&" s1[1 to i-1]='"&s1[1 to i-1]&"'"&CRLF&" s1[i+1 to inf]='"&s1[i+1 to inf]&"'"&CRLF& " s1[i+1 to j]='"&s1[i+1 to j]&"'"&CRLF& " s1='"&s1&"'") */
		s1= catlist(2L,subst(GC_PUSHS(s1),1L,i-1L),subst(GC_PUSHS(s1),i+1L,j));  /*  -- del '*' */
		asize= catlist(3L,cvs(m*(3*n+10L)) ,GC_PUSHS("+"),GC_PUSHS(asize));
		s= catlist(5L,GC_PUSHS(s1),GC_PUSHS("["),GC_PUSHS(asize),GC_PUSHS(
        "] = { "),GC_PUSHS(valist));  /*  -- put
					preload AFTER declar. */
/*  # # DBUG('40000,"[FSM22].3.6 aSize='"&aSize&"'"&CRLF&" s='"&s&"'"&CRLF&" s1='"&s1&"'") */
		/*  -- Now make a copy of the declaration 
		  without the 'P_'  and remove the '*' in
		  s3 '*P_' */
		i= length(GC_PUSHS(s3))-1L;
		do {--i;} while (!((i==1||equ(subsr(GC_PUSHS(s3),i,3L),GC_PUSHS("*P_")))));
		s= catlist(5L,GC_PUSHS(s),subst(GC_PUSHS(s3),1L,i),subst(GC_PUSHS(s3),i+
        3L,length(s3)),GC_PUSHS(";"),GC_PUSHS(crlf));
/*  # # DBUG('40000,"[FSM22].3.7 s='"&s&"'"&CRLF&" s3='"&s3&"'") */
		{GC_UNMARKSSTKFRAME;}}/* /CHECK preload adjust HEADER */

	else	{/* /NOCHECK gen: '<declar>={...}' */
/*  # # DBUG('40000,"[FSM22].3.8 s1='"&s1&"'"&CRLF&" vaList='"&vaList&"'") */
		s= catlist(3L,GC_PUSHS(s1),GC_PUSHS(" = { "),GC_PUSHS(valist));   /*  -- put preload
						 AFTER */
/*  # # DBUG('40000,"[FSM22].3.8.1 s='"&s&"'") */
		}/* /NOCHECK gen: '<declar>={...}' */
/*  # # DBUG('40000,"[FSM22].4 wSpace1='"&wSpace1&"'"&CRLF&" wSpace2='"&wSpace2&"'"&CRLF&" vaList='"&vaList&"'") */

	if (*wspace1!='\0') valist= catlist(3L,GC_PUSHS(valist),GC_PUSHS(wspace1),GC_PUSHS(wspreface));
	if (*wspace2!='\0') valist= catlist(3L,GC_PUSHS(valist),GC_PUSHS(wspace2),GC_PUSHS(wspreface));
	midofexpr= 0L;	/*  -- finished with statement */
	if ((((ps_itrash_= (typedata&037))>0) ? (ps_itrash_+0140L)
				:0L)!=(((ps_itrash_= (typearray&037))>0) ? (ps_itrash_+0140L)
				:0L))
		{/* error */
		s= catlist(2L,GC_PUSHS(s),GC_PUSHS(crlf));
		err_deathwish(&s,
	  catlist(9L,GC_PUSHS("WARNING! Mismatch between"),GC_PUSHS(crlf),
        GC_PUSHS("PRELOAD data type=\'"),cvtypes(typedata),
        GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("ARRAY declaration type=\'"),cvtypes(typearray),
        GC_PUSHS("\'")),
					7L,(INTEGER)('N'/*WARNING*/));
		}/* error */
	if (notmainflag &&(blocklevel<=1) &&!slobflag)
		{/* error */
		s= catlist(2L,GC_PUSHS(s),GC_PUSHS(crlf));
		err_deathwish(&s,
catlist(3L,
        GC_PUSHS("WARNING! You can\'t use PRELOADed ARRAYs at block level 1 in")
        ,GC_PUSHS(crlf),GC_PUSHS("a non-main() module (i.e file)")),
					7L,(INTEGER)('N'/*WARNING*/));
		}/* error */

GC_EPOPS(dbug(040000L,catlist(5L,GC_PUSHS("[FSM22].5 preload!with"),GC_PUSHS(crlf),
        GC_PUSHS("s=\'"),GC_PUSHS(s),GC_PUSHS("\'"))));
	oldtypestatement= "%%declaration";
;
	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 's2'=<L0> string                              */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/



#undef hdrspace
}/* FSM22 */
