/* FILE: fsm23.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmc.c, being converted 12/25/87, 06:54:53PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm23(h)
	INTEGER h;
{/* FSM23 */
INTEGER ch, 
	brk, 
	dotypechk, 
	rval, 
	lval, 
	sign, 
	isleftconst,
	isrightconst;
STRING s, 
	oldsaistatement, 
	oldcstatement, 
	opr, 
	rexpr, 
	lexpr, 
	msg;
;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,23L))= (*aChkI(cntfsms,1L,23L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM23] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[23] <shift>-*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM23>]
.INDEX ++PSAIL PROCEDURE: FSM23
	MAP SAIL:	a LSH n
	Logical shifts may be performed two ways:
	a) If the shift n is a signed integer 
		then 	+ n:	LSH(a,n)
		Else 	- n:	RSH(a,n)
	   These LSH and RSH macros can map to the 
	   C 	<< 	and 	>>
	   respectively if the HASHLOGICALSHIFT <config.h>
	   parameter is set.
	b) If it is an variable, then we must call
	   a runtime to evaluate it since the shift direction
	   is not known.
	c) If a and n are INTEGER constants then do the eval
	   here to optimize it to octal integer value.
.ENDLABEL [<++PSAIL PROCEDURE: FSM23>]
 */
/*  # # DBUG('40000,"[FSM23].1 cStatement='"&cStatement&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(oldsaistatement); /* for G.C. */
	GC_NOTESTRING(oldcstatement); /* for G.C. */
	GC_NOTESTRING(opr); /* for G.C. */
	GC_NOTESTRING(rexpr); /* for G.C. */
	GC_NOTESTRING(lexpr); /* for G.C. */
	GC_NOTESTRING(msg); /* for G.C. */
	oldcstatement= cstatement;	/*  -- save in case
						needed when we DO NOT
					optimize */
	lexpr= GC_EPOPS(left_expr(&cstatement,1L)); /*  -- skip left
					comments */
	GC_EPOPS(remove_white_ends(GC_PUSHS(lexpr)));
	push(GC_PUSHS(lexpr));
	isleftconst= chk_iconst(GC_PUSHS(lexpr),&lval);
	pop(&lexpr);
/*  # # DBUG('40000,"[FSM23].1.1 lExpr='"&lExpr&"' lVal="&CVS(lVal)&" isLeftConst="&PBOOL(isLeftConst)&CRLF&" saiStatement='"&saiStatement&"'") */

	oldtoken= saitoken;	/*  -- SHIFT */
	while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
	sign= (INTEGER)*saistatement;	/*  -- sign character */
	if ((*saistatement=='-') ||(*saistatement=='+'))
		{/* shift right */
		opr= "RSH";
		ch= LOP(saistatement);   /*  -- Trash 'sign'  */
		}/* shift right */
	else opr= "LSH"; 		/*  -- shift left */

	oldsaistatement= saistatement;	/*  -- make a copy */
/*  # # DBUG('40000,"[FSM23].2.1.2 saiStatement='"&saiStatement&"'"&CRLF&" oldsaiStatement='"&oldsaiStatement&"'") */
	rexpr= GC_EPOPS(get_token(&saistatement));
/*  # # DBUG('40000,"[FSM23].2.1.3 rExpr='"&rExpr&"'"&CRLF&" oldSaiStatement='"&oldSaiStatement&"'") */
	if (*saistatement=='\0')
		{/* go try to optimize it */
		push(GC_PUSHS(oldsaistatement)); push(GC_PUSHS(opr));
		pushnumber(sign);
		push(GC_PUSHS(lexpr)); pushnumber(lval);
		pushnumber(isleftconst); push(GC_PUSHS(rexpr));
		isrightconst= chk_iconst(GC_PUSHS(rexpr),&rval);
					/*  -- get shift cnt */
/*  # # DBUG('40000,"[FSM23].2.1.4 rVal='"&CVS(rVal)&"' rExpr='"&rExpr&"' isRightConst="&PBOOL(isRightConst)) */
		pop(&rexpr); popnumber(&isleftconst);
		popnumber(&lval); pop(&lexpr);
		popnumber(&sign); pop(&opr);
		pop(&oldsaistatement);
		}/* go try to optimize it */
	else isrightconst= 0L;   /*  -- never... */
/*  # # DBUG('40000,"[FSM23].2 sign='"&(ps!sTrash!_sign)&"' rExpr='"&rExpr&"' rVal="&CVS(rVal)&CRLF&" lExpr='"&lExpr&"' lVal="&CVS(lVal)&CRLF&" isRightConst="&PBOOL(isRightConst)&" isLeftConst="&PBOOL(isLeftConst)&CRLF&" saiStatement='"&saiStatement&"'") */
/*  # # DBUG('40000,"[FSM23].2.1 saiStatement='"&saiStatement&"'"&CRLF&" oldSaiStatement='"&oldSaiStatement&"'") */
	if (isrightconst &&(ABS(rval)>32))
		{/* error */
		msg= crlf;	/*  -- force new line */
		err_deathwish(&msg,
			catlist(3L,GC_PUSHS("WARNING! Shift of \'"),cvs(rval),
        GC_PUSHS("\' > 32-bits is not portable")),
					5L,(INTEGER)('N'/*WARNING*/));
		}/* error */
	else msg= PNULL;

	if (isrightconst &&isleftconst)
		{/* Optimize and eval it here */
		ch= ((sign=='-') ? (RSH(lval,rval))
			: (LSH(lval,rval)));
		s= catlist(2L,GC_PUSHS("0"),cvos(ch));  /*  -- OCTAL is nicer! */
/*  # # DBUG('40000,"[FSM23].3 sign='"&(ps!sTrash!_sign)&"' s='"&s&"'"&CRLF&" lExpr='"&lExpr&"' lVal="&CVS(lVal)&CRLF&" rExpr='"&rExpr&"' rVal="&CVS(rVal)) */
		}/* Optimize and eval it here */

	else	{/* Not optimize */
		INTEGER targettype;
		/*  -- first restore cStatement and saiStatement */
		saistatement= oldsaistatement;
		cstatement= oldcstatement;
/*  # # DBUG('40000,"[FSM23].3.1 saiStatement='"&saiStatement&"'"&CRLF&" oldSaiStatement='"&oldSaiStatement&"'") */
		dotypechk= 1;	/*  -- coerce to INTEGER */
		targettype= 0;
		pdw_ptype(targettype,codeinteger);
		s= GC_EPOPS(infix_to_prefix(targettype,GC_PUSHS(opr),GC_PUSHS(PNULL),
					dotypechk));
		}/* Not optimize */
	if (*msg!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(msg));
	pdw_ptype(lasttype,codeinteger);
GC_EPOPS(dbug(040000L,catlist(3L,GC_PUSHS("[FSM23].4 s=\'"),GC_PUSHS(s),GC_PUSHS("\'"))));
;
	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'brk'=<L0> integer                            */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/


}/* FSM23 */
