/* FILE: fsm25.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmc.c, being converted 12/25/87, 06:54:53PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm25(h)
	INTEGER h;
{/* FSM25 */
STRING s, 
	s1, 
	blockname, 
	msg, 
	gcstuff, 
	errmsgs, 
	wspreface, 
	oldpname,
	genasymbol, 
	genbsymbol;
INTEGER ch, 
	lch, 
	i, 
	ssize, 
	dwindex, 
	startidx, 
	endidx, 
	oldptype;

/*   --
.LABEL [<++PSAIL PROCEDURE: FSM25>]
.INDEX ++PSAIL PROCEDURE: FSM25
	Upon exiting from a block, we must do the following:
	[1] Check if need to emit extra <semicolon> if missing.
	[2] If /GCcode then generate G.C. pointer UNMARKSTACKFRAME
	    macros.
	[3] If /CHECK and arrays were declared in the block then
	    generate deallocation function call for these arrays 
	    (i.e. to <sairun> function aryfree()).
	[4] If /PROFILE then generate profile exit macros.
	[5] POP block stack frame and decrement blockLevel.
	[6] If the block was a procedure body, then check that a
	    RETURN was specified if needed or was used if should not
	    have been.
	[7] If /UNIQUE then check for unique symbols declared in this
	    block.
	[8] Remove any symbols declared in this block from symtab
	    [NOTE: REM!SYMBOLS will check for unused symbols if
	     the /CLUTTER switch was set.].
	[9] If 'notMainFlag' was set (i.e. ENTRY module) do not emit
	    final '}' for outter block.
	[10] If blkBgensym[blockLevel] was not null, then emit that
	     block label BEFORE the '}'.
	[11] If blkAgensym[blockLevel] was not null, then emit that
	     block label AFTER the '}'.
.ENDLABEL [<++PSAIL PROCEDURE: FSM25>]
 */
;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,25L))= (*aChkI(cntfsms,1L,25L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(7L,GC_PUSHS("[FSM25] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h),
        GC_PUSHS(" oldTypeStatement=\'"),GC_PUSHS(oldtypestatement),
        GC_PUSHS("\'"))));
GC_EPOPS(dbug(040000L,catlist(15L,GC_PUSHS("[FSM25].0.1 blockLevel="),cvs(blocklevel),
        GC_PUSHS(" locSptr="),cvs(locsptr),GC_PUSHS(" locAptr="),
        cvs(locaptr),GC_PUSHS(crlf),GC_PUSHS("  firstLOCxct="),
        pbool(firstlocxct),GC_PUSHS(" didLOCemit="),
        pbool(didlocemit),GC_PUSHS(crlf),GC_PUSHS("  sEmit=\'"),
        GC_PUSHS(semit),GC_PUSHS("\'"))));
GC_EPOPS(dbug(040000L,catlist(12L,GC_PUSHS("[FSM25].0.2 lastProcedure=\'"),
        GC_PUSHS(lastprocedure),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  typeLastProcDecl=\'"),cvtypes(typelastprocdecl),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  dclSymPtr="),
        cvs(dclsymptr),GC_PUSHS(" dclLocStkFrame[blockLevel]="),
        cvs((*aChkI(dcllocstkframe,1L,blocklevel))))));
/*[25] END*/
/*  --------------------------------------------- */
/*  . . . TEST IF ADD AN EXTRA 'semiColon'  . . . */
/*  --------------------------------------------- */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(blockname); /* for G.C. */
	GC_NOTESTRING(msg); /* for G.C. */
	GC_NOTESTRING(gcstuff); /* for G.C. */
	GC_NOTESTRING(errmsgs); /* for G.C. */
	GC_NOTESTRING(wspreface); /* for G.C. */
	GC_NOTESTRING(oldpname); /* for G.C. */
	GC_NOTESTRING(genasymbol); /* for G.C. */
	GC_NOTESTRING(genbsymbol); /* for G.C. */
	lch= (INTEGER)'\0';
	for (i=length(GC_PUSHS(cstatement));i<=1;i--)
		{/* find non-W.S end of line */
		ch= (*(cstatement+i-1));
		if (iswhitespace(ch)) continue; /*  --  Not yet */
		lch= ch;
		break; 		/*  -- found it! */
		}/* find non-W.S end of line */

GC_EPOPS(dbug(040000L,catlist(11L,GC_PUSHS("[FSM25].0.3 lCh=\'"),GC_PUSHS(s1= GC_EPOPS(
        makstr(lch))),GC_PUSHS("\' isLastExecutableExpr="),
        pbool(islastexecutableexpr),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  oldTypeStatement=\'"),GC_PUSHS(oldtypestatement)
        ,GC_PUSHS("\' lastMappedToken=\'"),GC_PUSHS(lastmappedtoken)
        ,GC_PUSHS("\'"))));
	/*  -- test if insert 'semiColon' before END */
	if ((lch!='\0') &&(lch!=*semicolon) &&
	   (lch!='}') &&(lch!='/') &&
	   islastexecutableexpr) 
		{/* Insert 'semiColon' */
GC_EPOPS(dbug(040000L,catlist(9L,GC_PUSHS("[FSM25].1 lCh=\'"),
        GC_PUSHS(s1= GC_EPOPS(makstr(lch))),GC_PUSHS(
        "\' oldToken=\'"),GC_PUSHS(oldtoken),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS("  cStatement=\'"),
        GC_PUSHS(cstatement),GC_PUSHS("\'"))));
/*  # # @V.52.164		INSERT!BEFORE!WHITE(cStatement,semiColon) */
		s1= GC_EPOPS(fsm63(hsemicolon)); /*  -- Do what we do when
				   we do it with <SEMICOLON>!
				   NOTE: we do NOT insert <SC>
				   if the oldToken was 'end' */
		if (*cstatement=='\0') cstatement= s1; 
		else cstatement= catlist(2L,GC_PUSHS(cstatement),GC_PUSHS(s1));
GC_EPOPS(dbug(040000L,catlist(3L,GC_PUSHS("[FSM25].1.1 cStatement=\'"),GC_PUSHS(cstatement),
        GC_PUSHS("\'"))));
		}/* Insert 'semiColon' */

/*  # # @V.56.60		oldToken_"end" */
/*  # # @V.56.60  NOTE: Moved this to the END of [FSM25]  */
	if (!ismacroflag) 
	  (*aChkI(dcllocstkframe,1L,blocklevel))= prevdclsymptr= dclsymptr;
				/*  -- save for /Unique */
	if (blocklevel>0)
		{/* trash for e1,e2,e3 strings */
		(*aChkC(fore1list,1L,blocklevel))= (*aChkC(fore2list,1L,blocklevel))= (*aChkC(fore3list,1L,blocklevel))= PNULL;
		}/* trash for e1,e2,e3 strings */


/*  -------------------------------------------------------- */
/*  . . . EMIT ANY BLOCK TERMINATION CODE  */
/*  -------------------------------------------------------- */
GC_EPOPS(dbug(040000L,catlist(5L,GC_PUSHS("[FSM25].2.3 didBlkExit="),pbool(didblkexit),
        GC_PUSHS(" oldTypeStatement=\'"),GC_PUSHS(oldtypestatement),
        GC_PUSHS("\'"))));
gcstuff= ((!fast_equ(GC_PUSHS(oldtypestatement),GC_PUSHS("return"))) ? 
	GC_EPOPS(mak_blk_exit(blocklevel, blocklevel-1L, GC_PUSHS(PNULL))
	 ): PNULL);
GC_EPOPS(dbug(040000L,catlist(5L,GC_PUSHS("[FSM25].2.3.1 didBlkExit="),pbool(didblkexit),
        GC_PUSHS(" gcStuff=\'"),GC_PUSHS(gcstuff),GC_PUSHS("\'"))));

/*  ------------------------------------------------------------------ */
/*  . . . POP BLOCK STACK FRAME AND GENERATE BLOCK LABEL COMMENT . . . */
/*  ------------------------------------------------------------------ */
	oldpname= lastprocedure;  /*  -- save for /UNIQUE:n */
	oldptype= typelastprocdecl;  /*  -- save for did-RETURN-tests */
GC_EPOPS(dbug(040000L,catlist(7L,GC_PUSHS("[FSM25].2.3.2 blockLevel="),cvs(blocklevel),
        GC_PUSHS(crlf),GC_PUSHS(" dclSymPtr="),cvs(dclsymptr),
        GC_PUSHS(" dclLocStkFrame[blockLevel-1]="),
        cvs((*aChkI(dcllocstkframe,1L,MAX((blocklevel-1L),0L)))))));
	genasymbol= (*aChkC(blkagensym,1L,blocklevel));
	genbsymbol= (*aChkC(blkbgensym,1L,blocklevel));
GC_EPOPS(dbug(040000L,catlist(5L,GC_PUSHS("[FSM25].2.3.2.0 genBsymbol=\'"),
        GC_PUSHS(genbsymbol),GC_PUSHS("\' genAsymbol=\'"),
        GC_PUSHS(genasymbol),GC_PUSHS("\'"))));
	blockname= GC_EPOPS(pop_block_name()); /*  -- read the code since
				    -- there are lots of side 
				    -- effects */
GC_EPOPS(dbug(040000L,catlist(7L,GC_PUSHS("[FSM25].2.3.2.1 blockLevel="),cvs(blocklevel),
        GC_PUSHS(crlf),GC_PUSHS(" dclSymPtr="),cvs(dclsymptr),
        GC_PUSHS(" dclLocStkFrame[blockLevel-1]="),
        cvs((*aChkI(dcllocstkframe,1L,MAX((blocklevel-1L),0L)))))));

	if (TRUE /*  # # @V.54.61 (Not isMacroFlag)  */)
		{/* Set up to remove local symbols */
		/*  -- Remove local symbols defined in block */
		endidx= dclsymptr;
		dclsymptr= (*aChkI(dcllocstkframe,1L,blocklevel)); 
			/*  -- Restore declSymbol[] stack frame
			for local variables. */
			startidx= dclsymptr+1L;
GC_EPOPS(dbug(040000L,catlist(7L,GC_PUSHS("[FSM25].2.3.2.1.1 blockLevel="),cvs(blocklevel),
        GC_PUSHS(crlf),GC_PUSHS(" dclSymPtr="),cvs(dclsymptr),
        GC_PUSHS(" dclLocStkFrame[blockLevel-1]="),
        cvs((*aChkI(dcllocstkframe,1L,MAX((blocklevel-1L),0L)))))));
		}/* Set up to remove local symbols */
GC_EPOPS(dbug(040000L,catlist(7L,GC_PUSHS("[FSM25].2.3.2.2 blockLevel="),cvs(blocklevel),
        GC_PUSHS(crlf),GC_PUSHS(" dclSymPtr="),cvs(dclsymptr),
        GC_PUSHS(" dclLocStkFrame[blockLevel-1]="),
        cvs((*aChkI(dcllocstkframe,1L,MAX((blocklevel-1L),0L)))))));
	if (blocklevel<0)
		err_hlr(GC_PUSHS(
        		  catlist(GC_PUSHS(
        "[FSM25] More \'END\'s then \'BEGIN\'s for END  blockLevel=")
        ,cvs(blocklevel),GC_PUSHS(crlf),GC_PUSHS(" saiStatement="),
        GC_PUSHS(saistatement)))); 
	else if ((blocklevel>0) ||
		(!notmainflag &&blocklevel==0)) s= GC_EPOPS(simple_map(h)
	); else s= " "; 	/*  -- Note: don't need '}' for main()  */
GC_EPOPS(dbug(040000L,catlist(6L,GC_PUSHS("[FSM25].2.3.3 blockLevel="),cvs(blocklevel),
        GC_PUSHS(" s=\'"),GC_PUSHS(s),GC_PUSHS("\' notMainFlag="),
        pbool(notmainflag))));

	s= catlist(2L,GC_PUSHS(s),GC_PUSHS(blockname));
	if (*genbsymbol!='\0') s= catlist(3L,GC_PUSHS(genbsymbol),GC_PUSHS(": ;"),GC_PUSHS(s));  /*  -- BEFORE label.
					Note: K&R Section 9.12-9.13
					require <SC> after ':' before
					end block '}'  */
	if (*gcstuff!='\0') s= catlist(2L,GC_PUSHS(gcstuff),GC_PUSHS(s));   /*  -- BLOCK!EXIT code */
	if (*genasymbol!='\0') s= catlist(4L,GC_PUSHS(s),GC_PUSHS(crlf),GC_PUSHS(genasymbol),
        GC_PUSHS(": ")); /*  -- AFTER label */
GC_EPOPS(dbug(040000L,catlist(27L,GC_PUSHS("[FSM25].2.4 uniqFlag=\'"),pbool(uniqflag),
        GC_PUSHS(crlf),GC_PUSHS(" oldPname=\'"),GC_PUSHS(oldpname),
        GC_PUSHS("\' lastProcedure=\'"),GC_PUSHS(lastprocedure),
        GC_PUSHS("\'  oldLastProcedure=\'"),GC_PUSHS(
        oldlastprocedure),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" oldPtype=\'"),cvtypes(oldptype),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" typeLastProcDecl=\'"),
        cvtypes(typelastprocdecl),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  prevDclSymPtr="),cvs(prevdclsymptr),
        GC_PUSHS(" dclSymPtr="),cvs(dclsymptr),
        GC_PUSHS(" startIdx="),cvs(startidx),GC_PUSHS(" endIdx="),
        cvs(endidx))));

/*  ----------------------------------------------------------------- */
/*  . . . CHECK IF RETURNED VALUE CONSISTENT WITH TYPED PROCEDURE . . */
/*  ----------------------------------------------------------------- */
	if (uniqflag &&(!ismacroflag) &&
	   (prevdclsymptr>dclsymptr)) 
		{/* end of procedure definition */
		douniquetest= 1L;   /*  -- for each procedure! */
		if ((*ps_warning_!='\0') &&!slobflag &&
/*   # # @V.52.99		   (blockLevel Leq 1) And
# # # @V.52.99		   (oldLastProcedure Neq "<")
# # # @V.42.99	 */
		   !fast_equ(GC_PUSHS(oldpname),GC_PUSHS(lastprocedure)))
			{/* check it */
		   	if (((((ps_itrash_= (oldptype&037))>0) ? (ps_itrash_+0140L)
				:0L)!=codevoid) &&
			   (!sawreturnflag)) 
				{dwindex= 2;
				msg= 
        				catlist(GC_PUSHS(
        "/* WARNING! Never used \'RETURN()\' in typed PROCEDURE \'")
        ,GC_PUSHS(oldpname),GC_PUSHS("\'! */"));}else if ((((ps_itrash_= (oldptype&037))>0) ? (ps_itrash_+0140L)
				:0L)!=codevoid&&
/*   # # @V.56.60		        Not FAST!EQU(oldTypeStatement,
# # # @V.56.60						"return")  */
			        !fast_equ(GC_PUSHS(oldtoken),GC_PUSHS("return"))) 
				{dwindex= 6;
				msg= 
        				catlist(GC_PUSHS(
        "/* WARNING! Last statement Neq \'RETURN()\' in typed PROCEDURE \'")
        ,GC_PUSHS(oldpname),GC_PUSHS("\'! */"));}else msg= PNULL;
			if (*msg!='\0') err_deathwish(&s,GC_PUSHS(msg),dwindex,0L);
			}/* check it */
		}/* end of procedure definition */

/*  ----------------------------------------------------------------- */
/*  . . . If /UNIQUE THEN CHECK FOR UNIQUE SYMBOLS DECLARED IN BLOCK  */
/*  ----------------------------------------------------------------- */
	if (douniquetest)
		{/* do /UNIQUE symbol test */
		push(GC_PUSHS(lastprocedure)); lastprocedure= oldpname;
		s1= GC_EPOPS(uniqdeclarations(uniqwidth));
		pop(&lastprocedure);
		uniqstuff= ((*uniqstuff=='\0') ? s1 : catlist(2L,GC_PUSHS(uniqstuff),GC_PUSHS(s1)));
		}/* do /UNIQUE symbol test */

/*  ---------------------------------------------------- */
/*  . . . REMOVE ANY SYMBOLS DECLARED IN THE BLOCK . . . */
/*  ---------------------------------------------------- */
	errmsgs= PNULL;
/*  -- NOTE: @V.55.18 don't bother cleaning up symbols at the very end
of the program!
@V.56.04 HOWEVER... if we don't check it then we can not find global
clutter. So modified it to only REM!SYMBOLS at global level if
/CLUTTER.
 */
	if ((startidx<=endidx) &&
	   ((blocklevel>0) ||useclutterflag)) errmsgs= GC_EPOPS(rem_symbols(startidx,endidx));
			/*  -- NOTE: @V.53.84 If there were any
				#define ... type symbols defined
				in this block, them REM!SYMBOLS
				will generate #undef ... for 
					each of them which is returned
				in errMsgs */

GC_EPOPS(dbug(040000L,catlist(27L,GC_PUSHS("[FSM25].3 blockLevel="),cvs(blocklevel),
        GC_PUSHS(" prevDclSymPtr="),cvs(prevdclsymptr),
        GC_PUSHS(" oldTypeStatement=\'"),GC_PUSHS(oldtypestatement),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" dclSymPtr="),
        cvs(dclsymptr),GC_PUSHS(" isMacroFlag="),pbool(ismacroflag),
        GC_PUSHS(" doUniqueTest="),pbool(douniquetest),
        GC_PUSHS(crlf),GC_PUSHS(" typeLastProcDecl=\'"),
        cvtypes(typelastprocdecl),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" locSptr="),cvs(locsptr),GC_PUSHS(" locAptr="),
        cvs(locaptr),GC_PUSHS(crlf),GC_PUSHS(" s=\'"),GC_PUSHS(s),
        GC_PUSHS("\'"))));
	oldtypestatement= "end";
	if (*errmsgs!='\0') s= catlist(2L,GC_PUSHS(errmsgs),GC_PUSHS(s));
	if (blocklevel==0) lineoneflag= -1L;  /*  -- i.e. logical EOF...
					which is checked in
					CVT!SAIL!TO!C to
					ignore input after this */
		oldtoken= "end";		/*  -- added @V.56.60 */
GC_EPOPS(dbug(040040L,catlist(22L,GC_PUSHS("[FSM25].4 sPDLptr="),cvs(spdlptr),
        GC_PUSHS(" midOfExpr="),pbool(midofexpr),
        GC_PUSHS(" lineOneFlag="),cvs(lineoneflag),GC_PUSHS(crlf),
        GC_PUSHS(" s=\'"),GC_PUSHS(s),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" sEmit=\'"),GC_PUSHS(semit),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS("  lastProcedure=\'"),
        GC_PUSHS(lastprocedure),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" typeLastProcDecl=\'"),cvtypes(typelastprocdecl),
        GC_PUSHS("\'"))));

;
	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'ssize'=<L0> integer                          */
/* 'wspreface'=<L0> string                       */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/


}/* FSM25 */
