/* FILE: fsm26.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmc.c, being converted 12/25/87, 06:54:53PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm26(h)
	INTEGER h;
{/* FSM26 */
STRING s, 
	s1, 
	s2, 
	id, 
	postfix, 
	rexpr, 
	brkstr;
INTEGER ch, 
	atype, 
	acode, 
	etype, 
	idx;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,26L))= (*aChkI(cntfsms,1L,26L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM26] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[26] <Reference fn>(-)*/
/*  -- 
.LABEL [<++PSAIL PROCEDURE: FSM26>]
.INDEX ++PSAIL PROCEDURE: FSM26
++++ MAY BE UNUSED ++++
	Map SAIL functions with several interpretations ie 
	which are generic which require special interpretations
	as well as by value or reference.
	This includes LOP(-), COP(-), LENGTH(-).
	Map SAIL:	aaa(v1,v2,...) 
	to C:	 	aaa(&v1,v2,...)
	except if the arg is a string.
	except in the case of length() which is not reference
	but
		length(s) - if s is STRING
			and length(GC_PUSHS(x)) if /GCCODE
		lenSET(s) - if s is SET
		lenLIST(s) - if s is LIST
		lenITEM(s) - if s is ITEM
	Also test if the variable is a SET or LIST variable in
	which case append it a SET or LIST prefix to the
	operator. If the operators is 'length' then change it
	to 'lenSET and 'lenLIST'
	NOTE: these are really generic procedures.
	NOTE: If the function is LENGTH(<string constant>) then return
	the integer value string.
.ENDLABEL [<++PSAIL PROCEDURE: FSM26>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(s2); /* for G.C. */
	GC_NOTESTRING(id); /* for G.C. */
	GC_NOTESTRING(postfix); /* for G.C. */
	GC_NOTESTRING(rexpr); /* for G.C. */
	GC_NOTESTRING(brkstr); /* for G.C. */
	oldtoken= saitoken;	/*  -- FCT(REF) */
	s= GC_EPOPS(simple_map(h));
	while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
	if (*saistatement=='(') ch= LOP(saistatement); 
	else err_hlr(catlist(3L,GC_PUSHS("[FSM26] No \'(\' seen after function \'"),
        GC_PUSHS(oldtoken),GC_PUSHS("\'")));
/*  # # DBUG('40000,"[FSM26].1 s='"&s&"' saiStatement='"&s&"'") */
	s1= rexpr= GC_EPOPS(copy_either(GC_PUSHS(")"),&brkstr));
	pushnumber(h); push(GC_PUSHS(s));
	rexpr= GC_EPOPS(r_d_expr_map(GC_PUSHS(rexpr)));
	pop(&s); popnumber(&h);
	atype= lasttype;		/*  -- save it */

	lasttype= (*aChkI(decldw,1L,idx= (*aChkI(dwptr,1L,h))));
	s1= (*aChkC(declformal,1L,idx));     /*  -- get the 1st arg and cvt */
	s2= GC_EPOPS(scan(&s1,13L,&ch));	/*  -- break on ':' */
	etype= cvidw(GC_PUSHS(s2));   	/*  -- cvt packed to DW */
/*  # # DBUG('40000,"[FSM26].2 rExpr='"&rExpr&"'"&CRLF&"  aType='"&CVTYPES(aType)&"'"&CRLF&"  lastType='"&CVTYPES(lastType)&"'"&CRLF&" eType='"&CVTYPES(eType)&"'") */
	acode= (((ps_itrash_= (atype&037))>0) ? (ps_itrash_+0140L)
				:0L);
	if (acode==codeset) postfix= (catlist(2L,GC_PUSHS("SET"),GC_PUSHS(ps__leap_))); 
	else if (acode==codelist) postfix= (catlist(2L,GC_PUSHS("LIST"),GC_PUSHS(ps__leap_))); 
	else if (isleapcode(acode)) postfix= (catlist(2L,GC_PUSHS("ITEM"),GC_PUSHS(ps__leap_))); 
	else postfix= PNULL;
	if (isleapcode(acode)) pdw_ptype(etype,acode);  /*  -- force it */
GC_EPOPS(dbug(040000L,catlist(9L,GC_PUSHS("[FSM26].2.1 postfix=\'"),GC_PUSHS(postfix),
        GC_PUSHS("\' aCode=\'"),
        GC_PUSHS(ps_strash_= GC_EPOPS(makstr(acode))),GC_PUSHS("\'")
        ,GC_PUSHS(crlf),GC_PUSHS(" NEW eType=\'"),cvtypes(etype),
        GC_PUSHS("\'"))));

	if (h==hlop&&(acode==codestring||isunaryscalartype(atype))) 
		{/* String LOP */
		s= "LOP";	/*  -- Use caps */
		acode= codestring;   /*  -- Force the type */
		pdw_ptype(atype,codestring);
		}/* String LOP */
	if (h==hlength)
		{/* shorten it so unique:6 chars */
		if (isleapcode(atype)) s= catlist(3L,GC_PUSHS("len"),GC_PUSHS(postfix),GC_PUSHS("(")); else s= catlist(2L,GC_PUSHS(s),GC_PUSHS("("));
		}/* shorten it so unique:6 chars */
	else if (h==hlop&&*postfix!='\0') s= catlist(3L,GC_PUSHS("lop"),GC_PUSHS(postfix),GC_PUSHS("(")); else if ((acode!=codestring) &&!isleapcode(atype)) s= catlist(2L,GC_PUSHS(s),GC_PUSHS("(&")); else s= catlist(2L,GC_PUSHS(s),GC_PUSHS("(")); 	/*  -- No reference for STRING */
GC_EPOPS(dbug(040000L,catlist(21L,GC_PUSHS("[FSM26].3 rExpr=\'"),GC_PUSHS(rexpr),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  aType=\'"),
        cvtypes(atype),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" eType=\'"),cvtypes(etype),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS("  postFix=\'"),GC_PUSHS(postfix),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" s=\'"),GC_PUSHS(s),
        GC_PUSHS("\' saiStatement=\'"),GC_PUSHS(s),GC_PUSHS("\'"))));

	if (atype!=etype) rexpr= GC_EPOPS(cvactual_to_expected(etype,atype,GC_PUSHS(rexpr)));
	if (h==hlength||(*s=='L'&&equ(subst(GC_PUSHS(s),1L,3L),GC_PUSHS("LOP")))) pdw_ptype(lasttype,codeinteger); 
	else if (isleapcode(atype)) pdw_ptype(lasttype,codeitem); 
	else lasttype= atype;
/*  # # DBUG('40000,"[FSM26].3.1 rExpr='"&rExpr&"'"&CRLF&" aType='"&CVTYPES(aType)&"'") */

	if ((((ps_itrash_= (atype&037))>0) ? (ps_itrash_+0140L)
				:0L)==codestring&&
	   chk_sconst(GC_PUSHS(rexpr),&s1,1L)) 
		{/* Do eval */
/*  # # DBUG('40000,"[FSM26].3.2 s1='"&s1&"'") */
		if (h==hlength) s= GC_EPOPS(cvs(length(GC_PUSHS(s1)))
		); else if (h==hlop) s= GC_EPOPS(cvs(LOP(s1)));
GC_EPOPS(dbug(040000L,catlist(7L,GC_PUSHS("[FSM26].3.2.1 s1=\'"),GC_PUSHS(s1),GC_PUSHS("\'")
        ,GC_PUSHS(crlf),GC_PUSHS(" s=\'"),GC_PUSHS(s),GC_PUSHS("\'"))));
			}/* Do eval */
	else	{/* Do a function call */
		if (usegcflag &&h==hlength &&acode==codestring) add_gc_pushs(&rexpr);
		s= catlist(3L,GC_PUSHS(s),GC_PUSHS(rexpr),GC_PUSHS(")"));
		}/* Do a function call */
	oldtypestatement= "procedure";
GC_EPOPS(dbug(040000L,catlist(5L,GC_PUSHS("[FSM26].4 s=\'&"),GC_PUSHS(s),
        GC_PUSHS("\' lastType=\'"),makstr(lasttype),GC_PUSHS("\'"))));
;
	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'id'=<L0> string                              */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/


}/* FSM26 */
