/* FILE: fsm27.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmc.c, being converted 12/25/87, 06:54:53PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm27(h)
	INTEGER h;
{/* FSM27 */
STRING s, 
	s1, 
	s2, 
	be, 
	thenstatement, 
	elsestatement, 
	brkstr;
INTEGER ch;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,27L))= (*aChkI(cntfsms,1L,27L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM27] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[27] IF-statement*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM27>]
.INDEX ++PSAIL PROCEDURE: FSM27
	Map SAIL:	If <be> Then <s1> Else <s2>
	To C:		if(<be>)<s1><SC> else<s2>

	NOTE: an 'else' following the 'then' of
	an IF...THEN...ELSE statement chain is bound to the
	preceeding THEN - not to previous THENs. See [REISER]
	SAIL manual page 16.
.ENDLABEL [<++PSAIL PROCEDURE: FSM27>]
 */

	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(s2); /* for G.C. */
	GC_NOTESTRING(be); /* for G.C. */
	GC_NOTESTRING(thenstatement); /* for G.C. */
	GC_NOTESTRING(elsestatement); /* for G.C. */
	GC_NOTESTRING(brkstr); /* for G.C. */
	oldtypestatement= oldtoken= "if";  /*  -- @V.46.4 */
	pushnumber(inifflag); inifflag= 1L;
	pushnumber(isifexpr); isifexpr= 0L;
	firstiftoken= 1L; 	/*  -- disable parser for an <if-expr> */
	pushnumber(midofexpr); midofexpr= 1L;
	s= GC_EPOPS(simple_map(h));
	if (iswhitespace((INTEGER)*saistatement)) s= catlist(2L,GC_PUSHS(s),GC_PUSHS(LOP(saistatement))); else s= catlist(2L,GC_PUSHS(s),GC_PUSHS(" "));   	/*  -- Must have white space */
	be= GC_EPOPS(copy_omit(GC_PUSHS("then")));
	if (*saistatement==*cr)
		{/* try to trash blank line */
		s2= be;
		s1= PNULL;
		while (*s2!='\0'&&
		   ((ch= (*(s2+length(s2)-1))==*tab) ||ch==*space))
			{/* backup 'be' */
			if (*s1=='\0') s1= GC_EPOPS(makstr(ch
			)); else s1= catlist(2L,GC_PUSHS(s1),makstr(ch));
			s2= subst(GC_PUSHS(s2),1L,length(s2)-1L);   /*  -- shorten */
			}/* backup 'be' */
		if (equ(subst(GC_PUSHS(s2),length(s2)-1L,length(s2)),GC_PUSHS(crlf))) be= subst(GC_PUSHS(s2),1L,length(s2)-2L); /*  -- shorten be */
		}/* try to trash blank line */
/*  # # DBUG('40000,"[FSM27].1 be='"&be&"' saiStatement='"&saiStatement&"'") */
	push(GC_PUSHS(s));
	while ((*be!='\0') &&iswhitespace((INTEGER)*be)) ps_itrash_= LOP(be); {/* TRASH!RIGHT!WS */
			while ((*be!='\0') &&
			      (ps_itrash_= (*(be+length(be)-1))) &&
			      iswhitespace(ps_itrash_)) 
						be= subst(GC_PUSHS(be),1L,length(be)-1L);
			}/* TRASH!RIGHT!WS */
	pdw_ptype(lasttype,codeinteger);     /*  -- type expected */
	be= GC_EPOPS(r_d_expr_map(GC_PUSHS(be)));
	map_be(&be,&lasttype);	/*  -- Map to ((INTEGER)(be))   */
/*  # # DBUG('40000,"[FSM27].1.1 be='"&be&"' lastType='"&CVTYPES(lastType)&"'") */
	pop(&s);
	s= catlist(2L,GC_PUSHS(s),GC_PUSHS(be));
	GC_EPOPS(map_ws_comments(&s,0L));

	thenstatement= GC_EPOPS(rightstatement());
/*  # # DBUG('40000,"[FSM27].2 thenStatement='"&thenStatement&CRLF&"' saiStatement='"&saiStatement&"'") */
	push(GC_PUSHS(s)); push(GC_PUSHS(brkstr));
	s1= GC_EPOPS(r_d_expr_map(GC_PUSHS(thenstatement)));
	pop(&brkstr); pop(&s);
	s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s1));
	GC_EPOPS(map_ws_comments(&s,0L));
/*  # # DBUG('40000,"[FSM27].2.3 s='"&s&"'"&CRLF&" saiStatement='"&saiStatement&"'"&CRLF&" oldTypeStatement="&oldTypeStatement) */

	if (fast_equ(GC_PUSHS(saistatement),GC_PUSHS("else")))
		{/* process the ELSE */
		saitoken= "else";
		push(GC_PUSHS(oldtypestatement)); push(GC_PUSHS(s));
		pushnumber(incaseflag); incaseflag= 0L;
		s1= GC_EPOPS(fsm30(helse));
		popnumber(&incaseflag);
		pop(&s); pop(&oldtypestatement);
		s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s1));
/*  # # DBUG('40000,"[FSM27].3 s='"&s&CRLF&"' saiStatement='"&saiStatement&"'") */
		}/* process the ELSE */

	popnumber(&midofexpr);
	popnumber(&isifexpr); popnumber(&inifflag);
	if (!fast_equ(GC_PUSHS(oldtypestatement),GC_PUSHS("return"))) 
            oldtypestatement= "if";     /*  -- for END [FSM25] chker */

	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'elsestatement'=<L0> string                   */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/


}/* FSM27 */
