/* FILE: fsm28.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmc.c, being converted 12/25/87, 06:54:53PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm28(h)
	INTEGER h;
{/* FSM28 */
INTEGER i, 
	n, 
	hs;
STRING s, 
	s1, 
	wspace, 
	id;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,28L))= (*aChkI(cntfsms,1L,28L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM28] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[28] GO(TO)*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM28>]
.INDEX ++PSAIL PROCEDURE: FSM28
	Check if really mean (GO,GO TO,GOTO) then 
	  map to GOTO
	If we attempt to GOTO a level 1 symbol from level 2 or
	greater (i.e. to the main()) then this is
	non-portable and we will flag it as such by issuing
	a DEATHWISH WARNING.
	In addition, if we are exiting a procedure where
	GC, dynamic storage or profiling was done, we need to
		also deallocate the BLOCK EXIT as well.
.ENDLABEL [<++PSAIL PROCEDURE: FSM28>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(wspace); /* for G.C. */
	GC_NOTESTRING(id); /* for G.C. */
	oldtoken= "goto";
	while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
	if (*saistatement=='t'&&equ(subst(GC_PUSHS(saistatement),1L,2L),GC_PUSHS("to")) &&
	   !isvariable((*(saistatement+3-1)))) saistatement= subst(GC_PUSHS(saistatement),3L,length(saistatement));
	while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
	s= "goto ";
	id= GC_EPOPS(get_token(&saistatement));	/*  -- get label */
	s= catlist(2L,GC_PUSHS(s),GC_PUSHS(id));
	i= find_symbol(GC_PUSHS(id),&n,&hs);		/*  -- lookup label */
	if (i==0) err_undf(&s,GC_PUSHS(id));
/*  # # DBUG('40000,"[FSM28].1 id="&id&" i="&CVS(i)&" lastProcedure="&lastProcedure&" declInProc[i]="&saiSym[declInProc[i]]) */
	if ((!slobflag) &&
	   (!equ(GC_PUSHS(lastprocedure),GC_PUSHS((*aChkC(saisym,1L,(*aChkI(declinproc,1L,i)))))))) 
		{/* NON-LOCAL goto */
		/*  -- Check for non-local jump to a higher level */
		s= catlist(2L,GC_PUSHS(s),GC_PUSHS(crlf));
		err_deathwish(&s,
	catlist(7L,GC_PUSHS("WARNING! Can\'t GOTO label \'"),GC_PUSHS(id),
        GC_PUSHS("\' which is not in \'"),GC_PUSHS(lastprocedure),
        GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("Try to recode the GOTO using setjmp()/longjmp().")),
					 9L, (INTEGER)('N'/*WARNING*/));
		}/* NON-LOCAL goto */

	else	{/* Emit block exit stuff if needed */
		s= GC_EPOPS(mak_blk_exit(blocklevel,(*aChkI(declblklvl,1L,i)),GC_PUSHS(s)));
/*  # # DBUG('40000,"[FSM28].1 didBlkExit="&PBOOL(didBlkExit)&" s='"&s&"'") */
		didblkexit= 0L;	/*  -- reset it */
		}/* Emit block exit stuff if needed */

	oldtypestatement= "goto";
	isemitgcflag= !ismacroflag;	/*  -- enable for GC code 
					   generation */
;
/*  # # DBUG('40000,"[FSM28].2 didBlkExit="&PBOOL(didBlkExit)&" s='"&s&"'") */
	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'wspace'=<L0> string                          */
/* 's1'=<L0> string                              */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/


}/* FSM28 */
