/* FILE: fsm3.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsma.c, being converted 12/25/87, 05:15:20PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  -------------------------------------------------------- */
/*INTERNAL*/  STRING fsm3(h)
	INTEGER h;
{/* FSM3 */
STRING s, 
	id, 
	e1, 
	e2, 
	e3, 
	s1, 
	s2, 
	s3, 
	s4, 
	brkstr, 
	e1list;
INTEGER signe2, 
	signe3, 
	ch, 
	iswhileterminator;

;
{/* INCFSM */ if (usecntfsmflag)
   (*aChkI(cntfsms,1L,3L))++;
}/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM3] \'rule\' NODE["),
			      GC_PUSHS(*aChkC(saisym,1L,h)),
			      GC_PUSHS("]="),prt_node(h))));
/*[3] FOR*/
/*
.LABEL [<++PSAIL PROCEDURE: FSM3>]
.INDEX ++PSAIL PROCEDURE: FSM3
	Map SAIL: For id_e1 Step e2 Until e3 Do
	to  C: 	  for (id=e1;id<=(e3);id=id+(e2)) 

	and	Map SAIL: For id_e1 Step e2 While e3 Do
	to  C: 	  for (id=e1;(e3);id=id+(e2)) 

	NOTE: We also currently map SAIL <for-list>'s eg.
		For i:=x1,x2,...,xn Do <s1>;
	{INTEGER ii;	      will be unique name * /
	 INTEGER iVal[n+1];  will be unique name * /
	 iVal[1]=x1;
	 iVal[2]=x2;
	   ...
	 iVal[n]=xn;
	 for (ii=1,i=iVal[ii]; ii<=n; ii++,i=iVal[ii]) <s1>;
	}
	To:  
		...
	     {i=n,<s>}

	Map MAINSAIL: For id_e1 Upto e3 Do
			then let e2=+1
	Map MAINSAIL: For id_e1 Downto e3 Do
			then let e2=-1
.ENDLABEL [<++PSAIL PROCEDURE: FSM3>]
*/

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(id); /* for G.C. */
GC_NOTESTRING(e1); /* for G.C. */
GC_NOTESTRING(e2); /* for G.C. */
GC_NOTESTRING(e3); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(s3); /* for G.C. */
GC_NOTESTRING(s4); /* for G.C. */
GC_NOTESTRING(brkstr); /* for G.C. */
GC_NOTESTRING(e1list); /* for G.C. */
oldtoken= saitoken;
pushnumber(midofexpr); midofexpr= TRUE;
push(GC_PUSHS(e1list));
e1list= PNULL;
while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement))
   ps_itrash_= LOP(saistatement);

/*  -------------------------------------------------------- */
/* 	. . . . .  GET id: <FOR id:=e1 ... DO> . . . . . . */
/*  -------------------------------------------------------- */
id= GC_EPOPS(getid(&saistatement,&saibrk));
push(GC_PUSHS(id));	/*  -- in case e1List exists */
while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement))
   ps_itrash_= LOP(saistatement);
if (iswhitespace(saibrk))
   saibrk= LOP(saistatement);
if (!(saibrk==':'&&*saistatement=='=')) 
   err_hlr(GC_PUSHS("[FSM3] \'FOR\' statement has no \':=\' after id")); 
else ch= LOP(saistatement);          /*  -- Get rid of := */
while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement))
   ps_itrash_= LOP(saistatement);

/*  --------------------------------------------------------------- */
/* 	. . . . .  GET e1: <FOR id:=e1 STEP ... DO> . . . . . . */
/*  ---------------------------------------------------------------- */
/*  # # DBUG('40000,"[FSM3].1 saistatement='"&saistatement&"'") */
if (TRUE ||(!mainsailflag)   /*   -- @V.58.01 for MAINSAIL */)
   {/* SAIL 'for' loop */
    brkstr= PNULL;
    s3= "@";
    do 	{/* get e1 */
	 if (*brkstr!='\0')
	   s3= catlist(2L,GC_PUSHS(s3),GC_PUSHS(brkstr));
	 s3= catlist(2L,GC_PUSHS(s3),
		     copy_either(GC_PUSHS(",step,until,while,do"),&brkstr));
        }/* get e1 */
    while (!((*brkstr!=',') ||(*saistatement=='\0')));
    ch= LOP(s3);			/*  -- trash prefix */
    e1= GC_EPOPS(remove_white_ends(GC_PUSHS(s3)));
/* # # DBUG('40000,"[FSM3].1.1 id='"&id&"' brkStr='"&brkStr&"' e1='"&e1&"'") */
    if (fast_equ(GC_PUSHS(brkstr),GC_PUSHS("do")) ||
	chk_expr_list(makstr((INTEGER)1.0E1))) 
      {/* handle expression list */
       e1list= e1;
       e1= id;  /*  -- i.e. dummy */
      }/* handle expression list */
    else {/* eval e1 */
	  push(GC_PUSHS(brkstr)); push(GC_PUSHS(id));
	  e1= GC_EPOPS(r_d_expr_map(GC_PUSHS(e1)));
	  pop(&id); pop(&brkstr);
         }/* eval e1 */

/*  ---------------------------------------------------- */
/* 	. . . . .  GET e2: <e2 UNTIL e3 DO> . . . . . . */
/*  ----------------------------------------------------- */
/*  # # DBUG('40000,"[FSM3].1.2 e1='"&e1&"' e1List='"&e1List&"'") */
    s3= "@";
    if (!fast_equ(GC_PUSHS(brkstr),GC_PUSHS("do")))
      {/* Get e2 */
       brkstr= PNULL;
       do {/* get e2 */
	   if (*brkstr!='\0')
	     s3= catlist(2L,GC_PUSHS(s3),GC_PUSHS(brkstr));
	   s3= catlist(2L,GC_PUSHS(s3),
		       copy_either(GC_PUSHS(",until,while,do"),&brkstr));
          }/* get e2 */
       while (!((*brkstr!=',') ||(*saistatement=='\0')));
       if (fast_equ(GC_PUSHS(brkstr),GC_PUSHS("while")))
	 iswhileterminator= 1L;
       else iswhileterminator= 0L;
      }/* Get e2 */
    ch= LOP(s3);		/*  -- trash prefix */
    e2= GC_EPOPS(remove_white_ends(GC_PUSHS(s3)));
/*  # # DBUG('40000,"[FSM3].2 brkStr='"&brkStr&"' e2='"&e2&
    "' isWhileTerm="&PBOOL(isWhileTerminator)) */
    signe2= '+';
    if (*e2=='-'&&(chk_id(subst(1.0E2,2L,length(1.0E2))) ||
		   chk_number(subst(1.0E2,2L,length(1.0E2)))))
      signe2= LOP(e2); /*  -- count backwards */;
    if ((*e2=='\0'&&*e1list=='\0') ||chk_expr_list(makstr((INTEGER)1.0E2))) 
      {/* handle expression list */
	  if (*e2!='\0')
	    e2= catlist(3L,GC_PUSHS("/* "),GC_PUSHS(e2),GC_PUSHS(" */"));
	  err_n_p(&e2);
      }/* handle expression list */
    else {/* eval e2 */
	  push(GC_PUSHS(brkstr)); push(GC_PUSHS(id)); push(GC_PUSHS(e1));
	  pushnumber(signe2);
	  s3= e2;
	  e2= GC_EPOPS(r_d_expr_map(GC_PUSHS(s3)));
	  popnumber(&signe2); 
	  pop(&e1); pop(&id); pop(&brkstr);
         }/* eval e2 */
   }/* SAIL 'for' loop */

else {/* MAINSAIL 'for' loop */
/* IFC EVAL(parsemainsail)=1 */
/* THENC */
 /* MESSAGE: " <Parsing MAINSAIL code>"  */;
      e1= GC_EPOPS(copy_either(GC_PUSHS("upto,downto"),&e2));
      e1= GC_EPOPS(remove_white_ends(GC_PUSHS(e1)));
      push(GC_PUSHS(id)); push(GC_PUSHS(e2));
      e1= GC_EPOPS(r_d_expr_map(GC_PUSHS(e1)));
      pop(&e2); pop(&id);

      if (fast_equ(GC_PUSHS(e2),GC_PUSHS("upto")))
        signe2= '+'; 
      else if (fast_equ(GC_PUSHS(e2),GC_PUSHS("downto")))
        signe2= '-'; 
      else err_hlr(GC_PUSHS("[FSM3] No UPTO or DOWNTO in \'for\'"));
      e2= "1"; 			/*  -- force step 1 */
   /* ENDC */
     }/* MAINSAIL 'for' loop */

/*  -------------------------------------------- */
/* 	. . . . .  GET e3: <e3 DO> . . . . . . */
/*  -------------------------------------------- */
/*  # # DBUG('40000,"[FSM3].2.1 e2='"&e2&"'"&CRLF&
    " saiStatement='"&saiStatement&"'") */
e3= PNULL;
if (!fast_equ(GC_PUSHS(brkstr),GC_PUSHS("do")))
  e3= GC_EPOPS(copy_either(GC_PUSHS("do"),&brkstr)); /*  -- get e3 */
while ((*e3!='\0') &&iswhitespace((INTEGER)1.0E3))
  ps_itrash_= LOP(e3);
while ((ch= (*(e3+length(e3)-1))) &&iswhitespace(ch))
   e3= subst(GC_PUSHS(e3),1L,length(e3)-1L);   /*  -- get ALL right WS */
/*  # # DBUG('40000,"[FSM3].3 e3='"&e3&"'"&CRLF&
    "  saiStatement='"&saiStatement&"'") */
signe3= '+';
if (*e3=='-'&&(chk_id(subst(1.0E3,2L,length(1.0E3))) ||
	       chk_number(subst(1.0E3,2L,length(1.0E3)))))
   signe3= LOP(e3);	/*  -- count backwards */;
if ((*e3=='\0'&&*e1list=='\0') ||chk_expr_list(makstr((INTEGER)1.0E3)))
   {/* handle expression list */
     if (*e3!='\0')
       e3= catlist(3L,GC_PUSHS("/* "),GC_PUSHS(e3),GC_PUSHS(" */"));
     err_n_p(&e3);
   }/* handle expression list */
else {/* eval e3 */
      push(GC_PUSHS(id)); push(GC_PUSHS(saistatement)); push(GC_PUSHS(e1));
      pushnumber(signe2); push(GC_PUSHS(e2));
      pushnumber(signe3);
      s3= e3;
      e3= GC_EPOPS(r_d_expr_map(GC_PUSHS(s3)));
      popnumber(&signe3); pop(&e2); popnumber(&signe2);
      pop(&e1); pop(&saistatement); pop(&id);
     }/* eval e3 */
/*  # # DBUG('40000,"[FSM3].3.1 e3='"&e3&"'") */

/*  ------------------------------------------------ */
/* 	. . . . .  BUILD C <for-loop>  . . . . . . */
/*  ------------------------------------------------ */
/*  # # DBUG('40000,"[FSM3].4 e1="&e1&" e2="&e2&" signe2="&signe2&
    " e3="&e3&" signe3="&signe3) */
fore1str= catlist(3L,GC_PUSHS(id),GC_PUSHS("="),GC_PUSHS(e1));
if (iswhileterminator)
   fore2str= catlist(3L,GC_PUSHS("("),GC_PUSHS(e3),GC_PUSHS(")"));
else fore2str= catlist(3L,GC_PUSHS(id),GC_PUSHS((signe3=='-') 
						? ">="
						: "<="),
		       GC_PUSHS((isdigit((INTEGER)*e3) ||
				 chk_id(makstr((INTEGER)1.0E3)))
				? e3
				: catlist(3L,GC_PUSHS("("),GC_PUSHS(e3),
					  GC_PUSHS(")"))));
if ((cvd(GC_PUSHS(e2))==1&&signe2=='+'))
   fore3str= catlist(2L,GC_PUSHS(id),GC_PUSHS("++"));
else if ((signe2=='-'&&cvd(makstr((INTEGER)1.0E2))==1))
   fore3str= catlist(2L,GC_PUSHS(id),GC_PUSHS("--"));
else fore3str= catlist(4L,GC_PUSHS(id),makstr(signe2),GC_PUSHS("="),
		       GC_PUSHS((isdigit((INTEGER)*e2) ||
				 chk_id(makstr((INTEGER)1.0E2)))
				? e2
				: catlist(3L,GC_PUSHS("("),GC_PUSHS(e2),
					  GC_PUSHS(")"))));

s= catlist(7L,GC_PUSHS("for ("),GC_PUSHS(fore1str),GC_PUSHS(";"),
	   GC_PUSHS(fore2str),GC_PUSHS(";"),GC_PUSHS(fore3str),
	   GC_PUSHS(")"));
/*  # # DBUG('40000,"[FSM3].5 id='"&id&"' forE1str="&forE1str&
    " forE2str="&forE2str&" forE3str="&forE3str&CRLF&
    " s='"&s&"'"&CRLF&" saiStatement='"&saiStatement&"'") */

/*  - - - - - - - - - - - - - - - - - - - - - - - - */
/*  	. . . EVAL 'do' <statement> . . .	 */
/*  - - - - - - - - - - - - - - - - - - - - - - - - */
GC_EPOPS(map_ws_comments(&s,0L));   /*  -- Eat up stuff just in case... */
s1= GC_EPOPS(rightstatement());
/*  # # DBUG('40000,"[FSM3].6 s='"&s&"' s1='"&s1&"'"&CRLF&
    " saiStatement='"&saiStatement&"'") */
if (*s1=='\0') 
   err_hlr(GC_PUSHS(
		    "[FSM3] Missing <statement> after DO in <for-loop>"));
pushnumber(sawstrfct); sawstrfct= 0L;
pushnumber(midofexpr); midofexpr= 0L;
push(GC_PUSHS(s)); push(GC_PUSHS(e1list));
push(GC_PUSHS(fore1str)); push(GC_PUSHS(fore2str)); push(GC_PUSHS(fore3str));
s1= GC_EPOPS(r_d_expr_map(GC_PUSHS(s1)));
pop(&fore3str); pop(&fore2str); pop(&fore1str);
/*  # # DBUG('40000,"[FSM3].6.1 s1='"&s1&"'"&CRLF&
    " saiStatement='"&saiStatement&"'") */
/*  # # DBUG('40000,"[FSM3].6.1.1 forE1str="&forE1str&
    " forE2str="&forE2str&" forE3str="&forE3str) */
pop(&e1list); pop(&s);
popnumber(&midofexpr);
/*  # # @V.53.59	If sawStrFct And useGCflag
 # # # @V.53.59		Then
 # # # @V.53.59		Begin "add GC marking stuff"
 # # # @V.53.59		s1_"{GC_SMARK" & semiColon & " " & s1 
*/
/*  # # @V.53.59     INSERT!BEFORE!WHITE(s1," GC_SUNMARK"&semiColon&"}") */
/*  # # @V.53.59		End "add GC marking stuff" */
s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s1));  /*  -- add <statement>  */
/*  # # DBUG('40000,"[FSM3].6.2 s='"&s&"'") */
popnumber(&sawstrfct);



/*  -------------------------------------- */
/*  . . . Handle e1List if it exists . . . */
/*  -------------------------------------- */
pop(&id); 	/*  -- in case EVAL e1 list */
if (*e1list!='\0')
   {/* eval the e1 list first */
     INTEGER n, 
             dwid, 
             idx, 
	     cid, 
	     hid, 
	     idptype;
     STRING ivalid, 
	     iid, 
	     wspreface;
     GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
     GC_NOTESTRING(ivalid); /* for G.C. */
     GC_NOTESTRING(iid); /* for G.C. */
     GC_NOTESTRING(wspreface); /* for G.C. */
     set_preface(&wspreface);
     if (*wspreface=='\0'&&(blocklevel>1)) 
       wspreface= subsr(GC_PUSHS(ps_spaces),1L,(blocklevel-1L)*8L);
     iid= id;			/*  -- gensym it */
     for (n=1;n<=6;n++)
       {/* make sure unique */
	   iid= catlist(2L,GC_PUSHS("i"),GC_PUSHS(iid)); /*  -- Pinochio */
	   idx= find_symbol(GC_PUSHS(iid),&cid,&hid);
	   if ((idx==0) ||((*aChkI(declblklvl,1L,idx))<blocklevel))
	     break;
       }/* make sure unique */
     ivalid= catlist(2L,GC_PUSHS("Val"),GC_PUSHS(id));	/*  -- gensym it */
     for (n=1;n<=6;n++)
       {/* make sure unique */
	   ivalid= catlist(2L,GC_PUSHS("i":E$^cd5
QSX
"),GC_PUSHS(ivalid)); /*  -- Pinochio */
			idx= find_symbol(GC_PUSHS(ivalid),&cid,&hid);
			if ((idx==0) ||
			   ((*aChkI(declblklvl,1L,idx))<blocklevel)) break;
			}/* make sure unique */
		dwid= (*aChkI(decldw,1L,find_symbol(GC_PUSHS(id),&cid,&hid)));
		idptype= (((ps_itrash_= (dwid&037))>0) ? (ps_itrash_+0140L)
				:0L);
/*  # # DBUG('40000,"[FSM3].7 idPtype='"&(s_idPtype)&"' iID='"&iID&"' iValID='"&iValID&"'"&CRLF&"  e1List='"&e1List&"'"&CRLF&"  dwID='"&CVTYPES(dwID)&"'"&CRLF&"  s1='"&s1&"'") */
		n= 0;
		s= PNULL;
		s2= e1list;	/*  -- for counting */
		while ((*s2!='\0'))
			{/* count the exprs */
			s= GC_EPOPS(rightexpr(&s2));
			++n;
			while ((*s2!='\0') &&iswhitespace((INTEGER)*s2)) ps_itrash_= LOP(s2);
			if (*s2==',') cid= LOP(s2);
/*  # # DBUG('40000,"[FSM3].7.0.1 n="&CVS(n)&"  s2='"&s2&"'") */
			}/* count the exprs */
/*  # # DBUG('40000,"[FSM3].7.0.2 n="&CVS(n)&"  e1List='"&e1List&"'") */

		s= catlist(12L,GC_PUSHS("{INTEGER "),GC_PUSHS(iid),GC_PUSHS(";"),
        GC_PUSHS(wspreface),GC_PUSHS(" "),
        GC_PUSHS((idptype==codestring) ? "STRING"
        		    : (idptype==codereal) ? "float"
        		    : (idptype==codedouble) ? "double"
        		    : "INTEGER"),GC_PUSHS(" "),GC_PUSHS(ivalid),
        GC_PUSHS("["),cvs(n+1L),GC_PUSHS("];"),GC_PUSHS(wspreface));
		n= 0;
		s3= s2= PNULL;
		if (*e2=='/') s2= catlist(3L,GC_PUSHS("/* STEP-LIST: "),subst(GC_PUSHS(e2),3L,
        length(e2)),GC_PUSHS(crlf));
		if (*e3=='/') s3= catlist(3L,GC_PUSHS("/* UNTIL-LIST: "),subst(GC_PUSHS(e3),3L,
        length(e3)),GC_PUSHS(crlf));
		if (*s2=='\0') s2= s3; 
		else if (*s3!='\0') s2= catlist(2L,GC_PUSHS(s2),GC_PUSHS(s3));
		push(GC_PUSHS(s2));
		push(GC_PUSHS(s1)); push(GC_PUSHS(id));
		push(GC_PUSHS(iid)); push(GC_PUSHS(ivalid)); pushnumber(dwid);
		while ((*e1list!='\0'))
			{/* scan and cvt exprs */
			++n;
/*  # # DBUG('40000,"[FSM3].7.1 n="&CVS(n)&" e1List='"&e1List&"'") */
			e1= GC_EPOPS(rightexpr(&e1list));
/*  # # DBUG('40000,"[FSM3].7.2 n="&CVS(n)&" e1='"&e1&"'") */
			push(GC_PUSHS(e1list)); push(GC_PUSHS(s)); pushnumber(n);
			push(GC_PUSHS(wspreface)); push(GC_PUSHS(oldtoken));
			lasttype= dwid; midofexpr= 1L;
			oldtoken= ":=";
			e1= GC_EPOPS(r_d_expr_map(GC_PUSHS(e1)));
			pop(&oldtoken); pop(&wspreface);
			popnumber(&n); pop(&s); pop(&e1list);
/*  # # DBUG('40000,"[FSM3].7.3 EVALED e1='"&e1&"'") */
			s= catlist(9L,GC_PUSHS(s),GC_PUSHS(" "),GC_PUSHS(ivalid),GC_PUSHS("["),
        cvs(n),GC_PUSHS("] = "),GC_PUSHS(e1),GC_PUSHS(";"),
        GC_PUSHS(wspreface));
/*  # # DBUG('40000,"[FSM3].7.4 s='"&s&"'") */
			while ((*e1list!='\0') &&iswhitespace((INTEGER)*e1list)) ps_itrash_= LOP(e1list);
			if (*e1list==',') ch= LOP(e1list);
			while ((*e1list!='\0') &&iswhitespace((INTEGER)*e1list)) ps_itrash_= LOP(e1list);
			}/* scan and cvt exprs */
		popnumber(&dwid); pop(&ivalid); pop(&iid);
		pop(&id); pop(&s1);
/*  # # DBUG('40000,"[FSM3].7.5 s='"&s&"'") */
		s= catlist(23L,GC_PUSHS(s),GC_PUSHS(" for ("),GC_PUSHS(iid),GC_PUSHS(
        "=1,"),GC_PUSHS(id),GC_PUSHS("="),GC_PUSHS(ivalid),
        GC_PUSHS("[1]; "),GC_PUSHS(iid),GC_PUSHS("<="),cvs(n),
        GC_PUSHS("; "),GC_PUSHS(iid),GC_PUSHS("++, "),GC_PUSHS(id),
        GC_PUSHS("="),GC_PUSHS(ivalid),GC_PUSHS("["),GC_PUSHS(iid),
        GC_PUSHS("]) "),GC_PUSHS(s1),GC_PUSHS(wspreface),GC_PUSHS(
        "}"));
/*  # # DBUG('40000,"[FSM3].7.6 s='"&s&"'") */
		pop(&s2);
		if (*s2!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s2));
/*  # # DBUG('40000,"[FSM3].7.7 s='"&s&"'") */
		{GC_UNMARKSSTKFRAME;}}/* eval the e1 list first */
	popnumber(&midofexpr);
	pop(&e1list);
/*  # # DBUG('40000,"[FSM3].7.8 forE1str="&forE1str&" forE2str="&forE2str&" forE3str="&forE3str) */
GC_EPOPS(dbug(040000L,catlist(3L,GC_PUSHS("[FSM3].8 s=\'"),GC_PUSHS(s),GC_PUSHS("\'"))));
/* NO-OP */;
	oldtypestatement= "for";
	isemitgcflag= !ismacroflag; 	/*  -- enable for GC code
					  generation */

	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 's4'=<L0> string                              */
/*************************************************/

}/* FSM3 */

