/* FILE: fsm35.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmc.c, being converted 12/25/87, 06:54:53PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm35(h)
	INTEGER h;
{/* FSM35 */
INTEGER nextbrk, 
	ch, 
	i, 
	j, 
	ltype, 
	rtype, 
	isarithop, 
	dooptimizeflag;
STRING s, 
	s1, 
	s2, 
	s3, 
	s4, 
	lid, 
	rid, 
	rexpr, 
	rexpr2, 
	brkstr, 
	wspace;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,35L))= (*aChkI(cntfsms,1L,35L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(13L,GC_PUSHS("[FSM35] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h),GC_PUSHS(" sPDLptr="),
        cvs(spdlptr),GC_PUSHS(crlf),GC_PUSHS(" lastType=\'"),
        cvtypes(lasttype),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" isFRAGMENTflag="),pbool(isfragmentflag))));
/*[35] :=*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM35>]
.INDEX ++PSAIL PROCEDURE: FSM35
	For non-LEAP <id>'s, Check for 
		<id>:=<id>+1 or <id>:=<id>-1
	in which case map it to 
		<id>++ or <id>--,
@V.56.15 always		++<id> or --<id>,
	(if isArrayAdrFlag then
		++<id> or --<id> ).
	Check for
	<id>=<id><opr><value> 
and map into
	<id> <opr>= <value>
	Check for 
	<id>=<value><+ or * opr><id> 
and map into
	<id> <+ or * opr>= <value>

NOTE:	If assigning a string to a non-string or a non-string to a
string, we must check and do explicit type conversion for the
target C compiler.
	EG.	i:=s		==>	i = *s
and
		s:=i		==>	s = makstr(i).
			or	==>	s = makstr((INTEGER) r)
					when r is not 'int'
@V.51.28 NOTE: don't process SEMICOLONs here!!!
@V.52.112 NOTE: Make sure that there is a space after = to avoid
problems with old Version 6 code (=+, =-, =* and =&) which could be
generated in PSAIL. Eg. VAX-11C is unhappy!.
.ENDLABEL [<++PSAIL PROCEDURE: FSM35>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(s2); /* for G.C. */
	GC_NOTESTRING(s3); /* for G.C. */
	GC_NOTESTRING(s4); /* for G.C. */
	GC_NOTESTRING(lid); /* for G.C. */
	GC_NOTESTRING(rid); /* for G.C. */
	GC_NOTESTRING(rexpr); /* for G.C. */
	GC_NOTESTRING(rexpr2); /* for G.C. */
	GC_NOTESTRING(brkstr); /* for G.C. */
	GC_NOTESTRING(wspace); /* for G.C. */
	oldtoken= oldtypestatement= ":=";
	midofexpr= 1L;

/*  # # DBUG('40000,"[FSM35].0.0.1 cStatement='"&cStatement&"'"&CRLF&" saiStatement='"&saiStatement&"'") */

	while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);  /*  -- just in case it was a break */

/*  # # @V.56.117		If (lastType Land DW!leap)
# # # @V.56.117		Then
# # # @V.56.117		Begin "DO NOT optimize!!!"
# # # @V.56.117		s_SIMPLE!MAP(h) */
/*  # # @V.56.117	# # # DBUG('40000,"[FSM35].0.0.2 NO-OPTIMIZ lastType='"&CVTYPES(lastType)&"'") */
/*  # # @V.56.117		Return(s) */
/*  # # @V.56.117		End "DO NOT optimize!!!" */

/*  --------------------------------- */
/*  . . . DO SCALAR ASSIGNMENT . . .  */
/*  --------------------------------- */
	/*  -- test if i++ or i-- */
	pushnumber(lasttype);
	rexpr= GC_EPOPS(rightstatement());	/*  -- NOTE: in SAIL syntax! */
	if ((*(rexpr+length(rexpr)-1))==';')
		{/* not the ';' */
		if (*saistatement=='\0') saistatement= ";"; 
		else saistatement= catlist(2L,GC_PUSHS(";"),GC_PUSHS(saistatement));
		rexpr= subst(GC_PUSHS(rexpr),1L,length(rexpr)-1L);
		}/* not the ';' */
/*  # # DBUG('40000,"[FSM35].0.0.1.1 rExpr='"&rExpr&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
	rexpr2= rexpr;
	rid= GC_EPOPS(rightid(&rexpr)); 	/*  -- NOTE: in SAIL syntax! */
	popnumber(&lasttype);
/*  # # DBUG('40000,"[FSM35].0.0.2 rID='"&rID&"' rExpr='"&rExpr&"'"&CRLF&" saiStatement="&saiStatement) */
	wspace= PNULL;
	while (iswhitespace((INTEGER)*rexpr)) 
		if (*wspace=='\0') wspace= GC_EPOPS(makstr(LOP(rexpr) 
		)); else wspace= catlist(2L,GC_PUSHS(wspace),GC_PUSHS(LOP(rexpr)));
				/*  -- just in case <id> [... */
	if (!isalpha(GC_PUSHS(rexpr))) nextbrk= LOP(rexpr); 
	else nextbrk= (INTEGER)'\0';	/*  -- get operator if any */
/*  # # DBUG('40000,"[FSM35].0.1 nextBrk='"&(s2_nextBrk)&"' rExpr='"&rExpr&"'") */
/*  -- NOTE: @V.16.00 to catch array auto accesses we need to backup the
previous expression rather than the previous token as used here. Need
'lastExpr' code... */
	s1= cstatement
;
	s2= GC_EPOPS(left_id(&s1));		/*  -- NOTE: in C syntax! */
	s3= s2;			/*  -- First scan off id */
	ltype= lasttype;

	if (usechkflag &&(equ(subst(GC_PUSHS(s2),1L,6L),GC_PUSHS("(*aChk")) ||
			   equ(subst(GC_PUSHS(s2),1L,6L),GC_PUSHS("(*aAdr"))))
		{/* get with pointers */
		/*  -- Extract 'name,a,b,c' from 
			'(*aChk(&name,a,b,c)'
		or
			'(*aAdr(&name,a,b,c)'
		 */
		ch= LOP(s2);		/*  -- trash first '(' */
		s4= GC_EPOPS(scan(&s2,7L,&ch));     /*  -- trash up to 2nd '(' */
/*  # # DBUG('40000,"[FSM35].0.1.1 AFTER TRASH (*aAdr?(..)) s2='"&s2&"'") */
		lid= GC_EPOPS(scan(&s2,14L,&ch));	/*  -- get name upto ',' */
		s4= GC_EPOPS(scan(&s2,14L,&ch));	/*  -- trash nbr args */
		s4= subst(GC_PUSHS(s2),1L,length(s2)-2L);	/*  -- trash last '))'  */
		lid= catlist(4L,GC_PUSHS(lid),GC_PUSHS("["),GC_PUSHS(s4),GC_PUSHS("]"));
/*  # # DBUG('40000,"[FSM35].0.1.2 lID='"&lID&"' s3='"&s3&"' s2='"&s2&"' s4='"&s4&"'") */
			}/* get with pointers */

	else	{/* get with [][] */
		lid= GC_EPOPS(makstr(LOP(s2)));	/*  -- Now convert back to SAIL
				  to compare lID vs rID */
		while ((*s2!='\0'))
		    if (equ(subsr(GC_PUSHS(s2),1L,2L),GC_PUSHS("][")))
			{/* change '][' to ',' to chk arrays */
			lid= catlist(2L,GC_PUSHS(lid),GC_PUSHS(","));
			s2= subst(GC_PUSHS(s2),3L,length(s2));	/*  -- Shorten it */
			}/* change '][' to ',' to chk arrays */
			else lid= catlist(2L,GC_PUSHS(lid),GC_PUSHS(LOP(s2)));
		}/* get with [][] */

	s= "=";      /*  -- assume fail, & do assignment map */
	lasttype= ltype; 	/*  -- use in later mapping */
/*  # # DBUG('40000,"[FSM35].1 lID='"&lID&"' rID='"&rID&"' lType='"&CVTYPES(lType)&"'"&CRLF&"' s='"&s&"'"&CRLF&" ISUNARYSCALARTYPE(lType)="&PBOOL(ISUNARYSCALARTYPE(lType))&CRLF&" isFRAGMENTflag="&PBOOL(isFRAGMENTflag)) */

	if (!fast_equ(GC_PUSHS(lid),GC_PUSHS(rid)) ||
	   !isunaryscalartype(ltype) ||
	   (((ps_itrash_= (lasttype&037))>0) ? (ps_itrash_+0140L)
				:0L)==codestring)
		{/* test if need to do <rValue> COERCION! */
		/*  -- Restore rExpr before eval. */
		push(GC_PUSHS(s)); pushnumber(ltype);
		push(GC_PUSHS(lastmappedtoken));
		lastmappedtoken= ":=";   /*  -- Setup to handle
					an <if-expression> */
		rexpr= GC_EPOPS(r_d_expr_map(GC_PUSHS(rexpr2)));
		pop(&lastmappedtoken);
		popnumber(&ltype); pop(&s);
		rtype= lasttype;
		lasttype= ltype;		/*  -- ie. <lValue> type */
/*  # # DBUG('40000,"[FSM35].1.1 rType='"&CVTYPES(rType)&"'"&CRLF&"  lType='"&CVTYPES(lType)&"'"&CRLF&"  lastType='"&CVTYPES(lastType)&"'"&CRLF&"  rExpr='"&rExpr&"'"&CRLF&"  saiStatement='"&saiStatement&"'"&CRLF&" isFRAGMENTflag="&PBOOL(isFRAGMENTflag)) */
		s= "= "; 	/*  -- The space is added
				     to avoid the VERSION-6
				     C compiler problem with
				     =-, =&, =+ and =* etc.. */
		if (!ismacroflag &&(ltype!=rtype) &&
		   !isscalartype(ltype,rtype))
			{/* Do Coercion where C will NOT! */
			midofexpr= 0L;
			s= catlist(2L,GC_PUSHS(s),cvactual_to_expected(ltype,
        						rtype,GC_PUSHS(rexpr)));
/*  # # DBUG('40000,"[FSM35].1.2 rType='"&CVTYPES(rType)&"'"&CRLF&"  s='"&s&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
			}/* Do Coercion where C will NOT! */
		else s= catlist(2L,GC_PUSHS(s),GC_PUSHS(rexpr));
/*  # # DBUG('40000,"[FSM35].1.3 saiToken='"&saiToken&"' sPDLptr="&CVS(sPDLptr)&CRLF&" lastType='"&CVTYPES(lastType)&"'"&CRLF&" s='"&s&"'") */
		oldtoken= oldtypestatement= ":=";
;
		{GC_UNMARKSSTKFRAME;
		 GC_SRETURN(s);}    /*  -- pass the sucker back... */
		}/* test if need to do <rValue> COERCION! */


	isarithop= (nextbrk=='+'||nextbrk=='-' ||
	    	   nextbrk=='*' ||nextbrk=='/');
/*  # # DBUG('40000,"[FSM35].2 nextBrk='"&(ps!sTrash!_nextBrk)&"' isArithOp="&PBOOL(isArithOp)&" rExpr='"&rExpr&"'"&CRLF&" s='"&s&"' lID='"&lID&"' rID='"&rID&"'") */

	if (!isarithop) 
		{/* Not + - * or / */
		if (nextbrk!='\0') 
			{/* back up brk char */
			if (*rexpr=='\0') rexpr= GC_EPOPS(makstr(nextbrk
			)); else rexpr= catlist(2L,makstr(nextbrk),GC_PUSHS(rexpr));
			}/* back up brk char */
		s= catlist(2L,GC_PUSHS(s),GC_PUSHS(rid));   	/*  -- output '<rId>=<rId>' */
		/*  -- Failed Parse '<id>+ or <id>- */
/*  # # DBUG('40000,"[FSM35].2.1 s='"&s&"'") */
		}/* Not + - * or / */

	else 	{/* Optimize it */
/*  # # DBUG('40000,"[FSM35].2.2 s='"&s&"' isArrayAdrFlag="&PBOOL(isArrayAdrFlag)&CRLF&" rExpr='"&rExpr&"'"&CRLF&" saiStatement='"&saiStatement&"'") */

/*  -- NOTE: @V.56.15 force mapping to ++<id> and --<id> instead of
<id>++ and <id>-- which can possibly get us into semantic difficulty
in some cases. Eg.
	If (i:=i+1) > 20 ...
would map to:
	if(i++)>20
which has different semantics than
	if(++i)>20.
 */
	rexpr2= rexpr;
/*  # # @V.56.151	If rExpr2 Neq "1"
# # # @V.56.151		Then s1_NULL
# # # @V.56.151	Else s1_GET!TOKEN(rExpr2) */
	s1= GC_EPOPS(get_token(&rexpr2));	/*  -- get next token */
			/*  -- will test if 1, see if next is term */
	rexpr2= GC_EPOPS(remove_white_ends(GC_PUSHS(rexpr2)));
	dooptimizeflag= (((*saistatement==';'&&
		         (*rexpr2=='\0'||
		          (*rexpr2=='e'&&
		           equ(subsr(GC_PUSHS(rexpr2),1L,4L),GC_PUSHS("else"))
		          )
		         )
		        ) ||
		       *rexpr2==',' ||*rexpr2==')' ||
	       	       *rexpr2==']' ||
		       (*rexpr2=='\0') ||
		       (*saistatement=='\0'&&*rexpr2=='\0'))) &&
		      (lasttype&020000L)==0;
/*  # # DBUG('40000,"[FSM35].2.2.0.1 s1='"&s1&"' rExpr2='"&rExpr2&"' expr='"&rExpr&"'"&CRLF&" doOptimizeFlag="&PBOOL(doOptimizeFlag)&CRLF&" saiStatement='"&saiStatement&"'") */
		if (dooptimizeflag &&
	   (*s1=='1'&&(((INTEGER)*s1==(INTEGER)'1') ||equ(GC_PUSHS(s1),GC_PUSHS("1L"))))) 
		{/* ++<id> or --<id> or just <id><opr> */
		/*  -- NOTE: do NOT skip left comments */
		if ((nextbrk=='*'||nextbrk=='/')) s= GC_EPOPS(left_expr(&cstatement,0L)
	        ); else /*  # # @V.56.25 If Not isArrayAdrFlag
		   		Then s_(nextBrk & nextBrk)
			   Else  */  s= (catlist(3L,makstr(nextbrk),makstr(nextbrk),left_expr(&cstatement,0L)));
/*  # # DBUG('40000,"[FSM35].2.2.1 s='"&s&"'") */
		rexpr= rexpr2;		/*  -- get rest */
		}/* ++<id> or --<id> or just <id><opr> */

	else if (dooptimizeflag)
		{/* <id><op>=<var> */
		if (nextbrk=='+'||nextbrk=='*' ||nextbrk=='/' ||
		   (nextbrk!='+'&&
			(chk_id(GC_PUSHS(rexpr)) ||
			    (*saistatement==';'||
			     *saistatement==')' ||
			     *saistatement==']' ||
			     *saistatement==','
			    )
			)
		   )) s= catlist(3L,GC_PUSHS(" "),makstr(nextbrk),GC_PUSHS("= ")); else s= catlist(2L,GC_PUSHS(" += "),makstr(nextbrk));    /*  -- be careful
					optimizing minus... */
/*  # # DBUG('40000,"[FSM35].2.2.2 s='"&s&"'") */
		}/* <id><op>=<var> */

	else	{/* opps, need to back it up can't optimize */
		/*  -- failed optimization parse since there
		     was something in <rValue> which had
		     higher precedence and overode optimization */
		rexpr= catlist(3L,GC_PUSHS(rid),makstr(nextbrk),GC_PUSHS(rexpr)); /*  -- backup */
		s= " = ";	/*  -- get the <rValue> using R!D */
/*  # # DBUG('40000,"[FSM35].2.2.3 s='"&s&"' rExpr='"&rExpr&"'") */
		}/* opps, need to back it up can't optimize */

/*  # # DBUG('40000,"[FSM35].2.2.4 s='"&s&"' rExpr='"&rExpr&"'") */
/*  @V.54.89 -- Why not just use  TRASH!RIGHT!WS(cStatement) ??? */
	if (isarrayadrflag) while ((ch= (*(cstatement+length(cstatement)-1)))!='\0'&&
		   iswhitespace(ch))
			{/* trash trailing WS */
			cstatement= subst(GC_PUSHS(cstatement),1L,length(cstatement)-1L);
			}/* trash trailing WS */
	}/* Optimize it */

	if (*rexpr!='\0') saistatement= ((*saistatement=='\0') ? rexpr : catlist(2L,GC_PUSHS(rexpr),GC_PUSHS(saistatement)));

	oldtoken= oldtypestatement= ":=";
GC_EPOPS(dbug(040000L,catlist(24L,GC_PUSHS("[FSM35].3 sPDLptr="),cvs(spdlptr),GC_PUSHS(crlf)
        ,GC_PUSHS(" lastType=\'"),cvtypes(lasttype),
        GC_PUSHS("\' saiToken=\'"),GC_PUSHS(saitoken),GC_PUSHS("\'")
        ,GC_PUSHS(crlf),GC_PUSHS(" s=\'"),GC_PUSHS(s),GC_PUSHS("\'")
        ,GC_PUSHS(crlf),GC_PUSHS(" rExpr=\'"),GC_PUSHS(rexpr),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" cStatement=\'"),
        GC_PUSHS(cstatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" saiStatement=\'"),GC_PUSHS(saistatement),
        GC_PUSHS("\'"))));
;
	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'brkstr'=<L0> string                          */
/* 'j'=<L0> integer                              */
/* 'i'=<L0> integer                              */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/


}/* FSM35 */
