/* FILE: fsm36.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmc.c, being converted 12/25/87, 06:54:53PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm36(h)
	INTEGER h;
{/* FSM36 */
INTEGER isintpow, 
	isintbase;
STRING s, 
	rexpr, 
	fct, 
	rid, 
	lexpr, 
	rexprc;
INTEGER rtype, 
	ltype, 
	ch;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,36L))= (*aChkI(cntfsms,1L,36L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(7L,GC_PUSHS("[FSM36] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h),GC_PUSHS(" lastType=\'"),
        cvtypes(lasttype),GC_PUSHS("\'"))));
/*[36] ^*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM36>]
.INDEX ++PSAIL PROCEDURE: FSM36
	 Map SAIL:	'a ^ b'  
		(note '**' was mapped to '^' in CVEVALQUOTE)
	  to C:
		If /NOMATH then:
		'POW(a,b)' a or b is REAL and,
		'IPOW(a,b)' a or b are INTEGERs.
		If /MATH then:
		Generate the following calls for <psrun9.c>
		based on the type:
		Type of
		a	b		Generate function call
		-----------			--------
		Int	Int		INTEGER ppowii(a,b)
		Int	Real		INTEGER ppowif(a,b)
		Real	Int		float ppowfi(a,b)
		Real	Real		float ppowff(a,b)

		Further optimizations are performed:
		If b is 2 and a is simple ID then PPOW2(a),
		If b is 3 and a is simple ID then PPOW3(a).
	These are <sairun.h> macros which will call the C
	compiler exp() for /NOMATH and <psrun9.c>'s pexp().
.ENDLABEL [<++PSAIL PROCEDURE: FSM36>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(rexpr); /* for G.C. */
	GC_NOTESTRING(fct); /* for G.C. */
	GC_NOTESTRING(rid); /* for G.C. */
	GC_NOTESTRING(lexpr); /* for G.C. */
	GC_NOTESTRING(rexprc); /* for G.C. */
	oldtoken= "^";
	ltype= lasttype;
	while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
	if (*saistatement=='(') rexpr= catlist(2L,copy_omit(GC_PUSHS(")")) ,GC_PUSHS(")")); else	{/* get the id */
/*  # # @V.52.144	NOTE: this type of thing should be made a procedure! */
/*  # # DBUG('40000,"[FSM36].0.1 saiStatement='"&saiStatement&"'") */
		rexpr= GC_EPOPS(get_token(&saistatement));
		while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
/*  # # DBUG('40000,"[FSM36].0.2 rExpr='"&rExpr&"'"&CRLF&"  saiStatement='"&saiStatement&"'") */
		if (*saistatement=='('||*saistatement=='[')
		   {/* get rest of expr */
		   rexpr= catlist(2L,GC_PUSHS(rexpr),makstr(ch= LOP(saistatement)));
		   if (ch=='(') rexpr= catlist(3L,GC_PUSHS(rexpr),copy_omit(GC_PUSHS(")")),GC_PUSHS(")")); else if (ch=='[') rexpr= catlist(3L,GC_PUSHS(rexpr),copy_omit(GC_PUSHS("]")),GC_PUSHS("]"));
		   }/* get rest of expr */
		}/* get the id */
		/*  -- We need to do this because of operator 
		  -- precedence (i.e. ** >> rest of oprs) */
/*  # # DBUG('40000,"[FSM36].1 rExpr='"&rExpr&"'"&CRLF&"  saiStatement='"&saiStatement&"'") */
	pushnumber(ltype);
	rexpr= GC_EPOPS(r_d_expr_map(GC_PUSHS(rexpr)));
	rtype= lasttype;
	popnumber(&ltype);
	isintpow= ((((ps_itrash_= (rtype&037))>0) ? (ps_itrash_+0140L)
				:0L)==codeinteger);
	isintbase= ((((ps_itrash_= (ltype&037))>0) ? (ps_itrash_+0140L)
				:0L)==codeinteger);
/*  # # DBUG('40000,"[FSM36].2 rExpr='"&rExpr&"' isINTpow="&PBOOL(isINTpow)&" isINTbase="&PBOOL(isINTbase)&CRLF&" rType='"&CVTYPES(rType)&"'") */

	if (usepmathflag)
		{/* expand to <psrun9.c> pkg calls */
		fct= ((isintbase &&isintpow) ? 
				"powii"
			: (isintbase &&!isintpow) ? 
				"powif"
			: (!isintbase &&isintpow) ? 
				"powfi"
			: (!isintbase &&!isintpow) ? 
				"powff"
			: "pow");
		}/* expand to <psrun9.c> pkg calls */
	else	{/* use <sairun.h> macros */
		fct= ((isintbase &&isintpow) ? 
			"IPOW"
			: "POW");
		}/* use <sairun.h> macros */
	lexpr= GC_EPOPS(left_expr(&cstatement,1L));   /*  -- get <lExpr>
				but also skip left comments */
	if (isintpow) rexpr= GC_EPOPS(cvactual_to_expected(rtype,rtype,GC_PUSHS(rexpr)));
	if (isintbase) lexpr= GC_EPOPS(cvactual_to_expected(rtype,rtype,GC_PUSHS(lexpr)));
	rexprc= rexpr;		/*  -- do-cast it ... */
	GC_EPOPS(rmv_integer_cast(GC_PUSHS(rexprc)));
/*  # # DBUG('40000,"[FSM36].3 lExpr='"&lExpr&"' fct='"&fct&"' rExprC='"&rExprC&"'"&CRLF&" lType='"&CVTYPES(lType)&"'") */
	if (isintpow &&chk_id(GC_PUSHS(lexpr)) &&
	   (fast_equ(GC_PUSHS(rexprc),GC_PUSHS("2")) ||fast_equ(GC_PUSHS(rexprc),GC_PUSHS("3"))))
		{/* Optimize ID^2 or ID^3 mapping */
		s= catlist(5L,GC_PUSHS("PPOW"),GC_PUSHS(rexpr),GC_PUSHS("("),
        GC_PUSHS(lexpr),GC_PUSHS(")"));
		}/* Optimize ID^2 or ID^3 mapping */
	else 	{/* Do regular POW-type function call */
		s= catlist(6L,GC_PUSHS(fct),GC_PUSHS("("),GC_PUSHS(lexpr),GC_PUSHS(","),
        GC_PUSHS(rexpr),GC_PUSHS(")"));
		}/* Do regular POW-type function call */
	pdw_ptype(lasttype,
		  (((((ps_itrash_= (ltype&037))>0) ? (ps_itrash_+0140L)
				:0L)==codeinteger&&
			(((ps_itrash_= (rtype&037))>0) ? (ps_itrash_+0140L)
				:0L)==codeinteger) ?  
			codeinteger : codereal));
GC_EPOPS(dbug(040000L,catlist(7L,GC_PUSHS("[FSM36].4 s=\'"),GC_PUSHS(s),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" lastType=\'"),cvtypes(lasttype),
        GC_PUSHS("\'"))));
;
	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'rid'=<L0> string                             */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/


}/* FSM36 */
