/* FILE: fsm38.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmc.c, being converted 12/25/87, 06:54:53PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm38(h)
	INTEGER h;
{/* FSM38 */
STRING s, 
	s1, 
	s2, 
	id, 
	token, 
	msg, 
	ws, 
	relop1, 
	relop2,
	lexpr, 
	lid, 
	rexpr;
INTEGER complexflag, 
	i, 
	ch, 
	lcvflag, 
	parencnt, 
	foundrexpr, 
	ltype,
	rtype, 
	cn2, 
	hn2, 
	idx2, 
	lcode, 
	rcode;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,38L))= (*aChkI(cntfsms,1L,38L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(7L,GC_PUSHS("[FSM38] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h),GC_PUSHS(" lastType=\'"),
        cvtypes(lasttype),GC_PUSHS("\'"))));
/*[38] CPX REL*/
/*   --
.LABEL [<++PSAIL PROCEDURE: FSM38>]
.INDEX ++PSAIL PROCEDURE: FSM38
	Map SAIL:	<boolean-relation-exprs>
	To C:		<C-boolean-relation-exprs>
	If relation is of the form
	SAIL:	a REL1 b REL2 c
	it is called a 'COMPLEX-RELATION' and it maps to 
	to C:	a REL1 b And b REL2 c
	Examples: 		3 < x < 7
		or		"a" Leq c Leq "z"
	NOTE: 'a REL1 ' is returned from this procedure
		while 'b And b REL2 c' is stuffed back
		into saiStatement to be reparsed
	NOTE: If b is a complex expression, containing one or
	more '_' then side affects could be generated. PRINT
	A WARNING!!! and use just the 'id' as for example
		("A" < (ch_LOP(s)) < "Z")
	maps to
		('A' < (ch=lop(&s)) && ch < 'Z')

	NOTE:  The old SAIL syntax is mapped to the new SAIL syntax
	in CVEVALQUOTE
		>= for GEQ, <= for LEQ.
	NOTE: The mapping of NEQ to != is handled here!
	NOTE: The type of a Boolean expression is integer, so
	we must force that here if not double or float!
	NOTE: @V.47.18
	rExpr is the <right-expr> to the <relation 1>
		which invoked this FSM.
	relOp1 is the <relation 1>.
	id is an <identifier> if rExpr has an embedded 
		assignment to <identifier> or it is equal
		to rExpr.
.ENDLABEL [<++PSAIL PROCEDURE: FSM38>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(s2); /* for G.C. */
	GC_NOTESTRING(id); /* for G.C. */
	GC_NOTESTRING(token); /* for G.C. */
	GC_NOTESTRING(msg); /* for G.C. */
	GC_NOTESTRING(ws); /* for G.C. */
	GC_NOTESTRING(relop1); /* for G.C. */
	GC_NOTESTRING(relop2); /* for G.C. */
	GC_NOTESTRING(lexpr); /* for G.C. */
	GC_NOTESTRING(lid); /* for G.C. */
	GC_NOTESTRING(rexpr); /* for G.C. */
	oldtoken= "cpx rel";
	midofexpr= 1L;

/*  ----------------------------------------------------- */
/*  . . . ANALYZE <LEFT-operand> 'lExpr' AND 'lID'  . . . */
/*  ----------------------------------------------------- */
	ltype= lasttype;
	lcode= (((ps_itrash_= (lasttype&037))>0) ? (ps_itrash_+0140L)
				:0L);   /*  -- get primitive type */
	lcvflag= 0L;
	lexpr= GC_EPOPS(left_expr(&cstatement,1L));  /*  -- skip left
						comments */
	while ((*lexpr!='\0') &&iswhitespace((INTEGER)*lexpr)) ps_itrash_= LOP(lexpr);  {/* TRASH!RIGHT!WS */
			while ((*lexpr!='\0') &&
			      (ps_itrash_= (*(lexpr+length(lexpr)-1))) &&
			      iswhitespace(ps_itrash_)) 
						lexpr= subst(GC_PUSHS(lexpr),1L,length(lexpr)-1L);
			}/* TRASH!RIGHT!WS */
	s= lexpr;
	lid= GC_EPOPS(left_id(&s));    /*  -- Set to 'L.NULL' if NULL */
	if (!isunaryscalartype(ltype)) lcvflag= 1L;  	/*  -- ie. must CVT to
					INTEGER type */
/*  # # DBUG('40000,"[FSM38].0.1 lExpr='"&lExpr&"' lID='"&lID&"'"&CRLF&"  lType='"&CVTYPES(lType)&"'"&CRLF&"  lCVflag="&PBOOL(lCVflag)&CRLF&"  cStatement='"&cStatement&"'") */

/*  -------------------------------------------------------------------- */
/*  . . . Analyze <RIGHT-operand> GET 'rExpr', 'relOp1', 'relOp2'  . . . */
/*  -------------------------------------------------------------------- */
	if ((*saitoken=='>'||*saitoken=='<' ||*saitoken=='!') &&
	   (*saistatement=='=')) relop1= catlist(2L,GC_PUSHS(saitoken),GC_PUSHS(LOP(saistatement))); else relop1= GC_EPOPS(simple_map(h));

	while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
	parencnt= 0;
	relop2= rexpr= id= PNULL;
	foundrexpr= 0L;
	do 	{/* get rExpr and id-region */
/*  # # DBUG('40000,"[FSM38].0.1.0.1 saiToken='"&saiToken&"' saiStatement='"&saiStatement&"'") */
		if (!iswhitespace(ch)) s2= saistatement;	/*  -- backup ptr */
		token= GC_EPOPS(getid(&saistatement,&ch));
		if (*token=='\0'&&ch==*quote) 
			{/* get quoted string */
			pushnumber(iscopy_toflag);
			iscopy_toflag= 1L;
			token= GC_EPOPS(map_quotes(&saistatement));
			popnumber(&iscopy_toflag);
			ch= (INTEGER)'\0';
			}/* get quoted string */
/*  # # DBUG('40000,"[FSM38].0.1.0.2 token='"&token&"' ch='"&(ps!sTrash!_ch)&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
		if (ch=='(') ++parencnt; else if (ch==')') --parencnt; else if (ch==':'&&*saistatement=='=') 
			{/* handle assignment */
			token= catlist(3L,GC_PUSHS(token),makstr(ch),GC_PUSHS(LOP(saistatement)));
			ch= (INTEGER)'\0';
			if (*id=='\0'&&isalpha(GC_PUSHS(s2))) id= GC_EPOPS(rightid(&s2));
				/*  -- Get id for CMPLX EXPR */
			}/* handle assignment */
		else if ((parencnt==0))
			{/* check if done */
			/*  -- NOTE: special HACK for FSM38 checking value
		  of declFSM[] to be 38!!! */
			if (ch=='<'||ch=='>' ||ch=='=' ||
			    ((idx2= find_symbol(GC_PUSHS(token),&cn2,&hn2))!=0&&
			     (((*aChkI(declfsm,1L,idx2))&0177777)==38))) 
				{/* handle 2nd REL */
				if (ch=='<'||ch=='>' ||ch=='=')
					{/* non-alpha */
					relop2= GC_EPOPS(makstr(ch));
					if (*saistatement=='=') 
					   relop2= 
        					     catlist(GC_PUSHS(relop2),GC_PUSHS(LOP(saistatement)));
					ch= (INTEGER)'\0';
					}/* non-alpha */
				else 	{/* NEQ */
/*  # # @V.50.50					relOp2_declCsym[idx2] &
						ch */ /*  -- MAP it */
					relop2= catlist(2L,GC_PUSHS(token),makstr(ch));
					token= GC_EPOPS(makstr(ch= (INTEGER)'\0'));
					}/* NEQ */
				foundrexpr= 1L;
				}/* handle 2nd REL */
			else if (fast_equ(GC_PUSHS(token),GC_PUSHS("and")) ||
				fast_equ(GC_PUSHS(token),GC_PUSHS("or")))
				{/* next sub-expr */
				if (ch!='\0') token= catlist(2L,GC_PUSHS(token),makstr(ch));
				saistatement= catlist(2L,GC_PUSHS(token),GC_PUSHS(saistatement));
				token= GC_EPOPS(makstr(ch= (INTEGER)'\0'));
				foundrexpr= 1L;
				}/* next sub-expr */
			}/* check if done */

		if (*token!='\0') 
			{/* append it */
			rexpr= ((*rexpr=='\0') ? token : catlist(2L,GC_PUSHS(rexpr),GC_PUSHS(token)));
			}/* append it */

		if (ch!='\0') 
			{/* append it */
			if (*rexpr=='\0') rexpr= GC_EPOPS(makstr(ch
			)); else rexpr= catlist(2L,GC_PUSHS(rexpr),makstr(ch));
			}/* append it */
		}/* get rExpr and id-region */
	 while (!((*saistatement=='\0') ||foundrexpr));


/*  --------------------------------------------------------------- */
/*  . . . SET UP <id> AS <lValue> of <rExpr> OR <rExpr> ITSELF . .  */
/*  --------------------------------------------------------------- */
	if (*id=='\0') id= rexpr;	  /*  -- use the whole thing! */
	while ((*id!='\0') &&iswhitespace((INTEGER)*id)) ps_itrash_= LOP(id);  {/* TRASH!RIGHT!WS */
			while ((*id!='\0') &&
			      (ps_itrash_= (*(id+length(id)-1))) &&
			      iswhitespace(ps_itrash_)) 
						id= subst(GC_PUSHS(id),1L,length(id)-1L);
			}/* TRASH!RIGHT!WS */
	while ((*rexpr!='\0') &&iswhitespace((INTEGER)*rexpr)) ps_itrash_= LOP(rexpr);  {/* TRASH!RIGHT!WS */
			while ((*rexpr!='\0') &&
			      (ps_itrash_= (*(rexpr+length(rexpr)-1))) &&
			      iswhitespace(ps_itrash_)) 
						rexpr= subst(GC_PUSHS(rexpr),1L,length(rexpr)-1L);
			}/* TRASH!RIGHT!WS */
/*  # # DBUG('40000,"[FSM38].0.1.1 id='"&id&"' rExpr='"&rExpr&"' foundRexpr="&PBOOL(foundRexpr)&CRLF&" relOp1='"&relOp1&"' relOp2='"&relOp2&"'"&CRLF&" lType='"&CVTYPES(lType)&"'"&CRLF&" saiStatement='"&saiStatement&"'"&CRLF&" cStatement='"&cStatement&"'") */

/*  -------------------------------------- */
/*  . . . COERCE <lExpr> IF REQUIRED . . . */
/*  -------------------------------------- */
	if ((!mainsailflag ||lcode!=codestring)
/*  # # @V.52.112  Or (relOp1 Neq "=")    */)
		{/* SAIL conversion */
		if (lcvflag
/*  # # @V.52.114    And Not isMACROflag   */)
			{/* COERCE <lExpr> to INTEGER */
/*  -- @V.56.20 NOTE: we really don't want to cast a string as
'(INTEGER)*<str-expr>' but rather as '*<str-expr>'. So we pass this
on to the coercion procedure by setting the expected type to that of
BYTE i.e. CODEbyte.
 */
			INTEGER newcode;
			newcode= (((((ps_itrash_= (ltype&037))>0) ? (ps_itrash_+0140L)
				:0L)==codestring) ? codebyte
			    	 : codeinteger);
			pdw_ptype(lasttype,newcode);
/*  # # DBUG('40000,"[FSM38].0.1.1.0.1 newCode='"&(ps!sTrash!_newCode)&"'"&CRLF&" lastType=0"&CVOS(lastType)&"='"&CVTYPES(lastType)&"'") */
			lexpr= GC_EPOPS(cvactual_to_expected(lasttype,ltype,
								GC_PUSHS(lexpr)));
/*  # # DBUG('40000,"[FSM38].0.1.1.1 newCode='"&(ps!sTrash!_newCode)&"'"&CRLF&" lExpr='"&lExpr&"'"&CRLF&" lType='"&CVTYPES(lType)&"'"&CRLF&" lCVflag="&PBOOL(lCVflag)) */
			ltype= lasttype;
			lcode= codeinteger;
			}/* COERCE <lExpr> to INTEGER */
		if (*cstatement=='\0') cstatement= lexpr; 
		else cstatement= catlist(2L,GC_PUSHS(cstatement),GC_PUSHS(lexpr)); 
				/*  -- put it back */
/*  # # DBUG('40000,"[FSM38].0.1.2 lExpr='"&lExpr&"' lCode='"&(ps!sTrash!_lCode)&"'"&CRLF&" lType='"&CVTYPES(lType)&"'"&CRLF&" new cStatement='"&cStatement&"'") */
		}/* SAIL conversion */

	else 	{/* MAINSAIL '=' conversion */
/* IFC EVAL(parsemainsail)=1 */
/* THENC */

 /* MESSAGE: " <Parsing MAINSAIL code>"  */;
		if ((lcode==codestring))
			{/* Map MAINSAIL '=' to 'EQU()' */ 
			/*   -- NOTE: @V.58.05 eval rExpr then
			   create an EQU(s1,s2) call with GC
			   protection if needed.
			 */
/*  # # DBUG('40000,"[FSM38].0.1.3 MAINSAIL STRING '='"&CRLF&" rExpr='"&rExpr&"'") */
			push(GC_PUSHS(lexpr)); push(GC_PUSHS(relop2)); push(GC_PUSHS(s));
			rexpr= GC_EPOPS(r_d_expr_map(GC_PUSHS(rexpr)));
			pop(&s); pop(&relop2); pop(&lexpr);
/*  # # DBUG('40000,"[FSM38].0.1.3.1 lExpr='"&lExpr&"'"&CRLF&"' rExpr='"&rExpr&"'") */
			add_gc_pushs(&rexpr);
			add_gc_pushs(&lexpr);
			relop1= catlist(5L,GC_PUSHS("equ("),GC_PUSHS(lexpr),GC_PUSHS(","),
        GC_PUSHS(rexpr),GC_PUSHS(")"));
			complexflag= 0L;
/*  # # DBUG('40000,"[FSM38].0.1.3.2 lExpr='"&lExpr&"'"&CRLF&"' rExpr='"&rExpr&"'"&CRLF&" relOp1='"&relOp1&"'") */
			rexpr= PNULL;
			}/* Map MAINSAIL '=' to 'EQU()' */
    /* ENDC */
		}/* MAINSAIL '=' conversion */

/*  ---------------------------------- */
/*  . . . GET W.S. AFTER <rExpr> . . . */
/*  ---------------------------------- */
	ws= PNULL;
	map_whitespace(&ws);	/*  -- get whitespace if any */
		if (*ws==*space) ws= PNULL;	/*  -- ignore single SPACE  */

/*  # # DBUG('40000,"[FSM38].1 relOp1='"&relOp1&"' complexFlag="&PBOOL(complexFlag)&" relOp2='"&relOp2&"'"&CRLF&" saiStatement='"&saiStatement&"'") */

/*  ------------------------------------------------------------- */
/*  . . . ANALYZE 2nd RELATIONAL OPERATOR 'relOp2' IF EXISTS. . . */
/*  ------------------------------------------------------------- */
	if (*relop2!='\0')
		{/* Neq, >, <, = */
		if (*ws=='\0') ws= " ";
		saistatement= catlist(5L,GC_PUSHS(ws),GC_PUSHS(id),GC_PUSHS(" "),GC_PUSHS(relop2),
        GC_PUSHS(saistatement));
				 /*  -- BACKUP input stream */
		complexflag= 1L;
		}/* Neq, >, <, = */

	else 	{/* Not complex */
		complexflag= 0L;
		}/* Not complex */
/*  # # DBUG('40000,"[FSM38].2 rExpr='"&rExpr&"'"&CRLF&" saiStatement='"&saiStatement&"'"&CRLF&" complexFlag="&PBOOL(complexFlag)) */

/*  -------------------------------------------- */
/*  . . . EVAL <rExpr> if it is not NULL . . .  */
/*  -------------------------------------------- */
	if ((*rexpr!='\0'))
		{/* Eval rExpr */
		pushnumber(complexflag);
		push(GC_PUSHS(relop2)); push(GC_PUSHS(relop1)); push(GC_PUSHS(s));
		rexpr= GC_EPOPS(r_d_expr_map(GC_PUSHS(rexpr)));
		pop(&s); pop(&relop1); pop(&relop2);
		popnumber(&complexflag);
		rtype= lasttype;
		rcode= (((ps_itrash_= (lasttype&037))>0) ? (ps_itrash_+0140L)
				:0L);
		}/* Eval rExpr */
/*  # # DBUG('40000,"[FSM38].2.2 rExpr='"&rExpr&"' rCode='"&(ps!sTrash!_rCode)&"'"&CRLF&"  rType='"&CVTYPES(rType)&"'") */

	lasttype= 0L;
	if (!isunaryscalartype(rtype) &&(*rexpr!='\0'))
		{/* coerce it */
/*  -- @V.56.20 NOTE: we really don't want to cast a string as
'(INTEGER)*<str-expr>' but rather as '*<str-expr>'. So we pass this
on to the coercion procedure by setting the expected type to that of
BYTE i.e. CODEbyte.
 */
		INTEGER newcode;
		newcode= (((((ps_itrash_= (rtype&037))>0) ? (ps_itrash_+0140L)
				:0L)==codestring) ? codebyte
		    	 : codeinteger);
		pdw_ptype(lasttype,newcode);
		rexpr= GC_EPOPS(cvactual_to_expected(lasttype,rtype,
						GC_PUSHS(rexpr)));
/*  # # DBUG('40000,"[FSM38].2.2.1 newCode='"&(ps!sTrash!_newCode)&"'"&CRLF&" rExpr='"&rExpr&"'"&CRLF&" rType='"&CVTYPES(rType)&"'") */
		}/* coerce it */
	pdw_ptype(lasttype,codeinteger);
/*  # # DBUG('40000,"[FSM38].3 rExpr='"&rExpr&"'") */

	s= relop1;	/*  -- build this expr - handles map to EQU(a,b) */
	if (*rexpr!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(rexpr));	/*  -- build this expr */
/*  # # DBUG('40000,"[FSM38].4 s='"&s&"'") */

	if (complexflag)
		{/* <rValue> of COMPLEX relation */
		/*  -- Handle complex relations by
		  creating another relation in SAIL
		  space and backing up the input stream
		  in SAISTATEMENT to include it. We will
		  then parse it later.  */
		s= catlist(2L,GC_PUSHS(s),GC_PUSHS(" &&"));  /*  -- what we return */
/*  # # DBUG('40000,"[FSM38].5 BACKUP saiStatement='"&saiStatement&"'"&CRLF&" s='"&s&"'") */
			}/* <rValue> of COMPLEX relation */

/*  # # DBUG('40000,"[FSM38].6 s='"&s&"'"&CRLF&" saiStatement='"&saiStatement&"'"&CRLF&" cStatement='"&cStatement&"'") */

	lasttype= 0L;
	pdw_ptype(lasttype,codeinteger);
;
	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'i'=<L0> integer                              */
/* 'msg'=<L0> string                             */
/* 's1'=<L0> string                              */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/


}/* FSM38 */
