/* FILE: fsm39.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmc.c, being converted 12/25/87, 06:54:53PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm39(h)
	INTEGER h;
{/* FSM39 */
STRING s, 
	s1, 
	s2, 
	rexpr, 
	ws, 
	prfstr, 
	prfws;
INTEGER ch, 
	i, 
	ssize, 
	atype, 
	rcode, 
	arelocstrflag, 
	hlproc,
	expectreturnflag, 
	toblklevel, 
	actualreturnvalueflag;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,39L))= (*aChkI(cntfsms,1L,39L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(8L,GC_PUSHS("[FSM39] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h),GC_PUSHS(crlf),
        GC_PUSHS(" typeLastProcDecl=\'"),cvtypes(typelastprocdecl),
        GC_PUSHS("\'"))));
/*[39] RETURN*/
/*   --
.LABEL [<++PSAIL PROCEDURE: FSM39>]
.INDEX ++PSAIL PROCEDURE: FSM39
	If doing G.C. in SAIL style, then map NON-String
	  procedure returns such as:
		'return(arg)' 
	  to
		GC_NRETURN(arg)
	  If it IS a String procedure, then map it to
		GC_SRETURN(arg)

	If there are any String declarations in the
	procedure, then
		GC_RETURN

	If it is not a string procedure and there are no string
	variables declared in the procedure, then just map it 
	to itself, i.e.

		return(arg)
	or	return.
	NOTE: could have the situation of
		return end
	or	return else

	NOTE: we only need to do this IFF there were a string
	declaration in progress.

	In addition, if we are exiting a procedure where
	GC, dynamic storage or profiling was done, we need to
	also deallocate the BLOCK EXIT as well.

	By definition, a Return is from some inner block
	level > 2 to block level 2 (assuming non-nested
	procedures).

	When one is returning from a procedure each local string
pointer variable needs to be removed from this stack as follows by
trapping all
	'return(...)'	or 'return'
statements for the procedure and emitting one of the following macro
definitions for the SAIL 'return. Note that 'n' is a returned number
and 's' is a returned string.

	PSAIL MACRO MAPPINGS FOR 'return'
	---------------------------------
.LABEL [<FSM39-RETURN-MACRO-TABLE>]
        Use     |        String     Return     Procedure uses
        Macro   |        Procedure  Value      String variables
        -----            ---------  ---------  ----------------
        return               no         no         no
        return(n)            no         yes        no
        GC_RETURN            no         no         yes
        GC_NRETURN(n)        no         yes        yes
        return(GC_PUSH(s))   yes        yes        no
        GC_SRETURN(s)        yes        yes        yes
.ENDLABEL [<FSM39-RETURN-MACRO-TABLE>]
.ENDLABEL [<++PSAIL PROCEDURE: FSM39>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(s2); /* for G.C. */
	GC_NOTESTRING(rexpr); /* for G.C. */
	GC_NOTESTRING(ws); /* for G.C. */
	GC_NOTESTRING(prfstr); /* for G.C. */
	GC_NOTESTRING(prfws); /* for G.C. */
	if ((typelastprocdecl&0100000L)==0) err_hlr(GC_PUSHS(
	"[FSM39] Can only RETURN from within procedure body."));
	midofexpr= 1L;
	ws= PNULL;
	map_whitespace(&ws);
	oldtoken= saitoken;

	hlproc= hash_c(GC_PUSHS(lastprocedure));  /*  -- check target level */
	toblklevel= (*aChkI(declblklvl,1L,(*aChkI(dwptr,1L,hlproc))));

/*  --	Deallocate (dynamic-arrays, profile, string pointers for GC)
if required by global switches and state of block structure.
 */
/*  # # @V.48.153		sSize_locSptr - blkSPDLptr[2] */
/*  # # @V.566.139	sSize_locSptr - blkSPDLptr[toBlkLevel] */
	ssize= locsptr -(*aChkI(blkspdlptr,1L,toblklevel+1L));
				/*  -- in case nested procedure */
	arelocstrflag= ((ssize>0) &&
			(0<(*aChkI(blkspdlptr,1L,blocklevel)) && (*aChkI(blkspdlptr,1L,blocklevel))<locsptr));
/*  # # DBUG('40000,"[FSM39].0.1 blockLevel="&CVS(blockLevel)&" toBlkLevel="&CVS(toBlkLevel)&CRLF&" locSptr='"&CVS(locSptr)&"' sSize="&CVS(sSize)) */
/*  # # DBUG('40000,"[FSM39].0.2 blkSPDLptr[toBlkLevel+1]='"&CVS(blkSPDLptr[toBlkLevel+1])&" lastProcedure='"&lastProcedure&"' areLOCSTRflag="&PBOOL(areLOCSTRflag)) */

/*  # # @V.45.191 ALL PROCEDURES ARE DECLARED AT BLOCK LEVEL 2, NOT
'blockLevel' !!!! IF THIS IS ONE THAT ISN'T, THEN WE WILL GENERATE
CRAP.!!! We need to test blockLevel of procedure we are in, i.e.
toBlkLevel.
 */

	rcode= (((ps_itrash_= (typelastprocdecl&037))>0) ? (ps_itrash_+0140L)
				:0L);
	while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
/*  # # DBUG('40000,"[FSM39].1 rCode='"&(ps!sTrash!_rCode)&"'"&CRLF&" typeLastProcDecl='"&CVTYPES(typeLastProcDecl)&"'"&CRLF&" saiStatement='"&saiStatement&"'"&" NODE[lastProcedure='"&lastProcedure&"']="&PRT!NODE(HASH!C(lastProcedure))) */

	actualreturnvalueflag= 0L;
	expectreturnflag= ((((ps_itrash_= (typelastprocdecl&037))>0) ? (ps_itrash_+0140L)
				:0L)!=codevoid);

/*  ---------------------------------------------------- */
/*  -	Generate the particular type of RETURN needed  */
/*  ---------------------------------------------------- */
/*  # # @V.56.91 NOTE: what if have: 'RETURN VARIABLE' or 'RETURN ELSE'? */
	if (expectreturnflag)
		{/* process return arg */
		if (rcode==codestring&&(ssize>0) &&usegcflag
/*   # # @V.56.118  		And areLOCSTRflag  */) s= "GC_SRETURN"; 
		else if (ssize>0&&usegcflag) s= "GC_NRETURN"; 
		else s= "return";
		}/* process return arg */

	else	{/* process NO return arg */
		if (ssize!=0&&usegcflag) s= "GC_RETURN"; 
		else s= "return";
		}/* process NO return arg */
/*  # # DBUG('40000,"[FSM39].1.0.1 s='"&s&"'"&CRLF&" saiStatement='"&saiStatement&"'") */

/*  --------------------------------------------------------- */
/*  - 	Get the actual argument and coerce it if required  */
/*  --------------------------------------------------------- */
	if (expectreturnflag)
		{/* do coercion */
/*  # # DBUG('40000,"[FSM39].1.1 saiStatement='"&saiStatement&"'") */
		rexpr= GC_EPOPS(rightexpr(&saistatement));
		GC_EPOPS(remove_white_ends(GC_PUSHS(rexpr)));
		if (*rexpr!='\0')
			{/* is return value */
			sawreturnflag= 1L;
			actualreturnvalueflag= 1L;
			}/* is return value */
		if (*rexpr=='(') rexpr= subst(GC_PUSHS(rexpr),2L,length(rexpr)-1L);
/*  # # DBUG('40000,"[FSM39].1.2 rExpr='"&rExpr&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
		lasttype= typelastprocdecl&0777174010633L;
/*  # # DBUG('40000,"[FSM39].1.2.1 lastType='"&CVTYPES(lastType)&"'") */
		push(GC_PUSHS(s)); pushnumber(lasttype);
		rexpr= GC_EPOPS(r_d_expr_map(GC_PUSHS(rexpr)));
		atype= lasttype;
		popnumber(&lasttype); pop(&s);
/*  # # DBUG('40000,"[FSM39].1.3 rCode='"&(ps!sTrash!_rCode)&"'"&CRLF&" aType='"&CVTYPES(aType)&"'"&CRLF&" lastType='"&CVTYPES(lastType)&"'") */
		if (((((ps_itrash_= (lasttype&037))>0) ? (ps_itrash_+0140L)
				:0L)!=(((ps_itrash_= (atype&037))>0) ? (ps_itrash_+0140L)
				:0L))
/*  # # @V.52.137	   And ISSCALARTYPE(lastType,aType)  */) rexpr= GC_EPOPS(cvactual_to_expected(lasttype,atype,
								GC_PUSHS(rexpr)));
		if (usegcflag &&rcode==codestring &&
		   !arelocstrflag &&*s=='r')
			{/* return in STRING pdl */
/*  # # @V.56.151		If Not EQU(rExpr[1 for 9],"GC_EPOPS(")
# # # @V.56.151			Then rExpr_"GC_PUSHS(" & rExpr &")"
# # # @V.56.151		Else rExpr_rExpr[10 to inf-1] */ 
			add_gc_pushs(&rexpr);
/*  # # DBUG('40000,"[FSM39].1.3.1 rExpr='"&rExpr&"'") */
				/*  -- Optimize 
				   'GC_PUSHS(GC_EPOPS(...))' 
				   ==> '...' */
			}/* return in STRING pdl */
		rexpr= catlist(3L,GC_PUSHS("("),GC_PUSHS(rexpr),GC_PUSHS(")"));  /*  -- always insert
					the returned value in (...) */
/*  # # DBUG('40000,"[FSM39].1.4 rExpr='"&rExpr&"'"&CRLF&" lastType='"&CVTYPES(lastType)&"'") */
		}/* do coercion */

	else if (*saistatement=='(')
		{/* error */
		err_hlr(GC_PUSHS(
	catlist(7L,GC_PUSHS("[FSM39] Can\'t RETURN value \'"),
	        GC_PUSHS(saistatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
	        GC_PUSHS(" for untyped PROCEDURE \'"),GC_PUSHS(
	        lastprocedure),GC_PUSHS("\'."))));
		rexpr= PNULL;
		}/* error */

	else	{/* what's left */
/*  # # @V.56.145		rExpr_NULL */
/*  # # DBUG('40000,"[FSM39].1.4.1 rExpr='"&rExpr&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
		}/* what's left */

/*  --------------------------------------------------------- */
/*  -	Build the actual RETURN(arg) statement if required */
/*  --------------------------------------------------------- */
/*  # # DBUG('40000,"[FSM39].1.5 s='"&s&"' rExpr='"&rExpr&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
	if (*rexpr!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(rexpr));
	if (*ws!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(ws));
/*  # # DBUG('40000,"[FSM39].1.5.1 s='"&s&"'") */

	if (*s=='G')
		{/* NO ';' after GCxRETURN() macro */
/*  -- NOTE - we must do this since the macro has {...return} block */
		while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
		if (*saistatement==';') ch= LOP(saistatement); /*  -- TRASH it */
		}/* NO ';' after GCxRETURN() macro */
/*  # # DBUG('40000,"[FSM39].2 s='"&s&"'") */

/*  ------------------------------------------------------------ */
/*  - 	Embed it in general procedure block deallocation code  */
/*  ------------------------------------------------------------ */
	s= GC_EPOPS(mak_blk_exit(blocklevel,toblklevel,GC_PUSHS(s)));
/*  # # DBUG('40000,"[FSM39].3 prfWS='"&prfWS&"' didBlkExit="&PBOOL(didBlkExit)&" saiSym[hLproc]='"&saiSym[hLProc]&"' toBLkLevel="&CVS(toBlkLevel)&CRLF&" s='"&s&"'") */
	didblkexit= 0L;  	/*  -- only allow for [FSM25] */

/*  # # DBUG('40000,"[FSM39].4 oldTypeStatement='"&oldTypeStatement&"'") */
	oldtoken= oldtypestatement= "return";
/*  # # DBUG('40000,"[FSM39].5 oldTypeStatement='"&oldTypeStatement&"' oldToken='"&oldToken&"'"&CRLF&" s='"&s&"'"&CRLF&" lastType='"&CVTYPES(lastType)&"'") */
;
	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'i'=<L0> integer                              */
/* 'prfws'=<L0> string                           */
/* 'prfstr'=<L0> string                          */
/* 's2'=<L0> string                              */
/* 's1'=<L0> string                              */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/


}/* FSM39 */
