/* FILE: fsm4.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsma.c, being converted 12/25/87, 05:15:20PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  -------------------------------------------------------- */
/*INTERNAL*/  STRING fsm4(h)
	INTEGER h;
{/* FSM4 */
STRING lexpr, 
	id, 
	e1, 
	e2, 
	e3, 
	s, 
	s1, 
	s2, 
	nexttoken,
	lb1, 
	lb2, 
	ub1, 
	ub2, 
	id1, 
	id2, 
	bk2str, 
	idname, 
	suffix;
INTEGER i, 
	j, 
	k, 
	m, 
	brktcnt, 
	ch, 
	isarraysliceflag, 
	bk1, 
	nbktcount,
	rtype, 
	idtype, 
	cs, 
	hs, 
	thistype;


{/* INCFSM */
if (usecntfsmflag)
   (*aChkI(cntfsms,1L,4L))++;
}/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(14L,GC_PUSHS("[FSM4] \'rule\' NODE["),
			      GC_PUSHS(*aChkC(saisym,1L,h)),
			      GC_PUSHS("]="),prt_node(h),
			      GC_PUSHS(" oldToken=\'"),
			      GC_PUSHS(oldtoken),GC_PUSHS("\'"),
			      GC_PUSHS(" cStatement=\'"),
			      GC_PUSHS(cstatement),GC_PUSHS("\'"),
			      GC_PUSHS(crlf),
			      GC_PUSHS(" lastType=\'"),
			      cvtypes(lasttype),GC_PUSHS("\'"))));
/*[4] [<expr>*/
/*   --
 .LABEL [<++PSAIL PROCEDURE: FSM4>]
 .INDEX ++PSAIL PROCEDURE: FSM4
	 NOTE: If the <lValue> is DW!macro, then we must expand it so
	 that we can check if it is an array or string...

	 (a)	Map non-LEAP and non-String array specifications as
	 follows:
	   a.1)	If /NOCHECK or DW!cArray
	 SAIL:		[e1,e2,...,en]
	 to
	 C:		[e1][e2]...[en].
	 Also compute the number of [] pairs found and emit a
	 warning message if the ID is a DUMMY variable and the
	 count > 1.
 or	  a.2)  if /CHECK and UNSAFE array And Not DW!cArray
			 (*aChkX(id,n,e1,e2,...,en))
 or	  a.3)  if /CHECK and SAFE array And Not DW!cArray
			 (*aAdrX(id,n,e1,e2,...,en))
	 Where: X is a suffix internal PSAIL type code
		 I = Integer, F = Real, C = String etc.

	 (b)	For SAIL LEAP bracketed triples:
	 If oldToken is a sail operator and not a user
	 defined symbol, then parse as a LEAP bracketed triple
	 of type ITEMVAR.
	 Map SAIL:	[a XOR o EQV v]
	 to C:		fndT(a,o,v)

	 (c)	For SAIL sub strings:
	 If <id>[a TO b] or <id>[a FOR b] then 
	   MAP: <id>[a TO/FOR b] 
	   TO:  strsub(<id>, a, "to/for", b)
	 Additional rule: If 'inf' appears in either a or b then
		 map it to 'length(lExpr)'
	 Additional rule [@V.46.98]: We can do some optimization
		 on substrings of the form 
			 's[j for 1]'
	 to 		'(*(s+j-1))' 
	 and set the type to INTEGER instead of STRING.
	 If j=1 then simply use '(*s)'.
	 NOTE: @V.46.98 SAIL implements (see [Reiser] pg 48)
	 substrings as follows:
		 s[a for b]	as	subsr(s,a,b)
	 and
		 s[a to b]	as	subst(s,a,b).
	 If <id> is a quoted string constant and a and b are
	 integers then eval it here to optimize it.

	 (d)	If /EXTENSIONS, then look for [a:b] and test whether
	 this is an ARRAY-SLICE assignement. If so then map as
	 follows:
	 MAP SAIL: a1[lb1:ub1]:=a2[lb2:ub2]
	 To C:	arrblt(&a1[lb1],&a2[lb2],
			 MAX((ub1-lb1),(ub2-lb2))+1)
	 NOTE: this is done by backing up into saiStatement
	   arrblt(a1[lb1],a2[lb2],((ub1-lb1) MAX (ub2-lb2))+1)
	 and then re-EVALing it.
 .ENDLABEL [<++PSAIL PROCEDURE: FSM4>]
  */

 /*  . . . Initialize */
 GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
 GC_NOTESTRING(lexpr); /* for G.C. */
 GC_NOTESTRING(id); /* for G.C. */
 GC_NOTESTRING(e1); /* for G.C. */
 GC_NOTESTRING(e2); /* for G.C. */
 GC_NOTESTRING(e3); /* for G.C. */
 GC_NOTESTRING(s); /* for G.C. */
 GC_NOTESTRING(s1); /* for G.C. */
 GC_NOTESTRING(s2); /* for G.C. */
 GC_NOTESTRING(nexttoken); /* for G.C. */
 GC_NOTESTRING(lb1); /* for G.C. */
 GC_NOTESTRING(lb2); /* for G.C. */
 GC_NOTESTRING(ub1); /* for G.C. */
 GC_NOTESTRING(ub2); /* for G.C. */
 GC_NOTESTRING(id1); /* for G.C. */
 GC_NOTESTRING(id2); /* for G.C. */
 GC_NOTESTRING(bk2str); /* for G.C. */
 GC_NOTESTRING(idname); /* for G.C. */
 GC_NOTESTRING(suffix); /* for G.C. */
 nbktcount= 0;
 idname= oldtoken;
 idtype= lasttype;

 pushnumber(midofexpr); midofexpr= 1L;
 pushnumber(lasttype);

 /*  --------------------------------------- */
 /*  . . . Check for bracketed triples . . . */
 /*  --------------------------------------- */
 s1= saistatement;
 while ((*s1!='\0') && iswhitespace((INTEGER)*s1))
    ps_itrash_= LOP(s1);
 nexttoken= GC_EPOPS(rightid(&s1));	/*  -- look ahead... */
 rtype= chk_type(GC_PUSHS(nexttoken));
 /*  # # DBUG('40000,"[FSM4].0.0.2 lastType='"&CVTYPES(lastType)&"'"&CRLF&
     "  rType="&CVTYPES(rType)&CRLF&" i="&CVS(i)&
     " nextToken="&nextToken&CRLF&" sPDLptr="&CVS(sPDLptr)&
     " nPDLptr="&CVS(nPDLptr)) */
 if (isleapcode(rtype))
   {/* Parse as LEAP bracketed triple */
     s1= GC_EPOPS(copy_omit(GC_PUSHS("]")));
 /*  # # DBUG('40000,"[FSM4].0.0.3 s1='"&s1&"'") */
     s= ((ismakeflag) ?  "make" : "fndT");
     if (*ps__leap_!='\0')
       s= catlist(2L,GC_PUSHS(s),GC_PUSHS(ps__leap_));
     s= catlist(4L,GC_PUSHS(s),GC_PUSHS("("),map_leap_triple(&s1),
		GC_PUSHS(")"));
 /*  # # DBUG('40000,"[FSM4].0.0.4 Evaled BRKTD-TRPL s="&s) */
     popnumber(&lasttype);	/*  -- fix PDL */
     popnumber(&midofexpr);
     lasttype= 020000L;
     pdw_ptype(lasttype,codeitemvar);
     pdw_itemtype(lasttype,2L); /*  -- bracketed triple */

     {GC_UNMARKSSTKFRAME;
      GC_SRETURN(s);}
   }/* Parse as LEAP bracketed triple */

 /*  ------------------------------------------------------------------- */
 /*  . . . FORCE EVAL OF ALL <left-id> MACROS WHICH ~ DW!fragments . . . */
 /*  ------------------------------------------------------------------- */
 if ((idtype&02000L) && (idtype&01000L)==0)
   {/* must PSAIL!EVAL it */
     INTEGER idx, 
	     hi, 
	     ci;
 /*  # # DBUG('40000,"[FSM4].0.0.1 idName='"&idName&"'"&CRLF&
     "  idType="&CVTYPES(idType)) */
     idx= find_symbol(GC_PUSHS(idname),&ci,&hi);
 /*  # # DBUG('40000,"[FSM4].0.0.2 PRT!NODE["&idName&"]="&PRT!NODE(hI)) */
     idname= (*aChkC(declsize,1L,idx)); 	/*  -- Evaled SAIL (ie. C) code */
 /*  # # @V.52.181		idName_R!D!EXPR!MAP(idName) */
     idtype= lasttype&0777777777677L;
 /*  # # DBUG('40000,"[FSM4].0.0.3 idName='"&idName&"'"&CRLF&
     "  idType="&CVTYPES(idType)) */
     popnumber(&ch);	 /*  -- use new type */
     pushnumber(lasttype);	 /*  -- save new type */
     lexpr= GC_EPOPS(left_expr(&cstatement,1L)); /*  -- skip
						     past left comments */
     if (*lexpr=='(') 
       {/* push back '(' */
	 if (*cstatement=='\0') 
	   cstatement= GC_EPOPS(makstr(LOP(lexpr)));
	 else cstatement= catlist(2L,GC_PUSHS(cstatement),
				  GC_PUSHS(LOP(lexpr)));
       }/* push back '(' */
     if (*cstatement=='\0')
       cstatement= idname; 
     else cstatement= catlist(2L,GC_PUSHS(cstatement),GC_PUSHS(idname));
 /*  # # DBUG('40000,"[FSM4].0.0.4 idName='"&idName&"'"&CRLF&
     "  idType="&CVTYPES(idType)&CRLF&"  lExpr='"&lExpr&
     "' NEW cStatement='"&cStatement&"'") */
   }/* must PSAIL!EVAL it */

pushnumber(isarrayadrflag);
isarrayadrflag= 1L;             /*  -- so gen ++<id> not <id>++
				    and don't trap 'FOR' */
s2= s1= GC_EPOPS(copy_omit(GC_PUSHS("]")));
ch= LOP(s2);	                /*  -- set s2:=s1[2 to inf] */
k= length(GC_PUSHS(s1));        /*  -- Find end of subscr. expr */
/*  # # DBUG('40000,"[FSM4].0.1  k="&CVS(k)&" s1='"&s1&"'"&CRLF&
    " s2='"&s2&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
isarraysliceflag= 0L;

/*  -------------------------------------------------- */
/*  .  .  .  CHECK FOR SUBSTRING SPECIFICATION  .  .   */
/*  -------------------------------------------------- */
for (j=2;j<=k;j++)
  {/* match it */
    ch= LOP(s2);	/*  -- ch := s1[j for 1] and
			    # -- s2 := s1[j+1 to inf] */
    if (useextensionsflag && (ch==':') && (*s2!='='))
      {/* may be an ARRAY-SLICE else error */
	isarraysliceflag= 1L;
	break;
      }/* may be an ARRAY-SLICE else error */

    else if (!isalpha(makstr(ch)) &&
	     ( (equ(subsr(GC_PUSHS(s2),1L,2L),GC_PUSHS("to")) &&
		!isalpha(makstr((*(s2+3-1)))) ) ||
	      (equ(subsr(GC_PUSHS(s2),1L,3L),GC_PUSHS("for")) &&
	       !isalpha(makstr((*(s2+4-1)))) )
	      ))
           {/* It is a subString spec. */
	    INTEGER e1type, 
	            e2type;
/*  # # DBUG('40000,"[FSM4].1 ch='"&(ps!sTrash!_ch)&
    "' rEvalFlag="&PBOOL(rEvalFlag)&CRLF&
    " s1[1 to j]='"&s1[1 to j]&"'"&CRLF&
    " s1[j+1 to inf]='"&s1[j+1 to inf]&"'"&CRLF&" s2='"&s2&"'") */
	    lexpr= GC_EPOPS(left_expr(&cstatement,1L)); 
	                         /*  -- skip past left comments */
	    if (*lexpr=='(') 
	      cstatement= catlist(2L,GC_PUSHS(cstatement),
				  GC_PUSHS(LOP(lexpr)));
	                         /* Push it back*/
	    if (*s2=='t')
	      m=  4L; 
	    else m= 5;
		                /*  -- Get left (e1) and right (e2) args */
	    e1= subst(GC_PUSHS(s1),1L,j-1L);
	    e2= subst(GC_PUSHS(s1),(j+m),length(s1));
/*  # # DBUG('40000,"[FSM4].2 e1='"&e1&"' e2='"&e2&"' lExpr='"&lExpr&"'") */
	    pushnumber(m);
	    push(GC_PUSHS(lexpr)); push(GC_PUSHS(e2));
	    e1= GC_EPOPS(map_inf(GC_PUSHS(e1),GC_PUSHS(lexpr)));
	    e1type= lasttype;
	    pop(&e2); pop(&lexpr);
	    push(GC_PUSHS(e1)); push(GC_PUSHS(lexpr));
	    e2= GC_EPOPS(map_inf(GC_PUSHS(e2),GC_PUSHS(lexpr)));
	    e2type= lasttype;
	    pop(&lexpr); pop(&e1);
	    popnumber(&m);
	    popnumber(&isarrayadrflag);
	    popnumber(&lasttype);
	    popnumber(&midofexpr);
/*  # # DBUG('40000,"[FSM4].2.1 e1='"&e1&"' e2='"&e2&
    "' lExpr='"&lExpr&"'"&CRLF&" isArrayAdrFlag="&PBOOL(isArrayAdrFlag)&
    " midOfExpr="&PBOOL(midOfExpr)&CRLF&
    " lastType='"&CVTYPES(lastType)&"'") */

	    if (chk_sconst(GC_PUSHS(lexpr),&s2,0L) &&
		chk_iconst(makstr((INTEGER)1.0E1),&j) &&
		chk_iconst(makstr((INTEGER)1.0E2),&k))
	      {/* OPTIMIZE! eval it here! */
/*  # # DBUG('40000,"[FSM4].2.1.1 EVAL s2='"&s2&"'"&CRLF&
    " j="&CVS(j)&" k='"&CVS(k)&"'") */
	        s= catlist(3L,GC_PUSHS(quote),
			   GC_PUSHS((m==4) ? subst(GC_PUSHS(s2),j,k)
				           : subsr(GC_PUSHS(s2),j, k)),
			   GC_PUSHS(quote));
		pdw_ptype(lasttype,codestring);
/*  # # DBUG('40000,"[FSM4].2.1.2 s='"&s&"'") */
	       }/* OPTIMIZE! eval it here! */

	    else if (fast_equ(GC_PUSHS(e2),GC_PUSHS("1")))
	           {/* optimize single char */
		     if (fast_equ(GC_PUSHS(e1),GC_PUSHS("1")))
		       s= catlist(3L,GC_PUSHS("(*"),GC_PUSHS(lexpr),
				  GC_PUSHS(")"));
		     else s= catlist(5L,GC_PUSHS("(*("),GC_PUSHS(lexpr),
				     GC_PUSHS("+"),GC_PUSHS(e1),
				     GC_PUSHS("-1))"));
		     pdw_ptype(lasttype,codeinteger);
		   }/* optimize single char */
	    else {/* Map to <sairun.c> call */
		  if (usegcflag)
		    add_gc_pushs(&lexpr);
		  pdw_ptype(lasttype,codeinteger);
		  e1= GC_EPOPS(cvactual_to_expected(lasttype,
						    e1type,GC_PUSHS(e1)));
		  e2= GC_EPOPS(cvactual_to_expected(lasttype,
						    e2type,GC_PUSHS(e2)));
/*  # # @V.46.71 -- OLD --		s_"strsub(" & lExpr & "," &
 # # # @V.46.71 -- OLD --			e1 & "," & quote &
 # # # @V.46.71 -- OLD --		         (If m=4
 # # # @V.46.71 -- OLD --		  		Then "to"
 # # # @V.46.71 -- OLD --		    		Else "for") &
 # # # @V.46.71 -- OLD --		  	quote & "," & e2 & ")" */
		  s = catlist(7L,GC_PUSHS((m==4) ? "subst(" : "subsr("),
			      GC_PUSHS(lexpr),GC_PUSHS(","),GC_PUSHS(e1),
			      GC_PUSHS(","),GC_PUSHS(e2),GC_PUSHS(")"));
		  pdw_ptype(lasttype,codestring);
		  sawstrfct= 1L;
	        }/* Map to <sairun.c> call */
/*  # # DBUG('40000,"[FSM4].2.2 s='"&s&"'"&CRLF&
    "  lastType='"&CVTYPES(lastType)&"'") */

	    {GC_ADJSTKFRAME(1);
	     GC_SRETURN(s);}
	}/* It is a subString spec. */
  }/* match it */


/*  ------------------------------------------------ */
/*  . . . NOT STRING, do access method on 's1' . . . */
/*  ------------------------------------------------ */
s= PNULL;
	/*  -- if /EXTENSIONS then allow ARRAY-SLICES */
if (isarraysliceflag)
  {/* parse ARRAY-SLICE */
/*  # # DBUG('40000,"[FSM4].2.3 SLICE s1='" & s1 & "'"&CRLF&

    "  saiStatement='"&saiStatement&"'") */
      while ((*saistatement!='\0') && 
	     iswhitespace((INTEGER)*saistatement))
	ps_itrash_= LOP(saistatement);
      s= catlist(2L,GC_PUSHS(LOP(saistatement)),GC_PUSHS(LOP(saistatement)));
					 /*  -- get ':='  */
      while ((*saistatement!='\0') && 
	     iswhitespace((INTEGER)*saistatement))
	ps_itrash_= LOP(saistatement);  /*  -- get 2nd oprnd */
      id2= GC_EPOPS(scan(&saistatement,11L,&ch));  /*  -- Copy to '[' */
      s2= GC_EPOPS(copy_either(GC_PUSHS("]"),&bk2str));
      lb2= GC_EPOPS(scan(&s2,13L,&bk1));
      ub2= s2;
/*  # # DBUG('40000,"[FSM4].2.3.1 s2='"&s2&"' lb2='"&lb2&
    "' ub2='"&ub2&"'"&CRLF&"  s='"&s&"'"&CRLF&
    "  cStatement='"&cStatement&"'") */
      if (!equ(GC_PUSHS(s),GC_PUSHS(":=")) ||(*bk2str!=']') ||
	  (ch!='[') ||(bk1!=':'))
	err_hlr(GC_PUSHS("[FSM4] ARRAY-SLICE syntax error"));
      id1= GC_EPOPS(left_id(&cstatement));
      lb1= GC_EPOPS(scan(&s1,13L,&ch));	/*:*/
      ub1= s1;
      s= catlist(17L,GC_PUSHS("arrblt("),GC_PUSHS(id1),GC_PUSHS("["),
		 GC_PUSHS(lb1),GC_PUSHS("],"),GC_PUSHS(id2),GC_PUSHS("["),
		 GC_PUSHS(lb2),GC_PUSHS("],(("),GC_PUSHS(ub1),GC_PUSHS("-"),
		 GC_PUSHS(lb1),GC_PUSHS(")min("),GC_PUSHS(ub2),GC_PUSHS("-"),
		 GC_PUSHS(lb2),GC_PUSHS("))+1)"));
      if (*saistatement=='\0')
	saistatement= s; 
      else saistatement= catlist(2L,GC_PUSHS(s),GC_PUSHS(saistatement));
                                                     /*  -- backup */
/*  # # DBUG('40000,"[FSM4].2.3.2 s1='"&s1&"' id1='"&id1&
    "' lb1='"&lb1&"' ub1='"&ub1&"'"&CRLF&"  s='"&s&"'"&CRLF&
    "  cStatement='"&cStatement&"'") */
      s= PNULL;
      popnumber(&isarrayadrflag);
      popnumber(&lasttype);  /*  -- NOTE: i.e. old type */
      popnumber(&midofexpr);

      {GC_UNMARKSSTKFRAME;
       GC_SRETURN(s);}
  }/* parse ARRAY-SLICE */

else if ((!usechkflag) || (lasttype&0200000L))
  {/* Use C language array access method */
/*  ----------------------------------------------------------- */
/*  . . . CVT: <variable>[a,b,c] ==> <variable>[a][b][c] . . .
 # . . . . . .Scan for ']' checking for '[' looking for ',' .
 # . . . . . .Map all ',' to ']['  */
/*  ----------------------------------------------------------- */

      pushnumber(idtype); push(GC_PUSHS(idname));
      push(GC_PUSHS(saistatement));
      saistatement= catlist(2L,GC_PUSHS(s1),GC_PUSHS(","));
                                      /*  -- Now map ',' to  ']'  */
      pdw_ptype(lasttype,chk_type(GC_PUSHS(oldtoken)));
/*  # # DBUG('40000,"[FSM4].3 oldToken='"&oldToken&
    " lastType='"&CVTYPES(lastType)&"' s1='"&s1&"'") */
      s= "@";			/*  -- leader character */
      while ((*saistatement!='\0'))
	{/* map [<arg-list>] */
/*  # # DBUG('40000,"[FSM4].3.1 s='"&s&"'"&CRLF&
    " saiStatement="&saiStatement) */
	    e1= GC_EPOPS(copy_omit(GC_PUSHS(",")));   /*  -- SPECIAL!!! */
	    ++nbktcount;
	    pushnumber(nbktcount);
	    push(GC_PUSHS(s)); push(GC_PUSHS(s1));
	    pushnumber(isarrayadrflag);
	    pdw_ptype(lasttype,codeinteger);
/*  # # @V.48.55 May mave to push more stuff to get full R!D!... */
	    s2= GC_EPOPS(r_d_expr_map(GC_PUSHS(e1)));
	    if (!isunaryscalartype(lasttype)) 
	      {/* CVT it */
		thistype= 0;
		pdw_ptype(thistype,codeinteger);
		s2= GC_EPOPS(cvactual_to_expected(thistype,
						  lasttype,GC_PUSHS(s2)));
	      }/* CVT it */
	    popnumber(&isarrayadrflag); pop(&s1); pop(&s);
	    popnumber(&nbktcount);
	    s= catlist(4L,GC_PUSHS(s),GC_PUSHS("["),GC_PUSHS(s2),
		       GC_PUSHS("]"));
/*  # # DBUG('40000,"[FSM4].3.2 s='"&s&"'"&CRLF&
    " saiStatement="&saiStatement) */
	    if (*saistatement==',')
	      ch= LOP(saistatement);
	  }/* map [<arg-list>] */
      pop(&saistatement); pop(&idname); popnumber(&idtype);
      ch= LOP(s);			/*  -- trash '@' */

      /*  -- Check if the number of [][] > 1 for dummy var */
/*  # # DBUG('40000,"[FSM4].3.3 idType='"&CVTYPES(idType)&"'"&CRLF&
    " cStatement='"&cStatement&"'") */
      if (!slobflag && (idtype&040000L) &&(nbktcount>1))
	{/* error */
	  s= catlist(2L,GC_PUSHS(s),GC_PUSHS(crlf));
	  err_deathwish(&s,
			catlist(7L,GC_PUSHS("WARNING! "),cvs(nbktcount),
	GC_PUSHS("-dim. array formal arg. access is not portable for"),
				GC_PUSHS(crlf),GC_PUSHS("C ARRAY\'"),
				GC_PUSHS(idname),
        GC_PUSHS("\' access. Manually edit or use PSAIL dynamic arrays.")),
			10L,(INTEGER)('N'));
       }/* error */

      if (!slobflag && ((idtype&0350)==0)) 
	{/* Array mis-declar error */
	  if (!(idtype&020000L)) 
	    {/* error */
	      s2= cstatement; /*  -- get <lExpr> for errMSG */
	      idname= GC_EPOPS(left_id(&s2));
	      err_hlr(catlist(10L,
GC_PUSHS("[FSM4] Can\'t do array operation on non-array declared variable \'"),
			      GC_PUSHS(idname),GC_PUSHS("\'"),
			      GC_PUSHS(crlf),
			      GC_PUSHS(" Declaration of \'"),GC_PUSHS(idname),
			      GC_PUSHS("\' is \'"),cvtypes(idtype),
			      GC_PUSHS("\'"))));
        }/* error */
    }/* Array mis-declar error */
  }/* Use C language array access method */

else
  {/* Use ARRAY DESCRIPTORS access method */
/*  ---------------------------------------------------------------- */
/*  . . . CVT TO ARRAY DESCRIPTORS: <variable>[a,b,c] ==> 
 # . . . . If SAFE:	(*aChk<variable>,nArgs,a,b,c))
 # . . . . If UNSAFE:	(*aAdr(<variable>,nArgs,a,b,c)) */
/*  ---------------------------------------------------------------- */
    INTEGER ptype;
/*  # # DBUG('40000,"[FSM4].4 oldToken='"&oldToken&"' s='"&s&"'"&CRLF&
    " cStatement='"&cStatement&"'"&CRLF&
    " lastType='"&CVTYPES(lastType)&"'") */
    id= GC_EPOPS(left_id(&cstatement));   /*  -- get array name */
    i= find_symbol(GC_PUSHS(id),&cs,&hs);
    lasttype= (*aChkI(decldw,1L,i));
    if ((lasttype&0400000L)!=0) 
       s= "(*aAdr"; 
    else s= "(*aChk";
    if ((ptype= (((ps_itrash_= (lasttype&037))>0)
                              ? (ps_itrash_+0140L) : 0L))==0)
      {/* trouble - undefined!!! */
	if (ismacroflag) isfragmentflag= 1L;
	else ptype= codeinteger;  /*  -- default */
      }/* trouble - undefined!!! */
    suffix= GC_EPOPS(cvupcase(makstr(ptype)));
                        	/*  -- i.e. PSAIL internal TYPE code */
    s= catlist(5L,GC_PUSHS(s),GC_PUSHS(suffix),GC_PUSHS("("),
	       GC_PUSHS(id), GC_PUSHS(","));
/*  # # DBUG('40000,"[FSM4].4.1 id='"&id&"' s='"&s&"'"&CRLF&
    " cStatement='"&cStatement&"'"&CRLF&" lastType='"&CVTYPES(lastType)&"'") */

/*  ----------------------------------------------------------- */
/*  . . . . . . . MAP THE ARGLIST - COERCE TO INTEGER IF NEEDED */
/*  ----------------------------------------------------------- */
    m= 0;
    s2= PNULL;
    push(GC_PUSHS(saistatement));
    pushnumber(rdlevel);
    ++rdlevel;          	/*  -- fake COPY!EITHER */
    saistatement= catlist(2L,GC_PUSHS(s1),GC_PUSHS("]"));
                                /*  -- Prep it for terminator */
    while ((*saistatement!='\0'))
       {/* make arg list */
	e1= GC_EPOPS(copy_either(GC_PUSHS(",]"),&e2));
	push(GC_PUSHS(e2)); pushnumber(m); push(GC_PUSHS(s2));
	push(GC_PUSHS(s1)); push(GC_PUSHS(s));
	e1= GC_EPOPS(r_d_expr_map(GC_PUSHS(e1)));
	pop(&s); pop(&s1);
	pop(&s2); popnumber(&m); pop(&e2);
/*  # # @V.54.01 --> was block:
 # # # @V.54.01		If GDW!pType(lastType) Neq CODEinteger
 # # # @V.54.01			Then
 # # # @V.54.01 			Begin "COERCE it!"
*/
	             /*  -- COERCE it to 32-bit INTEGER if need be! */
	thistype= 0;
	pdw_ptype(thistype,codeinteger);
	e1= GC_EPOPS(cvactual_to_expected(thistype,lasttype,
					  GC_PUSHS(e1)));

	if (*s2=='\0') 
	  s2= e1;
	else s2= catlist(2L,GC_PUSHS(s2),GC_PUSHS(e1));
	if (*e2==',')
	  s2= catlist(2L,GC_PUSHS(s2),GC_PUSHS(e2));
	++m;
/*  # # DBUG('40000,"[FSM4].4.2 e1='"&e1&"' e2='"&e2&"' s2='"&s2&
    "' m="&CVS(m)) */
      }/* make arg list */
    popnumber(&rdlevel); pop(&saistatement);
    s1= GC_EPOPS(cvs(m));		/*  -- Add nbr args seen in call */
    s1= GC_EPOPS(cvactual_to_expected(thistype,thistype,GC_PUSHS(s1)));
				        /*  -- force 32-bit INTEGER */
    s= catlist(5L,GC_PUSHS(s),GC_PUSHS(s1),GC_PUSHS(","),GC_PUSHS(s2),
	       GC_PUSHS("))"));         /*  -- Add actual arg list */
/*  # # DBUG('40000,"[FSM4].4.3 s1='"&s1&"'"&CRLF&
    " s2='"&s2&"'"&CRLF&" s='"&s&"'") */
    }/* Use ARRAY DESCRIPTORS access method */

popnumber(&isarrayadrflag);
popnumber(&lasttype);              /*  -- NOTE: this was old type */
popnumber(&midofexpr);
lasttype=lasttype&0777777777577L; /*  -- NOTE: we
				      trash the array marker since we
				      are accessing ONLY an element of
				      the array not the entire array! */
/*  # # DBUG('40000,"[FSM4].5 s='"&s&"'"&CRLF&
    " lastType='"&CVTYPES(lastType)&"'"&CRLF&
    " saiStatement='"&saiStatement&"'") */

GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'brktcnt'=<L0> integer                        */
/* 'e3'=<L0> string                              */
/*************************************************/

}/* FSM4 */

