/* FILE: fsm44.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmd.c, being converted 12/25/87, 07:27:34PM*/

/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */



/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm44(h)
	INTEGER h;
{/* FSM44 */
STRING s, 
	s1, 
	savetoken, 
	srcd, 
	srcdid, 
	smember, 
	lid, 
	trash;
INTEGER brk, 
	i, 
	type, 
	ct, 
	ht, 
	irp, 
	crp, 
	hrp, 
	imem, 
	cmem, 
	hmem,
	hrpclass, 
	hrmemclass, 
	dwrp, 
	itype, 
	dwleaprp, 
	dockemitflag;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,44L))= (*aChkI(cntfsms,1L,44L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM44] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[44] : or ,*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM44>]
.INDEX ++PSAIL PROCEDURE: FSM44
	Map SAIL:	':'
		a) 	':='
		   to C '='
	or	b) 	'<labelId>:'
		   to C '<labelID>:'
	or	c) 	'Rclass:Rmem[Rptr]'
		   to C 'Rptr->RmemR.C.(Rclass)'
	also	MAP SAIL:	','
	To C:		','
.ENDLABEL [<++PSAIL PROCEDURE: FSM44>]
 */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(savetoken); /* for G.C. */
GC_NOTESTRING(srcd); /* for G.C. */
GC_NOTESTRING(srcdid); /* for G.C. */
GC_NOTESTRING(smember); /* for G.C. */
GC_NOTESTRING(lid); /* for G.C. */
GC_NOTESTRING(trash); /* for G.C. */

savetoken= oldtoken;     /*  -- may be RECORD!CLASS id */
oldtoken= ":";
/* 	NOTE: change when doing records to see if record member is to
right in which case change the : to ->  .
	i.e. For class name A, member name B and Record
		pointer C
		eg. <rcrd-class>:<rcrd-member>[<rcrd-pointer]
		Then Map
		SAIL		A:B[C]
		to C		C->B R.C.(A)
 */
if (*saistatement=='=')
   {/* Map := to _ */
    /*  --	Use FSM[:] instead of FSM[:=]! */
     saitoken= catlist(2L,GC_PUSHS(saitoken),GC_PUSHS(LOP(saistatement)));
     s= GC_EPOPS(fsm35(hbackarrow)); /*Go eval it as ':='*/ 
/*  -- NOTE!!!: The following HACK is to fake out PROCESS!TOKEN and
MAP!EXPR to think that it came back from ':=' instead of ':' when we
return -- THIS IS THE ONLY ONE AS FAR AS WE KNOW... THIS TYPE OF
STUFF IS NOTHING BUT TROUBLE. BUT YOU HAVE TO DO WHAT YOU HAVE TO
DO...
*/
     popnumber(&dockemitflag);  /*  --  old value
				    set in MAP!EXPR */
     popnumber(&i);  /*  -- i old USER idx for MAP!EXPR */
     popnumber(&i);   /*  -- i old h for PROCESS!TOKEN */
     pop(&trash);  /*  -- trash old saiToken for MAP!EXPR */
     oldtoken= saitoken= ":=";	  /*  -- so correct */
     push(GC_PUSHS(saitoken));    /*  -- so set lastMappedToken
				      correctly */
     i= find_symbol(GC_PUSHS(":="),&ct,&ht);
     pushnumber(i);  /*  -- new idx for PROCES!TOKEN */
     pushnumber(hbackarrow);	/*  -- new h for MAP!EXPR */
     pushnumber(dockemitflag); /*  -- restore value */
   }/* Map := to _ */

else if (((((ps_itrash_= (((type= (*aChkI(decldw,1L,
				      (i= find_symbol(GC_PUSHS(savetoken),
					          &ct,&ht))))))&037))>0)
	   ? (ps_itrash_+0140L)
	   : 0L)==coderecclass) &&
	 isalpha(GC_PUSHS(saistatement)))
  {/* Member of RECORD */
/*  # # DBUG('40000,"[FSM44].1 Class node="&PRT!NODE(hT)) */
    oldtoken= "->";
    lid= GC_EPOPS(left_id(&cstatement)); /*backup*/
    smember= GC_EPOPS(getid(&saistatement,&brk));
/*  # # DBUG('40000,"[FSM44].1.1 lID='"&lID&"' sMember='"&sMember&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
    if (brk!='[')
      err_hlr(GC_PUSHS(
		   catlist(7L,
			   GC_PUSHS("[FSM44] Missing \'[\' in RECORD access"),
		           GC_PUSHS(crlf),GC_PUSHS("for <class>:<member>=\'"),
		           GC_PUSHS(savetoken),GC_PUSHS(":"),GC_PUSHS(smember),
		           GC_PUSHS("\'"))));

    srcd= GC_EPOPS(copy_either(GC_PUSHS("],;,end"),&s1));
    if (*s1!=']') 
      err_hlr(GC_PUSHS(
		   catlist(9L,
			   GC_PUSHS("[FSM44] Missing \']\' in RECORD access"),
		           GC_PUSHS(crlf),
			   GC_PUSHS("for <class>:<member>[<ptr>]=\'"),
			   GC_PUSHS(savetoken),
		           GC_PUSHS(":"),GC_PUSHS(smember),GC_PUSHS("["),
		           GC_PUSHS(srcd),GC_PUSHS("]\'"))));

    if (chk_id(GC_PUSHS(srcd))) srcdid= srcd; 
    else {/* is an expression */
	  s1= srcd;
	  srcdid= GC_EPOPS(getid(&s1,&brk));
	  if (fast_equ(GC_PUSHS(srcdid),GC_PUSHS("datum")))
	    {/* want datum ARG! */
	      s1= GC_EPOPS(remove_white_ends(GC_PUSHS(s1)));
	      srcdid= GC_EPOPS(getid(&s1,&brk));
	    }/* want datum ARG! */
	  push(GC_PUSHS(srcdid)); push(GC_PUSHS(smember));
	  push(GC_PUSHS(savetoken)); push(GC_PUSHS(oldtoken));
	  push(GC_PUSHS(lid)); pushnumber(ct);
	  pushnumber(ht); pushnumber(i);
	  srcd= GC_EPOPS(r_d_expr_map(GC_PUSHS(srcd)));
	  popnumber(&i); popnumber(&ht);
	  popnumber(&ct); pop(&lid);
	  pop(&oldtoken); pop(&savetoken);
	  pop(&smember); pop(&srcdid);
        }/* is an expression */
/*  # # DBUG('40000,"[FSM44].2 sRcdID='"&sRcdID&"' sRcd='"&sRcd&"'") */

    imem= find_rc_symbol(GC_PUSHS(smember),&hmem,ht);
/*  # # DBUG('40000,"[FSM44].2.1 sMember node="&PRT!NODE(-iMem)) */

    irp= find_symbol(GC_PUSHS(srcdid),&crp,&hrp);
    if ((ht==hany_class))
      err_n_p(&lid);
/*  # # DBUG('40000,"[FSM44].3 lID='"&lID&"' sRcd node="&PRT!NODE(hRP)) */

    s= catlist(5L,GC_PUSHS(srcd),GC_PUSHS("/*("),GC_PUSHS(lid),
	       GC_PUSHS(")*/->"),GC_PUSHS(smember));
    lasttype= (*aChkI(decldw,1L,imem));   /*  -- type of a record
					      member access is that of the
					      member! not the pointer */
    hrpclass= (*aChkI(declrclass,1L,irp));  /*  -- hash pointer of
						associated class */
    hrmemclass= (*aChkI(declrclass,1L,imem));  /*  -- hash ptr of
						   associated class */
/*  # # DBUG('40000,"[FSM44].3.1 hRmemClass="&CVS(hRmemClass)&"='"&saiSym[hRmemClass]&"'"&CRLF&"  hRPClass="&CVS(hRPClass)&"='"&saiSym[hRPClass]&"'"&CRLF&"  lastType='"&CVTYPES(lastType)&"'")
*/
    if ((lasttype&01000000L)==0||
	((hrmemclass!=hrpclass) &&
	 (hrmemclass!=hany_class) &&
	 (hrpclass!=hany_class)))
      err_hlr(GC_PUSHS(
		       catlist(31L,GC_PUSHS("[FSM44] \'"),GC_PUSHS(smember),
			       GC_PUSHS("\' isn\'t RECORD!CLASS \'"),
			       GC_PUSHS(savetoken),
			       GC_PUSHS("\' member,"),GC_PUSHS(crlf),
			       GC_PUSHS(" for \'"),
			       GC_PUSHS(savetoken),GC_PUSHS(":"),
			       GC_PUSHS(smember),
			       GC_PUSHS("["),GC_PUSHS(srcd),GC_PUSHS("]\',"),
			       GC_PUSHS(crlf)
			       ,GC_PUSHS(" Record class of \'"),
			       GC_PUSHS(smember),
			       GC_PUSHS("\' = \'"),
			       GC_PUSHS(*aChkC(saisym,1L,hrmemclass)),
			       GC_PUSHS("\',"),GC_PUSHS(crlf),
			       GC_PUSHS(" Record class of REC!PTR \'"),
			       GC_PUSHS(srcdid),
			       GC_PUSHS("\' = "),
			       GC_PUSHS(*aChkC(saisym,1L,hrpclass)),
			       GC_PUSHS("\'"),GC_PUSHS(crlf),
			       GC_PUSHS(" type["),
			       GC_PUSHS(smember),GC_PUSHS("]=\'"),
			       cvtypes(lasttype),
			       GC_PUSHS("\'."))));

    dwrp= (*aChkI(decldw,1L,irp));
    dwleaprp= (dwrp&020000L)
            ? cvltypep(itype= gdw_itemtype(dwrp))
	    : (itype= 0);             /*  -- no LEAP type */
/*  # # DBUG('40000,"[FSM44].3.2 iType="&CVS(iType)&CRLF&"  dwLeapRP='"&
    CVTYPES(dwLeapRP)&"'"&CRLF&"  dwRP="&CVTYPES(dwRP)&"'"&CRLF&"  hT="&
    CVS(hT)&"='"&saiSym[hRPclass]&CRLF&"  hRPClass="&CVS(hRPClass)&"='"&
    saiSym[hRPClass]&"'") */
    if (!( ((dwrp&0777777757777L) &&
	    ((((ps_itrash_= (dwrp&037))>0)
	      ? (ps_itrash_+0140L)
	      : 0L)==coderecptr)) ||
	  ((dwrp&020000L) &&
	   ((((ps_itrash_= (dwleaprp&037))>0)
	      ? (ps_itrash_+0140L)
	      : 0L)==coderecptr))
	  ) ||
	((hrpclass!=ht) &&
	 (hrpclass!=hany_class)))
      err_hlr(GC_PUSHS(
          catlist(25L,GC_PUSHS("[FSM44] \'"),GC_PUSHS(srcd),
		  GC_PUSHS("\' isn\'t RECORD ptr of RECORD CLASS \'"),
		  GC_PUSHS(savetoken),GC_PUSHS("\'"),GC_PUSHS(crlf),
		  GC_PUSHS(" for \'"),GC_PUSHS(savetoken),GC_PUSHS(":"),
		  GC_PUSHS(smember),GC_PUSHS("["),GC_PUSHS(srcd),
		  GC_PUSHS("]\',"),GC_PUSHS(crlf),
		  GC_PUSHS(" Record class of \'"),GC_PUSHS(srcd),
		  GC_PUSHS("\' is \'"),GC_PUSHS(*aChkC(saisym,1L,hrpclass)),
		  GC_PUSHS("\',"),GC_PUSHS(crlf),GC_PUSHS(" type["),
		  GC_PUSHS(srcd),GC_PUSHS("]=\'"),cvtypes((*aChkI(decldw,1L,
								  irp))),
		  GC_PUSHS("\'."))));
		/*  -- OK all is well, now clear MEMBER bit */
    lasttype=lasttype&0777776777777L;
  }/* Member of RECORD */

else if (((((ps_itrash_= (type&037))>0)
	      ? (ps_itrash_+0140L)
	      : 0L)==codelabel))
       {/* use ':' to define label */
         oldtoken= ":";
	 s= GC_EPOPS(simple_map(h));
/*  # # @V.49.36		dcStaticDeclaration_NULL */
/*  # # @V.49.36		lastDeclaration_lastDeclaration Land 
					(Lnot DW!static) */
	 if (!iswhitespace((INTEGER)*saistatement))
	   s= catlist(2L,GC_PUSHS(s),GC_PUSHS(" ")); /*force white space*/
	 pdw_ptype(lasttype,codelabel);
       }/* use ':' to define label */
else err_hlr(GC_PUSHS(catlist(
		  GC_PUSHS("[FSM44] Illegal use of \':\', type \'"),
			      GC_PUSHS(savetoken),
			      GC_PUSHS("\'=\'"),cvtypes(type),
			      GC_PUSHS("\'"))));

GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'cmem'=<L0> integer                           */
/*************************************************/
}/* FSM44 */
