/* FILE: fsm46.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmd.c, being converted 12/25/87, 07:27:34PM*/

/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */



/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm46(h)
	INTEGER h;
{/* FSM46 */
STRING s, 
	s1, 
	be;
INTEGER ch, 
	atype;

;
{/* INCFSM */
    if (usecntfsmflag)
      (*aChkI(cntfsms,1L,46L))++;
}/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(6L,GC_PUSHS("[FSM46] \'rule\' NODE["),
			      GC_PUSHS(*aChkC(saisym,1L,h)),
			      GC_PUSHS("]="),prt_node(h),
			      GC_PUSHS(" lastType="),
        cvtypes(lasttype))));
/*[46] IF-expression*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM46>]
.INDEX ++PSAIL PROCEDURE: FSM46
	Map SAIL:	If be Then e1 Else e2
	To C    :	be ? e1 : e2
NOTE: the type returned is that of e1 when it is evaled.
.ENDLABEL [<++PSAIL PROCEDURE: FSM46>]
*/
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(be); /* for G.C. */
oldtoken= "if";
pushnumber(isifexpr); isifexpr= 1L;
firstiftoken= 1L; /*disable parser for an IF-statement*/
pushnumber(midofexpr); midofexpr= 1L;
pushnumber(lasttype);	/*  -- save type of <if-expr>
						expected */
be= GC_EPOPS(copy_omit(GC_PUSHS("then")));

/*  ---------------------------------- */
/*  . . . EVALUATE <Bool-expr> . . . . */
/*  ---------------------------------- */
while ((*be!='\0') &&iswhitespace((INTEGER)*be))
   ps_itrash_= LOP(be);
lasttype= 0L;
pdw_ptype(lasttype,codeinteger);	/*  -- prep it */
be= GC_EPOPS(r_d_expr_map(GC_PUSHS(be)));
atype= lasttype;
map_be(&be,&atype);	/*  -- Map to ((INTEGER)(be))  */
popnumber(&lasttype);
/*  # # DBUG('40000,"[FSM46].1 be='"&be&"'"&CRLF&"  aType='"&
    CVTYPES(aType)&"'"&CRLF&"  lastType='"&CVTYPES(lastType)&"'"&CRLF&
    "  saiStatement='"&saiStatement&"'") */
/*  # # 12/20/83 - need to scan backwards to 1st non (LF,CR,space,tab)
	then insert the ')' after it. Same for 'DO'
*/
insert_before_white(&be,GC_PUSHS(" ? "));

/*  ---------------------------------------- */
/*  . . . GET AND EVALUATE <then-expr> . . . */
/*  ---------------------------------------- */
push(GC_PUSHS(be));
pushnumber(lasttype);	/*  -- so we don't clobber it
				with COPY!EITHER or R!D */
s1= GC_EPOPS(copy_either(GC_PUSHS("else"),&saitoken));
if (*s1!=*cr&&iswhitespace((INTEGER)*s1))
  ch= LOP(s1);
midofexpr= 1L;
s1= GC_EPOPS(r_d_expr_map(GC_PUSHS(s1)));
atype= lasttype;
if (fast_equ(GC_PUSHS(lastmappedtoken),GC_PUSHS(":=")))
   s1= catlist(3L,GC_PUSHS("("),GC_PUSHS(s1),
	       GC_PUSHS(")"));  /*  -- need to do this
				    because some C compilers are too
				    wimpy to handle the IF-EXPR without () */
popnumber(&lasttype);
pop(&s);
/*  -- @V.52.130 NOTE: need to set the type if lastType was 0 since
    it is possible to use an <if-expr> in a PRINT() statement
    which does NOT have a predefined type!
*/
if (lasttype==0) lasttype= atype;  /*  -- acquire current type */
if (!(atype==lasttype||isscalartype(atype,lasttype))) 
s1= GC_EPOPS(cvactual_to_expected(lasttype,atype, GC_PUSHS(s1)));
s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s1));   /*  -- add on <THEN-EXPR> */
oldtypestatement= "if";
/*  # # DBUG('40000,"[FSM46].2 s='"&s&"'"&CRLF&"  lastType='"&
    CVTYPES(lastType)&"'") */

/*  ---------------------------------------- */
/*  . . . GET AND EVALUATE <else-expr> . . . */
/*  ---------------------------------------- */
push(GC_PUSHS(s)); 		/*  -- Eval <ELSE-expr> part */
pushnumber(lasttype);
saitoken= "else";
midofexpr= 1L;
s1= GC_EPOPS(fsm30(helse));   	/*  -- Go eval it */
atype= lasttype;
popnumber(&lasttype);
pop(&s);
if (!(atype==lasttype||isscalartype(atype,lasttype))) 
  s1= GC_EPOPS(cvactual_to_expected(lasttype,atype,GC_PUSHS(s1)));
s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s1));
popnumber(&midofexpr);
popnumber(&isifexpr);
/*  # # DBUG('40000,"[FSM46].3 s='"&s&"'"&CRLF&"  lastType='"&
    CVTYPES(lastType)&"'") */
oldtypestatement= "if";

GC_SRETURN(s)
}/* FSM46 */
