/* FILE: fsm47.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmd.c, being converted 12/25/87, 07:27:34PM*/

/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm47(h)
	INTEGER h;
{/* FSM47 */
STRING s, 
	s1, 
	id, 
	expr, 
	brkstr;
INTEGER ch, 
	trash, 
	brk, 
	n, 
	atype;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,47L))= (*aChkI(cntfsms,1L,47L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM47] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[47] CASE-expression*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM47>]
.INDEX ++PSAIL PROCEDURE: FSM47
	 Handles unlabled (no [i]) CASE-expressions as
	follows:
	MAP SAIL:	CASE i Of (e0,e1,e2,...,en)
	to C:		(i==0) ? e0
			: (i==1) ? e1
			: (i==2) ? e2
				...
			: (i==n) ? en

	NOTE: the type is that of e0

	NOTE: FSM[2] CASE-statement sets up as
	<expr> & "```" & saiStatement
.ENDLABEL [<++PSAIL PROCEDURE: FSM47>]
 */
/*  # # DBUG('40000,"[FSM47].1 lastType='"&CVTYPES(lastType)&"'") */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(id); /* for G.C. */
	GC_NOTESTRING(expr); /* for G.C. */
	GC_NOTESTRING(brkstr); /* for G.C. */
	s= "@";		/*  -- prep string with preface character */
	{/* TRASH!RIGHT!WS */
			while ((*cstatement!='\0') &&
			      (ps_itrash_= (*(cstatement+length(cstatement)-1))) &&
			      iswhitespace(ps_itrash_)) 
						cstatement= subst(GC_PUSHS(cstatement),1L,length(cstatement)-1L);
			}/* TRASH!RIGHT!WS */ /*  -- butt against other expr */
		id= GC_EPOPS(scan(&saistatement,18L,&brk)); /*for '`' */
	if (!(*id=='('&&(*(id+length(id)-1))==')')) id= catlist(3L,GC_PUSHS("("),GC_PUSHS(id),GC_PUSHS(")"));
	if (brk!='`'&&
	   !equ(subst(GC_PUSHS(saistatement),1L,2L),GC_PUSHS("``")))
	    err_hlr(GC_PUSHS("[FSM47] DRYROT!! missing ``` in CASE<expr>```...")); 
	    else {/* remove `` */
	         ch= LOP(saistatement);
	         ch= LOP(saistatement);
	    	 }/* remove `` */
	pushnumber(isifexpr); isifexpr= 1L;
	pushnumber(midofexpr); midofexpr= 1L;
	n= 0;			/*  -- Set up case ctr */
/*  # # DBUG('40000,"[FSM47].1.1 s='"&s&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
	do 	{/* eval expr cases separated by ',' */
		GC_EPOPS(map_ws_comments(&s,0L));
/*  # # DBUG('40000,"[FSM47].2 n="&CVS(n)&" s='"&s&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
		expr= GC_EPOPS(copy_either(GC_PUSHS(",)"),&brkstr));  /*  -- on , or )  */
/*  # # DBUG('40000,"[FSM47].2.1 expr="&expr&" s="&s&CRLF&" saiStatement="&saiStatement) */
		if (n>0) pushnumber(lasttype);
		pushnumber(n); push(GC_PUSHS(id)); push(GC_PUSHS(s));
		s1= GC_EPOPS(r_d_expr_map(GC_PUSHS(expr)));
		pop(&s); pop(&id); popnumber(&n);
		if (n>0) 
			{/* coerce rest of ei */
			atype= lasttype;   /*  -- save it */
			popnumber(&lasttype);
			if (atype!=lasttype) s1= GC_EPOPS(cvactual_to_expected(
					lasttype,atype,GC_PUSHS(s1)));
			}/* coerce rest of ei */
		else atype= lasttype;   /*  -- latch type */

/*  -- NOTE: If <expr> s1 is NULL then do not emit code for this count
'n' but increment the counter! */
		if ((*s1!='\0') &&
		   (fast_equ(GC_PUSHS(oldtypestatement),GC_PUSHS("if")) ||
		    fast_equ(GC_PUSHS(oldtypestatement),GC_PUSHS("case")))) s1= catlist(3L,GC_PUSHS("("),GC_PUSHS(s1),GC_PUSHS(")"));
		if (((++n)>1) &&(*s1!='\0')) s= catlist(2L,GC_PUSHS(s),GC_PUSHS(tab));
		if (*s1!='\0')
			s= catlist(8L,GC_PUSHS(s),GC_PUSHS("("),GC_PUSHS(id),GC_PUSHS("=="),cvs(n
        -1L),GC_PUSHS(") ? "),GC_PUSHS(s1),GC_PUSHS(crlf));
		if (*saistatement==*cr) 
			{/* trash CRLF */
			ch= LOP(saistatement);
			ch= LOP(saistatement);
			}/* trash CRLF */
		map_whitespace(&s); 
		if ((*brkstr==',') &&(*s1!='\0')) s= catlist(2L,GC_PUSHS(s),GC_PUSHS("  :"));  /*  -- i.e. else  */
/*  # # DBUG('40000,"[FSM47].2.2 time="&RUN!TIME&CRLF&"  s1='"&s1&"'"&" s='"&s&"'") */
		}/* eval expr cases separated by ',' */
	 while (!((*brkstr==')') ||(*saistatement=='\0')));
	oldtoken= "case";
	oldtypestatement= "case";
	popnumber(&midofexpr);
	popnumber(&isifexpr);
	/*  --  NOTE: the type is that of e0    */
	if (length(GC_PUSHS(s))==1) s= PNULL; 
		else s= subst(GC_PUSHS(s),2L,length(s)-2L);   /*  -- trash '@' preface
					character and final
					CRLF */
/*  # # DBUG('40000,"[FSM47].3 s='"&s&"'"&CRLF&"  lastType='"&CVTYPES(lastType)&"'") */
;
	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'trash'=<L0> integer                          */
/*************************************************/
}/* FSM47 */
