/* FILE: fsm48.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmd.c, being converted 12/25/87, 07:27:34PM*/

/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm48(h)
	INTEGER h;
{/* FSM48 */
STRING s, 
	s1, 
	token;
INTEGER i, 
	ch, 
	h2, 
	_class;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,48L))= (*aChkI(cntfsms,1L,48L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM48] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[48] PSAIL!FORGET*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM48>]
.INDEX ++PSAIL PROCEDURE: FSM48
	Remove specified symbols or subLanguage symbols from
	symbol table.
	Eg.	PSAIL!FORGET foreach,such,that,in
	   or	PSAIL!FORGET LEAP:
.ENDLABEL [<++PSAIL PROCEDURE: FSM48>]
  */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(token); /* for G.C. */
	s= "/* PSAIL!FORGET";
	map_whitespace(&s);
	s1= GC_EPOPS(scan(&saistatement,10L,&ch));	/*  -- to <SC> */
	s= catlist(3L,GC_PUSHS(s),GC_PUSHS(s1),GC_PUSHS(" */"));
	if (blocklevel>1) err_hlr(GC_PUSHS(
	"[FSM48] Can\'t PSAIL!FORGET except at block level 1")); 
	else while ((*s1!='\0'))
		{/* eat tokens */
		while ((*s1!='\0') &&iswhitespace((INTEGER)*s1)) ps_itrash_= LOP(s1);
		token= GC_EPOPS(getid(&s1,&ch));
		if (ch==':')
			{/* remove all of subLanguage */
			INTEGER h1, 
			dw, 
			n;
			s1= token;
			ch= LOP(s1);  /*  -- get rid of L */
			n= cvd(GC_PUSHS(s1));  /*  -- get number */
			if (!(1<=n && n<=15)) err_hlr(GC_PUSHS(
	catlist(3L,GC_PUSHS(
	        "[FSM48] PSAIL!FORGET illegal sub-language name \'"),
	        GC_PUSHS(token),GC_PUSHS("\'"))));
			s1= ((*((s1= (*aChkC(sublanguage,1L,n))))!='\0') ? catlist(3L,GC_PUSHS(":["),GC_PUSHS(s1),GC_PUSHS("] ")): ": ");
			s= catlist(4L,GC_PUSHS(s),GC_PUSHS("/* Sublanguage "),GC_PUSHS(token),
        GC_PUSHS(s1));
			for (i=1;i<=1600L;i++)
			  if (gdw_sublanguage((*aChkI(decldw,1L,i)))==n&&
				((h1= (*aChkI(declhash,1L,i)))!=0) &&
				(*((s1= (*aChkC(saisym,1L,h1))))!=007) &&
				(*s1!='\0'))
				{/* delete index i */
				s= catlist(3L,GC_PUSHS(s),GC_PUSHS(s1),GC_PUSHS(" "));  /*  -- note it */
				(*aChkC(saisym,1L,h1))= "\007";  /*  -- BELL */
				(*aChkI(dwptr,1L,h1))= 0;
				(*aChkC(declcsym,1L,i))= GC_EPOPS(makstr((*aChkI(declfsm,1L,i))= (*aChkI(declnargs,1L,i))= (*aChkI(declinproc,1L,i))= (*aChkI(decldw,1L,i))= (INTEGER)*((*aChkC(declformal,1L,i))= (*aChkC(declsize,1L,i))= GC_EPOPS(makstr((*aChkI(declhash,1L,i))= 0)))));
				}/* delete index i */
			s= catlist(2L,GC_PUSHS(s),GC_PUSHS("*/"));
			/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'dw'=<L0> integer                             */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/


}/* remove all of subLanguage */
		else if ((i= find_symbol(GC_PUSHS(token),&_class,&h2))!=0)
			{/* remove symbol h */
			(*aChkC(saisym,1L,h2))= "\007"; /*BELL*/
			(*aChkC(declcsym,1L,i))= GC_EPOPS(makstr((*aChkI(declfsm,1L,i))= (*aChkI(declnargs,1L,i))= (*aChkI(declinproc,1L,i))= (*aChkI(decldw,1L,i))= (INTEGER)*((*aChkC(declformal,1L,i))= (*aChkC(declsize,1L,i))= GC_EPOPS(makstr((*aChkI(declhash,1L,i))= 0)))));
			{if (usereportflag) (*aChkI(errstatistics,1L,23L))= (*aChkI(errstatistics,1L,23L))+-1L; } /*  -- for /REPORT */
			}/* remove symbol h */
		}/* eat tokens */
	if (length(GC_PUSHS(s))>72) s= GC_EPOPS(justify_text(GC_PUSHS(" "),GC_PUSHS(PNULL),GC_PUSHS(s)));
/*  # # DBUG('40000,"[FSM48].1 s='"&s&"'") */
	oldtypestatement= "%%declaration";
;
	GC_SRETURN(s)
}/* FSM48 */
