/* FILE: fsm4a.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1987 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsma.c, being converted 12/25/87, 05:15:20PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */



/*  -------------------------------------------------------- */
/*INTERNAL*/  STRING fsm4a(h)
	INTEGER h;
{/* FSM4a */
STRING a, 
	b, 
	s, 
	s1, 
	s2, 
	id, 
	rangesize, 
	sbrk, 
	arystorageclass;
INTEGER notnbrboundsflag;
INTEGER aisnbr, 
	bisnbr, 
	i, 
	n, 
	ch, 
	itype;

{/* INCFSM */
if (usecntfsmflag)
  (*aChkI(cntfsms,1L,-1L))++;
}/* INCFSM */		/*  -- SPECIAL MAPPING */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM4a] \'rule\' NODE["),
			      GC_PUSHS(*aChkC(saisym, 1L,h)),
			      GC_PUSHS("]="),prt_node(h))));
/*[4]a [<declar.>*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM4a>]
.INDEX ++PSAIL PROCEDURE: FSM4a
	  There are 2 cases for mapping DECLARATIONS:
	a) MAP: declaration  var[a:b,c:d,...]
	   TO:  var[f(a,b)][f(c,d)][...]
		if any spec is '*' then set it to '1'
	b) PRELOAD repeat count, i.e. '[45]3.14'
	   the latter indicated by 'oldTypeStatement' if
	   it has the value "preload_with".
	If /CHECK and not OWN then set 'lastAsize' to
	@<varname>,nArgs,LB1,UB1,...,LBn,UBn,"varname",'type'
	If /CHECK and OWN then set 'lastAsize' to
	!<varname>,nArgs,LB1,UB1,...,LBn,UBn,"varname",'type'
	If /CHECK and doing a PRELOAD!WITH then set 'lastAsize' to
	#<varname>,nArgs,LB1,UB1,...,LBn,UBn,"varname",'type'

	else set lastAsize to
	1*(UB1-LB1+1)*...*(UBn-LBn+1)
.ENDLABEL [<++PSAIL PROCEDURE: FSM4a>]
*/
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(a); /* for G.C. */
GC_NOTESTRING(b); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(id); /* for G.C. */
GC_NOTESTRING(rangesize); /* for G.C. */
GC_NOTESTRING(sbrk); /* for G.C. */
GC_NOTESTRING(arystorageclass); /* for G.C. */
if (fast_equ(GC_PUSHS(oldtypestatement),GC_PUSHS("preload_with")))
  {/* doing PRELOAD repeat count */
    s1= a= GC_EPOPS(scan(&saistatement,14L,&saibrk));   /*  -- for ']'  */
/* # # DBUG('40000,"[FSM4a].0.1 a='"&a&"' saiBrk='"&
   (ps!sTrash!_saiBrk)&"'"&CRLF&"  saiStatement='"&saiStatement&"'") */
    if (!isdigit((INTEGER)*s1) &&(*s1!=*quote)) 
      {/* force an EVAL */
	pushnumber(usefoldingflag); usefoldingflag= 1L;
	a= GC_EPOPS(fold_const_expr(GC_PUSHS(s1)));   /*  -- Map to const */
	popnumber(&usefoldingflag);
      }/* force an EVAL */
    n= cvd(GC_PUSHS(a));			/*  -- get value */
    if ((saibrk!=']') ||(n<1||n>1000))
      err_hlr(GC_PUSHS(catlist(5L,
             GC_PUSHS("[FSM4a] missing \']\' or preload repeat count \'"),
			       GC_PUSHS(s1),GC_PUSHS("="),cvs(n),
			       GC_PUSHS("\' out of range [1:1000]"))));
    b= GC_EPOPS(rightexpr(&saistatement));
    while ((*b!='\0') && iswhitespace((INTEGER)*b))
      ps_itrash_= LOP(b);
    {/* TRASH!RIGHT!WS */
      while ((*b!='\0') && (ps_itrash_= (*(b+length(b)-1))) &&
	     iswhitespace(ps_itrash_)) 
	b= subst(GC_PUSHS(b),1L,length(b)-1L);
    }/* TRASH!RIGHT!WS */
    while ((*saistatement!='\0') && 
	   iswhitespace((INTEGER)*saistatement)) 
      ps_itrash_= LOP(saistatement);
    if ((*saistatement!=',') && (*saistatement!='\0'))
      err_hlr(GC_PUSHS(
   "[FSM4a] missing \',\' or \';\' terminator on PRELOAD repeat count"));
    midofexpr= 1L;
    pushnumber(n);
    b= GC_EPOPS(r_d_expr_map(GC_PUSHS(b)));
    popnumber(&n);
    s= s1= PNULL;
    for (i=1;i<=n;i++)
      {/* generate repeated datums */
	if (*s=='\0')
	  s= b;
	else s= catlist(3L,GC_PUSHS(s),GC_PUSHS(","),GC_PUSHS(b));
	if (length(GC_PUSHS(s))>72)
	  {/* break up monster string */
	      if (*s1=='\0') 
		s1= catlist(2L,GC_PUSHS(s),GC_PUSHS(crlf));
	      else s1= catlist(3L,GC_PUSHS(s1),GC_PUSHS(s),GC_PUSHS(crlf));
	      s= PNULL;
	  }/* break up monster string */
      }/* generate repeated datums */
    if (*s1!='\0') 
      if (*s!='\0') 
	s= catlist(2L,GC_PUSHS(s1),GC_PUSHS(s)); 
      else s= s1; 
    else s= s;	                	/*  -- build string */
/*  # # DBUG('40000,"[FSM4a].0.2 s='"&s&"'") */
/*  # # DBUG('40000,"[FSM4a].0.1 a='"&a&"' saiBrk='"&
    (ps!sTrash!_saiBrk)&"'"&CRLF&"  saiStatement='"&saiStatement&"'") */
  }/* doing PRELOAD repeat count */

else if (usechkflag)
       {/* ARRAY declaration using array descriptors */
	 id= oldtoken;			/*  -- name of array */
	 n= 0;
	 lastasize= "1L";
	 s1= PNULL;
	 do {/* map and count ':'s */
/*  # # DBUG('40000,"[FSM4a].1 /CHECK n="&CVS(n)&" s='"&s&"'"&CRLF&
    "  saiStatement='"&saiStatement&"'") */
	     s2= ((useextensionsflag) ? ",:,],;"
		                      : ":,],;");
	     a= GC_EPOPS(copy_either(GC_PUSHS(s2),&sbrk));
	                                     /*  -- lower bound */
	     if (useextensionsflag &&
		 *((a= GC_EPOPS(remove_white_ends(GC_PUSHS(a)))))=='*')
	       {/* handle '*' bound value */
		 a= "1";
		 while ((*saistatement!='\0') &&
			iswhitespace((INTEGER)*saistatement))
		   ps_itrash_= LOP(saistatement);
		 if (*sbrk!=':')
		   {/* force 1:1 */
		       saistatement= catlist(3L,GC_PUSHS("1"),
					     GC_PUSHS(sbrk),
					     GC_PUSHS(saistatement));
		       sbrk= ":";   /*  -- fake it out */
		   }/* force 1:1 */
	       }/* handle '*' bound value */
	     if (*sbrk!=':')
	       err_hlr(GC_PUSHS(catlist(3L,
	       GC_PUSHS("[FSM4a] NO \':\' after ARRAY decl. lower bound \'"),
					GC_PUSHS(a),
					GC_PUSHS("\' - CHECK YOUR CODE"))));
	     if (lastdeclaration&0200000L)
	       a= catlist(3L,GC_PUSHS("(("),GC_PUSHS(a),
			  GC_PUSHS(") min 0L)"));
					/*  -- for C!ARRAY */
	     b= GC_EPOPS(copy_either(GC_PUSHS(",],;"),&sbrk));
                                        /*  -- upper bound */
	     if (useextensionsflag &&
		 *((b= GC_EPOPS(remove_white_ends(GC_PUSHS(b)))))=='*')
	       {/* handle '*' bound value */
		 b= "1";
	       }/* handle '*' bound value */
	     if ((*sbrk!=','&&*sbrk!=']'))
	       err_hlr(GC_PUSHS(catlist(3L,
               GC_PUSHS("[FSM4a] NO \':\' after ARRAY decl. upper bound \'"),
					GC_PUSHS(b),
					GC_PUSHS("\' - CHECK YOUR CODE"))));
	     GC_EPOPS(dbug(040000L,catlist(5L,
					GC_PUSHS("[FSM4a].1.1 /CHECK a=\'"),
					   GC_PUSHS(a),
					   GC_PUSHS("\' b=\'"),
					   GC_PUSHS(b),GC_PUSHS("\'"))));
	/*  -- EVAL a and b and then do FOLDing  */
		/*  -- Clear next two globals so that R!D can
		    handle [...] as values for the bounds! */
	     push(GC_PUSHS(oldtypestatement)); oldtypestatement= PNULL;
	     pushnumber(lastdeclaration); lastdeclaration= 0L;
	     push(GC_PUSHS(lastasize));
	     pushnumber(midofexpr);
	     midofexpr= 1L;
	     itype= 0; pdw_ptype(itype,codeinteger);
	     b= GC_EPOPS(r_d_expr_map(GC_PUSHS(b)));
/*  # # @V.54.01		If GDW!pType(lastType) Neq CODEinteger
    # # @V.54.01			Then  */
	     b= GC_EPOPS(cvactual_to_expected(itype,lasttype,GC_PUSHS(b)));

	     midofexpr= 1L;
	     a= GC_EPOPS(r_d_expr_map(GC_PUSHS(a)));
/*  # # @V.54.01		If GDW!pType(lastType) Neq CODEinteger
    # # @V.54.01			Then  */
	     a= GC_EPOPS(cvactual_to_expected(itype,lasttype,GC_PUSHS(a)));

	     popnumber(&midofexpr);
	     pop(&lastasize);
	     popnumber(&lastdeclaration); 
	     pop(&oldtypestatement);
GC_EPOPS(dbug(040000L,catlist(5L,
			      GC_PUSHS("[FSM4a].1.2 R!D!EVAL++ a=\'"),
			      GC_PUSHS(a),
			      GC_PUSHS("\' b=\'"),GC_PUSHS(b),
			      GC_PUSHS("\'"))));

	     ++n;		/*  -- count number of args */
	     if (*s1=='\0')
	       s1= catlist(4L,GC_PUSHS(a),GC_PUSHS(","),
			   GC_PUSHS(b),GC_PUSHS(","));
	     else s1= catlist(5L,GC_PUSHS(s1),GC_PUSHS(a),
			      GC_PUSHS(","),GC_PUSHS(b),
			      GC_PUSHS(","));
	     if (*a=='-'||!chk_integer(GC_PUSHS(a)) &&
		 !chk_id(GC_PUSHS(a)))
	       a= catlist(3L,GC_PUSHS("("),GC_PUSHS(a),GC_PUSHS(")"));
                                                   /*  -- () if EXPR */
	     if (*b=='-'||!chk_integer(GC_PUSHS(b)) &&
		 !chk_id(GC_PUSHS(b)))
	       b= catlist(3L,GC_PUSHS("("),GC_PUSHS(b),GC_PUSHS(")"));
	                                           /*  -- () if EXPR */
	     lastasize= catlist(3L,GC_PUSHS(lastasize),
				GC_PUSHS("*("),GC_PUSHS(b));
	     s2= a;	/*  -- copy for test */
	     GC_EPOPS(rmv_integer_cast(GC_PUSHS(s2)));
	     if (fast_equ(GC_PUSHS(s2),GC_PUSHS("0")))
	       lastasize= catlist(2L,GC_PUSHS(lastasize),
				  GC_PUSHS("+1L)")); 
	     else if (fast_equ(GC_PUSHS(s2),GC_PUSHS("1")))
	       lastasize= catlist(2L,GC_PUSHS(lastasize),GC_PUSHS(")"));
	     else lastasize= catlist(4L,GC_PUSHS(lastasize),
				     GC_PUSHS("-"),GC_PUSHS(a),
				     GC_PUSHS("+1L)"));
	     GC_EPOPS(dbug(040000L,catlist(13L,
					   GC_PUSHS("[FSM4a].1.3 a=\'"),
					   GC_PUSHS(a),GC_PUSHS("\' b=\'"),
					   GC_PUSHS(b),GC_PUSHS("\'"),
					   GC_PUSHS(crlf),
					   GC_PUSHS("  s1=\'"),GC_PUSHS(s1),
					   GC_PUSHS("\' lastAsize=\'"),
					   GC_PUSHS(lastasize),
					   GC_PUSHS("\' s2=\'"),
					   GC_PUSHS(s2),GC_PUSHS("\'"))));
	   }/* map and count ':'s */
	 while (!(*sbrk==']'||(*saistatement=='\0')));
	 arystorageclass= ((ispreload_withflag) ? "#"
		                    : ((lastdeclaration&0400L) ? "!"
                                    : "@"));    /*  -- set the 
						    flag which is 
						    used by [FSM11] and
						    [EMIT!LOC!CODE] */
	 s2= GC_EPOPS(cvactual_to_expected(itype,itype,cvs(n)));
				   /*  -- make 32-bit integer */
	 s= catlist(12L,GC_PUSHS(arystorageclass),GC_PUSHS(id),
		    GC_PUSHS(","),GC_PUSHS(s2),GC_PUSHS(","),
		    GC_PUSHS(s1),GC_PUSHS(quote),
		    GC_PUSHS(id),GC_PUSHS(quote),GC_PUSHS(",\'"),
		    GC_PUSHS(s2=(((ps_itrash_=(lastdeclaration&037))>0)
				 ? GC_EPOPS(makstr((ps_itrash_+0140L)))
				 : 0L)),
		    GC_PUSHS("\'"));  
                         /*  -- Special string to be used by FSM11 */
GC_EPOPS(dbug(040000L,catlist(7L,GC_PUSHS("[FSM4a].1.4 aryStorageClass=\'"),
			      GC_PUSHS(arystorageclass),
			      GC_PUSHS("\'"),GC_PUSHS(crlf),
			      GC_PUSHS(" s=\'"),GC_PUSHS(s),
			      GC_PUSHS("\'"))));
       }/* ARRAY declaration using array descriptors */

else  {/* ARRAY declaration as C declaration */
        s= "[";
	notnbrboundsflag= 0L;   /*  -- unless proven otherwise */
	do {/* Process ARRAY declaration list */
/*  # # DBUG('40000,"[FSM4a].2 /NOCHECK n="&CVS(n)&" s='"&s&
    "'"&"  saiStatement='"&saiStatement&"'") */
	    a= GC_EPOPS(copy_either(GC_PUSHS(":,],;"),&sbrk));	
	                                         /*  -- lower bound */
	    if (*sbrk!=':') 
	      err_hlr(GC_PUSHS(catlist(3L,
             GC_PUSHS("[FSM4a] NO \':\' after ARRAY decl. lower bound \'"),
				       GC_PUSHS(a),
				       GC_PUSHS("\' - CHECK YOUR CODE"))));
	    b= GC_EPOPS(copy_either(GC_PUSHS(",],;"),&sbrk));
	                                        /*  -- upper bound */
	    if (*sbrk!=','&&*sbrk!=']')
	      err_hlr(catlist(3L,
            GC_PUSHS("[FSM4a] NO \':\' after ARRAY decl. upper bound \'"),
			      GC_PUSHS(b),
			      GC_PUSHS("\' - CHECK YOUR CODE")));
/*  # # DBUG('40000,"[FSM4a].2.1 /NOCHECK a='"&a&"' b='"&b&"'") */
	    /*  -- handle dynamic bounds but issue
		a TRASH!GRAPHIC warning!!! */
	    push(GC_PUSHS(oldtypestatement)); oldtypestatement= PNULL;
	    pushnumber(lastdeclaration); lastdeclaration= 0L;
	    push(GC_PUSHS(sbrk)); pushnumber(midofexpr);
	    midofexpr= 1L;
/*  # # @V.53.06		PUSH(a) */
	    b= GC_EPOPS(r_d_expr_map(GC_PUSHS(b)));
	    if (((((ps_itrash_= (lasttype&037))>0) ? (ps_itrash_+0140L)
		  :0L)!=codeinteger) ||
		(*b==*singlequote))
	      b=GC_EPOPS(cvactual_to_expected(itype,lasttype,GC_PUSHS(b)));
/*  # # @V.53.06		POP(a) */
/*  # # @V.53.06		PUSH(b) */
	    midofexpr= 1L;
	    a= GC_EPOPS(r_d_expr_map(GC_PUSHS(a)));
	    if (((((ps_itrash_= (lasttype&037))>0) ? (ps_itrash_+0140L)
		  :0L)!=codeinteger) ||
		(*a==*singlequote)) 
	      a= GC_EPOPS(cvactual_to_expected(itype,lasttype,GC_PUSHS(a)));
/*  # # @V.53.06		POP(b) */
	    popnumber(&midofexpr); pop(&sbrk);
	    popnumber(&lastdeclaration); 
	    pop(&oldtypestatement);
/*  # # DBUG('40000,"[FSM4a].2.2 R!D!EVAL++ a='"&a&"' b='"&b&"'") */

	    aisnbr= isdigit((INTEGER)*a);
	    bisnbr= isdigit((INTEGER)*b);
	    notnbrboundsflag=(notnbrboundsflag || (!aisnbr) ||(!aisnbr));
				  /*  -- remember if failed! */
		if (aisnbr &&(cvd(GC_PUSHS(a))>=0) &&bisnbr)
		  rangesize= catlist(2L,cvs(cvd(GC_PUSHS(b))+1L),
				     GC_PUSHS("L")); 
		else if (aisnbr &&(cvd(GC_PUSHS(a))>=0))
		  rangesize= (catlist(2L,GC_PUSHS(b),GC_PUSHS("+1L"))); 
		else {/* TROUBLE ahead... */
		       if ((aisnbr &&(cvd(GC_PUSHS(a))<0)) ||(*a=='-'))
			 rangesize= catlist(4L,GC_PUSHS(b),
					    GC_PUSHS("+1L-("),
					    GC_PUSHS(a),GC_PUSHS(")"));
		       else if ((bisnbr &&(cvd(GC_PUSHS(b))<0)) ||
				(*b=='-'))
			      rangesize= catlist(3L,GC_PUSHS("(-"),
						 GC_PUSHS(a),
						 GC_PUSHS("+1L)"));
		       else {/* trouble */
			      rangesize= catlist(5L,GC_PUSHS("(("),
						 GC_PUSHS(b),
						 GC_PUSHS(")-("),
						 GC_PUSHS(a),
						 GC_PUSHS(")+1L)"));
			      err_warning(&rangesize);
			    }/* trouble */
		     }/* TROUBLE ahead... */
	    if (usefoldingflag)
	      rangesize= GC_EPOPS(fold_const_expr(GC_PUSHS(rangesize)));
	    else rangesize= catlist(3L,GC_PUSHS("("),
				    GC_PUSHS(rangesize),GC_PUSHS(")"));
/*  # # DBUG('40000,"[FSM4a].2.3  a='"&a&"' b='"&b&"' rangeSize='"&
    rangeSize&"' lastAsize='"&lastAsize&"'") */
	    if (length(GC_PUSHS(lastasize))==1)
	      lastasize= rangesize;  
	    else lastasize= catlist(3L,GC_PUSHS(lastasize),
				    GC_PUSHS("*"),GC_PUSHS(rangesize));
/*  # # DBUG('40000,"[FSM4a].2.4 NEW lastAsize='"&lastAsize&"'") */
	    s= catlist(3L,GC_PUSHS(s),GC_PUSHS(rangesize),GC_PUSHS("]"));
	    if (*sbrk==',') 
	      s= catlist(2L,GC_PUSHS(s),GC_PUSHS("["));
	  }/* Process ARRAY declaration list */
	while (!(*sbrk==']'||(*saistatement=='\0')));
	if (notnbrboundsflag)
	  {/* Opps, no dynamic bounds! */
	    s= catlist(2L,GC_PUSHS(s),GC_PUSHS(crlf));
	    err_deathwish(&s,
			  catlist(3L,
 GC_PUSHS("WARNING! No dynamic, negative or non-numeric bounds for C style"),
				  GC_PUSHS(crlf),
				  GC_PUSHS("arrays with /NOCHECK!")), 4L,
			  (INTEGER)('N'));
	  }/* Opps, no dynamic bounds! */
      }/* ARRAY declaration as C declaration */

if (usefoldingflag)
  lastasize= GC_EPOPS(fold_const_expr(GC_PUSHS(lastasize)));

GC_EPOPS(dbug(040000L,catlist(7L,GC_PUSHS("[FSM4a].3 n="),cvs(n),
			      GC_PUSHS(" lastAsize=\'"),
			      GC_PUSHS(lastasize),GC_PUSHS("\' s=\'"),
			      GC_PUSHS(s),GC_PUSHS("\'"))));

GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'ch'=<L0> integer                             */
/*************************************************/
}/* FSM4a */
