/* FILE: fsm5.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsma.c, being converted 12/25/87, 05:15:20PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  -------------------------------------------------------- */
/*INTERNAL*/  STRING fsm5(h)
	INTEGER h;
{/* FSM5 */
STRING s, 
	s1, 
	id, 
	be, 
	brkstr;
INTEGER iswhile_do;


{/* INCFSM */
if (usecntfsmflag)
(*aChkI(cntfsms,1L,5L))++;
}/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM5] \'rule\' NODE["),
			      GC_PUSHS(*aChkC(saisym,1L ,h)),
			      GC_PUSHS("]="),prt_node(h))));
/*[5] WHILE*/
/*
.LABEL [<++PSAIL PROCEDURE: FSM5>]
.INDEX ++PSAIL PROCEDURE: FSM5
	 Map SAI:	WHILE <be> Do <statement>;
	  To  C:	while (<be>) <statement>;
	However, if the WHILE is part of a previous DO
	statement, then look for ; rather than DO.
.ENDLABEL [<++PSAIL PROCEDURE: FSM5>]
*/
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(id); /* for G.C. */
GC_NOTESTRING(be); /* for G.C. */
GC_NOTESTRING(brkstr); /* for G.C. */
if (fast_equ(GC_PUSHS(oldtoken),GC_PUSHS("do")))
  {/* Do...Until(while) */
/*  # # DBUG('40000,"[FSM5].1 oldTypeStatement="&oldTypeStatement&CRLF&
    " saiStatement='"&saiStatement&"'") */
   be= GC_EPOPS(copy_either(GC_PUSHS(";,end,else"),&brkstr));
/*  # # DBUG('40000,"[FSM5].2 be='"&be&"' brkStr='"&brkStr&"'") */
   if (*brkstr!=';')
     brkstr= catlist(2L,GC_PUSHS(";"),GC_PUSHS(brkstr));
   saistatement= catlist(2L,GC_PUSHS(brkstr),GC_PUSHS(saistatement));
/*  # # DBUG('40000,"[FSM5].3 saiStatement='"&saiStatement&"'") */
   iswhile_do= 0L;
  }/* Do...Until(while) */

else  { /* While...Do */
        oldtoken= "while";
        be= GC_EPOPS(remove_white_ends(copy_omit(GC_PUSHS("do"))));
        iswhile_do= 1L;
      }/* While...Do */

while ((*be!='\0') &&iswhitespace((INTEGER)*be))
   ps_itrash_= LOP(be);
{/* TRASH!RIGHT!WS */
    while ((*be!='\0') &&
	   (ps_itrash_= (*(be+length(be)-1))) &&
	   iswhitespace(ps_itrash_)) 
      be= subst(GC_PUSHS(be),1L,length(be)-1L);
}/* TRASH!RIGHT!WS */
pushnumber(lasttype);
pdw_ptype(lasttype,codeinteger);
pushnumber(midofexpr); midofexpr= iswhile_do;
pushnumber(sawstrfct);
sawstrfct= 0L;
pushnumber(iswhile_do);
be= GC_EPOPS(r_d_expr_map(GC_PUSHS(be)));
map_be(&be,&lasttype);	/*  -- map to ((INTEGER)be)  */
popnumber(&iswhile_do);
if (!iswhile_do) 
  be= catlist(3L,GC_PUSHS("(!"),GC_PUSHS(be),GC_PUSHS(")"));
/*  # # DBUG('40000,"[FSM5].3.1 be='"&be&"' sawStrFct="&PBOOL(sawStrFct)) */

/*  # # @V.53.59	If useGCflag And sawStrFCT
 # # # @V.53.59		Then 
 # # # @V.53.59		Begin "for G.C."
 # # # @V.53.59		be_"(GC_SCLEANUP(" & be */
/*  # # @V.53.59		INSERT!BEFORE!WHITE(be,"))") */
/*  # # @V.53.59		End "for G.C." */
popnumber(&sawstrfct);

s= catlist(2L,GC_PUSHS("while "),GC_PUSHS(be));

if (iswhile_do)
  {/* Eval <statement part> */
    GC_EPOPS(map_ws_comments(&s,0L));
    s1= GC_EPOPS(rightstatement());
/*  # # DBUG('40000,"[FSM5].4 midOfExpr="&PBOOL(midOfExpr)&CRLF&
    " isIfExpr="&PBOOL(isIfExpr)&CRLF&
    " lastMappedToken='"&lastMappedToken&"'"&CRLF&
    " s='"&s&"' s1='"&s1&"'") */
    if (*s1=='\0')
      err_hlr(GC_PUSHS(
	       "[FSM5] missing statement after DO in <while-do-loop>")); 
    else {/* Eval it */
           fore2str= be;	/*  -- setup in case */
	   fore1str= fore3str= PNULL;
	   midofexpr= 0L;
	   pushnumber(isifexpr); isifexpr= 0L;
	   push(GC_PUSHS(lastmappedtoken));
	   lastmappedtoken= PNULL;
	   push(GC_PUSHS(s)); push(GC_PUSHS(be));
	   s1= GC_EPOPS(r_d_expr_map(GC_PUSHS(s1)));
	   pop(&be); pop(&s);
	   pop(&lastmappedtoken);
	   popnumber(&isifexpr);
         }/* Eval it */
    if (*s1!='\0')
      s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s1));
  }/* Eval <statement part> */

popnumber(&midofexpr);
popnumber(&lasttype);
fore2str= be;	/*  -- setup for NEXT statement if used! */
fore1str= fore3str= PNULL;
oldtypestatement= "while";
isemitgcflag= !ismacroflag;	/*  -- enable for GC code
				    generation */

GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'id'=<L0> string                              */
/*************************************************/

}/* FSM5 */

