/* FILE: fsm50.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmd.c, being converted 12/25/87, 07:27:34PM*/

/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm50(h)
	INTEGER h;
{/* FSM50 */
INTEGER ch, 
	lth, 
	type1, 
	type2;
STRING s, 
	s1, 
	e1, 
	e2;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,50L))= (*aChkI(cntfsms,1L,50L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM50] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[50] FAST!EQU*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM50>]
.INDEX ++PSAIL PROCEDURE: FSM50
	MAP SAIL:	FAST!EQU(s1,s2) 
	to C as either:
			equ(s1,s2)
	or		(*s1==*s2)
	If s1 and/or s2 is a single character substring of the Form
	sj[k For 1] or 'c' (i.e. a single quoted character).

	NOTE: Optimize EQU(s1,s2) to 'TRUE' iff s1 equals s2.
.ENDLABEL [<++PSAIL PROCEDURE: FSM50>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(e1); /* for G.C. */
	GC_NOTESTRING(e2); /* for G.C. */
	oldtoken= saitoken;
	while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
	if (*saistatement=='(') ch= LOP(saistatement); 
	else err_hlr(GC_PUSHS("[FSM50] Missing \'(\' in EQU(s1,s2) call"));
	push(GC_PUSHS(oldtoken)); oldtoken= "(";
	midofexpr= 1L;
	e1= GC_EPOPS(copy_omit(GC_PUSHS(",")));
	e2= GC_EPOPS(copy_omit(GC_PUSHS(")")));
	push(GC_PUSHS(e2));
	pdw_ptype(lasttype,codestring);     /*  -- Prep the R!D */
	oldtoken= lastmappedtoken= "(";
	midofexpr= 1L;
	e1= GC_EPOPS(r_d_expr_map(GC_PUSHS(e1)));
	pop(&e2);
	pushnumber(lasttype); push(GC_PUSHS(e1));
	pdw_ptype(lasttype,codestring);     /*  -- Prep the R!D */
	oldtoken= lastmappedtoken= ",";
	e2= GC_EPOPS(r_d_expr_map(GC_PUSHS(e2)));
	type2= lasttype;
	pop(&e1); popnumber(&type1);
	pop(&oldtoken);
/*  # # DBUG('40000,"[FSM50].1 e1='"&e1&"' type1='"&CVTYPES(type1)&"' e2='"&e2&"' type2='"&CVTYPES(type2)&"'") */
	if (*e1==*singlequote&&
	   (((ps_itrash_= (type1&037))>0) ? (ps_itrash_+0140L)
				:0L)==codestring) pdw_ptype(type1,codeinteger); 
	else if (*e1==*quote&&(*(1.0E1+length(1.0E1)-1))==*quote &&
	   ((lth= length(makstr((INTEGER)1.0E1)))==3||(lth==4&&(*(1.0E1+2-1))==('\\'/*WARNING*/))))
		{/* convert e1 to 'c' INTEGER */
		e1= catlist(3L,GC_PUSHS(singlequote),subst(GC_PUSHS(e1),2L,length(e1)-1L),
        GC_PUSHS(singlequote));
		pdw_ptype(type1,codeinteger);
		}/* convert e1 to 'c' INTEGER */
	if (*e2==*singlequote&&
	   (((ps_itrash_= (type2&037))>0) ? (ps_itrash_+0140L)
				:0L)==codestring) pdw_ptype(type2,codeinteger); 
	else if (*e2==*quote&&(*(1.0E2+length(1.0E2)-1))==*quote &&
	   ((lth= length(makstr((INTEGER)1.0E2)))==3||(lth==4&&(*(1.0E2+2-1))==('\\'/*WARNING*/))))
		{/* convert e2 to 'c' INTEGER */
		e2= catlist(3L,GC_PUSHS(singlequote),subst(GC_PUSHS(e2),2L,length(e2)-1L),
        GC_PUSHS(singlequote));
		pdw_ptype(type2,codeinteger);
		}/* convert e2 to 'c' INTEGER */
/*  # # DBUG('40000,"[FSM50].2 e1='"&e1&"' e2='"&e2&"' isFRAGMENTflag="&PBOOL(isFRAGMENTflag)&CRLF&" type1='"&CVTYPES(type1)&"'"&CRLF&" type2='"&CVTYPES(type2)&"'") */

	if ((((ps_itrash_= (type1&037))>0) ? (ps_itrash_+0140L)
				:0L)==codestring&&
	   (((ps_itrash_= (type2&037))>0) ? (ps_itrash_+0140L)
				:0L)==codestring)
		{/* just map to equ(s1,s2) */
		if (type1&010000000L) e1= catlist(2L,GC_PUSHS("*"),GC_PUSHS(e1)); else add_gc_pushs(&e1);
		if (type2&010000000L) e2= catlist(2L,GC_PUSHS("*"),GC_PUSHS(e2)); else add_gc_pushs(&e2);
		s= catlist(5L,GC_PUSHS("equ("),GC_PUSHS(e1),GC_PUSHS(","),GC_PUSHS(e2),
        GC_PUSHS(")"));
		}/* just map to equ(s1,s2) */

	else	{/* Optimize to character test */
		pdw_ptype(lasttype,codeinteger);
		e1= GC_EPOPS(cvactual_to_expected(lasttype,type1,GC_PUSHS(e1)));
		e2= GC_EPOPS(cvactual_to_expected(lasttype,type2,GC_PUSHS(e2)));
		s= catlist(5L,GC_PUSHS("("),GC_PUSHS(e1),GC_PUSHS("=="),GC_PUSHS(e2),
        GC_PUSHS(")"));
		}/* Optimize to character test */
	if (fast_equ(GC_PUSHS(e1),GC_PUSHS(e2))) s= "TRUE"; 
	else if (*e1==*quote&&1.0E2==*quote &&!((INTEGER)1.0E1==(INTEGER)1.0E2)) s= "FALSE";		/*  -- optimize it!
 */	pdw_ptype(lasttype,codeinteger);
/*  # # DBUG('40000,"[FSM50].3 s='"&s&"' isFRAGMENTflag="&PBOOL(isFRAGMENTflag)&CRLF&"  lastType='"&CVTYPES(lastType)&"'") */
;
	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 's1'=<L0> string                              */
/*************************************************/
}/* FSM50 */
