/* FILE: fsm52.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmd.c, being converted 12/25/87, 07:27:34PM*/

/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm52(h)
	INTEGER h;
{/* FSM52 */
STRING s, 
	s1, 
	s2, 
	sym1, 
	sym2, 
	cnt1, 
	cnt2, 
	size;
INTEGER i, 
	j, 
	ch, 
	cs1, 
	cs2, 
	hs1, 
	hs2, 
	dw1, 
	dw2, 
	ptype1, 
	ptype2;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,52L))= (*aChkI(cntfsms,1L,52L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM52] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[52] ARRTRAN*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM52>]
.INDEX ++PSAIL PROCEDURE: FSM52
	MAP SAIL:	ARRTRAN(buf1,buf2)
	to
	let cnt be MIN(sizeof(buf1),sizeof(buf2))

	NOTE: If /NOCHECK then	Carrtran(&buf1,&buf2,cnt)
	NOTE: If /CHECK then	arrtran(buf1,buf2).
.ENDLABEL [<++PSAIL PROCEDURE: FSM52>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(s2); /* for G.C. */
	GC_NOTESTRING(sym1); /* for G.C. */
	GC_NOTESTRING(sym2); /* for G.C. */
	GC_NOTESTRING(cnt1); /* for G.C. */
	GC_NOTESTRING(cnt2); /* for G.C. */
	GC_NOTESTRING(size); /* for G.C. */
	oldtoken= saitoken;
	s= GC_EPOPS(simple_map(h));
	if (!usechkflag) s= catlist(2L,GC_PUSHS("C"),GC_PUSHS(s));
	while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
	if (*saistatement!='(') err_hlr(GC_PUSHS("[FSM52] Missing \'(\' in ARRTRAN")); 
		else ch= LOP(saistatement);
	sym1= GC_EPOPS(rightexpr(&saistatement));
	map_whitespace(&s);
	if (*saistatement!=',') err_hlr(GC_PUSHS("[FSM52] missing \',\' in ARRTRAN")); 
		else ch= LOP(saistatement);
	sym2= GC_EPOPS(rightexpr(&saistatement));
	map_whitespace(&s);
	if (*saistatement!=')') err_hlr(GC_PUSHS("[FSM52] Missing \')\' in ARRTRAN")); 
	else ch= LOP(saistatement); 	/*  -- eat it up */
/*  # # DBUG('40000,"[FSM52].1 sym1='"&sym1&"' sym2='"&sym2&"'") */
	if (fast_equ(subsr(GC_PUSHS(sym1),1L,5L),GC_PUSHS("datum")))
		{/* need type of itemvar */
		s2= sym1;
		s1= GC_EPOPS(scan(&s2,12L,&i));  	/*  -- up to '(' */
		s1= GC_EPOPS(rightid(&s2));
		i= find_symbol(GC_PUSHS(s1),&cs1,&hs1);  /*  -- check types */
		sym1= GC_EPOPS(r_d_expr_map(GC_PUSHS(sym1)));  /*  -- need to eval it */
		}/* need type of itemvar */
	else i= find_symbol(GC_PUSHS(sym1),&cs1,&hs1);  /*  -- check types */
	if (fast_equ(subsr(GC_PUSHS(sym2),1L,5L),GC_PUSHS("datum")))
		{/* need type of itemvar */
		s2= sym2;
		s1= GC_EPOPS(scan(&s2,12L,&j));  	/*  -- up to '(' */
		s1= GC_EPOPS(rightid(&s2));
		j= find_symbol(GC_PUSHS(s1),&cs2,&hs2);  /*  -- check types */
		sym2= GC_EPOPS(r_d_expr_map(GC_PUSHS(sym2)));  /*  -- need to eval it */
		}/* need type of itemvar */
	else j= find_symbol(GC_PUSHS(sym2),&cs2,&hs2);
	ptype1= (((ps_itrash_= (((((dw1= (*aChkI(decldw,1L,i)))&020000L) ? 
			     cvltypep(gdw_itemtype(dw1)): dw1))&037))>0) ? (ps_itrash_+0140L)
				:0L);
	ptype2= (((ps_itrash_= (((((dw2= (*aChkI(decldw,1L,j)))&020000L) ? 
			     cvltypep(gdw_itemtype(dw2)): dw2))&037))>0) ? (ps_itrash_+0140L)
				:0L);
/*  # # DBUG('40000,"[FSM52].2 sym1='"&sym1&"' sym2='"&sym2&"'"&CRLF&" dw1='"&CVTYPES(dw1)&"'"&CRLF&" dw2='"&CVTYPES(dw2)&"'"&CRLF&" pType1='"&(ps!sTrash!_pType1)&"' pType2='"&(ps!sTrash!_pType2)&"'") */
	if (((dw1&047350)==0&&
	    (dw1&040L)==0) ||
	   ((dw2&047350)==0&&
	    (dw2&040L)==0))
		err_hlr(GC_PUSHS(
	catlist(13L,GC_PUSHS("[FSM52] Both args must be ARRAYs in ARRTRAN,"),
	        GC_PUSHS(crlf),GC_PUSHS(" type["),GC_PUSHS(sym1),
	        GC_PUSHS("]=\'"),cvtypes(dw1),GC_PUSHS("\'"),GC_PUSHS(crlf)
	        ,GC_PUSHS(" type["),GC_PUSHS(sym2),GC_PUSHS("]=\'"),
	        cvtypes(dw2),GC_PUSHS("\'"))));
	if (!usechkflag)
		{/* get size */
		cnt2= "0";
		if (slobflag) err_warning(&cnt2);
		cnt1= cnt2;
/*  --	NOTE: we are in trouble if they are not constants.... */
		if (i!=0) cnt1= (*aChkC(declsize,1L,i));
		if (j!=0) cnt2= (*aChkC(declsize,1L,j));
		lasttype= 0L;
		pdw_ptype(lasttype,codeinteger);
/*  # # DBUG('40000,"[FSM52].2.1 cnt1='"&cnt1&"' cnt2='"&cnt2&"'"&CRLF&" lastType='"&CVTYPES(lastType)&"'") */
		if (usefoldingflag)
			{/* fold constant expressions */
			cnt1= GC_EPOPS(fold_const_expr(GC_PUSHS(cnt1)));
			cnt2= GC_EPOPS(fold_const_expr(GC_PUSHS(cnt2)));
			while ((*cnt1!='\0') &&iswhitespace((INTEGER)*cnt1)) ps_itrash_= LOP(cnt1);
			while ((*cnt2!='\0') &&iswhitespace((INTEGER)*cnt2)) ps_itrash_= LOP(cnt2);
			}/* fold constant expressions */
		if (fast_equ(GC_PUSHS(cnt1),GC_PUSHS(cnt2))) size= cnt1; 
		else if (chk_integer(GC_PUSHS(cnt1)) &&chk_integer(GC_PUSHS(cnt2))) size= GC_EPOPS(cvs(MIN(cvd(GC_PUSHS(cnt1)),cvd(GC_PUSHS(cnt2))))
		); else size= catlist(5L,GC_PUSHS("MIN("),GC_PUSHS(cnt1),GC_PUSHS(","),
        GC_PUSHS(cnt2),GC_PUSHS(")"));
		size= GC_EPOPS(fold_const_expr(GC_PUSHS(size)));
/*  # # DBUG('40000,"[FSM52].3 size='"&size&"'"&CRLF&" lastType='"&CVTYPES(lastType)&"'") */
		i= 0;	/*  -- force 32-bit INTEGER */
		pdw_ptype(i,codeinteger);
		size= GC_EPOPS(cvactual_to_expected(i,lasttype,GC_PUSHS(size)));
		}/* get size */
	if (!usechkflag)
		{/* use & and set &* ==> NULL */
		if (*sym1=='*') ch= LOP(sym1); 
		else sym1= catlist(2L,GC_PUSHS("&"),GC_PUSHS(sym1));
		if (*sym2=='*') ch= LOP(sym2); 
		else sym2= catlist(2L,GC_PUSHS("&"),GC_PUSHS(sym2));
		}/* use & and set &* ==> NULL */
	s= catlist(5L,GC_PUSHS(s),GC_PUSHS("("),GC_PUSHS(sym1),GC_PUSHS(","),
        GC_PUSHS(sym2));
	if (!usechkflag) s= catlist(3L,GC_PUSHS(s),GC_PUSHS(","),GC_PUSHS(size));
	s= catlist(2L,GC_PUSHS(s),GC_PUSHS(")"));
	if ((ptype1!=ptype2)) err_warning(&s);
/*  # # DBUG('40000,"[FSM52].4 s='"&s&"'") */
	oldtypestatement= "%%fct_call";
;
	GC_SRETURN(s)
}/* FSM52 */
