/* FILE: fsm53.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmd.c, being converted 12/25/87, 07:27:34PM*/

/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm53(h)
	INTEGER h;
{/* FSM53 */
INTEGER i, 
	ch, 
	cs, 
	hs, 
	atype, 
	acode;
STRING s, 
	val, 
	cnt, 
	sym, 
	oldsym;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,53L))= (*aChkI(cntfsms,1L,53L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM53] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[53] ARRCLR*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM53>]
.INDEX ++PSAIL PROCEDURE: FSM53
	MAP SAIL:	ARRCLR(buf1,<opt val>)
	If not optional value then force 0 value.
	NOTE: If /NOCHECK then	Carrclr(&buf1,val,cnt)
	NOTE: If /CHECK then	arrclr(buf1,val)
.ENDLABEL [<++PSAIL PROCEDURE: FSM53>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(val); /* for G.C. */
	GC_NOTESTRING(cnt); /* for G.C. */
	GC_NOTESTRING(sym); /* for G.C. */
	GC_NOTESTRING(oldsym); /* for G.C. */
	oldtoken= GC_EPOPS(cvupcase(GC_PUSHS(saitoken)));
	s= GC_EPOPS(simple_map(h));
	if (!usechkflag) s= catlist(2L,GC_PUSHS("C"),GC_PUSHS(s));
	while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
	if ((*saistatement!='(')) err_hlr(GC_PUSHS("[FSM53] Missing \'(\' in ARRCLR")); 
		else s= catlist(2L,GC_PUSHS(s),GC_PUSHS(LOP(saistatement))); /*get it*/
	map_whitespace(&s);
	sym= GC_EPOPS(rightexpr(&saistatement));
	oldsym= sym;		/*  -- remember in case error */
	sym= GC_EPOPS(r_d_expr_map(GC_PUSHS(sym)));
	if (!usechkflag) 
		{/* use & and set &*==>NULL */
		if (*sym=='*') ch= LOP(sym); 
		else s= catlist(2L,GC_PUSHS(s),GC_PUSHS("&"));
		}/* use & and set &*==>NULL */

	atype= lasttype;
	acode= (((ps_itrash_= (atype&037))>0) ? (ps_itrash_+0140L)
				:0L);
	if ((atype&0200L)==0) 
		err_hlr(GC_PUSHS(
	catlist(8L,GC_PUSHS("[FSM53] ARRCLR expects array arg for \'"),
	        GC_PUSHS(oldsym),GC_PUSHS("\',"),GC_PUSHS(" type["),
	        GC_PUSHS(oldsym),GC_PUSHS("]=\'"),cvtypes(atype),
	        GC_PUSHS("\'."))));
	s= catlist(2L,GC_PUSHS(s),GC_PUSHS(sym));
	map_whitespace(&s);
	if ((*saistatement==')')) 
		{val= ((acode==codestring) ? "PNULL"
		     : (acode==codereal||acode==codedouble) ? 
			"0.0"
		      : "0");
		if (slobflag) err_warning(&val);
		}else	{/* get value */
		ch= LOP(saistatement); /*  -- Trash ','  */
		midofexpr= 1L;
		val= GC_EPOPS(rightexpr(&saistatement));
		val= GC_EPOPS(r_d_expr_map(GC_PUSHS(val)));
		}/* get value */
/*  # # @V.51.33	aType_0 */
/*  # # @V.51.33	PDW!pType(aType,CODEinteger) */
	if (usefoldingflag) val= GC_EPOPS(fold_const_expr(GC_PUSHS(val)));
	val= GC_EPOPS(cvactual_to_expected(atype,lasttype,GC_PUSHS(val)));
/*  # # DBUG('40000,"[FSM53].1 s='"&s&"' val='"&val&"' useCHKflag="&PBOOL(useCHKflag)&" lastType='"&CVTYPES(lastType)&"'"&CRLF&" aType='"&CVTYPES(aType)&"'") */

	s= catlist(3L,GC_PUSHS(s),GC_PUSHS(","),GC_PUSHS(val));	/*  -- build '(id,val' */
	if (!usechkflag)
		{/* no dynamic arrays */
		cnt= "0";
		if (!slobflag) err_warning(&cnt);
		if ((i= find_symbol(GC_PUSHS(sym),&cs,&hs))!=0) cnt= (*aChkC(declsize,1L,i));
/*  # # DBUG('40000,"[FSM53].2 cnt='"&cnt&"' i="&CVS(i)) */
		if (usefoldingflag) cnt= GC_EPOPS(fold_const_expr(GC_PUSHS(cnt)));
		cnt= GC_EPOPS(cvactual_to_expected(atype,lasttype,GC_PUSHS(cnt)));
		s= catlist(3L,GC_PUSHS(s),GC_PUSHS(","),GC_PUSHS(cnt));
		}/* no dynamic arrays */
	if (*saistatement==')') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(LOP(saistatement)));
/*  # # DBUG('40000,"[FSM53].3 s='"&s&"'") */
	oldtypestatement= "%%fct_call";
;
	GC_SRETURN(s)
}/* FSM53 */
