/* FILE: fsm55.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmd.c, being converted 12/25/87, 07:27:34PM*/

/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm55(h)
	INTEGER h;
{/* FSM55 */
INTEGER i, 
	ch, 
	type, 
	cs, 
	hs, 
	dw;
STRING s, 
	element, 
	setname, 
	specifier, 
	position, 
	direction,
	terminator, 
	allspecifier;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,55L))= (*aChkI(cntfsms,1L,55L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM55] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[55] PUT/REMOVE<leap item>*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM55>]
.INDEX ++PSAIL PROCEDURE: FSM55
	Map SAIL:	PUT x IN y [BEFORE/AFTER z]
	to either
			put(x,y)
	or		putBefore(x,y,z)
	or		putAfter(x,y,z)
	or		putIndexed(x,y,z)

		REMOVE x FROM y
	or	REMOVE ALL x FROM y
	is mapped to either  
		remSET(x,y)
or			remLIST(x,y)
or			remListAll(x,y)
These take the form of:
	<Opr><element><direction><set name>[<specifier><position>].
.ENDLABEL [<++PSAIL PROCEDURE: FSM55>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(element); /* for G.C. */
	GC_NOTESTRING(setname); /* for G.C. */
	GC_NOTESTRING(specifier); /* for G.C. */
	GC_NOTESTRING(position); /* for G.C. */
	GC_NOTESTRING(direction); /* for G.C. */
	GC_NOTESTRING(terminator); /* for G.C. */
	GC_NOTESTRING(allspecifier); /* for G.C. */
	element= setname= specifier= allspecifier= position= direction= GC_EPOPS(makstr(type= (INTEGER)'\0'));
	oldtoken= saitoken;
	s= GC_EPOPS(simple_map(h));
	element= GC_EPOPS(copy_either(GC_PUSHS("in,from,all"),&direction));
	if (h==hremove&&fast_equ(GC_PUSHS(direction),GC_PUSHS("all")))
		{/* ALL specified in REMOVE */
		allspecifier= "All";
		element= GC_EPOPS(copy_either(GC_PUSHS("in,from"),&direction));
		}/* ALL specified in REMOVE */
		else allspecifier= PNULL;
	while ((*element!='\0') &&iswhitespace((INTEGER)*element)) ps_itrash_= LOP(element);  {/* TRASH!RIGHT!WS */
			while ((*element!='\0') &&
			      (ps_itrash_= (*(element+length(element)-1))) &&
			      iswhitespace(ps_itrash_)) 
						element= subst(GC_PUSHS(element),1L,length(element)-1L);
			}/* TRASH!RIGHT!WS */
	setname= GC_EPOPS(copy_either(GC_PUSHS(";,end,else,before,after"),&terminator));
	while ((*setname!='\0') &&iswhitespace((INTEGER)*setname)) ps_itrash_= LOP(setname);  {/* TRASH!RIGHT!WS */
			while ((*setname!='\0') &&
			      (ps_itrash_= (*(setname+length(setname)-1))) &&
			      iswhitespace(ps_itrash_)) 
						setname= subst(GC_PUSHS(setname),1L,length(setname)-1L);
			}/* TRASH!RIGHT!WS */
	if (fast_equ(GC_PUSHS(terminator),GC_PUSHS("before")) ||
	   fast_equ(GC_PUSHS(terminator),GC_PUSHS("after")))
		{/* after/before */
		ch= (INTEGER)*(GC_EPOPS(cvupcase(makstr(LOP(terminator)))));
		specifier= catlist(2L,makstr(ch),GC_PUSHS(terminator));
		terminator= PNULL;
		position= GC_EPOPS(copy_either(GC_PUSHS(";,end,else"),&terminator));
	      while ((*position!='\0') &&iswhitespace((INTEGER)*position)) ps_itrash_= LOP(position); {/* TRASH!RIGHT!WS */
			while ((*position!='\0') &&
			      (ps_itrash_= (*(position+length(position)-1))) &&
			      iswhitespace(ps_itrash_)) 
						position= subst(GC_PUSHS(position),1L,length(position)-1L);
			}/* TRASH!RIGHT!WS */
		dw= (*aChkI(decldw,1L,find_symbol(GC_PUSHS(position),&cs,&hs)));
		if (!isleapcode(dw)) specifier= "Indexed";
		if (h==hremove) err_hlr(GC_PUSHS(
			"[FSM55] Illegal REMOVE syntax!"));
		}/* after/before */

	if (h==hremove) 
		{/* REMOVE */
		i= find_symbol(GC_PUSHS(setname),&cs,&hs);
		type= (((ps_itrash_= (((*aChkI(decldw,1L,i)))&037))>0) ? (ps_itrash_+0140L)
				:0L);
/*  # # DBUG('40000,"[FSM55].1 setName="&setName&" i="&CVS(i)&" type="&CVTYPES(type)) */
		s= "remIndexed";
		if ((i!=0)) ((type==codeset)) ? 
				(INTEGER)*((s= "remSet"
			)):;  ((type==codelist)) ? 
				(INTEGER)*(s= "remList";
		)else;}/* REMOVE */

	if (*allspecifier!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(allspecifier));
	if (*specifier!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(specifier));
	if (*ps__leap_!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(ps__leap_));
	s= catlist(5L,GC_PUSHS(s),GC_PUSHS("("),GC_PUSHS(element),GC_PUSHS(","),
        GC_PUSHS(setname));
	if ((*specifier!='\0')) s= catlist(3L,GC_PUSHS(s),GC_PUSHS(","),GC_PUSHS(position));
	s= catlist(2L,GC_PUSHS(s),GC_PUSHS(")"));
	if (*terminator!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(terminator));
	oldtypestatement= "%%fct_call";
;
	GC_SRETURN(s)
}/* FSM55 */
