/* FILE: fsm56.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmd.c, being converted 12/25/87, 07:27:34PM*/

/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm56(h)
	INTEGER h;
{/* FSM56 */
STRING s, 
	s1, 
	s2, 
	s3, 
	brkstr;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,56L))= (*aChkI(cntfsms,1L,56L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM56] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[56] MAKE/ERASE<leap triple>*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM56>]
.INDEX ++PSAIL PROCEDURE: FSM56
	Map SAIL:	MAKE/ERASE  a XOR b EQV y
	to C:
		make(a,b,c)
	and
		erase(a,b,c)
.ENDLABEL [<++PSAIL PROCEDURE: FSM56>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(s2); /* for G.C. */
	GC_NOTESTRING(s3); /* for G.C. */
	GC_NOTESTRING(brkstr); /* for G.C. */
	oldtoken= saitoken;
	s= GC_EPOPS(simple_map(h));
	s1= GC_EPOPS(copy_either(GC_PUSHS("xor"),&brkstr));
	while ((*s1!='\0') &&iswhitespace((INTEGER)*s1)) ps_itrash_= LOP(s1); {/* TRASH!RIGHT!WS */
			while ((*s1!='\0') &&
			      (ps_itrash_= (*(s1+length(s1)-1))) &&
			      iswhitespace(ps_itrash_)) 
						s1= subst(GC_PUSHS(s1),1L,length(s1)-1L);
			}/* TRASH!RIGHT!WS */
	s2= GC_EPOPS(copy_either(GC_PUSHS("eqv"),&brkstr));
	while ((*s2!='\0') &&iswhitespace((INTEGER)*s2)) ps_itrash_= LOP(s2); {/* TRASH!RIGHT!WS */
			while ((*s2!='\0') &&
			      (ps_itrash_= (*(s2+length(s2)-1))) &&
			      iswhitespace(ps_itrash_)) 
						s2= subst(GC_PUSHS(s2),1L,length(s2)-1L);
			}/* TRASH!RIGHT!WS */
	s3= GC_EPOPS(rightexpr(&saistatement));
	while ((*s3!='\0') &&iswhitespace((INTEGER)*s3)) ps_itrash_= LOP(s3); {/* TRASH!RIGHT!WS */
			while ((*s3!='\0') &&
			      (ps_itrash_= (*(s3+length(s3)-1))) &&
			      iswhitespace(ps_itrash_)) 
						s3= subst(GC_PUSHS(s3),1L,length(s3)-1L);
			}/* TRASH!RIGHT!WS */
/*  # # DBUG('40000,"[FSM56].1 s1='"&s1&"' s2='"&s2&"' s3='"&s3&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
	push(GC_PUSHS(s));
	if (!chk_id(GC_PUSHS(s1)))
		{/* map it */
		push(GC_PUSHS(s2)); push(GC_PUSHS(s3));
		s1= GC_EPOPS(r_d_expr_map(GC_PUSHS(s1)));
		pop(&s3); pop(&s2);
		}/* map it */
	if (!chk_id(GC_PUSHS(s2)))
		{/* map it */
		push(GC_PUSHS(s1)); push(GC_PUSHS(s3));
		s2= GC_EPOPS(r_d_expr_map(GC_PUSHS(s2)));
		pop(&s3); pop(&s1);
		}/* map it */
	if (!chk_id(GC_PUSHS(s3)))
		{/* map it */
		push(GC_PUSHS(s1)); push(GC_PUSHS(s2));
		s3= GC_EPOPS(r_d_expr_map(GC_PUSHS(s3)));
			pop(&s2); pop(&s1);
		}/* map it */
	pop(&s);
/*  # # DBUG('40000,"[FSM56].2 s1='"&s1&"' s2='"&s2&"' s3='"&s3&"'") */
	if (fast_equ(GC_PUSHS(s),GC_PUSHS("make"))) ismakeflag= 1L;
	if (*ps__leap_!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(ps__leap_));
	s= catlist(8L,GC_PUSHS(s),GC_PUSHS("("),GC_PUSHS(s1),GC_PUSHS(","),
        GC_PUSHS(s2),GC_PUSHS(","),GC_PUSHS(s3),GC_PUSHS(")"));
/*  # # DBUG('40000,"[FSM56].3 s='"&s&"'") */
	oldtypestatement= "%%fct_call";
;
	GC_SRETURN(s)
}/* FSM56 */
