/* FILE: fsm58.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmd.c, being converted 12/25/87, 07:27:34PM*/

/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */



/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm58(h)
	INTEGER h;
{/* FSM58 */
INTEGER i, 
	ch, 
	brk, 
	datumtype, 
	itemtype, 
	ptype, 
	rtype;
STRING s, 
	s1, 
	s2, 
	lexpr, 
	rexpr, 
	datumarg, 
	datumprefix, 
	opttypes;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,58L))= (*aChkI(cntfsms,1L,58L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM58] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[58] DATUM<leap>*/
/*   --
.LABEL [<++PSAIL PROCEDURE: FSM58>]
.INDEX ++PSAIL PROCEDURE: FSM58
	Maps SAIL:	datum(x) 
	to C:		*datum(&Eval(x))
	If 'x' is typed then append the PSAIL internal declaration
	type to the word 'datum' as for example with
	INTEGER ITEM ijk, REAL ITEM xyz, STRING ITEM s1
	and	Datum(ijk), Datum(xyz) and Datum(s1)
	Maps to:	datumI(ijk), datumF(xyz) and datumS(s1)
and
#		Maps SAIL:	datum(x)[index list]
	to C:		*datum(Eval(x))[Eval(index list)]
and
	Maps SAIL:	datum(x)_<expr> 
	to C:		saveDatum(&x,<expr>)
	NOTE: datum(x) function returns a POINTER to the <leaprun.c>
	datum.
	
	This FSM also maps PROPS(item)
	 to 	props(item)
	 or 	putProps(item,value)

NOTE: @V.52.85 2/1/86 - Add EXTENSION to PSAIL which allows type
declarations in DATUM(x,<type>)'s just as we can currently do for
MEMORY[x,<type>]. This allows us to set up an untyped ITEMVAR-ARRAY
where each element of the array is a datum of a different type. We
can then use TYPEIT() on the element to (1) determine the type. We
can then use alternate statements (such as 
	ITEMVAR ARRAY a[1:1000]
	ITEMVAR iv
	INTEGER i
	REAL r
	STRING s
	iv := a(i)
	Case TYPEIT(iv) Of
	Begin
	[i] i:=DATUM(iv,INTEGER)
	[r] r:=DATUM(iv,REAL)
	[s] s:=DATUM(iv,STRING)
		. . .
	End.
which would generate datumI(), datumF() and datumC() respectively.
	i:=DATUM(a(x,INTEGER)
.ENDLABEL [<++PSAIL PROCEDURE: FSM58>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(s2); /* for G.C. */
	GC_NOTESTRING(lexpr); /* for G.C. */
	GC_NOTESTRING(rexpr); /* for G.C. */
	GC_NOTESTRING(datumarg); /* for G.C. */
	GC_NOTESTRING(datumprefix); /* for G.C. */
	GC_NOTESTRING(opttypes); /* for G.C. */
	oldtoken= saitoken;
	datumprefix= GC_EPOPS(simple_map(h));
	while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
	ch= LOP(saistatement);
	s2= GC_EPOPS(copy_either(GC_PUSHS(",)"),&s1));	/*  -- with (..)  */
	if (*s1==',') opttypes= GC_EPOPS(copy_either(GC_PUSHS(")"),&s1)
	); else opttypes= PNULL;	/*  -- EXTENSION to PSAIL allows
				optional TYPE declaration
				in DATUM(x,<type>) as we
				do for MEMORY[x,<type>] */
	if (!(ch=='('&&*s1==')'))
	err_hlr(GC_PUSHS("[FSM58] Missing \'(\' or \')\' after DATUM"));
/*  # # DBUG('40000,"[FSM58].1 s2='"&s2&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
	datumarg= GC_EPOPS(r_d_expr_map(GC_PUSHS(s2)));  	/*  -- Eval it */
/*  # # DBUG('40000,"[FSM58].2 datumArg='"&datumArg&"'"&CRLF&" lastType=0"&CVOS(lastType)&"='"&CVTYPES(lastType)&"'") */
	if ((lasttype&020000L)==0)
		{/* cvt it to LEAP type */
/*  # # @V.48.72 -- NOTE: Needs more word reguarding setting type
# # #	'item' bits */
		datumtype= dw_leap|codeitemvar|(datumtype&0200L);
		datumarg= GC_EPOPS(cvactual_to_expected(datumtype,
					lasttype,GC_PUSHS(datumarg)));
		}/* cvt it to LEAP type */
	else datumtype= lasttype;

	datumarg= catlist(3L,GC_PUSHS("("),GC_PUSHS(datumarg),GC_PUSHS(")"));
	itemtype= gdw_itemtype(datumtype);

/*  # # DBUG('40000,"[FSM58].2.1 optTypeS='"&optTypeS&"' datumArg='"&datumArg&"'"&CRLF&" datumType='"&CVTYPES(datumType)&"'"&CRLF&" itemType=0"&CVOS(itemType)) */
	if (*opttypes!='\0')
		{/* Use explicty type for DATUM */
		i= cvstype(GC_PUSHS(opttypes));   /*  -- cvt SAIL decl type
					string to DW */
		if (i==0) err_hlr(GC_PUSHS(
catlist(3L,GC_PUSHS("[FSM58] Illegal <type> \'"),GC_PUSHS(opttypes),
        GC_PUSHS("\' in DATUM(<item>,<type>)"))));
		itemtype= cvptypel(i);  /*  -- cvt DW to itemCode */
/*  # # DBUG('40000,"[FSM58].2.1.1 datumArg='"&datumArg&"'"&CRLF&" datumType='"&CVTYPES(datumType)&"'"&CRLF&" itemType=0"&CVOS(itemType)&CRLF&" i='"&CVTYPES(i)&"'") */
		}/* Use explicty type for DATUM */

/*  . . . .  Compute the DATUM type string PREFIX . . . .  */
	if ((itemtype==0) ||
	 (datumtype&020000L)==0 ||
	   (itemtype==1))
		{/* is untyped datum */
		if (ismacroflag) isfragmentflag= 1L;
		lasttype= 0L;
		pdw_ptype(lasttype,codeinteger); /*  -- DEFAULT */
		itemtype= ptype= 0;
		err_warning(&datumprefix);
/*  # # DBUG('40000,"[FSM58].2.2 itemType='"&CVS(itemType)&"'"&CRLF&" datumType=0"&CVOS(datumType)&"='"&CVTYPES(datumType)&"'"&CRLF&" pType='"&(ps!sTrash!_pType)&"'"&CRLF&" datumPrefix='"&datumPrefix&"' datumArg='"&datumArg&"'"&CRLF&" lastType='"&CVTYPES(lastType)&"'") */
			}/* is untyped datum */
	else 	{/* is Typed datum */
		lasttype= cvltypep(itemtype);
		ptype= (((ps_itrash_= (lasttype&037))>0) ? (ps_itrash_+0140L)
				:0L);
		if (ptype!=0) datumprefix= 
        
        					  catlist(GC_PUSHS(datumprefix),cvupcase(makstr(ptype)));
				/*  -- Eg. change extension
				  of DATUM?(). I.e DATUMI() */
/*  # # DBUG('40000,"[FSM58].3 itemType='"&CVS(itemType)&"'"&CRLF&" datumType=0"&CVOS(datumType)&"='"&CVTYPES(datumType)&"'"&CRLF&" pType='"&(ps!sTrash!_pType)&"'"&CRLF&" datumPrefix='"&datumPrefix&"' datumArg='"&datumArg&"'"&CRLF&" lastType='"&CVTYPES(lastType)&"'") */
		}/* is Typed datum */
	if (datumtype&040L) lasttype=lasttype|0200L;

	s= catlist(2L,GC_PUSHS(datumprefix),GC_PUSHS(datumarg)); 	/*  -- Add Declaration
					type postfix */
/*  # # DBUG('40000,"[FSM58].3.1 s='"&s&"' datumPrefix='"&datumPrefix&"'"&CRLF&"  datumArg='"&datumArg&"'"&CRLF&" lastType="&CVTYPES(lastType)&"'") */

/*   . . . If DATUM(..)[...] SYNTAX ... */
	while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
	if ((*saistatement=='['))
		{/* array arg list */
/*  # #@V.48.133	If (datumType Land DW!itemArray)=0 ### */
		if ((lasttype&0200L)==0) err_hlr(GC_PUSHS(
catlist(9L,
        GC_PUSHS("[FSM58] Can\'t access ARRAY DATUM for non-array itemvar \'")
        ,GC_PUSHS(s2),GC_PUSHS("\'."),GC_PUSHS(crlf),
        GC_PUSHS("Type \'"),GC_PUSHS(s2),GC_PUSHS("\' = \'"),
        cvtypes(lasttype),GC_PUSHS("\'"))));
		ch= LOP(saistatement);  /*  -- So FSM4 works */
		push(GC_PUSHS(cstatement));
		push(GC_PUSHS(datumprefix));  pushnumber(lasttype);
		push(GC_PUSHS(datumarg)); push(GC_PUSHS(oldtoken));
		oldtoken= cstatement= catlist(2L,GC_PUSHS("*"),GC_PUSHS(s));  /*  -- ie. <lValue> */
		s= GC_EPOPS(fsm4(hleftbracket));
		pop(&oldtoken); pop(&datumarg);
		popnumber(&lasttype); pop(&datumprefix);
		pop(&cstatement);
	if (!usechkflag) s= catlist(3L,GC_PUSHS(datumprefix),GC_PUSHS(datumarg),GC_PUSHS(s));
/*  # # DBUG('40000,"[FSM58].4 s='"&s&"'") */
		}/* array arg list */

/*  . . . . CHECK IF ASSIGNMENT STATEMENT . . .  */
	while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
	if (*saistatement==':'&&(*(saistatement+2-1))=='=')
		{/* is left EXPR, get <rValue> */
		saistatement= subst(GC_PUSHS(saistatement),3L,length(saistatement)); /*trash :=*/
		lexpr= s;     /*  -- full datum() returns pointer */
		rexpr= GC_EPOPS(rightexpr(&saistatement));
		pushnumber(lasttype); push(GC_PUSHS(lexpr));
		push(GC_PUSHS(datumprefix));
		rexpr= GC_EPOPS(r_d_expr_map(GC_PUSHS(rexpr)));
		rtype= lasttype;
		pop(&datumprefix);
		pop(&lexpr); popnumber(&lasttype);
		rexpr= GC_EPOPS(cvactual_to_expected(lasttype,rtype,
						GC_PUSHS(rexpr)));
		s= catlist(7L,GC_PUSHS("save"),GC_PUSHS(datumprefix),GC_PUSHS("("),
        GC_PUSHS(lexpr),GC_PUSHS(","),GC_PUSHS(rexpr),GC_PUSHS(")"));
/*  # # DBUG('40000,"[FSM58].5 s='"&s&"'") */
		}/* is left EXPR, get <rValue> */
	
	if (*s==('d'/*WARNING*/)) s= catlist(2L,GC_PUSHS("*"),GC_PUSHS(s));	  /*  -- since reference as ptr */
	if (*ps__leap_!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(ps__leap_));
/*  # # DBUG('40000,"[FSM58].6 s='"&s&"'"&CRLF&" lastType='"&CVTYPES(lastType)&"'"&CRLF&" datumType='"&CVTYPES(datumType)&"'") */
	oldtypestatement= "%%fct_call";

	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'brk'=<L0> integer                            */
/*************************************************/
}/* FSM58 */
