/* FILE: fsm59.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsmd.c, being converted 12/25/87, 07:27:34PM*/

/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING fsm59(h)
	INTEGER h;
{/* FSM59 */
INTEGER ch, 
	i, 
	brk, 
	n;
STRING s, 
	s1, 
	s2, 
	condition, 
	varlist, 
	condmap, 
	varmap, 
	wspreface;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,59L))= (*aChkI(cntfsms,1L,59L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(6L,GC_PUSHS("[FSM59] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h),GC_PUSHS("  locLEAPptr="),
        cvs(locleapptr))));
/*[59] FOREACH<leap>*/
/*
.LABEL [<++PSAIL PROCEDURE: FSM59>]
.INDEX ++PSAIL PROCEDURE: FSM59
	Map SAIL:
		FOREACH <varlist> SUCH THAT <LEAP boolean> DO
					<statement>
	  to C:
		{<varlst>=-1;
		 while (foreach(n,&v1,&v2,...,&vn))
			if (<LEAP boolean>') <statement>
		}
	Where: <varlist> is a list of leap ITEMVAR declared
			variables.
		<LEAP boolean> is a conjunction (using AND) of
			<leap-element>.
		<leap-element> is either
				a XOR b EQV z
			or
				a IN S. (S is SET or LIST)
		Where a,b,c are in <varlist>.
		<LEAP boolean>' is a mapping to a list of
		triple retrieval, and list and set test
		booleans.
		Each <be> of the <LEAP boolean> conjunction
		is subjected to the P_SKIP() search
		optimization using procedure
		CHK!LEAP!OPTIMIZE(<be>,a,o,v) called for 'IN'
		(FSM19) and triples (FSM66).
.ENDLABEL [<++PSAIL PROCEDURE: FSM59>]
*/
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(s2); /* for G.C. */
	GC_NOTESTRING(condition); /* for G.C. */
	GC_NOTESTRING(varlist); /* for G.C. */
	GC_NOTESTRING(condmap); /* for G.C. */
	GC_NOTESTRING(varmap); /* for G.C. */
	GC_NOTESTRING(wspreface); /* for G.C. */
	set_preface(&wspreface);
	oldtoken= saitoken;
	n= 0;
	while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
	varlist= GC_EPOPS(copy_either(GC_PUSHS("such,suchthat"),&s1));
	if (fast_equ(GC_PUSHS(s1),GC_PUSHS("such"))) s2= GC_EPOPS(copy_omit(GC_PUSHS("that")));
	while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
	condition= GC_EPOPS(copy_omit(GC_PUSHS("do")));
/*  # # DBUG('40000,"[FSM59].1 varList='"&varList&"'"&CRLF&" condition='"&condition&"'") */

	/* 	Map <varlist> to (int)a=b=...=c=-1   */
	varmap= PNULL;
	s1= varlist;
	while ((*s1!='\0'))
		if (*s1==',')
			{/* map , to = */
			ch= LOP(s1);
			varmap= catlist(2L,GC_PUSHS(varmap),GC_PUSHS("="));
			}/* map , to = */
			else varmap= catlist(2L,GC_PUSHS(varmap),GC_PUSHS(LOP(s1)));
	varmap= catlist(2L,GC_PUSHS(varmap),GC_PUSHS("= -1"));
/*  # # DBUG('40000,"[FSM59].2 varMap='"&varMap&"'") */

/*  # # ***ADD CODE***@V.35.02, Will call MAP!TRIPLE */
/* 			Map <SAIL LEAP boolean> to <C LEAP boolean>' 
		list of fndT(a,b,c), inSET(a,S), inLIST(a,L)
		statements */
	pushnumber(locleapptr);	   /*  -- ie. whats in var stack */
	s1= varlist;
	while ((*s1!='\0'))
		{/* setup FOREACH locals stack frame */
		s2= GC_EPOPS(getid(&s1,&brk));
		while ((*s2!='\0') &&iswhitespace((INTEGER)*s2)) ps_itrash_= LOP(s2);  {/* TRASH!RIGHT!WS */
			while ((*s2!='\0') &&
			      (ps_itrash_= (*(s2+length(s2)-1))) &&
			      iswhitespace(ps_itrash_)) 
						s2= subst(GC_PUSHS(s2),1L,length(s2)-1L);
			}/* TRASH!RIGHT!WS */
		if (chk_id(GC_PUSHS(s2)))
			{/* push LOCAL itemvar */
			if ((++locleapptr)>20) err_hlr(GC_PUSHS(
			"[FSM59] localLEAP[] PDL OVF!"));
			(*aChkC(localleap,1L,locleapptr))= s2;
			++n;
			}/* push LOCAL itemvar */
		}/* setup FOREACH locals stack frame */

	push(GC_PUSHS(varmap));
	pushnumber(isforeachflag); isforeachflag= 1L;
	condmap= GC_EPOPS(r_d_expr_map(GC_PUSHS(condition))); /*eval bool*/
	popnumber(&isforeachflag);
/*  # # DBUG('40000,"[FSM59].3 locLEAPptr="&CVS(locLEAPptr)&" n="&CVS(n)&CRLF&"  condMap='"&condMap&"'") */
	pop(&varlist);
	locleapptr -= n;	/*  -- Remove stack frame */

	s= catlist(5L,GC_PUSHS("{"),GC_PUSHS(varmap),GC_PUSHS(";"),
        GC_PUSHS(wspreface),GC_PUSHS("while (foreach"));
	if (*ps__leap_!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(ps__leap_));
	s= catlist(3L,GC_PUSHS(s),GC_PUSHS("("),cvs(n));
/*  # # DBUG('40000,"[FSM59].3.1 s='"&s&"'") */
	for (i=1;i<=n;i++)
		s= catlist(3L,GC_PUSHS(s),GC_PUSHS(",&"),GC_PUSHS(*aChkC(localleap,1L,i)));
/*  # # DBUG('40000,"[FSM59].3.2 s='"&s&"'") */
	s= catlist(9L,GC_PUSHS(s),GC_PUSHS("))"),GC_PUSHS(wspreface),
        GC_PUSHS(tab),GC_PUSHS("if ("),GC_PUSHS(condmap),GC_PUSHS(
        ")"),GC_PUSHS(wspreface),GC_PUSHS(tab));
/*  # # DBUG('40000,"[FSM59].3.3 s='"&s&"'"&CRLF&"  saiStatement='"&saiStatement&"'") */

/* 	 . . . Eval the DO in case need to do STRING G.C. ... */
	push(GC_PUSHS(wspreface)); push(GC_PUSHS(s)); pushnumber(sawstrfct);
	s1= GC_EPOPS(rightstatement());  	/*  -- get entire DO is around */
/*  # # DBUG('40000,"[FSM59].4 s1='"&s1&"'"&CRLF&"  saiStatement='"&saiStatement&"'") */
	sawstrfct= 0L;
	s1= GC_EPOPS(r_d_expr_map(GC_PUSHS(s1)));
/*  # # @V.53.59	If sawStrFct and useGCflag
# # # @V.53.59		Then
# # # @V.53.59		Begin "add GC marking stuff"
# # # @V.53.59		s1_"{GC_SMARK" & semiColon & " " & s1 */
/*  # # @V.53.59		INSERT!BEFORE!WHITE(s1,"GC_SUNMARK"&semiColon&"}") */
/*  # # @V.53.59		End "add GC marking stuff" */
	popnumber(&sawstrfct); pop(&s); pop(&wspreface);
	popnumber(&locleapptr);
	if (equ(subst(GC_PUSHS(s1),1L,2L),GC_PUSHS(crlf)) &&
	    equ(subst(GC_PUSHS(wspreface),length(wspreface)-1L,
		      length(wspreface)),GC_PUSHS(crlf)))
		{/* No double CRLF */
		ch= LOP(s1); ch= LOP(s1);
		}/* No double CRLF */
	s= catlist(4L,GC_PUSHS(s),GC_PUSHS(s1),GC_PUSHS(wspreface),
		   GC_PUSHS("}"));
/*  # # DBUG('40000,"[FSM59].5 s1='"&s1&"'"&CRLF&"  s='"&s&"'"&
    "  locLEAPptr="&CVS(locLEAPptr)) */

	oldtypestatement= "foreach";
	isemitgcflag= !ismacroflag;	/*  -- enable for GC code 
					   generation */

	GC_SRETURN(s)
}/* FSM59 */

