/* FILE: fsm6.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsma.c, being converted 12/25/87, 05:15:20PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */

/*  -------------------------------------------------------- */
/*INTERNAL*/  STRING fsm6(h)
	INTEGER h;
{/* FSM6 */
STRING s, 
	s1, 
	s2, 
	brkstr, 
	be, 
	stmnt;
INTEGER i, 
	ch;


{/* INCFSM */
if (usecntfsmflag)
  (*aChkI(cntfsms,1L,6L))++;
}/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM6] \'rule\' NODE["),
			      GC_PUSHS(*aChkC(saisym,1L,h)),
			      GC_PUSHS("]="),prt_node(h))));
/*[6] DO*/
/*
.LABEL [<++PSAIL PROCEDURE: FSM6>]
.INDEX ++PSAIL PROCEDURE: FSM6
	If NOT part of a FOR or WHILE statement then
	   Map SAI:	DO <statement> UNTIL <be>;
	   To C:	do <statement>; while (! (<be>));
Future		   Map SAI:	DO <statement> WHILE<be>;
Future		   To C:	do <statement>; while (<be>);
@V.56.51
	If /MAINSAIL:
	   Map SAIL:	DO <statement> <non-UNTIL-terminator>
	   To C:	do <statement>; while (1);

	Scan the statement and R!D eval it. Trash the UNTIL
	Then finish the boolean later.
.ENDLABEL [<++PSAIL PROCEDURE: FSM6>]
*/
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(brkstr); /* for G.C. */
GC_NOTESTRING(be); /* for G.C. */
GC_NOTESTRING(stmnt); /* for G.C. */
oldtoken= "do";
pushnumber(midofexpr); midofexpr= 0L;
s= GC_EPOPS(rightstatement());
GC_EPOPS(dbug(040000L,catlist(7L,GC_PUSHS("[FSM6].1 s=\'"),GC_PUSHS(s),
			      GC_PUSHS("\'"),
			      GC_PUSHS(crlf),GC_PUSHS(" saiStatement=\'"),
			      GC_PUSHS(saistatement),GC_PUSHS("\'"))));
saistatement= catlist(2L,GC_PUSHS(s),GC_PUSHS(saistatement)); 
                                     /*  -- so make sure UNTIL is there! */
/*  # # @V.45.56      s2_"until,while" */ /*  -- Not implemented at this
				           time ...  later maybe.. */
s2= "until";		/*  -- PSAIL default break token */

#if (parsemainsail==1)
if (mainsailflag)
s2= "until,;,end,else";
#endif

s1= GC_EPOPS(copy_either(GC_PUSHS(s2),&brkstr)); 
GC_EPOPS(dbug(040000L,catlist(11L,GC_PUSHS("[FSM6].1.1 brkStr=\'"),
			      GC_PUSHS(brkstr),
			      GC_PUSHS("\'"),GC_PUSHS(crlf),
			      GC_PUSHS(" s1=\'"),
			      GC_PUSHS(s1),GC_PUSHS("\'"),
			      GC_PUSHS(crlf),
			      GC_PUSHS(" saiStatement=\'"),
			      GC_PUSHS(saistatement),
			      GC_PUSHS("\'"))));

#if (parsemainsail==1)
if (mainsailflag &&!fast_equ(GC_PUSHS(brkstr),GC_PUSHS("until")))
  {/* force an UNTIL FALSE==> while(1) */
    if (equ(GC_PUSHS(brkstr),GC_PUSHS("end")))
      {/* get the rest of it */
	  s1= catlist(2L,GC_PUSHS(s1),GC_PUSHS(brkstr));  /*  -- preserve it */
	  s2= GC_EPOPS(copy_either(GC_PUSHS("until,;,end,else"),&brkstr)); 
	  s1= catlist(2L,GC_PUSHS(s1),GC_PUSHS(s2));
	  if (!equ(GC_PUSHS(brkstr),GC_PUSHS("until")))
	    saistatement= ((*saistatement=='\0')
                                   ? brkstr
			           : catlist(2L,GC_PUSHS(brkstr),
					     GC_PUSHS(saistatement)));
GC_EPOPS(dbug(040000L,catlist(11L,GC_PUSHS("[FSM6].1.1.1 brkStr=\'"),
			      GC_PUSHS(brkstr),
			      GC_PUSHS("\'"),GC_PUSHS(crlf),
			      GC_PUSHS(" s1=\'"),
			      GC_PUSHS(s1),GC_PUSHS("\'"),
			      GC_PUSHS(crlf),
			      GC_PUSHS(" saiStatement=\'"),
			      GC_PUSHS(saistatement),
			      GC_PUSHS("\'"))));
        }/* get the rest of it */
    if (!equ(GC_PUSHS(brkstr),GC_PUSHS("until")))
      {/* It really is a DOFOREVER-LOOP */
	saistatement= catlist(3L,GC_PUSHS(" FALSE "),GC_PUSHS(brkstr),
			      GC_PUSHS(saistatement)); /*  -- backup */
	brkstr= "until";
      }/* It really is a DOFOREVER-LOOP */
GC_EPOPS(dbug(040000L,catlist(11L,
			GC_PUSHS("[FSM6].1.2 AFTER-MAINSAIL-FIXUP brkStr=\'"),
			      GC_PUSHS(brkstr),GC_PUSHS("\'"),GC_PUSHS(crlf),
			      GC_PUSHS(" s1=\'"),GC_PUSHS(s1),GC_PUSHS("\'"),
			      GC_PUSHS(crlf),GC_PUSHS(" saiStatement=\'"),
			      GC_PUSHS(saistatement),GC_PUSHS("\'"))));
  }/* force an UNTIL FALSE==> while(1) */
#endif /*MAINSAIL==1*/

stmnt= s1;	/*  -- keep copy for other processing */
while ((*s1!='\0') &&iswhitespace((INTEGER)*s1)) 
  ps_itrash_= LOP(s1);
s2= GC_EPOPS(getid(&s1,&ch));
if (!fast_equ(GC_PUSHS(s2),GC_PUSHS("begin"))) 
  {/* make statement a BLOCK */
      while ((*stmnt!='\0') &&iswhitespace((INTEGER)*stmnt))
	ps_itrash_= LOP(stmnt);
      stmnt= catlist(2L,GC_PUSHS("begin "),GC_PUSHS(stmnt));
      insert_before_white(&stmnt,GC_PUSHS(";end"));
  }/* make statement a BLOCK */
/*  # # DBUG('40000,"[FSM6].2 stmnt='"&stmnt&"'"&CRLF&
    " saiStatement='"&saiStatement&"'") */

push(GC_PUSHS(stmnt)); push(GC_PUSHS(brkstr));	/*  -- eval the <be>  */
be= GC_EPOPS(fsm5(hwhile)); 	/*  -- Go EVAL 'while' in case
				    we do 'next' in <statement> */
pop(&brkstr); pop(&stmnt);
/*  # # DBUG('40000,"[FSM6].3 be='"&be&"'"&CRLF&
    " isIFexpr="&PBOOL(isIFexpr)&" lastMappedToken='"&lastMappedToken&
    "'"&CRLF&" saiStatement='"&saiStatement&"'") */

midofexpr= 0L;
push(GC_PUSHS(lastmappedtoken));
pushnumber(isifexpr);	 isifexpr= 0L;
pushnumber(sawstrfct);	 /*  -- eval the <statement> */
sawstrfct= 0L;
push(GC_PUSHS(brkstr));
stmnt= GC_EPOPS(r_d_expr_map(GC_PUSHS(stmnt)));
pop(&brkstr);
/*  # # @V.53.59	If useGCflag And sawStrFCT
 # # # @V.53.59		Then
 # # # @V.53.59		Begin "Add G.C. code"
 # # # @V.53.59		stmnt_"{GC_SMARK" & semiColon & " " & stmnt */
/*  # # @V.53.59		INSERT!BEFORE!WHITE(stmnt,semiColon&
 # # # @V.53.59				" GC_SUNMARK"&semiColon&"}") */
/*  # # @V.53.59		End "Add G.C. code" */
popnumber(&sawstrfct);
popnumber(&isifexpr);
pop(&lastmappedtoken);

/*  # # DBUG('40000,"[FSM6].4 stmnt='"&stmnt&"'"&CRLF&
    " saiStatement='"&saiStatement&"'") */
oldtoken= "do";
popnumber(&midofexpr);
s= catlist(4L,GC_PUSHS("do "),GC_PUSHS(stmnt),GC_PUSHS(" "),
	   GC_PUSHS(be));
/*  # # DBUG('40000,"[FSM6].5 s='"&s&"'"&CRLF&
    " saiStatement='"&saiStatement&"'") */
oldtypestatement= "do";
isemitgcflag= !ismacroflag;	/*  -- enable for GC code generation */

GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'i'=<L0> integer                              */
/*************************************************/
}/* FSM6 */
