/* FILE: fsm62.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsme.c, being converted 12/25/87, 08:02:03PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  -------------------------------------------------------- */
/*INTERNAL*/  STRING fsm62(h)
	INTEGER h;
{/* FSM62 */
STRING s, 
	s1, 
	s2, 
	brkstr, 
	scopy;
INTEGER i, 
	ch, 
	dw, 
	h1;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,62L))= (*aChkI(cntfsms,1L,62L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM62] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[62] <AWK-like-macro-remapper opr>*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM62>]
.INDEX ++PSAIL PROCEDURE: FSM62
	Special remapper for various syntax extensions including
	MAINSAIL specific code.
	Later when REMAP(token,rule) is working, we express
	all MAINSAIL mappings as SYMTAB entries and do it there.
	**** THIS IS TERMPORARY@V.56.64 ****

	ARRAY:
	... ARRAY (lb1 to ub1, ...) id'
	to
	... ARRAY id[lb1:ub1, ...]'

	INIT:		\`b`(`c\ ==> \`G`b_init(`b,`c)\
	will map: INIT aStr("HIS","ALA",...,"MET")
	      to: C_init(aStr,"HIS","ALA",...,"MET")

	SOURCEFILE:	\`P<SC>\ ==> \require `P source_file<SC>\
	will map: SOURCEFILE "ABC.REQ"<SC>
	      to: require "ABC.REQ" source_file<SC>
	@V.56.63 - note that SOURCEFILE currently maps directly to
	[FSM17].

	<id>. RECORD access(L3 extension):
		\`b`T`Z==`r``\==>\`X`Y:`b[`Z]`
	will map:	rp.mem
	      to:	rc:mem[rp]
	where rc is the record class of rp.
.ENDLABEL [<++PSAIL PROCEDURE: FSM62>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(s2); /* for G.C. */
	GC_NOTESTRING(brkstr); /* for G.C. */
	GC_NOTESTRING(scopy); /* for G.C. */
	scopy= saistatement;	/*  -- in case err msg needed */
	s= saitoken;		/*  -- default */

	if (mainsailflag &&h==hash_c(GC_PUSHS("array")))
		{/* remap (...)id TO id[...] array */
		while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
		ch= LOP(saistatement);  /*  -- get '(' */
		if (ch!='(') brkstr= PNULL; 
		else s1= GC_EPOPS(copy_either(GC_PUSHS(")"),&brkstr));
					/*  -- get arglist */
/*  # # # DBUG('40000,"[FSM62].0.1 brkStr='"&brkStr&"' ch='"&(s2_ch)&"' s1='"&s1&"'") */
		if ((*brkstr!=')') ||(ch!='(')) err_hlr(GC_PUSHS(
		
		        					catlist(GC_PUSHS(
		        "[FSM62] bad \'(bounds-list)\' in ARRAY declaration"),
		        GC_PUSHS(crlf),GC_PUSHS(" \'"),GC_PUSHS(scopy),
		        GC_PUSHS("\'"))));
		while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
		s= GC_EPOPS(get_token(&saistatement));  /*  -- id */
		s= catlist(2L,GC_PUSHS(s),GC_PUSHS("["));
/*  # # # DBUG('40000,"[FSM62].1 s='"&s&"' s1='"&s1&"'") */
		while (*s1!='\0')
			if (*s1==' '&&
			   equ(subsr(GC_PUSHS(s1),1L,4L),GC_PUSHS(" to ")))
				{/* map ' to '==>':' */
				s= catlist(2L,GC_PUSHS(s),GC_PUSHS(":"));
				s1= subst(GC_PUSHS(s1),5L,length(s1));
				}/* map ' to '==>':' */
			else s= catlist(2L,GC_PUSHS(s),GC_PUSHS(LOP(s1)));
		s= catlist(2L,GC_PUSHS(s),GC_PUSHS("]"));	/*  -- tack on close brkt */
		/*  -- NOTE: push back to be reparsed by FSM11 */
		saistatement= ((*saistatement=='\0') ? s
			      : catlist(2L,GC_PUSHS(s),GC_PUSHS(saistatement)));
		s= "/*ARRAY*/ ";	/*  -- just a comment... */
		}/* remap (...)id TO id[...] array */

	else if (mainsailflag &&h==hash_c(GC_PUSHS("init")))
		{/* INIT id (aLst)==>T_init(id,aLst) */
		while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
		s= GC_EPOPS(get_token(&saistatement)); /*  -- id */
		s= GC_EPOPS(remove_white_ends(GC_PUSHS(s)));
		while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
		if ((ch= LOP(saistatement))!='(') brkstr= PNULL; 
		else s1= GC_EPOPS(copy_either(GC_PUSHS(")"),&brkstr));   /*  -- arglist */
/*  # # # DBUG('40000,"[FSM62].2 ch='"&(s2_ch)&"' brkStr='"&brkStr&"' s='"&s&"'"&CRLF&"  s1='"&s1&"'") */
		h1= hash_c(GC_PUSHS(s));
		dw= (*aChkI(decldw,1L,i= (*aChkI(dwptr,1L,h1))));
		if (h1==0||(dw&0200L)==0 ||
		   (*brkstr!=')'&&(ch!='('))) err_hlr(GC_PUSHS(
 
         		catlist(GC_PUSHS(
         "[FSM62] Missing \'(<parameter-list>)\' or Array <id> in INIT statement")
         ,GC_PUSHS(crlf),GC_PUSHS(" \'"),GC_PUSHS(scopy),
         GC_PUSHS("\'"))));
		s2= (((ps_itrash_= (dw&037))>0) ? GC_EPOPS(makstr((ps_itrash_+0140L)
				)):0L);  /*  -- Synthesize SUFFIX char */
		s= catlist(7L,GC_PUSHS(s2),GC_PUSHS("_init"),GC_PUSHS("("),GC_PUSHS(s),
        GC_PUSHS(","),GC_PUSHS(s1),GC_PUSHS(")"));
/*  # # DBUG('40000,"[FSM62].2.1 s='"&s&"'"&CRLF&" dw='"&CVTYPES(dw)&"'") */
/*  -- NOTE: we need to now do argument checking and coercion using
the [FSM71].
 */
		saistatement= ((*saistatement=='\0') ? s : catlist(2L,GC_PUSHS(s),GC_PUSHS(saistatement)));
		s= PNULL;	/*  -- don't do it here but when RE-eval! */
		}/* INIT id (aLst)==>T_init(id,aLst) */

	else if (useextensionsflag &&h==hash_c(GC_PUSHS(".")) &&
		((((ps_itrash_= (lasttype&037))>0) ? (ps_itrash_+0140L)
				:0L)==coderecptr))
		{/* see if remap rp.mem==>rc:mem[rp] */
		STRING rp, 
		rc, 
		mem;
		INTEGER hrp, 
		crp, 
		irp, 
		hrc;
		GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
		GC_NOTESTRING(rp); /* for G.C. */
		GC_NOTESTRING(rc); /* for G.C. */
		GC_NOTESTRING(mem); /* for G.C. */
		rp= ((*cstatement!='\0') ? (rp= GC_EPOPS(left_id(&cstatement) )): PNULL);
		irp= find_symbol(GC_PUSHS(rp),&crp,&hrp);
		rc= (*aChkC(saisym,1L,hrc= (*aChkI(declrclass,1L,irp))));
/*  # # DBUG('40000,"[FSM62].3 mem='"&mem&"' rp='"&rp&"' rc='"&rc&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
		mem= GC_EPOPS(get_token(&saistatement));
		s= catlist(6L,GC_PUSHS(rc),GC_PUSHS(":"),GC_PUSHS(mem),GC_PUSHS("["),
        GC_PUSHS(rp),GC_PUSHS("]"));
		saistatement= ((*saistatement=='\0') ? s : catlist(2L,GC_PUSHS(s),GC_PUSHS(saistatement)));
		s= PNULL;	/*  -- just remapping it back */
		{GC_UNMARKSSTKFRAME;}}/* see if remap rp.mem==>rc:mem[rp] */

	else s= GC_EPOPS(simple_map(h));	/*  -- nothing matched! */
GC_EPOPS(dbug(040000L,catlist(7L,GC_PUSHS("[FSM62].4 s=\'"),GC_PUSHS(s),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"))));
;
	GC_SRETURN(s)
}/* FSM62 */
