/* FILE: fsm65.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsme.c, being converted 12/25/87, 08:02:03PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  -------------------------------------------------------- */
/*INTERNAL*/  STRING fsm65(h)
	INTEGER h;
{/* FSM65 */
STRING s, 
	s1, 
	data, 
	type, 
	lid, 
	rid, 
	nexttoken;
INTEGER h1, 
	h2, 
	ch, 
	i, 
	j, 
	k, 
	argtype;
INTEGER ctype, 
	stype, 
	isleaplistflag, 
	lastoprisleap, 
	isrightleapopr;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,65L))= (*aChkI(cntfsms,1L,65L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM65] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[65] (<LEAP-LIST>*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM65>]
.INDEX ++PSAIL PROCEDURE: FSM65
	If the previous token is a LEAP LIST operator, then
	MAP SAIL:	(a,b,c,a) 
		or	LISTO a,b,c,a LISTC
		or	{{a,b,c,a}} 
	to C:		defLIST(a,b,c,a,0)
	Otherwise, just map nested parentheses.
	NOTE: the (a,b,c...) is ambigous so we must be extra careful.
	a) the 1st element after the '(' must be a LEAP type.
	b) the left operand must be a leap type.
	c) the operator must be either 
		=, ASSOC, IN, UNION, INTER, -
.ENDLABEL [<++PSAIL PROCEDURE: FSM65>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(data); /* for G.C. */
	GC_NOTESTRING(type); /* for G.C. */
	GC_NOTESTRING(lid); /* for G.C. */
	GC_NOTESTRING(rid); /* for G.C. */
	GC_NOTESTRING(nexttoken); /* for G.C. */
	i= (INTEGER)*(lid= PNULL);
	midofexpr= 1L;
	isleaplistflag= 0L;
	if (h==hleftparen&&(ctype= isleapcode(lasttype)))
		{/* test for (...) LEAP list */
		h1= hash_c(GC_PUSHS(oldtoken));
		s= saistatement;
		argtype= chk_type(GC_PUSHS(rid= GC_EPOPS(rightid(&s))));
		stype= isleapcode(argtype);
		lastoprisleap= (h1==hbackarrow||h1==hunion ||
			 h1==hinter ||h1==hassoc ||
			 (h1==hminus&&stype));
		if (!(isleaplistflag= (ctype &&stype &&
					lastoprisleap)))
			{/* check right token */
			nexttoken= GC_EPOPS(remove_white_ends(GC_PUSHS(
					GC_EPOPS(scan(&s,19L,&ch)))));
			h2= hash_c(GC_PUSHS(nexttoken));
			isrightleapopr= (h2==hin) ||(stype &&h2==hxor);
			if (ctype &&stype &&isrightleapopr) isleaplistflag= 1L;
			}/* check right token */
/*  # # DBUG('40000,"[FSM65].1 cType="&PBOOL(cType)&" rID="&rID&" sType="&PBOOL(sType)&CRLF&"  lastOPRisLEAP="&PBOOL(lastOPRisLEAP)&" nextToken='"&nextToken&"' isRightLEAPopr="&PBOOL(isRightLEAPopr)&CRLF&"  isLEAPlistFlag="&PBOOL(isLEAPlistFlag)&" argType='"&CVTYPES(argType)&"'") */
		}/* test for (...) LEAP list */

	if (!isleaplistflag &&
		(h==hlisto||
	         (h==hleftsquiggle&&*sailargdelim!='{' &&
		  *saistatement=='{'
		 )
		)) isleaplistflag= 1L;

	if (isleaplistflag)
		{/* map to defLIST */
		s= "defLIST";
		if (*ps__leap_!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(ps__leap_));
		s= catlist(2L,GC_PUSHS(s),GC_PUSHS("("));
		if (h==hleftsquiggle) 
			{/* is {{...}} */
			ch= LOP(saistatement); /*  -- trash 2nd { */
			data= GC_EPOPS(copy_omit(GC_PUSHS("}")));
			ch= LOP(saistatement); /*  -- trash 2nd } */
			}/* is {{...}} */
			else data= GC_EPOPS(copy_omit(GC_PUSHS("),listc")));
		s= catlist(3L,GC_PUSHS(s),remove_white_ends(GC_PUSHS(data)),GC_PUSHS(
        ",0)"));
				/*  # # @V.46.118 NULL==>0 */
		oldtoken= "listo";
		pdw_ptype(lasttype,codelist); 	/*  -- now redefine it */
		}/* map to defLIST */

	else 	{/* '(' expr */
		s= GC_EPOPS(copy_either(GC_PUSHS(")"),&s1));
		push(GC_PUSHS(oldtoken));
		push(GC_PUSHS(lastmappedtoken)); lastmappedtoken= "(";
		s= GC_EPOPS(r_d_expr_map(GC_PUSHS(s)));
		pop(&lastmappedtoken);
		pop(&oldtoken);
		if (!(chk_number(GC_PUSHS(s)) ||chk_id(GC_PUSHS(s))) ||
		   ((*aChkI(decldw,1L,(*aChkI(dwptr,1L,hash_c(GC_PUSHS(s))))))&0303760)) s= catlist(3L,GC_PUSHS("("),GC_PUSHS(s),GC_PUSHS(")"));  /*  -- Optimize 
					'(<nbr>)'==>'<nbr>' .
					Not alphas since could
					be expandable macro. */
/*  # # DBUG('40000,"[FSM65].2 oldToken='"&oldToken&"'"&CRLF&" lastType='"&CVTYPES(lastType)&CRLF&"' s='"&s&"'") */
		}/* '(' expr */
	midofexpr= 1L;
;
	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'k'=<L0> integer                              */
/* 'j'=<L0> integer                              */
/* 'type'=<L0> string                            */
/*************************************************/
}/* FSM65 */
