/* FILE: fsm66.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsme.c, being converted 12/25/87, 08:02:03PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  -------------------------------------------------------- */
/*INTERNAL*/  STRING fsm66(h)
	INTEGER h;
{/* FSM66 */
STRING s, 
	s1, 
	s2, 
	a, 
	o, 
	v, 
	lexpr, 
	opr2;
INTEGER brk, 
	i, 
	type, 
	cs, 
	hs, 
	is1any, 
	is2any, 
	ltype, 
	istripleflag;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,66L))= (*aChkI(cntfsms,1L,66L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM66] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[66] XOR/ASSOC/EQV*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM66>]
.INDEX ++PSAIL PROCEDURE: FSM66
.ENDLABEL [<++PSAIL PROCEDURE: FSM66>]
	IF the oldToken is a LEAP element,
	Then if associative triple 
		MAP: a XOR o EQV v ==> fndT(a,o,v)

	else	MAP: a XOR o	 ==> fnd3T(a,o)
	else	MAP: a ASSOC v	 ==> fnd2T(a,v)
	else	MAP: o EQV v	 ==> fnd1T(o,v)

	else	MAP: a XOR ANY	 ==> fnd23T(a)
	else	MAP: a ASSOC ANY ==> fnd23T(a)
	else	MAP: o EQV ANY	 ==> fnd13T(o)

	else	MAP: ANY XOR o	 ==> fnd13T(o)
	else	MAP: ANY ASSOC v ==> fnd12T(a)
	else	MAP: ANY EQV v	 ==> fnd13T(v)

		NOTE: & is use ONLY IF the argument is a
		      <leap-local> variable.
		NOTE: X and Y are from the set {1,2,3,NULL}.
	Else if <lValue> Neq LEAP type we
	    assume arithmetic XOR or EQV
			MAP: a XOR b ==> a ^ b,
			MAP: a EQV b ==> EQV(a,b).
.ENDLABEL [<++PSAIL PROCEDURE: FSM66>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(s2); /* for G.C. */
	GC_NOTESTRING(a); /* for G.C. */
	GC_NOTESTRING(o); /* for G.C. */
	GC_NOTESTRING(v); /* for G.C. */
	GC_NOTESTRING(lexpr); /* for G.C. */
	GC_NOTESTRING(opr2); /* for G.C. */
	ltype= lasttype;
/*  # # DBUG('40000,"[FSM66].1 oldToken='"&oldToken&"'"&CRLF&"  lType='"&CVTYPES(lType)&"'") */
	oldtoken= saitoken;
	a= o= v= opr2= PNULL;
	istripleflag= 0L;
	if (isleapcode(ltype))
		{/* Is LEAP entity */
		lexpr= GC_EPOPS(left_expr(&cstatement,1L)); /*  -- skip left comment */
		if (*lexpr=='(') cstatement= catlist(2L,GC_PUSHS(cstatement),GC_PUSHS(LOP(lexpr)));
						 /*  -- Put it back */
		a= lexpr;	/*  -- save ATTRIBUTE field */
/*  # # DBUG('40000,"[FSM66].2 a='"&a&"'"&CRLF&" saiStatement='"&saiStatement&"'"&CRLF&" cStatement='"&cStatement&"'") */
		while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
		o= GC_EPOPS(getid(&saistatement,&brk));  /*  -- second element */
		while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
		if (brk=='('||
		   (iswhitespace(brk) &&*saistatement=='('))
			{/* OBJECT expression */
			o= catlist(4L,GC_PUSHS(o),makstr(brk),copy_omit(GC_PUSHS(")")),
        GC_PUSHS(")"));
			while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
			}/* OBJECT expression */
		else if (brk==';') 
			{/* push back */
			saistatement= ((*saistatement=='\0') ? ";"
				      : catlist(2L,GC_PUSHS(saistatement),GC_PUSHS(";")));
			brk= (INTEGER)'\0';
			}/* push back */
/*  # # DBUG('40000,"[FSM66].2.1 brk='"&(ps!sTrash!_brk)&"' o='"&o&"'"&CRLF&"  saiStatement='"&saiStatement&"'")
		 */if (h==hxor)
			{/* check if triple */
			s2= saistatement;   /*  -- save it */
			opr2= GC_EPOPS(getid(&saistatement,&brk));
			if (fast_equ(GC_PUSHS(opr2),GC_PUSHS("eqv")))
				{/* YEP - is triple */
				while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
				istripleflag= 1L;
				v= GC_EPOPS(rightexpr(&saistatement));
				}/* YEP - is triple */
			else 	{/* NOPE - not triple */
				saistatement= s2;  /*  -- backup */
				}/* NOPE - not triple */
			}/* check if triple */
		else if (brk==';') 
			{/* push back */
			if (*saistatement=='\0') saistatement= ";"; 
			else saistatement= catlist(2L,GC_PUSHS(saistatement),GC_PUSHS(";"));
			brk= (INTEGER)'\0';
			}/* push back */
/*  # # DBUG('40000,"[FSM66].2.2 isTripleFlag="&PBOOL(isTripleFlag)&" saiSym[h]='"&saiSym[h]&"' opr2='"&opr2&"' brk='"&(ps!sTrash!_brk)&"'"&CRLF&" a='"&a&"'"&" o='"&o&"' v='"&v&"'"&CRLF&"  saiStatement='"&saiStatement&"'")
 *//*  # # DBUG('40000,"[FSM66].3 locLeapPtr="&CVS(locLeapPtr)&CRLF&" isFOREACHflag="&PBOOL(isFOREACHflag)&CRLF&" saiStatement='"&saiStatement&"'") */
		/*  -- NOTE: the LEAP 'local' itemvars are set 
		  up by the FOREACH FSM! */
		pushnumber(h); pushnumber(istripleflag);
		push(GC_PUSHS(a)); push(GC_PUSHS(v));
		o= GC_EPOPS(r_d_expr_map(GC_PUSHS(o)));
		pop(&v);
		push(GC_PUSHS(o));
		v= GC_EPOPS(r_d_expr_map(GC_PUSHS(v)));
		pop(&o); pop(&a); popnumber(&istripleflag);
		popnumber(&h);
/*  # # DBUG('40000,"[FSM66].4 a='"&a&"'"&" o='"&o&"' v='"&v&"'") */

		s= "fndT";
		if (istripleflag) 
			{/* TRIPLE */
			s= catlist(7L,GC_PUSHS("fndT("),GC_PUSHS(a),GC_PUSHS(","),GC_PUSHS(o),
        GC_PUSHS(","),GC_PUSHS(v),GC_PUSHS(")"));
			if (isforeachflag) s= GC_EPOPS(chk_leap_optimize(GC_PUSHS(s),GC_PUSHS(a),GC_PUSHS(o),GC_PUSHS(v)));
			lasttype= 020000L;
			pdw_ptype(lasttype,codeitemvar);
			}/* TRIPLE */
		else	{/* derived set? */
			is1any= fast_equ(GC_PUSHS(a),GC_PUSHS("any"));
			is2any= fast_equ(GC_PUSHS(o),GC_PUSHS("any"));
			if ((!is1any) &&(!is2any))
				{/* 2-tuple derived set */
				if (h==hxor) s= catlist(5L,GC_PUSHS("fnd3T("),GC_PUSHS(a),GC_PUSHS(","),GC_PUSHS(o),
        GC_PUSHS(")")); else if (h==hassoc) s= catlist(5L,GC_PUSHS("fnd2T("),GC_PUSHS(a),GC_PUSHS(","),GC_PUSHS(o),
        GC_PUSHS(")")); else s= catlist(5L,GC_PUSHS("fnd1T("),GC_PUSHS(a),GC_PUSHS(","),GC_PUSHS(o),
        GC_PUSHS(")"));
				}/* 2-tuple derived set */
			else if ((!is1any) &&is2any)
				{/* x OPR ANY derived set */
				if (h==hxor||h==hassoc) s= catlist(3L,GC_PUSHS("fnd23T("),GC_PUSHS(a),GC_PUSHS(")")); else s= catlist(3L,GC_PUSHS("fnd13T("),GC_PUSHS(a),GC_PUSHS(")"))}/* x OPR ANY derived set */
			else if (is1any &&(!is2any))
				{/* ANY OPR x derived set */
				if (h==hxor) s= catlist(3L,GC_PUSHS("fnd13T("),GC_PUSHS(o),GC_PUSHS(")")); else s= catlist(3L,GC_PUSHS("fnd12T("),GC_PUSHS(o),GC_PUSHS(")"))}/* ANY OPR x derived set */
			else s= "fnd123T()";
			lasttype= 020000L;
			pdw_ptype(lasttype,codeset); 
					/*  -- ie. derived */
			}/* derived set? */
/*  # # DBUG('40000,"[FSM66].5 s='"&s&"'"&CRLF&" lastType='"&CVTYPES(lastType)&"'") */
		}/* Is LEAP entity */

	else	{/* is simple XOR or EQV */
		s= GC_EPOPS(fsm20(h)); 		/*  -- arithmetic operator */
		pdw_ptype(lasttype,codeinteger);
GC_EPOPS(dbug(040000L,catlist(3L,GC_PUSHS("[FSM66].6 s=\'"),GC_PUSHS(s),GC_PUSHS("\'"))));
		}/* is simple XOR or EQV */
	midofexpr= 1L;
;
	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'hs'=<L0> integer                             */
/* 'cs'=<L0> integer                             */
/* 'type'=<L0> integer                           */
/* 'i'=<L0> integer                              */
/* 's1'=<L0> string                              */
/*************************************************/

}/* FSM66 */
