/* FILE: fsm67.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsme.c, being converted 12/25/87, 08:02:03PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  -------------------------------------------------------- */
/*INTERNAL*/  STRING fsm67(h)
	INTEGER h;
{/* FSM67 */
STRING s, 
	token;
INTEGER i, 
	brk, 
	cs, 
	hs;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,67L))= (*aChkI(cntfsms,1L,67L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM67] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[67] <SAFE-list>*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM67>]
.INDEX ++PSAIL PROCEDURE: FSM67
	Map SAIL:	SAFE <array spec>
	to C:		SAFE 
	      and set DW!safe in lastDeclaration for 
	      this statement.
	MAP SAIL	NOW!SAFE <array name list>
		and	NOW!UNSAFE <array name list>
	to modifying the symbols in the PSAIL local user
	symbol table.
	MAP SAIL	GENERIC (<proc-name>)
	To C		 GENERIC(<proc-name>) 
	and set 'genericName' to <proc-name>.
	Map SAIL: OWN <sail-declar>
	to C:	  static <C-declar>
.ENDLABEL [<++PSAIL PROCEDURE: FSM67>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(token); /* for G.C. */
	s= PNULL;
		oldtoken= saitoken;
	if (ismacroflag) isfragmentflag= 

	1L; else if (fast_equ(GC_PUSHS(saitoken),GC_PUSHS("own")))
		{/* just map OWN to static */
		if ((lastdeclaration&010000L)==0)
			{/* fix it */
			dcstaticdeclaration= "static ";
			lastdeclaration=lastdeclaration|0400L;
			}/* fix it */
		s= PNULL;   	/*  -- NOTE: we will add 'static' in [FSM11] */
		}/* just map OWN to static */

	else if (fast_equ(GC_PUSHS(saitoken),GC_PUSHS("safe"))) 
		{/* Just SAFE */
		s= GC_EPOPS(simple_map(h));
		lastdeclaration=lastdeclaration|0400000L;
		}/* Just SAFE */

	else if (fast_equ(GC_PUSHS(saitoken),GC_PUSHS("now_safe")) ||
		fast_equ(GC_PUSHS(saitoken),GC_PUSHS("now_unsafe")))
		{/* Change SAFE/UNSAFE array status */
		s= catlist(3L,GC_PUSHS("/* "),simple_map(h),GC_PUSHS(" "));
		while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
		while ((*saistatement!='\0') &&
		   (*((token= GC_EPOPS(getid(&saistatement,&brk))))!='\0'))	{/* modify user symtab */
			s= catlist(2L,GC_PUSHS(s),GC_PUSHS(token));	/*  -- add it on */
			i= find_symbol(GC_PUSHS(token),&cs,&hs);
			if ((i!=0) &&
			   equ(GC_PUSHS(saitoken),GC_PUSHS("now_safe"))) 
				{/* safe it */
				(*aChkI(decldw,1L,i))= (*aChkI(decldw,1L,i))|0400000L;
				}/* safe it */
			else if ((i!=0) &&
				equ(GC_PUSHS(saitoken),GC_PUSHS("now_unsafe"))) 
				{/* unsafe it */
				(*aChkI(decldw,1L,i))= (*aChkI(decldw,1L,i))&0777777377777L;
				}/* unsafe it */
			if (brk==',') s= catlist(2L,GC_PUSHS(s),makstr(brk)); else break;
			GC_EPOPS(map_ws_comments(&s,0L));
			}/* modify user symtab */
		s= catlist(2L,GC_PUSHS(s),GC_PUSHS(" */"));
		}/* Change SAFE/UNSAFE array status */

	else if (fast_equ(GC_PUSHS(saitoken),GC_PUSHS("generic")))
		{/* GENERIC (<proc-name>) */
		s= GC_EPOPS(scan(&saistatement,12L,&i));   /*  -- get the '(' */
		genericname= GC_EPOPS(getid(&saistatement,&brk));
				/*  -- get the '<name>)'   */
/*  # # DBUG('40000,"[FSM67].1 i='"&(s_i)&"' genericName='"&genericName&"' brk='"&(s_brk)&"'") */
		if (i!='('||brk!=')' ||!isalpha(GC_PUSHS(genericname))) err_hlr(GC_PUSHS(
			
			        					catlist(GC_PUSHS(
			        "[FSM67] Illegal generic name specifier \'"),
			        cvupcase(GC_PUSHS(genericname)),GC_PUSHS("\'"))));
		s= catlist(3L,GC_PUSHS("/* GENERIC ("),GC_PUSHS(genericname),
        GC_PUSHS(") */"));
		lastdeclaration=lastdeclaration|017204544;
		}/* GENERIC (<proc-name>) */
;
	GC_SRETURN(s)
}/* FSM67 */
