/* FILE: fsm68.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsme.c, being converted 12/25/87, 08:02:03PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  -------------------------------------------------------- */
/*INTERNAL*/  STRING fsm68(h)
	INTEGER h;
{/* FSM68 */
STRING s, 
	s1, 
	s2, 
	s3, 
	bname, 
	endlabel, 
	iscontinueflag;
INTEGER ch, 
	i, 
	j, 
	k, 
	p, 
	q, 
	toblklevel, 
	blidx;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,68L))= (*aChkI(cntfsms,1L,68L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM68] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[68] <CONT./DONE>*/
/*   --
.LABEL [<++PSAIL PROCEDURE: FSM68>]
.INDEX ++PSAIL PROCEDURE: FSM68
	Map  C		from 		SAIL		toBlockLevel
	    ---				----    	------------
	continue			Continue	    same
  or	continue /*bLabel*/		Continue "bLabel"   same
  or	goto <lblPREFIX&#> /*bLabel*/  	Continue "bLabel"   BEFORE }

	break				Done		    same -1
  or	break /*bLabel*/		Done "bLabel"	    same -1
  or	goto <lblPREFIX&#> /*bLabel*/  	Done "bLabel"       AFTER } -1

	In general, to CONTINUE an outer block at level toBlkLevel use 
	goto <label just BEFORE toBlkLevel>).
	In general, to DONE an outer block at level toBlkLevel use 
	goto <label just AFTER toBlkLevel>.

	Also called here using R!D from [FSM69] NEXT which maps NEXT
	to CONTINUE and then does the rest of the eval here.

	The lblPREFIX[1 to 2] prefix is used and the '#' is length 4
	with leading zeros. The GOTO is generated when we have to leave
	the current block. The '#' is generated with CVS(genCnt++) and
	SETFORMAT(-4,0). The block label is not the current
	CURRENT level but that of the target block label.

	In addition, if we are exiting a procedure where
	GC, dynamic storage or profiling was done, we need to
	also deallocate the BLOCK EXIT as well.
.ENDLABEL [<++PSAIL PROCEDURE: FSM68>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(s2); /* for G.C. */
	GC_NOTESTRING(s3); /* for G.C. */
	GC_NOTESTRING(bname); /* for G.C. */
	GC_NOTESTRING(endlabel); /* for G.C. */
	GC_NOTESTRING(iscontinueflag); /* for G.C. */
	oldtoken= saitoken;
	s= GC_EPOPS(simple_map(h));	/*  -- map to continue or break */
	if (fast_equ(GC_PUSHS(saitoken),GC_PUSHS("next")))
	{/* add wsPREFACE to continue */
	set_preface(&s1);
	s= catlist(2L,GC_PUSHS(s1),GC_PUSHS(s));  		/*  -- since from R!D */
	}/* add wsPREFACE to continue */
	map_whitespace(&s);
	s1= endlabel= bname= PNULL;
	iscontinueflag= GC_EPOPS(makstr((!fast_equ(GC_PUSHS(saitoken),GC_PUSHS("done")))));
	toblklevel= blocklevel +(((INTEGER)*(iscontinueflag
				     )) ?  0L:-1L); /*  -- default */
/*  # # DBUG('40000,"[FSM68].0.1 isCONTINUEflag="&PBOOL(isCONTINUEflag)&" toBlkLevel="&CVS(toBLkLevel)) */
	if ((*saistatement==*quote))
	{/* Check block name for non-current */
	midofexpr= 1L;
	ch= LOP(saistatement);  /*  -- Trash 1st quote */
	pushnumber(iscopy_toflag); iscopy_toflag= 1L;
	push(GC_PUSHS(saitoken));
	bname= GC_EPOPS(map_quotes(&saistatement));
	pop(&saitoken);
	popnumber(&iscopy_toflag);
	bname= subst(GC_PUSHS(bname),2L,length(bname)-1L);  /*  -- trash quotes */
	i= 0;	/*  -- default none */
/*  -- NOTE: it is illegal to CONTINUE or DONE block level 1 or 0 at
main() level and at level 2 within a procedure!!!
 */
	k= ((notmainflag) ?   3L:2L);
	if (*bname=='\0') i= blocklevel; 
	else for (j=blocklevel;j<=2;j--)
		if (equ(GC_PUSHS(bname),GC_PUSHS((*aChkC(blkname,1L,j)))))
			{/* found it */
			i= j;
			break;
			}/* found it */
	if (i!=0) toblklevel= i; 
	else	{/* error */
		err_hlr(GC_PUSHS(
        			catlist(GC_PUSHS("[FSM68] Can\'t find block level name ")
        ,GC_PUSHS(quote),GC_PUSHS(bname),GC_PUSHS(quote),
        GC_PUSHS(" for "),cvupcase(GC_PUSHS(saitoken)),GC_PUSHS(".")
        ,GC_PUSHS(crlf),
        GC_PUSHS(" Check if you spelled it correctly."))));
		toblklevel= blocklevel;
		}/* error */

/*  # # DBUG('40000,"[FSM68].1 i="&CVS(i)&" k="&CVS(k)&" bName='"&bName&"'"&CRLF&" blockLevel="&CVS(blockLevel)&" toBlkLevel="&CVS(toBLkLevel)) */

	if ((INTEGER)*(!iscontinueflag))
		{/* DONE is down 1 block level */
		--toblklevel;
/*  # # DBUG('40000,"[FSM68].2 map DONE toBlkLevel="&CVS(toBlkLevel)) */
		}/* DONE is down 1 block level */

	if (((toblklevel<blocklevel) &&
	     *iscontinueflag) ||
	   ((toblklevel<blocklevel-1L) &&
	     *(!iscontinueflag))) 
		{/* Need to use GOTO!!!!!! */
		/*  -- Generate label to GOTO... */

/*  # # DBUG('40000,"[FSM68].3 toBlkLevel="&CVS(toBLkLevel)&" blkAgensym[toBlkLevel]='"&blkAgensym[toBlkLevel]&"' blkBgensym[toBlkLevel]='"&blkBgensym[toBlkLevel]&"'") */
/*  -- NOTE:@V.56.125: Need to have different label for CONTINUE since
it must do a GOTO just BEFORE the 'END' not after as the current GOTO
does.
 */
		if ((INTEGER)*iscontinueflag)
			{/* down 1 level */
			blidx= toblklevel;
			endlabel= (*aChkC(blkbgensym,1L,blidx));
/*  # # DBUG('40000,"[FSM68].3.1 CONTINUEblIdx="&CVS(blIdx)&" endLabel='"&endLabel&"'") */
			}/* down 1 level */
		else	{/* DONE label */
			blidx= toblklevel+1L;
			endlabel= (*aChkC(blkagensym,1L,blidx));
/*  # # DBUG('40000,"[FSM68].3.2 DONE blIdx="&CVS(blIdx)&" endLabel='"&endLabel&"'") */
			}/* DONE label */
		getformat(&p,&q);
		setformat(-4L,0L);
		if (*endlabel=='\0') endlabel= 
        				 catlist(GC_PUSHS(lblprefix),cvs((++gencnt)));
		setformat(p,q);
		s= catlist(2L,GC_PUSHS("goto "),GC_PUSHS(endlabel));

/*  -- Save it in block arrays in any case. This will be used by FSM25
for END which emits the label for the above GOTO!
 */
		if ((INTEGER)*iscontinueflag) (*aChkC(blkbgensym,1L,blidx))= endlabel; 
		else (*aChkC(blkagensym,1L,blidx))= endlabel;
/*  # # DBUG('40000,"[FSM68].3.3 blIdx="&CVS(blIdx)&" toBlkLevel="&CVS(toBLkLevel)&" blkAgensym[blIdx]='"&blkAgensym[blIdx]&"' blkBgensym[blIdx]='"&blkBgensym[blIdx]&"'") */

		}/* Need to use GOTO!!!!!! */
	}/* Check block name for non-current */

/*  # # DBUG('40000,"[FSM68].4 s='"&s&"'"&CRLF&" blockLevel="&CVS(blockLevel)&" toBlkLevel="&CVS(toBlkLevel)&" bName='"&bName&"'"&CRLF&" endLabel='"&endLabel&"' didBlkExit="&PBOOL(didBlkExit)&" genCnt="&CVS(genCnt)) */
/*  # # @V.56.123		s3_saiStatement */	/*  -- save it while lookahead */
	s1= PNULL;		/*  -- get comments if any */
	map_whitespace(&s1);	/*  -- to get at next token */
	while ((*s1!='\0') &&iswhitespace((INTEGER)*s1)) ps_itrash_= LOP(s1);	/*  -- only leave comments */
	if (*saistatement=='e'&&equ(subsr(GC_PUSHS(saistatement),1L,3L),GC_PUSHS("end"))) s= catlist(2L,GC_PUSHS(s),GC_PUSHS(";"));    	/*  -- Lookahead for <SC> */
/*  # # @V.56.123		saiStatement_s3 */	/*  -- restore it */
	if (*s1!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s1));   /*  -- only add comments */
	if (*bname!='\0') s= catlist(4L,GC_PUSHS(s),GC_PUSHS(" /* "),GC_PUSHS(bname),GC_PUSHS(" */"));
/*  # # DBUG('40000,"[FSM68].5 s='"&s&"'"&CRLF&" s1='"&s1&"'") */
	s= GC_EPOPS(mak_blk_exit(blocklevel,toblklevel,GC_PUSHS(s)));
	didblkexit= 0L;	/*  -- reset it */
GC_EPOPS(dbug(040000L,catlist(3L,GC_PUSHS("[FSM68].6 s=\'"),GC_PUSHS(s),GC_PUSHS("\'"))));
	oldtypestatement= "%%loop_ctrl";
;
	GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 's3'=<L0> string                              */
/* 's2'=<L0> string                              */
/*************************************************/

}/* FSM68 */
