/* FILE: fsm7.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsma.c, being converted 12/25/87, 05:15:20PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  -------------------------------------------------------- */
/*INTERNAL*/  STRING fsm7(h)
	INTEGER h;
{/* FSM7 */
INTEGER ch, 
	i, 
	j, 
	k, 
	val, 
	n, 
	atype, 
	thistype, 
	idx, 
	dw, 
	lthcat,
	dooptflag, 
	dotypechk;
STRING s, 
	sprime, 
	s1, 
	s2, 
	s3, 
	lexpr, 
	expr, 
	fct, 
	ws, 
	wsnext;


{/* INCFSM */
if (usecntfsmflag)
  (*aChkI(cntfsms,1L,7L))++;
}/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM7] \'rule\' NODE["),
			      GC_PUSHS(*aChkC(saisym,1L,h)),
			      GC_PUSHS("]="),prt_node(h))));
/*[7] &*/
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM7>]
.INDEX ++PSAIL PROCEDURE: FSM7
 		Process String concatinate '&' by Translating to
	C-language 'concat(a,b)' function if /CONCAT is 
	specified else catlist(2L,a,b,) is used.
	Concatenation requires backing up the cStatement string.
	In addition, look for converting integers in the
	range of 001 to 177 to \nnn inserted in the string
	rather than using the makstr() function call.

	Merge string constants into one string constant:
		"ABC" & "DEF"
	to	"ABCDEF".

	NOTE: @V.46.62 Optimize LOP(...) when used with concatenate eg.
		s1&LOP(s2)
	 would normally generate:
		catlist(2L,s1,makstr(LOP(s2)))
	But since, catlist() can handle single char's, we
	should optimize it to:
		catlist(2L,s1,LOP(s2))
	NOTE: If we evaled this in a MACRO declaration then force
	isFRAGMENTflag if untyped formal args.
	The general form of catlist() is:
	catlist(nL,s1,s2,...,sn).
.ENDLABEL [<++PSAIL PROCEDURE: FSM7>]
 */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(sprime); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(s3); /* for G.C. */
GC_NOTESTRING(lexpr); /* for G.C. */
GC_NOTESTRING(expr); /* for G.C. */
GC_NOTESTRING(fct); /* for G.C. */
GC_NOTESTRING(ws); /* for G.C. */
GC_NOTESTRING(wsnext); /* for G.C. */
pushnumber(midofexpr); midofexpr= 1L;
/*  # # DBUG('40000,"[FSM7].0.1 cStatement='"&cStatement&"'"&CRLF&
    "  saiStatement='"&saiStatement&"'"&CRLF&
    "  lastType='"&CVTYPES(lastType)&"'") */
oldtoken= "&";
dooptflag= 1L;

/*  # # NOTE: @V.53.85 recode [FSM7] 'concat(...) chain by using the
same code as for catlist() but (a) emit a string of ')))))' at the
end required instead of the a count of strings in the beginning of
catlist() and (b) instead of emitting ',' between '&' maps, emit
',concat('.
*/

if (!useconcatflag)
  {/* build CATLIST */
    lthcat= 8;	/*  -- i.e. LENGTH("catlist(") */
    s= PNULL;
    lexpr= GC_EPOPS(left_expr(&cstatement,1L));
				/*  -- skip past left comments */
    idx= (*aChkI(dwptr,1L,hash_c(GC_PUSHS(lexpr))));
    dw= (idx!=0) ? (*aChkI(decldw,1L,idx)) : lasttype;
    if ((dw&02000L) &&
	(dw&01000L)==0 &&
	((((ps_itrash_= (dw&037))>0) ? (ps_itrash_+0140L)
				    : 0L)==codeinteger))
      {/* if string or const then use it */
	s1= (*aChkC(declsize,1L,idx)); /*  -- i.e. macro def */
/*  # # DBUG('40000,"[FSM7].0.2 lExpr='"&lExpr&"' s1='"&s1&"'"&CRLF&
    " dw='"&CVTYPES(dw)&"'") */
	i= ((*s1==('\'')) ? cvo(subst(GC_PUSHS(s1),2L,length(s1)))
			  : cvd(GC_PUSHS(s1)));
	if (1<=i && i<=0177) 
	  {/* CVT it */
	    pdw_ptype(dw,codestring);
	            /*  -- fake it since catlist() will handle it */
	    lexpr= catlist(4L,GC_PUSHS(quote),GC_PUSHS("\\"),cvos(i),
			   GC_PUSHS(quote));
	    dw=dw&0777777775777L;
	  }/* CVT it */
/*  # # DBUG('40000,"[FSM7].0.3 NEW lExpr='"&lExpr&"' s1='"&s1&"'"&CRLF&
    " dw='"&CVTYPES(dw)&"'") */
      }/* if string or const then use it */
    if (useleapflag &&
	(idx!=0) &&
	((((ps_itrash_= (dw&037))>0) ? (ps_itrash_+0140L)
				    : 0L)==codelist))
      fct= "catLLIST("; 
    else {/* is string concat */
           fct= "catlist(";      /*  -- NOTE upper/lower
				     case distinctions for C */
	   sawstrfct= 1L;
         }/* is string concat */

    GC_EPOPS(map_ws_comments(&s,0L));
    if (*lexpr=='('&&(*(lexpr+length(lexpr)-1))==')') 
      lexpr= subst(GC_PUSHS(lexpr),2L,length(lexpr)-1L);

/*  ---------------------------------------------- */
/*  . . . SEE IF CAN FORCE 'STRING CONSTANT' . . . */
/*  ---------------------------------------------- */
    if (*lexpr==*singlequote)
      lexpr= catlist(3L,GC_PUSHS(quote),
		     subst(GC_PUSHS(lexpr),2L,length(lexpr)-1L),
		     GC_PUSHS(quote));
    else if ((*lexpr=='l'&&
	      equ(subst(GC_PUSHS(lexpr),1L,4L),GC_PUSHS("lop("))) ||
	     (*lexpr=='L'&&
	      equ(subst(GC_PUSHS(lexpr),1L,4L),GC_PUSHS("LOP("))))
            {/* optimize 'LOP(s)' to '*s' */
	      pdw_ptype(lasttype,codestring);
					 /*  -- fake type! */
	    }/* optimize 'LOP(s)' to '*s' */

    else if ((chk_integer(GC_PUSHS(lexpr)) ||
	      ((dw&02000L) &&
	       chk_iconst(GC_PUSHS((*aChkC(declsize,1L,idx))),&j) &&
	       *((lexpr= GC_EPOPS(cvs(j)))))) &&
	     ((*lexpr=='0'&&
	       (00<=(val= cvo(GC_PUSHS(lexpr))) && val<=0177)) ||
	      (00<=(val= cvd(GC_PUSHS(lexpr))) && val<=0177)))
            {/* map it */
	     /*  -- if was macro constant then eval it */
	      if (val==0) 
		err_n_p(&lexpr); 
	      else lexpr= catlist(4L,GC_PUSHS(quote),GC_PUSHS("\\"),
				  cvos(val),GC_PUSHS(quote));
	      pdw_ptype(lasttype,codestring);
	    }/* map it */
    else {/* make a string */
	   pdw_ptype(lasttype,codestring);
	   lexpr= GC_EPOPS(cvactual_to_expected(lasttype,dw,
						GC_PUSHS(lexpr)));
         }/* make a string */
/*  # # DBUG('40000,"[FSM7].0.4 OPTMIZ.lExpr='"&lExpr&"'"&CRLF&
    " lastType='"&CVTYPES(lastType)&"'") */

/*  ---------------------------------------------------------- */
/*  . . . PROCESS A LIST OF '&' TO CREATE catlist(...,0) . . . */
/*  ---------------------------------------------------------- */
    while ((*s==' '))
      ch= LOP(s); /*  -- ignore spaces */
    saistatement= catlist(2L,GC_PUSHS("&"),GC_PUSHS(saistatement));
    if (*s=='\0')
      s= fct; 
    else s= catlist(2L,GC_PUSHS(s),GC_PUSHS(fct));
    push(GC_PUSHS(s));
/*  # # DBUG('40000,"[FSM7].1 lExpr='"&lExpr&"'"&CRLF&
    "  s='"&s&"'"&CRLF&"  saiStatement='"&saiStatement&"'") */

    n= 1;		/*  -- number of '&'s  */

    sprime = s = lexpr;
    if (usegcflag)
      add_gc_pushs(&s);
    while ((*saistatement=='&'))
      {/* build catlist */
	ch= LOP(saistatement); /*  -- Trash '&'  */
	while ((*saistatement==' ') ||
	       (*saistatement==*tab))
	  ch= LOP(saistatement); 
	                    /*  -- trash leading spaces */
	ws= ",";	    /*  -- pre - @V.54.41 */
	GC_EPOPS(map_ws_comments(&ws,0L));
	ws= ",";            /*  -- @V.54.41 ignore ws */
	pushnumber(isfragmentflag);
	expr= GC_EPOPS(copy_either(GC_PUSHS(",&,end,;,else"),&s2));
	popnumber(&j);
	if (ismacroflag &&isfragmentflag &&
	    *s2=='\0' &&(*expr!='\0'))
	  isfragmentflag= j;          /*  -- Reset */
	{/* TRASH!RIGHT!WS */
	    while ((*expr!='\0') &&
		   (ps_itrash_= (*(expr+length(expr)-1))) &&
		   iswhitespace(ps_itrash_)) 
	      expr= subst(GC_PUSHS(expr),1L,length(expr)-1L);
	}/* TRASH!RIGHT!WS */  /*  -- this is OK since
	    we will justify text */
/*  # # DBUG('40000,"[FSM7].1.0.0.1 n="&CVS(n)&CRLF&
    " expr='"&expr&"'"&CRLF&" s1='"&s1&"'") */
	if ((*(expr+length(expr)-1))==' ')
	  expr= subst(GC_PUSHS(expr),1L,length(expr)-1L);
						/*  -- TRASH */
	if (*s2!='\0')
	  if (*saistatement=='\0')
	    saistatement= s2; 
	  else saistatement= catlist(2L,GC_PUSHS(s2),
				     GC_PUSHS(saistatement));
/*  # # @V.46.192			If expr=singleQuote
 # # # @V.46.192				Then expr_quote & 
 # # # @V.46.192				   expr[2 to inf-1] &
 # # # @V.46.192				   quote */ /*  -- keep 'c'
 # # # @V.46.192				      as "c" string */
				/*  --- eval <rValue> --- */
	if (*expr==*quote)
	  {/* just simple quoted str */
	    atype= lasttype;
	    pdw_ptype(atype,codestring);
				/*  -- BUT map SAIL quoted string
				    to C string taking special
				    C characters into account. */
	    pushnumber(iscopy_toflag);
	    iscopy_toflag= 0L; /*  -- lets fct MAP!QUOTE map
				   special chars */
	    s1= expr;
	    ch= LOP(s1);	/*  -- eat 1st " */
	    expr= GC_EPOPS(map_quotes(&s1));
	    popnumber(&iscopy_toflag);
/*  # # DBUG('40000,"[FSM7].1.0.0.2 after-MAP!QUOTE expr='"&expr&"'") */
	  }/* just simple quoted str */

	else  {/* eval expr to string */
	        pushnumber(n); push(GC_PUSHS(s));
		push(GC_PUSHS(ws)); pushnumber(lasttype);
		pdw_ptype(lasttype,codestring);
					/*  -- want string */
		expr= GC_EPOPS(r_d_expr_map(GC_PUSHS(expr)));
		atype= lasttype;
/*  # # DBUG('40000,"[FSM7].1.0.1 expr='"&expr&"'"&CRLF&
    "  aType='"&CVTYPES(aType)&"'") */
		if ((atype&02000L) &&
		    (atype&01000L)==0 &&
		    (((ps_itrash_= (atype&037))>0) ? (ps_itrash_+0140L)
				                   : 0L)==codeinteger)
		  {/* Use if string or const */
		    s1= (*aChkC(declsize,1L,
				(*aChkI(dwptr,1L,hash_c(GC_PUSHS(expr))))));
/*  # # DBUG('40000,"[FSM7].1.0.2 expr='"&expr&"' s1='"&s1&"'"&CRLF&
    " aType='"&CVTYPES(aType)&"'") */
		    i= ((*s1==('\''/*WARNING*/))
                                 ? cvo(subst(GC_PUSHS(s1),2L,length(s1)))
				 : cvd(GC_PUSHS(s1)));
		    if (1<=i && i<=0177)
		      pdw_ptype(atype,codestring);
		                     /*  -- fake it since catlist() will
					 handle it */
/*  # # DBUG('40000,"[FSM7].1.0.3 NEW aType='"&CVTYPES(aType)&"'") */
		  }/* Use if string or const */
		if (atype==0&&ismacroflag) 
		  isfragmentflag= 1L;
		popnumber(&lasttype); pop(&ws);
		pop(&s); popnumber(&n);
	      }/* eval expr to string */

/*  ---------------------------------------------- */
/*  . . . SEE IF CAN FORCE A STRING CONSTANT . . . */
/*  ---------------------------------------------- */
	if (*expr=='('&&(*(expr+length(expr)-1))==')')
	  expr= subst(GC_PUSHS(expr),2L,length(expr)-1L); 
	else if (*expr=='c'&&
		 equ(subst(GC_PUSHS(expr),1L,8L),GC_PUSHS("catlist(")))
	  expr= subst(GC_PUSHS(expr),10L,length(expr)-1L);
	if ((chk_integer(GC_PUSHS(expr)) ||
	     ((atype&02000L) &&
	      (idx= (*aChkI(dwptr,1L,hash_c(GC_PUSHS(expr))))) &&
	      chk_iconst(GC_PUSHS((*aChkC(declsize,1L,idx))),&j) &&
	      *((expr= GC_EPOPS(cvs(j)))))) &&
	    ((*expr=='0'&&
	      (00<=(val= cvo(GC_PUSHS(expr))) && val<=0177)) ||
	     (00<=(val= cvd(GC_PUSHS(expr))) && val<=0177)))
	  {/* map it */
	    if (val==0)
	      {/* error */
		if (ismacroflag)
		  isfragmentflag= 1L;
		else err_n_p(&expr);
	      }/* error */
	    else expr= catlist(4L,GC_PUSHS(quote),GC_PUSHS("\\"),
			       cvos(val),GC_PUSHS(quote));
	    pdw_ptype(atype,codestring);
	    if (val==0&&!slobflag &&
		!ismacroflag)
	      {/* error */
		  s= catlist(2L,GC_PUSHS(s),GC_PUSHS(crlf));
		  err_deathwish(&s,
  GC_PUSHS("WARNING! can\'t concatenate \'0\' (zero) with C type strings"),
				5L,(INTEGER)('N'));
	      }/* error */
	    else if (val==0&&ismacroflag)
	      isfragmentflag= 1L;
	  }/* map it */

	if ((*expr=='l'&&
	     equ(subst(GC_PUSHS(expr),1L,4L),GC_PUSHS("lop("))) ||
	    (*expr=='L'&&
	     equ(subst(GC_PUSHS(expr),1L,4L),GC_PUSHS("LOP("))))
	  {/* Opt.'LOP(s)' to '*s' */
	    pdw_ptype(atype,codestring); 
					/*  -- fake type! */
	}/* Opt.'LOP(s)' to '*s' */

/*  # # DBUG('40000,"[FSM7].1.1 expr='"&expr&"'"&CRLF&
    " ws='"&ws&"'"&CRLF&" s='"&s&"'"&CRLF&" sPrime='"&sPrime&"'"&CRLF&
    " doOptFlag="&PBOOL(doOptFlag)) */

/*  ------------------------------------- */
/*  . . . OPTIMIZE "A"&"B" ==> "AB" . . . */
/*  ------------------------------------- */
/*  @V.53.60 NOTE: since we are enclosing string constants in
GC_PUSHS() we have to do this tricky test for adjacent string
contstants using sPrime copy of s without the GC_PUSHS() if any 
*/
	if (dooptflag &&(n==1) &&
	    chk_sconst(GC_PUSHS(sprime),&s2,0L) &&
	    chk_sconst(GC_PUSHS(expr),&s3,0L))
	  {/* merge quoted strings */
	    s= catlist(4L,GC_PUSHS(quote),GC_PUSHS(s2),GC_PUSHS(s3),
		       GC_PUSHS(quote));
	    sprime= s;
	    if (usegcflag)
	      add_gc_pushs(&s);
/*  # # DBUG('40000,"[FSM7].1.1.1 Optimize s2='"&s2&"'"&CRLF&
    " s3='"&s3&"'"&CRLF&" s='"&s&"'") */
	  }/* merge quoted strings */

	else if ((n==1) &&
		 (*expr==*quote) &&
		 ((*(sprime+length(sprime)-1))==*quote))
	  {/* concat TAIL */
/*  @V.63.67 NOTE: seem that this is redundent with the above code
since CHK!SCONST will return a quoted string so this sould take care
of it. I will leave a trap here for future investigation.
*/
/*  # # DBUG('40000,"[FSM7].1.1.2 s='"&s&"'"&CRLF&
    " sPrime='"&sPrime&"'") */
	    s= catlist(subst(GC_PUSHS(sprime),1L,length(sprime)-1L),
		       subst(GC_PUSHS(expr),2L,length(expr)));
	    sprime= s;
	    if (usegcflag)
	       add_gc_pushs(&s);
	  }/* concat TAIL */
	else  {/* map it */
	        dooptflag= 0L;
		thistype= 0;
		pdw_ptype(thistype,codestring);
		expr= GC_EPOPS(cvactual_to_expected(thistype,atype,
						    GC_PUSHS(expr)));
		if (usegcflag)
		  add_gc_pushs(&expr);
		sprime = s = (catlist(3L,GC_PUSHS(s),GC_PUSHS(ws),
				      GC_PUSHS(expr)));
		++n; /*  -- times not optimized */
	      }/* map it */
	map_whitespace(&s);
/*  # # DBUG('40000,"[FSM7].1.2 n="&CVS(n)&" s='"&s&"'"&CRLF&
    " saiStatement='"&saiStatement&"'") */
    }/* build catlist */
    pop(&s1);	/*  -- i.e. FCT name */
    if (n>1) 
      {/* use <sairun> concat fct */
/*  # # DBUG('40000,"[FSM7].1.3 s='"&s&"'"&CRLF&" s1='"&s1&"'") */
	  s= catlist(2L,GC_PUSHS(s1),GC_PUSHS(s));
/*  # # DBUG('40000,"[FSM7].1.3.1 n="&CVS(n)&" s='"&s&"'") */
	  insert_before_white(&s,GC_PUSHS(")"));
/*  # # DBUG('40000,"[FSM7].1.3.1.1 s='"&s&"'") */
	  j= ((equ(subsr(GC_PUSHS(s),1L,8L),GC_PUSHS("catlist(")))
		 ? 8L 
	      : (equ(subsr(GC_PUSHS(s),1L,9L),GC_PUSHS("catLLIST(")))
	         ? 9L
              : 0L);
	  if (j>0)
	    {/* add INTEGER arg cnt */
	      k= 0;
	      pdw_ptype(k,codeinteger);
	      s2= GC_EPOPS(cvs(n));
	      s2= GC_EPOPS(cvactual_to_expected(k,k,GC_PUSHS(s2)));
	      s= catlist(4L,subst(GC_PUSHS(s),1L,j),GC_PUSHS(s2),
			 GC_PUSHS(","),
			 subst(GC_PUSHS(s),j+1L,length(s)));
	    }/* add INTEGER arg cnt */
/*  # # DBUG('40000,"[FSM7].1.3.2 s='"&s&"'"&CRLF&
    " saiStatement='"&saiStatement&"'") */
        }/* use <sairun> concat fct */
    else if (usegcflag &&n==1 &&*s=='G') 
      s= subst(GC_PUSHS(s),10L,length(s)-1L);
				    /*  -- remove 'GC_PUSHS()' */
/*  # # DBUG('40000,"[FSM7].1.3.3 n="&CVS(n)&" s='"&s&"'") */
  }/* build CATLIST */

else {/* use old fashioned string concat */
       lthcat= 7;	/*  -- i.e. LENGTH("concat(") */
       dotypechk= 1;	/*  -- coerce to string */
/*  # # DBUG('40000,"[FSM7].2 cStatement='"&cStatement&"'"&CRLF&
    " saiStatement='"&saiStatement&"'") */
       s= GC_EPOPS(infix_to_prefix(codestring,GC_PUSHS("concat"),
				   GC_PUSHS(PNULL), dotypechk));
/*  # # DBUG('40000,"[FSM7].2.1 s='"&s&"'"&CRLF&
    " cStatement='"&cStatement&"'"&CRLF&
    " saiStatement='"&saiStatement&"'") */
       sawstrfct= 1L;
     }/* use old fashioned string concat */

pdw_ptype(lasttype,codestring);
popnumber(&midofexpr);
/*  # # DBUG('40000,"[FSM7].3 s='"&s&"'") */

/* NO-OP */;
set_preface(&ws);
wsnext= catlist(2L,GC_PUSHS(ws),subsr(GC_PUSHS(ps_spaces),1L,lthcat));
s= GC_EPOPS(justify_text(GC_PUSHS(wsnext),GC_PUSHS(PNULL),GC_PUSHS(s)));
GC_EPOPS(dbug(040000L,catlist(3L,GC_PUSHS("[FSM7].4 s=\'"),
			      GC_PUSHS(s),GC_PUSHS("\'"))));

GC_SRETURN(s)
}/* FSM7 */
