/* FILE: fsm73.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsme.c, being converted 12/25/87, 08:02:03PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  -------------------------------------------------------- */
/*INTERNAL*/  STRING fsm73(h)
	INTEGER h;
{/* FSM73 */
STRING s, 
	s1, 
	name;
INTEGER ch, 
	dw;

;
{/* INCFSM */ if (usecntfsmflag) (*aChkI(cntfsms,1L,73L))= (*aChkI(cntfsms,1L,73L))+1L;
		     }/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(4L,GC_PUSHS("[FSM73] \'rule\' NODE["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("]="),prt_node(h))));
/*[73] <SYMTAB type tests>*/
/*   --
.LABEL [<++PSAIL PROCEDURE: FSM73>]
.INDEX ++PSAIL PROCEDURE: FSM73
	This is a catch-all FSM to do wierd stuff having
	to do with the symbol-table, special built-in
	functions or macros.
	(1)	Map SAIL:	DECLARATION(id) or 
			EXPR!TYPE(expression)
			CHECK!TYPE(declaration list)
	To C:		octal DW string.

	(2)	MAP SAIL:	COMPILER!BANNER
	To C:		string which is:
M		PSAIL    28-APR-86   2:42 DSK:JUNK.SAI  1-1
M		/SCREEN/NOLOGO
	(that is the compiler switches specified by USER
	command line and not those subsequently added using
	COMPILER!SWITCHES.)

	(3)	MAP SAIL:	NOMAC
	to C:	NULL but set nomacFLAG:=TRUE
	(4)	MAP SAIL:	ENTRY <opt. list of names> <semiColon>
	to C:	/*ENTRY*/
		    and set notMAINflag := TRUE

	(5)	MAP SAIL:	CVMS(<macro-name>)
		    or  CVPS(<macro param name>)
	to C:	        a string constant of the <macro-body>
			    or  a string constant = actual macro arg.

	(6)	MAP SAIL:	!!SYMBOL!! <symbol-name>
	to C:	/* PRT!NODE(<symbol-name>) */

	(7)	MAP SAIL:   with /EXTENSIONS
		    FROM <module-file> IMPORT <var-list> 
	to C:	/* FROM <module-file> IMPORT <var-list> */
		and extract only those variables in <var-list>
		found in the module-file. Report those
		not found. <module-file> is an .RQU file.
.ENDLABEL [<++PSAIL PROCEDURE: FSM73>]
 */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(name); /* for G.C. */
	s= PNULL;
	saitoken= (*aChkC(saisym,1L,h));	/*  -- just in case */
	if (equ(GC_PUSHS(saitoken),GC_PUSHS("declaration")) ||
	   equ(GC_PUSHS(saitoken),GC_PUSHS("expr_type")) ||
	   equ(GC_PUSHS(saitoken),GC_PUSHS("check_type")))
		{/* manufacture DW code */
		while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
		if (*saistatement=='(')
			{/* get arg list */
			ch= LOP(saistatement);
			s1= GC_EPOPS(copy_omit(GC_PUSHS(")")));
			GC_EPOPS(remove_white_ends(GC_PUSHS(s1)));
			}/* get arg list */
		else err_hlr(GC_PUSHS(
        						catlist(GC_PUSHS("[FSM73] missing \'(\' for "),
        GC_PUSHS(saitoken))));
		if (*saitoken=='c') dw= cvstype(GC_PUSHS(s1)); 
		else if (*saitoken=='e')
			{/* use lastType of EXPR!TYPE(x) */
/*  # # @V.55.19			PUSHNUMBER(lastType) */
			lasttype= 0L;
			s1= GC_EPOPS(r_d_expr_map(GC_PUSHS(s1)));
			dw= lasttype;
/*  # # @V.55.19			POPNUMBER(lastType) */
			}/* use lastType of EXPR!TYPE(x) */
		else dw= (*aChkI(decldw,1L,(*aChkI(dwptr,1L,hash_c(GC_PUSHS(s1))))));
		dw=dw&0777770275157L;
		s= catlist(2L,GC_PUSHS("0"),cvos(dw));
		if (ismacroflag &&
		   ((dw&040000L) ||
		    ((((ps_itrash_= (dw&037))>0) ? (ps_itrash_+0140L)
				:0L)==0))) isfragmentflag= 1L;
		lasttype= 0L;
		pdw_ptype(lasttype,codeinteger);
		}/* manufacture DW code */

	else if (equ(GC_PUSHS(saitoken),GC_PUSHS("compiler_banner")))
		{/* COMPILER!BANNER */
		/*  -- Fake a 'SAIL-style' 'COMPILER!BANNER' -- */
		s= GC_EPOPS(todays_date());  /*  -- get 'MM/DD/YY, HH:MM:sam'  */
		ii= cvd(subsr(GC_PUSHS(s),1L,2L));	/*  -- get the Month */
		jj= (((*(s+19-1))=='P') ?  12L:0L); /*  -- AM/PM flag */
		s= catlist(9L,subst(GC_PUSHS(s),4L,5L),GC_PUSHS("-"),GC_PUSHS(((ii)==0) ?
         "ERR"
          :	((ii)==1) ? "JAN"
          :	((ii)==2) ? "FEB"
          :	((ii)==3) ? "MAR"
          :	((ii)==4) ? "APR"
        			       :	((ii)==5) ? "MAY"
          :	((ii)==6) ? "JUN"
          :	((ii)==7) ? "JUL"
          :	((ii)==8) ? "AUG"
          :	((ii)==9) ? "SEP"
        			       :	((ii)==10) ? "OCT"
          :	((ii)==11) ? "NOV"
          :	((ii)==12) ? "DEC"),GC_PUSHS("-"),subst(GC_PUSHS(s),7L,
        8L),GC_PUSHS("   "),cvs(cvd(subst(GC_PUSHS(s),12L,13L))+jj),
        GC_PUSHS(":"),subst(GC_PUSHS(s),14L,15L)); 	/*  -- Put into form 
					'DD-mon-YY   HH:MM'  */
		s= catlist(15L,GC_PUSHS(quote),GC_PUSHS("M		PSAIL    "),GC_PUSHS(s),
        GC_PUSHS(" DSK:"),GC_PUSHS(saifile),GC_PUSHS(ippn),
        GC_PUSHS("  "),cvs(pagecount),GC_PUSHS("-"),cvs(linecount),
        GC_PUSHS(crlf),GC_PUSHS("M		"),GC_PUSHS(scmd),GC_PUSHS(crlf)
        ,GC_PUSHS(quote));
		}/* COMPILER!BANNER */

	else if (h==hnomac) nomacflag= 

	1L; else if (equ(GC_PUSHS(saitoken),GC_PUSHS("entry")))
		{/* saw ENTRY -- set NOT main() !!! */
		s= GC_EPOPS(copy_omit(GC_PUSHS(";")));   	/*  -- trash it */
		s= catlist(3L,GC_PUSHS("/* ENTRY (procedure pkg) "),GC_PUSHS(s),
        GC_PUSHS(" */")); 
		if (blocklevel==0) notmainflag= 1L;
		}/* saw ENTRY -- set NOT main() !!! */

	else if (equ(GC_PUSHS(saitoken),GC_PUSHS("cvms")))
		{/* make STRING of macro body */
		ch= LOP(saistatement);
		name= GC_EPOPS(scan(&saistatement,8L,&ch));  /*  -- get name */
		if (*((s1= (*aChkC(declsize,1L,(*aChkI(dwptr,1L,hash_c(GC_PUSHS(name))))))))=='\0') s= twoquotes; 
		else s= s1;
		pdw_ptype(lasttype,codestring);
		}/* make STRING of macro body */

	else if (equ(GC_PUSHS(saitoken),GC_PUSHS("cvps")))
		{/* make STRING of macro parameter name */
		if (ismacroflag) isfragmentflag= 1L;  /*  -- must
				be set if in macro force
				PSAIL!EVAL  */
		/*  -- map to quoted ACTUAL name */
		ch= LOP(saistatement);    /*  -- trash '(' */
		s1= GC_EPOPS(scan(&saistatement,8L,&ch));
		s= catlist(3L,GC_PUSHS(quote),GC_PUSHS(s1),GC_PUSHS(quote));
		pdw_ptype(lasttype,codestring);
		}/* make STRING of macro parameter name */

	else if (useextensionsflag &&
		equ(GC_PUSHS(saitoken),GC_PUSHS("__symbol__")))
		{/* Return PRT!NODE(<name>) as comment */
		INTEGER h/*WARNING*/;
		STRING name;
		GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
		GC_NOTESTRING(name); /* for G.C. */
		while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
		name= GC_EPOPS(scan(&saistatement,10L,&h));   /*  -- to <SC> */
		{/* TRASH!RIGHT!WS */
			while ((*name!='\0') &&
			      (ps_itrash_= (*(name+length(name)-1))) &&
			      iswhitespace(ps_itrash_)) 
						name= subst(GC_PUSHS(name),1L,length(name)-1L);
			}/* TRASH!RIGHT!WS */
		h= hash_c(GC_PUSHS(name));
		pushnumber(debugswitch);
		pushnumber(dbugcode);
		debugswitch= dbugcode= -1L;    /*  -- all bits on */
		if (h==0) (*aChkC(saisym,1L,0L))= name; /*  -- fake it */
		s= GC_EPOPS(prt_node(h));
		(*aChkC(saisym,1L,0L))= PNULL; 	/*  -- fix it */
		popnumber(&dbugcode);
		popnumber(&debugswitch);
		s= catlist(4L,GC_PUSHS("/* "),GC_PUSHS(s),GC_PUSHS(" */"),GC_PUSHS(crlf));
		{GC_UNMARKSSTKFRAME;}}/* Return PRT!NODE(<name>) as comment */

	else if (equ(GC_PUSHS(saitoken),GC_PUSHS("from")))
		{/* FROM is ill-LEAP or FROM/IMPORT if /EXT */
		if (!useextensionsflag) s= GC_EPOPS(fsm31(h) )/*  -- illegal */; 
		else	{/* FROM <modFile> IMPORT <varlist> */
			STRING rqufile,
			varlist,
			v,
			so,
			s1,
			s2,
			s3;
			STRING /*ARRAY*/ *var  /* [1:100] */ ;
			INTEGER rbrk, 
			rchan, 
			reof, 
			rcnt, 
			rerr,
				maxvars, 
			i, 
			idxuser, 
			cs, 
			hs,
				nfound;
			GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
			GC_NOTESTRING(rqufile); /* for G.C. */
			GC_NOTESTRING(varlist); /* for G.C. */
			GC_NOTESTRING(v); /* for G.C. */
			GC_NOTESTRING(so); /* for G.C. */
			GC_NOTESTRING(s1); /* for G.C. */
			GC_NOTESTRING(s2); /* for G.C. */
			GC_NOTESTRING(s3); /* for G.C. */
			GC_NOTEASTRING(var);	/* for G.C. */
			var = arymkC(1L,1L,100L,"var",'c');	/* Dynamic Array */
			so= s1= GC_EPOPS(scan(&saistatement,10L,&rbrk));
					/*  -- for semicolon */
			s= catlist(4L,GC_PUSHS("/* FROM"),GC_PUSHS(s1),GC_PUSHS(" */"),
        GC_PUSHS(crlf));
			s1= GC_EPOPS(remove_white_ends(GC_PUSHS(s1)));
			if (*s1==*quote)
				{/* quoted filename */
				rbrk= LOP(s1);
				rqufile= GC_EPOPS(map_quotes(&s1));
				rqufile= subst(GC_PUSHS(rqufile),2L,length(rqufile)-1L);
				}/* quoted filename */
			else rqufile= GC_EPOPS(get_token(&s1));
			while ((*s1!='\0') &&iswhitespace((INTEGER)*s1)) ps_itrash_= LOP(s1);
			s2= GC_EPOPS(get_token(&s1));  /*  -- should be IMPORT */
/*  # # DBUG('40000,"[FSM73].1 rquFile='"&rquFile&"' s2='"&s2&"'"&CRLF&" s1='"&s1&"'") */
			if (!equ(GC_PUSHS(s2),GC_PUSHS("import"))) err_hlr(GC_PUSHS(

        	catlist(GC_PUSHS(
        "[FSM73] Missing \'IMPORT\' keyword in \'FROM <rquFile> IMPORT <var-list>\'")
        ,GC_PUSHS(crlf),GC_PUSHS(" in \'"),GC_PUSHS(so),
        GC_PUSHS("\'."))));
			varlist= GC_EPOPS(remove_white_ends(GC_PUSHS(s1)));
/*  # # DBUG('40000,"[FSM73].2 varList='"&varList&"'") */
			maxvars= 0;
			while (*((v= GC_EPOPS(get_token(&varlist))))!='\0')
				if ((*v!=',') &&
				   !iswhitespace((INTEGER)*v))
				     {/* push it */
				     (*aChkC(var,1L,++maxvars))= v;
/*  # # DBUG('40000,"[FSM73].2.1 var[maxVars="&CVS(maxVars)&"]='"&var[maxVars]&"'") */
				     }/* push it */
		/*  -- open rChan file with .RQU extension
			 */rchan= PSgetchan();
			PSopen(rchan,GC_PUSHS("DSK"),0L,1L,0L,&(rcnt= 1000),
						&rbrk,&reof);
			lookup(rchan,GC_PUSHS(rqufile),&rerr);
			if (rerr)
				{/* try again */
				if ((*(rqufile+length(rqufile)-3L-1))!='.') rqufile= catlist(2L,GC_PUSHS(rqufile),GC_PUSHS(".RQU"));
				lookup(rchan,GC_PUSHS(rqufile),&rerr);
				}/* try again */
/*  # # DBUG('40000,"[FSM73].2.2 rChan="&CVS(rChan)&" rquFile='"&rquFile&"' rEof="&CVS(rEof)& " rErr="&CVS(rErr)) */
			if (rerr) err_hlr(GC_PUSHS(
	   catlist(3L,GC_PUSHS("[FSM73] IMPORT file \'"),GC_PUSHS(rqufile),
	           GC_PUSHS("\' not found."))));
		/*  -- Scan for ids in file and then test if
		they are in var[]. If so add declaration
		line to front of saiStatement */
			so= "@";
			nfound= 0;
			while (!reof)
				{/* Analyze each file decl */
/*  # # DBUG('40000,"[FSM73].2.3 sO='"&sO&"'") */
				s3= "@";
				while (!reof)
					{/* get next line */
					s2= GC_EPOPS(input(rchan,1L));
/*  # # DBUG('40000,"[FSM73].2.3.1 s2='"&s2&"'") */
					if (*s2!='\0') s3= catlist(3L,GC_PUSHS(s3),GC_PUSHS(s2),GC_PUSHS(crlf));
/*  # # DBUG('40000,"[FSM73].2.3.2 s3='"&s3&"'") */
					if ((*(s2+length(s2)-1))==';') break;
					}/* get next line */
				ch= LOP(s3);	/*  -- trash '@' */
/*  # # DBUG('40000,"[FSM73].3 next line s3='"&s3&"'") */
				s2= s3;		/*  -- copy defn */
				/*  -- skip past keywords to id */
				while ((*s2!='\0') &&
				      (*((v= GC_EPOPS(get_token(&s2))))!='\0') &&
				      (iswhitespace((INTEGER)*v) ||
				       ((*aChkI(declfsm,1L,idxuser= find_symbol(GC_PUSHS(
						  v),&cs,&ch)))&0777)>0)) 0L	/*  -- skip past keywords */
/*  # # DBUG('40000,"[FSM73].3.1 v='"&v&"' s2'="&s2&"'") */
				for (i=1;i<=maxvars;i++)
					if (equ(GC_PUSHS(v),GC_PUSHS((*aChkC(var,1L,i)))))
						{/* found it */
						so= catlist(2L,GC_PUSHS(so),GC_PUSHS(s3));
						++nfound;
						(*aChkC(var,1L,i))= PNULL;
/*  # # DBUG('40000,"[FSM73].3.2 nFound="&CVS(nFound)&" sO='"&sO&"'") */
						break;
						}/* found it */
				}/* Analyze each file decl */
			ch= LOP(so);	/*  -- trash '@' */
/*  # # DBUG('40000,"[FSM73].4 nFound="&CVS(nFound)&" maxVars="&CVS(maxVars)&CRLF&" sO='"&sO&"'") */
			if (nfound!=maxvars)
				{/* missing vars in file */
				s1= 
        				catlist(GC_PUSHS("Missing IMPORT variables FROM \'"),
        GC_PUSHS(rqufile),GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" "));
				for (i=1;i<=maxvars;i++)
					if (*((*aChkC(var,1L,i)))!='\0') s1= 
        							catlist(GC_PUSHS(s1),GC_PUSHS(*aChkC(var,1L,i)),
        GC_PUSHS(" "));
/*  # # DBUG('40000,"[FSM73].5 sO'="&sO&"'"&CRLF&" s1='"&s1&"'")
				 */err_deathwish(&s, GC_PUSHS(s1),
					 2L, (INTEGER)'\0');
				}/* missing vars in file */
			if (*so!='\0')
			  saistatement=	catlist(GC_PUSHS(so),
						GC_PUSHS(saistatement));
/*  # # DBUG('40000,"[FSM73].6 s='"&s&"'"&CRLF&" saiStatement'="&
    saiStatement&"'") */
			release(1L,rchan);
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'hs'=<L0> integer                             */
/*************************************************/
			{aryfree((INTEGER *)var,(INTEGER *)0); 
                       /* Free List of Dynamic Arrays */
			 GC_UNMARKSSTKFRAME;}
		    }/* FROM <modFile> IMPORT <varlist> */
	    }/* FROM is ill-LEAP or FROM/IMPORT if /EXT */

GC_SRETURN(s)
}/* FSM73 */
