/* FILE: fsm9.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psfsma.c, being converted 12/25/87, 05:15:20PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */

/*  -------------------------------------------------------- */
/*INTERNAL*/  STRING fsm9(h)
	INTEGER h;
{/* FSM9 */
STRING s, 
	trash, 
	s1, 
	s2, 
	ws, 
	oldsaistatement;
INTEGER lllch, 
	llch, 
	lch, 
	ch;


{/* INCFSM */
if (usecntfsmflag)
  (*aChkI(cntfsms,1L,9L))++;
}/* INCFSM */

GC_EPOPS(dbug(040000L,catlist(10L,GC_PUSHS("[FSM9] \'rule\' NODE["),
			      GC_PUSHS(*aChkC(saisym,1L,h)),
			      GC_PUSHS("]="),prt_node(h),
			      GC_PUSHS(" midOfExpr="),
			      pbool(midofexpr),GC_PUSHS(" oldToken=\'"),
			      GC_PUSHS(oldtoken),
			      GC_PUSHS("\' isCOPY!TOflag="),
			      pbool(iscopy_toflag))));
/*  # # DBUG('40000,"[FSM9].0.1 saiStatement='"&saiStatement&"'") */
/*  --
.LABEL [<++PSAIL PROCEDURE: FSM9>]
.INDEX ++PSAIL PROCEDURE: FSM9
	Map quoted SAIL string constants to an optimized quoted C
string constant if 'midOfExpr' is TRUE. Otherwise map it to a
comment. NOTE: in C, denote a double quote " in an embedded String by
a \" construct and \ by \\. Also denote the ' as \'. If we are
evaling a macro body, then allow leftmost quoted string constants.
.ENDLABEL [<++PSAIL PROCEDURE: FSM9>]
*/

/*[9] quote*/
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(trash); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(ws); /* for G.C. */
GC_NOTESTRING(oldsaistatement); /* for G.C. */

ws = s = PNULL;
oldsaistatement= saistatement;  /*  -- in case ERR!HLR */
if (iscopy_toflag ||
    ((midofexpr ||*oldtoken=='(' ||*oldtoken==',' ||
      ismacroflag) &&
     (*oldtoken!=';')))
  {/* Output String between quotes */
/*  # # DBUG('40000,"[FSM9].1 doing QUOTE saiStatement='"&saiStatement&"'") */
      s= GC_EPOPS(map_quotes(&saistatement));
      if (*s==*singlequote)
	pdw_ptype(lasttype,codeinteger); 
      else pdw_ptype(lasttype,codestring);
				 /*  -- Default */
/*  # # DBUG('40000,"[FSM9].1.1 s='"&s&"' saiStatement='"&saiStatement&"'") */
      oldtoken= quote;
   }/* Output String between quotes */

else {/* cvt to comment */
       oldtoken= "comment";
       lllch= llch= lch= (INTEGER)'\0';
       ch= (INTEGER)*quote;
/*  # # DBUG('40000,"[FSM9].2 doing CMT saiStatement='"&saiStatement&"'") */
       if ((*saistatement==*quote) &&
	   ((*(saistatement+2-1))!=*quote))
	 {/* NULL quote comment */
	   s= "/**/";
	   ch= LOP(saistatement); /*  -- trash it */
         }/* NULL quote comment */
       else do 
	 {/* look for 2nd quote */
	   lllch= llch;
	   llch= lch;
	   lch= ch;
	   ch= LOP(saistatement);
/*  # # DBUG('40000,"[FSM9].2.1 lllCh="&(trash_lllCh)&" llCh="&
    (trash_llCh)&" lCh="&(trash_lCh)&" ch="&(trash_ch)&CRLF&
    " saiStatment="&saiStatement) */
	   if (((lllch==*quote&&llch==*quote &&
		 lch==*quote &&ch!=*quote) ||
		(llch!='\0'&&llch!=*quote &&
		 lch==*quote &&ch!=*quote)))
	     {/* end of quote */
	       s= GC_EPOPS(map_embedded_comments(subst(GC_PUSHS(s),1L,
						       length(s)-1L)));
	       s= catlist(3L,GC_PUSHS("/*"),GC_PUSHS(s),GC_PUSHS("*/"));
	       saistatement= catlist(2L,makstr(ch),GC_PUSHS(saistatement));
					/*  -- backup has BUG @V.32.14 */
	       break;
	   }/* end of quote */
	   else if (lch=='*'&&ch=='/')
	     s= catlist(3L,GC_PUSHS(s),GC_PUSHS(" "),makstr(ch));
	   else if (ch==('\\'))
	     s= catlist(2L,GC_PUSHS(s),GC_PUSHS("\\\\"));
	   else {if (*s=='\0') s= GC_EPOPS(makstr(ch ));
	   else s= catlist(2L,GC_PUSHS(s),makstr(ch));
	     }
       }/* look for 2nd quote */
       while (!((*saistatement=='\0')));
       if ((*saistatement=='\0')) 
	 {/* error abort */
	     err_hlr(GC_PUSHS(
	catlist(5L,GC_PUSHS("[FSM9] (quote) COMMENT missing 2nd \""),
	        GC_PUSHS(crlf),GC_PUSHS("\'"),GC_PUSHS(oldsaistatement),
	        GC_PUSHS("\'"))));
	 }/* error abort */
       if (!usecommentflag)
	 s= PNULL;   /*  -- kill the sucker!!! */
     }/* cvt to comment */

if (*ws!='\0')
  s= catlist(2L,GC_PUSHS(s),GC_PUSHS(ws));  
                                   /* -- append trailing white space */
/* # # DBUG('40000,"[FSM9].3 s='"&s&"' saiStatement='"&saiStatement&"'") */

GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 's2'=<L0> string                              */
/* 's1'=<L0> string                              */
/* 'trash'=<L0> string                           */
/*************************************************/
}/* FSM9 */

