/* FILE: get_c_token.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pslex.c, being converted 12/25/87, 08:38:10PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING get_c_token(txt,moretext)
	STRING *txt;
	STRING *moretext;
/*  ------------------------------------------------------- */
{/* GET!C!TOKEN */
/*  --
.LABEL [<++PSAIL PROCEDURE: GET!C!TOKEN>]
.INDEX ++PSAIL PROCEDURE: GET!C!TOKEN
DESCRIPTION:
	Scan for next C type token. NOTE: if a quoted string did not
have a terminator QUOTE, then do not report an error. If moreText is
not NULL, then keep scanning from it.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: GET!C!TOKEN>]
 */
STRING tok;
INTEGER brk, 
	n;

;

/*  # # DBUG('2000,"[GET!C!TOKEN] txt='"&txt&"' |txt|="&CVS(LENGTH(txt))) */

/* NO-OP */;
/* NO-OP */;

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(txt); /* for G.C. */
GC_NOTESTRING(moretext); /* for G.C. */
GC_NOTESTRING(tok); /* for G.C. */
tok= GC_EPOPS(scan(txt,38L,&brk));	/*  -- Equiv to break table 17 but retain break 
			if scanned string is not null.
			for getting next token */
if (*tok=='\0'&&brk!='\0') tok= GC_EPOPS(makstr(LOP(*txt)));	/*  -- force it to be break char */
if (*tok==brk) 
	{/* build super token */
	if ((*(*txt)=='=') &&(brk=='!'||brk=='<' ||brk=='>' ||brk=='=' ||
			  brk=='+' ||brk=='-' ||brk=='*' ||brk=='/' ||
			  brk=='%' ||brk=='&' ||brk=='|' ||brk=='^') ||
	   (brk=='+'&&*(*txt)=='+') ||
	   (brk=='-'&&*(*txt)=='-') ||
	   (brk=='>'&&*(*txt)=='>') ||
	   (brk=='<'&&*(*txt)=='<') ||
	   (brk=='&'&&*(*txt)=='&') ||
	   (brk=='|'&&*(*txt)=='|')) tok= catlist(2L,GC_PUSHS(tok),GC_PUSHS(LOP(*txt)));
	}/* build super token */

else if ((brk=='+'||brk=='-') &&isdigit((INTEGER)*tok) &&(*(tok+length(tok)-1))=='E')
	{/* get the <exp> of the real nbr: <mantissa>E<exp> */
	tok= catlist(2L,GC_PUSHS(tok),GC_PUSHS(LOP(*txt)));	/*  -- get the <exp> sign */
	tok= catlist(2L,GC_PUSHS(tok),scan(txt,38L,&brk));	/*  -- Add on <exp>  */
GC_EPOPS(dbug(02000L,catlist(7L,GC_PUSHS("[GET!C!TOKEN].0.1 tok=\'"),GC_PUSHS(tok),
        GC_PUSHS("\' txt=\'"),GC_PUSHS(*txt),GC_PUSHS("\' brk=\'"),
        GC_PUSHS(ps_strash_= GC_EPOPS(makstr(brk))),GC_PUSHS("\'"))));
	}/* get the <exp> of the real nbr: <mantissa>E<exp> */

if (*tok==*quote)
   while ((*(*txt)!='\0'))
	{/* get quoted string */
	tok= catlist(2L,GC_PUSHS(tok),scan(txt,30L,&brk));  /*  -- scan for \, ' or " and
					retain break for null string */
	if (brk==('\\'/*WARNING*/)) tok= catlist(2L,GC_PUSHS(tok),GC_PUSHS(LOP(*txt))); else if (brk==*quote) break;
	if ((*(*txt)=='\0') &&(*(*moretext)!='\0')) *txt= catlist(2L,scan(moretext,1L,&brk),GC_PUSHS(crlf));  /*  -- get new line */
	}/* get quoted string */

else if (*tok==*singlequote)
   {/* single quote */
   while ((*(*txt)!='\0'))
	{/* get single-quoted string */
	tok= catlist(2L,GC_PUSHS(tok),scan(txt,30L,&brk));    /*  -- scan for \, ' or "  and
				     append it to scanned string */
	if (brk==('\\'/*WARNING*/)) tok= catlist(2L,GC_PUSHS(tok),GC_PUSHS(LOP(*txt))); else if (brk==*singlequote) break;
	}/* get single-quoted string */
/*  # # DBUG('2000,"[GET!C!TOKEN].0.2 tok='"&tok&"' txt='"&txt&"' brk='"&(ps!sTrash!_brk)&"'") */
   }/* single quote */

else if (*tok=='/'&&*(*txt)=='*')
   {/* get C comment */	/*  -- This sucker handles nested C cmts */
   tok= catlist(2L,GC_PUSHS(tok),GC_PUSHS(LOP(*txt)));
   n= 1;
   while ((n>0) &&(*(*txt)!='\0'))
	{/* get / *...* / string */
	tok= catlist(2L,GC_PUSHS(tok),scan(txt,31L,&brk));     /*  -- scan for * or /  and
					append it to scanned string */
	if (brk=='*'&&*(*txt)=='/') 
		{/* end of CMT */
		--n;
		tok= catlist(2L,GC_PUSHS(tok),GC_PUSHS(LOP(*txt)));
		}/* end of CMT */
	else if (brk=='/'&&*(*txt)=='*') 
		{/* start of new CMT */
		++n;
		tok= catlist(2L,GC_PUSHS(tok),GC_PUSHS(LOP(*txt)));
		}/* start of new CMT */
	if (*(*txt)=='\0'&&*(*moretext)!='\0') *txt= catlist(2L,scan(moretext,1L,&brk),GC_PUSHS(crlf));  /*  -- get new line */
	}/* get / *...* / string */
/*  # # DBUG('2000,"[GET!C!TOKEN].1 n="&CVS(n)&" tok='"&tok&"' txt='"&txt&"'") */
   }/* get C comment */

/*  # # DBUG('2000,"[GET!C!TOKEN].2 tok='"&tok&"'=O"&CVOS((ps!iTrash!_tok))&" txt='"&txt&"'") */
GC_EPOPS(dbug(02000L,catlist(8L,GC_PUSHS("[GET!C!TOKEN].2.1 tok=\'"),GC_PUSHS(tok),
        GC_PUSHS("\'=0"),cvos((ps_itrash_= (INTEGER)*tok)),
        GC_PUSHS(" |tok|="),cvs(length(GC_PUSHS(tok))),
        GC_PUSHS(" |txt|="),cvs(length(GC_PUSHS(*txt))))));
;
GC_SRETURN(tok)
}/* GET!C!TOKEN */
