/* FILE: get_input.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pslex.c, being converted 12/25/87, 08:38:10PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING get_input()
/*  ------------------------------------------------------- */
{/* GET!INPUT */
/*  --
.LABEL [<++PSAIL PROCEDURE: GET!INPUT>]
.INDEX ++PSAIL PROCEDURE: GET!INPUT
DESCRIPTION:
	Input a text-line appending a CRLF from the input .SAI file.
If eof is found, then try to unstack REQUIRE files if any. If we are
at the last EOF and are compiling a SAIL '.REQ' (i.e. C '.h') file
then we must fake out PSAIL and insert a BEGIN/END pair around the
file. Keeps track of the file line and page counters as well. NOTE:
@V.53.15 When running on UNIX environments there is no CRLF but
rather a \n. So we must (1) be able to BREAK on \n and (2) map it to
a CRLF so that the rest of PSAIL can handle it.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: GET!INPUT>]
 */
STRING s;
INTEGER i;

;

/*  # # DBUG('1000,"[GET!INPUT] saiEof="&CVOS(saiEof)&" reqOutput["&CVS(reqLEvel)&"]="&PBOOL(reqOutput[reqLevel])&CRLF&" line='"&line&"'") */

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
if (saieof) GC_SRETURN(PNULL)

s= GC_EPOPS(input(saichan,1L));			/*  -- Break on LF  */
nuldevflag= (*aChkI(reqoutput,1L,reqlevel));		/*  -- always reset because of
					the delay with REQUIRE source 
					files when done with /NOREQUIRE */
GC_EPOPS(dbug(01000L,catlist(11L,GC_PUSHS("[GET!INPUT].1 s=\'"),GC_PUSHS(s),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" NULdevFlag="),pbool(nuldevflag),
        GC_PUSHS(" reqLevel="),cvs(reqlevel),
        GC_PUSHS(" reqFile[reqLevel]=\'"),GC_PUSHS(*aChkC(reqfile,1L
        ,reqlevel)),GC_PUSHS("\'"))));

if (saieof)
	{/* Process EOF */
	if ((reqlevel<=0))
		{/* Process final EOF */
/*  -- NOTE: @V.54.85 SPECIAL HANDLING is required to insert a
BEGIN/END pair around the file when the file being compiled is a
'.REQ' (i.e. '.h') file.
 */
		if (equ(subst(GC_PUSHS(cfile),length(cfile)-1L,length(cfile)),GC_PUSHS(".h")))
			{/* add 'END;' at the real end */
			if (*s=='\0') s= "end;"; 
			else s= catlist(2L,GC_PUSHS(s),GC_PUSHS("end;"));
			}/* add 'END;' at the real end */
		}/* Process final EOF */

	else	{/* Implement REQUIRE in PSAIL */
		release(1L,saichan);	/*  -- free up the channel */
		--reqlevel;
		pagecount= (*aChkI(reqpage,1L,reqlevel));
		linecount= (*aChkI(reqline,1L,reqlevel));
		nuldevflag= (*aChkI(reqoutput,1L,reqlevel));
		saistatement= (*aChkC(reqsaistr,1L,reqlevel));  /*  -- unstack it */
		line= (*aChkC(reqlnstr,1L,reqlevel));  	/*  -- stuff left in the
						look ahead buffer from
						before - better fix it 
						up so no one will know */
		PSprintf("%s",GC_PUSHS(crlf));			/*  -- force new line */
		for (i=1;i<=reqlevel;i++) 
			PSprintf("%s",GC_PUSHS(tab));
		saichan= (*aChkI(reqchan,1L,reqlevel));
		saieof= 0L;
		s= GC_EPOPS(input(saichan,1L));
GC_EPOPS(dbug(01000L,catlist(27L,GC_PUSHS("[GET!INPUT].1.1 (UNSTACK reqLevel="),cvs(
        reqlevel),GC_PUSHS(" ["),GC_PUSHS(*aChkC(reqfile,1L,
        reqlevel)),GC_PUSHS("]) "),GC_PUSHS(crlf),
        GC_PUSHS(" old reqOutput["),cvs(reqlevel+1L),GC_PUSHS("]="),
        pbool((*aChkI(reqoutput,1L,reqlevel+1L))),GC_PUSHS(crlf),
        GC_PUSHS("  NULdevFlag="),pbool(nuldevflag),
        GC_PUSHS(" isMACROflag="),pbool(ismacroflag),GC_PUSHS(crlf),
        GC_PUSHS("  s=\'"),GC_PUSHS(s),GC_PUSHS("\'"),GC_PUSHS(crlf)
        ,GC_PUSHS(" saiStatement=\'"),GC_PUSHS(saistatement),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" line=\'"),
        GC_PUSHS(line),GC_PUSHS("\'"))));
		if (ismacroflag)
			{/* Real trouble here!!!! */
			ismacroflag= 0L;   /*  -- so we can see error! */
			err_hlr(GC_PUSHS(
	  "[GET!INPUT] End-Of-File found looking for MACRO body!"));
			ismacroflag= 1L;
			}/* Real trouble here!!!! */
		}/* Implement REQUIRE in PSAIL */
	}/* Process EOF */

if (*s=='\0') s= crlf; 
else s= catlist(2L,GC_PUSHS(s),GC_PUSHS(crlf));		/*  -- always give them something! */
/*  --	Check if a form-feed which will appear as 1st char of a new
line...
 */

if (*s==*ff) 
	{/* new page */
	PSprintf("%c%s",' ',cvs((++pagecount)));
	linecount= 0L;			/*  -- Start clean */
	}/* new page */

laststatement= catlist(2L,GC_PUSHS(laststatement),GC_PUSHS(s));  /*  -- in case need for ERR!HLR */
++linecount;
++totlinecount;

/*  # # DBUG('1000,"[GET!INPUT].2 saiEof="&CVOS(saiEof)&" s="&s) */
;
GC_SRETURN(s)
}/* GET!INPUT */
