/* FILE: get_next_statement.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pslex.c, being converted 12/25/87, 08:38:10PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */



#define old_g_n_s 1L		/*  -- while debuging this mess */
/* IFC EVAL((not old_g_n_s))=0 */
 /* THENC <<<FAILED!!!>>>

comment  -------------------------------------------------------;
internal rrecursive procedure get_next_statement;
comment  -------------------------------------------------------;
begin "GET!NEXT!STATEMENT"
comment  --
.LABEL [<++PSAIL PROCEDURE: OLD-GET!NEXT!STATEMENT>]
.INDEX ++PSAIL PROCEDURE: OLD-GET!NEXT!STATEMENT
DESCRIPTION:

	Scan a SAIL statement ending with a SEMICOLON from 'line' and
input file if required. Note that data is preprocessed for comments
(not inside double quotes) using CVEVALQUOTE.

@V.45.139 NOTE: Normally when we are evaling previously extracted
statements with R!D!EXPR!MAP we do not get additional input
lines. But if we are evaling RIGHTSTATEMENT and are not doing a macro
body, we can get additional input lines.
SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: OLD-GET!NEXT!STATEMENT>]
;
string locline, s, s1, s2, s3, trash, delimbrk;
integer ch, isquote, sawdoublequote, parencnt, delimcnt;

ifc is_sail
 thenc
define add_ch(dst,x)=\Begin If dst=NULL Then dst_(x)
				Else dst_dst & (x); End\;
 endc;

ifc is_psail
 thenc
define add_ch(string dst, integer x)=\Begin If dst=NULL Then dst_(x)
				Else dst_dst & (x); End\;
 endc; comment  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++;

;

dbug(01000,"[GET!NEXT!STATEMENT] saiStatement='"&saistatement&"'"&crlf&" line='"&line&"'");
comment  # # @V.47.133 NOTE: Be careful since this is not really the right
# # # 	place to do this....;
comment  # # @V.48.10 condStatementFlag_FALSE;
comment  # # @V.49.40 SET!STATIC(blockLevel);  comment  set dcStaticD.. & lastDecl..;

parencnt:=0;
comment NO-OP;;
locline:=null;			comment  -- local line we accumulate here;

if sailbodydelim neq quote or sairbodydelim neq quote or
   sailargdelim neq quote or sairargdelim neq quote
	then
	begin "change delimiter break table"
	delimbrk:=quote & ");(";		comment  -- Set up break table;
	if sailbodydelim neq quote
		then delimbrk:=delimbrk & sailbodydelim;
	if sairbodydelim neq quote and sairbodydelim neq sailbodydelim
		then delimbrk:=delimbrk & sairbodydelim;
	if sailargdelim neq quote and sailargdelim neq sailbodydelim
		then delimbrk:=delimbrk & sailargdelim;
	if sairargdelim neq quote and sairargdelim neq sailargdelim and
	   sairargdelim neq sairbodydelim
		then delimbrk:=delimbrk & sairargdelim;
	setbreak(27,b27:=delimbrk,null,"INS");
comment  # # DBUG('1000,"[GET!NEXT!STATEMENT].0.1 delimBrk='"&delimBrk&"'");
	end "change delimiter break table";

if not saieof
  then 
  do	begin "find end of statement"
comment  # # DBUG('1000,"[GET!NEXT!STATEMENT].0.2 parenCnt="&CVS(parenCnt)&" delimCnt="&CVS(delimCnt)&CRLF&" locLine='"&locLine&"'"&CRLF&" line='"&line&"'");
	if (line=null)
		then
		begin "get new line"
comment  # # DBUG('1000,"[GET!NEXT!STATEMENT].0.3 parenCnt="&CVS(parenCnt)&" delimCnt="&CVS(delimCnt)&CRLF&" locLine='"&locLine&"'"&CRLF&" line='"&line&"'");
		if (revalflag>0) and not isrightstatementflag
			then done;	comment  -- no more input while rEval 
					and not doing RIGHTSTATEMENT.;
		if line=null and not saieof
			then 
			begin "suck from file"
			s3:=get_input; 	comment  -- from .SAI file;
					comment  -- NOTE: may be restore line
					from require files;
			if line=null
				then line:=cvevalquote(s3)
				else line:=line & cvevalquote(s3);
comment  # # DBUG('1000,"[GET!NEXT!STATEMENT].0.4 line='"&line&"'");
			end "suck from file";
		if line=null and saieof
			then done;
		end "get new line";

	s1:=scan(line,27,ch); 		comment  -- Grab token and keep CRLF;
comment  # # DBUG('1000,"[GET!NEXT!STATEMENT].0.5 s1='"&s1&"' ch='"&(trash_ch)&"'"&CRLF&"  line='"&line&"'");

	if s1="c" and ch neq ";" and equ(s1,"comment")
		then
		begin "Special COMMENT scan!!!"
		comment  -- Get up to SEMICOLON and keep going;
		s1:=s1 & ch;
		s1:=s1 & scan(line,10,ch); comment  -- NOTE that CVEVALQUOTE
					    got the entire COMMENT!!!;
comment  # # DBUG('1000,"[GET!NEXT!STATEMENT].0.6 s1='"&s1&"' ch='"&(trash_ch)&"'");
		end "Special COMMENT scan!!!";

	if s1 neq null
		then	begin if locline=null 
				then locline:=s1
			   else locline:=locline & s1;
			end; 		comment  -- do CHUNKS;

	if ch="("
		then
		begin "open '(' or procedure arg list"
		parencnt:=parencnt+1;
		add_ch(locline,ch);
		end "open '(' or procedure arg list"

	else if ch=")"
		then
		begin "Close ')' or procedure arg list"
		parencnt:=parencnt-1;
		add_ch(locline,ch);
		end "Close ')' or procedure arg list"

	else if (ch neq quote) and (ch=sailbodydelim or ch=sailargdelim)
		then
		begin "Suck in the DELIMITED string"
comment  --		SAIL can parse the following MACRO delimiters set up
		as illustrated by the following example:
			REQUIRE "{}{}" DELIMITERS
		the input string
			Define xxx={....}
		will have the ... between { and } copied intact.
		NOTE: the left and right delimiters might be the same!
;
comment  # # DBUG('1000,"[GET!NEXT!STATEMENT].1 BEGIN DELIM parenCnt="&CVS(parenCnt)&" delimCnt="&CVS(delimCnt)&CRLF&" locLine='"&locLine&"'"&CRLF&" line='"&line&"'");
		add_ch(locline,ch);		comment  -- 1st delimiter;
		delimcnt:=1;			comment  -- prep counter;
		while (line neq null) and (delimcnt>0) do
			begin "copy DELIMITED string"
			s2:=scan(line,27,ch);	comment  -- for RIGHT Delim.;
comment  # # DBUG('1000,"[GET!NEXT!STATEMENT].1.1 s2='"&s2&"' ch='"&(trash_ch)&"'");
			if s2 neq null
				then 
				begin if locline=null
					then locline:=s2
					else locline:=locline & s2;
				end;
			if ch neq null
				then add_ch(locline,ch);
			if (ch=sairbodydelim)
				then delimcnt:=delimcnt-1
			else if (ch=sailbodydelim)
				then delimcnt:=delimcnt+1
			else if (ch=sairargdelim)
				then delimcnt:=delimcnt-1
			else if (ch=sailargdelim)
				then delimcnt:=delimcnt+1;
			end "copy DELIMITED string";
comment  # # DBUG('1000,"[GET!NEXT!STATEMENT].1.2 END DELIM parenCnt="&CVS(parenCnt)&" delimCnt="&CVS(delimCnt)&CRLF&" locLine='"&locLine&"'"&CRLF&" line='"&line&"'");
		end "Suck in the DELIMITED string"

	else if (ch=quote)
		then
		begin "Suck in the QUOTED string"
comment  --		SAIL can parse the following:
			"abc"
			"a""c"
			"""abc"""
			"""ab""cde""".
			<lMacroDelim>abc"xyz<rMacroDelim>
;
		isquote:=true;
		add_ch(locline,ch); "1st quote"
comment  # # DBUG('1000,"[GET!NEXT!STATEMENT].2 BEGIN QUOTE locLine='"&locLine&"'"&CRLF&" line="&line);
		while (line neq null) and isquote do
			begin "copy QUOTED string"
			sawdoublequote:=false;
			s2:=scan(line,22,ch);	comment  -- for " or ' ;
			if s2 neq null
				then locline:=locline & s2;
					"NOTE: GET!LINE has entire q-s"
			if (ch=quote) 
				then
				begin "found another quote"
				if (line neq quote)
					then isquote:=false
					else 
					begin "get double quote"
					sawdoublequote:=true;
					locline:=locline & lop(line);
					end "get double quote";
				end "found another quote"
			else if (quote neq ch = sairbodydelim)
				then isquote:=false;
			locline:=locline & ch; "build string"
			end "copy QUOTED string";
comment  # # DBUG('1000,"[GET!NEXT!STATEMENT].2.1 END QUOTE locLine="&locLine&CRLF&" line="&line);
		end "Suck in the QUOTED string"

	else if ch neq null
		then add_ch(locline,ch); "build SAIL statement"
	end "find end of statement"
until (ch=semicolon) and (parencnt leq 0) and (delimcnt leq 0) or 
      (line=null and saieof);
if saistatement=null 
	then saistatement:=locline
else saistatement:=saistatement & locline;

comment NO-OP;;

dbug(01000,"[GET!NEXT!STATEMENT].3 saiStatement='"&saistatement&"'"&crlf&" line='"&line&"'"&" parenCnt="&cvs(parencnt)&" delimCnt="&cvs(delimcnt)&crlf&"   blockLevel="&cvs(blocklevel));
;
end "GET!NEXT!STATEMENT";
 */ /* ENDC */	/*  old G!N!S */
/*  ------------------------------------------------------- */
/* IFC EVAL(old_g_n_s)=1 */
/* THENC */

/*INTERNAL*/   void get_next_statement()
/*  ------------------------------------------------------- */
{/* GET!NEXT!STATEMENT */
/*  --
.LABEL [<++PSAIL PROCEDURE: GET!NEXT!STATEMENT>]
.INDEX ++PSAIL PROCEDURE: GET!NEXT!STATEMENT
DESCRIPTION:
	Scan a SAIL statement ending with a SEMICOLON from 'line' and
input file if required. Note that data is preprocessed for comments
(not inside double quotes) are mapped to C format.

@V.45.139 NOTE: Normally when we are evaling previously extracted
statements with R!D!EXPR!MAP we do not get additional input
lines. But if we are evaling RIGHTSTATEMENT and are not doing a macro
body, we can get additional input lines.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: GET!NEXT!STATEMENT>]
 */
STRING s, 
	s1, 
	s2, 
	s3, 
	trash;
INTEGER ch, 
	isquote, 
	sawdoublequote, 
	parencnt, 
	delimcnt;

/* IFC EVAL(is_sail)=0 */
 /* THENC <<<FAILED!!!>>>

define add_ch(dst,x)=\Begin If dst=NULL Then dst_(x)
				Else dst_dst & (x); End\;
  */ /* ENDC */

/* IFC EVAL(is_psail)=1 */
/* THENC */

#define add_ch(dst,x) {if (*dst=='\0') dst= x; \
				else dst= catlist(2L,GC_PUSHS(dst),makstr(x)); }
  /* ENDC */ /*  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

;

GC_EPOPS(dbug(01000L,catlist(4L,GC_PUSHS(crlf),
        GC_PUSHS("[GET!NEXT!STATEMENT] saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"))));

/*  # # @V.48.10 condStatementFlag_FALSE */
/*  # # @V.49.40 SET!STATIC(blockLevel) */  /*  set dcStaticD.. & lastDecl.. */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(s3); /* for G.C. */
GC_NOTESTRING(trash); /* for G.C. */
delimcnt= parencnt= 0;
/*  # # @V.49.40 SET!STATIC(blockLevel) */  /*  -- set dcStaticD.. & lastDecl.. */
if (!saieof) 
  do 	{/* find end of statement */
/*  # # DBUG('1000,"[GET!NEXT!STATEMENT].0.1 parenCnt="&CVS(parenCnt)&" delimCnt="&CVS(delimCnt)&CRLF&" saiStatement='"&saiStatement&"'"&CRLF&" line='"&line&"'") */
/* NO-OP */;
	if ((*line=='\0'))
		{/* get new line */
GC_EPOPS(dbug(01000L,catlist(12L,GC_PUSHS("[GET!NEXT!STATEMENT].0.2 parenCnt="),cvs(
        parencnt),GC_PUSHS(" delimCnt="),cvs(delimcnt),
        GC_PUSHS(crlf),GC_PUSHS(" saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" line=\'"),GC_PUSHS(line),GC_PUSHS("\'"))));
		if ((revalflag>0) &&!isrightstatementflag) break;	/*  -- no more input while rEval 
					and not doing RIGHTSTATEMENT. */
		if (*line=='\0'&&!saieof) 
			{/* get fresh line from file */
			s3= GC_EPOPS(get_input()); 	/*  -- from .SAI file */
					/*  -- NOTE: may be restore line
					from require files */
			if (*line=='\0') line= GC_EPOPS(cvevalquote(GC_PUSHS(s3))
				); else line= catlist(2L,GC_PUSHS(line),cvevalquote(GC_PUSHS(s3)));
/*  # # DBUG('1000,"[GET!NEXT!STATEMENT].0.3 line='"&line&"'") */
			}/* get fresh line from file */
		if (*line=='\0'&&saieof) break;
		}/* get new line */

	s1= GC_EPOPS(scan(&line,17L,&ch)); 		/*  -- Grab token and keep CRLF */
	if (*s1=='c'&&ch!=';' &&equ(GC_PUSHS(s1),GC_PUSHS("comment")))
		{/* Special COMMENT scan!!! */
		/*  -- Get up to SEMICOLON  */
		s1= catlist(2L,GC_PUSHS(s1),makstr(ch));
		s1= catlist(2L,GC_PUSHS(s1),scan(&line,10L,&ch));   /*  -- NOTE that CVEVALQUOTE
					got the entire COMMENT!!! */
		}/* Special COMMENT scan!!! */
/*  # # DBUG('1000,"[GET!NEXT!STATEMENT].0.4 s1='"&s1&"' ch='"&(trash_ch)&"'") */
	if (*s1!='\0')	{if (*saistatement=='\0') saistatement= s1; 
			else saistatement= catlist(2L,GC_PUSHS(saistatement),GC_PUSHS(s1));
			} 			/*  -- do CHUNKS */

	if (ch=='(')
		{/* open '(' or procedure arg list */
		++parencnt;
		GC_EPOPS(add_ch(GC_PUSHS(saistatement),ch));
		}/* open '(' or procedure arg list */

	else if (ch==')')
		{/* Close ')' or procedure arg list */
		--parencnt;
		GC_EPOPS(add_ch(GC_PUSHS(saistatement),ch));
		}/* Close ')' or procedure arg list */

	else if ((ch==*sailbodydelim) &&(ch!=*quote))
		{/* Suck in the DELIMITED string */
/*  --		SAIL can parse the following MACRO delimiters set up
		as illustrated by the following example:
			REQUIRE "{}{}" DELIMITERS
		the input string
			Define xxx={....}
		will have the ... between { and } copied intact.
		NOTE: the left and right delimiters may be the same!
 */
/*  # # DBUG('1000,"[GET!NEXT!STATEMENT].1 BEGIN DELIM parenCnt="&CVS(parenCnt)&" delimCnt="&CVS(delimCnt)&CRLF&" saiStatement='"&saiStatement&"'"&CRLF&" line='"&line&"'") */
		GC_EPOPS(add_ch(GC_PUSHS(saistatement),ch));	/*  -- 1st delimiter */
		delimcnt= 1;			/*  -- prep counter */
		while ((*line!='\0') &&(delimcnt>0))
			{/* copy DELIMITED string */
			s2= GC_EPOPS(scan(&line,17L,&ch));	/*  -- for RIGHT Delim. */
/*  # # DBUG('1000,"[GET!NEXT!STATEMENT].1.1 s2='"&s2&"' ch='"&(trash_ch)&"'") */
			if (*s2!='\0') 
				{if (*saistatement=='\0') saistatement= s2; 
				else saistatement= catlist(2L,GC_PUSHS(saistatement),GC_PUSHS(s2));
				}
			if (ch!='\0') GC_EPOPS(add_ch(GC_PUSHS(saistatement),ch));
			if ((ch==*sairbodydelim)) --delimcnt; else if ((ch==*sailbodydelim)) ++delimcnt;
			}/* copy DELIMITED string */
/*  # # DBUG('1000,"[GET!NEXT!STATEMENT].1.2 END DELIM parenCnt="&CVS(parenCnt)&" delimCnt="&CVS(delimCnt)&CRLF&" saiStatement='"&saiStatement&"'"&CRLF&" line='"&line&"'") */
		if (*line=='\0'&&delimcnt>0)
			{/* real DRYROT trouble!!! */
			pushnumber(ismacroflag); ismacroflag= 0L;
			err_hlr(GC_PUSHS(
	
	        				catlist(GC_PUSHS(
	        "[GET!NEXT!STATEMENT] DRYROT - missing right macro delimiter \'")
	        ,GC_PUSHS(sairbodydelim),GC_PUSHS("\'"))));
			popnumber(&ismacroflag);
			}/* real DRYROT trouble!!! */
		}/* Suck in the DELIMITED string */

	else if ((ch==*quote))
		{/* Suck in the QUOTED string */
/*  --		SAIL can parse the following:
			"abc"
			"a""c"
			"""abc"""
			"""ab""cde""".
			<lMacroDelim>abc"xyz<rMacroDelim>
 */
		isquote= 1L;
		GC_EPOPS(add_ch(GC_PUSHS(saistatement),ch)); /*1st quote*/
		while ((*line!='\0') &&isquote)
			{/* copy QUOTED string */
			sawdoublequote= 0L;
			s2= GC_EPOPS(scan(&line,22L,&ch));	/*  -- for " or '  */
			if (*s2!='\0') saistatement= catlist(2L,GC_PUSHS(saistatement),GC_PUSHS(s2));
					/*NOTE: GET!LINE has entire q-s*/
			if ((ch==*quote))
				{/* found another quote */
				if ((*line!=*quote)) isquote= 
					0L; else 
					{/* get double quote */
					sawdoublequote= 1L;
					saistatement= 
        							catlist(GC_PUSHS(saistatement),GC_PUSHS(LOP(line)));
					}/* get double quote */
				}/* found another quote */
	 /*  # # @V.51.112 -- do not need since CVEVALQUOTE gets
			  -- the complete quote. The bug appeared
			  -- with REQUIRE "\\\\" DELIMITERS
			  -- and then showed up with "ABC \ XYZ".
			  -- so thake the ELSE part OUT...
			Else If (quote Neq ch = saiRbodyDelim)
				Then isQuote_FALSE */
			saistatement= catlist(2L,GC_PUSHS(saistatement),makstr(ch)); /*build string*/
			}/* copy QUOTED string */
/*  # # DBUG('1000,"[GET!NEXT!STATEMENT].2 END QUOTE saiStatement="&saiStatement&CRLF&" line="&line) */
		}/* Suck in the QUOTED string */

	else if (ch!='\0') GC_EPOPS(add_ch(GC_PUSHS(saistatement),ch)); /*build SAIL statement*/
	}/* find end of statement */
 while (!((ch==*semicolon) &&(parencnt<=0) &&(delimcnt<=0) ||
      (*line=='\0'&&saieof)));

/* NO-OP */;

GC_EPOPS(dbug(01000L,catlist(14L,GC_PUSHS("[GET!NEXT!STATEMENT].3 saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" line=\'"),GC_PUSHS(line),GC_PUSHS("\'"),
        GC_PUSHS(" parenCnt="),cvs(parencnt),GC_PUSHS(" delimCnt="),
        cvs(delimcnt),GC_PUSHS(crlf),GC_PUSHS("   blockLevel="),
        cvs(blocklevel))));
;
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'trash'=<L0> string                           */
/* 's'=<L0> string                               */
/*************************************************/

#undef add_ch
{GC_UNMARKSSTKFRAME;}
}/* GET!NEXT!STATEMENT */
 /* ENDC */	/*  old G!N!S */
