/* FILE: get_token.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pslex.c, being converted 12/25/87, 08:38:10PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING get_token(txt)
	STRING *txt;
/*  ------------------------------------------------------- */
{/* GET!TOKEN */
/*  --
.LABEL [<++PSAIL PROCEDURE: GET!TOKEN>]
.INDEX ++PSAIL PROCEDURE: GET!TOKEN
DESCRIPTION:
	Scan for and return an alphanumeric identifier in 'txt'.
Since '!' were previously (using CVEVALQUOTE) mapped to '_' and '_'
mapped to ':=", then pass through all '_' characters as alphanumeric.
If the normal SCAN fails, then LOP the break character as
the symbol returned. Note: also that we have expanded '@' to 'E' in
CVEVALQUOTE.
This is a hog since we have to be on the lookout for REAL scientific
notation at all times.

@V.41.07 added mapping of MACRO 'FRAGMENT' type symbols.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: GET!TOKEN>]
 */
STRING t, 
	s1, 
	s2,  
	token, 
	sbody;
INTEGER ch, 
	h, 
	i, 
	oldtype, 
	tclass, 
	cs, 
	hs, 
	lt, 
	brk, 
	ht, 
	chn,
	notdeclarationflag;

/* #define tst_number (t neq null) and\
	(isdigit(t) or (t="." and isdigit(txt)) or\
	  (t="e" or t="E") and (not iscopy_toflag) and\
	  notdeclarationflag and\
	  (  ((lt:=length(t))=1 and \
		((chn:=lop(s2:=txt))="+" or chn="-") and\
		isdigit(s2)) or\
	     (lt>1 and chk_integer(t[2 to inf]))\
	  ) and ((ht:=hash_c(t))=0 )\
	)\
		then\
		begin "get the <number>"\
		if brk neq null\
			then t:=t & brk;     _2 -- put back together\
						before scan number;\
		txt:=t & txt;\
		if t="e" or t="E"\
			then txt:="1.0" & txt;\
		t:=get_number(txt);   _2 -- has side effect of setting \
				       0lasttype0 to\
					codeinteger or codereal_;\
		isnumberflag:=lasttype;\
_2 _2 _2 Ev.47.6 - we might move _this code into the actual fsms which\
use the tokens such as fsm18, fsm19, fsm14 etc and add the\
0deathwish[5]0 code.;\
_2 _2 _2 Ev.47.6	if gdw_ptype(lasttype)=codeinteger and\
_2 _2 _2 Ev.47.6	   not chk_32bit_integer(t)\
_2 _2 _2 Ev.47.6		then err_warning(t);\
dbug(02000,"[GET!TOKEN].1 <number> lastType='"&cvtypes(lasttype)&"' t='"&t&"'");\
		end "get the <number>"\
	 ====> PSAIL!EVAL */

;

GC_EPOPS(dbug(02000L,catlist(3L,GC_PUSHS("[GET!TOKEN] txt=\'"),GC_PUSHS(*txt),GC_PUSHS("\'"))));
/* NO-OP */;

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(txt); /* for G.C. */
GC_NOTESTRING(t); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(token); /* for G.C. */
GC_NOTESTRING(sbody); /* for G.C. */
notdeclarationflag= (!fast_equ(GC_PUSHS(oldtypestatement),GC_PUSHS("%%declaration")));

t= GC_EPOPS(scan(txt,29L,&brk));	   /*  -- @V.49.91 same as b17 but "INR" in order
				to RETAIN the break char in the
				front of 'txt' */
/*  # # DBUG('2000,"[GET!TOKEN].0.1 t='"&t&"' brk='"&(s1_brk)&"' txt='"&txt&"'") */
if (brk=='.'&&
	(isdigit((INTEGER)*t) ||
	 (*((s1= *txt))&&(brk= LOP(s1)) &&isdigit((INTEGER)*s1)) ))
	{/* special handling for '.' */
	t= ((*t!='\0') ? catlist(2L,GC_PUSHS(t),GC_PUSHS(LOP(*txt))): LOP(*txt));
	brk= (INTEGER)'\0';
	}/* special handling for '.' */
else	{/* get rid of brk one way or another */
	if (*t!='\0') brk= (INTEGER)*(PNULL
	); else t= GC_EPOPS(makstr(brk= LOP(*txt)));		/*  -- get break char */
	}/* get rid of brk one way or another */
/*  # # DBUG('2000,"[GET!TOKEN].0.2 t='"&t&"' brk='"&(s1_brk)&"'=0"&CVOS(brk)&" |t|="&CVS(length(t))&" txt='"&txt&"'") */

sbody= PNULL;
oldtype= lasttype;
isnumberflag= 0L;

if ((brk=='\0') &&(*t!='\0') &&
	(isdigit((INTEGER)*t) ||(*t=='.'&&isdigit((INTEGER)*(*txt))) ||
	  (*t=='e'||*t=='E') &&(!iscopy_toflag) &&
	  notdeclarationflag &&
	  (  ((lt= length(GC_PUSHS(t)))==1&&
		((chn= LOP(s2= *txt))=='+'||chn=='-') &&
		isdigit((INTEGER)*s2)) ||
	     (lt>1&&chk_integer(subst(GC_PUSHS(t),2L,length(t))))
	  ) &&((ht= hash_c(GC_PUSHS(t)))==0)
	))
		{/* get the <number> */
		if (brk!='\0') t= catlist(2L,GC_PUSHS(t),makstr(brk));     /*  -- put back together
						before scan number */
		*txt= catlist(2L,GC_PUSHS(t),GC_PUSHS(*txt));
		if (*t=='e'||*t=='E') *txt= catlist(2L,GC_PUSHS("1.0"),GC_PUSHS(*txt));
		t= GC_EPOPS(get_number(txt));   /*  -- Has side effect of setting 
				       'lastType' to
					CODEinteger or CODEreal! */
		isnumberflag= lasttype;
/*  # # @V.47.6 - we might move this code into the actual FSMs which
use the tokens such as FSM18, FSM19, FSM14 etc and add the
'deathWish[5]' code. */
/*  # # @V.47.6	If GDW!pType(lastType)=CODEinteger And
# # # @V.47.6	   Not CHK!32BIT!INTEGER(t)
# # # @V.47.6		Then ERR!WARNING(t) */
GC_EPOPS(dbug(02000L,catlist(5L,GC_PUSHS("[GET!TOKEN].1 <number> lastType=\'"),
        cvtypes(lasttype),GC_PUSHS("\' t=\'"),GC_PUSHS(t),
        GC_PUSHS("\'"))));
		}/* get the <number> */
	

else 	{/* test if expand macro */
GC_EPOPS(dbug(02000L,catlist(9L,GC_PUSHS("[GET!TOKEN].1.1 <tst-XPND> t=\'"),GC_PUSHS(t),
        GC_PUSHS("\' txt=\'"),GC_PUSHS(*txt),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" lastType=\'"),cvtypes(lasttype),
        GC_PUSHS("\'"))));
	while ((brk=='\0') &&(*t!='\0') &&
/*   # # @V.52.15	(Not isMacroFlag) And   */
	   (!iscopy_toflag) &&(!nomacflag) &&
	   (i= (*aChkI(dwptr,1L,hash_c(GC_PUSHS(t))))) &&((*aChkI(decldw,1L,i))&01000L))
		{/* Expand SAIL fragment */
/*  # # DBUG('20,"[GET!TOKEN].2 t='"&t&"' brk='"&(s1_brk)&"' i="&CVS(i)&"' h='"&CVS(h)&"'"&CRLF&" txt='"&txt&"'") */
		sbody= GC_EPOPS(expand_macro(GC_PUSHS(*txt),i));    /*  -- SAIL MACRO FRAGMENT */
/*  # # DBUG('20,"[GET!TOKEN].3 sBody='"&sBody&CRLF&"' txt='"&txt&"'") */
		t= GC_EPOPS(scan(&sbody,29L,&brk));  	   /*  -- Scan Expanded string */
		if (*t=='\0') t= GC_EPOPS(makstr(LOP(*txt)));	/*  -- get break char */
		if ((*t!='\0') &&
	(isdigit((INTEGER)*t) ||(*t=='.'&&isdigit((INTEGER)*(*txt))) ||
	  (*t=='e'||*t=='E') &&(!iscopy_toflag) &&
	  notdeclarationflag &&
	  (  ((lt= length(GC_PUSHS(t)))==1&&
		((chn= LOP(s2= *txt))=='+'||chn=='-') &&
		isdigit((INTEGER)*s2)) ||
	     (lt>1&&chk_integer(subst(GC_PUSHS(t),2L,length(t))))
	  ) &&((ht= hash_c(GC_PUSHS(t)))==0)
	))
		{/* get the <number> */
		if (brk!='\0') t= catlist(2L,GC_PUSHS(t),makstr(brk));     /*  -- put back together
						before scan number */
		*txt= catlist(2L,GC_PUSHS(t),GC_PUSHS(*txt));
		if (*t=='e'||*t=='E') *txt= catlist(2L,GC_PUSHS("1.0"),GC_PUSHS(*txt));
		t= GC_EPOPS(get_number(txt));   /*  -- Has side effect of setting 
				       'lastType' to
					CODEinteger or CODEreal! */
		isnumberflag= lasttype;
/*  # # @V.47.6 - we might move this code into the actual FSMs which
use the tokens such as FSM18, FSM19, FSM14 etc and add the
'deathWish[5]' code. */
/*  # # @V.47.6	If GDW!pType(lastType)=CODEinteger And
# # # @V.47.6	   Not CHK!32BIT!INTEGER(t)
# # # @V.47.6		Then ERR!WARNING(t) */
GC_EPOPS(dbug(02000L,catlist(5L,GC_PUSHS("[GET!TOKEN].1 <number> lastType=\'"),
        cvtypes(lasttype),GC_PUSHS("\' t=\'"),GC_PUSHS(t),
        GC_PUSHS("\'"))));
		}/* get the <number> */
			/*  -- scan number (w/NULL-stmnt) */
		*txt= sbody;		/*  -- Put rest in input string */
		}/* Expand SAIL fragment */
	}/* test if expand macro */

GC_EPOPS(dbug(020L,catlist(16L,GC_PUSHS("[GET!TOKEN].4 t=\'"),GC_PUSHS(t),
        GC_PUSHS("\' brk=\'"),GC_PUSHS(s1= GC_EPOPS(makstr(brk))),
        GC_PUSHS("\'=0"),cvos(brk),GC_PUSHS(" isNumberFlag=\'"),
        makstr(isnumberflag),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" txt=\'"),GC_PUSHS(*txt),GC_PUSHS("\' |t|="),
        cvs(length(GC_PUSHS(t))),GC_PUSHS(" |txt|="),
        cvs(length(GC_PUSHS(*txt))))));

lasttype= oldtype;
nomacflag= 0L;
;
GC_SRETURN(t)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'hs'=<L0> integer                             */
/* 'cs'=<L0> integer                             */
/* 'tclass'=<L0> integer                         */
/* 'h'=<L0> integer                              */
/* 'ch'=<L0> integer                             */
/* 'token'=<L0> string                           */
/*************************************************/

}/* GET!TOKEN */
