/* FILE: getid.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pslex.c, being converted 12/25/87, 08:38:10PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING getid(txt,brk)
	STRING *txt;
	INTEGER *brk;
/*  ------------------------------------------------------- */
{/* GETID */
/*  --
.LABEL [<++PSAIL PROCEDURE: GETID>]
.INDEX ++PSAIL PROCEDURE: GETID
DESCRIPTION:
	Scan for and return an alphanumeric identifier in 'txt'.
Since '!' were previously (using CVEVALQUOTE) mapped to '_' and '_'
mapped to ':=", then pass through all '_' characters as alphanumeric.
Leave the break character in 'brk'.

@V.41.07 added mapping of MACRO 'FRAGMENT' type symbols.
@V.51.122 trash preceeding COMMENT...<SC> and WS and then get id.

SIDE-EFFECTS:
@V.56.163 NOTE: accessing the <id> clears the DW!forwardRef bit in
its declDW[] word IFF it is (NOT DW!procedure). If we did not test
for the latter than we could not use Forward procedure declarations
prior to their declaration without trying to redefine them.

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: GETID>]
 */
STRING t, 
	s1, 
	token, 
	sbody;
INTEGER ch, 
	h, 
	idx, 
	oldtype, 
	cs, 
	hs, 
	lt, 
	dw;

/* #define tst_number (t neq null) and\
	(isdigit(t) or (t="." and isdigit(txt)) or\
	    (t="e" or t="E") and \
	    (  ((lt:=length(t))=1 and (brk="+" or brk="-") and\
		isdigit(txt)) or\
	      (lt>1 and chk_integer(t[2 to inf]))\
	    ) and (hash_c(t) neq 0) \
	)\
		then\
		begin "get the <number>"\
		if brk neq null\
			then t:=t & brk;   _2 -- put back together before \
						scan number;\
		if txt=null\
			then txt:=t\
		else txt:=t & txt;\
		if t="e" or t="E"\
			then txt:="1.0" & txt;\
		t:=get_number(txt);   _2 -- has side effect of setting \
				       0lasttype0 to\
					codeinteger or codereal_;\
_2 _2 _2 Ev.49.93 	brk:=lop(txt);		_2 -- Ev.49.59 why?????? ;\
	 	brk:=lop(txt);	_2 -- Ev.50.14 need a _break character\
				  since we pushed it back before;\
		isnumberflag:=lasttype;\
_2 _2 _2 Ev.47.6 - we should move _this code into the actual fsms which\
use the tokens such as fsm18, fsm19, fsm14 etc and add the\
0deathwish[5]0 code.;\
_2 _2 _2 Ev.47.6	if gdw_ptype(lasttype)=codeinteger and\
_2 _2 _2 Ev.47.6	   not chk_32bit_integer(t)\
_2 _2 _2 Ev.47.6		then err_warning(t);\
dbug(02000,"[GETID].1 <number> lastType='"&cvtypes(lasttype)&"' t='"&t&"'");\
		end "get the <number>"\
	 ====> PSAIL!EVAL */

;

GC_EPOPS(dbug(02000L,catlist(3L,GC_PUSHS("[GETID] txt=\'"),GC_PUSHS(*txt),GC_PUSHS("\'"))));
/* NO-OP */;

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(txt); /* for G.C. */
GC_NOTESTRING(t); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(token); /* for G.C. */
GC_NOTESTRING(sbody); /* for G.C. */
t= GC_EPOPS(scan(txt,17L,brk));	   /*  -- @V.38.09 SPEEDUP. Do NOT break on '_' */
if (*brk=='.'&&(isdigit((INTEGER)*t) ||isdigit((INTEGER)*(*txt))))
	{/* a number */
	t= ((*t!='\0') ? catlist(2L,GC_PUSHS(t),makstr(*brk)): *brk);
	*brk= (INTEGER)'\0';
	}/* a number */
/*  # # DBUG('2000,"[GETID].0.1 t='"&t&"' brk='"&(s1_brk)&"' LENGTH(t)="&CVS(length(t))) */

sbody= PNULL;
oldtype= lasttype;
isnumberflag= 0L;

if ((*t!='\0') &&
	(isdigit((INTEGER)*t) ||(*t=='.'&&isdigit((INTEGER)*(*txt))) ||
	    (*t=='e'||*t=='E') &&
	    (  ((lt= length(GC_PUSHS(t)))==1&&(*brk=='+'||*brk=='-') &&
		isdigit((INTEGER)*(*txt))) ||
	      (lt>1&&chk_integer(subst(GC_PUSHS(t),2L,length(t))))
	    ) &&(hash_c(GC_PUSHS(t))!=0) 
	))
		{/* get the <number> */
		if (*brk!='\0') t= catlist(2L,GC_PUSHS(t),makstr(*brk));   /*  -- put back together before 
						scan number */
		if (*(*txt)=='\0') *txt= t; 
		else *txt= catlist(2L,GC_PUSHS(t),GC_PUSHS(*txt));
		if (*t=='e'||*t=='E') *txt= catlist(2L,GC_PUSHS("1.0"),GC_PUSHS(*txt));
		t= GC_EPOPS(get_number(txt));   /*  -- Has side effect of setting 
				       'lastType' to
					CODEinteger or CODEreal! */
/*  # # @V.49.93 	brk_LOP(txt) */		/*  -- @V.49.59 WHY??????  */
	 	*brk= LOP(*txt);	/*  -- @V.50.14 need a break character
				  since we pushed it back before */
		isnumberflag= lasttype;
/*  # # @V.47.6 - we should move this code into the actual FSMs which
use the tokens such as FSM18, FSM19, FSM14 etc and add the
'deathWish[5]' code. */
/*  # # @V.47.6	If GDW!pType(lastType)=CODEinteger And
# # # @V.47.6	   Not CHK!32BIT!INTEGER(t)
# # # @V.47.6		Then ERR!WARNING(t) */
GC_EPOPS(dbug(02000L,catlist(5L,GC_PUSHS("[GETID].1 <number> lastType=\'"),
        cvtypes(lasttype),GC_PUSHS("\' t=\'"),GC_PUSHS(t),
        GC_PUSHS("\'"))));
		}/* get the <number> */
	

else	{/* not a number */
	h= hash_c(GC_PUSHS(t));		/*  -- use for several tests */
	while (h==hcomment)
		{/* Eat up preceeding comment */
		t= GC_EPOPS(scan(txt,10L,brk));	/*  -- Eat up the COMMENT ...<SC> */
		while ((*(*txt)!='\0') &&iswhitespace((INTEGER)*(*txt))) ps_itrash_= LOP(*txt);
		t= GC_EPOPS(scan(txt,17L,brk));	/*  -- now get it for real! */
		h= hash_c(GC_PUSHS(t));		/*  -- also need new hash code */
/*  # # DBUG('2000,"[GETID].1.1 COMMENT t='"&t&"'"&CRLF&" txt='"&txt&"'"&CRLF&"  lastType='"&CVTYPES(lastType)&"'") */
		}/* Eat up preceeding comment */
	/*  -- test if expand macro */
/*  # # DBUG('2000,"[GETID].1.2 <tst-XPND> lastType='"&CVTYPES(lastType)&"' t='"&t&"'") */
	while ((*t!='\0') &&
/*   # # @V.52.15 	(Not isMacroFlag) And  */
	   (!iscopy_toflag) &&(!nomacflag) &&
	   (idx= (*aChkI(dwptr,1L,h))) &&(dw= (*aChkI(decldw,1L,idx)))) if (!(dw&01000L))
			{/* check if clear forward Ref */
/*  @V.56.168 NOTE: clear everything except forward procedures! */
			if ((dw&0100000L)==0) (*aChkI(decldw,1L,idx))= (dw&0777775777777L);
GC_EPOPS(dbug(02000L,catlist(7L,GC_PUSHS("[GETID].1.3 t=\'"),GC_PUSHS(t),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" declDW[idx]=\'"),
        cvtypes((*aChkI(decldw,1L,idx))),GC_PUSHS("\'"))));
			break;	/*  -- don't want to be in loop */
			}/* check if clear forward Ref */
		else
		{/* Expand SAIL fragment */
		(*aChkI(decldw,1L,idx))= dw&0777775777777L;
GC_EPOPS(dbug(02000L,catlist(7L,GC_PUSHS("[GETID].1.4 t=\'"),GC_PUSHS(t),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" declDW[idx]=\'"),
        cvtypes((*aChkI(decldw,1L,idx))),GC_PUSHS("\'"))));
		if (*brk!='\0')
			{/* push break back */
			if (*(*txt)=='\0') *txt= GC_EPOPS(makstr(*brk
			)); else *txt= catlist(2L,makstr(*brk),GC_PUSHS(*txt));  /*  -- push break char back */
			}/* push break back */
/*  # # DBUG('20,"[GETID].2 t='"&t&"' brk='"&(s1_brk)&"' i="&CVS(i)&"' h='"&CVS(h)&"'"&CRLF&" txt='"&txt&"'") */
		sbody= GC_EPOPS(expand_macro(GC_PUSHS(*txt),idx));   /*  -- SAIL MACRO FRAGMENT */
/*  # # DBUG('20,"[GETID].3 sBody='"&sBody&CRLF&"' txt='"&txt&"'") */
		t= GC_EPOPS(scan(&sbody,17L,brk));	   /*  -- Scan Expanded string */
		h= hash_c(GC_PUSHS(t));		/*  -- also need new hash code */
		if ((*t!='\0') &&
	(isdigit((INTEGER)*t) ||(*t=='.'&&isdigit((INTEGER)*(*txt))) ||
	    (*t=='e'||*t=='E') &&
	    (  ((lt= length(GC_PUSHS(t)))==1&&(*brk=='+'||*brk=='-') &&
		isdigit((INTEGER)*(*txt))) ||
	      (lt>1&&chk_integer(subst(GC_PUSHS(t),2L,length(t))))
	    ) &&(hash_c(GC_PUSHS(t))!=0) 
	))
		{/* get the <number> */
		if (*brk!='\0') t= catlist(2L,GC_PUSHS(t),makstr(*brk));   /*  -- put back together before 
						scan number */
		if (*(*txt)=='\0') *txt= t; 
		else *txt= catlist(2L,GC_PUSHS(t),GC_PUSHS(*txt));
		if (*t=='e'||*t=='E') *txt= catlist(2L,GC_PUSHS("1.0"),GC_PUSHS(*txt));
		t= GC_EPOPS(get_number(txt));   /*  -- Has side effect of setting 
				       'lastType' to
					CODEinteger or CODEreal! */
/*  # # @V.49.93 	brk_LOP(txt) */		/*  -- @V.49.59 WHY??????  */
	 	*brk= LOP(*txt);	/*  -- @V.50.14 need a break character
				  since we pushed it back before */
		isnumberflag= lasttype;
/*  # # @V.47.6 - we should move this code into the actual FSMs which
use the tokens such as FSM18, FSM19, FSM14 etc and add the
'deathWish[5]' code. */
/*  # # @V.47.6	If GDW!pType(lastType)=CODEinteger And
# # # @V.47.6	   Not CHK!32BIT!INTEGER(t)
# # # @V.47.6		Then ERR!WARNING(t) */
GC_EPOPS(dbug(02000L,catlist(5L,GC_PUSHS("[GETID].1 <number> lastType=\'"),
        cvtypes(lasttype),GC_PUSHS("\' t=\'"),GC_PUSHS(t),
        GC_PUSHS("\'"))));
		}/* get the <number> */
				/*  -- scan number */
		*txt= sbody;		/*  -- Put rest in input string */
		}/* Expand SAIL fragment */
	}/* not a number */

GC_EPOPS(dbug(020L,catlist(16L,GC_PUSHS("[GETID].4 t=\'"),GC_PUSHS(t),GC_PUSHS(
        "\' brk=\'"),GC_PUSHS(s1= GC_EPOPS(makstr(*brk))),
        GC_PUSHS("=0"),cvos(*brk),GC_PUSHS("\' isNumberFlag=\'"),
        makstr(isnumberflag),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" txt=\'"),GC_PUSHS(*txt),GC_PUSHS("\' |t|="),
        cvs(length(GC_PUSHS(t))),GC_PUSHS(" |txt|="),
        cvs(length(GC_PUSHS(*txt))))));

lasttype= oldtype;
nomacflag= 0L;
;
GC_SRETURN(t)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'hs'=<L0> integer                             */
/* 'cs'=<L0> integer                             */
/* 'ch'=<L0> integer                             */
/* 'token'=<L0> string                           */
/*************************************************/

}/* GETID */
