/* FILE: infix_to_prefix.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pscvt.c, being converted 12/25/87, 03:15:56PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------ */
 /*INTERNAL*/ STRING infix_to_prefix(ltype,op,prefix,dotypechk)
	INTEGER ltype;
	STRING op;
	STRING prefix;
	INTEGER dotypechk;
/*  ------------------------------------------------------ */
{/* INFIX!TO!PREFIX */
/*  --
.LABEL [<++PSAIL PROCEDURE: INFIX!TO!PREFIX>]
.INDEX ++PSAIL PROCEDURE: INFIX!TO!PREFIX
DESCRIPTION:
	Convert infix expression of the form
		 'a OP b' 
to prefix expression
		'OP(@a,@b)' 
form as follows:
	where: 	'a' is positioned at end of 'cStatement',
		'OP' is in saiToken and is passed as an arg,
		'b' is the next input in 'saiStatement'
		'@' is the prefix supplied if non-null.,
		type checking and coercion is done if
			the doTypeChk flag is set as follows:
			----	---------
			0	No type check done,
			+1	coerce arg2 to lastType,
			-1	If arg2 Not then WARNING,

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: INFIX!TO!PREFIX>]
 */
STRING a, 
	b, 
	s, 
	s1, 
	ws;
INTEGER trash, 
	rtype;

;

GC_EPOPS(dbug(04000L,catlist(23L,GC_PUSHS("[INFIX!TO!PREFIX] op=\'"),GC_PUSHS(op),
        GC_PUSHS("\' prefix=\'"),GC_PUSHS(prefix),
        GC_PUSHS("\' doTypeChk="),cvs(dotypechk),GC_PUSHS(crlf),
        GC_PUSHS("  lType=\'"),cvtypes(ltype),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS("  lastType=\'"),cvtypes(lasttype),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  cStatement=\'"),
        GC_PUSHS(cstatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  saiStatement=\'"),GC_PUSHS(saistatement),
        GC_PUSHS("\'  |saiStatement|="),
        cvs(length(GC_PUSHS(saistatement))))));

/*  ------------------------------------------------------------------- */
/*  --	[1] Scan to the RIGHT saiStatement to get next expression 'b' */
/*  ------------------------------------------------------------------- */
	GC_POPS(prefix); /* from GC string PDL */
	GC_POPS(op); /* from GC string PDL */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(op); /* for G.C. */
	GC_NOTESTRING(prefix); /* for G.C. */
	GC_NOTESTRING(a); /* for G.C. */
	GC_NOTESTRING(b); /* for G.C. */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(ws); /* for G.C. */
	ws= PNULL;
	map_whitespace(&ws);
	b= GC_EPOPS(rightexpr(&saistatement));
	map_whitespace(&b);	/*  -- get the rest of it if any */
/*  # # DBUG('4000,"[INFIX!TO!PREFIX].1 b='"&b&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
	pushnumber(lasttype); pushnumber(ltype); pushnumber(dotypechk);
	push(GC_PUSHS(op)); push(GC_PUSHS(prefix));
	b= GC_EPOPS(r_d_expr_map(GC_PUSHS(b))); 	/*  -- Eval it */
	pop(&prefix); pop(&op); popnumber(&dotypechk); popnumber(&ltype);
	rtype= lasttype;
	popnumber(&lasttype);
/*  # # DBUG('4000,"[INFIX!TO!PREFIX].2 rType='"&rType&"' b='"&b&"'") */

	if ((dotypechk>0) ||
	   ((((ps_itrash_= (rtype&037))>0) ? (ps_itrash_+0140L)
				:0L)==codeinteger&&chk_integer(GC_PUSHS(b)))
/*   # # @V.54.01		And (rType Neq lType)  */) b= GC_EPOPS(cvactual_to_expected(ltype,rtype,GC_PUSHS(b)));
/*  # # DBUG('4000,"[INFIX!TO!PREFIX].2.1 b='"&b&"'") */


/*  ------------------------------------------------------------------- */
/*  --	[2] Scan cStatement backwards (i.e. to LEFT) to pickup
# --	previous expression 'a'. */
/*  ------------------------------------------------------------------- */
	a= GC_EPOPS(left_expr(&cstatement,1L));   /*  -- scan left for expression
					    and skip left comments */
	if (*a=='('&&*saistatement==')' &&
	   (length(GC_PUSHS(a))>1) &&((*(a+length(a)-1))!=')'))
		{/* expunge extra '( )' pair */
		trash= LOP(a);	/*  -- trash extra '(' */
		trash= LOP(saistatement);	/*  -- trash extra ')' */
		}/* expunge extra '( )' pair */
/*  # # DBUG('4000,"[INFIX!TO!PREFIX].3 a='"&a&"' cStatement='"&cStatement&"'") */
	if (*a==('\''/*WARNING*/)&&(*(a+length(a)-1))==('\''/*WARNING*/) &&
	   (((ps_itrash_= (ltype&037))>0) ? (ps_itrash_+0140L)
				:0L)==codestring)
		{/* change <lValue> back to quoted string */
/*  # # DBUG('4000,"[INFIX!TO!PREFIX].3.1 a='"&a&"'") */
		a= catlist(3L,GC_PUSHS(quote),subst(GC_PUSHS(a),2L,length(a)-1L),
        GC_PUSHS(quote));
		}/* change <lValue> back to quoted string */

/*  # # DBUG('4000,"[INFIX!TO!PREFIX].4 a='"&a&"' b='"&b&"' doTypeChk="&CVS(doTypeChk)&CRLF&" lType="&CVTYPES(lType)&CRLF&" rType="&CVTYPES(rType)) */
 	if ((dotypechk<0) &&(ltype!=rtype)) err_warning(&b); 
 	else if ((dotypechk>0) ||
		((((ps_itrash_= (ltype&037))>0) ? (ps_itrash_+0140L)
				:0L)==codeinteger&&chk_integer(GC_PUSHS(a)))
/*   # # @V.54.01		And (lastType Neq lType)  */) 
		{/* change back */
		a= GC_EPOPS(cvactual_to_expected(ltype,lasttype,GC_PUSHS(a)));
		lasttype= ltype;
		}/* change back */
/*  # # DBUG('4000,"[INFIX!TO!PREFIX].4.1 a='"&a&"' b='"&b&"'") */


/*  --------------------------- */
/*  --	[3] Construct string */
/*  --------------------------- */
s= catlist(2L,GC_PUSHS(op),GC_PUSHS("("));
if (*prefix!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(prefix));
s= catlist(3L,GC_PUSHS(s),GC_PUSHS(a),GC_PUSHS(","));
/*  # # @V.49.59 If ws Neq NULL
	Then s_s & ws */
if (*prefix!='\0') b= catlist(2L,GC_PUSHS(prefix),GC_PUSHS(b));
insert_before_white(&s,catlist(2L,GC_PUSHS(b),GC_PUSHS(")")));
GC_EPOPS(dbug(04000L,catlist(7L,GC_PUSHS("[INFIX!TO!PREFIX].5 s=\'"),GC_PUSHS(s),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" lastType=\'"),
        cvtypes(lasttype),GC_PUSHS("\'"))));
/* NO-OP */;

;
GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 's1'=<L0> string                              */
/*************************************************/

}/* INFIX!TO!PREFIX */
