/* FILE: insert_before_white.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pscvt.c, being converted 12/25/87, 03:15:56PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------ */
 /*INTERNAL*/ void insert_before_white(sold,si)
	STRING *sold;
	STRING si;
/*  ------------------------------------------------------ */
{/* INSERT!BEFORE!WHITE */
/*  --
.LABEL [<++PSAIL PROCEDURE: INSERT!BEFORE!WHITE>]
.INDEX ++PSAIL PROCEDURE: INSERT!BEFORE!WHITE
DESCRIPTION:
	Insert string 's' to the LEFT of the 'rightmost' white space in
Reference string 'sOld'.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: INSERT!BEFORE!WHITE>]
 */
STRING s, 
	s1, 
	s2;
INTEGER i, 
	j, 
	ch;

;

GC_EPOPS(dbug(0100000L,catlist(3L,GC_PUSHS("[INSERT!BEFORE!WHITE] si=\'"),GC_PUSHS(si),
        GC_PUSHS("\'"))));

GC_POPS(si); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(sold); /* for G.C. */
GC_NOTESTRING(si); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */

if (*(*sold)=='\0')
  *sold= si; 
else	{/* insert into existing string */
	j= 0;
	for (i=length(GC_PUSHS(*sold));i<=1;i--)
	  if ((ch= (*(*sold+i-1))) &&(!iswhitespace(ch)))
	    {/* found non-white space */
	      j= i;
	      break;
	    }/* found non-white space */
	if ((j>0))
	  *sold= catlist(3L,subst(GC_PUSHS(*sold),1L,j),GC_PUSHS(si),
			 subst(GC_PUSHS(*sold),j+1L,length(*sold))); 
	else *sold= catlist(2L,GC_PUSHS(si),GC_PUSHS(*sold));
	}/* insert into existing string */

/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 's2'=<L0> string                              */
/* 's1'=<L0> string                              */
/* 's'=<L0> string                               */
/*************************************************/

{GC_UNMARKSSTKFRAME;}
}/* INSERT!BEFORE!WHITE */
