/* FILE: issaideclar.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    April 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pschek.c, being converted 12/25/87, 02:41:52PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  --------------------------------------------------- */
/*INTERNAL*/  INTEGER issaideclar(x)
	STRING x;
/*  --------------------------------------------------- */
{/* ISSAIDECLAR */
/*  --
.LABEL [<++PSAIL PROCEDURE: ISSAIDECLAR>]
.INDEX ++PSAIL PROCEDURE: ISSAIDECLAR
DESCRIPTION:
	Test token x if is a SAIL declaration key word. By
definition, all declaration key words have a non-zero FSM and a
non-zero primitive data type.

SIDE-EFFECTS:
	It uses hash-integers hXXXXX which are set up in procedure
BUILD!TABLES. If we modify the symbol table (eg PSAIL!DEFINE etc)
these will NOT be updated. So we could have trouble if extensively
modifying the sublanguages.

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: ISSAIDECLAR>]
 */
INTEGER flag, 
	j, 
	fsmn, 
	dcode, 
	didx;

;

/*  # # DBUG('2000000,"[ISSAIDECLAR] String x='"&x&"'") */

/* IFC EVAL(not parsemainsail)=0 */
 /* THENC <<<FAILED!!!>>>

flag := (j:=hash_c(x)) and
	   ((fsmn:=declfsm[didx:=dwptr[j]]) land 0777) and
	   (dcode:=gdw_ptype(decldw[didx])) and
           (hinteger=j or hreal=j or hstring=j or
            hboolean=j or (fsmn=41 and dcode=coderecclass) or
            hreference=j or hforward=j or
            hintrnal=j or hexternal=j or
            hitem=j or hleap_array=j or
            hitemvar=j or hlist=j or
            href_item=j or hset=j or
            hprocedure=j or (fsmn=41 and dcode=coderecptr) or
	    (huntyped=j and useextensionsflag));
  */ /* ENDC */


/* IFC EVAL(parsemainsail)=1 */
/* THENC */

GC_POPS(x); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(x); /* for G.C. */
flag = (j= hash_c(GC_PUSHS(x))) &&
	   ((fsmn= (*aChkI(declfsm,1L,didx= (*aChkI(dwptr,1L,j)))))&0777) &&
	   (dcode= (((ps_itrash_= (((*aChkI(decldw,1L,didx)))&037))>0)
                                ? (ps_itrash_+0140L)
				: 0L)) &&
           (hinteger==j||hreal==j ||hstring==j ||
            hboolean==j ||(fsmn==41&&dcode==coderecclass) ||
            hreference==j ||hforward==j ||
            hintrnal==j ||hexternal==j ||
            hitem==j ||hleap_array==j ||
            hitemvar==j ||hlist==j ||
            href_item==j ||hset==j ||
            hprocedure==j ||(fsmn==41&&dcode==coderecptr) ||
            haddress==j ||hbits==j ||hcharadr==j ||
            hclass==j ||hgeneric==j ||
	    (huntyped==j&&useextensionsflag) );
  /* ENDC */

/*  # # DBUG('2000000,"[ISSAIDECLAR].1 String x='"&x&"' flag="&PBOOL(flag)) */

GC_NRETURN(flag)
}/* ISSAIDECLAR */
