/* FILE: left_expr.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pslex.c, being converted 12/25/87, 08:38:10PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING left_expr(si,skipleftcommentsflag)
	STRING *si;
	INTEGER skipleftcommentsflag;
/*  ------------------------------------------------------- */
{/* LEFT!EXPR */
/*  --
.LABEL [<++PSAIL PROCEDURE: LEFT!EXPR>]
.INDEX ++PSAIL PROCEDURE: LEFT!EXPR
DESCRIPTION:
	Scan string sI backwards to pick up an expression and 
	return that expression as well as shortening the string 
	in REFERENCE variable sI.
	NOTE: a) pass over C style comments '/ * ... * /' if
		 the 'skipLeftCommentsFlag' is TRUE, otherwise done.
	NOTE: b) if an <expr> is '*<expr>' or '&<expr>' then include
		the '*' or '&'.
	NOTE: c) that the break character will be the LAST char in sI.
	NOTE: d) Handle unary minus (-) as well as negations ~ or !)
		by including it. If the '-' is part of an expression
		then get the rest of the expression.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: LEFT!EXPR>]
 */
INTEGER i, 
	j, 
	k, 
	parencnt, 
	ch, 
	ch1, 
	lastch, 
	brktcnt, 
	lch, 
	rch,
	keeppointerflag;
INTEGER havetoken;
STRING a, 
	s, 
	s1, 
	s2;

;

GC_EPOPS(dbug(04000L,catlist(4L,GC_PUSHS("[LEFT!EXPR] sI=\'"),GC_PUSHS(*si),
        GC_PUSHS("\' |sI|="),cvs(length(GC_PUSHS(*si))))));
/* NO-OP */;

/*  --	[1] Scan sI backwards (i.e. to LEFT) to pickup previous 
	    expression 'a'.
	Scan break table b4 but if quote then backup to 2nd quote */

	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(si); /* for G.C. */
	GC_NOTESTRING(a); /* for G.C. */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(s1); /* for G.C. */
	GC_NOTESTRING(s2); /* for G.C. */
	if ((*(*si)=='\0'))
		{/* Something funny, return NULL */
		err_hlr(GC_PUSHS(
catlist(3L,
        GC_PUSHS("[LEFT!EXPR] missing <left-expr>, <left-stmnt>=\'"),
        GC_PUSHS(*si),GC_PUSHS("\'"))));
;
		{GC_UNMARKSSTKFRAME;
		 GC_SRETURN("/*L.NULL*/");}
		}/* Something funny, return NULL */

	brktcnt= 0;
	ch= (INTEGER)'\0';
	havetoken= 0L;
	keeppointerflag= 0L;
	parencnt= 0;
	{/* TRASH!RIGHT!WS */
			while ((*(*si)!='\0') &&
			      (ps_itrash_= (*(*si+length(*si)-1))) &&
			      iswhitespace(ps_itrash_)) 
						*si= subst(GC_PUSHS(*si),1L,length(*si)-1L);
			}/* TRASH!RIGHT!WS */
	i= length(GC_PUSHS(*si));
	for (k=i;k<=1;k--)
		{/* Scan left for OPRND */
		lastch= ch;
		ch= (*(*si+k-1));
		if (ch=='/'&&skipleftcommentsflag &&
		   (k>3) &&((*(*si+k-1L-1))=='*'))
			{/* skip past C-style Comment */
			for (j=k-2L;j<=2;j--)
				if ((*(*si+j-1))=='*'&&
				   (*(*si+j-1L-1))=='/')
					{/* found it */
					k= j-1L;   /*  -- adjust ptr */
/*  # # DBUG('4000,"[LEFT!EXPR].0.1 k="&CVS(k)&" sI[1:k]='"&sI[1 to k]&"'"&CRLF&"   sI[k+1:inf]='"&sI[k+1 to inf]&"'") */
					goto PS0001 /* Scan left for OPRND */;
					}/* found it */
				err_hlr(GC_PUSHS(
   catlist(3L,
           GC_PUSHS("[LEFT!EXPR] DRYROT! missing C comment terminator \'/*\' in cStatement,\15\12\
	cStatement=\'"
           /*N.P.*/),GC_PUSHS(cstatement),GC_PUSHS("\'"))));
			}/* skip past C-style Comment */

		else if (ch==*singlequote)
			{/* check single quote */
			k= MAX((k-1L),1L);	  /*  -- skip past quoted char */
			/*  --  Handle special case of '\''	 */
			while ((k>0) &&
			       (((ch= (*(*si+k-1)))!=('\''/*WARNING*/)) ||
				(ch==('\''/*WARNING*/)&&
				 (k==1||
				  (k>1&&(*(*si+k-1L-1))==('\\'/*WARNING*/)))))) --k;
/*  # # DBUG('4000,"[LEFT!EXPR].0.2 k="&CVS(k)&" sI[1:k]='"&sI[1 to k]&"'"&CRLF&"  sI[k+1:inf]='"&sI[k+1 to inf]&"'") */
			}/* check single quote */

		else if (ch==*quote) 
			{/* check quotes */
			/*  -- Handle special case of "\""    */
			k= MAX((k-1L),1L);
			while ((k>0))
				{/* process */
				ch= (*(*si+k-1));
				--k;
				if (ch!=*quote) continue; 
				else if ((lch= (*(*si+k-1)))==('\\'/*WARNING*/))
					{/* special case */
					--k;
					ch= lch;	  /*  -- change last char */
					}/* special case */
				else break;
				}/* process */
/*  # # DBUG('4000,"[LEFT!EXPR].0.3 k="&CVS(k)&" sI[1:k]='"&sI[1 to k]&"'"&CRLF&"  sI[k+1:inf]='"&sI[k+1 to inf]&"'") */
			}/* check quotes */

		else {/* Test characters not in quoted string */
		if (ch=='.') 
			{/* Part of decimal number */
			}/* Part of decimal number */

		else if (ch==')') 
			{/* count up */
			++parencnt;
			havetoken= 0L;
			}/* count up */

		else if (ch==']') 
			{/* count up */
			++brktcnt;
			havetoken= 0L;
			}/* count up */

		else if (ch=='[') 
			{/* count down */
			--brktcnt;
			havetoken= 0L;
			}/* count down */

		else if (ch=='(') 
			{/* count down */
			--parencnt;
			if (parencnt<0) 
			    {/* dangling left '(' */
			    ++k; 	/*  -- Do not include it! */
			    break;   /*  -- @V.45.185 dangling left '(' */
			    }/* dangling left '(' */
			if ((parencnt==0) &&
			   ((rch= (*(*si+k-1L-1)))!=0) &&
			   ((isvariable(rch) ||
				((rch=='=') &&
				 ((lch= (*(*si+(k-2L)-1)))!='=') &&
				  (lch!='>') &&(lch!='!') &&
				  (lch!='<')
				 )
				)
			    )) havetoken= 0L; /*not yet, suck 
				fct name or part of relation*/
			}/* count down */

		else if ((parencnt==0) &&(ch=='=') &&
			((lch= (*(*si+k-1L-1)))!='=') &&
			(lch!='<') &&(lch!='>') &&
			(lch!='!')) 
			{/* Assignment */
			havetoken= 1L;
			}/* Assignment */

		else if ((parencnt==0) &&
			(havetoken==0L&&
			 	 ((*((s2= subsr(GC_PUSHS(*si),k,5L)))=='w'&&
				   equ(GC_PUSHS(s2),GC_PUSHS("while")) &&
				    !isvariable((*(*si+k-1L-1)))) ||
				  (*((s2= subsr(GC_PUSHS(*si),k-4L,4L)))=='e'&&
				   equ(GC_PUSHS(s2),GC_PUSHS("else")) &&
				    !isvariable((*(*si+k-5L-1))))
				 ) 
			)) havetoken= 

		1L; else if (!(isvariable(ch) ||iswhitespace(ch) ||
			     (ch=='!') ||(ch=='~') ||(ch=='-'))) 
			{/* test if done */
/*  # # DBUG('4000,"[LEFT!EXPR].1 ch='"&(ps!sTrash!_ch)&"' k="&CVS(k)&" sI='"&sI&"'"&CRLF&" sI[1 to k]='"&sI[1 to k]&"' sI[k+1 to Inf]='"&sI[k+1 to Inf]&"'") */
			if ((ch=='*'||ch=='&') &&
			   (k==1||((ch1= (*(*si+k-1L-1)))=='('||
					ch1==',' ||ch1=='=')))
				{/* yes is *<id> */
				k= (MAX((k-1L),1L));
				keeppointerflag= 1L;
				}/* yes is *<id> */
			havetoken= 1L;   /*  -- @V.29.17 tested "_"  */
			}/* test if done */
		}/* Test characters not in quoted string */

/*  # # @V.24.06	WE MAY HAVE A PROBLEM HERE. CHECK IF WE NEED THE SAME
	NON-TERMINATION CONDITIONS AS IN RIGHTEXPR FOR RELATIONS 
	AND _  */

/*  # # DBUG('4000,"[LEFT!EXPR].2 ch='"&(ps!sTrash!_ch)&"' k="&CVS(k)&" pCnt="&CVS(parenCnt)&" haveTok="&PBOOL(haveToken)) */
		if ((parencnt==0) &&(brktcnt==0) &&
		    havetoken &&(!isvariable(ch))) break;  /*  -- @29.17 also tested (ch Neq "_") */
		PS0001: ;}/* Scan left for OPRND */

	ch= (*(*si+k-1));
	if ((ch!='\0') &&(((ch!=*quote) &&(ch!='(') &&
	    (ch!=*singlequote) &&
	    ((*aChkI(decldw,1L,(*aChkI(dwptr,1L,hash_c(makstr(ch))))))&0100L) &&
		!keeppointerflag) ||
	   (ch=='|'))) 
		{/* Do NOT include operators in 'a' */
		++k;
		}/* Do NOT include operators in 'a' */
	a= subst(GC_PUSHS(*si),k,length(*si));
	*si= subst(GC_PUSHS(*si),1L,k-1L);
	while (iswhitespace((INTEGER)*a)) *si= catlist(2L,GC_PUSHS(*si),GC_PUSHS(LOP(a))); /*keep WS in orig str*/
GC_EPOPS(dbug(04000L,catlist(10L,GC_PUSHS("[LEFT!EXPR].3 a=\'"),GC_PUSHS(a),GC_PUSHS(
        "\' k="),cvs(k),GC_PUSHS(" ch=\'"),
        GC_PUSHS(ps_strash_= GC_EPOPS(makstr(ch))),
        GC_PUSHS("\' sI=\'"),GC_PUSHS(*si),GC_PUSHS("\' parenCnt="),
        cvs(parencnt))));
/* NO-OP */;
if (*a=='\0') err_hlr(GC_PUSHS(
catlist(3L,
        GC_PUSHS("[LEFT!EXPR] missing <left-expr>, <left-stmnt>=\'"),
        GC_PUSHS(*si),GC_PUSHS("\'"))));
;
GC_SRETURN(a)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 's1'=<L0> string                              */
/* 's'=<L0> string                               */
/*************************************************/

}/* LEFT!EXPR */
