/* FILE: left_id.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pslex.c, being converted 12/25/87, 08:38:10PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING left_id(si)
	STRING *si;
/*  ------------------------------------------------------- */
{/* LEFT!ID */
/*  --
.LABEL [<++PSAIL PROCEDURE: LEFT!ID>]
.INDEX ++PSAIL PROCEDURE: LEFT!ID
DESCRIPTION:
	Scan string sI backwards to pick up an identifier and 
	return that expression as well as shortening the string 
	in REFERENCE variable sI.
	NOTE: a) pass over C style comments '/ * ... * /'.
	NOTE: b) Keep '*<id> or '&<id>' intact.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: LEFT!ID>]
 */
INTEGER ch, 
	ch1, 
	i, 
	j, 
	brktcnt, 
	parencnt;
STRING lexpr, 
	lid, 
	oldsi;

;

GC_EPOPS(dbug(04000L,catlist(4L,GC_PUSHS("[LEFT!ID] sI=\'"),GC_PUSHS(*si),
        GC_PUSHS("\' |sI|="),cvs(length(GC_PUSHS(*si))))));
/* NO-OP */;

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(si); /* for G.C. */
GC_NOTESTRING(lexpr); /* for G.C. */
GC_NOTESTRING(lid); /* for G.C. */
GC_NOTESTRING(oldsi); /* for G.C. */
oldsi= *si;		/*  -- copy in case DRYROT error */
lexpr= GC_EPOPS(left_expr(si,1L));	/*  -- and skip left comments */
/*  # # DBUG('4000,"[LEFT!ID].1 lExpr='"&lExpr&"'") */

if ((*lexpr=='\0'))
	{/* DRYROT */
	err_hlr(GC_PUSHS(
catlist(3L,GC_PUSHS("[LEFT!ID] missing <left ident>, <left-stmnt>=\'")
        ,GC_PUSHS(oldsi),GC_PUSHS("\'"))));
	lid= PNULL;
	}/* DRYROT */

else	{/* scan for left ID */
	if (chk_id(GC_PUSHS(lexpr))) i= 
	1L; else	{/* pick up first left ID */
		parencnt= brktcnt= 0;
		for (i=length(GC_PUSHS(lexpr));i<=1;i--)
			{/* find id */
			ch= (*(lexpr+i-1));
			if (ch=='/'&&(i>3) &&((*(lexpr+i-1L-1))=='*'))
				{/* skip past C-style Comment */
/*  # # DBUG('4000,"[LEFT!ID].2 lExpr[1 to i-1]='"&lExpr[1 to i-1]&"' lExpr[i to inf]='"&lExpr[i to inf]&"'") */
				for (j=i-2L;j<=2;j--)
					if ((*(lexpr+j-1))=='*'&&
					   (*(lexpr+j-1L-1))=='/')
						{/* found it */
						i= j-1L;  /*  -- adjust ptr */
/*  # # DBUG('4000,"[LEFT!ID].2.1 i="&CVS(i)&" lExpr[1:i]='"&lExpr[1 to i]&"' lExpr[i+1:inf]='"&lExpr[i+1 to inf]&"'") */
						goto PS0002 /* find id */;
						}/* found it */
					err_hlr(GC_PUSHS(
   catlist(3L,
           GC_PUSHS("[LEFT!ID] DRYROT! missing C comment terminator \'/*\' in cStatement,\15\12\
	cStatement=\'"
           /*N.P.*/),GC_PUSHS(cstatement),GC_PUSHS("\'"))));
				}/* skip past C-style Comment */
			else if (ch==*singlequote&&i>1)
				{/* move past '-' */
				/*  -- Parse 'c', '\c', or '\nnn' */
				for (j=i-1L;j<=1;j--)
				    if ((*(lexpr+j-1))==('\''/*WARNING*/)&&
					(j==1||
					(*(lexpr+j-1L-1))!=('\\'/*WARNING*/)))
					{/* found it */
					i= j; 
					break;
					}/* found it */
/*  # # DBUG('4000,"[LEFT!ID].2.2 i="&CVS(i)&" lExpr[1:i]='"&lExpr[1 to i]&"'"&CRLF&"   lExpr[i+1:inf]='"&lExpr[i+1 to inf]&"'")
				 */}/* move past '-' */

			else if (ch==*quote&&i>1)
				{/* move past quote---quote */
				/*  -- Parse "ccc" or "ccc\"ccc" */
				for (j=i-1L;j<=1;j--)
				    if ((*(lexpr+j-1))==*quote&&
					(j==1||
					(*(lexpr+j-1L-1))!=('\\'/*WARNING*/)))
					{/* found it */
					i= j;
					break;
					}/* found it */
/*  # # DBUG('4000,"[LEFT!ID].2.3 i="&CVS(i)&" lExpr[1:i]='"&lExpr[1 to i]&"'"&CRLF&"   lExpr[i+1:inf]='"&lExpr[i+1 to inf]&"'")
				 */}/* move past quote---quote */

			else if (ch=='(') --parencnt; else if (ch=='[') --brktcnt; else if (ch==')') ++parencnt; else if (ch==']') ++brktcnt; else if (brktcnt==0&&parencnt==0 &&
				(i>1) &&isvariable(ch) &&
				((ch1= (*(lexpr+i-1L-1)))>0) &&
				!isvariable(ch1)) 
				{/* test if done */
				if ((ch1=='*'||ch1=='&') &&(i==2) ||
				   ((ch1= (*(lexpr+i-2L-1)))=='('||
					ch1==',' ||ch1=='=')) --i; 
						/*  -- include '*' / '&' */
				break;
				}/* test if done */
			PS0002: ;}/* find id */
		}/* pick up first left ID */

	lid= subst(GC_PUSHS(lexpr),i,length(lexpr));
/*  # # @V.51.58	If i<1
		Then sI_sI & lExpr[1 to i-1] */
	if (i>1)
		{/* put rest of lExpr back with sI */
		if (*(*si)=='\0') *si= subst(GC_PUSHS(lexpr),1L,i-1L); 
		else *si= catlist(2L,GC_PUSHS(*si),subst(GC_PUSHS(lexpr),1L,i-1L));
		}/* put rest of lExpr back with sI */
	}/* scan for left ID */

GC_EPOPS(dbug(04000L,catlist(10L,GC_PUSHS("[LEFT!ID].3 lID=\'"),GC_PUSHS(lid),
        GC_PUSHS("\' lExpr=\'"),GC_PUSHS(lexpr),GC_PUSHS("\' i="),
        cvs(i),GC_PUSHS(crlf),GC_PUSHS(" sI=\'"),GC_PUSHS(*si),
        GC_PUSHS("\'"))));
/* NO-OP */;
if (*lid=='\0') err_hlr(GC_PUSHS(
catlist(3L,GC_PUSHS("[LEFT!ID] missing <left ident>, <left-stmnt>=\'")
        ,GC_PUSHS(*si),GC_PUSHS("\'"))));

;
GC_SRETURN(lid)
}/* LEFT!ID */
