/* FILE: mak_blk_exit.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psgc.c, being converted 12/25/87, 04:48:55PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ---------------------------------------------------- */
/*INTERNAL*/  STRING mak_blk_exit(fromblklevel,toblklevel,emit_c_statement)
	INTEGER fromblklevel;
	INTEGER toblklevel;
	STRING emit_c_statement;
/*  ---------------------------------------------------- */
{/* MAK!BLK!EXIT */
/*   --
.LABEL [<++PSAIL PROCEDURE: MAK!BLK!EXIT>]
.INDEX ++PSAIL PROCEDURE: MAK!BLK!EXIT
DESCRIPTION:
	Emit any code needed when we exit a block level whether by
RETURN, GOTO, CONTINUE, DONE, NEXT or exiting a block with END. Don't
do it if didBlkExit is set since we have already done it before. It
is the other routine'ss (read that FSM's) responsibility to clear
this flag which is set here when we leave. We ONLY EMIT CODE if
(toBlkLevel is < fromBlkLevel). We may have to emit code for:
	1. /CHECKarray: dynamic arrays using an emitted 
			aryfree(<array-list>,(INTEGER *)0)
	   where <array-list> is the list of all active array pointers
	   in the range fromBlkLevel to toBlkLevel+1.
	2. /PROFILE: profile code. We only emit code to turn off
	   profiling if the statement is a 'return' or 'GC_?RETURN'.
	   If blockLevel > 1 then emit
			PROFIL_OFF("proc-name")
	   otherwise emit, at the end of the program in main(),
			PROFIL_PRINT.
	3. /GCcode: string GC code. If (fromBlkLevel-toBlkLevel)> 1
	   then emit 
			GC_ADJSSTKFRAME(blkLevelDif)
	   otherwise emit
			GC_UNMARKSSTKFRAME.

SIDE-EFFECTS:
	1. If /PROFILE and doing GOTO main() level then will emit bogus
PROFIL_PRINT call. Extra W.S. being emitted.
	2. May have a semantic problem in that CONTINUE should goto a
label just before the END and DONE should goto a lable just after the
END statement (when jumping out of the current block). Soln is to
have two parallel label stacks/block level. Not implemented yet.
		SAIL-code         C-code          Emitted block code
                ---------         ------          ------------------
     ---- Begin <1>
     | L1:
     |  | -- Procedure <2>
     |  ---- Begin <2>         ==> {                (NONE)
     |  | L2:
     |  |  ---- Begin <3>      ==> {                (NONE)
     |  |  | L3:
     |  |  |  ---- Begin <4>   ==> {                (NONE)
     |  |  |  | L4:
     |  |  |  |  Continue <4>  ==> continue         (NONE)
     |  |  |  |  Continue <3>  ==> goto PS0002/B     free <4>
     |  |  |  |  Continue <2>  ==> goto PS0001/B     free <4>,<1>
     |  |  |  |  Done <4>      ==> break             free <4>
     |  |  |  |  Done <3>      ==> goto PS0002/A     free <4>,<3>
     |  |  |  |  Done <2>      ==> goto PS0001/A     free <4>,<3>,<2>
     |  |  |  |  Next <4>      ==> ... continue     (NONE)
     |  |  |  |  Next <3>      ==> ... goto PS0002/B free <4>
     |  |  |  |  Next <2>      ==> ... goto PS0001/B free <4>,<3>
     |  |  |  |  Goto L4       ==> Goto L4          (NONE)
     |  |  |  |  Goto L3       ==> Goto L3           free L4>
     |  |  |  |  Goto L2       ==> Goto L2           free L4>,<3>
     |  |  |  |  Goto L1       ==> Goto L1           free L4>,<3>,<2>
     |  |  |  |  Return        ==> return            free <4>,<3>,<2>
     |  |  |  | PS0003/B:
     |  |  |  ---- End <4>     ==> }                 free <4>
     |  |  | PS0003/A:
     |  |  |  Return           ==> return            free <3>,<2>
     |  |  | PS0002/B:
     |  |  ---- End <3>        ==> }                 free <3>
     |  | PS0002/A:
     |  |  Return              ==> return            free <2>
     |  | PS0001/B:
     |  ---- End <2>           ==> }               ++free <2>
     | PS0001/A:
     ---- End <1>

NOTE: Continue <2>, Done <2> and Next <2> are only allowed if block
level <2> is not a procedure (i.e. in the main()) module.
++NOTE: there is NO code emitted if the previous oldTypeStatement was
a 'return' which did it for us.

PROBLEMS/KNOWN-BUGS:
NOTE: @V.56.45 Prior to creating this procedure the code was
scattered and duplicated (inconsistently) in different FSMs.

.ENDLABEL [<++PSAIL PROCEDURE: MAK!BLK!EXIT>]
 */
STRING s, 
	s1, 
	s2, 
	bname, 
	wspreface, 
	wsnext, 
	wsfirst;
INTEGER j, 
	n, 
	blvl, 
	ch, 
	ssize, 
	procblklevel;

;

GC_EPOPS(dbug(040000000L,catlist(11L,GC_PUSHS("[MAK!BLK!EXIT] blockLevel="),cvs(blocklevel),
        GC_PUSHS(crlf),GC_PUSHS(" fromBlkLevel="),cvs(fromblklevel),
        GC_PUSHS(" toBlkLevel="),cvs(toblklevel),GC_PUSHS(crlf),
        GC_PUSHS(" emit!c!statement=\'"),GC_PUSHS(emit_c_statement),
        GC_PUSHS("\'"))));


/*  --	[1] Get the preface white space from end of cStatement in
case needed.
 */
GC_POPS(emit_c_statement); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(emit_c_statement); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(bname); /* for G.C. */
GC_NOTESTRING(wspreface); /* for G.C. */
GC_NOTESTRING(wsnext); /* for G.C. */
GC_NOTESTRING(wsfirst); /* for G.C. */
s= "@";
if (!didblkexit &&(usegcflag ||usechkflag ||useprfileflag) &&
   (fromblklevel>toblklevel)) set_preface(&wspreface); 
else	{/* oops -- should not have been called since nothing to do */
/*  # # DBUG('40000000,"[MAK!BLK!EXIT].0.1 emit!c!statement='"&emit!c!statement&"'"&CRLF&" useCHKflag="&PBOOL(useCHKflag)&" useGCflag="&PBOOL(useGCflag)&" sawSTRfct="&PBOOL(sawSTRfct)&CRLF&" didLOCemit="&PBOOL(didLOCemit)&" usePrfileFlag="&PBOOL(usePrfileFlag)) */
	{GC_UNMARKSSTKFRAME;
	 GC_SRETURN(emit_c_statement);}
	}/* oops -- should not have been called since nothing to do */

procblklevel= (*aChkI(declblklvl,1L,(*aChkI(dwptr,1L,hash_c(GC_PUSHS(lastprocedure))))));
/*  # # DBUG('40000000,"[MAK!BLK!EXIT].1 wsPreface='"&wsPreface&"'"&CRLF&" useCHKflag="&PBOOL(useCHKflag)&" useGCflag="&PBOOL(useGCflag)&" sawSTRfct="&PBOOL(sawSTRfct)) */
/*  # # DBUG('40000000,"[MAK!BLK!EXIT].1.1 didLOCemit="&PBOOL(didLOCemit)&" usePrfileFlag="&PBOOL(usePrfileFlag)&CRLF&" procBlkLevel="&CVS(procBlkLevel)) */
/* IFC EVAL(usemacros)=1 */
/* THENC */

/*  # # For j_1 Step 1 Until fromBlkLevel Do # # # DBUG('40000000,"[MAK!BLK!EXIT].1.2 blkSPDLptr["&CVS(j)&"]="&CVS(blkSPDLptr[j])&" blkName='"&blkName[j]&"'") */
   /* ENDC */


/*  --	[2] If /CHECKarray then emit any necessary aryfree() code
needed to deallocate the arrays which may be in several block levels.
 */
if (usechkflag &&toblklevel>0)
	{/* FREE up the DYNAMIC ARRAYS */
	s1= "@";		/*  -- build list of arrays to deallocate */
	for (blvl=fromblklevel;blvl<=((toblklevel+1L));blvl--)
		{/* build dealloc level bLvl */
/*  # # DBUG('40000000,"[MAK!BLK!EXIT].2 blkFreeAryList["&CVS(bLvl)&"]='"&s2&"'") */
		s2= (*aChkC(blkfrearylist,1L,blvl));
		if ((*s2!='\0')) s1= catlist(2L,GC_PUSHS(s1),GC_PUSHS(s2));
		}/* build dealloc level bLvl */
	ch= LOP(s1);
	if (*s1!='\0')
		{/* Emit aryfree() call */
		s1= catlist(3L,GC_PUSHS("aryfree("),GC_PUSHS(s1),
        GC_PUSHS("(INTEGER *)0);  /* Free List of Dynamic Arrays */"));
/*  # # @V.56.80	wsFirst_wsPreface */
		wsfirst= PNULL;
		wsnext= catlist(2L,GC_PUSHS(wspreface),subsr(GC_PUSHS(ps_spaces),1L,8L));
/*  # # DBUG('40000000,"[MAK!BLK!EXIT].2.1 s1='"&s1&"'") */
		s1= GC_EPOPS(justify_text(GC_PUSHS(wsnext),GC_PUSHS(wsfirst),GC_PUSHS(s1)));
/*  # # DBUG('40000000,"[MAK!BLK!EXIT].2.2 AFTER J!T s1='"&s1&"'") */
		s= catlist(3L,GC_PUSHS(s),GC_PUSHS(s1),GC_PUSHS(wspreface));
		}/* Emit aryfree() call */
/*  # # DBUG('40000000,"[MAK!BLK!EXIT].2.3 /CHKARRAY s='"&s&"'") */
	}/* FREE up the DYNAMIC ARRAYS */


/*  --	[3] If /PROFILE then emit any necessary profile macro code if
Return or GC_XRETURN */
if (useprfileflag &&
   (toblklevel<=procblklevel))
	{/* insert PROFILE code */
	if ((toblklevel>=1) &&
	   (*emit_c_statement=='r'||*emit_c_statement=='G')) s= 
        			catlist(GC_PUSHS(s),GC_PUSHS("PROFIL_OFF("),GC_PUSHS(
        quote),cvupcase(GC_PUSHS(lastprocedure)),GC_PUSHS(quote),
        GC_PUSHS(");  /* Turn off PROFILING */ "),GC_PUSHS(wspreface)); else if (toblklevel==0&&(!notmainflag)) s= 
        			catlist(GC_PUSHS(s),
        GC_PUSHS("PROFIL_PRINT; /* dump profile */"),
        GC_PUSHS(wspreface));
/*  # # DBUG('40000000,"[MAK!BLK!EXIT].3 /PROFILE s='"&s&"'")
	 */}/* insert PROFILE code */


/*  --	[4] If /GCcode then emit any necessary GC block termination
macro code.
 */
if (usegcflag &&(toblklevel>0)
/*   # # @V.56.83  And didLOCemit */)
	{/* Unmark the string GC stack frame */
	INTEGER gctoblklevel, 
	isreturnflag;
/*  -- NOTE: if we are doing a 'GC_xRETURN' or 'return' then it will do
one GC_UNMARKSTKFRAME for us so bump the block level up 1 to take
this into account.
 */
	isreturnflag= (*emit_c_statement=='G'||*emit_c_statement=='r');
/*  # # @V.56.148		gcToBlkLevel_toBlkLevel + 
				(If isReturnFlag Then 1 Else 0) */
	gctoblklevel= toblklevel +1L;
/*  # # @V.56.85  	sSize_blkSPDLptr[fromBlkLevel] - blkSPDLptr[toBlkLevel] */
/*  # # @V.56.125   	sSize_locSptr - blkSPDLptr[toBlkLevel] */
/*  # # @V.56.163    	sSize_(If gcToBlkLevel < fromBlkLevel  */
   	ssize= (((gctoblklevel<=fromblklevel) &&
		  !(isreturnflag &&(fromblklevel==toblklevel+1L))) ? 
			locsptr -(*aChkI(blkspdlptr,1L,gctoblklevel))
		:0L);
/*  # # DBUG('40000000,"[MAK!BLK!EXIT].4 fromBlkLevel="&CVS(fromBlkLevel)&" gcToBlkLevel="&CVS(gcToBlkLevel)&" sSize="&CVS(sSize)&CRLF&" isReturnFlag="&PBOOL(isReturnFlag)&" locSptr="&CVS(locSptr)&CRLF&" blkSPDLptr[fromBlkLevel]="&CVS(blkSPDLptr[fromBlkLevel])&" blkSPDLptr[gcToBlkLevel]="&CVS(blkSPDLptr[gcToBlkLevel])) */
	if ((ssize>0) &&
	   (fromblklevel>=1)   	/*   # # @V.56.83 was 2 before */)
		{/* emit GC stuff */
/*  # # @V.56.45-[FSM25]	s_s & "GC_UNMARKSSTKFRAME" & semiColon & wsPreface */
		s= catlist(2L,GC_PUSHS(s),GC_PUSHS(((n= (fromblklevel-gctoblklevel))>1) ?
         catlist(3L,GC_PUSHS("GC_ADJSTKFRAME("),cvs(n-1L),
        GC_PUSHS(");")): "GC_UNMARKSSTKFRAME;"));   /*  -- from the
							GOTO [FSM28] */
		s= catlist(2L,GC_PUSHS(s),GC_PUSHS(wspreface));
		}/* emit GC stuff */
/*  # # DBUG('40000000,"[MAK!BLK!EXIT].4.1 n="&CVS(n)&" s='"&s&"'") */
	}/* Unmark the string GC stack frame */


/*  --	[5] Ok, if there is anything there then we need to wrap it
with {} and change the statement type to 'end'.
 */
ch= LOP(s);		/*  -- trash '@' */
/*  # # DBUG('40000000,"[MAK!BLK!EXIT].5 s='"&s&"'") */
if (*s=='\0') s= emit_c_statement; 
else 	{/* opps, have to add all sorts of stuff before it */
	if (*emit_c_statement=='\0') {/* TRASH!RIGHT!WS */
			while ((*s!='\0') &&
			      (ps_itrash_= (*(s+length(s)-1))) &&
			      iswhitespace(ps_itrash_)) 
						s= subst(GC_PUSHS(s),1L,length(s)-1L);
			}/* TRASH!RIGHT!WS */
	s= catlist(3L,GC_PUSHS("{"),GC_PUSHS(s),
        GC_PUSHS(((INTEGER)*(emit_c_statement
        			)) ? catlist(3L,GC_PUSHS(" "),GC_PUSHS(emit_c_statement),
        GC_PUSHS(";}")): "}"));
	oldtoken= "end";		/*  -- so [FSM25] can do stuff */
	didblkexit= 1L;
	}/* opps, have to add all sorts of stuff before it */
GC_EPOPS(dbug(040000000L,catlist(7L,GC_PUSHS("[MAK!BLK!EXIT].6 oldToken=\'"),GC_PUSHS(oldtoken)
        ,GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" s=\'"),GC_PUSHS(s)
        ,GC_PUSHS("\'"))));

;
GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'j'=<L0> integer                              */
/* 'bname'=<L0> string                           */
/*************************************************/

}/* MAK!BLK!EXIT */
