/* FILE: map_be.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psparse.c, being converted 12/25/87, 09:34:41PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ----------------------------------------------------- */
/*INTERNAL*/  void map_be(be,xtype)
	STRING *be;
	INTEGER *xtype;
/*  ----------------------------------------------------- */
{/* MAP!BE */
/*  --
.LABEL [<++PSAIL PROCEDURE: MAP!BE>]
.INDEX ++PSAIL PROCEDURE: MAP!BE
DESCRIPTION:
	Map 'be' to '(be)'. If xType is not a numeric scalar (integer,
float or double) then cast it as ((INTEGER)be).

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:
	@V.46.93 NOTE: a more complex algorithm is required to analyze
'('...')' and operators in the expression in order to determine if
the extra '(...)' are required. Therefore default to just throwing
them in!.

.ENDLABEL [<++PSAIL PROCEDURE: MAP!BE>]
 */
INTEGER ntype;

;

/*  # # DBUG('200,"[MAP!BE] be'"&be&"'"&CRLF&" xType='"&CVTYPES(xType)&"'") */


GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(be); /* for G.C. */
if (!isunaryscalartype(*xtype))
	{/* map to integer */
	ntype= *xtype;			/*  -- set up expected type */
	pdw_ptype(ntype,codeinteger);
	*be= GC_EPOPS(cvactual_to_expected(ntype,*xtype,GC_PUSHS(*be)));
	*xtype= ntype;			/*  -- now set returned type */
	}/* map to integer */

*be= catlist(2L,GC_PUSHS("("),GC_PUSHS(*be));				/*  --insert (...) around be */
insert_before_white(be,GC_PUSHS(")"));

GC_EPOPS(dbug(0200L,catlist(7L,GC_PUSHS("[MAP!BE].1 NEW be\'"),GC_PUSHS(*be),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  xType=\'"),
        cvtypes(*xtype),GC_PUSHS("\'"))));

;
{GC_UNMARKSSTKFRAME;}
}/* MAP!BE */
