/* FILE: map_bkslash_str.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psparse.c, being converted 12/25/87, 09:34:41PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ----------------------------------------------------- */
/*INTERNAL*/  void map_bkslash_str(stxt)
	STRING *stxt;
/*  ----------------------------------------------------- */
{/* MAP!BKSLASH!STR */
/*  --
.LABEL [<++PSAIL PROCEDURE: MAP!BLSLASH!STR>]
.INDEX ++PSAIL PROCEDURE: MAP!BLSLASH!STR
DESCRIPTION:
	Map any C style '\nnn' characters in string s to the ASCII
values.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: MAP!BLSLASH!STR>]
 */
INTEGER ch, 
	n;
STRING sr, 
	s, 
	s1;

;

/*  # # DBUG('200,"[MAP!BKSLASH!STR] sTxt='"&sTxt&"'") */

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(stxt); /* for G.C. */
GC_NOTESTRING(sr); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
sr= "@";
s= *stxt;				/*  -- work off of copy */
while ((*s!='\0'))
	{/* look for '\' */
	s1= GC_EPOPS(scan(&s,39L,&ch)); 	/*  -- scan for '\' */
	if (*s1!='\0') sr= catlist(2L,GC_PUSHS(sr),GC_PUSHS(s1));
/*  # # DBUG('200,"[MAP!BKSLASH!STR].1 s='"&s&"'"&CRLF&"  s1='"&s1&"' ch='"&(ps!sTrash!_ch)&"' sR='"&sR&"'") */
	if (ch==('\\'/*WARNING*/)) 
		{/* process '\?' */
		if (*s=='n') {ch= LOP(s); ch= (INTEGER)*lf; }else if (*s=='r') {ch= LOP(s); ch= (INTEGER)*cr; }else if (*s=='t') {ch= LOP(s); ch= (INTEGER)*tab; }else if (isoctal((INTEGER)*s))
			{/* get number char */
			n= 0;
			ch= 0;
			while ((n<=3) &&isoctal((INTEGER)*s)) 
				{++n; ch = ch*8+(LOP(s)-(INTEGER)'0'); }
			}/* get number char */
		else ch= LOP(s);	/*  -- default to literal value */
		sr= catlist(2L,GC_PUSHS(sr),makstr(ch));		/*  -- add single character on */
/*  # # DBUG('200,"[MAP!BKSLASH!STR].1.1 ch="&CVS(ch)&"  ch='"&(ps!sTrash!_ch)&"'"&CRLF&" sR='"&sR&"'") */
		}/* process '\?' */
	}/* look for '\' */

ch= LOP(sr);		/*  -- trash '@' */

GC_EPOPS(dbug(0200L,catlist(5L,GC_PUSHS("[MAP!BKSLASH!STR].2 sR=\'"),GC_PUSHS(sr),
        GC_PUSHS("\' sTxt=\'"),GC_PUSHS(*stxt),GC_PUSHS("\'"))));

*stxt= sr;			/*  -- replace it */

;
{GC_UNMARKSSTKFRAME;}
}/* MAP!BKSLASH!STR */
