/* FILE: map_chk_args.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psparse.c, being converted 12/25/87, 09:34:41PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ----------------------------------------------------- */
/*INTERNAL*/  STRING map_ck_args(procname)
	STRING procname;
/*  ----------------------------------------------------- */
{/* MAP!CK!ARGS */
/*   --
.LABEL [<++PSAIL PROCEDURE: MAP!CK!ARGS>]
.INDEX ++PSAIL PROCEDURE: MAP!CK!ARGS
DESCRIPTION:
	Scan and map saiStatement to output string 's'. The last
token scanned is passed here in 'procName'. saiStatement is
positioned at the left '(' of the actual call arg list if it exists.
Do type conversion of the actual arguments in the call to those
expected in the call. These are contained in the USER symbol table in
the internal PSAIL compressed form declFormal[] for the 'procName'
symbol. These are expanded to Descriptor Word (DW) format and saved
one arg/entry in eTypeList[]. If the arg is a REFERENCE type, then
'&' is stored in the corresponding refArgList[] table.

	NOTE: single charater strings "q" which are mapped to 'q' must
be mapped back to "q" if a string arg is expected.

	NOTE: the 'declFormal[idx]' is the PSAIL internal format
formal-arg specification for the procedure and is of the form:

		outType:argList1:n1[arglist2:n2[...,

Where: 	argListI is the Ith declaration list type and
	outtype is the procedure's return declaration type.

	NOTE: When the actual argument is a macro id, then force its
expansion here rather than in C since we MUST know its type now....
	NOTE: cf. [Reiser] if evaling a macro then eval CVS, CVOS etc
if the arguments are constants of CVD, CVO if they are string
constants.
	@V.54.68 NOTE: now save eval'ed args of last MAK!CK!ARG in
global
	string array evalArgList[1:nArgsFound].
	@V.56.68 If arg count checking is disabled (i.e. REPEATABLE
arg - /EXTENSION) then insert the numeric (LONG) count as the first
arg of the procedure.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: MAP!CK!ARGS>]
 */
STRING s, 
	s1, 
	s2, 
	s3, 
	s4, 
	espec, 
	edecl, 
	aarg, 
	trash, 
	brkstr,
	mappedaarg, 
	caarg, 
	refprefix, 
	oldsaistatement, 
	dvlist;
  static INTEGER /*ARRAY*/ *refarglist  /* [1:maxmargs] */  = 0; /*  -- stores NULL or
							'*' char */
  static INTEGER /*ARRAY*/ *etypelist  /* [1:maxmargs] */  = 0;  /*  -- stores DW type code */
  static STRING /*ARRAY*/ 
/***********************************************************************/
/* WARNING! Can't have OWN STRING declarations in non-MAIN module      */
/* or inner blocks! Suggest you move 'STRING defaultvalue' declaration */
/* to global level in MAIN module and recompile.                       */
/***********************************************************************//*N.P.*/
/***************************/
/*<7>    ..                */
/*      .                  */
/*   /----------\          */
/*   | o         _______/  */
/*   |__         -------\  */
/*   \----------/          */
/*                         */
/*   A GROSS MOBY          */
/***************************/

*defaultvalue  /* [1:maxmargs] */  = 0; /*  -- stores opt def
							value */
INTEGER i, 
	j, 
	k, 
	ch, 
	h, 
	idx, 
	nargsexpected, 
	jspec, 
	sign, 
	etype,
	atype, 
	ecode, 
	acode, 
	_class, 
	harg, 
	cs, 
	hs, 
	fsmn;

;

GC_EPOPS(dbug(0100000000L,catlist(7L,GC_PUSHS("[MAP!CK!ARGS] procName=\'"),GC_PUSHS(procname),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"))));

GC_POPS(procname); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(procname); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(s3); /* for G.C. */
GC_NOTESTRING(s4); /* for G.C. */
GC_NOTESTRING(espec); /* for G.C. */
GC_NOTESTRING(edecl); /* for G.C. */
GC_NOTESTRING(aarg); /* for G.C. */
GC_NOTESTRING(trash); /* for G.C. */
GC_NOTESTRING(brkstr); /* for G.C. */
GC_NOTESTRING(mappedaarg); /* for G.C. */
GC_NOTESTRING(caarg); /* for G.C. */
GC_NOTESTRING(refprefix); /* for G.C. */
GC_NOTESTRING(oldsaistatement); /* for G.C. */
GC_NOTESTRING(dvlist); /* for G.C. */
GC_NOTEASTRING(defaultvalue);	/* for G.C. */
refarglist = arymkI(1L,1L,40L,"refarglist",'i');	/* Dynamic Array */
etypelist = arymkI(1L,1L,40L,"etypelist",'i');	/* Dynamic Array */
defaultvalue = arymkC(1L,1L,40L,"defaultvalue",'c');	/* Dynamic Array */
oldsaistatement= saistatement;
map_whitespace(&s);
if ((idx= find_symbol(GC_PUSHS(procname),&cs,&hs))==0||
   ((fsmn= ((*aChkI(declfsm,1L,idx))&0177777))!=71&&(fsmn!=54) &&
    (fsmn!=10))) 
	err_hlr(catlist(11L,GC_PUSHS("[MAP!CK!ARGS] Symbol \'"),GC_PUSHS(procname),
        GC_PUSHS("\' isn\'t a PROCEDURE (i.e. FSM"),cvs(fsmn),
        GC_PUSHS("),"),GC_PUSHS(crlf),GC_PUSHS(" type["),
        GC_PUSHS(procname),GC_PUSHS("]=\'"),cvtypes((*aChkI(decldw,
        1L,idx))),GC_PUSHS("\'.")));
					/*  -- get index of procedure
					name in symtab if succeed */

/*  --------------------------------------------------- */
/*  ... GET EXPECTED SPEC WHICH IS AFTER 1st ':' ...  */
/*  --------------------------------------------------- */
s= "@";				/*  -- insert prefix */
edecl= (*aChkC(declformal,1L,idx));		/*  -- get packed formal decl */
nargsexpected= (*aChkI(declnargs,1L,idx));	/*  -- if <0 then do not do arg counting! */
dvlist= (*aChkC(declsize,1L,idx));		/*  -- has declaration 'defaultValue'
				list appended */
s2= GC_EPOPS(scan(&dvlist,2L,&i)); 		/*  -- Scan for ',' to
				get default list from string
				which looks like 
				   'procedure[#],v1,v2,...vN'
				and vj is 'N' if no value or a number
				if it is. It is put there in [FSM12] */
if ((*s2!='\0') &&(nargsexpected>0) &&(*saistatement!='('))
	{/* add '()' */
	if (*saistatement=='\0') saistatement= "()"; 
	else saistatement= catlist(2L,GC_PUSHS("()"),GC_PUSHS(saistatement));
	}/* add '()' */
GC_EPOPS(dbug(0100000000L,catlist(11L,GC_PUSHS("[MAP!CK!ARGS].0.1 eDecl=\'"),GC_PUSHS(edecl),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" dvList=\'"),
        GC_PUSHS(dvlist),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" saiStatement=\'"),GC_PUSHS(saistatement),
        GC_PUSHS("\'"))));
s1= edecl;			/*  -- Analyze expected spec */
jspec= 0;			/*  -- number of args in formal spec */
nargsfound= 0L;			/*  -- number of actual args found */
arrclr(refarglist,0L);
arrclr(etypelist,0L);
arrclr(defaultvalue,PNULL);
espec= PNULL;
pushnumber(lasttype);

/*  ------------------------------------------------------------------ */
/*  ... ANALYZE 'eDecl' TO BUILD EXPECTED FORMAL-ARG SPEC LIST DW's IN
# ...   ARRAYS 'eTypeList[] and 'refArgList[]'	...  */
/*  ------------------------------------------------------------------ */
while ((*s1!='\0') &&(jspec<40L))
	{/* build expected-arg list */
	espec= GC_EPOPS(scan(&s1,13L,&ch));		/*  -- scan ONLY for ':'  */
	etype= cvidw(GC_PUSHS(espec));		/*  -- map internal decl to DW */
	ecode= (((ps_itrash_= (etype&037))>0) ? (ps_itrash_+0140L)
				:0L);
GC_EPOPS(dbug(0100000000L,catlist(11L,GC_PUSHS("[MAP!CK!ARGS].0.1.1 eSpec=\'"),GC_PUSHS(espec),
        GC_PUSHS("\' s1=\'"),GC_PUSHS(s1),GC_PUSHS("\' ch=\'"),
        GC_PUSHS(s3= GC_EPOPS(makstr(ch))),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" dvList=\'"),GC_PUSHS(dvlist),
        GC_PUSHS("\'"))));
	if (ch!=':') 
		err_hlr(GC_PUSHS(
        			catlist(GC_PUSHS(
        "[MAP!CK!ARGS] DRYROT! can\'t find ETYPE \':\'  for procedure \'")
        ,GC_PUSHS(procname),GC_PUSHS("\'"))));
	if (*s1=='-') sign= LOP(s1); 
		else sign= '+';
	s2= GC_EPOPS(scan(&s1,4L,&ch));		/*  -- scan for '[' if it exists */
	k= cvd(GC_PUSHS(s2));			/*  -- make a number */
	if ((k>0) &&(ch!='\0') &&(ch!='[')) 
		err_hlr(GC_PUSHS(
        			catlist(GC_PUSHS(
        "[MAP!CK!ARGS] DRYROT! can\'t find COUNT \'[\'  for procedure \'")
        ,GC_PUSHS(procname),GC_PUSHS("\'"))));
GC_EPOPS(dbug(0100000000L,catlist(8L,GC_PUSHS("[MAP!CK!ARGS].0.2 k="),cvs(k),GC_PUSHS(crlf),
        GC_PUSHS(" eSpec=\'"),GC_PUSHS(espec),
        GC_PUSHS("\' eType=\'"),cvtypes(etype),GC_PUSHS("\'"))));
	if ((etype&010000000L) ||
	   (!usechkflag &&(etype&0606710))) refprefix= "&"; 
	else refprefix= PNULL;		/*  -- Set prefix to what we emit */

	if (etype&0400000L) etype=etype&0777777377777L;   /*  -- Trash it */

	for (i=1;i<=k;i++)
		{/* Save specification for variable */
		if ((++jspec)==40L) 
			goto PS0001 /* build expected-arg list */; /*  -- Overflow! */
		(*aChkI(etypelist,1L,jspec))= etype;		/*  -- save DW spec */
		(*aChkI(refarglist,1L,jspec))= (INTEGER)*refprefix;   /*  -- i.e. '&' or NULL */
		(*aChkC(defaultvalue,1L,jspec))= GC_EPOPS(scan(&dvlist,2L,&ch));  /*  -- next value */
/*  # # DBUG('100000000,"[MAP!CK!ARGS].0.3 eTypeList["&CVS(jSpec)&"]='"&CVTYPES(eTypeList[jSpec])&"'"&CRLF&" i="&CVS(i)&" jSpec="&CVS(jSpec)&CRLF&" eSpec='"&eSpec&"' refArgList[jSpec]='"&(trash_refArgList[jSpec])&"'"&CRLF&" defaultValue[jSpec]='"&defaultValue[jSpec]&"'") */
		}/* Save specification for variable */
	}/* build expected-arg list */
PS0001: 
if (jspec==40L) err_hlr(catlist(5L,
        GC_PUSHS("[MAP!CK!ARGS] DRYROT! > 40 expected-args, eDecl["),
        GC_PUSHS(procname),GC_PUSHS("]=\'"),GC_PUSHS(edecl),
        GC_PUSHS("\'")));

/*  -------------------------------------- */
/*  . . . TEST WHETHER WE CHECK ARGS . . . */
/*  -------------------------------------- */
if (sign=='-') nargsexpected= -1;	  /*  -- can set it from eDecl as well */
GC_EPOPS(dbug(0100000000L,catlist(7L,GC_PUSHS("[MAP!CK!ARGS].1 eSpec=\'"),GC_PUSHS(espec),
        GC_PUSHS("\' nArgsExpected="),cvs(nargsexpected),
        GC_PUSHS(crlf),GC_PUSHS(" saiStatement="),
        GC_PUSHS(saistatement))));

map_whitespace(&s);
if ((nargsexpected>0&&*saistatement!='(')) 
	{/* error! */
	pushnumber(debugswitch); debugswitch= 1L;
	pushnumber(dbugcode); dbugcode= -1L;  /*  -- so allow PRT!NODE() */
	err_hlr(GC_PUSHS(

        		catlist(GC_PUSHS(
        "[MAP!CK!ARGS] missing \'(\' in beginning of arg list for proc. \'")
        ,GC_PUSHS(procname),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  Number expected args="),cvs(nargsexpected),
        GC_PUSHS(crlf),GC_PUSHS("  Actual args=\'"),
        GC_PUSHS(oldsaistatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  rdLevel="),cvs(rdlevel),GC_PUSHS("  rrLevel="),
        cvs(rrlevel),GC_PUSHS("  blockLevel="),cvs(blocklevel),
        GC_PUSHS(crlf),GC_PUSHS("  saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  cStatement=\'"),GC_PUSHS(cstatement),
        GC_PUSHS("\'"),prt_node((*aChkI(declhash,1L,idx))))));
	popnumber(&dbugcode); popnumber(&debugswitch);
	}/* error! */

else if ((nargsexpected>40L)) 
	err_hlr(GC_PUSHS(
catlist(7L,GC_PUSHS("[MAP!CK!ARGS] proc. \'"),GC_PUSHS(procname),
        GC_PUSHS("\' # args-expected ("),cvs(nargsexpected),
        GC_PUSHS(") > MAX("),GC_PUSHS("40"),GC_PUSHS(")")))); 

else if ((nargsexpected==0&&*saistatement=='(')) 
	err_hlr(GC_PUSHS(
	
	        		catlist(GC_PUSHS(
	        "[MAP!CK!ARGS] unexpected \'(\' found in procedure call to \'")
	        ,GC_PUSHS(procname),GC_PUSHS("\'"),GC_PUSHS(crlf),
	        GC_PUSHS(" Number expected args="),cvs(nargsexpected),
	        GC_PUSHS(crlf),GC_PUSHS(" Actual args=\'"),
	        GC_PUSHS(oldsaistatement),GC_PUSHS("\'"))));

if (*saistatement=='(') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(LOP(saistatement)));

/*  ----------------------------------- */
/*  . . . GET AND MAP ACTUAL ARGS . . . */
/*  ----------------------------------- */
push(GC_PUSHS(oldtoken));			/*  -- Need '(' or ',' in case [FSM9] */
oldtoken= "(";
brkstr= PNULL;
pushnumber(midofexpr); midofexpr= 1L;
if (nargsexpected==0) s= catlist(2L,GC_PUSHS(s),GC_PUSHS("()")); else for (nargsfound=1;((nargsfound<=40L) &&
		(*saistatement!='\0') &&
		(*brkstr!=')'||
		 (*brkstr==')'&&(nargsfound<=nargsexpected && nargsexpected>0) &&
		  *((*aChkC(defaultvalue,1L,nargsfound)))!='N')) &&
		((nargsfound<=nargsexpected && nargsexpected>0) ||
		 (nargsexpected<0)));nargsfound++)
	{/* process Argument List */
/*  # # DBUG('100000000,"[MAP!CK!ARGS].2 brkStr='"&brkStr&"' s='"&s&"'"&CRLF&"  defaultValue[nArgsFound]='"&defaultValue[nArgsFound]&"' nArgsFound="&CVS(nArgsFound)&CRLF&" saiStatement='"&saiStatement&"'") */
	if ((*brkstr==')'||*saistatement==')') &&
	   (*((aarg= (*aChkC(defaultvalue,1L,nargsfound))))!='N'))
		{/* assume we use the default value */
		if (nargsfound>1) s= catlist(2L,subst(GC_PUSHS(s),1L,length(s)-1L),GC_PUSHS(","));    /*  -- backup */
/*  # # DBUG('100000000,"[MAP!CK!ARGS].2.0.1 aArg='"&aArg&"' nArgsFound="&CVS(nArgsFound)&CRLF&" saiStatement='"&saiStatement&"'"&CRLF&" brkStr='"&brkStr&"' s='"&s&"'") */
		}/* assume we use the default value */
	else aarg= GC_EPOPS(copy_either(GC_PUSHS(",)"),&brkstr));     /*  -- Get next arg */
/*  # # DBUG('100000000,"[MAP!CK!ARGS].2.0.2 s='"&s&"' aArg='"&aArg&"' nArgsFound="&CVS(nArgsFound)&CRLF&" saiStatement='"&saiStatement&"'"&CRLF&" brkStr='"&brkStr&"' sPDLptr="&CVS(sPDLptr)&" nPDLptr="&CVS(nPDLptr)) */
	if (*aarg==')') err_hlr(GC_PUSHS(
	
	        		catlist(GC_PUSHS(
	        "[MAP!CK!ARGS] Too few args in call to procedure \'"),
	        GC_PUSHS(procname),GC_PUSHS("\'"))));

/*  ----------------------------- */
/*  . . . EVAL THE NEXT ARG . . . */
/*  ----------------------------- */
	midofexpr= 1L;
/*  # # DBUG('100000000,"[MAP!CK!ARGS].2.1 aArg='"&aArg&"'"&CRLF&" eTypeList["&CVS(nArgsFound)&"]='"&CVTYPES(eTypeList[nArgsFound])&"'"&PRT!NODE(HASH!C(aArg))) */
	if (((*aChkI(decldw,1L,idx= find_symbol(GC_PUSHS(aarg),&cs,&hs)))&0100000L) &&
	   ((*aChkI(etypelist,1L,nargsfound))&0100000L))
		{/* Don't EVAL it */
		caarg= aarg;    /*  -- i.e. we will pass function ADDRESS */
		atype= lasttype= (*aChkI(decldw,1L,idx));
		}/* Don't EVAL it */
	else	{/* go EVAL it */
		for (j=1;j<=(((nargsexpected>0) ? nargsexpected 
				: (MIN(jspec,nargsfound))));j++) 
			{pushnumber((*aChkI(etypelist,1L,j)));
			pushnumber((*aChkI(refarglist,1L,j))); 
			push(GC_PUSHS((*aChkC(defaultvalue,1L,j)))); 
			push(GC_PUSHS((*aChkC(evalarglist,1L,j))));
/*  # #  DBUG('100000000,"[MAP!CK!ARGS].2.1.1 refArgList["&CVS(j)&"]='"&(trash_refArgList[j])&"'"&CRLF&" eTypeList[j]="&CVOS(eTypeList[j])&"='"&CVTYPES(eTypeList[j])&CRLF&" defaultValue[j]='"&defaultValue[j]&"'") */
			}
		push(GC_PUSHS(procname));
		pushnumber(nargsfound); pushnumber(nargsexpected);
		push(GC_PUSHS(s)); push(GC_PUSHS(brkstr)); pushnumber(jspec);
		lasttype= 0L;
		pushnumber(usefoldingflag); usefoldingflag= 1L;
		lastmappedtoken= ",";	   /*  -- in case IF-eEXPR etc */
		caarg= GC_EPOPS(r_d_expr_map(GC_PUSHS(aarg)));  /*  -- do what has to be done */
		popnumber(&usefoldingflag);
		atype= lasttype;
		popnumber(&jspec); pop(&brkstr); pop(&s);
		popnumber(&nargsexpected); popnumber(&nargsfound);
		pop(&procname);
		oldtoken= brkstr;  /*  -- save for next pass if [FSM9]... */
		for (j=((nargsexpected>0) ? GC_EPOPS(makstr(nargsexpected 
			)): (MIN(jspec,nargsfound)));j<=1;j--) 
			{pop(aChkC(evalarglist,1L,j)); 
			pop(aChkC(defaultvalue,1L,j)); 
			popnumber(aChkI(refarglist,1L,j));
			popnumber(aChkI(etypelist,1L,j)); 
 /*  # # DBUG('100000000,"[MAP!CK!ARGS].2.2 refArgList["&CVS(j)&"]='"&(trash_refArgList[j])&"'"&CRLF&" eTypeList[j]="&CVOS(eTypeList[j])&"='"&CVTYPES(eTypeList[j])) */
			}
		}/* go EVAL it */
/*  # # DBUG('100000000,"[MAP!CK!ARGS].2.2.1 cAarg='"&cAarg&"'"&CRLF&"  lastType='"&CVTYPES(lastType)&"'") */

/*  --------------------------------------------------- */
/*  . . . HANDLE PREVIOUS FORMAL ARGS AS REFERENCE ARGS */
/*  --------------------------------------------------- */
GC_EPOPS(dbug(0100000000L,catlist(6L,GC_PUSHS("[MAP!CK!ARGS].2.3 cAarg=\'"),GC_PUSHS(caarg),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  lastType=\'"),
        cvtypes(lasttype))));
	if ((*caarg!='*') &&
	   ((j= find_symbol(GC_PUSHS(caarg),&_class,&harg))!=0) &&
	   ((*aChkI(decldw,1L,j))&dw_reference /*    # # @V.50.82 DW!formalArg */)) 
		{/* add * reference */
		caarg= catlist(2L,GC_PUSHS("*"),GC_PUSHS(caarg));    /*  -- reference FORMALS as ptrs */
/*  # # DBUG('100000000,"[MAP!CK!ARGS].2.3.1 j='"&CVS(j)&" new cAarg='"&cAarg&"'"&CRLF&"  declDW[j]='"&CVTYPES(declDW[j])) */
		}/* add * reference */

/*  ---------------------------------------- */
/*  . . . DO TYPE COERCION IF REQUIRED . . . */
/*  ---------------------------------------- */
/*  # # DBUG('100000000,"[MAP!CK!ARGS].3 aType='"&CVTYPES(aType)&"'"&CRLF&" eType='"&CVTYPES(eType)&"'"&CRLF&" nArgsFound="&CVS(nArgsFound)&CRLF&" s2='"&s2&"'"&CRLF&" cAarg='"&cAarg&"'") */
	etype= (*aChkI(etypelist,1L,((nargsexpected>0) ? nargsfound 
			: (MIN(jspec,nargsfound)))));
/*  # # DBUG('100000000,"[MAP!CK!ARGS].3.1 aType='"&CVTYPES(aType)&"'"&CRLF&" eType='"&CVTYPES(eType)&"'"&CRLF&"  nArgsFound="&CVS(nArgsFound)) */
	ecode= (((ps_itrash_= (etype&037))>0) ? (ps_itrash_+0140L)
				:0L);
	acode= (((ps_itrash_= (atype&037))>0) ? (ps_itrash_+0140L)
				:0L);
	refprefix= GC_EPOPS(makstr((*aChkI(refarglist,1L,nargsfound))));   /*  -- get expected REFERENCE
						flag */
GC_EPOPS(dbug(0100000000L,catlist(11L,GC_PUSHS("[MAP!CK!ARGS].3.1.1 cAarg=\'"),GC_PUSHS(caarg),
        GC_PUSHS("\' refPrefix=\'"),GC_PUSHS(refprefix),GC_PUSHS(
        "\'"),GC_PUSHS(crlf),GC_PUSHS(" aCode=\'"),
        GC_PUSHS(ps_strash_= GC_EPOPS(makstr(acode))),
        GC_PUSHS("\' eCode=\'"),
        GC_PUSHS(ps_strash_= GC_EPOPS(makstr(ecode))),GC_PUSHS("\'"))));

/*  --------------------------------------------------------- */
/*  . . . MUST HAVE EXACT TYPE MATCH FOR REFERENCE ARGS . . . */
/*  --------------------------------------------------------- */
/*  # # @V.56.159 NOTE: need to add code to ignore REFERENCE if ARRAY
declaration - we pass it the header addresso the '&' is not needed.
 */
	if (*refprefix=='&')
		{/* must have exact match for REFERENCE */
		/*  -- first make sure we are not trying to pass an
		    INTEGER constant by reference! Eg. &123 is N.P. */
		while ((*caarg!='\0') &&iswhitespace((INTEGER)*caarg)) ps_itrash_= LOP(caarg);	/*  -- @V.56.45 must have no WS
						between '&' and '<id>' */
		if ((acode==codeinteger||acode==codereal) &&
		   chk_number(GC_PUSHS(caarg)))
			{/* error */
			s= catlist(2L,GC_PUSHS(s),GC_PUSHS(crlf));
			err_deathwish(&s,
   catlist(5L,
        GC_PUSHS("WARNING! Although SAIL allows passing constants by reference,")
        ,GC_PUSHS(crlf),GC_PUSHS("C doesn\'t - recode \'"),
        GC_PUSHS(caarg),GC_PUSHS("\' as a variable.")),
				10L,(INTEGER)('N'/*WARNING*/));
			}/* error */
		if ((*caarg=='*') ||*caarg=='(')
			{/* try to optimize '&*' references */
			if (*caarg=='*')
				{/* simple optimization */
				ch= LOP(caarg);   /*  -- Trash '&*'  */
				mappedaarg= caarg;
				}/* simple optimization */
			else	{/* &(...(*<expr>)...) optimization */
				INTEGER i, 
				j, 
				k, 
				n, 
				ch;
				STRING s1;
/*  # # DBUG('100000000,"[MAP!CK!ARGS].3.1.2 cAarg='"&cAarg&"'") */
				GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
				GC_NOTESTRING(s1); /* for G.C. */
				s1= caarg;  /*  -- copy which we will eat */
				n= 0;	/*  -- number of '('s seen */
				while ((ch= LOP(s1))=='(') ++n;
				if (ch=='*'&&
				   equ(subst(GC_PUSHS(caarg),length(caarg)-n+1L,length(caarg)),GC_PUSHS(
					subsr(GC_PUSHS("))))))))))))))))))"),1L,n)))) mappedaarg= subst(GC_PUSHS(caarg),n+2L,length(caarg)-n); 
				else mappedaarg= catlist(2L,GC_PUSHS("&"),GC_PUSHS(caarg));
/*  # # DBUG('100000000,"[MAP!CK!ARGS].3.1.3 mappedAarg='"&mappedAarg&"' cAarg='"&cAarg&"'"&CRLF&"  s1='"&s1&"' n="&CVS(n)) */
				/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'k'=<L0> integer                              */
/* 'j'=<L0> integer                              */
/* 'i'=<L0> integer                              */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/


{GC_UNMARKSSTKFRAME;}}/* &(...(*<expr>)...) optimization */
			refprefix= PNULL;
/*  # # DBUG('100000000,"[MAP!CK!ARGS].3.1.4 mappedAarg='"&mappedAarg&"' refPrefix='"&refPrefix&"'") */
			}/* try to optimize '&*' references */
		else mappedaarg= caarg;

/*  # # DBUG('100000000,"[MAP!CK!ARGS].3.1.5 aCode='"&(ps!sTrash!_aCode)&"' eCode='"&(ps!sTrash!_eCode)&"'"&CRLF&" aType='"&CVTYPES(aType)&"'"&CRLF&" eType='"&CVTYPES(eType)&"'") */
		if ((codeuntyped!=ecode) &&
		   ( (ecode!=acode) ||
		     ((etype&0200L) &&
		      ((etype&0200L)!=(atype&0200L))
                     )
		   )) err_hlr(GC_PUSHS(
catlist(15L,
        GC_PUSHS("[MAP!CK!ARGS] Must have same declaration type for variables")
        ,GC_PUSHS(crlf),
        GC_PUSHS("	passed by REFERENCE in procedure \'"),
        GC_PUSHS(procname),GC_PUSHS("\'."),GC_PUSHS(crlf),
        GC_PUSHS("	Expected type=\'"),cvtypes(etype),
        GC_PUSHS("\' And"),GC_PUSHS(crlf),GC_PUSHS("	actual type("),
        GC_PUSHS(caarg),GC_PUSHS(")=\'"),cvtypes(atype),
        GC_PUSHS("\'."))));
		}/* must have exact match for REFERENCE */

	else if (etype==codeuntyped) mappedaarg= caarg; 

	else 	{/* map actual to that of expected type */
		/*  -- note this will cast integer consts to 32-bits */
		mappedaarg= GC_EPOPS(cvactual_to_expected(etype,atype,GC_PUSHS(caarg)));
GC_EPOPS(dbug(0100000000L,catlist(3L,GC_PUSHS("[MAP!CK!ARGS].3.1.6. mappedAarg=\'"),
        GC_PUSHS(mappedaarg),GC_PUSHS("\'"))));
		if (usegcflag &&ecode==codestring) add_gc_pushs(&mappedaarg);
	 	}/* map actual to that of expected type */
GC_EPOPS(dbug(0100000000L,catlist(3L,GC_PUSHS("[MAP!CK!ARGS].3.2 mappedAarg=\'"),
        GC_PUSHS(mappedaarg),GC_PUSHS("\'"))));

	if (*refprefix!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(refprefix));

	s= catlist(3L,GC_PUSHS(s),GC_PUSHS(mappedaarg),GC_PUSHS(brkstr));

	(*aChkC(evalarglist,1L,nargsfound))= mappedaarg;	/*  -- this is a hook
				for others to use the evaled arg list
				of the function just parsed. This is
				used for example in FSM10 to handle
				the optimization of SCANC by evaling
				it there. etc... */
GC_EPOPS(dbug(0100000000L,catlist(8L,GC_PUSHS("[MAP!CK!ARGS].3.2.1 nArgsExpected="),
        cvs(nargsexpected),GC_PUSHS(" nArgsFound="),cvs(nargsfound),
        GC_PUSHS(crlf),GC_PUSHS(" s=\'"),GC_PUSHS(s),GC_PUSHS("\'"))));
GC_EPOPS(dbug(0100000000L,catlist(5L,GC_PUSHS("[MAP!CK!ARGS].3.2.2 evalArgList["),
        cvs(nargsfound),GC_PUSHS("]=\'"),GC_PUSHS(*aChkC(evalarglist
        ,1L,nargsfound)),GC_PUSHS("\'"))));

	map_whitespace(&s);
	if ((nargsfound>=40L) ||(nargsfound>nargsexpected && nargsexpected>0))
		err_hlr(GC_PUSHS(
		catlist(11L,GC_PUSHS("[MAP!CK!ARGS] "),cvs(nargsfound),
		        GC_PUSHS(" actual args found > "),cvs(nargsexpected),
		        GC_PUSHS(" number expected args in procedure \'"),
		        GC_PUSHS(procname),GC_PUSHS("\',"),GC_PUSHS(crlf),
		        GC_PUSHS(" Actual args=\'"),GC_PUSHS(oldsaistatement),
		        GC_PUSHS("\'"))));
	}/* process Argument List */


/*  ------------------------- */
/*  . . . FINAL CLEANUP . . . */
/*  ------------------------- */
popnumber(&midofexpr); pop(&oldtoken); popnumber(&lasttype);

ch= LOP(s);			/*  -- remove the '@' prefix */
if (nargsexpected<0) s= catlist(4L,GC_PUSHS(LOP(s)),cvs(nargsfound-1L),GC_PUSHS("L,"),
        GC_PUSHS(s));
					 	/*  -- force # actual
						args as the first arg */
GC_EPOPS(dbug(0100000000L,catlist(6L,GC_PUSHS("[MAP!CK!ARGS].4 s=\'"),GC_PUSHS(s),GC_PUSHS("\'")
        ,GC_PUSHS(crlf),GC_PUSHS(" saiStatement="),
        GC_PUSHS(saistatement))));
;
GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'h'=<L0> integer                              */
/* 'trash'=<L0> string                           */
/* 's4'=<L0> string                              */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/


}/* MAP!CK!ARGS */
