/* FILE: map_declar.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psparse.c, being converted 12/25/87, 09:34:41PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ----------------------------------------------------- */
/*INTERNAL*/  STRING map_declar(token)
	STRING token;
/*  ----------------------------------------------------- */
{/* MAP!DECLAR */
/*   --
.LABEL [<++PSAIL PROCEDURE: MAP!DECLAR>]
.INDEX ++PSAIL PROCEDURE: MAP!DECLAR
DESCRIPTION:
	Map only BUILT-IN and DECLARATION type tokens. If the token
is a already exists as a FORWARD PROCEDURE definition, then allow it
to be updated without creating a new symbol since it is a FORWARD
reference. Generate n-tuple:

	(String  token,
	 String  lastProcedure,
	 Integer lastDeclaration,
	 String  lastFormal,
	 String  lastAsize,
	 Integer blockLevel,
	 String  lastCsym,
	 Integer lastFSM,
	 Integer lastNargs,
	 Integer lastSubLang,
	 Integer lastRClass)
stored in
	'declHash[1:dclSymPtr]= HASH!C(token)
	'declInProc[1:dclSymPtr]= HASH!C(lastProcedure)
	'declDW[1:dclSymPtr] 	= lastDeclaration, various status bits 
				  defined in table L.2 which includes:
					Bit		Function
					-------------------------
					DW!external	EXTERNAL
					DW!internal	INTERNAL
					DW!formalArg	DUMMY REF
					DW!forwardRef	FORWARD REF
					DW!safe		SAFE ARRAY
					DW!array	ARRAY
					lastSubLang (0 to 15)
	'declFormal[1:dclSymPtr]  = lastFormal
	'declSize[1:dclSymPtr]  = lastAsize
	'declBlkLvl[1:dclSymPtr]  = blockLevel
	'declCsym[1:dclSymPtr]  = lastCsym
	'declFSM[1:dclSymPtr]  = lastFSM
	'declNargs[1:dclSymPtr]  = lastNargs
	'declRClass[1:dclSymPtr]  = lastRClass

Be careful of detrious calls to MAP!DECLAR.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: MAP!DECLAR>]
 */
INTEGER h, 
	idx, 
	cs, 
	jdx, 
	hlp, 
	updateforwardflag, 
	dw;
STRING s, 
	wmsg;

;
GC_EPOPS(dbug(0200L,catlist(4L,GC_PUSHS("[MAP!DECLAR] token=\'"),GC_PUSHS(token),
        GC_PUSHS("\' dclSymPtr="),cvs(dclsymptr))));
GC_EPOPS(dbug(0200L,catlist(39L,GC_PUSHS("[MAP!DECLAR].0.1 lastProcedure=\'"),
        GC_PUSHS(lastprocedure),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  lastDeclaration=\'"),cvtypes(lastdeclaration),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  lastFormal=\'"),
        GC_PUSHS(lastformal),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  lastAsize=\'"),GC_PUSHS(lastasize),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  blockLevel=\'"),
        cvs(blocklevel),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  lastCsym=\'"),GC_PUSHS(lastcsym),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS("  lastFSM=\'"),cvs(lastfsm),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  lastNargs=\'"),
        cvs(lastnargs),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  lastSubLang=\'"),cvs(lastsublang),GC_PUSHS("\'")
        ,GC_PUSHS(crlf),GC_PUSHS("  lastRClass=\'"),cvs(lastsublang)
        ,GC_PUSHS("\'"))));
GC_EPOPS(dbug(0200L,catlist(23L,GC_PUSHS("[MAP!DECLAR].0.2 blockLevel=\'"),cvs(blocklevel)
        ,GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  lastCsym=\'"),
        GC_PUSHS(lastcsym),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  lastFSM=\'"),cvs(lastfsm),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS("  lastNargs=\'"),cvs(lastnargs),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  lastSubLang=\'"),
        cvs(lastsublang),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  lastRClass=\'"),cvs(lastsublang),GC_PUSHS("\'"))));


/*  ----------------------- */
/*  . . . INITIALIZE . . .  */
/*  ----------------------- */
	GC_POPS(token); /* from GC string PDL */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(token); /* for G.C. */
	GC_NOTESTRING(s); /* for G.C. */
	GC_NOTESTRING(wmsg); /* for G.C. */
	s= token;	/*  -- Do special mapping of redefined keywords! */
	wmsg= PNULL;	/*  -- will have warning mapping if required */
	idx= 0;		/*  -- Default of NEW index of newly created
			  symbol if different from jdx */

if ((*token!='\0'))
	{/* enter it into USER symtab */
/*  ----------------------------------------------------- */
/*  . . . LOOKUP SYMBOL TO SEE IF IT ALREADY EXISTS . . . */
/*  ----------------------------------------------------- */
	jdx= find_symbol(GC_PUSHS(token),&cs,&h);
if (h!=0) GC_EPOPS(dbug(0200L,catlist(4L,GC_PUSHS("[MAP!DECLAR].1.0 OLD NODE["),GC_PUSHS(token),
        GC_PUSHS("]="),prt_node(h))));

/*  --------------------------------------------------------- */
/*  . . . ENTER IT INTO HASH TABLE IF NOT THERE ALREADY . . . */
/*  --------------------------------------------------------- */
	if (h==0) h= put_hash_c(GC_PUSHS(token));   /*  -- force into HASH table */
GC_EPOPS(dbug(0200L,catlist(10L,GC_PUSHS("[MAP!DECLAR].1.1 token=\'"),GC_PUSHS(token),
        GC_PUSHS("\' NEW h="),cvs(h),GC_PUSHS(" jdx="),cvs(jdx),
        GC_PUSHS(crlf),GC_PUSHS(" s=\'"),GC_PUSHS(s),GC_PUSHS("\'"))));
	if (h==0) err_hlr(GC_PUSHS(
        					catlist(GC_PUSHS("[MAP!DECLAR] DRYROT - PUT!HASH!C("),
        GC_PUSHS(token),GC_PUSHS(") is 0!"))));

/*  ----------------------------------------------- */
/*  . . . CHECK FOR MULTIPLY DEFINED SYMBOLS . . .  */
/*  ----------------------------------------------- */
	dw= (*aChkI(decldw,1L,jdx));		/*  -- get it since will do lots of tests */
	if ((blocklevel>=2))
		{/* test if previously defined FORMAL arg */
		if ((dw&040000L)) err_warning(&s); 	/*  -- Watch out!!! */
GC_EPOPS(dbug(0200L,catlist(11L,GC_PUSHS("[MAP!DECLAR].2 lastProcedure=\'"),
        GC_PUSHS(lastprocedure),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" s=\'"),GC_PUSHS(s),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" dw=declDW[jdx]OLD=\'"),cvtypes(dw),GC_PUSHS("\'"))));
		}/* test if previously defined FORMAL arg */

/* 	If existing PROCEDURE names a FORWARD reference at the same
	block level then overwrite it!. Also test for redefinition of
	symbols - i.e. formal may be overwritten by variable or macro
	which may overwrite each other.
 */
	updateforwardflag= (dw&02000000L) &&
					(dw&0100000L);
	if ((jdx>0) &&((*aChkI(declblklvl,1L,jdx))==blocklevel) &&
	   !slobflag &&!isifcflag &&
	   ((dw&02000000L)==0) &&
	    (!updateforwardflag) &&
	   ((dw&01000000L)==0&&lastrclass==0))
		{/* check some more! */
		if ((lastdeclaration&010000L) &&
		   ((*aChkI(decldw,1L,jdx))&04000L) &&
		   ((lastdeclaration&0777777767777L)==
		    ((*aChkI(decldw,1L,jdx))&0777777773777L)))
			{/* Change EXTERNAL to INTERNAL! */
			updateforwardflag= 1L;
			}/* Change EXTERNAL to INTERNAL! */
		else	{/* issue a warning! */
			wmsg= crlf;
			err_deathwish(&wmsg,
			catlist(11L,GC_PUSHS("WARNING!!! Redefining \'"),
				GC_PUSHS(token),
        GC_PUSHS("\' in same block level"),GC_PUSHS(crlf),
        GC_PUSHS("new type=\'"),cvtypes(lastdeclaration),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("Old type=\'"),
        cvtypes((*aChkI(decldw,1L,jdx))),GC_PUSHS("\'")),
					8L, 0L);
			}/* issue a warning! */
		}/* check some more! */

/*  ----------------------------------------------------------- */
/*  . . . MAKE NEW SYMBOL IF NOT FORWARD PROCEDURE UPDATE. . .  */
/*  ----------------------------------------------------------- */
	if (updateforwardflag) idx= jdx; 
	else if ((++dclsymptr)>1600L)
		err_hlr(GC_PUSHS(
 "[MAP!DECLAR] > 1600 declarations in your program. Increase \'maxDeclPtr\' in PSAIL and rebuild PSAIL.")); 
   	else idx= dclsymptr;    /*  -- use the incremented pointer */
GC_EPOPS(dbug(0200L,catlist(6L,GC_PUSHS("[MAP!DECLAR].3 idx="),
			    cvs(idx),GC_PUSHS(" jdx="),
			    cvs(jdx),GC_PUSHS(" dclSymPtr="),
			    cvs(dclsymptr))));

/*  ---------------------------------------------------------------- */
/*  . . . UPDATE SYMBOL TABLE NODE[idx] WITH GLOBAL PARAMETERS . . . */
/*  ---------------------------------------------------------------- */
	(*aChkI(declblklvl,1L,idx))= blocklevel;
	(*aChkC(declcsym,1L,idx))= lastcsym;
	(*aChkC(declformal,1L,idx))= lastformal;  	/*  -- Is non-null for 
					procedure names or if a MACRO
					then the 'saiBody' */
	(*aChkI(declfsm,1L,idx))= lastfsm;
	(*aChkI(declhash,1L,idx))= h;
	(*aChkI(declinproc,1L,idx))= hlp= hash_c(GC_PUSHS(lastprocedure));
	(*aChkI(declnargs,1L,idx))= lastnargs;
	(*aChkI(declrclass,1L,idx))= lastrclass;
	(*aChkC(declsize,1L,idx))= lastasize; /*this will be updated
					 if see '['*/
				/*  -- Add additional symtab bits -- */
	pdw_sublanguage(lastdeclaration,lastsublang);
	(*aChkI(decldw,1L,idx))= lastdeclaration;

	if (jdx==0||(lastdeclaration&01000000L)==0) (*aChkI(dwptr,1L,h))= idx;  /*  -- Set backwards hashed pointer to
				      index idx. Note: Do not set
				      it to this NODE if it is a 
				      Record CLASS|PTR|MEM if there is 
				      another non-RECORD there already */
GC_EPOPS(dbug(0200L,catlist(4L,GC_PUSHS("[MAP!DECLAR].4 NEW NODE["),GC_PUSHS(token),
        GC_PUSHS("]="),prt_node(h))));
	}/* enter it into USER symtab */

else s= PNULL;				/*  -- NULL token */

if (*wmsg!='\0') 
	{/* add error msg */
	if (*s=='\0') s= wmsg; 
	else s= catlist(2L,GC_PUSHS(s),GC_PUSHS(wmsg));		/*  -- Add on ERROR message */
	}/* add error msg */
{/* INCSTAT */ if (usereportflag) (*aChkI(errstatistics,1L,21L))= (*aChkI(errstatistics,1L,21L))+1L;
		     }/* INCSTAT */
GC_EPOPS(dbug(0200L,catlist(4L,GC_PUSHS("[MAP!DECLAR].5 s=\'"),GC_PUSHS(s),
        GC_PUSHS("\' Max USYMBOLS="),cvs((*aChkI(errstatistics,1L,
        21L))))));
;
GC_SRETURN(s)
}/* MAP!DECLAR */
