/* FILE: map_embedded-comments.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psparse.c, being converted 12/25/87, 09:34:41PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ----------------------------------------------------- */
/*INTERNAL*/  STRING map_embedded_comments(si)
	STRING si;
/*  ----------------------------------------------------- */
{/* MAP!EMBEDDED!COMMENTS */
/*  --
.LABEL [<++PSAIL PROCEDURE: MAP!EMBEDDED!COMMENTS>]
.INDEX ++PSAIL PROCEDURE: MAP!EMBEDDED!COMMENTS
DESCRIPTION:
	Remove all embedded C style comments delimiters as for example:
		'/ *' ... '* /'
	to
		      ...

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: MAP!EMBEDDED!COMMENTS>]
 */
STRING s, 
	sout;
INTEGER ch;

;

/*  # # DBUG('200,"[MAP!EMBEDDED!COMMENTS] sI='"&sI&"'") */
GC_POPS(si); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(si); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(sout); /* for G.C. */
sout= "@";				/*  -- add prefix  */
while (*si!='\0')
	{/* process input string */
	s= GC_EPOPS(scan(&si,17L,&ch));		/*  -- scan for '* or /'  */
	if (*s!='\0')
		{/* copy data */
		sout= catlist(2L,GC_PUSHS(sout),GC_PUSHS(s));
		}/* copy data */

	if ((ch=='/'&&*si=='*') ||(ch=='*'&&*si=='/')) 
		{/* trash the other part of delimiter */
		ch= LOP(si);
		}/* trash the other part of delimiter */
	else if (ch!='\0')
		{/* copy data */
		if (*sout=='\0') sout= GC_EPOPS(makstr(ch
		)); else sout= catlist(2L,GC_PUSHS(sout),makstr(ch));   /*  -- else Copy break character */
		}/* copy data */
	}/* process input string */
ch= LOP(sout);				/*  -- trash the '@' prefix */
GC_EPOPS(dbug(0200L,catlist(3L,GC_PUSHS("[MAP!EMBEDDED!COMMENTS].1 sOut=\'"),
        GC_PUSHS(sout),GC_PUSHS("\'"))));

;
GC_SRETURN(sout)
}/* MAP!EMBEDDED!COMMENTS */
