/* FILE: map_expr.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psparse.c, being converted 12/25/87, 09:34:41PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ----------------------------------------------------- */
/*INTERNAL*/  STRING map_expr(h)
	INTEGER h;
/*  ----------------------------------------------------- */
{/* MAP!EXPR */
/*  --
.LABEL [<++PSAIL PROCEDURE: MAP!EXPR>]
.INDEX ++PSAIL PROCEDURE: MAP!EXPR
DESCRIPTION:
	Call a FSM to map the SAIL token (possibly doing this
recursively) and return the corresponding C code translation..
NOTE: CHK!EMIT() is a macro and can not be optimized into a
function to save space since it has to delay EVALing the FSM until
AFTER it pushes any required EMIT code!
However, we can pass the name of the FSM by REFERENCE PROCEDURE and
the arg h so as to do this in using the doCkEmitFlag code also
in macro CHK!EMIT(). We must be VERY VERY careful to make sure that
table 'doCHKEMIT[opr]' and the 'Case (opr)' match.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: MAP!EXPR>]
 */
STRING s, 
	semit;
INTEGER idx, 
	opr, 
	dockemitflag;

 static INTEGER /*ARRAY*/ P_dochkemit[13+(73-0+1L)] = { 
   0,0,0,0,0,0,0,0,0,0,0,0,0, 0,	/*  -- [0] SIMPLE!MAP */
   0,	/*  -- [1] DEFINE */
   TRUE,	/*  -- [2] CASE */
   TRUE,	/*  -- [3] FOR */
   0,	/*  -- [4] [ */
   TRUE,	/*  -- [5] WHILE */
   TRUE,	/*  -- [6] DO */
   0,	/*  -- [7] & */
   0,	/*  -- [8] COMMENT */
   0,	/*  -- [9] quote */
   0,	/*  -- [10] # or id==COMMENT */
   0,	/*  -- [11] <declar. list>. */
   0,	/*  -- [12] PROCEDURE decl. */
   0,	/*  -- [13] LET */
   0,	/*  -- [14] infixOP */
   TRUE,	/*  -- [15] LOCATION @V.56.136 */
   TRUE,	/*  -- [16] MEMORY @V.56.136 */
   0,	/*  -- [17] REQUIRE */
   0,	/*  -- [18] BINOP& */
   0,	/*  -- [19] BINOP */
   0,	/*  -- [20] <LOGIC >32-bits test> */
   TRUE,	/*  -- [21] START!CODE */
   0,	/*  -- [22] PRELOAD!WITH */
   0,	/*  -- [23] <shift> - */
   0,	/*  -- [24] BEGIN */
   TRUE,	/*  -- [25] END @V.56.136 */
   0,	/*  -- [26] <Reference fn>(-) */
   TRUE,	/*  -- [27] IF */
   TRUE,	/*  -- [28] GO */
   0,	/*  -- [29] ARRAY/C!ARRAY */
   0,	/*  -- [30] ELSE */
   0,	/*  -- [31] <Ill.SAIL-syntax> */
   TRUE,	/*  -- [32] PRINT */
   TRUE,	/*  -- [33] OUTSTR */
   0,	/*  -- [34] REFER./VALUE */
   TRUE,	/*  -- [35] := */
   0,	/*  -- [36] ^ */
   0,	/*  -- [37] FORWARD/EXTERNAL */
   0,	/*  -- [38] CPX REL */
   TRUE,	/*  -- [39] RETURN */
   0,	/*  -- [40] INTERNAL */
   0,	/*  -- [41] RECORD!CLASS/!POINTER */
   TRUE,	/*  -- [42] NEW!RECORD */
   0,	/*  -- [43] COMPILER!SWITCHES */
   0,	/*  -- [44] : (was TRUE as of @V.56.04) */
   0,	/*  -- [45] / */
   0,	/*  -- [46] IF-expression */
   0,	/*  -- [47] CASE-expression */
   0,	/*  -- [48] PSAIL!FORGET */
   0,	/*  -- [49] PSAIL!DEFINE */
   0,	/*  -- [50] EQU */
   0,	/*  -- [51] Map C keyword */
   TRUE,	/*  -- [52] ARRTRAN */
   TRUE,	/*  -- [53] ARRCLR */
   0,	/*  -- [54] <coerce MACRO> */
   TRUE,	/*  -- [55] PUT/REMOVE<leap item> */
   TRUE,	/*  -- [56] MAKE/ERASE<leap triple> */
   TRUE,	/*  -- [57] NEW<leap> */
   TRUE,	/*  -- [58] DATUM<leap> */
   TRUE,	/*  -- [59] FOREACH<leap> */
   0,	/*  -- [60] 1:1 Map, preserve type */
   0,	/*  -- [61] IFC */
   0,	/*  -- [62] <AWK-like-macro-remap> */
   0,	/*  -- [63] <semiColon> */
   0,	/*  -- [64] {<LEAP-SET> */
   0,	/*  -- [65] (<LEAP-LIST> */
   0,	/*  -- [66] XOR/ASSOC/EQV */
   0,	/*  -- [67] <SAFE-list/GENERIC> */
   TRUE,	/*  -- [68] <CONT./DONE> */
   TRUE,	/*  -- [69] NEXT */
   0,	/*  -- [70] ABS */
   TRUE,	/*  -- [71] <proc-call-args> */
   TRUE,	/*  -- [72] <GENERIC proc-calls> @V.56.136 */
   0 };
 static INTEGER /*ARRAY*/ *dochkemit  /* [0:maxfsms] */ ;
	  /*  -- if TRUE do CHK!EMIT */

;

GC_EPOPS(dbug(010000L,catlist(28L,GC_PUSHS("[MAP!EXPR] \'rule\' ["),GC_PUSHS(*aChkC(saisym,
        1L,h)),GC_PUSHS("] blockLevel="),cvs(blocklevel),
        GC_PUSHS(crlf),GC_PUSHS(" locIptr="),cvs(lociptr),
        GC_PUSHS(" locSptr="),cvs(locsptr),GC_PUSHS(" locAptr="),
        cvs(locaptr),GC_PUSHS(" emitEnableFlag="),
        pbool(emitenableflag),GC_PUSHS(crlf),
        GC_PUSHS("  didMainEmit="),pbool(didmainemit),
        GC_PUSHS(" didLOCemit="),pbool(didlocemit),GC_PUSHS(crlf),
        GC_PUSHS("  oldToken=\'"),GC_PUSHS(oldtoken),
        GC_PUSHS("\' midOfExpr="),pbool(midofexpr),
        GC_PUSHS(" isIfExpr="),pbool(isifexpr),
        GC_PUSHS(" lastMappedToken=\'"),GC_PUSHS(lastmappedtoken),
        GC_PUSHS("\'"))));
GC_EPOPS(dbug(010000L,catlist(16L,GC_PUSHS("[MAP!EXPR].0.1 sPDLptr="),cvs(spdlptr),
        GC_PUSHS(" nPDLptr="),cvs(npdlptr),GC_PUSHS(crlf),
        GC_PUSHS(" blockLevel="),cvs(blocklevel),GC_PUSHS(crlf),
        GC_PUSHS(" dclSymPtr="),cvs(dclsymptr),GC_PUSHS(crlf),
        GC_PUSHS("  lastDeclaration="),cvos(lastdeclaration),
        GC_PUSHS("(8)=\'"),cvtypes(lastdeclaration),GC_PUSHS("\'"))));

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(semit); /* for G.C. */
dochkemit = aryHdrI(P_dochkemit,1,0,73,"dochkemit",'i');	/* Dynamic Array */
idx= (*aChkI(dwptr,1L,h));		/*  -- map hash index to decl DB index */


opr= (*aChkI(declfsm,1L,idx))&0177777;
if (opr==27&&midofexpr &&
	(isifexpr ||*lastmappedtoken=='+' ||*lastmappedtoken=='-' ||
	 *lastmappedtoken=='&' ||*lastmappedtoken==',' ||
	 *lastmappedtoken=='(' ||fast_equ(GC_PUSHS(lastmappedtoken),GC_PUSHS(":=")) ||
         fast_equ(GC_PUSHS(lastmappedtoken),GC_PUSHS("print")) )) opr= 46;		/*  -- i.e. <if-expr> or <if-statement>
				we must hand test. This must be done
				here rather than in the CASE
				statement in order to determine if it
				is a <if-statement> or
				<if-expression> so as to do the
				EMIT!LOC!CODE before the case
				statement. */

dockemitflag= (emitenableflag &&!didlocemit &&(*aChkI(dochkemit,1L,opr)) &&
		!midofexpr &&!ismacroflag);

GC_EPOPS(dbug(010000L,catlist(16L,GC_PUSHS("[MAP!EXPR].0.2 idx="),cvs(idx),GC_PUSHS(" opr=")
        ,cvs(opr),GC_PUSHS(" declFSM[idx]="),cvs((*aChkI(declfsm,1L,
        idx))&0177777),GC_PUSHS(crlf),GC_PUSHS(" doCHKEMIT[opr]="),
        pbool((*aChkI(dochkemit,1L,opr))),GC_PUSHS(" doCkEmitFlag=")
        ,pbool(dockemitflag),GC_PUSHS(" isFRAGMENTflag="),
        pbool(isfragmentflag),GC_PUSHS(crlf),GC_PUSHS(
        " declDW[idx]="),cvtypes((*aChkI(decldw,1L,idx))))));
if (usebacktraceflag) (*aChkC(errfsm,1L,rdlevel))= catlist(3L,GC_PUSHS(*aChkC(errfsm,1L,rdlevel)),GC_PUSHS(" "),cvs(opr));   /*  -- save backtrace in case error */

if (dockemitflag) 
	{/* do EMIT */
	semit= GC_EPOPS(emit_loc_code());  /*  -- get emitted code now
			before we eval sFCT! A side
			effect is to set didLOCemit */
	(*aChkI(emitepdl,1L,++eeptr))= emitenableflag;
	emitenableflag= 0L;
	push(GC_PUSHS(semit));	/*  -- NOTE PUSH IS CONDITIONAL!!!! */
	}/* do EMIT */
else semit= PNULL;

pushnumber(idx);
pushnumber(dockemitflag);
/*  -- N.B. - Be careful about changing what we PUSH/POP here since
FSM44 modfies the last token on the stack i.e. changes ':' to ':='.
Therefore, the last thing to be pushed MUST be saiToken.
 */
push(GC_PUSHS(saitoken));		/*  -- so we can set lastMappedToken */

switch (opr)
	{/* eval */
/*[0] SIMPLE!MAP*/  	case 0: s= GC_EPOPS(fsm0(h)); break;	/*Do 1:1 mapping, prop type*/
/*[1] DEFINE*/		case 1: s= GC_EPOPS(fsm1(h)); break;
/*[2] CASE*/		case 2: s= GC_EPOPS(fsm2(h)); break;
/*[3] FOR*/		case 3: s= GC_EPOPS(fsm3(h)); break;
/*[4] [*/			case 4: if (((lastdeclaration&0200L)!=0) ||
			   fast_equ(GC_PUSHS(oldtypestatement),GC_PUSHS("preload_with"))) s= GC_EPOPS(fsm4a(h) )default:  s= GC_EPOPS(fsm4(h)); break;
/*[5] WHILE*/		case 5: s= GC_EPOPS(fsm5(h)); break;
/*[6] DO*/		case 6: s= GC_EPOPS(fsm6(h)); break;
/*[7] &*/			case 7: s= GC_EPOPS(fsm7(h)); break;
/*[8] COMMENT*/		case 8: s= GC_EPOPS(fsm8(h)); break;
/*[9] quote*/		case 9: s= GC_EPOPS(fsm9(h)); break;
/*[10] # or id==COMMENT*/ case 10: s= GC_EPOPS(fsm10(h)); break;
/*[11] <declar. list>.*/  case 11: s= GC_EPOPS(fsm11(h)); break;
/*[12] PROCEDURE decl.*/	case 12: s= GC_EPOPS(fsm12(h)); break;
/*[13] LET*/  		case 13: s= GC_EPOPS(fsm13(h)); break;
/*[14] infixOP*/		case 14: s= GC_EPOPS(fsm14(h)); break;
/*[15] LOCATION*/		case 15: s= GC_EPOPS(fsm15(h)); break;
/*[16] MEMORY*/		case 16: s= GC_EPOPS(fsm16(h)); break;
/*[17] REQUIRE*/		case 17: s= GC_EPOPS(fsm17(h)); break;
/*[18] BINOP&*/		case 18: s= GC_EPOPS(fsm18(h)); break;
/*[19] BINOP*/		case 19: s= GC_EPOPS(fsm19(h)); break;
/*[20] <LOGIC >32-bits test>*/	case 20: s= GC_EPOPS(fsm20(h)); break;
/*[21] START!CODE*/ 	case 21: s= GC_EPOPS(fsm21(h)); break;
/*[22] PRELOAD!WITH*/  	case 22: s= GC_EPOPS(fsm22(h)); break;
/*[23] <shift> -*/ 	case 23: s= GC_EPOPS(fsm23(h)); break;
/*[24] BEGIN*/		case 24: s= GC_EPOPS(fsm24(h)); break;
/*[25] END*/		case 25: s= GC_EPOPS(fsm25(h)); break;
/*[26] <Reference fn>(-)*/  case 26: s= GC_EPOPS(fsm26(h)); break;
/*[27] IF*/		case 27: s= GC_EPOPS(fsm27(h)); break;
/*[28] GO*/		case 28: s= GC_EPOPS(fsm28(h)); break;
/*[29] <free>*/	case 29: s= GC_EPOPS(fsm29(h)); break;
/*[30] ELSE*/		case 30: s= GC_EPOPS(fsm30(h)); break;
/*[31] <Ill.SAIL-syntax>*/ case 31: s= GC_EPOPS(fsm31(h)); break;
/*[32] PRINT*/		case 32: s= GC_EPOPS(fsm32(h)); break;
/*[33] OUTSTR*/		case 33: s= GC_EPOPS(fsm33(h)); break;
/*[34] REFER./VALUE*/	case 34: s= GC_EPOPS(fsm34(h)); break;
/*[35] :=*/		case 35: s= GC_EPOPS(fsm35(h)); break;
/*[36] ^*/		case 36: s= GC_EPOPS(fsm36(h)); break;
/*[37] FORWARD/EXTERNAL*/	case 37: s= GC_EPOPS(fsm37(h)); break;
/*[38] CPX REL*/		case 38: s= GC_EPOPS(fsm38(h)); break;
/*[39] RETURN*/		case 39: s= GC_EPOPS(fsm39(h)); break;
/*[40] INTERNAL*/		case 40: s= GC_EPOPS(fsm40(h)); break;
/*[41] RECORD!CLASS/!POINTER*/	case 41: s= GC_EPOPS(fsm41(h)); break;
/*[42] NEW!RECORD*/	case 42: s= GC_EPOPS(fsm42(h)); break;
/*[43] COMPILER!SWITCHES*/  case 43: s= GC_EPOPS(fsm43(h)); break;
/*[44] :*/		case 44: s= GC_EPOPS(fsm44(h)); break;
/*[45] /*/		case 45: s= GC_EPOPS(fsm45(h)); break;
/*[46] IF-expression*/ 	case 46: s= GC_EPOPS(fsm46(h)); break;
/*[47] CASE-expression*/ 	case 47: s= GC_EPOPS(fsm47(h)); break;
/*[48] PSAIL!FORGET*/ 	case 48: s= GC_EPOPS(fsm48(h)); break;
/*[49] PSAIL!DEFINE*/ 	case 49: s= GC_EPOPS(fsm49(h)); break;
/*[50] EQU*/ 		case 50: s= GC_EPOPS(fsm50(h)); break;
/*[51] Map C keyword*/ 	case 51: s= GC_EPOPS(fsm51(h)); break;
/*[52] ARRTRAN*/ 		case 52: s= GC_EPOPS(fsm52(h)); break;
/*[53] ARRCLR*/ 		case 53: s= GC_EPOPS(fsm53(h)); break;
/*[54] <coerce MACRO>*/ 	case 54: s= GC_EPOPS(fsm54(h)); break;
/*[55] PUT/REMOVE<leap item>*/ case 55: s= GC_EPOPS(fsm55(h)); break;
/*[56] MAKE/ERASE<leap triple>*/ case 56: s= GC_EPOPS(fsm56(h)); break;
/*[57] NEW<leap>*/ 	case 57: s= GC_EPOPS(fsm57(h)); break;
/*[58] DATUM<leap>*/ 	case 58: s= GC_EPOPS(fsm58(h)); break;
/*[59] FOREACH<leap>*/ 	case 59: s= GC_EPOPS(fsm59(h)); break;
/*[60] 1:1 Map, preserve type*/ 	case 60: s= GC_EPOPS(fsm60(h)); break;
/*[61] IFC*/ 		case 61: s= GC_EPOPS(fsm61(h)); break;
/*[62] <AWK-like-macro-remapper*/ 	case 62: s= GC_EPOPS(fsm62(h)); break;
/*[63] <semiColon>*/ 	case 63: s= GC_EPOPS(fsm63(h)); break;
/*[64] {<LEAP-SET>*/ 	case 64: s= GC_EPOPS(fsm64(h)); break;
/*[65] (<LEAP-LIST>*/ 	case 65: s= GC_EPOPS(fsm65(h)); break;
/*[66] XOR/ASSOC/EQV*/ 	case 66: s= GC_EPOPS(fsm66(h)); break;
/*[67] <SAFE-list/GENERIC>*/ 	case 67: s= GC_EPOPS(fsm67(h)); break;
/*[68] <CONT./DONE>*/ 	case 68: s= GC_EPOPS(fsm68(h)); break;
/*[69] NEXT*/ 		case 69: s= GC_EPOPS(fsm69(h)); break;
/*[70] ABS*/ 		case 70: s= GC_EPOPS(fsm70(h)); break;
/*[71] <proc-call-args>*/ case 71: s= GC_EPOPS(fsm71(h)); break;
/*[72] <GENERIC proc-calls>*/  case 72: s= GC_EPOPS(fsm72(h)); break;
/*[73] <SYMTAB type tests>*/  case 73: s= GC_EPOPS(fsm73(h)); break;
	}/* eval */

pop(&lastmappedtoken);  /*  -- i.e. name of symbol which invoked this FSM
			-- unless was modified by the FSM */
popnumber(&dockemitflag);
popnumber(&idx);

if (dockemitflag)
	{/* Add sEmit here */
	pop(&semit);	/*  -- this was conditionally pushed */
	emitenableflag= (*aChkI(emitepdl,1L,(--eeptr)+1L));
	if (*semit!='\0')
		{/* fix up string */
		if (*s=='\0') s= semit; 
		else s= catlist(2L,GC_PUSHS(semit),GC_PUSHS(s));
		}/* fix up string */
	}/* Add sEmit here */

/*  ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !  */
/*  ! NOTE WELL ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !  */
/*  ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !  */
if (lasttype!=0) (*aChkI(decldw,1L,idx))= lasttype|0100L; 	/*  -- <=== THIS IS WHERE
						WE PROPAGATE THE TYPE
						but remember that
						it is a FSM!!! */
islastexecutableexpr= (*aChkI(dochkemit,1L,(*aChkI(declfsm,1L,idx))&0177777)); /*  -- i.e.
				pass on whether this was an
				executable expr or not */

GC_EPOPS(dbug(010000L,catlist(32L,GC_PUSHS("[MAP!EXPR].2 saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  locIptr="),cvs(lociptr),GC_PUSHS(" locSptr="),
        cvs(locsptr),GC_PUSHS(" locAptr="),cvs(locaptr),GC_PUSHS(
        crlf),GC_PUSHS(" s=\'"),GC_PUSHS(s),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS("  lastType="),cvos(lasttype),
        GC_PUSHS("(8)=\'"),cvtypes(lasttype),GC_PUSHS(crlf),
        GC_PUSHS("\' declDW[idx="),cvs(idx),GC_PUSHS("]="),
        cvos((*aChkI(decldw,1L,idx))),GC_PUSHS("(8)=\'"),
        cvtypes((*aChkI(decldw,1L,idx))),GC_PUSHS(crlf),
        GC_PUSHS("\' oldToken=\'"),GC_PUSHS(oldtoken),
        GC_PUSHS("\' oldTypeStatement=\'"),
        GC_PUSHS(oldtypestatement),GC_PUSHS("\'"))));
GC_EPOPS(dbug(010000L,catlist(22L,GC_PUSHS("[MAP!EXPR].2.1 locSptr="),cvs(locsptr),
        GC_PUSHS(" locAptr="),cvs(locaptr),GC_PUSHS(crlf),
        GC_PUSHS(" didMainEmit="),pbool(didmainemit),
        GC_PUSHS(" didLOCemit="),pbool(didlocemit),
        GC_PUSHS(" lastMappedToken=\'"),GC_PUSHS(lastmappedtoken),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" sEmit=\'"),
        GC_PUSHS(semit),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" is FRAGMENTflag="),pbool(isfragmentflag),
        GC_PUSHS(" oldToken=\'"),GC_PUSHS(oldtoken),GC_PUSHS("\'"))));
GC_EPOPS(dbug(010000L,catlist(17L,GC_PUSHS("[MAP!EXPR].2.2 sPDLptr="),cvs(spdlptr),
        GC_PUSHS(" nPDLptr="),cvs(npdlptr),GC_PUSHS(" blockLevel="),
        cvs(blocklevel),GC_PUSHS(crlf),
        GC_PUSHS("  isLastExecutableExpr="),
        pbool(islastexecutableexpr),GC_PUSHS("  midOfExpr="),
        pbool(midofexpr),GC_PUSHS(crlf),GC_PUSHS(
        "  lastDeclaration="),cvos(lastdeclaration),GC_PUSHS(
        "(8)=\'"),cvtypes(lastdeclaration),GC_PUSHS("\'"))));
GC_EPOPS(dbug(010000L,catlist(11L,GC_PUSHS("[MAP!EXPR].2.3 errLine["),cvs(rdlevel),
        GC_PUSHS("]=\'"),GC_PUSHS((*aChkC(errline,1L,rdlevel))),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" errFSM["),
        cvs(rdlevel),GC_PUSHS("]=\'"),GC_PUSHS((*aChkC(errfsm,1L,
        rdlevel))),GC_PUSHS("\'"))));

;
GC_SRETURN(s)
}/* MAP!EXPR */
