/* FILE: map_inf.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psparse.c, being converted 12/25/87, 09:34:41PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ----------------------------------------------------- */
/*INTERNAL*/  STRING map_inf(txt,id)
	STRING txt;
	STRING id;
/*  ----------------------------------------------------- */
{/* MAP!INF */
/*  --
.LABEL [<++PSAIL PROCEDURE: MAP!INF>]
.INDEX ++PSAIL PROCEDURE: MAP!INF
DESCRIPTION:
	If the token 'inf' occurs in a substring expression, this is
mapped to 'length('&id&')' for each occurance.
	[1] map all 'inf' to '__inf_temp__'.
	[2] R!D new expr.
	[3] map all '__inf_temp__' to 'length(id)'.
	[4] if <id> is a string constant then return CVS(LENGTH(id)-2).
@V.51.94 -- we could easily generalized this for other things than
just INF ... later...
@V.54.01 return the type of the R!D'ed 'txt' expr.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: MAP!INF>]
 */
STRING s, 
	s1, 
	tok, 
	nomore;
INTEGER ch, 
	isstrconst;

;

/*  # # DBUG('400000,"[MAP!INF] txt='"&txt&"' id='"&id&"'") */

/* 	[1] map all 'inf' to '__inf_temp__'. NOTE that if
	we eval a string constant it has SAIL ASCII not C type
	non-printing codes! */
GC_POPS(id); /* from GC string PDL */
GC_POPS(txt); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(txt); /* for G.C. */
GC_NOTESTRING(id); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(tok); /* for G.C. */
GC_NOTESTRING(nomore); /* for G.C. */
if ((isstrconst= chk_sconst(GC_PUSHS(id),&s1,1L))) id= s1;			/*  -- use the string instead */
s= "@";					/*  -- add prefix */
while ((*txt!='\0'))
	{/* check for 'inf' */
	tok= GC_EPOPS(get_token(&txt));		/*  -- get whatever */
	s= catlist(2L,GC_PUSHS(s),GC_PUSHS((fast_equ(GC_PUSHS(tok),
        GC_PUSHS("inf"))) ? 
        			"__inf_temp__" 
        			: tok));
	}/* check for 'inf' */
ch= LOP(s);				/*  -- trash '@' */
/*  # # DBUG('400000,"[MAP!INF].1 s='"&s&"'") */

/* 	[2] R!D new expr. */
pushnumber(isstrconst); push(GC_PUSHS(id));
s1= GC_EPOPS(r_d_expr_map(GC_PUSHS(s)));
pop(&id); popnumber(&isstrconst);
/*  # # DBUG('400000,"[MAP!INF].2 s1='"&s1&"'") */

/*  -- 	[3] map all '__inf_temp__' to 'length(id)'. */
s= "@";
while ((*s1!='\0'))
	{/* check for '__inf_temp__' */
	tok= GC_EPOPS(get_c_token(&s1,&(nomore= PNULL)));	/*  -- get whatever */
	s= catlist(2L,GC_PUSHS(s),GC_PUSHS((fast_equ(GC_PUSHS(tok),
        GC_PUSHS("__inf_temp__"))) ? 
        			((isstrconst) ? 
        					GC_EPOPS(cvs(length(GC_PUSHS(id)))
        				): catlist(3L,GC_PUSHS("length("),GC_PUSHS(id),
        GC_PUSHS(")")))
        			: tok));
	}/* check for '__inf_temp__' */
ch= LOP(s);			/*  -- Trash the '@' prefix */

if (isstrconst)
	{/* fold it it possible */
	s= GC_EPOPS(fold_const_expr(GC_PUSHS(s)));
GC_EPOPS(dbug(0400000L,catlist(7L,GC_PUSHS("[MAP!INF].3 s=\'"),GC_PUSHS(s),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" lastType=\'"),cvtypes(lasttype),
        GC_PUSHS("\'"))));
	}/* fold it it possible */

GC_EPOPS(dbug(0400000L,catlist(7L,GC_PUSHS("[MAP!INF].4 s=\'"),GC_PUSHS(s),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" lastType=\'"),cvtypes(lasttype),
        GC_PUSHS("\'"))));
;
GC_SRETURN(s)
}/* MAP!INF */
