/* FILE: map_leap_triple.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psparse.c, being converted 12/25/87, 09:34:41PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ----------------------------------------------------- */
/*INTERNAL*/ STRING map_leap_triple(si)
	STRING *si;
/*  ----------------------------------------------------- */
{/* MAP!LEAP!TRIPLE */
/*  --
.LABEL [<++PSAIL PROCEDURE: MAP!LEAP!TRIPLE>]
.INDEX ++PSAIL PROCEDURE: MAP!LEAP!TRIPLE
DESCRIPTION:
	Map a leap triple in the input string to an arg list
reference call (without '(...)').
	From SAIL:	a XOR b EQV c
	To 	 :	a,b,c

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: MAP!LEAP!TRIPLE>]
 */
STRING s, 
	s1, 
	a, 
	o, 
	v;
INTEGER thistype;

;

GC_EPOPS(dbug(0400000L,catlist(2L,GC_PUSHS("[MAP!LEAP!TRIPLE] sI=\'"),GC_PUSHS(*si))));
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(si); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(a); /* for G.C. */
GC_NOTESTRING(o); /* for G.C. */
GC_NOTESTRING(v); /* for G.C. */
push(GC_PUSHS(saistatement)); pushnumber(lasttype);
thistype= 020000L;
pdw_ptype(thistype,codeitem);
saistatement= *si;
s1= GC_EPOPS(remove_white_ends(copy_omit(GC_PUSHS("xor"))));
/*  # # DBUG('400000,"[MAP!LEAP!TRIPLE].1 s1='"&s1) */
a= GC_EPOPS(r_d_expr_map(GC_PUSHS(s1)));
if (!isleapcode(lasttype)) a= GC_EPOPS(cvactual_to_expected(thistype,lasttype,GC_PUSHS(a)));
push(GC_PUSHS(a));

s1= GC_EPOPS(remove_white_ends(copy_omit(GC_PUSHS("eqv"))));
/*  # # DBUG('400000,"[MAP!LEAP!TRIPLE].2 a="&a&" s1='"&s1) */
o= GC_EPOPS(r_d_expr_map(GC_PUSHS(s1)));
if (!isleapcode(lasttype)) o= GC_EPOPS(cvactual_to_expected(thistype,lasttype,GC_PUSHS(o)));
push(GC_PUSHS(o));

s1= GC_EPOPS(remove_white_ends(GC_PUSHS(saistatement)));
/*  # # DBUG('400000,"[MAP!LEAP!TRIPLE].3 o="&o&" s1='"&s1) */
v= GC_EPOPS(r_d_expr_map(GC_PUSHS(s1)));
if (!isleapcode(lasttype)) v= GC_EPOPS(cvactual_to_expected(thistype,lasttype,GC_PUSHS(v)));
/*  # # DBUG('400000,"[MAP!LEAP!TRIPLE].4 v='"&v) */

pop(&o);
pop(&a);
s= catlist(5L,GC_PUSHS(a),GC_PUSHS(","),GC_PUSHS(o),GC_PUSHS(","),
        GC_PUSHS(v));
GC_EPOPS(dbug(0400000L,catlist(3L,GC_PUSHS("[MAP!LEAP!TRIPLE].5 s=\'"),GC_PUSHS(s),
        GC_PUSHS("\'"))));

popnumber(&lasttype); pop(&saistatement);
;
GC_SRETURN(s)
}/* MAP!LEAP!TRIPLE */
