/* FILE: map_whitespace.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psparse.c, being converted 12/25/87, 09:34:41PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ----------------------------------------------------- */
/*INTERNAL*/  void map_whitespace(s)
	STRING *s;
/*  ----------------------------------------------------- */
{/* MAP!WHITESPACE */
/*  --
.LABEL [<++PSAIL PROCEDURE: MAP!WHITESPACE>]
.INDEX ++PSAIL PROCEDURE: MAP!WHITESPACE
DESCRIPTION:
	Scan off leading white space and append to s. Whitespace may
be SPACE, TAB, FF, CR, LF.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: MAP!WHITESPACE>]
 */
STRING ws;
INTEGER brk;

;

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(ws); /* for G.C. */
ws= GC_EPOPS(scan(&saistatement,37L,&brk));	/*  -- scan and append space, tab, CR,
							LF, FF */
if (*ws!='\0')
	{/* add it on to s */
	if (*(*s)=='\0') *s= ws; 
	else *s= catlist(2L,GC_PUSHS(*s),GC_PUSHS(ws));
	}/* add it on to s */
/*  # # DBUG('200,"[MAP!WHITESPACE] s='"&s&"'") */

;
{GC_UNMARKSSTKFRAME;}
}/* MAP!WHITESPACE */
