/* FILE: map_ws_comments.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psparse.c, being converted 12/25/87, 09:34:41PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ----------------------------------------------------- */
/*INTERNAL*/  STRING map_ws_comments(s,scansailflag)
	STRING *s;
	INTEGER scansailflag;
/*  ----------------------------------------------------- */
{/* MAP!WS!COMMENTS */
/*  --
.LABEL [<++PSAIL PROCEDURE: MAP!WS!COMMENTS>]
.INDEX ++PSAIL PROCEDURE: MAP!WS!COMMENTS
DESCRIPTION:
	Scan 'saiStatement' for 'COMMENT'...<SC>. If Not scanSAILflag
then map these to C style comments ..., otherwise just copy them
on through. Keep reading file input until get a semicolon. Also copy
white space before and after comments. The FSM should be able to
handle several comments in succession. If not in the middle of a
statement, then also accept "..." type comments.

NOTE: @V.45.229 If we see <symbol>: then try to parse as label which
will then be absorbed and treated as white space.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: MAP!WS!COMMENTS>]
 */
STRING s1, 
	s2, 
	token;
INTEGER ch, 
	oldtype;

;

GC_EPOPS(dbug(0200L,catlist(16L,GC_PUSHS("[MAP!WS!COMMENTS] midOfExpr="),pbool(midofexpr),
        GC_PUSHS(" scanSAILflag="),pbool(scansailflag),
        GC_PUSHS(crlf),GC_PUSHS(" |saiStatement|="),
        cvs(length(GC_PUSHS(saistatement))),
        GC_PUSHS("  saiStatement=\'"),GC_PUSHS(saistatement),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" |s|="),
        cvs(length(GC_PUSHS(*s))),GC_PUSHS("  s=\'"),GC_PUSHS(*s),
        GC_PUSHS("\'"))));

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(token); /* for G.C. */
oldtype= lasttype;
do  {/* Munch for WS, CMNTS & LABELS */
/*  # # DBUG('200,"[MAP!WS!COMMENTS].1 s='"&s&"'"&CRLF&"  saiStatement='"&saiStatement&"'"&CRLF&"  |(saiStatement)|="&CVS(LENGTH(saiStatement))) */
   map_whitespace(s);  		/*  -- Eat up white space */
/*  # # DBUG('200,"[MAP!WS!COMMENTS].1.1 AFTER W.S. s='"&s&"'"&CRLF&"  saiStatement='"&saiStatement&"'"&CRLF&"  |saiStatement|="&CVS(LENGTH(saiStatement))) */

   if ((*saistatement==*quote))
	{/* quote type comment */
	if (midofexpr) break;		/*  -- Sorry, it is real data! */
	push(GC_PUSHS(oldtoken));
	ch= LOP(saistatement);
	oldtoken= ";";			/*  -- Fake out FSM9 */
	s1= GC_EPOPS(fsm9(hquote));
	if (*(*s)=='\0') *s= s1;  
		else *s= catlist(2L,GC_PUSHS(*s),GC_PUSHS(s1));
	pop(&oldtoken);
	}/* quote type comment */

   else if ((*saistatement=='c') &&
	      equ(subsr(GC_PUSHS(saistatement),1L,7L),GC_PUSHS("comment")) &&
	      !isvariable((*(saistatement+8-1))))
		{/* found a comment */
/*  # # DBUG('200,"[MAP!WS!COMMENTS].1.2 COMMENT saiStatement='"&saiStatement&"'") */
		if (*saistatement=='#') ch= LOP(saistatement); 
			else saistatement= subst(GC_PUSHS(saistatement),8L,length(saistatement));
		s1= GC_EPOPS(scan(&saistatement,10L,&ch));	/*  --  Scan for <SC>   */
		if (!scansailflag) s1= GC_EPOPS(map_embedded_comments(GC_PUSHS(s1)));
		if (ch!=';'&&ismacroflag) 
		   err_hlr(GC_PUSHS(
	        "[MAP!WS!COMMENT] missing \';\' in COMMENT statement"));
		if (scansailflag) s1= catlist(3L,GC_PUSHS("comment "),GC_PUSHS(s1),GC_PUSHS(";")); else s1= catlist(3L,GC_PUSHS("/*"),GC_PUSHS(s1),GC_PUSHS(" */"));
		if (*(*s)=='\0') *s= s1;  
		else *s= catlist(2L,GC_PUSHS(*s),GC_PUSHS(s1));
		if (*saistatement=='\0'&&!ismacroflag &&(rdlevel<1)) get_next_statement(); 
					/*  -- Force next STATEMENT */
/*  # # DBUG('200,"[MAP!WS!COMMENTS].1.2.1 COMMENT s1='"&s1&"'"&CRLF&"  s='"&s&"'"&CRLF&"  saiStatement='"&saiStatement&"'") */
		goto PS0002 /* Munch for WS, CMNTS & LABELS */;
		}/* found a comment */


   else if (*saistatement=='\0') 
		{/* FINISHED */
GC_EPOPS(dbug(0200L,catlist(15L,GC_PUSHS("[MAP!WS!COMMENTS].1.3 isMACROflag="),
        pbool(ismacroflag),GC_PUSHS(" rdLevel="),cvs(rdlevel),
        GC_PUSHS(crlf),GC_PUSHS("  s=\'"),GC_PUSHS(*s),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  |saiStatement|="),
        cvs(length(GC_PUSHS(saistatement))))));
		if (!ismacroflag &&(rdlevel<1))	{/* get more stuff */
				get_next_statement();
/*  # # DBUG('200,"[MAP!WS!COMMENTS].1.3.1 saiStatement='"&(ps!sTrash!_saiStatement)&"'"&CRLF&" |saiStatement|="&CVS(LENGTH(saiStatement))&" saiStatement[1 for 1]="&CVOS(LOP(ps!sTrash!))&"(8)") */
				goto PS0002 /* Munch for WS, CMNTS & LABELS */;
				}/* get more stuff */
		else if (length(GC_PUSHS(saistatement))==0) break; 
			else err_hlr(GC_PUSHS(
		catlist(3L,
		        GC_PUSHS("[MAP!WS!COMMENTS] DRYROT - NULL in saiStatement=\'")
		        ,GC_PUSHS(saistatement),GC_PUSHS("\'"))));
		}/* FINISHED */


   else		{/* check if it is a label */
		if (!isalpha(GC_PUSHS(saistatement))) break;  	/*  -- only alpha labels */
		s2= saistatement;	/*  -- copy string to test */
		token= GC_EPOPS(getid(&s2,&ch));		/*  -- break on ":"  */
		if (ch!=':'||!isvariable((INTEGER)*token)) break;  /*  -- Not a label end of WS!COMMENT */
		if (chk_type(GC_PUSHS(token))!=codelabel) break;	/*  -- Not a legal label, must be
					   record */
		if (*(*s)=='\0') *s= catlist(2L,GC_PUSHS(token),GC_PUSHS(":")); else *s= catlist(3L,GC_PUSHS(*s),GC_PUSHS(token),GC_PUSHS(":"));
		saistatement= s2;	/*  -- Update input stream */
		}/* check if it is a label */
   PS0002: ;}/* Munch for WS, CMNTS & LABELS */
 while (!(isfragmentflag));

lasttype= oldtype;
GC_EPOPS(dbug(0200L,catlist(10L,GC_PUSHS("[MAP!WS!COMMENTS].2 s=\'"),GC_PUSHS(*s),
        GC_PUSHS("\' |s|="),cvs(length(GC_PUSHS(*s))),
        GC_PUSHS("  |saiStatement|="),
        cvs(length(GC_PUSHS(saistatement))),GC_PUSHS(crlf),
        GC_PUSHS(" saiStatement=\'"),GC_PUSHS(saistatement),
        GC_PUSHS("\'"))));

;
{GC_UNMARKSSTKFRAME;}
}/* MAP!WS!COMMENTS */
