/* FILE: pop_block_name.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psparse.c, being converted 12/25/87, 09:34:41PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ----------------------------------------------------- */
/*INTERNAL*/  STRING pop_block_name()
/*  ----------------------------------------------------- */
{/* POP!BLOCK!NAME */
/*  --
.LABEL [<++PSAIL PROCEDURE: POP!BLOCK!NAME>]
.INDEX ++PSAIL PROCEDURE: POP!BLOCK!NAME
DESCRIPTION:
	Called by "END" to pop and check if next string constant
"..." in input matches top of blkName[lastBlock] stack.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: POP!BLOCK!NAME>]
 */
STRING stkname, 
	inname, 
	s, 
	wspace, 
	s1, 
	s2;
INTEGER i, 
	ch;

;

GC_EPOPS(dbug(040L,catlist(18L,GC_PUSHS("[POP!BLOCK!NAME] blockLevel="),cvs(blocklevel),
        GC_PUSHS(" locIptr="),cvs(lociptr),GC_PUSHS("  locSptr="),
        cvs(locsptr),GC_PUSHS(" locAptr="),cvs(locaptr),GC_PUSHS(
        crlf),GC_PUSHS(" blkSPDLptr["),cvs(blocklevel),
        GC_PUSHS("]="),cvs((*aChkI(blkspdlptr,1L,blocklevel))),
        GC_PUSHS(" dclSymPtr="),cvs(dclsymptr),GC_PUSHS(crlf),
        GC_PUSHS(" blkFreAryList[blockLevel]="),
        GC_PUSHS(*aChkC(blkfrearylist,1L,blocklevel)))));
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(stkname); /* for G.C. */
GC_NOTESTRING(inname); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(wspace); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
wspace= PNULL;
while ((*saistatement!='\0') &&iswhitespace((INTEGER)*saistatement)) ps_itrash_= LOP(saistatement);
inname= PNULL;
if (*saistatement==*quote) 
	{/* found a block label */
	ch= LOP(saistatement);			/*  -- trash quote */
	pushnumber(iscopy_toflag); iscopy_toflag= 1L;
			/*  -- This prevents it from sucking white space */
	inname= GC_EPOPS(map_quotes(&saistatement)); 	/*  -- extract "string"  */
	popnumber(&iscopy_toflag);
	if (*inname==*quote||*inname==*singlequote) inname= GC_EPOPS(remove_white_ends(subst(GC_PUSHS(inname),2L,length(inname)-1L)));
GC_EPOPS(dbug(040L,catlist(7L,GC_PUSHS("[POP!BLOCK!NAME].0.1 inName=\'"),GC_PUSHS(inname)
        ,GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  saiStatement=\'")
        ,GC_PUSHS(saistatement),GC_PUSHS("\'"))));
	if (blocklevel==0)
		err_hlr(GC_PUSHS(
		catlist(5L,GC_PUSHS("[POP!BLOCK!NAME] Block# "),cvs(blocklevel),
		        GC_PUSHS(" = 0. No \'BEGIN\' for this END named \'"),
		        GC_PUSHS(inname),GC_PUSHS("\'"))));
	}/* found a block label */

map_whitespace(&wspace);
if (*saistatement==';') ch= LOP(saistatement); /*Trash ; */

stkname= (*aChkC(blkname,1L,blocklevel)); 	/*  -- get name of BEGIN */
/*  -- NOTE: the genAsymbol and genBsymbol variables which would
contain the GOTO <label> are NOT GLOBALS! This is because they are
use ONLY in [FSM25].
 */
/*  # # @V.56.127 genAsymbol_blkAgensym[blockLevel] */
/*  # # @V.56.127 genBsymbol_blkBgensym[blockLevel] */

lastprocedure= (*aChkC(blkpname,1L,blocklevel));     /*  -- name of procedure we are
					now in */
oldlastprocedure= lastprocedure;		/*  -- fixup this as well */
typelastprocdecl= (*aChkI(decldw,1L,(*aChkI(dwptr,1L,hash_c(GC_PUSHS(lastprocedure)))))); /*  -- type of
					procedure in which block was
					declared */
semit= (*aChkC(blksemit,1L,blocklevel)); 	/*  -- C code to emit before this stuff */

midofexpr= ((i= (*aChkI(blkbits,1L,blocklevel)))&01)!=0;  /*  -- Restore state */
incaseflag= (i&02)!=0;  		/*  -- Restore state */
inifflag= (i&04)!=0;  		/*  -- Restore state */
isifexpr= (i&010)!=0;  		/*  -- Restore state */
firstlocxct= (i&020)!=0;  	/*  -- Restore state */
didlocemit= (i&040)!=0;  	/*  -- Restore state */
emitenableflag= (i&0100)!=0;  	/*  -- Restore state */
didblkexit= (i&0200)!=0;  	/*  -- Restore state */
GC_EPOPS(dbug(040L,catlist(28L,
        GC_PUSHS("[POP!BLOCK!NAME].0.2 RESTORED FLAGS from blkBits[blockLevel]=")
        ,cvos(i),GC_PUSHS("(8)"),GC_PUSHS(crlf),
        GC_PUSHS("  midOfExpr="),pbool(midofexpr),GC_PUSHS(crlf),
        GC_PUSHS("  inCASEflag="),pbool(incaseflag),GC_PUSHS(crlf),
        GC_PUSHS("  inIFflag="),pbool(inifflag),GC_PUSHS(crlf),
        GC_PUSHS("  isIFexpr="),pbool(isifexpr),GC_PUSHS(crlf),
        GC_PUSHS("  firstLOCxct="),pbool(firstlocxct),GC_PUSHS(crlf)
        ,GC_PUSHS("  didLOCemit="),pbool(didlocemit),GC_PUSHS(crlf),
        GC_PUSHS(" sEmit=\'"),GC_PUSHS(semit),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" emitEnableFlag="),
        pbool(emitenableflag))));
locaptr= (*aChkI(blkapdlptr,1L,blocklevel));  /*  -- Restore LOCAL Array PDL ptr */
lociptr= (*aChkI(blkipdlptr,1L,blocklevel));  /*  -- Restore LOCAL ITEM PDL ptr */
locsptr= (*aChkI(blkspdlptr,1L,blocklevel));  /*  -- Restore LOCAL String PDL ptr */

/*  # # DBUG('40,"[POP!BLOCK!NAME].0.3 before ZERO blkXXXX[blockLevel]") */
GC_EPOPS(dbug(040L,catlist(5L,
        GC_PUSHS("[POP!BLOCK!NAME].0.3.1 blkAgenSym[blockLevel]=\'"),
        GC_PUSHS(*aChkC(blkagensym,1L,blocklevel)),
        GC_PUSHS("\' blkBgenSym[blockLevel]=\'"),
        GC_PUSHS(*aChkC(blkbgensym,1L,blocklevel)),GC_PUSHS("\'"))));
/*  -- This NULL assignment is in case we need to G.C. and want this
space.
 */
(*aChkC(blkagensym,1L,blocklevel))= PNULL;
(*aChkC(blkbgensym,1L,blocklevel))= PNULL;
(*aChkC(blkfrearylist,1L,blocklevel))= PNULL;
(*aChkC(blkname,1L,blocklevel))= PNULL;
(*aChkC(blkpname,1L,blocklevel))= PNULL;
(*aChkC(blksemit,1L,blocklevel))= PNULL;
/*  # # DBUG('40,"[POP!BLOCK!NAME].0.4 After ZERO blkXXXX[blockLevel]") */

--blocklevel;
GC_EPOPS(dbug(040L,catlist(17L,GC_PUSHS("[POP!BLOCK!NAME].1 next look for blkName["),
        cvs(blocklevel),GC_PUSHS("]="),GC_PUSHS(*aChkC(blkname,1L,
        blocklevel)),GC_PUSHS(crlf),GC_PUSHS("  locIptr="),
        cvs(lociptr),GC_PUSHS(" locSptr="),cvs(locsptr),
        GC_PUSHS(" locAptr="),cvs(locaptr),GC_PUSHS(crlf),
        GC_PUSHS(" this block name stkName=\'"),GC_PUSHS(stkname),
        GC_PUSHS("\' saw END inName=\'"),GC_PUSHS(inname),
        GC_PUSHS("\'"))));
GC_EPOPS(dbug(040L,catlist(13L,GC_PUSHS("[POP!BLOCK!NAME].2 oldLastProcedure=\'"),
        GC_PUSHS(oldlastprocedure),GC_PUSHS("\' lastProcedure=\'"),
        GC_PUSHS(lastprocedure),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" typeLastProcDecl=\'"),cvtypes(typelastprocdecl),
        GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" lastDeclaration=\'"),cvtypes(lastdeclaration),
        GC_PUSHS("\'"))));

/*  # #@V.37.08      OR ((inName Neq NULL) And (stkName=NULL)) And 
   (blockLevel>0) And (Not isMacroFlag)
# # # removed.... so /SLOBS can be slobs... */

if (((*inname=='\0') &&(*stkname!='\0') ||
    (*inname!='\0') &&(*stkname=='\0') &&!ismacroflag)) 
	{/* error */
	s1= PNULL;
	if ((!slobflag) &&(!noblocklabelwarningflag)) err_deathwish(&s1,
	GC_PUSHS(
        					catlist(GC_PUSHS(
        " WARNING!!!: begin/end labels do not MATCH at blockLevel[")
        ,cvs(blocklevel+1L),
        GC_PUSHS("]\15\12\
	BEGIN label=\'"/*N.P.*/),
        GC_PUSHS(stkname),GC_PUSHS("\'\15\12\
	END label=\'"
        /*N.P.*/),GC_PUSHS(inname),GC_PUSHS("\'"))), 8L, 0L);
	if (*s1!='\0')
		{/* build message */
		if (*wspace=='\0') wspace= s1; 
		else wspace= catlist(2L,GC_PUSHS(s1),GC_PUSHS(wspace));
		}/* build message */
	}/* error */

	else if (!fast_equ(GC_PUSHS(inname),GC_PUSHS(stkname)) &&(blocklevel>0) &&
		!ismacroflag) 
	{/* error */
	s= "@";				/*  -- add prefix */
	for (i=1;i<=(blocklevel+1L);i++)
		s= catlist(7L,GC_PUSHS(s),GC_PUSHS("     block["),cvs(i),GC_PUSHS("]=\'")
        ,GC_PUSHS(*aChkC(blkname,1L,i)),GC_PUSHS("\'"),GC_PUSHS(crlf));
	i= LOP(s);			/*  -- remove '@' prefix */
	err_hlr(catlist(15L,GC_PUSHS("[POP!BLOCK!NAME] At blockLevel="),
        cvs(blocklevel),GC_PUSHS(", block name stack="),GC_PUSHS(
        crlf),GC_PUSHS(s),GC_PUSHS(crlf),
        GC_PUSHS("  Stack \'Begin\' block name["),GC_PUSHS(stkname),
        GC_PUSHS("] NEQ"),GC_PUSHS(crlf),
        GC_PUSHS("  current \'End\' block name["),GC_PUSHS(inname),
        GC_PUSHS("]"),GC_PUSHS(crlf),
        GC_PUSHS("Bad SAIL program - Fix it and try again")));
	}/* error */
if ((*inname=='\0')) s= wspace; 
	else	{s= catlist(3L,GC_PUSHS("/* "),GC_PUSHS(inname),GC_PUSHS(" */"));
		if (*wspace!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(wspace));
		}
GC_EPOPS(dbug(040L,catlist(2L,GC_PUSHS("[POP!BLOCK!NAME].3 dclSymPtr="),cvs(dclsymptr))));
;
GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 's2'=<L0> string                              */
/*************************************************/

}/* POP!BLOCK!NAME */
