/* FILE: process_token.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psparse.c, being converted 12/25/87, 09:34:41PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ----------------------------------------------------- */
/*INTERNAL*/  STRING process_token()
/*  ----------------------------------------------------- */
{/* PROCESS!TOKEN */
/*  --
.LABEL [<++PSAIL PROCEDURE: PROCESS!TOKEN>]
.INDEX ++PSAIL PROCEDURE: PROCESS!TOKEN
DESCRIPTION:
	Scan an input token from 'saiStatement' (which may be either
an alphanumeric or brk token) then if it can be mapped to C - do it
using MAP!EXPR or simple symtab lookup for user declared non-macro
variables. If not then just pass it through.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: PROCESS!TOKEN>]
 */
INTEGER h, 
	i, 
	idxuser, 
	brk, 
	symclass;
STRING s, 
	s1;

;

GC_EPOPS(dbug(02000L,catlist(16L,GC_PUSHS("[PROCESS!TOKEN] midOfExpr="),pbool(midofexpr),
        GC_PUSHS(" oldTypeStatement=\'"),GC_PUSHS(oldtypestatement),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" emitEnableFlag="),pbool(emitenableflag),
        GC_PUSHS(" didLOCemit="),pbool(didlocemit),
        GC_PUSHS(" isFRAGMENTflag="),pbool(isfragmentflag))));
GC_EPOPS(dbug(02000L,catlist(6L,GC_PUSHS("[PROCESS!TOKEN].0.1 sPDLptr="),cvs(spdlptr),
        GC_PUSHS(" nPDLptr="),cvs(npdlptr),GC_PUSHS(" blockLevel="),
        cvs(blocklevel))));
/* 	Parse tokens in sail statement */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
saitoken= GC_EPOPS(get_token(&saistatement));  /*  -- sets 'isNUMBERflag' to CODEreal
					or CODEinteger if <number>
					otherwise it sets it to 0.
					It also expands MACROS
					if necessary */
GC_EPOPS(dbug(02000L,catlist(7L,GC_PUSHS("[PROCESS!TOKEN].0.2 saiToken=\'"),
        GC_PUSHS(saitoken),GC_PUSHS("\' lastMappedToken=\'"),
        GC_PUSHS(lastmappedtoken),GC_PUSHS("\' oldToken=\'"),
        GC_PUSHS(oldtoken),GC_PUSHS("\'"))));

if (iswhitespace((INTEGER)*saitoken))
	{/* just return as much WS as possible */
	s= saitoken;
	map_whitespace(&s);		/*  -- do it all here! */
GC_EPOPS(dbug(02000L,catlist(3L,GC_PUSHS("[PROCESS!TOKEN].0.4 s=\'"),GC_PUSHS(s),
        GC_PUSHS("\'"))));
	}/* just return as much WS as possible */

else
    {/* go process non WS */
    s= PNULL;
    symclass = h = idxuser = 0;

    if ((*saitoken!='\0')) 
	{/* process token */
	if (isnumberflag!=0)
		{/* use the <number> */
		lasttype= isnumberflag;   /*  -- flag IS the TYPE - either
					CODEinteger or CODEreal!!! */
		s= saitoken;		/*  -- use the number */
GC_EPOPS(dbug(02000L,catlist(9L,GC_PUSHS("[PROCESS!TOKEN].0.5 s=\'"),GC_PUSHS(s),
        GC_PUSHS("\' saiToken=\'"),GC_PUSHS(saitoken),GC_PUSHS("\'")
        ,GC_PUSHS(crlf),GC_PUSHS(" lastType=\'"),cvtypes(lasttype),
        GC_PUSHS("\'"))));
		}/* use the <number> */


/*  # # @V.48.14 Need to check LOCAL symtable before trying to do the
hash and see if a local non-hash symbol exists. This will be fixed
with the new symtab! */
	else	{/* hash the little devil */
		idxuser= find_symbol(GC_PUSHS(saitoken),&symclass,&h);
GC_EPOPS(dbug(02000L,catlist(14L,GC_PUSHS("[PROCESS!TOKEN].0.6 idxUser="),cvs(idxuser),
        GC_PUSHS(" symClass=\'"),
        GC_PUSHS(s1= GC_EPOPS(makstr(symclass))),GC_PUSHS("\' h="),
        cvs(h),GC_PUSHS(crlf),GC_PUSHS("  declBlkLvl[idxUser]="),
        cvs((*aChkI(declblklvl,1L,idxuser))),GC_PUSHS(crlf),
        GC_PUSHS(" declDW[idxUser]="),cvtypes((*aChkI(decldw,1L,
        idxuser))),GC_PUSHS("\'"),prt_node(h))));
		}/* hash the little devil */
GC_EPOPS(dbug(02000L,catlist(17L,GC_PUSHS("[PROCESS!TOKEN].1 saiToken=\'"),GC_PUSHS(
        saitoken),GC_PUSHS("\' h="),cvs(h),GC_PUSHS(" idxUser="),
        cvs(idxuser),GC_PUSHS(crlf),GC_PUSHS("  declDW[idxUser]="),
        cvtypes((*aChkI(decldw,1L,idxuser))),GC_PUSHS(crlf),
        GC_PUSHS("  lastType=\'"),cvtypes(lasttype),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS("  declBlkLvl[idxUser]="),cvs((
        *aChkI(declblklvl,1L,idxuser))),GC_PUSHS("\'"))));

	if ((symclass=='F')     /*  -- i.e. use only if FSM class symbol-- */) 
		{/* is FSM token */
		pushnumber(idxuser);
		s= GC_EPOPS(map_expr(h));			/*  -- Map the sucker... */
		popnumber(&idxuser);
		if ((((ps_itrash_= (((*aChkI(decldw,1L,idxuser)))&037))>0) ? (ps_itrash_+0140L)
				:0L)!=0) lasttype= ((*aChkI(decldw,1L,idxuser))&0137717577775);
GC_EPOPS(dbug(02000L,catlist(18L,GC_PUSHS("[PROCESS!TOKEN].1.1 s=\'"),GC_PUSHS(s),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  lastType=\'"),
        cvtypes(lasttype),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" declDW[idxUser="),cvs(idxuser),GC_PUSHS("]=\'"),
        cvtypes((*aChkI(decldw,1L,idxuser))),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS("  saiToken=\'"),GC_PUSHS(saitoken),
        GC_PUSHS("\' sawStrF="),pbool(sawstrfct))));
		lastidflag= 0L;		/*  -- Not variable */
		}/* is FSM token */

	else if (lastidflag)
		{/* opps! forgot ';' */
		err_hlr(GC_PUSHS(
        			catlist(GC_PUSHS(
        "[PROCES!TOKEN] missing \';\' before \'"),GC_PUSHS(saitoken)
        ,GC_PUSHS("\' - inserted, if you CONTINUE."))));
		if (*saistatement=='\0') saistatement= catlist(2L,GC_PUSHS(saitoken),GC_PUSHS(";")); else saistatement= catlist(3L,GC_PUSHS(saitoken),GC_PUSHS(";"),GC_PUSHS(saistatement));
		idxuser= h= 0;
		s= saitoken= PNULL;		/*  -- do it again! */
		}/* opps! forgot ';' */

	else if (!isnumberflag)
		{/* not SAIL key word */
		s= saitoken;	 		/*  -- See FSM11 */
GC_EPOPS(dbug(02000L,catlist(12L,GC_PUSHS("[PROCESS!TOKEN].2 s=\'"),GC_PUSHS(s),
        GC_PUSHS("\' lastIDflag="),pbool(lastidflag),
        GC_PUSHS(" isMACROflag="),pbool(ismacroflag),GC_PUSHS(crlf),
        GC_PUSHS("  declDW["),cvs(idxuser),GC_PUSHS("]=\'"),
        cvtypes((*aChkI(decldw,1L,idxuser))),GC_PUSHS("\'"))));

		lastidflag= 1L;
		if (idxuser!=0) 
			{/* is USER symbol */
			lasttype= (*aChkI(decldw,1L,idxuser));
			if ((lasttype&010000000L) &&
				(lasttype&040000L)) 
				{/* DUMMY reference variable */
				if ((lasttype&0100000L)==0) s= catlist(2L,GC_PUSHS("*"),GC_PUSHS(saitoken)); else s= catlist(3L,GC_PUSHS("(*"),GC_PUSHS(saitoken),GC_PUSHS(")()"));
						  /*  -- force it */
				}/* DUMMY reference variable */
GC_EPOPS(dbug(02000L,catlist(21L,GC_PUSHS("[PROCESS!TOKEN].2.1 s=\'"),GC_PUSHS(s),
        GC_PUSHS("\' emitEnableFlag="),pbool(emitenableflag),
        GC_PUSHS(" blockLevel="),cvs(blocklevel),GC_PUSHS(crlf),
        GC_PUSHS("  locIptr="),cvs(lociptr),GC_PUSHS(" locSptr="),
        cvs(locsptr),GC_PUSHS(" locAptr="),cvs(locaptr),GC_PUSHS(
        crlf),GC_PUSHS("  firstLOCxct="),pbool(firstlocxct),
        GC_PUSHS(" didLOCemit="),pbool(didlocemit),GC_PUSHS(crlf),
        GC_PUSHS(" midOfExpr="),pbool(midofexpr))));
			if (!midofexpr) {/* CHK!EMIT */
		if (emitenableflag &&!didlocemit) 
			{/* do EMIT */
			semit= GC_EPOPS(emit_loc_code());
			(*aChkI(emitepdl,1L,++eeptr))= emitenableflag;
			emitenableflag= 0L;
			s= s;
			emitenableflag= (*aChkI(emitepdl,1L,(--eeptr)+1L));
			if (*semit!='\0')
				{/* fix up string */
				if (*s=='\0') s= semit; 
					else s= catlist(2L,GC_PUSHS(semit),GC_PUSHS(s));
				semit= PNULL;	/*  Clear it */
				}/* fix up string */
			}/* do EMIT */
		else s= s;	/*  simple EVAL */
		}/* CHK!EMIT */ 	/*  -- emit if
					 	necessary. NOTE this is
						a MACRO */
GC_EPOPS(dbug(02000L,catlist(9L,GC_PUSHS("[PROCESS!TOKEN].2.1.1 s=\'"),GC_PUSHS(s),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  lastType=\'"),
        cvtypes(lasttype),GC_PUSHS("\'"),GC_PUSHS(" midOfExpr="),
        pbool(midofexpr))));
GC_EPOPS(dbug(02000L,catlist(18L,GC_PUSHS("[PROCESS!TOKEN].2.1.2 s=\'"),GC_PUSHS(s),
        GC_PUSHS("\' emitEnableFlag="),pbool(emitenableflag),
        GC_PUSHS(" blockLevel="),cvs(blocklevel),GC_PUSHS(crlf),
        GC_PUSHS("  locIptr="),cvs(lociptr),GC_PUSHS(" locSptr="),
        cvs(locsptr),GC_PUSHS(" locAptr="),cvs(locaptr),GC_PUSHS(
        crlf),GC_PUSHS("  firstLOCxct="),pbool(firstlocxct),
        GC_PUSHS(" didLOCemit="),pbool(didlocemit))));
			}/* is USER symbol */

		else if ((!ismacroflag) &&(!isnumberflag)) 
				{/* Can't seem to find it... */
				err_undf(&s,GC_PUSHS(saitoken));
				lasttype= 0L;  /*  -- Default to INTEGER */
				pdw_ptype(lasttype,codeinteger);
				}/* Can't seem to find it... */
		else if ((isnumberflag==codeinteger) &&
			(!slobflag) &&
			chk_32bit_integer(GC_PUSHS(s))) err_deathwish(&s,
      GC_PUSHS("WARNING! Integer constants > 32-bits are not portable"),
						5L,(INTEGER)('N'/*WARNING*/));

		if (!iswhitespace((INTEGER)*saitoken)) oldtoken= saitoken;
/*  # # DBUG('2000,"[PROCESS!TOKEN].2.2 saiTok='"&saiToken&"' s="&s&" oldToken='"&oldToken&"'") */
		}/* not SAIL key word */
	}/* process token */
    }/* go process non WS */

GC_EPOPS(dbug(02000L,catlist(16L,GC_PUSHS("[PROCESS!TOKEN].3 oldToken=\'"),
			     
			     GC_PUSHS(oldtoken),GC_PUSHS("\'"),
			     GC_PUSHS(crlf),GC_PUSHS("  s=\'"),
			     GC_PUSHS(s),GC_PUSHS("\'"),GC_PUSHS(crlf),
			     GC_PUSHS("  lastType=\'"),cvtypes(lasttype),
			     GC_PUSHS("\'"),
			     GC_PUSHS(crlf),GC_PUSHS(" midOfExpr="),
			     pbool(midofexpr),
			     GC_PUSHS(" isFRAGMENTflag="),
			     pbool(isfragmentflag))));
GC_EPOPS(dbug(02000L,catlist(12L,GC_PUSHS("[PROCESS!TOKEN].3.1 sPDLptr="),
			     cvs(spdlptr),
			     GC_PUSHS(" nPDLptr="),cvs(npdlptr),
			     GC_PUSHS(" blockLevel="),
			     cvs(blocklevel),GC_PUSHS(crlf),
			     GC_PUSHS("  oldTypeStatement=\'"),
			     GC_PUSHS(oldtypestatement)
			     ,GC_PUSHS("\' s=\'"),GC_PUSHS(s),
			     GC_PUSHS("\'"))));
GC_EPOPS(dbug(02000L,catlist(19L,GC_PUSHS("[PROCESS!TOKEN].3.2 sEmit=\'"),
			     GC_PUSHS(semit),
			     GC_PUSHS("\'"),GC_PUSHS(crlf),
			     GC_PUSHS(" blockLevel="),
			     cvs(blocklevel),GC_PUSHS(" locIptr="),
			     cvs(lociptr),
			     GC_PUSHS(" locSptr="),cvs(locsptr),
			     GC_PUSHS(" locAptr="),
			     cvs(locaptr),GC_PUSHS(crlf),
			     GC_PUSHS("  firstLOCxct="),
			     pbool(firstlocxct),GC_PUSHS(" didLOCemit="),
			     pbool(didlocemit),GC_PUSHS(" emitEnableFlag="),
			     pbool(emitenableflag))));

/* NO-OP */;
;
GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'brk'=<L0> integer                            */
/* 'i'=<L0> integer                              */
/*************************************************/

}/* PROCESS!TOKEN */
