/* FILE: prt_node.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psdbug.c, being converted 12/25/87, 01:13:54PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*   --------------------------------------- */
/*INTERNAL*/  STRING prt_node(h)
	INTEGER h;
/*   --------------------------------------- */
{/* PRT!NODE */
/*  --
.LABEL [<++PSAIL PROCEDURE: PRT!NODE>]
.INDEX ++PSAIL PROCEDURE: PRT!NODE
DESCRIPTION:
	If enabled with /DEBUG:200000000, then dump the guts of the
current nodePtr for each of its fields.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: PRT!NODE>]
 */
#define use_new_symtab 0L
STRING s, 
	s1, 
	s2;
INTEGER i, 
	j, 
	nodeptr;
#define tn(x) ((x=='\0') ? "<NUL>" : x)

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
if (h<0)	{/* by IDX */ 
		nodeptr= -h;	/*  -- i.e. was passed -INDEX not H !! */
		h= (*aChkI(declhash,1L,nodeptr));
		}/* by IDX */
else nodeptr= (*aChkI(dwptr,1L,h));

if ((debugswitch &&((0200000000&dbugcode)!=0)))
	{/* give them the full blown stuff */
/* IFC EVAL(not use_new_symtab)=1 */
/* THENC */

	/*  --- print the OLD full node--- */
	s= catlist(7L,GC_PUSHS(crlf),GC_PUSHS("+ + +<NODE["),
		   GC_PUSHS(*aChkC(saisym,1L,h)),GC_PUSHS(",h="),cvs(h),
		   GC_PUSHS("]> + +"),GC_PUSHS(crlf));
	s= catlist(4L,GC_PUSHS(s),
		   GC_PUSHS("+   dwPtr[h]=index for declXXX[]="),
		   cvs(nodeptr),GC_PUSHS(crlf));
	s= catlist(4L,GC_PUSHS(s),GC_PUSHS("+   declBlkLvl[]="),
		   cvs((*aChkI(declblklvl,1L,nodeptr))),GC_PUSHS(crlf));
	s= catlist(5L,GC_PUSHS(s),GC_PUSHS("+   declCsym[]=\'"),
		   tn((INTEGER)*((*aChkC(declcsym,1L,nodeptr)))),
		   GC_PUSHS("\'"),GC_PUSHS(crlf));
	s= catlist(7L,GC_PUSHS(s),
		   GC_PUSHS("+   declDW[]=0"),
		   cvos((*aChkI(decldw,1L,nodeptr))),GC_PUSHS(" =\'"),
		   cvtypes((*aChkI(decldw,1L,nodeptr))),
		   GC_PUSHS("\'"),GC_PUSHS(crlf));
	s= catlist(5L,GC_PUSHS(s),GC_PUSHS("+   declFormal[]=\'"),
		   tn((INTEGER)*((*aChkC(declformal,1L,nodeptr)))),
		   GC_PUSHS("\'"),GC_PUSHS(crlf));
	s= catlist(5L,GC_PUSHS(s),GC_PUSHS("+   declFSM[]"),
		   GC_PUSHS(((*aChkI(decldw,1L,nodeptr))&0100L)
		       ? "= FSM" 
        	       : "="),cvs((*aChkI(declfsm,1L,nodeptr))&0177777),
        GC_PUSHS(crlf));
	s= catlist(4L,GC_PUSHS(s),GC_PUSHS("+   declLEXCODES[]=0"),
		   cvos(RSH((*aChkI(declfsm,1L,nodeptr)),16L)),
		   GC_PUSHS(crlf));
	s= catlist(7L,GC_PUSHS(s),GC_PUSHS("+   declHash[]="),
		   cvs((*aChkI(declhash,1L,nodeptr))),GC_PUSHS("=\'"),
		   tn((INTEGER)*((*aChkC(saisym,1L,
					 (*aChkI(declhash,1L,
						 nodeptr)))))),
		   GC_PUSHS("\'"),GC_PUSHS(crlf));
	s= catlist(7L,GC_PUSHS(s),GC_PUSHS("+   declInProc[]="),
		   cvs(j= (*aChkI(declinproc,1L,nodeptr))),
		   GC_PUSHS("=\'"),
		   GC_PUSHS(*aChkC(saisym,1L,j)),GC_PUSHS("\'"),
		   GC_PUSHS(crlf));
	s= catlist(4L,GC_PUSHS(s),GC_PUSHS("+   declNargs[]="),
		   cvs((*aChkI(declnargs,1L,nodeptr))),GC_PUSHS(crlf));
	s= catlist(7L,GC_PUSHS(s),GC_PUSHS("+   declRClass[]="),
		   cvs(j= (*aChkI(declrclass,1L,nodeptr))),
		   GC_PUSHS("=\'"),
		   tn((INTEGER)*((*aChkC(saisym,1L,j)))),GC_PUSHS("\'"),
		   GC_PUSHS(crlf));
	s= catlist(5L,GC_PUSHS(s),GC_PUSHS("+   declSize[]=\'"),
		   tn((INTEGER)*((*aChkC(declsize,1L,nodeptr)))),
		   GC_PUSHS("\'"),
        GC_PUSHS(crlf));
  /* ENDC */

/* IFC EVAL(use_new_symtab)=0 */
 /* THENC <<<FAILED!!!>>>

	comment  --- "print the NEW full node---;
	s:=crlf&"+ + +<NODE["&saisym[h]&",h="&cvs(h)&"]> + +"&crlf;
	s:=s & "+   dwPtr[h]=nodePtr=" & cvs(nodeptr) & crlf;
	s:=s & "+   FSM="&cvs((gs_fsm(nodeptr)) land 017777) & crlf;
	s:=s & "+   LEXCODE=0"&cvs((gs_fsm(nodeptr))lsh-16) & crlf;
	s:=s & "+   BLOCKLEVEL="&cvs(gs_blocklevel(nodeptr)) & crlf;
	s:=s & "+   NEXTNODE index="&cvs(gs_nextnode(nodeptr)) & crlf;
	s:=s & "+   DW=0"&cvos(gs_dw(nodeptr))&" ='"&
		cvtypes(gs_dw(nodeptr)) & "'" & crlf;
	s:=s & "+   ARYHDR index ="&cvs(gs_aryhdr(nodeptr)) & crlf;
	s:=s & "+   RCLASSHDR index ="&cvs(gs_rclasshdr(nodeptr)) & crlf;
	s:=s & "+   NARGS index ="&cvs(gs_nargs(nodeptr)) & crlf;
	s:=s & "+   MAPSTR index ="&cvs(j:=gs_mapstr(nodeptr)) & " = '" &
		 stravail[j] & "'" & crlf;
	s:=s & "+   FORMALARGSTR index =" & 
		 cvs(j:=gs_formalargstr(nodeptr))&
		 " = '" & stravail[j] & "'" & crlf;
	s:=s & "+   INPROC hash index ="&cvs(j:=gs_inproc(nodeptr)) &
			"='" & saisym[j] & "'" & crlf;
	s:=s & "+   HASH this index ="&cvs(j:=gs_inproc(nodeptr)) &
			"='" & saisym[j] & "'" & crlf;
  */ /* ENDC */
	s= catlist(9L,GC_PUSHS(s),GC_PUSHS("+   blockLevel="),cvs(blocklevel),
        GC_PUSHS(" dclSymPtr="),cvs(dclsymptr),
        GC_PUSHS(" lastProcedure=\'"),GC_PUSHS(lastprocedure),
        GC_PUSHS("\'"),GC_PUSHS(crlf));
	s= catlist(3L,GC_PUSHS(s),
        GC_PUSHS("+ + + + + + + + + + + + + + + + + + + + + + + +"),
        GC_PUSHS(crlf));
	}/* give them the full blown stuff */

else s= catlist(4L,GC_PUSHS(" nodePtr["),cvs(h),GC_PUSHS("]="),cvs(nodeptr));

GC_SRETURN(s)

/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'i'=<L0> integer                              */
/* 's2'=<L0> string                              */
/* 's1'=<L0> string                              */
/*************************************************/

#undef tn
#undef use_new_symtab
}/* PRT!NODE */
