/* File: psfcts.h - composite header file from all module header */
/*
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	UNIX/Revised January 25, 1988
	UNIX/Revised December 29, 1987
	USED: PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED)
	January 16, 1987

	Derived from PSAIL.SAI V.43.50 7-19-84

*/

#ifndef HASCONFIG
#include "config.h"	/* Declares the type of machine we are on */
#endif

#ifndef SAI_RUN
#include "sairun.h"	/* SAIL compatibility runtime package */
#endif

#ifndef GC_RUN
#include "psrung.h"	/* Garbage collector header file */
#endif


/* File: pschek.h, being converted 12/25/87, 12:11:41AM*/

extern   INTEGER chk_c_keyword();    /* STRING s; */
extern   INTEGER chk_expr_list();    /* STRING s; */
extern   INTEGER chk_iconst();       /* STRING s; INTEGER *ival; */
extern   INTEGER chk_id();           /* STRING s; */
extern   INTEGER chk_integer();      /* STRING s; */
extern   STRING chk_leap_optimize(); /* STRING s; STRING a;
					STRING o; STRING v; */
extern   STRING chk_name_map();      /* STRING tok; */
extern   INTEGER chk_number();       /* STRING s; */
extern   INTEGER chk_real();         /* STRING s; */
extern   INTEGER chk_sail_keyword(); /* STRING s; */
extern   INTEGER chk_sconst();       /* STRING s; STRING *sval;
					INTEGER cvtbslashascii; */
extern   INTEGER chk_str_dryrot();   /* STRING s; STRING msg; */
extern   void chk_switches();        /* STRING s; */
extern   INTEGER chk_type();         /* STRING s; */
extern   INTEGER chk_32bit_integer(); /* STRING s; */
extern   INTEGER issaideclar();      /* STRING x; */
extern   INTEGER isscalartype();     /* INTEGER x; INTEGER y; */
extern   void set_preface();         /* STRING *wspreface; */
extern   STRING uniqdeclarations();  /* INTEGER size; */


/* File: pscvt.h, being converted 12/25/87, 12:17:22AM*/

extern   STRING cvactual_to_expected(); /* INTEGER typeexpected;
					   INTEGER typeactual;
					   STRING actualexpr; */
extern   STRING cvdummy_arg();       /* STRING *dumargarray; 
					INTEGER nargs; STRING stomap; */
extern   STRING cvdwi();             /* INTEGER dwbits; */
extern   STRING cvevalquote();       /* STRING ss; */
extern   INTEGER cvidw();            /* STRING itype; */
extern   STRING cvlower();           /* STRING ss; */
extern   INTEGER cvltypep();         /* INTEGER icode; */
extern   STRING cv_print_arglist();
extern   INTEGER cvptypel();         /* INTEGER dw; */
extern   INTEGER cvstype();          /* STRING stype; */
extern   STRING cvt_any_to_chr();    /* STRING s; STRING breakstr;
					INTEGER tochr; */
extern   STRING cvtypes();           /* INTEGER itype; */
extern   STRING cvupcase();          /* STRING ss; */
extern   INTEGER cv5int();           /* STRING ss; */
extern   INTEGER cv5hash();          /* STRING ss; */
extern   STRING fold_const_expr();   /* STRING nstr; */
extern   STRING infix_to_prefix();   /* INTEGER ltype; STRING op;
					STRING prefix;
					INTEGER dotypechk; */
extern   void insert_before_white(); /* STRING *si; STRING s; */
extern   STRING remove_white_ends(); /* STRING s; */


/* File: psdbug.h, being converted 12/25/87, 11:54:24AM*/

extern   void dbug_it();            /* INTEGER code; STRING s; */
extern   void err_deathwish();      /* STRING *s; STRING msg;
				       INTEGER deathwishindex;
				       INTEGER n_p_flag; */
extern   void err_hlr();            /* STRING msg; */
extern   void err_n_p();            /* STRING *s; */
extern   void err_report();
extern   void err_undf();           /* STRING *s; STRING id; */
extern   void err_warning();        /* STRING *s; */
extern   void out_both();           /* STRING s; */
extern   STRING prt_node();         /* INTEGER h; */
extern   STRING run_time();
extern   STRING stop_time();        /* INTEGER tday; INTEGER trun; */
extern   STRING todays_date();
extern   void watch_print();        /* STRING title; */


/* File: psfsma.h, being converted 12/25/87, 12:34:16AM*/

extern   STRING fsm0(); /* INTEGER h; */
extern   STRING fsm1(); /* INTEGER h; */
extern   STRING fsm2(); /* INTEGER h; */
extern   STRING fsm3(); /* INTEGER h; */
extern   STRING fsm4(); /* INTEGER h; */
extern   STRING fsm4a(); /* INTEGER h; */
extern   STRING fsm5(); /* INTEGER h; */
extern   STRING fsm6(); /* INTEGER h; */
extern   STRING fsm7(); /* INTEGER h; */
extern   STRING fsm8(); /* INTEGER h; */
extern   STRING fsm9(); /* INTEGER h; */
extern   STRING fsm10(); /* INTEGER h; */


/* File: psfsmb.h, being converted 12/25/87, 12:39:55AM*/

extern   STRING fsm11(); /* INTEGER h; */
extern   STRING fsm12(); /* INTEGER h; */
extern   STRING fsm13(); /* INTEGER h; */
extern   STRING fsm14(); /* INTEGER h; */
extern   STRING fsm15(); /* INTEGER h; */
extern   STRING fsm16(); /* INTEGER h; */
extern   STRING fsm17(); /* INTEGER h; */
extern   STRING fsm18(); /* INTEGER h; */
extern   STRING fsm19(); /* INTEGER h; */


/* File: psfsmc.h, being converted 12/25/87, 12:45:33AM*/

extern   STRING fsm20(); /* INTEGER h; */
extern   STRING fsm21(); /* INTEGER h; */
extern   STRING fsm22(); /* INTEGER h; */
extern   STRING fsm23(); /* INTEGER h; */
extern   STRING fsm24(); /* INTEGER h; */
extern   STRING fsm25(); /* INTEGER h; */
extern   STRING fsm26(); /* INTEGER h; */
extern   STRING fsm27(); /* INTEGER h; */
extern   STRING fsm28(); /* INTEGER h; */
extern   STRING fsm29(); /* INTEGER h; */
extern   STRING fsm30(); /* INTEGER h; */
extern   STRING fsm31(); /* INTEGER h; */
extern   STRING fsm32(); /* INTEGER h; */
extern   STRING fsm33(); /* INTEGER h; */
extern   STRING fsm34(); /* INTEGER h; */
extern   STRING fsm35(); /* INTEGER h; */
extern   STRING fsm36(); /* INTEGER h; */
extern   STRING fsm37(); /* INTEGER h; */
extern   STRING fsm38(); /* INTEGER h; */
extern   STRING fsm39(); /* INTEGER h; */
extern   STRING fsm40(); /* INTEGER h; */


/* File: psfsmd.h, being converted 12/25/87, 12:51:14AM*/

extern   STRING fsm41(); /* INTEGER h; */
extern   STRING fsm42(); /* INTEGER h; */
extern   STRING fsm43(); /* INTEGER h; */
extern   STRING fsm44(); /* INTEGER h; */
extern   STRING fsm45(); /* INTEGER h; */
extern   STRING fsm46(); /* INTEGER h; */
extern   STRING fsm47(); /* INTEGER h; */
extern   STRING fsm48(); /* INTEGER h; */
extern   STRING fsm49(); /* INTEGER h; */
extern   STRING fsm50(); /* INTEGER h; */
extern   STRING fsm51(); /* INTEGER h; */
extern   STRING fsm52(); /* INTEGER h; */
extern   STRING fsm53(); /* INTEGER h; */
extern   STRING fsm54(); /* INTEGER h; */
extern   STRING fsm55(); /* INTEGER h; */
extern   STRING fsm56(); /* INTEGER h; */
extern   STRING fsm57(); /* INTEGER h; */
extern   STRING fsm58(); /* INTEGER h; */
extern   STRING fsm59(); /* INTEGER h; */



/* File: psfsme.h, being converted 12/25/87, 12:56:54AM*/

extern   STRING fsm60(); /* INTEGER h; */
extern   STRING fsm61(); /* INTEGER h; */
extern   STRING fsm62(); /* INTEGER h; */
extern   STRING fsm63(); /* INTEGER h; */
extern   STRING fsm64(); /* INTEGER h; */
extern   STRING fsm65(); /* INTEGER h; */
extern   STRING fsm66(); /* INTEGER h; */
extern   STRING fsm67(); /* INTEGER h; */
extern   STRING fsm68(); /* INTEGER h; */
extern   STRING fsm69(); /* INTEGER h; */
extern   STRING fsm70(); /* INTEGER h; */
extern   STRING fsm71(); /* INTEGER h; */
extern   STRING fsm72(); /* INTEGER h; */
extern   STRING fsm73(); /* INTEGER h; */



/* File: psgc.h, being converted 12/25/87, 12:28:39AM*/

extern   void add_gc_pushs();       /* STRING *s; */
extern   STRING emit_cleanup_code();
extern   STRING emit_main_code();
extern   STRING emit_loc_code();
extern   STRING mak_blk_exit();     /* INTEGER fromblklevel; 
				       INTEGER toblklevel;
				       STRING emit_c_statement; */


/* File: psinit.h, being converted 12/25/87, 12:00:08AM*/

extern   STRING readfile();         /* STRING filename; */
extern   void readtrash_graphics(); /* STRING **tg; STRING filename; */
extern   void add_builtin();        /* STRING symbolspec; */
extern   void set_extensions();     /* INTEGER addthemflag; */
extern   void build_tables();



/* File: pslex.h, being converted 12/25/87, 01:02:33PM*/

extern   STRING copy_omit();        /* STRING saisym; */
extern   STRING copy_either();      /* STRING symlist; STRING *brkstr;*/
extern   STRING expand_macro();     /* STRING instr; INTEGER idx; */
extern   STRING get_c_token();      /* STRING *txt; STRING *moretext; */
extern   STRING getid();            /* STRING *txt; INTEGER *brk; */
extern   STRING get_input();
extern   void get_next_statement();
extern   STRING get_number();       /* STRING *s; */
extern   STRING get_token();        /* STRING *txt; */
extern   STRING left_expr();        /* STRING *s; 
				       INTEGER skipleftcommentsflag; */
extern   STRING left_id();          /* STRING *s; */
extern   STRING rightexpr();        /* STRING *s; */
extern   STRING rightid();          /* STRING *s; */
extern   STRING rightstatement();



/* File: psparse.h, being converted 12/25/87, 01:08:13PM*/

extern   void cvt_sail_to_c();
extern   STRING remap();           /* STRING token; STRING rule; */
extern   void map_be();            /* STRING *be; INTEGER *xtype; */
extern   void map_bkslash_str();   /* STRING *s; */
extern   STRING map_ck_args();     /* STRING procname; */
extern   STRING map_declar();      /* STRING token; */
extern   STRING map_embedded_comments(); /* STRING token; */
extern   STRING map_expr();        /* INTEGER h; */
extern   STRING map_inf();         /* STRING s; STRING id; */
extern   STRING map_leap_triple(); /* STRING *s; */
extern   STRING map_quotes();      /* STRING *s; */
extern   void map_whitespace();    /* STRING *s; */
extern   STRING map_ws_comments(); /* STRING *s; INTEGER scansailflag;*/
extern   void pop();               /* STRING *s; */
extern   STRING pop_block_name();
extern   void popnumber();         /* INTEGER *k; */
extern   STRING process_token();
extern   void push();              /* STRING s; */
extern   STRING push_block_name();
extern   void pushnumber();        /* INTEGER k; */
extern   STRING r_d_expr_map();    /* STRING s; */
extern   STRING simple_map();      /* INTEGER h; */



/* File: pspprt.h, being converted 12/25/87, 12:23:02AM*/
/* NOTE: 12-29-87 kept both functions are in this module because they
 * share local variables.
*/
extern   STRING justify_text();  /* STRING wsprefacenext;
				    STRING wsprefacefirst; STRING txt;*/
extern   STRING pretty_print();  /* STRING s; */



/* File: pssymt.h, being converted 12/25/87, 12:05:50AM*/

extern   INTEGER find_rc_symbol(); /* STRING s; INTEGER *hmem;
				      INTEGER hclass; */
extern   INTEGER find_symbol();  /* STRING s; INTEGER *classsym;
				    INTEGER *hsym; */
extern   INTEGER hash_c();       /* STRING sym; */
extern   INTEGER put_hash_c();   /* STRING sym; */
extern   STRING rem_symbols();   /* INTEGER startidx; INTEGER endidx; */

#if (dostdascii != 0)
extern   INTEGER ggdw_ptype();   /* INTEGER dw; */
extern   void ppdw_ptype();      /* REFERENCE INTEGER dw; INTEGER typecode; */
#endif
/* ----> End of psfcts.h <---- */
