/* File: PSGLBV.REQ */
/*      i.e. only compile as separate module if compiled alone
	with STANFORD SAIL.

                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			 Revised/UNIX January 25, 1988
			 Revised/UNIX December 29, 1987
			 April 17, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.


               Derived from PSAIL.SAI V.43.50  7-19-84


NOTE: PSGLBV.REQ is the universal global variable file. It is used to
compile both the INTERNAL and EXTERNAL declarations of global
variables and arrays. If we are using SAIL, then compile it separately
and it will be treated as a .SAI file of INTERNALS.  Compile it with
PSMAIN.SAI with PSAIL and it will also be treated as a group of
INTERNAL declarations but without the enclosing ENTRY/BEGIN/END.
Otherwise if Required with any other .SAI file (for both SAIL and
PSAIL) it will behave as a group of EXTERNAL declarations.

	Many of the global variables have short notes of their
function and some arrays have preloaded values.

*/

/* File: psglbv.h, being converted 12/25/87, 11:03:56AM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#ifndef HASCONFIG
#include "config.h"	/* Declares the type of machine we are on */
#endif

#ifndef SAI_RUN
#include "sairun.h"	/* SAIL compatibility runtime package */
#endif

#ifndef GC_RUN
#include "psrung.h"	/* Garbage collector header file */
#endif

/* 
.LABEL [<PSGLBV-REQ-COMPILE-MODE>]
*/

#ifdef is_main_module
#define use_internal 1
#define m_global /*INTERNAL*/
#define sa_glob  /*INTERNAL SAFER*/
#endif

#ifndef is_main_module
#define use_external 1
#define m_global extern
#define sa_glob extern /*SAFER*/
#endif


/* 
.ENDLABEL
*/


/* 	+ + + + + + + + + + + + + + + + + + + + + + + + + */
/* 	+   G L O B A L    V A R I A B L E S		  */
/* 	+ + + + + + + + + + + + + + + + + + + + + + + + + */

/*  --	NOTE: Keep all variables SORTED alphabetically for ease of
	editing and understanding.
*/

m_global STRING 
	cr,
	crlf,
	ff,
	fourquotes,
	lf,
	quote,
	semicolon,
	singlequote,
	space,
	tab,
	twoquotes;	/*  -- ASCII char codes in strings for use w/BAIL */

m_global STRING

        b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12, b13,
        b14, b15, b16, b17, b18, b19, b20, b21, b22, b23, b24,
        b25, b26, b27, b28, b29, b30, b31, b32, b33, b34, b35,
        b36, b37, b38, b39, b40;   /* -- break tbls */

 			    	/* -- Note: tables 41 to 45
				   are reserved for any one who needs
				   a temporary table */

m_global STRING 
	ps__leap_,
	ps_strash_,
	ps__undf_,
	ps_warning_,
	cfile,
	classize,
	cstatement,
	ctoken, 
	ctrfile,
	dcstaticdeclaration,
	fore1str,
	fore2str,
	fore3str,
	genericname,
	ippn,
	itemtype,
	lastasize,
	lastcsym,
	lastformal,
	lastmappedtoken,
	lastprocedure,
	laststatement,
	leftpadpp,
	line,
	mdate,
	minuses,
	mkrfile,
	mkrstr,
	mversion,
	nouqinternal,
	nouqprocedures,
	oldaryspec,
	oldctoken,
	oldlastprocedure,
	oldtoken,
	oldtypestatement,
	oppn,
	predeflist,
	promotedouble,
	ss,
        ss1,
        ss2,
        ss3,
	saifile,
	sailargdelim,
	sailbodydelim,
	saimacrodelimiters,
	sairargdelim,
	sairbodydelim,
	saistatement,
	saitoken,
	scmd,
	semit,
	ps_spaces,
	stars,
	uniqstuff,
	usepsaillibrary,
	vlist;

/* 
.LABEL [<PSGLBV-REQ-ARRAYS>]
*/
m_global INTEGER *blkapdlptr;  /* [0:maxblocks] */ 
                               /*  -- stack locAptr */
m_global STRING *blkagensym;   /* [0:maxblocks] */
                               /*  -- Name blk GENSYM for 
				   emitting After END */
m_global INTEGER *blkbits;     /* [0:maxblocks] */ 
                               /*  -- block 'state' bits
				  indicate TRUE if set to 1
				Bit (from right)  Function
				----------------   --------
				 0 = '1		   midOfExpr
				 1 = '2		   inCASEflag
				 2 = '4		   inIFflag
				 3 = '10	   isIFexpr
				 4 = '20	   firstLOCxct
				 5 = '40	   didLOCemit
				 6 = '100	   emitEnableFlag
				 7 = '200	   didBlkExit
				*/
m_global STRING *blkbgensym;    /* [0:maxblocks] */
                                /*  -- Name blk GENSYM 
				    for emitting Before END */
m_global STRING *blkfrearylist; /* [0:maxblocks] */  
                                /*  -- blk FreAryList for END */
m_global INTEGER *blkipdlptr;   /* [0:maxblocks] */ 
                                /*  -- stack locIptr */
m_global STRING *blkname;       /* [0:maxblocks] */
                                /*  -- Name blk label for BEGIN/END */
m_global STRING *blkpname;      /* [0:maxblocks] */
                                /*  -- last procedure name we are in */
m_global STRING *blksemit;      /* [0:maxblocks] */
                                /*  -- C code to emit */
m_global INTEGER *blkspdlptr;   /* [0:maxblocks] */ 
                                /*  -- stack locSptr */
m_global INTEGER *charisid;     /* [0:127] */ 
                                /*  -- CVEVALQUOTE char=ID char flag */
m_global STRING *charmap;       /* [0:255] */ 
                                /*  -- CVEVALQUOTE char mapper */

#if (docntfsm==1)
m_global  INTEGER *cntfsms;     /* [-1:maxfsms] */
                                /*  -- if /COUNTFSM ++(# FSM calls) */
m_global STRING *croaklist;     /* [0:maxcroakerrs+1] */ 
                                /*  -- CROAK-list */
m_global INTEGER *dcllocstkframe; /* [0:maxblocks] */ 
                                /*  -- loc. decl stk
				  frame, contains base index of declXXXX[]
				  for block structure */
m_global STRING *deathwish;     /* [0:maxstatistics] */
                                /*  -- Error graphic msgs */
m_global INTEGER *declblklvl;   /* [0:maxdeclptr] */
                                /* -- l.c. SAIL decl block level */
m_global STRING *declcsym;      /* [0:maxdeclptr] */ 
                                /*  -- Mapped C symbol/macro body */
m_global INTEGER *decldw;       /* [0:maxdeclptr] */
                                /*  -- SAIL decl word Bits
				  See Table L.2 in PSMACRO.REQ for
				  the bit allocation and macros to
				  access them */
m_global STRING *declformal;    /* [0:maxdeclptr] */ 
                                /*  -- l.c. SAIL decl formal arg types */
m_global INTEGER *declfsm;      /* [0:maxdeclptr] */ 
                                /*  -- RH(16-bits) PSAIL FSM
				  nbr if DW!fsm set. 
				  LH(16-bits) lexical
				  code used in COPY!EITHER */
m_global INTEGER *declhash;     /* [0:maxdeclptr] */ 
                                /*  -- dclSymPtr=index ptr,
				  the tables are used by UNIQ!DECLARATIONS */
m_global INTEGER *declinproc;   /* [0:maxdeclptr] */
                                /*  -- procedure where
				  declared else <MAIN> or 
				  <runtime>.
				  If procedure <id> then
				  'procedure[proc#]'.
				  If is a procedure <id> declar
				  then it is the cDeclaration */
m_global INTEGER *declnargs;    /* [0:maxdeclptr] */
                                /*  -- Number formal args
				      if there are in in the procedure any.
					Value	user defined function
					-----	--------
					0	symbol is not procedure
					-1	procedure has no args
					n>0	procedure has n args */
m_global INTEGER *declrclass;   /* [0:maxdeclptr] */
                                /*  -- If Not 0, then the
					has code index of the record
					class associated with this
					symbol. */
m_global STRING *declsize;      /* [0:maxdeclptr] */
                                /*  -- size of dimensions of
					the array if any. If symbol
					is SAIL Macro fragment
					then is number of dummy args */
m_global STRING *delimpdl;      /* [0:maxdelimpdl] */
                                /*  -- PSAIL macro delimiter stack */
m_global STRING *dumyname;      /* [0:20] */
                                /*  -- Arg list vars. ndummyArgs is indx */
m_global STRING *dumyrclass;    /* [0:20] */
                                /*  -- Arg list RCD!CLASS if RCD!PTR */
m_global INTEGER *dumytype;     /* [0:20] */
                                /*  -- Arg list SAIL Type of vars */
m_global INTEGER *dwptr;        /* [0:maxsymbols+1] */
                                /* -- PSAIL new symtab NODE
					ptr. Contains index of declXXX[] 
					arrays for intermediate symbol
					table.
					The hash fct points to both
					dwPtr[h] and saiSym[h] */

#if ((maxnodesize > 1)==0)
m_global INTEGER *dwavail;      /* [0:(maxnodesize*maxsymbols)+1] */
                                /*  -- PSAIL new symtab NODE AVAIL space */
#endif

m_global STRING *errfsm;        /* [0:maxrdlevels] */ 
                                /*  -- for ERR!HLR error analysis */
m_global STRING *errline;       /* [0:maxrdlevels] */ 
                                /*  --for ERR!HLR error analysis */
m_global INTEGER *emitepdl;     /* [0:maxnpdl+1] */ 
                                /*  -- for stacking emitEnableFlag 
                                       in CHK!EMIT() with @eEptr */
m_global INTEGER *errstatistics; /* [0:maxstatistics] */
                                /*  -- for /REPORT */
m_global STRING *evalarglist;   /* [0:maxmargs] */
                                /*  -- contains last
				    evaluated arglist elements
				    [1:nArgsFound] which is set
				    by MAP!CK!ARGS() */
m_global STRING *fore1list;     /* [0:maxfornest] */
                                /*  -- 'for' e1 at blockLevel' */
m_global STRING *fore2list;     /* [0:maxfornest] */
                                /*  -- 'for' e2 at blockLevel' */
m_global STRING *fore3list;     /* [0:maxfornest] */
                                /*  -- 'for' e3 at blockLevel' */
m_global STRING *hugecmtpdl;    /* [0:maxhugecmts] */
                                /*  -- for HUGE comments */
m_global STRING *localleap;     /* [0:20] */ 
                                /*  -- FOREACH local vars @ locLEAPptr */
m_global STRING *locaryname;    /* [0:maxlocsym] */ 
                                /*  -- Name of local dynamic array names 
				    @ locAptr */
m_global STRING *locitemname;   /* [0:maxlocsym] */
                                /*  -- Name of local LEAP 
				 set, list and item names @ locIptr */
m_global STRING *locstrname;    /* [0:maxlocsym] */
                                /*  -- name of local
				    string variable names @ locSptr */
m_global INTEGER *npdl;         /* [0:maxnpdl+1] */
                                /*  -- Used to do partial recursion */
m_global INTEGER *npdlcheck;    /* [0:2*maxblocks] */ 
                                /*  -- used in R!D DRYROT check
				    of 'nPDLptr' level chk */
m_global INTEGER *reqchan;      /* [0:4] */ /*  -- REQUIRE files status */
m_global STRING *reqfile;       /* [0:4] */ /*  -- REQUIRE files status */
m_global INTEGER *reqline;      /* [0:4] */ /*  -- REQUIRE files status */
m_global STRING *reqlnstr;      /* [0:4] */ /*  -- REQUIRE files status */
m_global INTEGER *reqoutput;    /* [0:4] */ /*  -- REQUIRE files status */
m_global INTEGER *reqpage;      /* [0:4] */ /*  -- REQUIRE files status */
m_global STRING *reqsaistr;     /* [0:4] */ /*  -- REQUIRE files status */
m_global STRING *saisym;        /* [0:maxsymbols+1] */ /* HASH table names */
m_global STRING *spdl;          /* [0:maxspdl+1] */
                                /*  -- Used to do partial recursion */
m_global INTEGER *spdlcheck;    /* [0:2*maxblocks] */ 
                                /*  -- used in R!D DRYROT check of 'sPDLptr'
				    level chk */
m_global STRING *stravail;      /* [0:maxstravail] */ 
                                /*  -- PSAIL symtab STRING AVAIL space */
m_global INTEGER *wrdavail;     /* [0:maxwrdavail] */  
                                /*  -- PSAIL symtab Word AVAIL space */
m_global INTEGER *wrdmap;       /* [0:maxwdmap] */ 
                                /*  -- nameMap 5-bit hash table */

#ifdef use_internal
/*INTERNAL*/ STRING ckeywords[10+1+maxckeywords] =
       {
	PNULL,
	"asm", "auto", "break", "CASE", "char", "class", "const",
	"default", "delete", "DO", "double", "ELSE", "enum", "extern",
	"float", "FOR", "friend", "GOTO", "IF", "inline", "int",
	"LONG", "NEW", "operator", "overload", "public", "register",
	"RETURN", "short", "sizeof", "static", "struct", "switch",
	"this", "typedef", "UNION", "unsigned", "virtual", "void",
	"WHILE"
       };
#endif

#ifdef use_external
extern STRING *ckeywords;       /* [1:maxckeywords] */
#endif
				/*  -- C++ keywords from
				    1-8-84, AT&T C.S. report TR108.
				    These words do NOT appear in
				    SAIL are in lower case. Do NOT
				    test common words which appear
				    in upper case. */

/*  -- NOTE: Should be consistent with CODExxxx macros in PSMACRO.REQ */
#ifdef use_internal
/*INTERNAL*/ STRING scvtype[10+33]=
       {
	"NULL",		        /* -- NO TYPE -- */
	"array",	        /* -- a -- */
	"interrupt",	        /* -- b -- */
	"string",	        /* -- c -- */
	"double",	        /* -- d -- */
	"event",	        /* -- e -- */
	"real",		        /* -- f -- */
	"label",	        /* -- g -- */
	"lisp_atom",	        /* -- h -- */
	"integer",	        /* -- i -- */
	"object",	        /* -- j -- */
	"lisp_Sexpr",	        /* -- k -- */
	"list",		        /* -- l -- */
	"macro",	        /* -- m -- */
	"void",		        /* -- n -- */
	"optional",	        /* -- o -- */
	"process",	        /* -- p -- */
	"record_pointer",       /* -- q -- */
	"reference",	        /* -- r -- */
	"set",		        /* -- s -- */
	"record_class",         /* -- t -- */
	"untyped", 	        /* -- u -- */
	"itemvar",	        /* -- v -- */
	"own",		        /* -- w -- */
	"item",		        /* -- x -- */
	"record_field",	        /* -- y -- */
	"safe",		        /* -- z -- */
	"item_array",	        /* -- { -- */
	"short",	        /* -- | -- */
	"byte",		        /* -- } -- */
	"c_array",	        /* -- ~ -- */
	"boolean"
       };	                /* -- is DUPLICATE for INTEGER -- i -- */
#endif

#ifdef use_external
extern STRING *scvtype;        /* [0:32] */
#endif
			       /*  -- @V.50.46 map type decl codes */

#ifdef use_internal
/*INTERNAL*/ STRING sublanguage[10+16]=
       {
        "ALGOL60-AND-STRINGS",
	"LEAP",
	"PROCESSES-EVENTS-AND-INTERRUPTS",
	"PSAIL-EXTENSIONS",
	null, null, null, null,
	null, null, null, null, null, null, null, null
       };
#endif

#ifdef use_external
extern STRING *sublanguage;    /* [0:15] */
#endif
			       /*  -- @V.45.228 for future sub
				   language classes in new symbol table.
			       */
/* 
.ENDLABEL
*/
m_global INTEGER 
	ps_itrash_,
	bitspsail,
	blocklevel,
	ceof, 
        cerr, 
        cbrk, 
        cchan, 
        ccount,
	cch,
	condstatementflag,
	cntunique,
	ctreof, 
        ctrerr, 
        ctrbrk, 
        ctrchan, 
        ctrcount,
	dbugcode,
	dclsymptr,
	delimtoppdl,
	dwfreelist,
	eeptr,
	firstiftoken,
	gencnt,
	ii,
	islastexecutableexpr,
	itemstart,
	jj,
	kk,
	lastdeclaration,
	lastfsm,
	lasthcnt,
	lasthfree,
	lastnargs,
	lastrclass,
	lastsublang,
	lasttype,
	lidtype,
	linecount,
	lineoneflag,
	lthwspp,
	locaptr,
	lociptr,
	locleapptr,
	locsptr,
	maxgcactivesize,
	maxlinelthpp,
	maxstrpdl,
	maxstkfstr,
	nargsfound,
	ndummyargs,
	nhsymbols,
	nhugecmts,
	npdlptr,
	nprocedures,
	nsym,
	pagecount,
	prevdclsymptr,
	rcvlevel,
	rdlevel,
	reqlevel,
	rrlevel,
	saieof, 
        saierr, 
        saibrk, 
        saichan, 
        saicount,
	spdlptr,
	stmntcnbr,
	stmntsperminute,
	strfreelist,
	timeday,
	timerun,
	timstartrun,
	timstoprun,
	totlinecount,
	typelastprocdecl,
	uniqwidth,
	warnlevel,
	wrdfreelist;

/* -----  SAIL Built in key words ---- */
m_global  INTEGER
	hany_class,
	hand,
	hash,
	hassoc,
	hbegin,
	hboolean,
	hcase,
	hcolon,
	hcomment,
	hc_array,
	hc_code,
	hdefine,
	hdiv,
	hdo,
	helse,
	helsec,
	hend,
	hendc,
	hevaldefine,
	hevalinclude,
	hevalredefine,
	hexternal,
	hfor,
	hforeach,
	hforward,
	hgeq,
	hgeneric,
	hif,
	hifc,
	hin,
	hinter,
	hinteger,
	hintrnal,
	hitem,
	hitemvar,
	hlabel,
	hland,
	hleap_array,
	hlength,
	hleq,
	hlist,
	hlistc,
	hlisto,
	hlong,
	hlnot,
	hlop,
	hlor,
	hlsh,
	hmax,
	hmin,
	hmod,
	hneq,
	hnomac,
	hnot,
	hor,
	hprint,
	hprocedure,
        hprocss,	    /*  -- for future use...@V.45.183 */
	hquick_code,
	hreal,
	hrecursive,
	hredefine,
	href_item,
	hreference,
	hremove,
	hrepeatable,
	hrot,
	hsafe,
	hset,
	hsetc,
	hseto,
	hsimple,
	hstart_code,
	hstep,
	hstring,
	hthenc,
	hunion,
	huntil,
	huntyped,
	hvalue,
	hwhile,
	hxor,

	hbackarrow,
	hdivide_sign,
	hleftbracket,
	hleftparen,
	hleftsquiggle,
	hminus,
	hquote,
	hsemicolon,

	h_main_,
	h_runtime_;


#if (parsemainsail==1)
m_global  INTEGER
	haddress,
	hbits,
	hcharadr,
	hclr,
	hclass,
	hior,
	hmsk,
	hntst,
	hntsta,
	hshl,
	hshr,
	htst,
	htsta;
#endif

m_global INTEGER
	adddumysymflag,
	bailswitch,
	debugswitch,
	didblkexit,
	didlocemit,
	didmainemit,
	douniquetest,
	emitenableflag,
	evalmacros,
	firstlocxct,
	firstmainxct,
	incaseflag,
	inifflag,
	isarrayadrflag,
	isckeywordflag,
	iscopy_toflag,
	iscvevalflag,
	isemitgcflag,
	isforeachflag,
	isfragmentflag,
	isifcflag,
	isifexpr,
	ismacroflag,
	ismakeflag,
	isnumberflag,
	ispreload_withflag,
	isquote,
	isrightstatementflag,
	isrcdclassflag,
	isrcdptrflag,
	issailkeywordflag,
	lastidflag,
	mainsailflag,
	midofcomment,
	midofexpr,
	midofquote,
	nbrcmtflag,
	noblocklabelwarningflag,
	nologoflag,
	nomacflag,
	notmainflag,
	nuldevflag,
	outputsailswitch,
	prttyprintflag,
	revalflag,
	sawdefineflag,
	sawreturnflag,
	sawstrfct,
	sawversionflag,
	screenflag,
	slobflag,
	uniqflag,
	usebacktraceflag,
	usechkflag,
	useclutterflag,
	usecntfsmflag,
	usecoerceflag,
	usecommentflag,
	useconcatflag,
	usecrlfflag,
	useextensionsflag,
	usefoldingflag,
	usegcflag,
	useifcevalflag,
	useleapflag,
	uselocalfilesflag,
	usemkrfileflag,
	usemoduleflag,
	usenamemapflag,
	usepmathflag,
	useprfileflag,
	useprocessesflag,
	userealflag,
	usereportflag,
	userequireflag,
	usetimerflag,
	yeserrorflag;

m_global float
	ssffactor;

/*		- - - - - - - - - - - - - - - - - - - - - */
/*		-    <Conditional Compiled> WATCH arrays  */
/*		- - - - - - - - - - - - - - - - - - - - - */
#if (dowatch==1)
#ifdef use_internal
        /*INTERNAL*/ INTEGER *w_count[10+1+maxwatch]={0};
        /*INTERNAL*/ INTEGER *w_time[10+1+maxwatch]={0};
#endif
#ifdef use_external
        extern INTEGER *w_count;  /* [1:maxwatch] */
        extern INTEGER *w_time;   /* [1:maxwatch] */
#endif
#endif /*DOWATCH*/


/*  ====> psglbv.h <==== */
