/* File: psmacros.h, being converted 12/25/87, 10:55:12AM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/
/* PSAIL cmd: psmacros.req[50,32,PSAIL,MODULE] */
/* PSAIL switches: /clutter/noerr:b */
/* Compiling HEADER file 'psmacros.h' */

#ifndef HASCONFIG
#include "config.h"	/* Declares the type of machine we are on */
#endif

#ifndef SAI_RUN
#include "sairun.h"	/* SAIL compatibility runtime package */
#endif

#ifndef GC_RUN
#include "psrung.h"		/* Garbage collector header file */
#endif

/*	 . . . . . . . . . . . . . . . . . . . . . . . . . . . . */
/*		FILE:	PSMACROS.REQ	

                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

                       UNIX/Revised January 25, 1988
                       UNIX/Revised December 28, 1987
                       May 17, 1987

               Derived from PSAIL.SAI V.43.50 7-19-84

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
        Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.
*/


/*
	--- All of the MACROS in the entire PSAIL package
	--- should be changed to the following coding
	--- in order to greatly simplify the code generated
	--- when PSAIL compiles itself. The code will be
	--- compilable by both SAIL and PSAIL. Note that SAIL can
	--- not handle any bogus identifiers (even macros which eval to
	--- NULL) in macro argument lists. It is for this reason that
	--- we must go to this cludge. The following macro which
	--- expects an INTEGER arg illustrates the point.

	IfC EQU(COMPILER!BANNER[4 for 5],"PSAIL")
	  ThenC "for PSAIL"
	Define ABC(INTEGER x)="CVS(x)".
	  EndC "for PSAIL".
	IfC Not EQU(COMPILER!BANNER[4 for 5],"PSAIL")
	  ThenC "for SAIL"
	Define ABC(x)="CVS(x)".
	  EndC "for SAIL".

NOTE: Macros IS!SAIL and IS!PSAIL are defined below doing the
above COMPILER!BANNER check, for your convenience.
*/


/*	- - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/*		S A I L    M A C R O    D E F N S		 */
/*	- - - - - - - - - - - - - - - - - - - - - - - - - - - - */


/*			NOTE: \ is not used in the C language */
/* NEW SAIL MACRO DELIMITERS=[\\\\] */

/*  -- NOTE: @V.53.42 June 7, 1986 --- Major change:
# --	Use the following macros with IFC code to supply all PSAIL
# -- macros with typed args to make the translation smoother.
# -- The typical macro first has the SAIL version and then the
# -- PSAIL version with the optimized TYPE included. This is
# -- only done for macros with args.
*/
#define is_psail TRUE

#define is_sail FALSE

/*  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
 #define addstat(i,x) {if(usereportflag) errstatistics[(i)] += (x)
			                         /* PSAIL!EVAL */
/*  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
#define arithcvtypecode(lcode,rcode) \
      ((lcode==codeinteger && rcode==codeinteger) ? codeinteger\
		: (lcode==codeinteger&&rcode==codereal ||\
		   rcode==codeinteger &&lcode==codereal) ? codereal\
                : (lcode==codereal&&rcode==codedouble ||\
		   rcode==codereal &&lcode==codedouble) ? codedouble\
		: lcode)
/*  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
#define check_dryrot(s,msg) /* no-op */
					/*  -- SAIL DRYROT check to be
					-- disabled when we are sure
					-- there is not lurking dryrot! */
/*  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
#define cvt_at_to_e(s) (s)

#define cvt_e_to_at(s) (s)

#define fast_equ(p,q) ((*p==*q) && equ(GC_PUSHS(p),GC_PUSHS(q)))

#define incfsm(i) if(usecntfsmflag) cntfsms[i]++  /* PSAIL!EVAL */

#define incstat(i) if(usereportflag) errstatistics[i]++  /* PSAIL!EVAL */

#define maxstat(i,x) if(usereportflag) \
	errstatistics[i]=MAX(errstatistics[i],(x))	/* PSAIL!EVAL */

#define pbool(x) ((x) ? catlist(2L,GC_PUSHS("T="),cvs(x)) \
		  : catlist(2L,GC_PUSHS("F="),cvs(x)))

#define dbug(code,x) if (debugswitch && (code&dbugcode)) dbug_it(code,x)

#define isalpha(x) (('a'<=(ps_itrash_= x) && ps_itrash_<='z') || \
		    ('A'<=ps_itrash_ && ps_itrash_<='Z') || \
		    (ps_itrash_=='_'))

#define isdigit(x) (('0'<=x && x<='9'))

#define isleapcode(x) ((ps_itrash_= ((x&037)+0140L))==codeitem||\
	ps_itrash_==codeitemvar ||ps_itrash_==codelist ||\
	ps_itrash_==codeset)

#define isleapdeclar(x) ( (*((ps_itrash_= hash_cx))!=0) &&\
           (hitem==ps_itrash_||hleap_array==ps_itrash_ ||\
           hitemvar==ps_itrash_ ||hlist==ps_itrash_ ||\
           href_item==ps_itrash_ ||hset==ps_itrash_))

#define isoctal(x) (('0'<=x && x<='7'))

#define isunaryscalartype(x) ((ps_itrash_=((x&037)+0140L))==codeinteger||\
			      ps_itrash_==codereal||ps_itrash_==codedouble)

#define isvariable(x) (('a'<=(ps_itrash_= x) && ps_itrash_<='z') ||\
		       ('A'<=ps_itrash_ && ps_itrash_<='Z') || \
		       ('0'<=ps_itrash_ && ps_itrash_<='9') ||\
		       (ps_itrash_=='_'))

#define iswhitespace(x) ((x==space||x==tab ||x==cr || x==lf ||x==ff))

#define rmv_integer_cast(x) if(*x=='(' && \
			       equ(subst(GC_PUSHS(x),1L,9L), \
				   GC_PUSHS("(INTEGER)"))) \
				     x= subst(GC_PUSHS(x),10L,length(x));\
                            else if ((*(x+length(x)-1))=='L') \
			      x= subst(GC_PUSHS(x),1L,length(x)-1L)

#define set_static(blvl) if (blvl<2) \
				{/* MAIN */\
				dcstaticdeclaration= "static ";\
				lastdeclaration= dw_static;\
				}/* MAIN */\
			  else 	{/*LOCAL */\
				dcstaticdeclaration= PNULL;\
				lastdeclaration= 0;\
				}/* LOCAL */

#define trash_left_ws(x) while(((x)!=PNULL) && iswhitespace(x)) \
		            ps_itrash_=LOP(x) /*  PSAIL!EVAL */

#define trash_right_space_tab(x) {/* TRASH!RIGHT!SPACE!TAB */\
			while ((*x!='\0') &&\
			      (ps_itrash_= (*(x+length(x)-1))) &&\
			      (ps_itrash_==space||ps_itrash_==tab)) \
				x= subst(GC_PUSHS(x),1L,length(x)-1L);\
			}/* TRASH!RIGHT!SPACE!TAB */

#define trash_right_ws(x) { /*TRASH!RIGHT!WS */\
			while ((x != PNULL) && \
			       (ps_itrash_=subst(GC_PUSHS(x), \
						 length(x),-1L) ) &&\
			       iswhitespace(ps_itrash_) )\
				 x= subst(GC_PUSHS(x),1L,length(x)-1L);\
			   } /* TRASH!RIGHT!WS */   /* PSAIL!EVAL */



/* 	------------------------------------------------ */
/* 	!   MACROS   FOR   E R R S T A T I S T I C S       */
/* 	------------------------------------------------ */
#define errnerrs 0	/*  -- nbr FATAL ERRORS if/NOERROR  */
#define err1warning 1	/*  -- nbr WARNING level 1 ERRORS */
#define err2warning 2	/*  -- nbr WARNING level 2 ERRORS */
#define err3warning 3	/*  -- nbr WARNING level 3 ERRORS */
#define err4warning 4	/*  -- nbr WARNING level 4 ERRORS */
#define err5warning 5	/*  -- nbr WARNING level 5 ERRORS */
#define err6warning 6	/*  -- nbr WARNING level 6 ERRORS */
#define err7warning 7	/*  -- nbr WARNING level 7 ERRORS */
#define err8warning 8	/*  -- nbr WARNING level 8 ERRORS */
#define err9warning 9	/*  -- nbr WARNING level 9 ERRORS */
#define err10warning 10	/*  -- nbr WARNING level 10 ERRORS */
#define errntgc 11	/*  -- nbr times SAIL GC CALLED */
#define errptgc 12	/*  -- Percent time SAIL GC CALLED */
#define errglbv 13	/*  -- nbr GLOBAL variables declared */
#define errlocv 14	/*  -- nbr LOCAL variables declared */
#define errnmacros 15	/*  -- nbr GLOBAL MACRO variables declared */
#define errsmacros 16	/*  -- size GLOBAL MACRO variables string space */
#define errproc 17	/*  -- nbr procedures declared */
#define errintern 18	/*  -- Nbr INTERNAL variables declared */
#define errextern 19	/*  -- Nbr EXTERNAL variables declared */
#define errforward 20	/*  -- nbr FORWARD procedures declared */
#define errusymbols 21  /*  -- size of SYMTAB used */
#define errfsymbols 22  /*  -- size of SYMTAB free */
#define errnbuiltin 23  /*  -- nbr of builtins declared */
#define errspdlmax 24   /*  -- maximum value of sPDLptr used */
#define errnpdlmax 25   /*  -- maximum value of nPDLptr used */
#define erralocmax 26   /*  -- maximum value of locAptr used */
#define errilocmax 27   /*  -- maximum value of locIptr used */
#define errslocmax 28   /*  -- maximum value of locSptr used */
#define errundf 29      /*  -- maximum number of UNDF msgs */
#define errwarning 30   /*  -- maximum number of WARNING msgs */
#define errnonportable 31 /*  -- maximum number of N.P. msgs */
#define errnclutter 32  /*  -- number UNUSED clutter variables */
#define errnhash_c 33   /*  -- nbr times HASH!C called */
#define errnprobes_hash_c 34 /*  -- nbr times HASH!C table probed */
#define errnlrg_comments 35 /*  -- maximum # large commets PDL */

/*
              ***  RECURSIVE DESCENT PDL MACROS  ***
	The following macros are used to implement
	the recursive descent stack due to a bug somewhere
	in the R.D. process which causes a SAIL PDL OVF error.
	This was discovered at version 8.00. When the bug
	is found, we can get rid of this trash and do it right
	using recursive procedures to do the stacking for us!
 */

#define push_aryname(s) { /* PUSH!ARYNAME */ \
			if ((++locaptr)>maxlocsym)\
			  err_hlr(catlist(3L,\
	       GC_PUSHS("[PUSH!ARYNAME] locAryName[] OVERFLOW! on '"),\
					  GC_PUSHS(s), GC_PUSHS("'"));\
			locaryname[locaptr]=(s);\
			maxstat(erralocmax,locaptr);  /* for /report */\
			} /* PUSH!ARYNAME */    /* PSAIL!EVAL */

#define push_itemname(s) {/*PUSH!ITEMNAME*/ \
			if ((++lociptr)>maxlocsym)\
			  err_hlr(catlist(3L, \
	       GC_PUSHS("[PUSH!ITEMNAME] locItemName[] OVERFLOW! on '"), \
					  GC_PUSHS(s), GC_PUSHS("'"));\
			locitemname[lociptr]=(s);\
			maxstat(errilocmax,lociptr);  /*for /report*/\
			} /* PUSH!ITEMNAME*/     /* PSAIL!EVAL */

#define push_strname(s) { /* PUSH!STRNAME*/\
			if((++locsptr)>maxlocsym)\
			    then \
			  err_hlr(catlist(3L, \
	       GC_PUSHS("[PUSH!STRNAME] locStrName[] OVERFLOW! on '"), \
					  GC_PUSHS(s), GC_PUSHS("'"));\
			locstrname[locsptr]=(s);\
			maxstat(errslocmax,locsptr);  /* for /report */ \
			} /* PUSH!STRNAME*/    /* PSAIL!EVAL */

#define chk_emit(sbuild,sfct) \
	       { /* CHK!EMIT */\
		 if(emitenableflag && ! didlocemit)\
		   { /* do EMIT */\
		     semit = emit_loc_code;\
		     emitepdl[++eeptr] = emitenableflag;\
		     emitenableflag = FALSE;\
		     sbuild = sfct;\
		     emitenableflag = emitepdl[eeptr--];\
		     if(semit != PNULL)\
		       { /* fix up string */ \
			 if(sbuild == PNULL)\
			   sbuild = semit;\
			 else sbuild=catlist(2L, \
					     GC_PUSHS(semit), \
					     GCPUSHS(sbuild));\
			 semit = PNULL;	/* clear it */\
		       } /* fix up string */\
		    } /* do EMIT */\
		 else sbuild=sfct;	/* simple eval */\
	       } /* CHK!EMIT */         /* PSAIL!EVAL */


/*		- - - - - - - - - - - - - - - - - - - - - */
/*		-    <Conditional Compiled> WATCH arrays  */
/*		- - - - - - - - - - - - - - - - - - - - - */

/*      	- - - - - - - - - - - - - - - - - - - - - - - -;
		W A T C H  timing optimization     M A C R O S ;
		- - - - - - - - - - - - - - - - - - - - - - - -;

 	The 3 WATCH!- macros are used to gather timing and # times a
procedures was executed type information about selected procedures
used in the program. It is normally turned off by redefining DOWATCH
to FALSE from TRUE. The WATCH!ON must be the FIRST executable
statement in the procedure and the WATCH!OFF must be the last before
the RETURN if any.  To add a new procedure XXXX to the watch macros,
edit the following:

	[1] Increment the value of 'maxWATCH'.
	[2] Add "XXXX" entry to the end of the PRESET!WITH table
	    for the proc[] string array.
	[3] Add a 'Define W!XXXX="..."' entry as the last watch number.
	[4] Add WATCH!ON(W!XXXX) and WATCH!OFF to procedure XXXX.
*/

#define maxwatch 170

#define watch_on  INTEGER _clock; _clock = callsys(0,"RUNTIM")

#define watch_off(p) { /* WATCH!OFF */ \
		w_time[p] += (callsys(0,"RUNTIM") - _clock); \
		w_count[p]++; \
		} /* WATCH!OFF */;

/*  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

/* 	@V.47.60 the WATCH!PRINT macro was moved to PSDBUG.SAI
	and is conditionally compiled there! NOTE: You must update
	the 'proc[]' string array in WATCH!PRINT entries when adding
	more procedures.
*/



/* 	Define the names of the selected procedures */
#define w_build_tables 1
#define w_chk_name_map 2
#define w_find_symbol 3
#define w_add_gc_pushs 4
#define w_hash_c 5
#define w_put_hash_c 6
#define w_chk_leap_optimize 7
#define w_chk_c_keyword 8
#define w_chk_expr_list 9
#define w_chk_id 10
#define w_chk_number 11
#define w_chk_sail_keyword 12
#define w_chk_switches 13
#define w_uniq_declarations 14
#define w_cv_print_arglist 15
#define w_cvactual_to_expected 16
#define w_cvdummy_arg 17
#define w_cvevalquote 18
#define w_cvlower 19
#define w_cvstype 20
#define w_cvtypes 21
#define w_cvupcase 22
#define w_infix_to_prefix 23
#define w_insert_before_white 24
#define w_pretty_print 25
#define w_remove_white_ends 26
#define w_fold_const_expr 27
#define w_set_extensions 28
#define w_emit_cleanup_code 29
#define w_emit_main_code 30
#define w_emit_loc_code 31
#define w_fsm0 32
#define w_fsm1 33
#define w_fsm2 34
#define w_fsm3 35
#define w_fsm4 36
#define w_fsm4a 37
#define w_fsm72 38
#define w_fsm5 39
#define w_fsm6 40
#define w_fsm7 41
#define w_fsm8 42
#define w_fsm9 43
#define w_fsm10 44
#define w_fsm11 45
#define w_fsm12 46
#define w_fsm13 47
#define w_fsm14 48
#define w_fsm15 49
#define w_fsm16 50
#define w_fsm17 51
#define w_fsm18 52
#define w_fsm19 53
#define w_fsm20 54
#define w_fsm21 55
#define w_fsm22 56
#define w_fsm23 57
#define w_fsm24 58
#define w_fsm25 59
#define w_fsm26 60
#define w_fsm27 61
#define w_fsm28 62
#define w_fsm29 63
#define w_fsm30 64
#define w_fsm31 65
#define w_fsm32 66
#define w_fsm33 67
#define w_fsm34 68
#define w_fsm35 69
#define w_fsm36 70
#define w_fsm37 71
#define w_fsm38 72
#define w_fsm39 73
#define w_fsm40 74
#define w_fsm41 75
#define w_fsm42 76
#define w_fsm43 77
#define w_fsm44 78
#define w_fsm45 79
#define w_fsm46 80
#define w_fsm47 81
#define w_fsm48 82
#define w_fsm49 83
#define w_fsm50 84
#define w_fsm51 85
#define w_fsm52 86
#define w_fsm53 87
#define w_fsm54 88
#define w_fsm55 89
#define w_fsm56 90
#define w_fsm57 91
#define w_fsm58 92
#define w_fsm59 93
#define w_fsm60 94
#define w_fsm61 95
#define w_fsm62 96
#define w_fsm63 97
#define w_fsm64 98
#define w_fsm65 99
#define w_fsm66 100
#define w_fsm67 101
#define w_fsm68 102
#define w_fsm69 103
#define w_fsm70 104
#define w_fsm71 105
#define w_chk_32bit_integer 106
#define w_copy_omit 107
#define w_copy_either 108
#define w_expand_macro 109
#define w_get_input 110
#define w_get_c_token 111
#define w_get_number 112
#define w_get_token 113
#define w_left_expr 114
#define w_left_id 115
#define w_rightexpr 116
#define w_rightid 117
#define w_rightstatement 118
#define w_cvt_sail_to_c 119
#define w_get_next_statement 120
#define w_map_be 121
#define w_map_ck_args 122
#define w_map_declar 123
#define w_map_expr 124
#define w_map_inf 125
#define w_map_leap_triple 126
#define w_map_quotes 127
#define w_map_ws_comments 128
#define w_pop_block_name 129
#define w_process_token 130
#define w_push_block_name 131
#define w_r_d_expr_map 132
#define w_simple_map 133
#define w_add_builtin 134
#define w_chk_integer 135
#define w_chk_real 136
#define w_chk_type 137
#define w_map_whitespace 138
#define w_pop 139
#define w_popnumber 140
#define w_push 141
#define w_pushnumber 142
#define w_map_embedded_comments 143
#define w_cvidw 144
#define w_cvdwi 145
#define w_rem_symbols 146
#define w_find_rc_symbol 147
#define w_fsm73 148
#define w_readfile 149
#define w_readtrash_graphics 150
#define w_chk_iconst 151
#define w_chk_sconst 152
#define w_cv5hash 153
#define w_cv5int 154
#define w_cvltypep 155
#define w_cvptypel 156
#define w_getid 157
#define w_justify_text 158
#define w_err_hlr 159
#define w_out_both 160
#define w_map_bkslash_str 161
#define w_issaideclar 162
#define w_isscalartype 163
#define w_set_preface 164
#define w_cvt_any_to_chr 165
#define w_p_pchk_line 166
#define w_ggdw_ptype 167
#define w_ppdw_ptype 168
#define w_mak_blk_exit 169
#define w_fsm11_keyword 170


/* 	------------------------------------------------ */
/* 	!   MACROS   FOR   NEW   SYMTAB			 */
/* 	------------------------------------------------ */

/* IFC EVAL(maxnodesize > 1)=0 */
 /* THENC <<<FAILED!!!>>>

comment 
Table L.1 SYMBOL TABLE DESCRIPTOR NODE IN dwAvail[]
---------------------------------------------------

  ---------------------------------------------------------------------
0 | FSM number (8bits) | BLOCKLEVEL (8bits) | NEXTNODE index (16bits) |
  ---------------------------------------------------------------------
1 | Descriptor Word (32-bits) (see table L.2 below)                   |
  ---------------------------------------------------------------------
2 | ARYHDR index (12bits) | RCLASSHDR index (12bits) | NARGS (8bits)  |
  ---------------------------------------------------------------------
3 | MAPSTR index (12bits) | FORMALARGSTR index (12bits) | 8bits<free> |
  ---------------------------------------------------------------------
4 | INPROC hash index (16-bits) |  HASH index this symbol 16-bits     |
  ---------------------------------------------------------------------

;

define gs_fsm(p) = \((dwAvail[p] LSH -24) Land '377)\;
define ps_fsm(p,v) = \Begin 
		     dwAvail[p]_(dwAvail[p] Land '00077777777) Lor
			    (((v) Land '377) LSH 24); End\;

define gs_blocklevel(p) = \((dwAvail[p] LSH -16) Land '377)\;
define ps_blocklevel(p,v) = \Begin 
		     dwAvail[p]_(dwAvail[p] Land '37700177777) Lor
			    (((v) Land '377) LSH 16); End\;

define gs_nextnode(p) = \(dwAvail[p] Land '177777)\;
define ps_nextnode(p,v) = \Begin 
		     dwAvail[p]_(dwAvail[p] Land '37777600000) Lor
			    ((v) Land '177777); End\;

define gs_dw(p) = \dwAvail[p+1]\;
define ps_dw(p,v) = \Begin dwAvail[p+1]_(v); End\;

define gs_aryhdr(p) = \((dwAvail[p+2] LSH -20) Land '7777)\;
define ps_aryhdr(p,v) = \Begin 
		     dwAvail[p+2]_(dwAvail[p+2] Land '00003777777) Lor
			    (((v) Land '7777) LSH 20); End\;

define gs_rclasshdr(p) = \((dwAvail[p+2] LSH -8) Land '7777)\;
define ps_rclasshdr(p,v) = \Begin 
		     dwAvail[p+2]_(dwAvail[p+2] Land '37774000377) Lor
			    (((v) Land '7777) LSH 8); End\;

define gs_nargs(p) = \(If (ps!iTrash!_(dwAvail[p+2] Land '377)) 
					Land '200
				Then -ps!iTrash! Else ps!iTrash!)\;
define ps_nargs(p,v) = \Begin 
		     dwAvail[p+2]_(dwAvail[p+2] Land '37777777400) Lor
			    ((v) Land '377); End\;

define gs_mapstr(p) = \((dwAvail[p+3] LSH -20) Land '7777)\;
define ps_mapstr(p,v) = \Begin 
		     dwAvail[p+3]_(dwAvail[p+3] Land '00003777777) Lor
			    (((v) Land '7777) LSH 20); End\;

define gs_formalargstr(p) = \((dwAvail[p+3] LSH -8) Land '7777)\;
define ps_formalargstr(p,v) = \Begin 
		     dwAvail[p+3]_(dwAvail[p+3] Land '37774000377) Lor
			    (((v) Land '7777) LSH 8); End\;

define gs_inproc(p) = \((dwAvail[p+4] LSH -16) Land '177777)\;
define ps_inproc(p,v) = \Begin 
		     dwAvail[p+4]_(dwAvail[p+4] Land '00000017777) Lor
			    (((v) Land '177777) LSH 16); End\;

define gs_hash(p) = \(dwAvail[p+4] Land '177777)\;
define ps_hash(p,v) = \Begin 
		     dwAvail[p+4]_(dwAvail[p+4] Land '37777600000) Lor
			    ((v) Land '177777); End\;
  */ /* ENDC */

/* 	---------------------------------------------------- */
/* 	!	P S A I L   DECLARATION TYPE INTERNAL CODES  */
/* 	---------------------------------------------------- */
#define codearray 'a'  /*  These go with the PRESET of sCVtype[] */
#define codeinterrupt 'b'
#define codestring 'c'
#define codedouble 'd'
#define codeevent 'e'
#define codereal 'f'
#define codelabel 'g'
#define codelispatom 'h'
#define codeinteger 'i'
#define codeobject 'j'
#define codelisp_sexpr 'k'
#define codelist 'l'
#define codemacro 'm'
#define codevoid 'n'
#define codeoptional 'o'
#define codeprocedure 'p'
#define coderecptr 'q'
#define codereference 'r'
#define codeset 's'
#define coderecclass 't'
#define codeuntyped 'u'
#define codeitemvar 'v'
#define codeown 'w'
#define codeitem 'x'
#define coderecmem 'y'
#define codesafe 'z'		/*  -- 26  */

/*  -- @V.50.46 The following are non-alphabetic extensions which must
be used with care since we may test for 'a:z'. Loosen up the tests
wherever they may be */
#define codeitemarray '{'	/*  -- 27  */
#define codeshort '|'		/*  -- 28  */
#define codebyte '}'		/*  -- 29  */
#define codecarray '~'	        /*  -- 30  */
#define codeboolean 'i'	        /*  -- 31  */


/* 	---------------------------------------------------- */
/* 	!	P S A I L   DESCRIPTIOR (WORD (DW) BITS      */
/* 	---------------------------------------------------- */
/*  
Table L.2 SYMBOL TABLE DESCRIPTOR WORD BIT ALLOCATION (@V.47.49)
----------------------------------------------------------------

 31-26  25-22
---------------
| Item | sub  |
---------------
  type   Lang.
 index   index

 21 20 19 18 17 16 15 14 13 12 11 10  9  8  7  6  5   4-0
------------------------------------------------------------
|  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  | prim. |
------------------------------------------------------------
  r  g  f  r  u  C  p  f  l  i  e  m  f  a  a  f  i  type
  e  e  o  e  n  a  r  o  e  n  x  a  r  u  r  s  t  index
  f  n  r  c  s  r  o  r  a  t  t  c  a  t  r  m  e
  e  e  w  o  a  r  c  m  p  e  e  r  g  o0 a     m
  r  r  a  r  f  a  e  a     r  r  o  m  /  y     A
  e  i  r  d  e0 y  d  l     n  n     e  s        r
  n  c  d mem /     u  A              n  t        r
  c  P  R     s     e  r              t  a        a
  e  r  e     a     D  g                 t        y
     o  f     f     e                    i
     c        e1    c                    c1
                    l
 */


#define gdw_itemtype(x) ((RSH(x,26L))&077)

#define pdw_itemtype(x,v) x= (x&000377777777)|(LSH((v&077),26L))

#define gdw_ptype(x) (((ps_itrash_=((x) & 037))>0) \
		      ? (ps_itrash_+"a"-1) : 0)     /* PSAIL!EVAL */  
  				      /*  in ['a':'z' and '{|}~DEL'] */

#define pdw_ptype(x,v) x= (x&0777777777740L)|(037&((('a'<=v && v<=0177L))\
					? (v-0142L) : 0L))
                                    /*  in [a:z and {|}~del] */\

#define gdw_sublanguage(x) ((RSH(x,22L))&017)

#define pdw_sublanguage(x,v) x= (x&037417777777)|(LSH((v&017),22L))


#define dw_itemarray 040
#define dw_fsm 0100
#define dw_array 0200
#define dw_static 0400
#define dw_fragment 01000
#define dw_macro 02000
#define dw_external 04000
#define dw_internal 010000
#define dw_leap 020000
#define dw_formalarg 040000
#define dw_procedure 0100000
#define dw_carray 0200000
#define dw_safe 0400000
#define dw_recmem 01000000
#define dw_forwardref 02000000
#define dw_genericproc 04000000
#define dw_reference 010000000

/*  -- The following bit pattern is used to MASK 'lastType' when
 -- passing a DW back from PROCESS!TOKEN 
*/
 #define dw_mask ('37400000037 | \
			    dw_itemarray | dw_array |\
			    dw_leap | dw_formalarg | \
			    dw_procedure | dw_carray | \
			    dw_safe | dw_recMem | dw_reference)
                                                   /* PSAIL!EVAL */

/*Finished[psmacros.req[50,32,PSAIL,MODULE]==>psmacro.h] 12/25/87, 11:03:28AM
# .SAI lines=1242 L.P.M=243, # .C stmnts=627 C-S.P.M.=123
Real TIME =00:07:56 CPU TIME  =00:04:50,   60.924%
*/
/* ------------------------------------------------------------ */

