/* File: pspprt.c, being converted 12/25/87, 04:06:45PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/
/* PSAIL cmd: pspprt.sai[50,32,PSAIL,MODULE] */
/* PSAIL switches: /clutter/noerr:b */
/* ENTRY (procedure pkg) */

#define LOCALFILE 1     /* use "file" not <file> */


/* SAIRUN.H PSAIL runtime package and macro definitions used in    */
/* evaluating some SAIL converted forms:                           */
#ifndef HASCONFIG
#include "config.h"	/* Declares the type of machine we are on */
#endif
#ifndef SAI_RUN
#include "sairun.h"	/* SAIL compatibility runtime package */
#endif
/*	 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */


/* psrunG.h - used by SAIL-style String Garbage Collector:        */
#ifndef GC_RUN
#include "psrung.h"		/* Garbage collector header file */
#endif
/*	 . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

/* PSPPRT.SAI */
/*
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

		April 23, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1987 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.


              Derived from PSAIL.SAI V.43.50   7-19-84


 */


#include "psparam.h" /* SOURCE!FILE */

#include "psmacros.h" /* SOURCE!FILE */

#include "psglbv.h" /* SOURCE!FILE */

#include "psdbug.h" /* SOURCE!FILE */

#include "pschek.h" /* SOURCE!FILE */

#include "pslex.h" /* SOURCE!FILE */

/*FORWARD*/  /*INTERNAL*/  STRING justify_text(); /* STRING wsprefacenext; STRING wsprefacefirst; STRING txt; */
/*FORWARD*/  /*INTERNAL*/  STRING pretty_print(); /* STRING s; */
/*  ------------------------------------------------------ */
/*  -    V A R I A B L E S   L O C A L   T O   M O D U L E */
/*  ------------------------------------------------------ */
/*  --
	These variables are used only in this module which is
dedicated to making things look good.
 */
static INTEGER 
	brktcnt		/*  -- [] counter */,
	ch, 
	ch1		/*  -- characters used during parse */,
	is_2statement		/*  -- in #<keyword> C statement */,
	isdefinestatement	/*  -- in #DEFINE C statement */,
	keepwsflag		/*  -- keep white space in quote or cmt */,
	lbl			/*  -- length of bldLine */,
	lctoken		/*  -- length of cToken */,
	lfctid			/*  -- break index if saw a function call */,
	llparen		/*  -- break index if saw a '(' */,
	lrparen		/*  -- break index if saw a ')' */,
	lsc			/*  -- break index if saw a semicolon */,
	lcomma			/*  -- break index if saw a ',' */,
	loclinecnt		/*  -- local line counter for this call */,
	loctokcnt		/*  -- count of local tokens */,
	ls1, 
	ls2, 
	ls3		/*  -- lengths of s1, s2, and s3 */,
	lthleftpadpp		/*  -- working length of leftPadPP */,
	inlist			/*  -- flag indicating in an arg list */,
	parencnt		/*  -- () counter */,
	pushbackflag		/*  -- flag indicating push token back
					to input line */,
	wasfctcallflag = 0;		/*  -- oldToken was start of FCT call */

 static INTEGER
	lastrow	/*  -- which column we left off at the
				last time we were here */,
	nlvlpp		/*  -- block level of {  } detected here. */,
	onceonlyflag = 0;	/*  -- once only initialization flag if
				     314159 */

/* NEW SAIL MACRO DELIMITERS=[\\\\] */
#define change_leftpad {"CHANGE!LEFTPAD"\
		/*  -- note ws preface is 0leftpadpp0  */\
	if ((nlvlpp<=0) ||(lthwspp==0)) leftpadpp= PNULL; \
	else leftpadpp= subsr(GC_PUSHS(ps_spaces),1L,(MAX(nlvlpp,1L))*lthwspp);\
	lthleftpadpp= length(GC_PUSHS(leftpadpp));		/*  -- size of preface */\
	}/* CHANGE!LEFTPAD */

/*  ----------------------------------------------------- */
/*INTERNAL*/  STRING justify_text(wsprefacenext,wsprefacefirst,txt)
	STRING wsprefacenext;
	STRING wsprefacefirst;
	STRING txt;
/*  ----------------------------------------------------- */
{/* JUSTIFY!TEXT */
/*  --
.LABEL [<++PSAIL PROCEDURE: JUSTIFY!TEXT>]
.INDEX ++PSAIL PROCEDURE: JUSTIFY!TEXT
DESCRIPTION:
	Justify C 'txt' to MAXLTH columns such that 

		wsPrefaceFirst & txt1 & CRLF
		wsPrefaceNext & txt2 & CRLF
			. . .
		wsPrefaceNext & txtN

	account for 'txt'. Additional CRLF lines are added if needed.
Do not split a lines in the middle of a quote. Keep '&'<id> and '*'<id>
with <id> if WS does not follow & or *.
Keep the ',' at the end of the previous line if it is the split
token.

Don't break on '(' if it is part of a function call or a cast:
		'abc(...)' or '(INTEGER)x'
Note: If we can break on both ',' and '(' then break on ',' which has
higher precedence.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:
	1. Breaks casts (INTEGER *)0 aafter ).
	2. Doesn't handle tabs correctly.

.ENDLABEL [<++PSAIL PROCEDURE: JUSTIFY!TEXT>]
 */

STRING s, 
	s1, 
	s2, 
	tok, 
	t, 
	nomore, 
	oldtok;
INTEGER ch, 
	ls1, 
	ltok, 
	k, 
	lnew, 
	lastcomma, 
	lastlparen;
#define maxlth 72

;

GC_EPOPS(dbug(0200000L,catlist(11L,GC_PUSHS("[JUSTIFY!TEXT] MAXLTH=72 wsPrefaceFirst=\'"),
        GC_PUSHS(wsprefacefirst),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  wsPrefaceNext=\'"),GC_PUSHS(wsprefacenext),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  txt=\'"),
        GC_PUSHS(txt),GC_PUSHS("\'"))));
/* NO-OP */;


/*  ----------------------------------------------------------------
# --	[1] note: preprocess tabs to ws spaces before measure it
# ---------------------------------------------------------------- */
GC_POPS(txt); /* from GC string PDL */
GC_POPS(wsprefacefirst); /* from GC string PDL */
GC_POPS(wsprefacenext); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(wsprefacenext); /* for G.C. */
GC_NOTESTRING(wsprefacefirst); /* for G.C. */
GC_NOTESTRING(txt); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(tok); /* for G.C. */
GC_NOTESTRING(t); /* for G.C. */
GC_NOTESTRING(nomore); /* for G.C. */
GC_NOTESTRING(oldtok); /* for G.C. */
tok= PNULL;		/*  -- set up to setup oldTok first time */
s= "@";			/*  -- final output string */
s1= "@";			/*  -- current line working string */
if (*((s2= wsprefacefirst))!='\0') while (*s2!='\0')
		{/* process the initial WS */
		/*  -- Note that we give the CRLF's to s not s1 */
		if (*s2!=*cr) s1= catlist(2L,GC_PUSHS(s1),GC_PUSHS(LOP(s2))); else s= catlist(3L,GC_PUSHS(s),GC_PUSHS(LOP(s2)),GC_PUSHS(LOP(s2))); /*  -- remove at once */
		}/* process the initial WS */
ls1= length(GC_PUSHS(s1));		/*  -- length of current line being assembled */
lastcomma= lastlparen= 0;   /*  -- i.e. there was no previous ',' or '(' */
GC_EPOPS(dbug(0200000L,catlist(7L,GC_PUSHS("[JUSTIFY!TEXT].0.1 s=\'"),GC_PUSHS(s),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" s1=\'"),
        GC_PUSHS(s1),GC_PUSHS("\'"))));


/*  -------------------------------
# --	[2] Justify the 'txt'
# ------------------------------- */
while ((*txt!='\0'))
	{/* eat up txt to make output string s */
/*  -----------------------------------------------
# --	[2.1] Get a complete C token to process
# ----------------------------------------------- */
	oldtok= tok;		/*  -- remember it in case need lookback */
/*  # # DBUG('200000,"[JUSTIFY!TEXT].1 s='"&s&"'"&CRLF&"  |s1|="&CVS(LENGTH(s1))&" s1='"&s1&"'"&CRLF&"  txt='"&txt&"'") */
/*  # # @V.54.71	Do tok_GET!C!TOKEN(txt,(noMore_NULL))
# # # @V.54.71	Until tok Neq NULL Or txt=NULL */
	tok= GC_EPOPS(get_c_token(&txt,&(nomore= PNULL)));
	if ((*tok=='&'||*tok=='*') &&!iswhitespace((INTEGER)*txt)) tok= catlist(2L,GC_PUSHS(tok),get_c_token(&txt,&(nomore= PNULL))); /*  -- keep
						pointers together */
	if (*oldtok==','&&*tok=='(')
			{/* keep '(cast)' together */
			tok= catlist(2L,GC_PUSHS(tok),scan(&txt,27L,&ch)); /*  -- '(<SC>)' for ')' */
			tok= catlist(2L,GC_PUSHS(tok),makstr(ch));
			}/* keep '(cast)' together */
	else if ((*tok!=',') &&
	        ((*txt=='('&&(ch= (*(tok+length(tok)-1)))!='\0' &&
	         !(isalpha(makstr(ch)) ||isdigit(ch))) ||
	        *txt=='['))
		{/* keep 'fct()' or 'id[' together */
		tok= catlist(2L,GC_PUSHS(tok),GC_PUSHS(LOP(txt)));	/*  -- keep together */
		if (ch=='('&&*txt==')') tok= catlist(2L,GC_PUSHS(tok),GC_PUSHS(LOP(txt))); /*  -- '()' case */
		}/* keep 'fct()' or 'id[' together */
	ltok= length(GC_PUSHS(tok));		/*  -- length of current token */
GC_EPOPS(dbug(0200000L,catlist(16L,GC_PUSHS("[JUSTIFY!TEXT].2 lS1="),cvs(ls1),
        GC_PUSHS(" |s1|="),cvs(length(GC_PUSHS(s1))),
        GC_PUSHS(" lTok="),cvs(ltok),GC_PUSHS(" |tok|="),
        cvs(length(GC_PUSHS(tok))),GC_PUSHS(" tok=\'"),GC_PUSHS(tok)
        ,GC_PUSHS("\' =0"),cvos((INTEGER)*tok),GC_PUSHS(crlf),
        GC_PUSHS(" txt=\'"),GC_PUSHS(txt),GC_PUSHS("\'"))));


/*  -------------------------------------------------------------------
# --	[2.2] Check if need to break line since it would be too long
# ------------------------------------------------------------------- */
/*  # # @V.54.70 NOTE following was '(tok Neq ",")' before */
	if ((((lnew= (ls1+ltok))>=72L) &&(*tok!='(') &&
	    (*tok!=')') &&(*tok!=']')) ||
	   (*tok==*cr&&*txt==*lf))
		{/* split line since adding 'tok' makes too long */
GC_EPOPS(dbug(0200000L,catlist(25L,GC_PUSHS("[JUSTIFY!TEXT].2.0.1 |tok|="),cvs(length(
        GC_PUSHS(tok))),GC_PUSHS(" lTok="),cvs(ltok),
        GC_PUSHS(" tok=\'"),GC_PUSHS(tok),GC_PUSHS("\'=0"),
        cvos((INTEGER)*tok),GC_PUSHS(crlf),GC_PUSHS(" lastCOMMA="),
        cvs(lastcomma),GC_PUSHS(" lastLPAREN="),cvs(lastlparen),
        GC_PUSHS(" lS1="),cvs(ls1),GC_PUSHS(" |s1|="),
        cvs(length(GC_PUSHS(s1))),GC_PUSHS(crlf),GC_PUSHS(" s1=\'"),
        GC_PUSHS(s1),GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" s=\'")
        ,GC_PUSHS(s),GC_PUSHS("\'"))));


/*  --------------------------------------------------------------------
# --	[2.2.1] See if need to backup and break at previous ',' or ')'
# -------------------------------------------------------------------- */
		if ((lnew>72L) &&(*tok!=*cr) &&
		   (k= ((lastcomma>0) ? lastcomma : lastlparen))>0)
			{/* break line at 'k' for ',' or '(' */
GC_EPOPS(dbug(0200000L,catlist(30L,GC_PUSHS("[JUSTIFY!TEXT].2.1 tok=\'"),GC_PUSHS(tok),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" k="),cvs(k),
        GC_PUSHS(" lNew="),cvs(lnew),GC_PUSHS(" lastCOMMA="),
        cvs(lastcomma),GC_PUSHS(" lastLPAREN="),cvs(lastlparen),
        GC_PUSHS(crlf),GC_PUSHS(" s1[1 to k]=\'"),subst(GC_PUSHS(s1)
        ,1L,k),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" s1[k+1 to inf]=\'"),subst(GC_PUSHS(s1),k+1L,
        length(s1)),GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" lS1="),
        cvs(ls1),GC_PUSHS(" s1=\'"),GC_PUSHS(s1),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" s=\'"),GC_PUSHS(s),GC_PUSHS("\'"))));
			tok= catlist(2L,subst(GC_PUSHS(s1),k+1L,length(s1)),GC_PUSHS(tok));
			s1= subst(GC_PUSHS(s1),1L,k);   /*  -- break at ',' or '(' */
			ltok= length(GC_PUSHS(tok));
			ls1= k;
GC_EPOPS(dbug(0200000L,catlist(16L,GC_PUSHS("[JUSTIFY!TEXT].2.1.1 tok=\'"),GC_PUSHS(tok),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" s1=\'"),
        GC_PUSHS(s1),GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" lS1=")
        ,cvs(ls1),GC_PUSHS(" |s1|="),cvs(length(GC_PUSHS(s1))),
        GC_PUSHS(" lTok="),cvs(ltok),GC_PUSHS(" |tok|="),
        cvs(length(GC_PUSHS(tok))))));
			}/* break line at 'k' for ',' or '(' */


/*  -----------------------------------------------------------------
# --	[2.2.2] Save broken line in output string, then reset the
# --	accumulator line string 's1'.
# ----------------------------------------------------------------- */
		ch= LOP(s1);		/*  -- trash '@' preface char */
/*  # # @V.56.06	If (s1=CR And LENGTH(s)>1) Or (s1 Neq CR)
			Then s_s & s1 */		/*  -- emit as new line */
		s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s1));		/*  -- emit as new line */
		if (!equ(subsr(GC_PUSHS(wsprefacenext),1L,2L),GC_PUSHS(crlf))) s= catlist(2L,GC_PUSHS(s),GC_PUSHS(crlf));  /*  -- so not CRLF twice */
		lastcomma= lastlparen= 0;
		s1= "@";
		if (*wsprefacenext!='\0') s1= catlist(2L,GC_PUSHS(s1),GC_PUSHS(wsprefacenext));
		if (*tok!=*cr) s1= catlist(2L,GC_PUSHS(s1),GC_PUSHS(tok)); else ch= LOP(txt);	/*  -- trash the LF */
		ls1= length(GC_PUSHS(s1));
GC_EPOPS(dbug(0200000L,catlist(19L,GC_PUSHS("[JUSTIFY!TEXT].2.2 NEW lS1="),cvs(ls1),
        GC_PUSHS(crlf),GC_PUSHS(" s1=\'"),GC_PUSHS(s1),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" s=\'"),GC_PUSHS(s),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" lS1="),cvs(ls1),
        GC_PUSHS(" |s1|="),cvs(length(GC_PUSHS(s1))),
        GC_PUSHS(" lTok="),cvs(ltok),GC_PUSHS(" |tok|="),
        cvs(length(GC_PUSHS(tok))))));
		}/* split line since adding 'tok' makes too long */


/*  -----------------------------------------------------------------
# --	[2.3] We are ok, line is not too long (or so we think) so
# --	just add token to accumulator line string.
# ----------------------------------------------------------------- */
	else	{/* Add 'tok' to current line */
		s1= catlist(2L,GC_PUSHS(s1),GC_PUSHS(tok));
		ls1 = ls1+ltok;
		if (*tok==',') lastcomma= ls1  /*  -- @V.55.19 may need to
					add +1 under some conditions */; 
		else if (*tok=='('&&ltok==1) lastlparen= ls1; /*  -- need to make sure
						length is 1 to avoid
						breaking casts!
 */GC_EPOPS(dbug(0200000L,catlist(24L,GC_PUSHS("[JUSTIFY!TEXT].2.3 lS1="),cvs(ls1),
        GC_PUSHS(" |s1|="),cvs(length(GC_PUSHS(s1))),
        GC_PUSHS(" lTok="),cvs(ltok),GC_PUSHS(" |tok|="),
        cvs(length(GC_PUSHS(tok))),GC_PUSHS(crlf),
        GC_PUSHS(" lastCOMMA="),cvs(lastcomma),
        GC_PUSHS(" lastLPAREN="),cvs(lastlparen),GC_PUSHS(" tok=\'")
        ,GC_PUSHS(tok),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" s1=\'"),GC_PUSHS(s1),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" s=\'"),GC_PUSHS(s),GC_PUSHS("\'"))));
		}/* Add 'tok' to current line */
	}/* eat up txt to make output string s */


/*  ----------------------------------------------------------------
# --	[3] When all done, add any remaining accumulator line to
# --	output string.
# ---------------------------------------------------------------- */
;
if (ls1!=0)
	{/* add final fragment */
	ch= LOP(s1);			/*  -- trash '@' preface char */
	s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s1));
	}/* add final fragment */

ch= LOP(s);				/*  -- trash '@' preface char */
GC_EPOPS(dbug(0200000L,catlist(3L,GC_PUSHS("[JUSTIFY!TEXT].3 s=\'"),GC_PUSHS(s),GC_PUSHS("\'"))));
/* NO-OP */;

;
GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 't'=<L0> string                               */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/



#undef maxlth
}/* JUSTIFY!TEXT */
/*  ----------------------------------------------------- */
 static void p_pchk_line(s,bldline,sresult)
	STRING *s;
	STRING *bldline;
	STRING *sresult;
/*  ----------------------------------------------------- */
{/* P!PCHK!LINE */
/*   --
.LABEL [<++PSAIL PROCEDURE: P!PCHK!LINE>]
.INDEX ++PSAIL PROCEDURE: P!PCHK!LINE
DESCRIPTION:
	NOTE: this procedures is only called from PRETTY!PRINT and is
used to wrap a line from 's' to 'maxLineLthPP' length maximum columns
and insert CRLF at proper punctuation. Also add leading white space
where appropriate with each block level having 'lthWSPP' default is
4) spaces. The algorithm justifies text and keeps track of the block
level. The pretty printer detected block level 'nLvlPP' is used to
set the 'leftPadPP' spaces.

Note: indices of special key words are kept for each bldLine being
	constructed in case we need to break. Eg.
        x = 3 + (4+5) + abc(xyzzy,emacs,foobah) -3<SC>
                ^          ^            ^     ^   ^
                |          |            |     |   |
            lLPAREN      lFCTID       lCOMMA  |  lSC
                                             lRPAREN

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:
	--- lots...

.ENDLABEL [<++PSAIL PROCEDURE: P!PCHK!LINE>]
 */
/*  -- The following INTEGER variables are defined global to this
# -- module but local to other modules */
/*  --	brktCnt,	# -- [] counter */
/*  --	ch, ch1,	# -- characters used during parse */
/*  --	is#statement,	# -- in #<keyword> C statement */
/*  --	isDEFINEstatement,  # -- in #DEFINE C statement */
/*  --	keepWSflag,	# -- keep white space in quote or cmt */
/*  --	lBL,		# -- length of bldLine */
/*  --	lCtoken,	# -- length of cToken */
/*  --	lFCTID,		# -- break index if saw a function call */
/*  --	lLPAREN,	# -- break index if saw a '(' */
/*  --	lRPAREN,	# -- break index if saw a ')' */
/*  --	lSC,		# -- break index if saw a semicolon */
/*  --	lCOMMA,		# -- break index if saw a ',' */
/*  --	locLineCnt,	# -- local line counter for this call */
/*  --	locTokCnt,	# -- count of local tokens */
/*  --	lS1, lS2, lS3,	# -- lengths of s1, s2, and s3 */
/*  --	lthLeftPadPP,	# -- working length of leftPadPP */
/*  --	inList,		# -- flag indicating in an arg list */
/*  --	parenCnt,	# -- () counter */
/*  --	pushBackFlag,	# -- flag indicating push token back
				to input line */
/*  --	wasFCTcallFlag,	# -- oldToken was start of FCT call */
STRING
/*  --	bldLine,	# -- line being assembled */
	ctoken		/*  -- current token being processed */,
	nomore		/*  -- junk variable for GET!C!TOKEN call */,
	s1, 
	s2, 
	s3, 
	s4
/*  --	sResult,	# -- output assembly of lines 
					already justified */,
	ws		/*  -- white space */,
	wsnl;		/*  -- white space for next line */
INTEGER i,
	j,
	k;
/*  -- Own Integer
# -- 	lastRow,	# -- which column we left off at the
				last time we were here */
/*  -- 	nLvlPP,		# -- block level of {  } detected here. */
/*  -- 	onceOnlyFlag */	/*  -- once only initialization flag if
				     314159 */

/* LABEL  doitagain */

;

GC_EPOPS(dbug(0200100L,catlist(3L,GC_PUSHS("[P!PCHK!LINE] s=\'"),GC_PUSHS(*s),GC_PUSHS("\'"))));
GC_EPOPS(dbug(0200100L,catlist(14L,GC_PUSHS("[P!PCHK!LINE].1 |lastRow|="),cvs(lastrow),
        GC_PUSHS(" |s|="),cvs(length(GC_PUSHS(*s))),GC_PUSHS(crlf),
        GC_PUSHS(" lthWsPP="),cvs(lthwspp),GC_PUSHS(" nLvlPP="),
        cvs(nlvlpp),GC_PUSHS(" parenCnt="),cvs(parencnt),
        GC_PUSHS(" oldCtoken=\'"),GC_PUSHS(oldctoken),GC_PUSHS("\'"))));
GC_EPOPS(dbug(0200100L,catlist(15L,GC_PUSHS("[P!PCHK!LINE].1.0.1 oldCtoken=\'"),
        GC_PUSHS(oldctoken),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" bldLine=\'"),GC_PUSHS(*bldline),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" sResult=\'"),GC_PUSHS(*sresult),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" s=\'"),GC_PUSHS(*s)
        ,GC_PUSHS("\'"))));
/* NO-OP */;



/*  ------------------------------------------------------------
# --	[2] Text justify, reading input line by line from 's'
# --	CHECK EACH LINE...					
# ------------------------------------------------------------ */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(bldline); /* for G.C. */
GC_NOTESTRING(sresult); /* for G.C. */
GC_NOTESTRING(ctoken); /* for G.C. */
GC_NOTESTRING(nomore); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(s3); /* for G.C. */
GC_NOTESTRING(s4); /* for G.C. */
GC_NOTESTRING(ws); /* for G.C. */
GC_NOTESTRING(wsnl); /* for G.C. */
doitagain:
GC_EPOPS(dbug(0200100L,catlist(3L,GC_PUSHS("[P!PCHK!LINE].1.1 s=\'"),GC_PUSHS(*s),
        GC_PUSHS("\'"))));
	s1= GC_EPOPS(scan(s,1L,&ch));		/*  -- get a line by Scanning
					for CRLF and trashing the CRLF */
GC_EPOPS(dbug(0200100L,catlist(11L,GC_PUSHS("[P!PCHK!LINE].1.1.1 ch=\'"),GC_PUSHS(ps_strash_=
         GC_EPOPS(makstr(ch))),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" s1=\'"),GC_PUSHS(s1),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" s=\'"),GC_PUSHS(*s),GC_PUSHS("\'"))));


/*  ------------------------------------------------------------
# --	[2.0.1] Setup parameters for line before justifying it
# ------------------------------------------------------------ */
	is_2statement= 0L;	/*  -- reset for each line */
	if (*s1=='#')
		{/* is '#'<keyword> */
		is_2statement= 1L;	/*  -- force column 1... */
		if (equ(subsr(GC_PUSHS(s1),1L,7L),GC_PUSHS("#define")))
			{/* Set DEFINE flag */
			isdefinestatement= 1L;     /*  -- Note: SAIL 
				     will force #define to column 1 */
			k= nlvlpp;
			++nlvlpp; /*  -- put macros indented */
			change_leftpad;
			nlvlpp= k;		/*  -- restore it */
			is_2statement= 1L;
			}/* Set DEFINE flag */
		else	{/* Not Define */
			}/* Not Define */
GC_EPOPS(dbug(0200000L,catlist(11L,GC_PUSHS("[P!PCHK!LINE].2 oldCtoken=\'"),GC_PUSHS(
        oldctoken),GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" s1=\'"),
        GC_PUSHS(s1),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" sResult=\'"),GC_PUSHS(*sresult),GC_PUSHS("\'"))));
		if (*oldctoken!=*cr)
			{/* force '#<pragma>' to column 1 */
			ch1= LOP(*bldline);
			while (*(*bldline)==*space) ch1= LOP(*bldline);
			if (*(*bldline)!='\0') *sresult= catlist(2L,GC_PUSHS(*sresult),GC_PUSHS(*bldline));
			*sresult= catlist(2L,GC_PUSHS(*sresult),GC_PUSHS(crlf));
			*bldline= "@";
			lbl= 1L;
GC_EPOPS(dbug(0200000L,catlist(7L,GC_PUSHS("[P!PCHK!LINE].2.0.1 cToken=\'"),GC_PUSHS(ctoken),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" sResult=\'"),
        GC_PUSHS(*sresult),GC_PUSHS("\'"))));
			}/* force '#<pragma>' to column 1 */
		}/* is '#'<keyword> */

	else if (isdefinestatement &&(*(s1+length(s1)-1))!=('\\'/*WARNING*/))
		{/* Clear DEFINE flag */
		isdefinestatement= 0L;
		change_leftpad;		/*  -- reset the spacing */
		}/* Clear DEFINE flag */

	++loclinecnt;	/*  -- count local lines */

	if (ch==*lf) 
		{/* Line had CRLF, expand LF to CRLF */
		if (*s1!='\0') s1= catlist(2L,GC_PUSHS(s1),GC_PUSHS(crlf)); else s1= crlf;
GC_EPOPS(dbug(0200000L,catlist(3L,GC_PUSHS("[P!PCHK!LINE].2.0.2 s1=\'"),GC_PUSHS(s1),
        GC_PUSHS("\'"))));
		}/* Line had CRLF, expand LF to CRLF */

	if (!keepwsflag) while (*s1==*space) 
				ch= LOP(s1); /*  -- trash leading spaces
						if not a C style cmnt */
	keepwsflag= 0L;		/*  -- force it to fail */

	if (fast_equ(GC_PUSHS(oldctoken),GC_PUSHS(crlf)) &&*s1==*cr &&equ(subst(GC_PUSHS(s1),1L,2L),GC_PUSHS(crlf))) goto doitagain; 	/*  -- eliminate multiple CRLF's */
	if ((loclinecnt>1) &&inlist) s1= catlist(2L,subsr(GC_PUSHS(ps_spaces),1L,(nlvlpp+1L)*lthwspp),
        GC_PUSHS(s1));
					/*  -- Add preface white space
					if processing an arg list,
					ie - help a little */
	ls1= length(GC_PUSHS(s1));
GC_EPOPS(dbug(0200000L,catlist(21L,GC_PUSHS("[P!PCHK!LINE].2.1 oldCtoken=\'"),
        GC_PUSHS(oldctoken),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" maxLineLthPP="),cvs(maxlinelthpp),
        GC_PUSHS(" lthLeftPadPP="),cvs(lthleftpadpp),
        GC_PUSHS(" nLvlPP="),cvs(nlvlpp),GC_PUSHS(crlf),
        GC_PUSHS(" |s|="),cvs(length(GC_PUSHS(*s))),GC_PUSHS(
        " |s1|="),cvs(ls1),GC_PUSHS(" s1=\'"),GC_PUSHS(s1),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" locLineCnt="),
        cvs(loclinecnt))));
/* NO-OP */;
/* NO-OP */;


/*  ----------------------------------------------------------------
# --	[2.1] Justify line 's1' into 'bldLine until it would be	   
# --	too long then break it into several lines saved in 'sResult'
# --	if needed.
# ------------------------------------------------------------------ */
	ctoken= PNULL;
	loctokcnt= 0L;
	lrparen= llparen= lfctid= lcomma= lsc= 0L;	/*  -- holds position of
				  -- last <semiColon> and <COMMA> seen
				  -- in bldLine if any so that we  
				  -- might back up to that  point. */
	while (*s1!='\0')
		{/* Break line up into smaller lines */
/* NO-OP */;
/* NO-OP */;
/* NO-OP */;


/*  --------------------------------------------------------------
# --	[2.1.0.1] Reset current break indexes based on oldCtoken
# -------------------------------------------------------------- */
/*  --	NOTE: What about casts (INTEGER), (STRING) (float), (double) 
# --	and (INTEGER *), (STRING *) (float *), (double *)  */
GC_EPOPS(dbug(0200000L,catlist(19L,GC_PUSHS("[P!PCHK!LINE].3 oldCtoken=\'"),GC_PUSHS(
        oldctoken),GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" lBL="),
        cvs(lbl),GC_PUSHS(" lCOMMA="),cvs(lcomma),
        GC_PUSHS(" lLPAREN="),cvs(llparen),GC_PUSHS(" lFCTID="),
        cvs(lfctid),GC_PUSHS(" lSC="),cvs(lsc),GC_PUSHS(crlf),
        GC_PUSHS(" inList="),pbool(inlist),
        GC_PUSHS(" wasFCTcallFlag="),pbool(wasfctcallflag))));
		if (*oldctoken==',') {lcomma= lbl; inlist= 1L; }else if (*oldctoken==';'||*oldctoken=='}') {lsc= lbl; inlist= 0L; }else if ((*oldctoken=='('&&(*ctoken=='*'||*ctoken=='&'))) llparen= lbl; 
		else if (wasfctcallflag)
			{/* note function level */
			lfctid= lbl;
/*  # # @V.55.06		fctNestIdx[topFctNextIdx_topFctNestIdx+1]_lBL */
			wasfctcallflag= 0L;	/*  -- only good once */
			}/* note function level */
		else if (*oldctoken==')')
			{/* Right ')' */
			if (inlist &&parencnt==0 &&brktcnt==0) inlist= 0L;
			lrparen= lbl;
			}/* Right ')' */
GC_EPOPS(dbug(0200000L,catlist(19L,GC_PUSHS("[P!PCHK!LINE].3.0.1 oldCtoken=\'"),
        GC_PUSHS(oldctoken),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" lBL="),cvs(lbl),GC_PUSHS(" lCOMMA="),cvs(lcomma),
        GC_PUSHS(" lLPAREN="),cvs(llparen),GC_PUSHS(" lFCTID="),
        cvs(lfctid),GC_PUSHS(" lSC="),cvs(lsc),GC_PUSHS(crlf),
        GC_PUSHS(" inList="),pbool(inlist),
        GC_PUSHS(" wasFCTcallFlag="),pbool(wasfctcallflag))));
					/*  -- point to it in case... */


/*  ----------------------------------------------------------------
#	[2.1.1] Get next C token and preprocess delimiter counters
# ---------------------------------------------------------------- */
/*  --	NOTE: assume that PSAIL will eat up the white space between a
# --	function ID and the leading '('.
 */
		ctoken= GC_EPOPS(get_c_token(&s1,s));	/*  -- if need more
						string input then get
						it from 's' */
		++loctokcnt;		/*  -- count nbr tokens */

		if (*s1=='('&&isalpha(GC_PUSHS(ctoken)))
			{/* is function call */
			ctoken= catlist(2L,GC_PUSHS(ctoken),GC_PUSHS(LOP(s1)));	/*  '('  */
			if (*s1==')')
				{/* complete fctleader 'fct()' */
				ctoken= catlist(2L,GC_PUSHS(ctoken),GC_PUSHS(LOP(s1)));	/*  ')'  */
				wasfctcallflag= 0L;
				}/* complete fctleader 'fct()' */
			else wasfctcallflag= 1L;
			}/* is function call */

		else if (*ctoken=='(')
			{/* check for (Casts) */
			if ((*s1=='I'&&equ(subsr(GC_PUSHS(s1),1L,7L),GC_PUSHS("INTEGER"))) ||
			   (*s1=='S'&&equ(subsr(GC_PUSHS(s1),1L,6L),GC_PUSHS("STRING"))) ||
			   (*s1=='f'&&equ(subsr(GC_PUSHS(s1),1L,5L),GC_PUSHS("float"))) ||
			   (*s1=='d'&&equ(subsr(GC_PUSHS(s1),1L,6L),GC_PUSHS("double")))) ctoken= catlist(3L,GC_PUSHS(ctoken),scan(&s1,32L,&ch),GC_PUSHS(")"));  /*  -- get cast */
			}/* check for (Casts) */

		else if (*ctoken==*cr&&*s1==*lf) ctoken= catlist(2L,GC_PUSHS(ctoken),GC_PUSHS(LOP(s1)));
					/*  -- keep 'CRLF' together
		 */lctoken= length(GC_PUSHS(ctoken));
GC_EPOPS(dbug(0200000L,catlist(20L,GC_PUSHS("[P!PCHK!LINE].3.0.2 cToken=\'"),GC_PUSHS(ctoken)
        ,GC_PUSHS("\'"),GC_PUSHS("=0"),cvos((INTEGER)*ctoken),
        GC_PUSHS(" VAL(s1)=\'"),
        GC_PUSHS(ps_strash_= GC_EPOPS(makstr(ps_itrash_= (INTEGER)
        *s1))),GC_PUSHS("\'=0"),cvos(ps_itrash_= (INTEGER)*s1),
        GC_PUSHS(crlf),GC_PUSHS("  parenCnt="),cvs(parencnt),
        GC_PUSHS(" brktCnt="),cvs(brktcnt),GC_PUSHS(" locTokCnt="),
        cvs(loctokcnt),GC_PUSHS(crlf),GC_PUSHS(" s1=\'"),
        GC_PUSHS(s1),GC_PUSHS("\'"))));

		if (wasfctcallflag ||(*(ctoken+length(ctoken)-1))=='(') ++parencnt; else if (*ctoken==')')
			{/* close it */
			--parencnt;
/*  # # @V.55.06		topFctNextIdx_topFctNestIdx-1 */
			}/* close it */
		else if (*ctoken=='[') ++brktcnt; else if (*ctoken==']') --brktcnt;
GC_EPOPS(dbug(0200000L,catlist(31L,GC_PUSHS("[P!PCHK!LINE].3.1 |cToken|="),cvs(lctoken),
        GC_PUSHS(" cToken=\'"),GC_PUSHS(ctoken),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS("  |s|="),cvs(length(GC_PUSHS(*s))),
        GC_PUSHS(" |s1|="),cvs(length(GC_PUSHS(s1))),
        GC_PUSHS(" s1=\'"),GC_PUSHS(s1),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS("  parenCnt="),cvs(parencnt),
        GC_PUSHS(" brktCnt="),cvs(brktcnt),GC_PUSHS(crlf),
        GC_PUSHS(" inList="),pbool(inlist),GC_PUSHS(" oldCtoken=\'")
        ,GC_PUSHS(oldctoken),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  lBL="),cvs(lbl),GC_PUSHS(" lCtoken="),cvs(
        lctoken),GC_PUSHS(" lastRow="),cvs(lastrow))));


/*  -------------------------------------------------------------------
# --	[2.1.2] Check & count block level & change preface WS if change
# ------------------------------------------------------------------- */
		if (*ctoken=='{') 
			{/* next Level */
			++nlvlpp;
			change_leftpad;
			}/* next Level */
		else if (*ctoken=='}')
			{/* previous Level */
			nlvlpp= MAX((nlvlpp-1L),0L);
			change_leftpad;
			}/* previous Level */
/*  # # @V.50.23Add FSM code for IF-ELSE, FOR, WHILE, SWITCH, DO-WHILE ...

 */GC_EPOPS(dbug(0200000L,catlist(26L,GC_PUSHS("[P!PCHK!LINE].3.1.1. |cToken|="),cvs(lctoken),
        GC_PUSHS(" cToken=\'"),GC_PUSHS(ctoken),
        GC_PUSHS("\' |bldLine|=\'"),cvs(length(GC_PUSHS(*bldline))),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" |s|="),
        cvs(length(GC_PUSHS(*s))),GC_PUSHS(" |s1|="),
        cvs(length(GC_PUSHS(s1))),GC_PUSHS(" s1=\'"),GC_PUSHS(s1),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" bldLine=\'"),
        GC_PUSHS(*bldline),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" lBL="),cvs(lbl),GC_PUSHS(" lCtoken="),
        cvs(lctoken),GC_PUSHS(" lastRow="),cvs(lastrow))));


/*  -----------------------------------------------------------
# --	[2.1.3] Check for and break on Line-break conditions
# ----------------------------------------------------------- */
/*  --	If CR then trash LF and set token<==NULL.
# --	If # then force it to column 1 of next line.
# --	If { then include it in NEXT line but break line.
# --	If } then include it in CURRENT line but break line.
# --	If isDEFINEstatement and cToken is '\' then trash CRLF and 
# --		break.
# --	If CRLF and isDEFINEstatement and cToken Neq '\' then add '\' 
# --		before CRLF and break.
# --	If |bldLine| + |cToken| + |lastRow| > (maxLineLthPP)
# --		AND ((cToken is NOT '(' or ',') Or
# --		     (pushBackFlag:=(cToken='*' And nextToken is ID And
# --				   oldCtoken={',' '(' '['}))
# --		    )
# --				Then break.
# --	 */
/*  -- NOTE: WHAT ABOUT pointer expression: *(p+q) ????
# --
# --	prev output  current    potential	   LINES or ADDITIONS
# --	----------------------------------
# --	| last row |  bldLine  |  cToken |
# --	----------------------------------
# --    0          ^           ^         ^
# --               |           |         |
# --         lastRow   +      lBL    +   lCtoken
 */
		pushbackflag= 0L;
		if ((*ctoken==*cr) ||
		   (*ctoken=='#') ||
		   (*ctoken=='}') ||
		   (*ctoken=='{') ||
		   (isdefinestatement &&*ctoken==('\\'/*WARNING*/)) ||
		   ( ((lbl+lctoken+lastrow)>maxlinelthpp) &&
		     ( (*ctoken!='('&&*ctoken!=',') ||
		       (pushbackflag= (*ctoken=='*'&&isalpha(GC_PUSHS(s1)) &&
				  (*oldctoken==','||*oldctoken=='(' ||
				   *oldctoken=='[')) )
		      ) ))
			{/* split current line */
GC_EPOPS(dbug(0200000L,catlist(26L,GC_PUSHS("[P!PCHK!LINE].3.2 |cToken|="),cvs(lctoken),
        GC_PUSHS(" cToken=\'"),GC_PUSHS(ctoken),
        GC_PUSHS("\'  |bldLine|="),cvs(length(GC_PUSHS(*bldline))),
        GC_PUSHS(crlf),GC_PUSHS(" bldLine=\'"),GC_PUSHS(*bldline),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" oldCtoken=\'"),
        GC_PUSHS(oldctoken),GC_PUSHS("\' locTokCnt="),cvs(loctokcnt)
        ,GC_PUSHS(crlf),GC_PUSHS(" sResult=\'"),GC_PUSHS(*sresult),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" pushBackFlag="),
        pbool(pushbackflag),GC_PUSHS(crlf),GC_PUSHS(" s1=\'"),
        GC_PUSHS(s1),GC_PUSHS("\'"))));


/*  -----------------------------------------------------
# --	[2.1.3.1] Ignore token - push back if necessary
# ----------------------------------------------------- */
			if (*ctoken==*cr||*ctoken==('\\'/*WARNING*/) ||pushbackflag) 
				{/* ignore token since use our own */
				if (pushbackflag) s1= catlist(2L,GC_PUSHS(ctoken),GC_PUSHS(s1)); else oldctoken= ctoken;
GC_EPOPS(dbug(0200000L,catlist(9L,GC_PUSHS("[P!PCHK!LINE].3.2.1 |oldCtoken|="),
        cvs((INTEGER)*oldctoken),GC_PUSHS(" oldCtoken=\'"),
        GC_PUSHS(oldctoken),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" s1=\'"),GC_PUSHS(s1),GC_PUSHS("\'"))));
				ctoken= PNULL;
				lctoken= lrparen= llparen= lfctid= lcomma= lsc= 0L;
							/*  -- no breaks */
				}/* ignore token since use our own */


/*  -------------------------------------
# --	[2.1.3.2] Process end of a block
# ------------------------------------- */
			else if (*ctoken=='}') 
				{/* Process '}' */
				while ((*s1!='\0'))
					{/* get trailing WS & CMTS */
					while (*s1==*space) 
						{/* add SPACE */
						ctoken= catlist(2L,GC_PUSHS(ctoken),GC_PUSHS(LOP(s1)));
						++lctoken;
						}/* add SPACE */
					if (*s1=='/'&&
					   ((lbl+lctoken+lastrow)<maxlinelthpp) &&
					   equ(subsr(GC_PUSHS(s1),1L,2L),GC_PUSHS("/*"))) 
					   {/* add cmt */
					   ctoken= 
        						catlist(GC_PUSHS(ctoken),get_c_token(&s1,s));
					   lctoken= length(GC_PUSHS(ctoken));
					   }/* add cmt */
					else break;
					}/* get trailing WS & CMTS */
				*bldline= catlist(2L,GC_PUSHS(*bldline),GC_PUSHS(ctoken));
						/*  -- CURRENT line */
				lbl = lbl+lctoken;  /*  -- calc. length */
GC_EPOPS(dbug(0200000L,catlist(11L,GC_PUSHS("[P!PCHK!LINE].3.2.2 |cToken|="),cvs(lctoken),
        GC_PUSHS(" cToken=\'"),GC_PUSHS(ctoken),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS("  |bldLine="),
        cvs(length(GC_PUSHS(*bldline))),GC_PUSHS(" bldLine=\'"),
        GC_PUSHS(*bldline),GC_PUSHS("\'"))));
GC_EPOPS(dbug(0200000L,catlist(7L,GC_PUSHS("[P!PCHK!LINE].3.2.2.1 lSC="),cvs(lsc),
        GC_PUSHS(" bldLine[1:lSC]="),GC_PUSHS(crlf),GC_PUSHS("  \'")
        ,GC_PUSHS((lsc>0) ? subst(GC_PUSHS(*bldline),1L,
        lsc) : PNULL),GC_PUSHS("\'"))));
GC_EPOPS(dbug(0200000L,catlist(7L,GC_PUSHS("[P!PCHK!LINE].3.2.2.2 lCOMMA="),cvs(lcomma),
        GC_PUSHS(" bldLine[1:lCOMMA]="),GC_PUSHS(crlf),
        GC_PUSHS("  \'"),
        GC_PUSHS((lcomma>0) ? subst(GC_PUSHS(*bldline),1L,
        lcomma) : PNULL),GC_PUSHS("\'"))));
GC_EPOPS(dbug(0200000L,catlist(7L,GC_PUSHS("[P!PCHK!LINE].3.2.2.3 lFCTID="),cvs(lfctid),
        GC_PUSHS(" bldLine[1:lFCTID]="),GC_PUSHS(crlf),
        GC_PUSHS("  \'"),
        GC_PUSHS((lfctid>0) ? subst(GC_PUSHS(*bldline),1L,
        lfctid) : PNULL),GC_PUSHS("\'"))));
GC_EPOPS(dbug(0200000L,catlist(7L,GC_PUSHS("[P!PCHK!LINE].3.2.2.4 lLPAREN="),cvs(llparen),
        GC_PUSHS(" bldLine[1:lLPAREN]="),GC_PUSHS(crlf),
        GC_PUSHS("  \'"),
        GC_PUSHS((llparen>0) ? subst(GC_PUSHS(*bldline),1L,llparen) 
        : PNULL),GC_PUSHS("\'"))));
GC_EPOPS(dbug(0200000L,catlist(7L,GC_PUSHS("[P!PCHK!LINE].3.2.2.5 lRPAREN="),cvs(lrparen),
        GC_PUSHS(" bldLine[1:lRPAREN]="),GC_PUSHS(crlf),
        GC_PUSHS("  \'"),
        GC_PUSHS((lrparen>0) ? subst(GC_PUSHS(*bldline),1L,lrparen) 
        : PNULL),GC_PUSHS("\'"))));
				oldctoken= ctoken;  /*  -- remember it */
				ctoken= PNULL;
				lctoken= lrparen= llparen= lfctid= lcomma= lsc= 0L;
						/*  -- no breaks */
				}/* Process '}' */

GC_EPOPS(dbug(0200000L,catlist(22L,GC_PUSHS("[P!PCHK!LINE].3.3 |lastRow|="),cvs(lastrow),
        GC_PUSHS(crlf),GC_PUSHS(" |cToken|="),cvs(lctoken),
        GC_PUSHS(" cToken=\'"),GC_PUSHS(ctoken),
        GC_PUSHS("\' |bldLine|="),cvs(length(GC_PUSHS(*bldline))),
        GC_PUSHS(crlf),GC_PUSHS(" bldLine=\'"),GC_PUSHS(*bldline),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" sResult=\'"),
        GC_PUSHS(*sresult),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  brktCnt="),cvs(brktcnt),GC_PUSHS(" parenCnt="),
        cvs(parencnt))));
GC_EPOPS(dbug(0200000L,catlist(7L,GC_PUSHS("[P!PCHK!LINE].3.3.1   lSC="),cvs(lsc),
        GC_PUSHS(" bldLine[1:lSC]="),GC_PUSHS(crlf),GC_PUSHS("  \'")
        ,GC_PUSHS((lsc>0) ? subst(GC_PUSHS(*bldline),1L,
        lsc) : PNULL),GC_PUSHS("\'"))));
GC_EPOPS(dbug(0200000L,catlist(7L,GC_PUSHS("[P!PCHK!LINE].3.3.1.1 lCOMMA="),cvs(lcomma),
        GC_PUSHS(" bldLine[1:lCOMMA]="),GC_PUSHS(crlf),
        GC_PUSHS("  \'"),
        GC_PUSHS((lcomma>0) ? subst(GC_PUSHS(*bldline),1L,
        lcomma) : PNULL),GC_PUSHS("\'"))));
GC_EPOPS(dbug(0200000L,catlist(7L,GC_PUSHS("[P!PCHK!LINE].3.3.1.2 lFCTID="),cvs(lfctid),
        GC_PUSHS(" bldLine[1:lFCTID]="),GC_PUSHS(crlf),
        GC_PUSHS("  \'"),
        GC_PUSHS((lfctid>0) ? subst(GC_PUSHS(*bldline),1L,
        lfctid) : PNULL),GC_PUSHS("\'"))));
GC_EPOPS(dbug(0200000L,catlist(7L,GC_PUSHS("[P!PCHK!LINE].3.3.1.3 lLPAREN="),cvs(llparen),
        GC_PUSHS(" bldLine[1:lLPAREN]="),GC_PUSHS(crlf),
        GC_PUSHS("  \'"),
        GC_PUSHS((llparen>0) ? subst(GC_PUSHS(*bldline),1L,llparen) 
        : PNULL),GC_PUSHS("\'"))));
GC_EPOPS(dbug(0200000L,catlist(7L,GC_PUSHS("[P!PCHK!LINE].3.3.1.4 lRPAREN="),cvs(lrparen),
        GC_PUSHS(" bldLine[1:lRPAREN]="),GC_PUSHS(crlf),
        GC_PUSHS("  \'"),
        GC_PUSHS((lrparen>0) ? subst(GC_PUSHS(*bldline),1L,lrparen) 
        : PNULL),GC_PUSHS("\'"))));


/*  ---------------------------------------------------------
# --	[2.1.3.3] Compute break-index k in case need it 
# --	          NOTE precedence P1 = first occurance of
# --				'fct('  or  '('
# --	          NOTE precedence P2 = last occurance of
# --				'<semiColon>'  or  ','
# --		  Then P2 has precedence over P1.
# --------------------------------------------------------- */
			k= (MAX((MAX(lsc,lcomma)),lrparen));  /*  -- last
							     one seen */
			j= (MIN(lfctid,llparen));
			if ((0<k && k<j)) k= j;	/*  -- takes prec. */
GC_EPOPS(dbug(0200000L,catlist(13L,GC_PUSHS("[P!PCHK!LINE].3.3.2 locTokCnt="),cvs(loctokcnt),
        GC_PUSHS(" k="),cvs(k),GC_PUSHS(crlf),
        GC_PUSHS("  bldLine[1:k]=\'"),GC_PUSHS((k>0) ? subst(
        GC_PUSHS(*bldline),1L,k) : PNULL),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" (lCtoken+lBL+lastRow)="),
        cvs(lctoken+lbl+lastrow),GC_PUSHS(" maxLineLthPP="),
        cvs(maxlinelthpp))));



/*  -----------------------------------------------------------------
# --	[2.1.3.4] See if we must break because the potential line
# --		lastRow & bldLine & cToken
# --	would be too long. However, even it this is true we
# --	need a potential place to break, k, and can't do it otherwise.
# ----------------------------------------------------------------- */
			wsnl= PNULL;
			if (((lctoken+lbl+lastrow)>maxlinelthpp) &&
			   (0<k && k<lbl) &&lctoken>0)
				{/* BREAK! keep 1 statement/line */
				s3= catlist(2L,subst(GC_PUSHS(*bldline),k+1L,length(*bldline)),
        GC_PUSHS(ctoken));
				if (*s1=='\0') s1= s3; 
				else s1= catlist(2L,GC_PUSHS(s3),GC_PUSHS(s1));  /*  -- push it back
						including the cTOKEN!! */
/*  # # @V.55.25			wsNL_"@" */
/*  # # @V.55.25			While s3=space Or s3=tab Do
# # # @V.55.25				wsNL_wsNL&LOP(s3) */
/*  # # @V.55.25			ch_LOP(wsNL) */
/*  # # @V.55.25			If s3 Neq NULL And 
# # # @V.55.25			  (ch1_LOP(s4_cToken))="/" And s4="*"
# # # @V.55.25				Then cToken_s3 & cToken */
/*  # # @V.55.25					# -- add WS only if
# # # @V.55.25					cToken is a C-COMMENT */

/*  # # @V.55.06			cToken_(If lthLeftPadPP=0 
# # # @V.55.06					   Then "  " 
# # # @V.55.06					Else leftPadPP) & 
# # # @V.55.06					cToken */

				ctoken= PNULL;	/*  -- @V.55.25 */
				lctoken= length(GC_PUSHS(ctoken));
				*bldline= subst(GC_PUSHS(*bldline),1L,k);
				lbl= k;
GC_EPOPS(dbug(0200000L,catlist(13L,GC_PUSHS("[P!PCHK!LINE].3.3.3 |cToken|="),cvs(lctoken),
        GC_PUSHS(" cToken=\'"),GC_PUSHS(ctoken),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" s1=\'"),GC_PUSHS(s1),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" bldLine=\'"),
        GC_PUSHS(*bldline),GC_PUSHS("\'"))));
				llparen= lfctid= lcomma= lsc= 0L;
				}/* BREAK! keep 1 statement/line */


/*  ----------------------------------------------------
# --	[2.1.3.5] Now, close out this line with CRLF
# ---------------------------------------------------- */
			ch= LOP(*bldline); /*  -- trash '@' */
			--lbl;
			s2= *sresult;	/*  -- copy for test coming up */
			if ((lbl>0) &&!(*ctoken=='{'&&loctokcnt==1))
				{/* add it */
				*sresult= catlist(2L,GC_PUSHS(*sresult),GC_PUSHS(*bldline));
					/*  -- add the build line to
						the final line */
				}/* add it */


/*  -------------------------------------------------
# --	[2.1.3.6] Add CRLF to result line if needed
# ------------------------------------------------- */
			if (*ctoken=='\0'||
			   (*ctoken!='\0'&&loctokcnt>1 &&
			    !equ(subsr(GC_PUSHS(s2),1L,2L),GC_PUSHS(crlf))))
				{/* Add CRLF to result line */
GC_EPOPS(dbug(0200000L,catlist(15L,GC_PUSHS("[P!PCHK!LINE].3.3.3.1 oldCtoken=\'"),
        GC_PUSHS(oldctoken),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" sResult=\'"),GC_PUSHS(*sresult),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" s1=\'"),GC_PUSHS(s1),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" bldLine=\'"),
        GC_PUSHS(*bldline),GC_PUSHS("\'"))));
				if (isdefinestatement &&
				   ((*ctoken!='\0') ||
				    (*ctoken=='\0'&&*oldctoken==('\\'/*WARNING*/))) &&
				   !(fast_equ(GC_PUSHS(*bldline),GC_PUSHS(crlf)) &&
				        length(GC_PUSHS(*sresult))==3)) *sresult= catlist(2L,GC_PUSHS(*sresult),GC_PUSHS("\\"));
				*sresult= catlist(2L,GC_PUSHS(*sresult),GC_PUSHS(crlf));
				if (*ctoken=='\0'&&*s1==*cr &&
				   equ(subsr(GC_PUSHS(s1),1L,2L),GC_PUSHS(crlf)))
					{/* also get next one */
					/*  -- but only if NULL bldLine */
					ch= LOP(s1);  /*  -- CR  */
					ch= LOP(s1);  /*  -- LF  */
GC_EPOPS(dbug(0200000L,catlist(5L,GC_PUSHS("[P!PCHK!LINE].3.3.3.1.1 cToken=\'"),
        GC_PUSHS(ctoken),GC_PUSHS("\' s1=\'"),GC_PUSHS(s1),
        GC_PUSHS("\'"))));
					}/* also get next one */
GC_EPOPS(dbug(0200000L,catlist(7L,GC_PUSHS("[P!PCHK!LINE].3.3.3.2 sResult=\'"),
        GC_PUSHS(*sresult),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" s1=\'"),GC_PUSHS(s1),GC_PUSHS("\'"))));
				}/* Add CRLF to result line */


/*  ---------------------------------------------------------------
# --	[2.1.3.7] Reinitialize built line and reset break-indexes
# --------------------------------------------------------------- */
			*bldline= "@";
			lastrow= 0L;
			/*  -- NOTE: must put #include etc in column 1
			  -- since some stupid C compilers like 
			  -- LATTICE-C wish it to be... */
			if ((*leftpadpp!='\0') &&(*ctoken!='#')) *bldline= catlist(2L,GC_PUSHS(*bldline),GC_PUSHS(leftpadpp));
			lbl= length(GC_PUSHS(*bldline));
			llparen= lfctid= lcomma= lsc= 0L;
					/*  -- reset each line */
			loctokcnt= 0L;	/*  - reset after split line */
GC_EPOPS(dbug(0200000L,catlist(30L,GC_PUSHS("[P!PCHK!LINE].3.3.4 lastRow="),cvs(lsc),
        GC_PUSHS(crlf),GC_PUSHS(" lSC="),cvs(lsc),GC_PUSHS(
        " lCOMMA="),cvs(lcomma),GC_PUSHS(" lFCTID="),cvs(lfctid),
        GC_PUSHS(" lPAREN="),cvs(llparen),GC_PUSHS(crlf),
        GC_PUSHS(" |lBL|="),cvs(lbl),GC_PUSHS(" bldLine=\'"),
        GC_PUSHS(*bldline),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" |Ctoken|="),cvs(lctoken),GC_PUSHS(" cToken=\'"),
        GC_PUSHS(ctoken),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" sResult=\'"),GC_PUSHS(*sresult),GC_PUSHS("\'"),
        GC_PUSHS(" s1=\'"),GC_PUSHS(s1),GC_PUSHS("\'"))));


/*  ---------------------------------------------------------------
# --	[2.1.3.8] Indent cToken with white space if not NULL
# --------------------------------------------------------------- */
			if ((*ctoken!='\0') &&(*ctoken!='#'))
				{/* indent the sucker */
/*  -- @V.55.06 NOTE:
# --	Possible algorithm for JUSTIFY!COMMENT which might be added.
# --	If bldLine == <whiteSpace-1> & "" And
# --	   the comment is > 1 line And
# --	   line 2 of comment has leading <whiteSpace-2>
# --	   If no line-2 then set <whiteSpace-2> to "  "
# --		Then
# --		[1] Trash leading <whiteSpace-1> in line1
# --		[2] Then prepend <whiteSpace-2> to line1.
 */
				if (lbl==1&&*ctoken=='/' &&
				   equ(subsr(GC_PUSHS(ctoken),1L,2L),GC_PUSHS("/*")))
					{/* JUSTIFY!COMMENT */
					STRING line1, 
					ws;
					INTEGER brk;
GC_EPOPS(dbug(0200000L,catlist(3L,GC_PUSHS("[P!PCHK!LINE].3.3.4.1 cToken=\'"),
        GC_PUSHS(ctoken),GC_PUSHS("\'"))));
					GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
					GC_NOTESTRING(line1); /* for G.C. */
					GC_NOTESTRING(ws); /* for G.C. */
					line1= GC_EPOPS(scan(&s3= ctoken,1L,&brk));
					if (brk==*lf) line1= catlist(2L,GC_PUSHS(line1),GC_PUSHS(crlf));
					ws= "@";
					s4= s3;
					while (*s3==*space||*s3==*tab) ws= catlist(2L,GC_PUSHS(ws),GC_PUSHS(LOP(s3)));
					brk= LOP(ws);	/*  -- trash '@' */
GC_EPOPS(dbug(0200000L,catlist(13L,GC_PUSHS("[P!PCHK!LINE].3.3.4.2 ws=\'"),GC_PUSHS(ws),
        GC_PUSHS("\' wsNL=\'"),GC_PUSHS(wsnl),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" line1=\'"),GC_PUSHS(line1),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" s3=\'"),
        GC_PUSHS(s3),GC_PUSHS("\'"))));
					if (*ws=='\0') ws= "  ";
					line1= catlist(2L,GC_PUSHS(ws),GC_PUSHS(line1));
					ctoken= (((INTEGER)*(s4
							)) ? catlist(2L,GC_PUSHS(line1),GC_PUSHS(s4)): ((INTEGER)*(wsnl
							)) ? catlist(2L,GC_PUSHS(wsnl),GC_PUSHS(line1)): line1);
GC_EPOPS(dbug(0200000L,catlist(3L,GC_PUSHS("[P!PCHK!LINE].3.3.4.3 cToken=\'"),
        GC_PUSHS(ctoken),GC_PUSHS("\'"))));
					{GC_UNMARKSSTKFRAME;}}/* JUSTIFY!COMMENT */ 
/*  # # @V.55.07 			Else cToken_(If lthLeftPadPP=0 
						   Then "  " 
						Else leftPadPP) & 
						cToken */
				lctoken= length(GC_PUSHS(ctoken));
GC_EPOPS(dbug(0200000L,catlist(5L,GC_PUSHS("[P!PCHK!LINE].3.3.5 |cToken|="),cvs(lctoken),
        GC_PUSHS(" cToken=\'"),GC_PUSHS(ctoken),GC_PUSHS("\'"))));
				}/* indent the sucker */
			}/* split current line */


/*  -------------------------------------------------------------
# --	[2.1.4] Add token to next line and then break it again if
# -- 		the token is still too large.
# ------------------------------------------------------------- */
		if ((*ctoken!='\0'))
			{/* Put token in NEXT line if too big */
GC_EPOPS(dbug(0200000L,catlist(11L,GC_PUSHS("[P!PCHK!LINE].3.4 cToken=\'"),GC_PUSHS(ctoken),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" bldLine=\'"),
        GC_PUSHS(*bldline),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" sResult=\'"),GC_PUSHS(*sresult),GC_PUSHS("\'"))));
			*bldline= catlist(2L,GC_PUSHS(*bldline),GC_PUSHS(ctoken));
			lbl = lbl+lctoken;
			oldctoken= ctoken;
			if ((lbl+lastrow)>maxlinelthpp)
				{/* split again! */
GC_EPOPS(dbug(0200000L,catlist(4L,GC_PUSHS("[P!PCHK!LINE].3.4.0.1 SPLIT AGAIN! lBL="),
        cvs(lbl),GC_PUSHS(" lastRow="),cvs(lastrow))));
				ch= LOP(*bldline);
				*sresult= catlist(3L,GC_PUSHS(*sresult),GC_PUSHS(*bldline),GC_PUSHS(crlf));
				*bldline= "@";
				lastrow= 0L;
				if (*leftpadpp!='\0') *bldline= catlist(2L,GC_PUSHS(*bldline),GC_PUSHS(leftpadpp));
				lbl= length(GC_PUSHS(*bldline));
				loctokcnt= 0L; /*  -- reset after split line */
				}/* split again! */
GC_EPOPS(dbug(0200000L,catlist(15L,GC_PUSHS("[P!PCHK!LINE].3.4.1 locTokCnt="),cvs(loctokcnt),
        GC_PUSHS(" oldCtoken=\'"),GC_PUSHS(oldctoken),GC_PUSHS("\'")
        ,GC_PUSHS(crlf),GC_PUSHS(" sResult=\'"),GC_PUSHS(*sresult),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" |lBL|="),cvs(lbl),
        GC_PUSHS(" bldLine=\'"),GC_PUSHS(*bldline),GC_PUSHS("\'"))));
			lastrow= 0L;
			}/* Put token in NEXT line if too big */

GC_EPOPS(dbug(0200000L,catlist(3L,GC_PUSHS("[P!PCHK!LINE].3.5.2 s1=\'"),GC_PUSHS(s1),
        GC_PUSHS("\'"))));
		}/* Break line up into smaller lines */

GC_EPOPS(dbug(0200000L,catlist(29L,GC_PUSHS("[P!PCHK!LINE].4 locTokCnt="),cvs(loctokcnt),
        GC_PUSHS(" lBL="),cvs(lbl),GC_PUSHS(" lastRow="),
        cvs(lastrow),GC_PUSHS(crlf),GC_PUSHS(" oldCtoken=\'"),
        GC_PUSHS(oldctoken),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" |bldLine|="),cvs(length(GC_PUSHS(*bldline))),
        GC_PUSHS(" lBL="),cvs(lbl),GC_PUSHS(crlf),
        GC_PUSHS(" bldLine=\'"),GC_PUSHS(*bldline),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" |sResult|="),
        cvs(length(GC_PUSHS(*sresult))),GC_PUSHS(" sResult=\'"),
        GC_PUSHS(*sresult),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" s1=\'"),GC_PUSHS(s1),GC_PUSHS("\'"))));

;
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'i'=<L0> integer                              */
/* 'nomore'=<L0> string                          */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/


{GC_UNMARKSSTKFRAME;}}/* P!PCHK!LINE */
/*  ----------------------------------------------------- */
/*INTERNAL*/  STRING pretty_print(s)
	STRING s;
/*  ----------------------------------------------------- */
{/* PRETTY!PRINT */
/*   --
.LABEL [<++PSAIL PROCEDURE: PRETTY!PRINT>]
.INDEX ++PSAIL PROCEDURE: PRETTY!PRINT
DESCRIPTION:
	When invoked with 
		/PRETTYPRINT:k1,k2
	wrap lines from 's' to 'maxLineLthPP' (k1 - default is 72)
columns and insert CRLF at proper punctuation. Also add leading white
space where appropriate with each block level having 'lthWSPP' (k2 -
default is 4) spaces. The algorithm justifies text and keeps track of
the block level. The pretty printer detected block level 'nLvlPP' is
used to set the 'leftPadPP' spaces.
NOTE: Do not justify QUOTED text.
NOTE: Never split a token...
NOTE: If k2=0 then do NOT map tab to space or insert extra block
	space.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

@V.51.94 NOTE: Read GPRTYS.SAI program to use some of its
	PRETTY-PRINT ideas.
@V.54.86 - NOTE: moved oldCtoken to PSGLBV.REQ since it needs to
be remembered between calls (i.e. local STATIC OWN) but
we would have problems witth the PSAIL GC so ...

@V.54.91 debugged separately in JPRTY2.SAI.

@V.55.26 broke PRETTY!PRINT and JUSTIFY!TEXT out of PSCVT.SAI into a
new PSAIL modules PSPPRT.SAI/.REQ and renamed the version @V.56.01.
The 'check next line' block of the [2] while-loop was broken out into
Procedure P!PCHK!LINE which is a procedure local to PSPPRT.SAI. Also
the INTEGER variables of PRETTY!PRINT were made global to PSPPRT.SAI
but not INTERNAL.

Note: indices of special key words are kept for each bldLine being
	constructed in case we need to break. Eg.
        x = 3 + (4+5) + abc(xyzzy,emacs,foobah) -3<SC>
                ^          ^            ^     ^   ^
                |          |            |     |   |
            lLPAREN      lFCTID       lCOMMA  |  lSC
                                             lRPAREN
.ENDLABEL [<++PSAIL PROCEDURE: PRETTY!PRINT>]
 */
/*  -- The following INTEGER variables are defined global to this
# -- module but local to other modules */
/*  --	brktCnt,	# -- [] counter */
/*  --	ch, ch1,	# -- characters used during parse */
/*  --	is#statement,	# -- in #<keyword> C statement */
/*  --	isDEFINEstatement,  # -- in #DEFINE C statement */
/*  --	keepWSflag,	# -- keep white space in quote or cmt */
/*  --	lBL,		# -- length of bldLine */
/*  --	lCtoken,	# -- length of cToken */
/*  --	lFCTID,		# -- break index if saw a function call */
/*  --	lLPAREN,	# -- break index if saw a '(' */
/*  --	lRPAREN,	# -- break index if saw a ')' */
/*  --	lSC,		# -- break index if saw a semicolon */
/*  --	lCOMMA,		# -- break index if saw a ',' */
/*  --	locLineCnt,	# -- local line counter for this call */
/*  --	locTokCnt,	# -- count of local tokens */
/*  --	lS1, lS2, lS3,	# -- lengths of s1, s2, and s3 */
/*  --	lthLeftPadPP,	# -- working length of leftPadPP */
/*  --	inList,		# -- flag indicating in an arg list */
/*  --	parenCnt,	# -- () counter */
/*  --	pushBackFlag,	# -- flag indicating push token back
				to input line */
/*  --	wasFCTcallFlag,	# -- oldToken was start of FCT call */
STRING
	bldline	/*  -- line being assembled */,
	ctoken		/*  -- current token being processed */,
	nomore		/*  -- junk variable for GET!C!TOKEN call */,
	s1, 
	s2,
	sresult	/*  -- output assembly of lines already justified */,
	ws		/*  -- white space */,
	wsnl;		/*  -- white space for next line */
INTEGER i;
 static INTEGER
	lastrow	/*  -- which column we left off at the
				last time we were here */,
	nlvlpp		/*  -- block level of {  } detected here. */,
	onceonlyflag = 0;	/*  -- once only initialization flag if
				     314159 */

/*  --	++++ POSSIBLE FUTURE stacking of function leader index +++ */
/*  # # @V.55.06 Define MAXNESTING="20" */
/*  # # @V.55.06 Own Integer Array fctNestIdx[0:MAXNESTING] */  /*  -- lBL's */
/*  # # @V.55.06 Integer topFctNextIdx */	/*  -- index for fctNestIDx[] */

;


GC_EPOPS(dbug(0200100L,catlist(3L,GC_PUSHS("[PRETTY!PRINT] s=\'"),GC_PUSHS(s),GC_PUSHS("\'"))));
GC_EPOPS(dbug(0200100L,catlist(12L,GC_PUSHS("[PRETTY!PRINT].0.1 |lastRow|="),cvs(lastrow),
        GC_PUSHS(" |s|="),cvs(length(GC_PUSHS(s))),GC_PUSHS(crlf),
        GC_PUSHS(" lthWsPP="),cvs(lthwspp),GC_PUSHS(" nLvlPP="),
        cvs(nlvlpp),GC_PUSHS(" oldCtoken=\'"),GC_PUSHS(oldctoken),
        GC_PUSHS("\'"))));
/* NO-OP */;

/*  ---------------------------------------------------------------- */
/*  --	[1] Initialization */
/*  --	Note: preprocess tabs to ws spaces before measure it.  */
/*  ---------------------------------------------------------------- */
GC_POPS(s); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(bldline); /* for G.C. */
GC_NOTESTRING(ctoken); /* for G.C. */
GC_NOTESTRING(nomore); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(sresult); /* for G.C. */
GC_NOTESTRING(ws); /* for G.C. */
GC_NOTESTRING(wsnl); /* for G.C. */
if (onceonlyflag!=314159)
	{/* do once-only code */
	onceonlyflag= 314159L;	/*  -- set so never again... */
	lastrow= 0L;		/*  -- never here before so 0 */
	oldctoken= PNULL;
	nlvlpp= 0L;		/*  -- initial block level */
	}/* do once-only code */
change_leftpad;			/*  -- Set default values */
bldline= "@";				/*  -- Set trash prefix */
if ((INTEGER)*leftpadpp) bldline= catlist(2L,GC_PUSHS("@"),GC_PUSHS(leftpadpp));	/*  -- Set trash prefix */
lbl= length(GC_PUSHS(bldline));
isdefinestatement= 0L;	/*  -- always assume not in #define stmnt
					since PSAIL forces them to
					be parsed as one string */
inlist= 0L;			/*  -- i.e. set TRUE if saw ',' */
/*  # # @V.55.06 topFctNextIdx_0 */		/*  -- index for fctNestIDx[] */


/*  -------------------------------------------------------- */
/*  --	[1.1] Map unquoted TABs and SPACEs to single SPACE */
/*  --          Note that we will insert (justify) whatever  */
/*  --          white space required for that block level    */
/*  -------------------------------------------------------- */
s1= s;
s= "@";				/*  -- Set trash prefix */
if ((lthwspp==0)) s= s1; 
else 	{/* do mapping */
	ctoken= PNULL;
	while ((*s1!='\0'))
		{/* expand tabs in s NOT QUOTED */
		s2= ctoken;		/*  -- remember it */
		ctoken= GC_EPOPS(get_c_token(&s1,&(nomore= PNULL))); /*  -- get C token */
		if (*ctoken==*tab||*ctoken==*space)
			{/* collapse into 1 space */
			while ((*s1==*tab||*s1==*space)) ch= LOP(s1); /*  -- eat it */
			s= catlist(2L,GC_PUSHS(s),GC_PUSHS(space));
			}/* collapse into 1 space */
		else s= catlist(2L,GC_PUSHS(s),GC_PUSHS(ctoken));	/*  -- rebuild the string */
		}/* expand tabs in s NOT QUOTED */
	}/* do mapping */
ch= LOP(s);				/*  -- Trash the '@' prefix */
GC_EPOPS(dbug(0200000L,catlist(10L,GC_PUSHS("[PRETTY!PRINT].1 isDEFINEstatement="),
        pbool(isdefinestatement),GC_PUSHS(crlf),
        GC_PUSHS(" oldCtoken=\'"),GC_PUSHS(oldctoken),GC_PUSHS("\'")
        ,GC_PUSHS(crlf),GC_PUSHS(" s=\'"),GC_PUSHS(s),GC_PUSHS("\'"))));


/*  --------------------------------------------- */
/*  --	[1.2] Test if starting C style comment  */
/*  --------------------------------------------- */
s1= s;			/*  -- copy it to test for start of C comment */
while ((*s1!='\0') &&iswhitespace((INTEGER)*s1)) ps_itrash_= LOP(s1);
keepwsflag= (*oldctoken==';') &&equ(subsr(GC_PUSHS(s1),1L,2L),GC_PUSHS("/*"));
if ((*oldctoken==';') &&(*s!=*cr) &&(!keepwsflag)) s= catlist(2L,GC_PUSHS(crlf),GC_PUSHS(s));	/*  -- break up multiple statement line */
GC_EPOPS(dbug(0200000L,catlist(8L,GC_PUSHS("[PRETTY!PRINT].1.1 oldCtoken=\'"),
        GC_PUSHS(oldctoken),GC_PUSHS("\' keepWSflag="),
        pbool(keepwsflag),GC_PUSHS(crlf),GC_PUSHS("  s=\'"),
        GC_PUSHS(s),GC_PUSHS("\'"))));
/* NO-OP */;


/*  ------------------------------------------------------------
# --	[2] Text justify, reading input line by line from 's'
# ------------------------------------------------------------ */
sresult= "@";
loclinecnt= 0L;				/*  -- reset local line ctr */
parencnt= brktcnt= 0L;			/*  -- counters for () and []  */
while ((*s!='\0'))
	{/* process line */
GC_EPOPS(dbug(0200000L,catlist(12L,GC_PUSHS("[PRETTY!PRINT].2 s=\'"),GC_PUSHS(s),GC_PUSHS(
        "\'"),GC_PUSHS(crlf),GC_PUSHS(" bldLine=\'"),GC_PUSHS(
        bldline),GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(crlf),
        GC_PUSHS(" sResult=\'"),GC_PUSHS(sresult),GC_PUSHS("\'"))));
	p_pchk_line(&s, &bldline, &sresult);
GC_EPOPS(dbug(0200000L,catlist(14L,GC_PUSHS("[PRETTY!PRINT].2.1 s=\'"),GC_PUSHS(s),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" bldLine=\'"),
        GC_PUSHS(bldline),GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(
        crlf),GC_PUSHS(" sResult=\'"),GC_PUSHS(sresult),GC_PUSHS(
        "\'"),GC_PUSHS(crlf),GC_PUSHS(stars))));
	}/* process line */


/*  -----------------------------------------------------------
# --	[3] Set up OWN parameters for the next time around...
# ----------------------------------------------------------- */
/*  -- Remember: lastRow is where we left off in previous call */
ch= LOP(bldline);
lastrow= MAX(lbl,0L);
if (*bldline!='\0') sresult= catlist(2L,GC_PUSHS(sresult),GC_PUSHS(bldline)); 	/*  -- finally build it! */
ch= LOP(sresult);			/*  -- trash '@' */

GC_EPOPS(dbug(0200000L,catlist(8L,GC_PUSHS("[PRETTY!PRINT].5 oldCtoken=\'"),GC_PUSHS(
        oldctoken),GC_PUSHS("\' |lastRow|="),cvs(lastrow),
        GC_PUSHS(crlf),GC_PUSHS(" sResult=\'"),GC_PUSHS(sresult),
        GC_PUSHS("\'"))));
GC_EPOPS(dbug(0200100L,catlist(4L,GC_PUSHS("[PRETTY!PRINT].5.1 |lastRow|="),cvs(lastrow),
        GC_PUSHS(" nLvlPP="),cvs(nlvlpp))));

;
GC_SRETURN(sresult)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'i'=<L0> integer                              */
/* 'wsnl'=<L0> string                            */
/* 'ws'=<L0> string                              */
/*************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/


}/* PRETTY!PRINT */
/***************************************************/
/*        U N U S E D    D E C L A R A T I O N S   */
/* 'ls3'=<L0> static integer                       */
/* 'ls2'=<L0> static integer                       */
/* 'ssffactor'=<L0> external real                  */
/* 'yeserrorflag'=<L0> external integer            */
/* 'usetimerflag'=<L0> external integer            */
/* 'userequireflag'=<L0> external integer          */
/* 'usereportflag'=<L0> external integer           */
/* 'userealflag'=<L0> external integer             */
/* 'useprocessesflag'=<L0> external integer        */
/* 'useprfileflag'=<L0> external integer           */
/* 'usepmathflag'=<L0> external integer            */
/* 'usenamemapflag'=<L0> external integer          */
/* 'usemoduleflag'=<L0> external integer           */
/* 'usemkrfileflag'=<L0> external integer          */
/* 'uselocalfilesflag'=<L0> external integer       */
/* 'useleapflag'=<L0> external integer             */
/* 'useifcevalflag'=<L0> external integer          */
/* 'usegcflag'=<L0> external integer               */
/* 'usefoldingflag'=<L0> external integer          */
/* 'useextensionsflag'=<L0> external integer       */
/* 'usecrlfflag'=<L0> external integer             */
/* 'useconcatflag'=<L0> external integer           */
/* 'usecommentflag'=<L0> external integer          */
/* 'usecoerceflag'=<L0> external integer           */
/* 'usecntfsmflag'=<L0> external integer           */
/* 'useclutterflag'=<L0> external integer          */
/* 'usechkflag'=<L0> external integer              */
/* 'usebacktraceflag'=<L0> external integer        */
/* 'uniqflag'=<L0> external integer                */
/* 'slobflag'=<L0> external integer                */
/* 'screenflag'=<L0> external integer              */
/* 'sawversionflag'=<L0> external integer          */
/* 'sawstrfct'=<L0> external integer               */
/* 'sawreturnflag'=<L0> external integer           */
/* 'sawdefineflag'=<L0> external integer           */
/* 'revalflag'=<L0> external integer               */
/* 'prttyprintflag'=<L0> external integer          */
/* 'outputsailswitch'=<L0> external integer        */
/* 'nuldevflag'=<L0> external integer              */
/* 'notmainflag'=<L0> external integer             */
/* 'nomacflag'=<L0> external integer               */
/* 'nologoflag'=<L0> external integer              */
/* 'noblocklabelwarningflag'=<L0> external integer */
/* 'nbrcmtflag'=<L0> external integer              */
/* 'midofquote'=<L0> external integer              */
/* 'midofexpr'=<L0> external integer               */
/* 'midofcomment'=<L0> external integer            */
/* 'mainsailflag'=<L0> external integer            */
/* 'lastidflag'=<L0> external integer              */
/* 'issailkeywordflag'=<L0> external integer       */
/* 'isrcdptrflag'=<L0> external integer            */
/* 'isrcdclassflag'=<L0> external integer          */
/* 'isrightstatementflag'=<L0> external integer    */
/* 'isquote'=<L0> external integer                 */
/* 'ispreload_withflag'=<L0> external integer      */
/* 'isnumberflag'=<L0> external integer            */
/* 'ismakeflag'=<L0> external integer              */
/* 'ismacroflag'=<L0> external integer             */
/* 'isifexpr'=<L0> external integer                */
/* 'isifcflag'=<L0> external integer               */
/* 'isfragmentflag'=<L0> external integer          */
/* 'isforeachflag'=<L0> external integer           */
/* 'isemitgcflag'=<L0> external integer            */
/* 'iscvevalflag'=<L0> external integer            */
/* 'iscopy_toflag'=<L0> external integer           */
/* 'isckeywordflag'=<L0> external integer          */
/* 'isarrayadrflag'=<L0> external integer          */
/* 'inifflag'=<L0> external integer                */
/* 'incaseflag'=<L0> external integer              */
/* 'firstmainxct'=<L0> external integer            */
/* 'firstlocxct'=<L0> external integer             */
/* 'evalmacros'=<L0> external integer              */
/* 'emitenableflag'=<L0> external integer          */
/* 'douniquetest'=<L0> external integer            */
/* 'didmainemit'=<L0> external integer             */
/* 'didlocemit'=<L0> external integer              */
/* 'didblkexit'=<L0> external integer              */
/* 'debugswitch'=<L0> external integer             */
/* 'bailswitch'=<L0> external integer              */
/* 'adddumysymflag'=<L0> external integer          */
/* 'htsta'=<L0> external integer                   */
/* 'htst'=<L0> external integer                    */
/* 'hshr'=<L0> external integer                    */
/* 'hshl'=<L0> external integer                    */
/* 'hntsta'=<L0> external integer                  */
/* 'hntst'=<L0> external integer                   */
/* 'hmsk'=<L0> external integer                    */
/* 'hior'=<L0> external integer                    */
/* 'hclass'=<L0> external integer                  */
/* 'hclr'=<L0> external integer                    */
/* 'hcharadr'=<L0> external integer                */
/* 'hbits'=<L0> external integer                   */
/* 'haddress'=<L0> external integer                */
/* 'h_runtime_'=<L0> external integer              */
/* 'h_main_'=<L0> external integer                 */
/* 'hsemicolon'=<L0> external integer              */
/* 'hquote'=<L0> external integer                  */
/* 'hminus'=<L0> external integer                  */
/* 'hleftsquiggle'=<L0> external integer           */
/* 'hleftparen'=<L0> external integer              */
/* 'hleftbracket'=<L0> external integer            */
/* 'hdivide_sign'=<L0> external integer            */
/* 'hbackarrow'=<L0> external integer              */
/* 'hxor'=<L0> external integer                    */
/* 'hwhile'=<L0> external integer                  */
/* 'hvalue'=<L0> external integer                  */
/* 'huntyped'=<L0> external integer                */
/* 'huntil'=<L0> external integer                  */
/* 'hunion'=<L0> external integer                  */
/* 'hthenc'=<L0> external integer                  */
/* 'hstring'=<L0> external integer                 */
/* 'hstep'=<L0> external integer                   */
/* 'hstart_code'=<L0> external integer             */
/* 'hsimple'=<L0> external integer                 */
/* 'hseto'=<L0> external integer                   */
/* 'hsetc'=<L0> external integer                   */
/* 'hset'=<L0> external integer                    */
/* 'hsafe'=<L0> external integer                   */
/* 'hrot'=<L0> external integer                    */
/* 'hrepeatable'=<L0> external integer             */
/* 'hremove'=<L0> external integer                 */
/* 'hreference'=<L0> external integer              */
/* 'href_item'=<L0> external integer               */
/* 'hredefine'=<L0> external integer               */
/* 'hrecursive'=<L0> external integer              */
/* 'hreal'=<L0> external integer                   */
/* 'hquick_code'=<L0> external integer             */
/* 'hprocss'=<L0> external integer                 */
/* 'hprocedure'=<L0> external integer              */
/* 'hprint'=<L0> external integer                  */
/* 'hor'=<L0> external integer                     */
/* 'hnot'=<L0> external integer                    */
/* 'hnomac'=<L0> external integer                  */
/* 'hneq'=<L0> external integer                    */
/* 'hmod'=<L0> external integer                    */
/* 'hmin'=<L0> external integer                    */
/* 'hmax'=<L0> external integer                    */
/* 'hlsh'=<L0> external integer                    */
/* 'hlor'=<L0> external integer                    */
/* 'hlop'=<L0> external integer                    */
/* 'hlnot'=<L0> external integer                   */
/* 'hlong'=<L0> external integer                   */
/* 'hlisto'=<L0> external integer                  */
/* 'hlistc'=<L0> external integer                  */
/* 'hlist'=<L0> external integer                   */
/* 'hleq'=<L0> external integer                    */
/* 'hlength'=<L0> external integer                 */
/* 'hleap_array'=<L0> external integer             */
/* 'hland'=<L0> external integer                   */
/* 'hlabel'=<L0> external integer                  */
/* 'hitemvar'=<L0> external integer                */
/* 'hitem'=<L0> external integer                   */
/* 'hintrnal'=<L0> external integer                */
/* 'hinteger'=<L0> external integer                */
/* 'hinter'=<L0> external integer                  */
/* 'hin'=<L0> external integer                     */
/* 'hifc'=<L0> external integer                    */
/* 'hif'=<L0> external integer                     */
/* 'hgeneric'=<L0> external integer                */
/* 'hgeq'=<L0> external integer                    */
/* 'hforward'=<L0> external integer                */
/* 'hforeach'=<L0> external integer                */
/* 'hfor'=<L0> external integer                    */
/* 'hexternal'=<L0> external integer               */
/* 'hevalredefine'=<L0> external integer           */
/* 'hevalinclude'=<L0> external integer            */
/* 'hevaldefine'=<L0> external integer             */
/* 'hendc'=<L0> external integer                   */
/* 'hend'=<L0> external integer                    */
/* 'helsec'=<L0> external integer                  */
/* 'helse'=<L0> external integer                   */
/* 'hdo'=<L0> external integer                     */
/* 'hdiv'=<L0> external integer                    */
/* 'hdefine'=<L0> external integer                 */
/* 'hc_code'=<L0> external integer                 */
/* 'hc_array'=<L0> external integer                */
/* 'hcomment'=<L0> external integer                */
/* 'hcolon'=<L0> external integer                  */
/* 'hcase'=<L0> external integer                   */
/* 'hboolean'=<L0> external integer                */
/* 'hbegin'=<L0> external integer                  */
/* 'hassoc'=<L0> external integer                  */
/* 'hash'=<L0> external integer                    */
/* 'hand'=<L0> external integer                    */
/* 'hany_class'=<L0> external integer              */
/* 'wrdfreelist'=<L0> external integer             */
/* 'warnlevel'=<L0> external integer               */
/* 'uniqwidth'=<L0> external integer               */
/* 'typelastprocdecl'=<L0> external integer        */
/* 'totlinecount'=<L0> external integer            */
/* 'timstoprun'=<L0> external integer              */
/* 'timstartrun'=<L0> external integer             */
/* 'timerun'=<L0> external integer                 */
/* 'timeday'=<L0> external integer                 */
/* 'strfreelist'=<L0> external integer             */
/* 'stmntsperminute'=<L0> external integer         */
/* 'stmntcnbr'=<L0> external integer               */
/* 'spdlptr'=<L0> external integer                 */
/* 'saicount'=<L0> external integer                */
/* 'saichan'=<L0> external integer                 */
/* 'saibrk'=<L0> external integer                  */
/* 'saierr'=<L0> external integer                  */
/* 'saieof'=<L0> external integer                  */
/* 'rrlevel'=<L0> external integer                 */
/* 'reqlevel'=<L0> external integer                */
/* 'rdlevel'=<L0> external integer                 */
/* 'rcvlevel'=<L0> external integer                */
/* 'prevdclsymptr'=<L0> external integer           */
/* 'pagecount'=<L0> external integer               */
/* 'nsym'=<L0> external integer                    */
/* 'nprocedures'=<L0> external integer             */
/* 'npdlptr'=<L0> external integer                 */
/* 'nhugecmts'=<L0> external integer               */
/* 'nhsymbols'=<L0> external integer               */
/* 'ndummyargs'=<L0> external integer              */
/* 'nargsfound'=<L0> external integer              */
/* 'maxstkfstr'=<L0> external integer              */
/* 'maxstrpdl'=<L0> external integer               */
/* 'maxgcactivesize'=<L0> external integer         */
/* 'locsptr'=<L0> external integer                 */
/* 'locleapptr'=<L0> external integer              */
/* 'lociptr'=<L0> external integer                 */
/* 'locaptr'=<L0> external integer                 */
/* 'lineoneflag'=<L0> external integer             */
/* 'linecount'=<L0> external integer               */
/* 'lidtype'=<L0> external integer                 */
/* 'lasttype'=<L0> external integer                */
/* 'lastsublang'=<L0> external integer             */
/* 'lastrclass'=<L0> external integer              */
/* 'lastnargs'=<L0> external integer               */
/* 'lasthfree'=<L0> external integer               */
/* 'lasthcnt'=<L0> external integer                */
/* 'lastfsm'=<L0> external integer                 */
/* 'lastdeclaration'=<L0> external integer         */
/* 'kk'=<L0> external integer                      */
/* 'jj'=<L0> external integer                      */
/* 'itemstart'=<L0> external integer               */
/* 'islastexecutableexpr'=<L0> external integer    */
/* 'ii'=<L0> external integer                      */
/* 'gencnt'=<L0> external integer                  */
/* 'firstiftoken'=<L0> external integer            */
/* 'eeptr'=<L0> external integer                   */
/* 'dwfreelist'=<L0> external integer              */
/* 'delimtoppdl'=<L0> external integer             */
/* 'dclsymptr'=<L0> external integer               */
/* 'dbugcode'=<L0> external integer                */
/* 'ctrcount'=<L0> external integer                */
/* 'ctrchan'=<L0> external integer                 */
/* 'ctrbrk'=<L0> external integer                  */
/* 'ctrerr'=<L0> external integer                  */
/* 'ctreof'=<L0> external integer                  */
/* 'cntunique'=<L0> external integer               */
/* 'condstatementflag'=<L0> external integer       */
/* 'cch'=<L0> external integer                     */
/* 'ccount'=<L0> external integer                  */
/* 'cchan'=<L0> external integer                   */
/* 'cbrk'=<L0> external integer                    */
/* 'cerr'=<L0> external integer                    */
/* 'ceof'=<L0> external integer                    */
/* 'blocklevel'=<L0> external integer              */
/* 'bitspsail'=<L0> external integer               */
/* 'sublanguage'=<L0> array external string        */
/* 'scvtype'=<L0> array external string            */
/* 'ckeywords'=<L0> array external string          */
/* 'wrdmap'=<L0> array external integer            */
/* 'wrdavail'=<L0> array external integer          */
/* 'stravail'=<L0> array external string           */
/* 'spdlcheck'=<L0> array external integer         */
/* 'spdl'=<L0> array external string               */
/* 'reqsaistr'=<L0> array external string          */
/* 'reqpage'=<L0> array external integer           */
/* 'reqoutput'=<L0> array external integer         */
/* 'reqlnstr'=<L0> array external string           */
/* 'reqline'=<L0> array external integer           */
/* 'reqfile'=<L0> array external string            */
/* 'reqchan'=<L0> array external integer           */
/* 'npdlcheck'=<L0> array external integer         */
/* 'npdl'=<L0> array external integer              */
/* 'locstrname'=<L0> array external string         */
/* 'locitemname'=<L0> array external string        */
/* 'locaryname'=<L0> array external string         */
/* 'localleap'=<L0> array external string          */
/* 'hugecmtpdl'=<L0> array external string         */
/* 'fore3list'=<L0> array external string          */
/* 'fore2list'=<L0> array external string          */
/* 'fore1list'=<L0> array external string          */
/* 'evalarglist'=<L0> array external string        */
/* 'errstatistics'=<L0> array external integer     */
/* 'emitepdl'=<L0> array external integer          */
/* 'errline'=<L0> array external string            */
/* 'errfsm'=<L0> array external string             */
/* 'dwptr'=<L0> array external integer             */
/* 'dumytype'=<L0> array external integer          */
/* 'dumyrclass'=<L0> array external string         */
/* 'dumyname'=<L0> array external string           */
/* 'delimpdl'=<L0> array external string           */
/* 'declsize'=<L0> array external string           */
/* 'declrclass'=<L0> array external integer        */
/* 'declnargs'=<L0> array external integer         */
/* 'declinproc'=<L0> array external integer        */
/* 'declhash'=<L0> array external integer          */
/* 'declfsm'=<L0> array external integer           */
/* 'declformal'=<L0> array external string         */
/* 'decldw'=<L0> array external integer            */
/* 'declcsym'=<L0> array external string           */
/* 'declblklvl'=<L0> array external integer        */
/* 'deathwish'=<L0> array external string          */
/* 'dcllocstkframe'=<L0> array external integer    */
/* 'croaklist'=<L0> array external string          */
/* 'cntfsms'=<L0> array external integer           */
/* 'charmap'=<L0> array external string            */
/* 'charisid'=<L0> array external integer          */
/* 'blkspdlptr'=<L0> array external integer        */
/* 'blksemit'=<L0> array external string           */
/* 'blkpname'=<L0> array external string           */
/* 'blkname'=<L0> array external string            */
/* 'blkipdlptr'=<L0> array external integer        */
/* 'blkfrearylist'=<L0> array external string      */
/* 'blkbgensym'=<L0> array external string         */
/* 'blkbits'=<L0> array external integer           */
/* 'blkagensym'=<L0> array external string         */
/* 'blkapdlptr'=<L0> array external integer        */
/* 'vlist'=<L0> external string                    */
/* 'usepsaillibrary'=<L0> external string          */
/* 'uniqstuff'=<L0> external string                */
/* 'semit'=<L0> external string                    */
/* 'scmd'=<L0> external string                     */
/* 'saitoken'=<L0> external string                 */
/* 'saistatement'=<L0> external string             */
/* 'sairbodydelim'=<L0> external string            */
/* 'sairargdelim'=<L0> external string             */
/* 'saimacrodelimiters'=<L0> external string       */
/* 'sailbodydelim'=<L0> external string            */
/* 'sailargdelim'=<L0> external string             */
/* 'saifile'=<L0> external string                  */
/* 'ss3'=<L0> external string                      */
/* 'ss2'=<L0> external string                      */
/* 'ss1'=<L0> external string                      */
/* 'ss'=<L0> external string                       */
/* 'promotedouble'=<L0> external string            */
/* 'predeflist'=<L0> external string               */
/* 'oppn'=<L0> external string                     */
/* 'oldtypestatement'=<L0> external string         */
/* 'oldtoken'=<L0> external string                 */
/* 'oldlastprocedure'=<L0> external string         */
/* 'oldaryspec'=<L0> external string               */
/* 'nouqprocedures'=<L0> external string           */
/* 'nouqinternal'=<L0> external string             */
/* 'mversion'=<L0> external string                 */
/* 'mkrstr'=<L0> external string                   */
/* 'mkrfile'=<L0> external string                  */
/* 'minuses'=<L0> external string                  */
/* 'mdate'=<L0> external string                    */
/* 'line'=<L0> external string                     */
/* 'laststatement'=<L0> external string            */
/* 'lastprocedure'=<L0> external string            */
/* 'lastmappedtoken'=<L0> external string          */
/* 'lastformal'=<L0> external string               */
/* 'lastcsym'=<L0> external string                 */
/* 'lastasize'=<L0> external string                */
/* 'itemtype'=<L0> external string                 */
/* 'ippn'=<L0> external string                     */
/* 'genericname'=<L0> external string              */
/* 'fore3str'=<L0> external string                 */
/* 'fore2str'=<L0> external string                 */
/* 'fore1str'=<L0> external string                 */
/* 'dcstaticdeclaration'=<L0> external string      */
/* 'ctrfile'=<L0> external string                  */
/* 'cstatement'=<L0> external string               */
/* 'classize'=<L0> external string                 */
/* 'cfile'=<L0> external string                    */
/* 'ps_warning_'=<L0> external string              */
/* 'ps__undf_'=<L0> external string                */
/* 'ps__leap_'=<L0> external string                */
/* 'b40'=<L0> external string                      */
/* 'b39'=<L0> external string                      */
/* 'b38'=<L0> external string                      */
/* 'b37'=<L0> external string                      */
/* 'b36'=<L0> external string                      */
/* 'b35'=<L0> external string                      */
/* 'b34'=<L0> external string                      */
/* 'b33'=<L0> external string                      */
/* 'b32'=<L0> external string                      */
/* 'b31'=<L0> external string                      */
/* 'b30'=<L0> external string                      */
/* 'b29'=<L0> external string                      */
/* 'b28'=<L0> external string                      */
/* 'b27'=<L0> external string                      */
/* 'b26'=<L0> external string                      */
/* 'b25'=<L0> external string                      */
/* 'b24'=<L0> external string                      */
/* 'b23'=<L0> external string                      */
/* 'b22'=<L0> external string                      */
/* 'b21'=<L0> external string                      */
/* 'b20'=<L0> external string                      */
/* 'b19'=<L0> external string                      */
/* 'b18'=<L0> external string                      */
/* 'b17'=<L0> external string                      */
/* 'b16'=<L0> external string                      */
/* 'b15'=<L0> external string                      */
/* 'b14'=<L0> external string                      */
/* 'b13'=<L0> external string                      */
/* 'b12'=<L0> external string                      */
/* 'b11'=<L0> external string                      */
/* 'b10'=<L0> external string                      */
/* 'b9'=<L0> external string                       */
/* 'b8'=<L0> external string                       */
/* 'b7'=<L0> external string                       */
/* 'b6'=<L0> external string                       */
/* 'b5'=<L0> external string                       */
/* 'b4'=<L0> external string                       */
/* 'b3'=<L0> external string                       */
/* 'b2'=<L0> external string                       */
/* 'b1'=<L0> external string                       */
/* 'twoquotes'=<L0> external string                */
/* 'singlequote'=<L0> external string              */
/* 'semicolon'=<L0> external string                */
/* 'quote'=<L0> external string                    */
/* 'fourquotes'=<L0> external string               */
/* 'ff'=<L0> external string                       */
/* 'dw_mask'=<L0> fragment macro                   */
/* 'dw_reference'=<L0> macro integer               */
/* 'dw_genericproc'=<L0> macro integer             */
/* 'dw_forwardref'=<L0> macro integer              */
/* 'dw_recmem'=<L0> macro integer                  */
/* 'dw_safe'=<L0> macro integer                    */
/* 'dw_carray'=<L0> macro integer                  */
/* 'dw_procedure'=<L0> macro integer               */
/* 'dw_formalarg'=<L0> macro integer               */
/* 'dw_leap'=<L0> macro integer                    */
/* 'dw_internal'=<L0> macro integer                */
/* 'dw_external'=<L0> macro integer                */
/* 'dw_macro'=<L0> macro integer                   */
/* 'dw_fragment'=<L0> macro integer                */
/* 'dw_static'=<L0> macro integer                  */
/* 'dw_array'=<L0> macro integer                   */
/* 'dw_fsm'=<L0> macro integer                     */
/* 'dw_itemarray'=<L0> macro integer               */
/* 'pdw_sublanguage'=<L0> formalArg macro integer  */
/* 'gdw_sublanguage'=<L0> macro integer            */
/* 'pdw_ptype'=<L0> formalArg macro integer        */
/* 'gdw_ptype'=<L0> fragment macro                 */
/* 'pdw_itemtype'=<L0> formalArg macro integer     */
/* 'gdw_itemtype'=<L0> macro integer               */
/* 'codeboolean'=<L0> macro integer                */
/* 'codecarray'=<L0> macro integer                 */
/* 'codebyte'=<L0> macro integer                   */
/* 'codeshort'=<L0> macro integer                  */
/* 'codeitemarray'=<L0> macro integer              */
/* 'codesafe'=<L0> macro integer                   */
/* 'coderecmem'=<L0> macro integer                 */
/* 'codeitem'=<L0> macro integer                   */
/* 'codeown'=<L0> macro integer                    */
/* 'codeitemvar'=<L0> macro integer                */
/* 'codeuntyped'=<L0> macro integer                */
/* 'coderecclass'=<L0> macro integer               */
/* 'codeset'=<L0> macro integer                    */
/* 'codereference'=<L0> macro integer              */
/* 'coderecptr'=<L0> macro integer                 */
/* 'codeprocedure'=<L0> macro integer              */
/* 'codeoptional'=<L0> macro integer               */
/* 'codevoid'=<L0> macro integer                   */
/* 'codemacro'=<L0> macro integer                  */
/* 'codelist'=<L0> macro integer                   */
/* 'codelisp_sexpr'=<L0> macro integer             */
/* 'codeobject'=<L0> macro integer                 */
/* 'codeinteger'=<L0> macro integer                */
/* 'codelispatom'=<L0> macro integer               */
/* 'codelabel'=<L0> macro integer                  */
/* 'codereal'=<L0> macro integer                   */
/* 'codeevent'=<L0> macro integer                  */
/* 'codedouble'=<L0> macro integer                 */
/* 'codestring'=<L0> macro integer                 */
/* 'codeinterrupt'=<L0> macro integer              */
/* 'codearray'=<L0> macro integer                  */
/* 'w_fsm11_keyword'=<L0> macro integer            */
/* 'w_mak_blk_exit'=<L0> macro integer             */
/* 'w_ppdw_ptype'=<L0> macro integer               */
/* 'w_ggdw_ptype'=<L0> macro integer               */
/* 'w_p_pchk_line'=<L0> macro integer              */
/* 'w_cvt_any_to_chr'=<L0> macro integer           */
/* 'w_set_preface'=<L0> macro integer              */
/* 'w_isscalartype'=<L0> macro integer             */
/* 'w_issaideclar'=<L0> macro integer              */
/* 'w_map_bkslash_str'=<L0> macro integer          */
/* 'w_out_both'=<L0> macro integer                 */
/* 'w_err_hlr'=<L0> macro integer                  */
/* 'w_justify_text'=<L0> macro integer             */
/* 'w_getid'=<L0> macro integer                    */
/* 'w_cvptypel'=<L0> macro integer                 */
/* 'w_cvltypep'=<L0> macro integer                 */
/* 'w_cv5int'=<L0> macro integer                   */
/* 'w_cv5hash'=<L0> macro integer                  */
/* 'w_chk_sconst'=<L0> macro integer               */
/* 'w_chk_iconst'=<L0> macro integer               */
/* 'w_readtrash_graphics'=<L0> macro integer       */
/* 'w_readfile'=<L0> macro integer                 */
/* 'w_fsm73'=<L0> macro integer                    */
/* 'w_find_rc_symbol'=<L0> macro integer           */
/* 'w_rem_symbols'=<L0> macro integer              */
/* 'w_cvdwi'=<L0> macro integer                    */
/* 'w_cvidw'=<L0> macro integer                    */
/* 'w_map_embedded_comments'=<L0> macro integer    */
/* 'w_pushnumber'=<L0> macro integer               */
/* 'w_push'=<L0> macro integer                     */
/* 'w_popnumber'=<L0> macro integer                */
/* 'w_pop'=<L0> macro integer                      */
/* 'w_map_whitespace'=<L0> macro integer           */
/* 'w_chk_type'=<L0> macro integer                 */
/* 'w_chk_real'=<L0> macro integer                 */
/* 'w_chk_integer'=<L0> macro integer              */
/* 'w_add_builtin'=<L0> macro integer              */
/* 'w_simple_map'=<L0> macro integer               */
/* 'w_r_d_expr_map'=<L0> macro integer             */
/* 'w_push_block_name'=<L0> macro integer          */
/* 'w_process_token'=<L0> macro integer            */
/* 'w_pop_block_name'=<L0> macro integer           */
/* 'w_map_ws_comments'=<L0> macro integer          */
/* 'w_map_quotes'=<L0> macro integer               */
/* 'w_map_leap_triple'=<L0> macro integer          */
/* 'w_map_inf'=<L0> macro integer                  */
/* 'w_map_expr'=<L0> macro integer                 */
/* 'w_map_declar'=<L0> macro integer               */
/* 'w_map_ck_args'=<L0> macro integer              */
/* 'w_map_be'=<L0> macro integer                   */
/* 'w_get_next_statement'=<L0> macro integer       */
/* 'w_cvt_sail_to_c'=<L0> macro integer            */
/* 'w_rightstatement'=<L0> macro integer           */
/* 'w_rightid'=<L0> macro integer                  */
/* 'w_rightexpr'=<L0> macro integer                */
/* 'w_left_id'=<L0> macro integer                  */
/* 'w_left_expr'=<L0> macro integer                */
/* 'w_get_token'=<L0> macro integer                */
/* 'w_get_number'=<L0> macro integer               */
/* 'w_get_c_token'=<L0> macro integer              */
/* 'w_get_input'=<L0> macro integer                */
/* 'w_expand_macro'=<L0> macro integer             */
/* 'w_copy_either'=<L0> macro integer              */
/* 'w_copy_omit'=<L0> macro integer                */
/* 'w_chk_32bit_integer'=<L0> macro integer        */
/* 'w_fsm71'=<L0> macro integer                    */
/* 'w_fsm70'=<L0> macro integer                    */
/* 'w_fsm69'=<L0> macro integer                    */
/* 'w_fsm68'=<L0> macro integer                    */
/* 'w_fsm67'=<L0> macro integer                    */
/* 'w_fsm66'=<L0> macro integer                    */
/* 'w_fsm65'=<L0> macro integer                    */
/* 'w_fsm64'=<L0> macro integer                    */
/* 'w_fsm63'=<L0> macro integer                    */
/* 'w_fsm62'=<L0> macro integer                    */
/* 'w_fsm61'=<L0> macro integer                    */
/* 'w_fsm60'=<L0> macro integer                    */
/* 'w_fsm59'=<L0> macro integer                    */
/* 'w_fsm58'=<L0> macro integer                    */
/* 'w_fsm57'=<L0> macro integer                    */
/* 'w_fsm56'=<L0> macro integer                    */
/* 'w_fsm55'=<L0> macro integer                    */
/* 'w_fsm54'=<L0> macro integer                    */
/* 'w_fsm53'=<L0> macro integer                    */
/* 'w_fsm52'=<L0> macro integer                    */
/* 'w_fsm51'=<L0> macro integer                    */
/* 'w_fsm50'=<L0> macro integer                    */
/* 'w_fsm49'=<L0> macro integer                    */
/* 'w_fsm48'=<L0> macro integer                    */
/* 'w_fsm47'=<L0> macro integer                    */
/* 'w_fsm46'=<L0> macro integer                    */
/* 'w_fsm45'=<L0> macro integer                    */
/* 'w_fsm44'=<L0> macro integer                    */
/* 'w_fsm43'=<L0> macro integer                    */
/* 'w_fsm42'=<L0> macro integer                    */
/* 'w_fsm41'=<L0> macro integer                    */
/* 'w_fsm40'=<L0> macro integer                    */
/* 'w_fsm39'=<L0> macro integer                    */
/* 'w_fsm38'=<L0> macro integer                    */
/* 'w_fsm37'=<L0> macro integer                    */
/* 'w_fsm36'=<L0> macro integer                    */
/* 'w_fsm35'=<L0> macro integer                    */
/* 'w_fsm34'=<L0> macro integer                    */
/* 'w_fsm33'=<L0> macro integer                    */
/* 'w_fsm32'=<L0> macro integer                    */
/* 'w_fsm31'=<L0> macro integer                    */
/* 'w_fsm30'=<L0> macro integer                    */
/* 'w_fsm29'=<L0> macro integer                    */
/* 'w_fsm28'=<L0> macro integer                    */
/* 'w_fsm27'=<L0> macro integer                    */
/* 'w_fsm26'=<L0> macro integer                    */
/* 'w_fsm25'=<L0> macro integer                    */
/* 'w_fsm24'=<L0> macro integer                    */
/* 'w_fsm23'=<L0> macro integer                    */
/* 'w_fsm22'=<L0> macro integer                    */
/* 'w_fsm21'=<L0> macro integer                    */
/* 'w_fsm20'=<L0> macro integer                    */
/* 'w_fsm19'=<L0> macro integer                    */
/* 'w_fsm18'=<L0> macro integer                    */
/* 'w_fsm17'=<L0> macro integer                    */
/* 'w_fsm16'=<L0> macro integer                    */
/* 'w_fsm15'=<L0> macro integer                    */
/* 'w_fsm14'=<L0> macro integer                    */
/* 'w_fsm13'=<L0> macro integer                    */
/* 'w_fsm12'=<L0> macro integer                    */
/* 'w_fsm11'=<L0> macro integer                    */
/* 'w_fsm10'=<L0> macro integer                    */
/* 'w_fsm9'=<L0> macro integer                     */
/* 'w_fsm8'=<L0> macro integer                     */
/* 'w_fsm7'=<L0> macro integer                     */
/* 'w_fsm6'=<L0> macro integer                     */
/* 'w_fsm5'=<L0> macro integer                     */
/* 'w_fsm72'=<L0> macro integer                    */
/* 'w_fsm4a'=<L0> macro integer                    */
/* 'w_fsm4'=<L0> macro integer                     */
/* 'w_fsm3'=<L0> macro integer                     */
/* 'w_fsm2'=<L0> macro integer                     */
/* 'w_fsm1'=<L0> macro integer                     */
/* 'w_fsm0'=<L0> macro integer                     */
/* 'w_emit_loc_code'=<L0> macro integer            */
/* 'w_emit_main_code'=<L0> macro integer           */
/* 'w_emit_cleanup_code'=<L0> macro integer        */
/* 'w_set_extensions'=<L0> macro integer           */
/* 'w_fold_const_expr'=<L0> macro integer          */
/* 'w_remove_white_ends'=<L0> macro integer        */
/* 'w_pretty_print'=<L0> macro integer             */
/* 'w_insert_before_white'=<L0> macro integer      */
/* 'w_infix_to_prefix'=<L0> macro integer          */
/* 'w_cvupcase'=<L0> macro integer                 */
/* 'w_cvtypes'=<L0> macro integer                  */
/* 'w_cvstype'=<L0> macro integer                  */
/* 'w_cvlower'=<L0> macro integer                  */
/* 'w_cvevalquote'=<L0> macro integer              */
/* 'w_cvdummy_arg'=<L0> macro integer              */
/* 'w_cvactual_to_expected'=<L0> macro integer     */
/* 'w_cv_print_arglist'=<L0> macro integer         */
/* 'w_uniq_declarations'=<L0> macro integer        */
/* 'w_chk_switches'=<L0> macro integer             */
/* 'w_chk_sail_keyword'=<L0> macro integer         */
/* 'w_chk_number'=<L0> macro integer               */
/* 'w_chk_id'=<L0> macro integer                   */
/* 'w_chk_expr_list'=<L0> macro integer            */
/* 'w_chk_c_keyword'=<L0> macro integer            */
/* 'w_chk_leap_optimize'=<L0> macro integer        */
/* 'w_put_hash_c'=<L0> macro integer               */
/* 'w_hash_c'=<L0> macro integer                   */
/* 'w_add_gc_pushs'=<L0> macro integer             */
/* 'w_find_symbol'=<L0> macro integer              */
/* 'w_chk_name_map'=<L0> macro integer             */
/* 'w_build_tables'=<L0> macro integer             */
/* 'chk_emit'=<L0> fragment macro                  */
/* 'push_strname'=<L0> fragment macro              */
/* 'push_itemname'=<L0> fragment macro             */
/* 'push_aryname'=<L0> fragment macro              */
/* 'errnlrg_comments'=<L0> macro integer           */
/* 'errnprobes_hash_c'=<L0> macro integer          */
/* 'errnhash_c'=<L0> macro integer                 */
/* 'errnclutter'=<L0> macro integer                */
/* 'errnonportable'=<L0> macro integer             */
/* 'errwarning'=<L0> macro integer                 */
/* 'errundf'=<L0> macro integer                    */
/* 'errslocmax'=<L0> macro integer                 */
/* 'errilocmax'=<L0> macro integer                 */
/* 'erralocmax'=<L0> macro integer                 */
/* 'errnpdlmax'=<L0> macro integer                 */
/* 'errspdlmax'=<L0> macro integer                 */
/* 'errnbuiltin'=<L0> macro integer                */
/* 'errfsymbols'=<L0> macro integer                */
/* 'errusymbols'=<L0> macro integer                */
/* 'errforward'=<L0> macro integer                 */
/* 'errextern'=<L0> macro integer                  */
/* 'errintern'=<L0> macro integer                  */
/* 'errproc'=<L0> macro integer                    */
/* 'errsmacros'=<L0> macro integer                 */
/* 'errnmacros'=<L0> macro integer                 */
/* 'errlocv'=<L0> macro integer                    */
/* 'errglbv'=<L0> macro integer                    */
/* 'errptgc'=<L0> macro integer                    */
/* 'errntgc'=<L0> macro integer                    */
/* 'err10warning'=<L0> macro integer               */
/* 'err9warning'=<L0> macro integer                */
/* 'err8warning'=<L0> macro integer                */
/* 'err7warning'=<L0> macro integer                */
/* 'err6warning'=<L0> macro integer                */
/* 'err5warning'=<L0> macro integer                */
/* 'err4warning'=<L0> macro integer                */
/* 'err3warning'=<L0> macro integer                */
/* 'err2warning'=<L0> macro integer                */
/* 'err1warning'=<L0> macro integer                */
/* 'errnerrs'=<L0> macro integer                   */
/* 'bail_debug'=<L0> fragment macro                */
/* 'trash_right_ws'=<L0> fragment macro            */
/* 'trash_right_space_tab'=<L0> macro string       */
/* 'set_static'=<L0> macro string                  */
/* 'rmv_integer_cast'=<L0> formalArg macro string  */
/* 'isvariable'=<L0> macro integer                 */
/* 'isunaryscalartype'=<L0> macro integer          */
/* 'isoctal'=<L0> macro integer                    */
/* 'isleapdeclar'=<L0> macro integer               */
/* 'isleapcode'=<L0> macro integer                 */
/* 'maxstat'=<L0> fragment macro                   */
/* 'incstat'=<L0> fragment macro                   */
/* 'incfsm'=<L0> fragment macro                    */
/* 'cvt_e_to_at'=<L0> formalArg macro integer      */
/* 'cvt_at_to_e'=<L0> formalArg macro integer      */
/* 'arithcvtypecode'=<L0> macro integer            */
/* 'addstat'=<L0> fragment macro                   */
/* 'lblprefix'=<L0> macro string                   */
/* 'rmvlargecomment'=<L0> macro integer            */
/* 'useinitializersswitch'=<L0> macro integer      */
/* 'chkdryrot_strings'=<L0> macro integer          */
/* 'maxmacroargs'=<L0> macro integer               */
/* 'maxglbsym'=<L0> macro integer                  */
/* 'maxglbstr'=<L0> macro integer                  */
/* 'plibacct'=<L0> macro string                    */
/* 'version'=<L0> macro string                     */
/* 'rmverrsqbrkts'=<L0> macro integer              */
/* 'esafer'=<L0> fragment macro                    */
/* 'isafer'=<L0> fragment macro                    */
/***************************************************/
/************************************************/
/*<2>                                           */
/*        \-\  -----*                           */
/*         \ \  \  /                            */
/*          \ \  \/                             */
/*           \ \ /                              */
/*            \ \                               */
/*             \-\                              */
/*  ROUGH WEATHER LIES AHEAD, GET SHIP SHAPE!   */
/************************************************/


 /* PSPPRT.SAI */


/*Finished[pspprt.sai[50,32,PSAIL,MODULE]==>pspprt.c] 12/25/87, 04:48:41PM
# .SAI lines=3186 L.P.M=87, # .C stmnts=1414 C-S.P.M.=39
Real TIME =00:39:24 CPU TIME  =00:34:29,   87.521%


                       portability*
                                 /*
                                / *              \|/
                               /  *              -*-
                              /P  *              /|\
                             / S  *
                            /  A  *
                            \  I  *
                             \ L  *
                ---           \   * ---
                 \ \           \  *  \ \
                  \ \-----------\ *---\ \
                   \ \           \*    \ \
                    \ \           *     \ \
                     \ \          *      \ \
                      \ \-----------------\ \
                       \ \                 \ \
                        \/                  \/

                       SAIL                  C


*/
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */

