/* FILE: push_block_name.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psparse.c, being converted 12/25/87, 09:34:41PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ----------------------------------------------------- */
/*INTERNAL*/  STRING push_block_name()
/*  ----------------------------------------------------- */
{/* PUSH!BLOCK!NAME */
/*  --
.LABEL [<++PSAIL PROCEDURE: PUSH!BLOCK!NAME>]
.INDEX ++PSAIL PROCEDURE: PUSH!BLOCK!NAME
DESCRIPTION:
	Called by "BEGIN" to check if next input is a string constant
block label in which case it pushes it onto blkName[lastBlock] stack.
It returns a comment for the label if found else it returns null. It
also pushes other global variables into tehe block stack frame.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: PUSH!BLOCK!NAME>]
 */
STRING inname, 
	s, 
	s1, 
	s2, 
	ws;
INTEGER i, 
	j, 
	ch;

;

GC_EPOPS(dbug(040L,catlist(15L,GC_PUSHS("[PUSH!BLOCK!NAME] old blockLevel="),
        cvs(blocklevel),GC_PUSHS(crlf),GC_PUSHS(" locIptr="),
        cvs(lociptr),GC_PUSHS(" locSptr="),cvs(locsptr),
        GC_PUSHS(" locAptr="),cvs(locaptr),GC_PUSHS(crlf),
        GC_PUSHS("  oldLastProcedure=\'"),GC_PUSHS(oldlastprocedure)
        ,GC_PUSHS("\' lastProcedure=\'"),GC_PUSHS(lastprocedure),
        GC_PUSHS("\'"))));
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(inname); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(ws); /* for G.C. */
ws= PNULL;
map_whitespace(&ws);
inname= PNULL;
if (!ismacroflag &&*saistatement==*quote) 
	{/* found a block label */
	ch= LOP(saistatement);			/*  -- trash quote */
	pushnumber(iscopy_toflag); iscopy_toflag= 1L;
			/*  -- This prevents it from sucking white space */
	inname= GC_EPOPS(map_quotes(&saistatement));	/*  -- extract "string"  */
	popnumber(&iscopy_toflag);
	if (*inname==*quote||*inname==*singlequote) inname= GC_EPOPS(remove_white_ends(subst(GC_PUSHS(inname),2L,length(inname)-1L)));
GC_EPOPS(dbug(040L,catlist(7L,GC_PUSHS("[PUSH!BLOCK!NAME].0.1 inName=\'"),
        GC_PUSHS(inname),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  saiStatement=\'"),GC_PUSHS(saistatement),
        GC_PUSHS("\'"))));
	if (blocklevel==20L)
		{/* error */
		s= "@";				/*  -- Add prefix */
		for (i=1;i<=(blocklevel+1L);i++)
		   s= catlist(6L,GC_PUSHS(s),GC_PUSHS("block["),cvs(i),GC_PUSHS("]="),
        GC_PUSHS(*aChkC(blkname,1L,i)),GC_PUSHS(crlf));
		i= LOP(s);			/*  -- remove '@' prefix */
		err_hlr(catlist(9L,GC_PUSHS("[PUSH!BLOCK!NAME] stack=\'"),GC_PUSHS(s),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("	 > "),
        GC_PUSHS("20"),GC_PUSHS(
        "# nesting block label levels for block \'"),
        GC_PUSHS(inname),GC_PUSHS("\'")));
		}/* error */
	}/* found a block label */

(*aChkC(blkname,1L,++blocklevel))= inname;
GC_EPOPS(dbug(040L,catlist(5L,GC_PUSHS("[PUSH!BLOCK!NAME].1 blkName[blockLevel="),
        cvs(blocklevel),GC_PUSHS("]=\'"),GC_PUSHS(*aChkC(blkname,1L,
        blocklevel)),GC_PUSHS("\'"))));
(*aChkC(blkfrearylist,1L,blocklevel))= PNULL;   /*  -- gen'ed later if DYNAMIC ARRAYS */
(*aChkC(blkagensym,1L,blocklevel))= PNULL;      /*  -- generated later if need GOTO */
(*aChkC(blkbgensym,1L,blocklevel))= PNULL;      /*  -- generated later if need GOTO */
(*aChkC(blkpname,1L,blocklevel))= oldlastprocedure; /*  -- name of procedure we are in */
oldlastprocedure= lastprocedure;	    /*  -- update just in case we are
					processing a PROCEDURE body */
typelastprocdecl= (*aChkI(decldw,1L,(*aChkI(dwptr,1L,hash_c(GC_PUSHS(lastprocedure))))));  /*  -- type of
				procedure in which block was declared */
(*aChkC(blksemit,1L,blocklevel))= semit;  /*  -- Save C code to emit before this stuff */

(*aChkI(blkbits,1L,blocklevel))= ((midofexpr) ?   01L:0L)|((incaseflag) ?   02L:0L)|((inifflag) ?   04L:0L)|((isifexpr) ?   010L:0L)|((firstlocxct) ?   020L:0L)|((didlocemit) ?   040L:0L)|((emitenableflag) ?   0100L:0L)|((didblkexit) ?   0200L:0L); 
					/*  -- save STATE of flags */
midofexpr= incaseflag= inifflag= isifexpr= firstlocxct= didlocemit= didblkexit = 0L; 		/*  -- CLEAR THEM!!! */
emitenableflag= 1L;			/*  -- NOW, ok to emit!LOC!code
					until we turn it off */

(*aChkI(blkapdlptr,1L,blocklevel))= locaptr;  /*  --Save LOCAL array PDL ptr */
(*aChkI(blkipdlptr,1L,blocklevel))= lociptr;  /*  --Save LOCAL ITEM PDL ptr */
(*aChkI(blkspdlptr,1L,blocklevel))= locsptr;  /*  --Save LOCAL String PDL ptr */
if ((*inname=='\0'))
  s= PNULL; 
else s= catlist(3L,GC_PUSHS("/* "),GC_PUSHS(inname),GC_PUSHS(" */"));
GC_EPOPS(dbug(040L,catlist(21L,GC_PUSHS("[PUSH!BLOCK!NAME].2 s=\'"),
			   GC_PUSHS(s),
			   GC_PUSHS("\' blockLevel\'="),cvs(blocklevel),
			   GC_PUSHS(crlf),
			   GC_PUSHS(" blkSPDLptr["),cvs(blocklevel),
			   GC_PUSHS("]="),
			   cvs((*aChkI(blkspdlptr,1L,blocklevel))),
			   GC_PUSHS(" blkBits[blockLevel]="),
			   cvos((*aChkI(blkbits,1L, blocklevel))),
			   GC_PUSHS(crlf),
			   GC_PUSHS("  oldLastProcedure=\'"),
			   GC_PUSHS(oldlastprocedure),
			   GC_PUSHS("\' lastProcedure=\'"),
			   GC_PUSHS(lastprocedure),
			   GC_PUSHS("\'"),GC_PUSHS(crlf),
			   GC_PUSHS(" typeLastProcDecl=\'"),
			   cvtypes(typelastprocdecl),
			   GC_PUSHS("\'"))));

 
GC_SRETURN(s)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'j'=<L0> integer                              */
/* 's2'=<L0> string                              */
/* 's1'=<L0> string                              */
/*************************************************/

}/* PUSH!BLOCK!NAME */
