/* FILE: put_hash_c.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pssymt.c, being converted 12/25/87, 02:03:55PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  INTEGER put_hash_c(sym)
	STRING sym;
/*  ------------------------------------------------------- */
{/* PUT!HASH!C */
/*  --
.LABEL [<++PSAIL PROCEDURE: PUT!HASH!C>]
.INDEX ++PSAIL PROCEDURE: PUT!HASH!C
DESCRIPTION:
	Find a hole in the hash table in which to store 'str' in the
range of [1:maxSymbols-1]. If the symbol is null or the symbol table
is full then return 0. Verify that it really got there by using
HASH!C(sym) to look it up! The slot used to store it 'lastHfree' is
gotten from a HASH!C() search.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: PUT!HASH!C>]
 */
INTEGER h, 
	htest;
STRING s1;

;
GC_POPS(sym); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(sym); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
if (*sym=='\0') GC_NRETURN(0)

sym= GC_EPOPS(cvlower(GC_PUSHS(sym)));

h= hash_c(GC_PUSHS(sym));	   /*  -- Note: lastHfree is hole if h=0 else exists. */
/*  # # DBUG('1,"[PUT!HASH] sym="&sym&" h="&CVS(h)&" lastHfree="&CVS(lastHfree)) */
if (lasthfree!=0) 
	{/* put into hash symbol table */
	++nhsymbols;
	if (h==0) h= lasthfree;	/*  -- Save free hole ptr */
	(*aChkC(saisym,1L,h))= sym;  	/*  -- Enter it into the symbol table!!! */
	htest= hash_c(GC_PUSHS(sym));	/*  -- Now read it again */
	}/* put into hash symbol table */

if ((htest!=h) ||(h==0) ||(lasthfree==0)) err_hlr(GC_PUSHS(
        		catlist(GC_PUSHS("[PUT!HASH!C] verification error hTest[")
        ,GC_PUSHS(sym),GC_PUSHS("]="),cvs(htest),GC_PUSHS(" NEQ h=")
        ,cvs(h),GC_PUSHS(crlf),GC_PUSHS(" % Hash table full = "),
        cvs((INTEGER)100.0*nhsymbols/1699L),GC_PUSHS(crlf),
        GC_PUSHS("lastHfree="),cvs(lasthfree),GC_PUSHS(" lastHcnt=")
        ,cvs(lasthcnt))));

;
GC_NRETURN(lasthfree)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 's1'=<L0> string                              */
/*************************************************/

}/* PUT!HASH!C */
