/* FILE: r_d_expr_map.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psparse.c, being converted 12/25/87, 09:34:41PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  --------------------------------------------------- */
/*INTERNAL*/  STRING r_d_expr_map(sinput)
	STRING sinput;
/*  --------------------------------------------------- */
{/* R!D!EXPR!MAP */
/*  --
.LABEL [<++PSAIL PROCEDURE: R!D!EXPR!MAP>]
.INDEX ++PSAIL PROCEDURE: R!D!EXPR!MAP
DESCRIPTION:
	Save current 'saiStatement,' then substitute 'sInput' for it
and recursively EVAL it into string 'sResult'. Restore 'saiStatement'
and then return 'sResult'.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: R!D!EXPR!MAP>]
 */
STRING token, 
	sresult, 
	s;
INTEGER brk, 
	h;

;

GC_EPOPS(dbug(01000000L,catlist(6L,GC_PUSHS("[R!D!EXPR!MAP] blockLevel="),cvs(blocklevel),
        GC_PUSHS(" sPDLptr="),cvs(spdlptr),GC_PUSHS(" nPDLptr="),
        cvs(npdlptr))));
GC_EPOPS(dbug(01000000L,catlist(11L,GC_PUSHS("[R!D!EXPR!MAP].0.1 oldTypeStatement="),
        GC_PUSHS(oldtypestatement),GC_PUSHS(crlf),
        GC_PUSHS(" lastType=\'"),cvtypes(lasttype),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" isIFCflag="),pbool(isifcflag),
        GC_PUSHS(" midOfExpr="),pbool(midofexpr))));
GC_EPOPS(dbug(01000000L,catlist(20L,GC_PUSHS("[R!D!EXPR!MAP].0.2 locIptr="),cvs(lociptr),
        GC_PUSHS(" locSptr="),cvs(locsptr),GC_PUSHS(" locAptr="),
        cvs(locaptr),GC_PUSHS(crlf),GC_PUSHS(" lastDeclaration=\'"),
        cvtypes(lastdeclaration),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" |sInput|="),cvs(length(GC_PUSHS(sinput))),
        GC_PUSHS(" sInput=\'"),GC_PUSHS(sinput),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS(" line=\'"),GC_PUSHS(line),
        GC_PUSHS("\'"))));
/* NO-OP */;
/* 	Recursive descent is available as an option after V.8.00 and
is made a permanent option > V.18.0.
 */

GC_POPS(sinput); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(sinput); /* for G.C. */
GC_NOTESTRING(token); /* for G.C. */
GC_NOTESTRING(sresult); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
if (*sinput=='\0')
	{/* Something is funny - evaling NULL input? */
	sresult= PNULL;
	}/* Something is funny - evaling NULL input? */
else	{/* go eval it */

/*  # # @V.53.78	PUSHNUMBER(emitEnableFlag) */
/*  # # @V.53.78	emitEnableFlag_FALSE */
	pushnumber(lastdeclaration);
	push(GC_PUSHS(saistatement));		/*  -- Save current input state */
	push(GC_PUSHS(cstatement));		/*  -- Save current output state */
	push(GC_PUSHS(saitoken));
	pushnumber(revalflag);
	saistatement= sinput;	/*  -- EVAL alternate input string */
	if (usetimerflag) cstatement= GC_EPOPS(run_time()); 
	else cstatement= PNULL;
	revalflag= 1L;		/*  -- Do not get input from .SAI!!! */
	++rdlevel;	/*  --  Level in Recursive Descent */
	(*aChkI(npdlcheck,1L,rdlevel))= npdlptr;	/*  -- Save NUMBER ptr for check */
	(*aChkI(spdlcheck,1L,rdlevel))= spdlptr;	/*  -- Save String ptr for check */
if (usebacktraceflag)
	{/* save BACKTRACE info */
	(*aChkC(errline,1L,rdlevel))= ((length(GC_PUSHS(sinput))>1000L) ? 
        					catlist(subst(GC_PUSHS(sinput),1L,1000L),GC_PUSHS(crlf)
        ,GC_PUSHS("	>>> ETC. <<<")): sinput);  /*  -- save in case need 
						for ERR!HLR() */
	(*aChkC(errfsm,1L,rdlevel))= "@";   /*  -- save in case need for ERR!HLR() */
	}/* save BACKTRACE info */
	map_whitespace(&cstatement);
/*  # # DBUG('1000000,"[R!D!EXPR!MAP].0.3 sPDLptr="&CVS(sPDLptr)&CRLF&" saiStatement="&saiStatement&CRLF&" isFragmentFlag="&PBOOL(isFragmentFlag)&" LENGTH(saiStatement)="&CVS(LENGTH(saiStatement))) */
	lastidflag= 0L;	/*  -- Not variable. Will be set TRUE
				     if previous ID was a VARIABLE! */
	while ((!(*saistatement=='\0')) &&(isfragmentflag==0L))
		{/* Process subloop */
GC_EPOPS(dbug(01000000L,catlist(10L,GC_PUSHS("[R!D!EXPR!MAP].1 cStatement=\'"),
        GC_PUSHS(cstatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" saiStatement=\'"),GC_PUSHS(saistatement),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" NULdevFlag="),
        pbool(nuldevflag))));
		s= GC_EPOPS(process_token()); /*  -- parse tokens in SAIL statement */
/* NO-OP */;
		/*  -- if /NUL is set or we are delving into
		  a REQUIRE ..SOURCE!FILE with /NOREQUIRE
		  then we don't bother to save the output */
		if ((*s!='\0')
/*  # # @V.54.08	 And (Not NULdevFlag)  */) 
			{/* build output string */
			if (*cstatement=='\0') cstatement= s; 
			else cstatement= catlist(2L,GC_PUSHS(cstatement),GC_PUSHS(s));
			}/* build output string */
/*  # # DBUG('1000000,"[R!D!EXPR!MAP].2 NULdevFlag="&PBOOL(NULdevFlag)&CRLF&" cStatement="&cStatement&CRLF&" saiStatement="&saiStatement&CRLF&" isFragmentFlag="&PBOOL(isFragmentFlag)) */
		}/* Process subloop */
/*  # # DBUG('1000000,"[R!D!EXPR!MAP].2.1 cStatement="&cStatement&CRLF&" saiStatement="&saiStatement&CRLF&" isFragmentFlag="&PBOOL(isFragmentFlag)) */
	if (spdlptr!=(*aChkI(spdlcheck,1L,rdlevel))||
	   npdlptr!=(*aChkI(npdlcheck,1L,rdlevel))) 
		{/* fatal error */
		ismacroflag= 0L;	/*  -- force it to barf! */
		err_hlr(GC_PUSHS(
        			catlist(GC_PUSHS(
        "[R!D!EXPR!MAP] DRYROT! initial sPDLptr="),
        cvs((*aChkI(spdlcheck,1L,rdlevel))),
        GC_PUSHS(" final sPDLptr="),cvs(spdlptr),GC_PUSHS(crlf),
        GC_PUSHS(" initial nPDLptr="),cvs((*aChkI(npdlcheck,1L,
        rdlevel))),GC_PUSHS(" final nPDLptr="),cvs(npdlptr),
        GC_PUSHS(crlf),GC_PUSHS(" rdLevel="),cvs(rdlevel),
        GC_PUSHS(" rrLevel="),cvs(rrlevel),GC_PUSHS(" blockLevel="),
        cvs(blocklevel),GC_PUSHS(crlf),GC_PUSHS(" saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" cStatement=\'"),GC_PUSHS(cstatement),GC_PUSHS(
        "\'"))));
		}/* fatal error */
	sresult= cstatement;		/*  -- Now make it local */
/*  --	Do input stream maintenance. If there is stuff left in
	saiStatement, we must put it away for later extraction by
	the GET!NEXT!STATEMENT procedure */
	if ((*saistatement!='\0') &&(!ismacroflag))
		{/* save it for later */
		if (*line=='\0') line= saistatement; 
		else line= catlist(2L,GC_PUSHS(saistatement),GC_PUSHS(line));
GC_EPOPS(dbug(01000000L,catlist(3L,GC_PUSHS("[R!D!EXPR!MAP].2.3 NEW line=\'"),GC_PUSHS(line),
        GC_PUSHS("\'"))));
		}/* save it for later */
GC_EPOPS(dbug(01000000L,catlist(3L,GC_PUSHS("[R!D!EXPR!MAP].2.4 sResult=\'"),GC_PUSHS(sresult)
        ,GC_PUSHS("\'"))));
if (fast_equ(GC_PUSHS(sresult),GC_PUSHS(";"))) sresult= space;  	/*  -- make null statement to SPACE */
GC_EPOPS(dbug(01000000L,catlist(11L,GC_PUSHS("[R!D!EXPR!MAP].2.4.1 useFOLDINGflag=\'"),
        pbool(usefoldingflag),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" errLine[rdLevel]=\'"),GC_PUSHS(*aChkC(errline,1L,
        rdlevel)),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" errFSM[rdLevel]=\'"),GC_PUSHS(*aChkC(errfsm,1L,
        rdlevel)),GC_PUSHS("\'"))));
/* NO-OP */;
	if (usefoldingflag &&!chk_integer(GC_PUSHS(sresult))) 
		{/* maybe do R!D here too */
		push(GC_PUSHS(sinput)); push(GC_PUSHS(oldtoken));
		sresult= GC_EPOPS(fold_const_expr(GC_PUSHS(sresult)));
		pop(&oldtoken); pop(&sinput);
		}/* maybe do R!D here too */
if (usebacktraceflag) (*aChkC(errline,1L,rdlevel))= (*aChkC(errfsm,1L,rdlevel))= "@";  /*  -- cleanup for GC */
	--rdlevel;	/*  --  Level in Recursive Descent */
	popnumber(&revalflag); 	/*  -- Restore input status */
	pop(&saitoken);
	pop(&cstatement);	/*  -- Restore old output state */
	pop(&saistatement);	/*  -- Restore old input state */
	popnumber(&lastdeclaration);
/*  # # @V.53.78	POPNUMBER(emitEnableFlag) */
	}/* go eval it */
GC_EPOPS(dbug(01000000L,catlist(37L,GC_PUSHS("[R!D!EXPR!MAP].3 String sInput=\'"),
        GC_PUSHS(sinput),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" sResult=\'"),GC_PUSHS(sresult),
        GC_PUSHS("\' isFragmentFlag="),pbool(isfragmentflag),
        GC_PUSHS(crlf),GC_PUSHS(" sPDLptr="),cvs(spdlptr),
        GC_PUSHS(" nPDLptr="),cvs(npdlptr),GC_PUSHS(crlf),
        GC_PUSHS(" lastType=\'"),cvtypes(lasttype),GC_PUSHS(crlf),
        GC_PUSHS("  locIptr="),cvs(lociptr),GC_PUSHS(" locSptr="),
        cvs(locsptr),GC_PUSHS(" locAptr="),cvs(locaptr),GC_PUSHS(
        crlf),GC_PUSHS(" oldToken=\'"),GC_PUSHS(oldtoken),
        GC_PUSHS("\' oldTypeStatement=\'"),
        GC_PUSHS(oldtypestatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" saiStatement=\'"),GC_PUSHS(saistatement),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" line=\'"),
        GC_PUSHS(line),GC_PUSHS("\'"))));
GC_EPOPS(dbug(01000000L,catlist(3L,GC_PUSHS("[R!D!EXPR!MAP].3.1 sEmit=\'"),
				GC_PUSHS(semit),
				GC_PUSHS("\'"))));

GC_SRETURN(sresult)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'h'=<L0> integer                              */
/* 'brk'=<L0> integer                            */
/* 'token'=<L0> string                           */
/*************************************************/

}/* R!D!EXPR!MAP */
