/* FILE: readfile.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psinit.c, being converted 12/25/87, 01:41:42PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ----------------------------------------------------- */
/*INTERNAL*/  STRING readfile(filename)
	STRING filename;
/*  ----------------------------------------------------- */
{/* READFILE */
/*  --
.LABEL [<++PSAIL PROCEDURE: READFILE>]
.INDEX ++PSAIL PROCEDURE: READFILE
DESCRIPTION:
	Read the input file specified by 'fileName' returning the
string (less form-feeds) if it is found. If
	1) there is an open error return 
			'?OPEN DSK ERROR'
	2) If the file is not found return 
			'?FILE: <fileName> NOT FOUND'
NOTE: at NCI/IPS, we keep the files on DMS: not SYS: or DSK:. The
global variable usePSAILlibary contains the account name where these
are kept. It may be set through the switches by
	/PSAILlibrary:[50,752] etc.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: READFILE>]
 */
#define nciips2020 1L
STRING s, 
	s1, 
	dev, 
	file;
INTEGER chan, 
	brk, 
	err, 
	eof, 
	count;

;

GC_POPS(filename); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(filename); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(dev); /* for G.C. */
GC_NOTESTRING(file); /* for G.C. */
if (*usepsaillibrary=='\0') file= filename; 
else file= catlist(2L,GC_PUSHS(filename),GC_PUSHS(usepsaillibrary));
GC_EPOPS(dbug(01L,catlist(5L,GC_PUSHS("[READFILE] fileName=\'"),GC_PUSHS(filename),
        GC_PUSHS("\' file=\'"),GC_PUSHS(file),GC_PUSHS("\'"))));

PSopen((chan= PSgetchan()),GC_PUSHS((dev= "DSK")),0L,3L,0L,&(count= 3000),&brk,&eof);
if (eof) s= catlist(3L,GC_PUSHS("?OPEN \'"),GC_PUSHS(dev),GC_PUSHS("\' ERROR")); else	{/* OK, continue */
	lookup(chan,GC_PUSHS(file),&err);
/* IFC EVAL(nciips2020)=1 */
/* THENC */

/*  -- NOTE: we keep all shared files on DMS: i.e. [50,752]  */
	if (err)
		{/* try again */
		release(1L,chan);
		PSopen((chan= PSgetchan()),GC_PUSHS((dev= "DMS")),0L,3L,0L,&(count= 3000),
							&brk,&eof);
				 /*  -- NOTE: only have DMS: at NCI/IPS */
		if (eof) s= catlist(3L,GC_PUSHS("?OPEN \'"),GC_PUSHS(dev),GC_PUSHS("\' ERROR")); else lookup(chan,GC_PUSHS(filename),&err);
		}/* try again */
    /* ENDC */
	if (err) s= catlist(3L,GC_PUSHS("?FILE: \'"),GC_PUSHS(filename),
        GC_PUSHS("\' NOT FOUND.")); else	{/* suck in the file */
		s= "@";		/*  -- preface char */
		while (!eof) 
			{/* build string */
			s1= GC_EPOPS(input(chan,28L)); 	/*  -- copy string but
						trash FF */
			if (*s1!='\0') s= catlist(2L,GC_PUSHS(s),GC_PUSHS(s1));
			if (brk!='\0') s= catlist(2L,GC_PUSHS(s),makstr(brk));
			}/* build string */
		brk= LOP(s);		 /*  -- trash the '@' */
		}/* suck in the file */
	}/* OK, continue */

release(1L,chan);
/*  # # DBUG('1,"[READFILE].2 s='"&s&"'") */

;
GC_SRETURN(s)
#undef nciips2020
}/* READFILE */
