/* FILE: readtrash_graphics.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psinit.c, being converted 12/25/87, 01:41:42PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ----------------------------------------------------- */
/*INTERNAL*/  void readtrash_graphics(tg,filename)
	STRING *tg;
	STRING filename;
/*  ----------------------------------------------------- */
{/* READTRASH!GRAPHICS */
/*  --
.LABEL [<++PSAIL PROCEDURE: READTRASH!GRAPHICS>]
.INDEX ++PSAIL PROCEDURE: READTRASH!GRAPHICS
DESCRIPTION:
	Read the trash-graphic input file specified by 'fileName' and
put the trash graphics into String array tG[idx] where each trash
graphic in the file is specified by,
		<idx>:<name>
		 .... the trash graphic in several lines 
and <idx> is 0 to maxStatistics.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: READTRASH!GRAPHICS>]
 */

STRING s, 
	sdata, 
	g;
INTEGER newn, 
	n, 
	brk;

;

GC_EPOPS(dbug(01L,catlist(3L,GC_PUSHS("[READTRASH!GRAPHICS] fileName=\'"),
        GC_PUSHS(filename),GC_PUSHS("\'"))));
GC_POPS(filename); /* from GC string PDL */
GC_POPS(tg); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(tg); /* for G.C. */
GC_NOTESTRING(filename); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(sdata); /* for G.C. */
GC_NOTESTRING(g); /* for G.C. */
arrclr(tg,PNULL);	/*  -- Zero out the old TG for GC purposes */
sdata= GC_EPOPS(readfile(GC_PUSHS(filename)));	/*  -- the the mess */
if (*sdata=='?') 
	{/* file missing! */
	PSprintf("%s%s",GC_PUSHS(sdata),GC_PUSHS(crlf));	/*  -- sorry, we can't do it */
	;
	{GC_UNMARKSSTKFRAME;
	 GC_RETURN(s);}
	}/* file missing! */
g= "@";				/*  -- set null with preface character */
n= -1;				/*  -- set illegal number */
while (*sdata!='\0')
	{/* eat up the file in string sData */
	s= catlist(2L,scan(&sdata,1L,&brk) ,GC_PUSHS(crlf));
/*  # # DBUG('1,"[READTRASH!GRAPHICS].1 n="&CVS(n)&" g='"&g&"'"&CRLF&" s='"&s&"'") */
	if (isdigit((INTEGER)*s))
		{/* start of a new trash graphic */
		newn= cvd(GC_PUSHS(s));		/*  -- get trial new n */
/*  # # DBUG('1,"[READTRASH!GRAPHICS].2 newN="&CVS(newN)&" OLD n="&CVS(n)&" g='"&g&"'") */
		if ((0<=n && n<=35L))
			{/* save old graphic */
			brk= LOP(g);	/*  -- trash '@' */
			(*aChkC(tg,1L,n))= g;
			g= "@";
			}/* save old graphic */
		else if (!((INTEGER)*g==(INTEGER)'@')) usererr(0L,0L,
	catlist(9L,GC_PUSHS("[READTRASH!GRAPHIC] DRYROT - illegal n=\'"),
        cvs(n),GC_PUSHS(" in file \'"),GC_PUSHS(filename),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" g=\'"),GC_PUSHS(g),
        GC_PUSHS("\'")));
		n= newn;			/*  -- Use the new value of n */
		g= "@";			/*  -- clear it just in case... */
GC_EPOPS(dbug(01L,catlist(3L,GC_PUSHS("[READTRASH!GRAPHICS].3 New n=\'"),cvs(n),
        GC_PUSHS("\'"))));
		continue;
		}/* start of a new trash graphic */
	else g= catlist(2L,GC_PUSHS(g),GC_PUSHS(s));   		/*  -- just build current graphic */
	}/* eat up the file in string sData */

brk= LOP(g);				/*  -- trash the '@' */
/*  # # DBUG('1,"[READTRASH!GRAPHICS].4 n="&CVS(n)&" g='"&g&"'") */
if (*g!='\0') 
	{/* save the last one */
	if (!(0<=n && n<=35L)) usererr(0L,0L,
	catlist(5L,GC_PUSHS("[READTRASH!GRAPHIC] DRYROT - illegal n=\'"),
        cvs(n),GC_PUSHS(" in file \'"),GC_PUSHS(filename),
        GC_PUSHS("\'")));
	(*aChkC(tg,1L,n))= g;
	}/* save the last one */

;
{GC_UNMARKSSTKFRAME;}
}/* READTRASH!GRAPHICS */
