/* FILE: rem_symbols.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pssymt.c, being converted 12/25/87, 02:03:55PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING rem_symbols(startidx,endidx)
	INTEGER startidx;
	INTEGER endidx;
/*  ------------------------------------------------------- */
{/* REM!SYMBOLS */
/*  --
.LABEL [<++PSAIL PROCEDURE: REM!SYMBOLS>]
.INDEX ++PSAIL PROCEDURE: REM!SYMBOLS
DESCRIPTION:
	Remove symbols from the USER defined symbol table in the
range of indices specified. This will be changed when the new symtab
is fully implemented @V.48.23.
@V.53.84 - if we are leaving a non-global block (which had
blockLevel>1) then if there are any #define type symbols in the
block, then emit #undef for each of them (left justified, one/line).
This is to avoid problems with C compiles which do not remove them in
a block-structured way.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: REM!SYMBOLS>]
 */
INTEGER idx, 
	jdx, 
	h, 
	dw, 
	n, 
	i, 
	jdxrcd;
STRING token, 
	smsg, 
	s1, 
	s2, 
	sundef;
;

GC_EPOPS(dbug(20000000L,catlist(9L,GC_PUSHS("[REM!SYMBOLS] startIdx="),cvs(startidx),
        GC_PUSHS(" endIdx="),cvs(endidx),GC_PUSHS("  blockLevel="),
        cvs(blocklevel),GC_PUSHS(crlf),
        GC_PUSHS(" errStatistics[errNCLUTTER]="),
        cvs((*aChkI(errstatistics,1L,32L))))));

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(token); /* for G.C. */
GC_NOTESTRING(smsg); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(sundef); /* for G.C. */
sundef= smsg= "@";			/*  -- null preface */
n= 0;			/*  -- number of unused CLUTTER variables found */
for (idx=endidx;idx<=startidx;idx--)
	{/* free up the sucker */
	h= (*aChkI(declhash,1L,idx));
	token= (*aChkC(saisym,1L,h));
GC_EPOPS(dbug(20000000L,catlist(4L,GC_PUSHS("[REM!SYMBOLS].0.1 old symbol["),GC_PUSHS(token),
        GC_PUSHS("]="),prt_node(h))));
	dw= (*aChkI(decldw,1L,idx));
	if ((blocklevel>0) &&(dw&02000L) &&
	   (dw&01000L)==0)
		{/* Remove it from the target C compilers symtab */
		sundef= catlist(4L,GC_PUSHS(sundef),GC_PUSHS("#undef "),GC_PUSHS(token),
        GC_PUSHS(crlf));
		}/* Remove it from the target C compilers symtab */
	if (useclutterflag &&(dw&02000000L) &&
	   (!slobflag))
		{/* sucker is CLUTTER... */
		++n;
		dw=dw&0777770275433L; 
				/*  -- do not include these since just
				makes printout messy and doesnt add
				much */
		s1= catlist(4L,GC_PUSHS("\'"),GC_PUSHS(token),GC_PUSHS("\'="),cvtypes(dw));
		{/* INCSTAT */ if (usereportflag) (*aChkI(errstatistics,1L,32L))= (*aChkI(errstatistics,1L,32L))+1L;
		     }/* INCSTAT */		/*  -- for /REPORT */
		if (n==1) smsg= 
        	catlist(GC_PUSHS(
        "@       U N U S E D    D E C L A R A T I O N S"),
        GC_PUSHS(crlf),GC_PUSHS(s1)); else smsg= catlist(3L,GC_PUSHS(smsg),GC_PUSHS(crlf),GC_PUSHS(s1));
/*  # # DBUG(20000000,"[REM!SYMBOLS].1 token='"&token&"' n="&CVS(n)&" errStatistics[errNCLUTTER]="&CVS(errStatistics[errNCLUTTER])&CRLF&"  dw='"&CVTYPES(dw)&"'"&CRLF&"  sMsg='"&sMsg&"'") */
		}/* sucker is CLUTTER... */
	else	{/* token is NOT clutter */
/*  # # DBUG(20000000,"[REM!SYMBOLS].1.1 Not clutter token='"&token&"'") */
		}/* token is NOT clutter */

	(*aChkI(declblklvl,1L,idx))= (INTEGER)*((*aChkC(declcsym,1L,idx))= GC_EPOPS(makstr((*aChkI(declfsm,1L,idx))= (*aChkI(declnargs,1L,idx))= (*aChkI(declblklvl,1L,idx))= (INTEGER)*((*aChkC(declformal,1L,idx))= "\000"))));
	if (!uniqflag) (*aChkI(declhash,1L,idx))= (*aChkI(declinproc,1L,idx))= (*aChkI(decldw,1L,idx))= (INTEGER)*((*aChkC(declsize,1L,idx))= "\000");    /*  -- need it for /UNIQUE */
/*  # # DBUG(20000000,"[REM!SYMBOLS].1.2 after DEL ["&token&"]="&PRT!NODE(h)) */

	/*  -- Do search for NEXT one which is not a RECORD!MEMBER if
	there is another symbol further on with the same name */

/*   --	Search the symbol table (declHash[idx]) in reverse for the
specified user token. If the instance found is a RECORD!MEMBER then
remember the instance and keep looking. If nothing else is found the
use the RECORD!MEMBER instance. If nothing is found then return 0.
Otherwise, return index into saiSym[declHash[i]] where the match
occured.

!!!  @V.49.84 LATER - change this HOG to a linked-list coded scheme. !!!

NOTE: @V.48.-- Symbols were put into the bottom part of the table in
assending order of block structure. I.e. the most local symbols in
the current block are at the end of the table.

			   -----------------
	0----------------->|		   |
			   |  <block 0>    |   i.e. Builtin symbols
	dclSymPtr blk 0--->-----------------
			   |  <block 1>    |
	dclSymPtr blk 1--->-----------------
			   |  <block 2>    |
	dclSymPtr blk 2--->-----------------
			   |  <block 3>    |
			   -----------------
				. . .
	dclSymPtr blk n--->-----------------
			   |  <free>       |
				. . .
	maxSymbols-------->-----------------

 */

/*  --	Note: symbols have highest block level at end of list */

	jdx= 0;		/*  -- Default is no match */
	jdxrcd= 0;	/*  -- Default is no RECORD!MEMBER symbol idx */

	for (i=dclsymptr;i<=1;i--)
		if (*((s2= (*aChkC(saisym,1L,(*aChkI(declhash,1L,i))))))==*token&&equ(GC_PUSHS(token),GC_PUSHS(s2)))
			{/* found it */
			jdx= i;
			if ((*aChkI(decldw,1L,i))&01000000L)
				{/* Found REC!MEM keep searching */
				if (jdxrcd==0) jdxrcd= i;
						   /*  -- Save 1st found */
				}/* Found REC!MEM keep searching */
			else break;
			}/* found it */

	if ((jdx==0) &&(jdxrcd!=0)) jdx= jdxrcd;     /*  -- use RECORD!MEMBER if nothing
					else was found */
GC_EPOPS(dbug(20000000L,catlist(4L,GC_PUSHS("[REM!SYMBOLS].1.3 token=\'"),GC_PUSHS(token),
        GC_PUSHS("\' jdx="),cvs(jdx))));

	if (jdx==0)
		{/* OK, now trash the symbol from hash table */
		/*  -- NOTE: we ONLY do this IFF there are no more
		  -- entries in the symbol table */
		(*aChkI(dwptr,1L,h))= 0;
		(*aChkC(saisym,1L,h))= "\007";		/*  -- BELL denotes deleted symbol
				so that we can:
				1) use this space over again if ever do
				   a PUT!HASH!C() call,
				2) enables us to keep seaching if 
				   looking for a symbol using HASH!C()
				 */
/*  # # DBUG(20000000,"[REM!SYMBOLS].2 new symbol for '"&token&"' is NULL!") */
		}/* OK, now trash the symbol from hash table */
	else 	{/* ok - replace it with older symbol */
		(*aChkI(dwptr,1L,h))= jdx;    /*  -- just backup symbol to previously
				defined one */
/*  # # DBUG(20000000,"[REM!SYMBOLS].2.1 new visible symbol["&token&"]="&PRT!NODE(h)) */
	}/* ok - replace it with older symbol */
	}/* free up the sucker */

jdx= LOP(smsg);				/*  -- trash the '@' */
s1= PNULL;
if (*smsg!='\0') err_deathwish(&s1,GC_PUSHS(smsg),2L,0L);

GC_EPOPS(dbug(20000000L,catlist(6L,GC_PUSHS("[REM!SYMBOLS].3 errStatistics[errNCLUTTER]="),
        cvs((*aChkI(errstatistics,1L,32L))),GC_PUSHS(crlf),
        GC_PUSHS(" sUndef=\'"),GC_PUSHS(sundef),GC_PUSHS("\'"))));

jdx= LOP(sundef);			/*  -- trash the '@" */
if (*sundef!='\0') 
	{/* add it on */
	if (*s1=='\0') s1= sundef; 
	else s1= catlist(3L,GC_PUSHS(s1),GC_PUSHS(crlf),GC_PUSHS(sundef));	/*  -- must be on new line */
	}/* add it on */
;
	GC_SRETURN(s1)
}/* REM!SYMBOLS */

