/* FILE: rightexpr.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pslex.c, being converted 12/25/87, 08:38:10PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING rightexpr(sinput)
	STRING *sinput;
/*  ------------------------------------------------------- */
{/* RIGHTEXPR */
/*  --
.LABEL [<++PSAIL PROCEDURE: RIGHTEXPR>]
.INDEX ++PSAIL PROCEDURE: RIGHTEXPR
DESCRIPTION:
	Scan REFERENCE string 'sI' left-to-the right for a 
previously CVEVALUATEd SUB-expression which is then returned.

Note 'sI' is shortened.
NOTE: the break character is returned in the FIRST char of sI.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: RIGHTEXPR>]
 */
INTEGER h, 
	i, 
	j, 
	k, 
	ch, 
	lastch, 
	brktcnt, 
	parencnt,
	squigglecnt, 
	doexitchk;
STRING b, 
	s, 
	s1, 
	token, 
	si, 
	t;

/* IFC EVAL(is_sail)=0 */
 /* THENC <<<FAILED!!!>>>

define backup_tok(tok)=\Begin If sI=NULL 
				Then sI_tok Else sI_tok & sI; End\;
  */ /* ENDC */

/* IFC EVAL(is_psail)=1 */
/* THENC */

#define backup_tok(tok) {if (*si=='\0') si= tok;  else si= catlist(2L,GC_PUSHS(tok),GC_PUSHS(si)); }
  /* ENDC */ /*  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

;

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(sinput); /* for G.C. */
GC_NOTESTRING(b); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(token); /* for G.C. */
GC_NOTESTRING(si); /* for G.C. */
GC_NOTESTRING(t); /* for G.C. */
si= *sinput;
GC_EPOPS(dbug(04000L,catlist(4L,GC_PUSHS("[RIGHTEXPR] sI=\'"),GC_PUSHS(si),
        GC_PUSHS("\' |sI|="),cvs(length(GC_PUSHS(si))))));
/* NO-OP */;

if ((*si=='\0'))
	{/* Something funny, return NULL */
GC_EPOPS(dbug(04000L,GC_PUSHS("[RIGHTEXPR].0.1 sI is NULL!!!")));
;
	{GC_UNMARKSSTKFRAME;
	 GC_SRETURN("0 comment <NULL-EXPR>;");}
	}/* Something funny, return NULL */

/*  --	[1] Scan to the RIGHT sI to get expression 'b' */
b= "@";			/*  -- string we are building, the @ is a dummy */
lastch= ch= (INTEGER)'\0';
brktcnt= 0;
parencnt= 0;
squigglecnt= 0;
while ((*si!='\0') &&iswhitespace((INTEGER)*si)) ps_itrash_= LOP(si);
/*  # # DBUG('4000,"[RIGHTEXPR].1 after TRASH!LEFT!WS b='"&b&"' |b|="&CVS(LENGTH(b))&CRLF&"  sI='"&sI&"' |sI|="&CVS(LENGTH(sI))) */

lastch= (INTEGER)'\0';
while ((*si!='\0') ||(lastch!='\0')) 
	{/* Make b expression */
	if (lastch!='\0')
		{/* use last ch */
		token= GC_EPOPS(makstr(lastch));
		lastch= (INTEGER)'\0';
		}/* use last ch */

	else 	{/* scan new token */
		if (*si!='\0')
			{/* copy over the white space */
			/*  --- Sorry, we have to cludge this since
			  MAP!WS!STATEMENT sucks stuff from the input
			  stream if we let it... In any case it
			  looks at 'saiStatement' so we have to
			  also fake out 'saiStatement' for now... */
			s= saistatement; saistatement= si; /*  -- scan sI  */
			pushnumber(ismacroflag); ismacroflag= 1L;
			pushnumber(isfragmentflag);
						/*  -- This disables 
						  GET!NEXT!STATEMENT */
			GC_EPOPS(map_ws_comments(&b,1L));    /*  -- DON'T map 
						     SAIL comments! */
			popnumber(&isfragmentflag);
			popnumber(&ismacroflag);
			si= saistatement; saistatement= s;  /*  -- RESTORE
							saiStatement */
/*  # # DBUG('4000,"[RIGHTEXPR].1.1 sI='"&sI&"'"&CRLF&"  sInput='"&sInput&"'"&CRLF&"  saiStatement='"&saiStatement&"'"&CRLF&"  isFRAGMENTflag="&PBOOL(isFRAGMENTflag)) */
			}/* copy over the white space */

		token= GC_EPOPS(getid(&si,&lastch));  	/*  -- get token by hook
						 or crook */
		if (*token=='\0')
			{/* use break char for token */
			token= GC_EPOPS(makstr(lastch));
			lastch= (INTEGER)'\0';
			if (*token=='\0') break;   	/*  -- if still NULL
						then exit */
			}/* use break char for token */
		}/* scan new token */

	doexitchk= ((brktcnt<=0) &&(parencnt<=0) &&
			(squigglecnt<=0));   	/*  -- enable test
							 for exit */
/*  # # DBUG('4000,"[RIGHTEXPR].2 token='"&token&"' b='"&b&"' lastCh='"&(t_lastCh)&"' doExitChk="&PBOOL(doExitChk)&CRLF&"  parenCnt="&CVS(parenCnt)&" brktCnt="&CVS(brktCnt)&" squiggleCnt="&CVS(squiggleCnt)&" sI='"&sI&"'") */

	if (doexitchk &&isalpha(GC_PUSHS(token))) 
		{/* check expression terminator */
		h= hash_c(GC_PUSHS(token));	/*  -- hash it for speedup */
		if (h==hend||h==helse ||h==hand ||h==hor) 
			{/* Finished */
			if (lastch!='\0') token= catlist(2L,GC_PUSHS(token),makstr(lastch));  /*  -- backup */
			GC_EPOPS(backup_tok(GC_PUSHS(token)));
			break;				/*  -- finished */
			}/* Finished */
		b= catlist(2L,GC_PUSHS(b),GC_PUSHS(token));
		if (h==hlisto) ++parencnt; else if (h==hlistc) --parencnt; else if (h==hseto) ++parencnt; else if (h==hsetc) --parencnt;
		}/* check expression terminator */

	else if ((*token==';'||*token==',') &&doexitchk) 
		{/* finished */
		GC_EPOPS(backup_tok(GC_PUSHS(token)));
		break;
		}/* finished */

	else if (*token==*singlequote)
		{/* single quote */
		if (isoctal((INTEGER)*si)) token= "0"; 
		else err_hlr(GC_PUSHS(

        			catlist(GC_PUSHS(
        "[RIGHTEXPR] DRYROT - found C single quote (\') in SAIL input string,")
        ,GC_PUSHS(crlf),GC_PUSHS(" \'"),GC_PUSHS(*sinput),
        GC_PUSHS("\'"))));
		b= catlist(2L,GC_PUSHS(b),GC_PUSHS(token));
/*  # # @V.50.88	If sI = "\"
# # # @V.50.88		Then b_b & LOP(sI) & LOP(sI) */  /*  -- Get past 
# # # @V.50.88					possible '\'' case! */
/*  # # @V.50.88	Do b_b & (ch_LOP(sI)) 
# # # @V.50.88	Until ch=singleQuote Or sI=NULL */  /*  -- copy rest of it */
		}/* single quote */

	else if (*token==*quote)
		{/* Suck a quoted string */
		pushnumber(iscopy_toflag); iscopy_toflag= 1L;
		b= catlist(2L,GC_PUSHS(b),map_quotes(&si));		/*  -- suck quote */
		popnumber(&iscopy_toflag);
		}/* Suck a quoted string */

	 else if (*token==')') 
		{/* end of expression */
		if (((--parencnt)<0) &&(brktcnt<=0) &&
			 (squigglecnt<=0) &&(*si!='(')) 
				{/* finished */
				GC_EPOPS(backup_tok(GC_PUSHS(token)));   /*  -- put it back */
				break;
				}/* finished */
		else b= catlist(2L,GC_PUSHS(b),GC_PUSHS(token));
		}/* end of expression */

	 else if (*token=='(')
		{/* Begin of expression */
		++parencnt;
		b= catlist(2L,GC_PUSHS(b),GC_PUSHS(token));
		}/* Begin of expression */

	 else if (*token=='[') 
		{/* Begin of array */
		++brktcnt;
		b= catlist(2L,GC_PUSHS(b),GC_PUSHS(token));
		}/* Begin of array */

	 else if (*token==']') 
		{/* end of array */
		if (((--brktcnt)<0) &&
		   (squigglecnt<=0) &&(parencnt<=0)) 
			{/* finished */
			GC_EPOPS(backup_tok(GC_PUSHS(token)));  	/*  -- put it back */
			break;
			}/* finished */
		else b= catlist(2L,GC_PUSHS(b),GC_PUSHS(token));
		}/* end of array */

	 else if (*token=='{') 
		{/* Begin of squiggle bracket */
		++squigglecnt;
		b= catlist(2L,GC_PUSHS(b),GC_PUSHS(token));
		}/* Begin of squiggle bracket */

	 else if (*token=='}') 
		{/* end of squiggle bracket */
		if (((--squigglecnt)<0) &&
			 (parencnt<=0) &&(brktcnt<=0)) 
			{/* finished */
			GC_EPOPS(backup_tok(GC_PUSHS(token)));	/*  -- put it back */
			break;
			}/* finished */
		else b= catlist(2L,GC_PUSHS(b),GC_PUSHS(token));
		}/* end of squiggle bracket */

	 else b= catlist(2L,GC_PUSHS(b),GC_PUSHS(token));	/*  -- just build expression string */

/*  # # DBUG('4000,"[RIGHTEXPR].3 b='"&b&"' |b|="&CVS(LENGTH(b))&CRLF&"  sI='"&sI&"' |sI|="&CVS(LENGTH(sI))&CRLF&"  parenCnt="&CVS(parenCnt)&" brktCnt="&CVS(brktCnt)&" squiggleCnt="&CVS(squiggleCnt)) */
	}/* Make b expression */

/*  # # DBUG('4000,"[RIGHTEXPR].4 b='"&b&"' |b|="&CVS(LENGTH(b))&CRLF&"  sI='"&sI&"' |sI|="&CVS(LENGTH(sI))) */
/* NO-OP */;
/* NO-OP */;

while (((ch= (*(b+length(b)-1)))!='@') &&iswhitespace(ch))
	{/* push back whitespace */
	if (*si=='\0') si= GC_EPOPS(makstr(ch 
	)); else si= catlist(2L,makstr(ch),GC_PUSHS(si));    		/*  -- push W.S. back */
	if ((ch!='@') ||(length(GC_PUSHS(b))>1)) b= subst(GC_PUSHS(b),1L,length(b)-1L);  	/*  -- shorten b */
	}/* push back whitespace */
ch= LOP(b);			/*  -- trash the '@' in front of string */

GC_EPOPS(dbug(04000L,catlist(12L,GC_PUSHS("[RIGHTEXPR].5 b=\'"),GC_PUSHS(b),
        GC_PUSHS("\' |b|="),cvs(length(GC_PUSHS(b))),GC_PUSHS(crlf),
        GC_PUSHS("  sI=\'"),GC_PUSHS(si),GC_PUSHS("\' |sI|="),
        cvs(length(GC_PUSHS(si))),GC_PUSHS(crlf),
        GC_PUSHS("  isFRAGMENTflag="),pbool(isfragmentflag))));
/* NO-OP */;
/* NO-OP */;
*sinput= si;			/*  -- Return remainder of the string */
if ((*b=='\0') &&(*(*sinput)!='\0')) err_hlr(GC_PUSHS(
	catlist(3L,GC_PUSHS("[RIGHTEXPR] Ill-formed <right-expr> in \'"),
	        GC_PUSHS(*sinput),GC_PUSHS("\'."))));

;
GC_SRETURN(b)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 't'=<L0> string                               */
/* 's1'=<L0> string                              */
/* 'k'=<L0> integer                              */
/* 'j'=<L0> integer                              */
/* 'i'=<L0> integer                              */
/*************************************************/

#undef backup_tok
}/* RIGHTEXPR */
