/* FILE: rightid.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pslex.c, being converted 12/25/87, 08:38:10PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING rightid(si)
	STRING *si;
/*  ------------------------------------------------------- */
{/* RIGHTID */
/*  --
.LABEL [<++PSAIL PROCEDURE: RIGHTID>]
.INDEX ++PSAIL PROCEDURE: RIGHTID
DESCRIPTION:
	Scan string sI left-to-right to pick up an identifier and
return that expression as well as shortening the string in REFERENCE
variable sI. If there are '[]' then suck that in as well. NOTE: if
there is [], then CHK!ID(...) will NOT be true!

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: RIGHTID>]
 */
INTEGER ch, 
	brktcnt;
STRING rid, 
	s1, 
	s2, 
	ws;

;

GC_EPOPS(dbug(04000L,catlist(3L,GC_PUSHS("[RIGHTID] sI=\'"),GC_PUSHS(*si),GC_PUSHS("\'"))));
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(si); /* for G.C. */
GC_NOTESTRING(rid); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(ws); /* for G.C. */
ws= PNULL;
pushnumber(ismacroflag); ismacroflag= 1L;  /*  -- so no read ahead */
s1= saistatement; saistatement= *si;	/*  -- fake it out */
GC_EPOPS(map_ws_comments(&ws,1L));		/*  -- trash the comment if any */
s2= saistatement;			/*  -- get reduced string */
saistatement= s1;			/*  -- restore it */
*si= s2;					/*  -- now save reduced string */
popnumber(&ismacroflag);
GC_EPOPS(dbug(04000L,catlist(3L,GC_PUSHS("[RIGHTID].0.1 sI=\'"),GC_PUSHS(*si),GC_PUSHS("\'"))));

/*  # # @V.53.50 If (sI=singleQuote)
# # # @V.53.50	Then
# # # @V.53.50	Begin "process '.' "
# # # @V.53.50	rID_sI[1 for 3] */
/*  # # @V.53.50	sI_sI[4 to inf] */
/*  # # @V.53.50	End "process '.' "

Else  COMMENT -- SHOULD NEVER BE NEEDED since parsing SAIL <rExpr> */
	if ((*(*si)==*quote))
	{/* process quote */
	rid= *si;
	*si= PNULL;
	}/* process quote */
else if (isdigit((INTEGER)*(*si)) ||*(*si)=='.') 
	{/* get <number> */
	rid= GC_EPOPS(get_number(si));		/*  -- parse <number> */
	}/* get <number> */

else 	{/* get alphanum token */
	rid= GC_EPOPS(get_token(si)); /*get single variable*/
	}/* get alphanum token */
/*  # # DBUG('4000,"[RIGHTID].1 rID='"&rID&"' sI='"&sI&"'") */

if (*(*si)=='[')
	{/* Complex */
/*  # # DBUG('4000,"[RIGHTID].2 rID='"&rID&"' sI='"&sI&"'") */
	rid= catlist(2L,GC_PUSHS(rid),GC_PUSHS(LOP(*si)));	 /*  -- get initial '['  */
	brktcnt= 1;
	while ((*(*si)!='\0') &&brktcnt>0)
		{/* balanced '[]' */
/*  # # @V.45.91 WATCH OUT FOR "]" case... */
		rid= catlist(2L,GC_PUSHS(rid),scan(si,36L,&ch));   /*  -- SCAN for '[ ]' */
		if (ch=='[') ++brktcnt; else if (ch==']') --brktcnt;
		}/* balanced '[]' */
/*  # # DBUG('4000,"[RIGHTID].2.1 rID='"&rID&"' sI='"&sI&"'") */
	}/* Complex */

/*  # # DBUG('4000,"[RIGHTID].3 rID='"&rID&"' sI='"&sI&"'") */

;
GC_SRETURN(rid)
}/* RIGHTID */

