/* FILE: rightstatement.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pslex.c, being converted 12/25/87, 08:38:10PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------------- */
/*INTERNAL*/  STRING rightstatement()
/*  ------------------------------------------------------- */
{/* RIGHTSTATEMENT */
/*  --
.LABEL [<++PSAIL PROCEDURE: RIGHTSTATEMENT>]
.INDEX ++PSAIL PROCEDURE: RIGHTSTATEMENT
DESCRIPTION:
	Scan saiStatement for a complete SAIL statement. Return that
statement as well as shortening saiStatement accordingly. Read
additional input from the file if not evaling a MACRO - independent
of recursion level!. Critical SAIL control structure key words are
used to enable sub-FSMs in this scanner.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: RIGHTSTATEMENT>]
 */
INTEGER ch, 
	brk, 
	h, 
	cnt;
STRING rstatement, 
	s, 
	s1, 
	s2, 
	brkstr, 
	token, 
	rightdelim;

/* NEW SAIL MACRO DELIMITERS=[\\\\] */

/* IFC EVAL(is_sail)=0 */
 /* THENC <<<FAILED!!!>>>

define get_this_token(x)=\ Begin
	MAP!WHITESPACE(rStatement);   # -- Snuggle upto non-NULL stuff;
	If saiStatement=NULL And Not isMacroFlag And (rdLevel<1)
		Then GET!NEXT!STATEMENT;  # -- Don't want null input;
	If saiStatement=NULL
		Then 
		Begin "error"
		If (rdLevel<1)
			Then
			ERR!HLR(
		"[RIGHTSTATEMENT] can not find end of SAIL statement!");
		Done;
		End "error";
	x_GET!TOKEN(saiStatement);
	End\;
  */ /* ENDC */

/* IFC EVAL(is_psail)=1 */
/* THENC */

#define get_this_token(x) {map_whitespace(&rstatement);   /*  -- snuggle upto non-null stuff */\
	if (*saistatement=='\0'&&!ismacroflag &&(rdlevel<1)) get_next_statement();   /*  -- don0t want null input */\
	if (*saistatement=='\0') \
		{"error"\
		if ((rdlevel<1))\
			err_hlr(GC_PUSHS(\
		"[RIGHTSTATEMENT] can not find end of SAIL statement!"));\
		break;\
		}/* error */\
	x= GC_EPOPS(get_token(&saistatement));\
	}
  /* ENDC */ /*  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

;

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(rstatement); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(brkstr); /* for G.C. */
GC_NOTESTRING(token); /* for G.C. */
GC_NOTESTRING(rightdelim); /* for G.C. */
(*aChkI(spdlcheck,1L,rdlevel+rrlevel+1L))= spdlptr;	/*  -- Save String ptr for check */
(*aChkI(npdlcheck,1L,rdlevel+rrlevel+1L))= npdlptr;	/*  -- Save NUMBER ptr for check */
++rrlevel;	/*  -- Recursive descent level starting at 1 */
GC_EPOPS(dbug(010L,catlist(16L,GC_PUSHS("{"),cvs(rrlevel),
        GC_PUSHS("}[RIGHTSTATEMENT] saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  line=\'"),GC_PUSHS(line),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS("  isMACROflag="),pbool(ismacroflag)
        ,GC_PUSHS(" rdLevel="),cvs(rdlevel),GC_PUSHS(" rrLevel="),
        cvs(rrlevel))));

if ((*line!='\0') &&(!ismacroflag) &&(rdlevel<1) &&(rrlevel==1))
	{/* copy line==>saiStatement */
	if (*saistatement=='\0') saistatement= line; 
	else saistatement= catlist(2L,GC_PUSHS(saistatement),GC_PUSHS(line));
	line= PNULL;
GC_EPOPS(dbug(010L,catlist(5L,GC_PUSHS("{"),cvs(rrlevel),
        GC_PUSHS("}[RIGHTSTATEMENT].0.1 saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"))));
	}/* copy line==>saiStatement */

rstatement= PNULL;
pushnumber(isrightstatementflag);
if (!ismacroflag) isrightstatementflag= 1L;
pushnumber(cnt); cnt= 0;		/*  -- number of tokens process/level */

while (1L)
   {/* munch it up to end of SAIL statement */
   ++cnt;	/*  -- number of tokens processed at this level */
   map_whitespace(&rstatement);
/*  # # DBUG('10,"{"&CVS(rrLevel)&"}[RIGHTSTATEMENT].1 cnt="&CVS(cnt)&CRLF&"  saiStatement='"&saiStatement&"'"&CRLF&"  rStatement='"&rStatement&"'") */
   GC_EPOPS(get_this_token(GC_PUSHS(token)));
   h= hash_c(GC_PUSHS(token));
/*  # # DBUG('10,"{"&CVS(rrLevel)&"}[RIGHTSTATEMENT].2 token='"&token&"' h='"&CVS(h)&"'") */
   if (*rstatement=='\0') rstatement= token; 
	else rstatement= catlist(2L,GC_PUSHS(rstatement),GC_PUSHS(token));

if (((*aChkI(decldw,1L,(*aChkI(dwptr,1L,h))))&0100L)==0)
	{/* Is not keyword - just copy it */
/*  # # DBUG('10,"{"&CVS(rrLevel)&"}[RIGHTSTATEMENT].2.0.1 rStatement='"&rStatement&"'"&CRLF&"  saiStatement='"&saiStatement&"'") */
	continue;
	}/* Is not keyword - just copy it */

else    if (h==hleftparen||h==hleftbracket ||h==hleftsquiggle)
	{/* Suck in ([{...}]) */
	if (h==hleftparen) rightdelim= ")"; 
	else if (h==hleftbracket) rightdelim= "]"; 
		else rightdelim= "}";
	rstatement= catlist(2L,GC_PUSHS(rstatement),copy_either(GC_PUSHS(rightdelim),
        &brkstr));
	rstatement= catlist(2L,GC_PUSHS(rstatement),GC_PUSHS(brkstr));
	continue;   		/*  -- look for terminator */
	}/* Suck in ([{...}]) */

   else if (h==hif)
	{/* suck in IF...THEN...ELSE statement */
/* 	NOTE: the ELSE must go with this IF if exists */
	rstatement= catlist(2L,GC_PUSHS(rstatement),copy_either(GC_PUSHS("then"),&brkstr));
	rstatement= catlist(2L,GC_PUSHS(rstatement),GC_PUSHS(brkstr));
/*  # # DBUG('10,"{"&CVS(rrLevel)&"}[RIGHTSTATEMENT].2.1 rStatement='"&rStatement&"'"&CRLF&"  saiStatement='"&saiStatement&"'") */
	push(GC_PUSHS(rstatement));
	s= GC_EPOPS(rightstatement());	/*  -- get the <THEN-statement> */
	pop(&rstatement);
	rstatement= catlist(2L,GC_PUSHS(rstatement),GC_PUSHS(s));
	if ((*saistatement!='\0'))
		{/* Check for the ELSE part */
		GC_EPOPS(get_this_token(GC_PUSHS(s))); 	/*  -- check for ELSE part */
		h= hash_c(GC_PUSHS(s));
		if (h==hcomment)
			{/* suck in comment */
			rstatement= catlist(3L,GC_PUSHS(rstatement),GC_PUSHS(s),scan(&saistatement,10L,&h)); /*;*/
			GC_EPOPS(get_this_token(GC_PUSHS(s)));
			h= hash_c(GC_PUSHS(s));
			}/* suck in comment */
/*  # # DBUG('10,"{"&CVS(rrLevel)&"}[RIGHTSTATEMENT].2.2 rStatement='"&rStatement&"'"&CRLF&"  s='"&s&"' saiStatement='"&saiStatement&"'") */
		if (h==helse)
			{/* get the ELSE part too */
			rstatement= catlist(2L,GC_PUSHS(rstatement),GC_PUSHS(s));
			push(GC_PUSHS(rstatement));
			s= GC_EPOPS(rightstatement());  /*  -- get <ELSE-statement> */
			pop(&rstatement);
			rstatement= catlist(2L,GC_PUSHS(rstatement),GC_PUSHS(s));
			}/* get the ELSE part too */
		else saistatement= catlist(2L,GC_PUSHS(s),GC_PUSHS(saistatement)); /*No, push it back*/
/*  # # DBUG('10,"{"&CVS(rrLevel)&"}[RIGHTSTATEMENT].2.2.1 rStatement='"&rStatement&"'"&CRLF&"  s='"&s&"' saiStatement='"&saiStatement&"'") */
		}/* Check for the ELSE part */
	}/* suck in IF...THEN...ELSE statement */

   else if (h==helse)
	{/* suck in ELSE statement */
/*  # # DBUG('10,"{"&CVS(rrLevel)&"}[RIGHTSTATEMENT].2.3 ELSE  cnt="&CVS(cnt)&CRLF&"  rStatement='"&rStatement&"'"&CRLF&"  saiStatement='"&saiStatement&"'") */
	if (cnt==1)
		{/* do ELSE statement */
		push(GC_PUSHS(rstatement));
		s= GC_EPOPS(rightstatement());
		pop(&rstatement);
		rstatement= catlist(2L,GC_PUSHS(rstatement),GC_PUSHS(s));
		}/* do ELSE statement */
	else	{/* DON'T process ELSE - backup! */
		saistatement= catlist(2L,GC_PUSHS(token),GC_PUSHS(saistatement));
		rstatement= subst(GC_PUSHS(rstatement),1L,length(rstatement)-4L);
		}/* DON'T process ELSE - backup! */
	}/* suck in ELSE statement */

   else if (h==hcase)
	{/* suck in CASE statement */
	rstatement= catlist(3L,GC_PUSHS(rstatement),copy_omit(GC_PUSHS("of")),GC_PUSHS(
        "of"));
	GC_EPOPS(map_ws_comments(&rstatement,1L));  /*  -- Don't map SAIL comments */
/*  # # DBUG('10,"{"&CVS(rrLevel)&"}[RIGHTSTATEMENT].2.3.1 CASE rStatement='"&rStatement&"'"&CRLF&"  saiStatement='"&saiStatement&"'") */
	push(GC_PUSHS(rstatement));
	s= GC_EPOPS(rightstatement());
	pop(&rstatement);
	rstatement= catlist(2L,GC_PUSHS(rstatement),GC_PUSHS(s));
	}/* suck in CASE statement */

   else if (h==hdo)
	{/* suck in DO statement */
	rstatement= catlist(3L,GC_PUSHS(rstatement),copy_omit(GC_PUSHS("until")),
        GC_PUSHS("until"));
	rstatement= catlist(2L,GC_PUSHS(rstatement),copy_either(GC_PUSHS(";,end,else"),
        &brkstr));
	rstatement= catlist(2L,GC_PUSHS(rstatement),GC_PUSHS(brkstr));
	}/* suck in DO statement */

   else if (h==hfor||h==hforeach)
	{/* suck in FOR statement */
	rstatement= catlist(2L,GC_PUSHS(rstatement),copy_either(GC_PUSHS("do"),&brkstr));
	rstatement= catlist(2L,GC_PUSHS(rstatement),GC_PUSHS(brkstr));
	push(GC_PUSHS(rstatement));
	s= GC_EPOPS(rightstatement());
	pop(&rstatement);
	rstatement= catlist(2L,GC_PUSHS(rstatement),GC_PUSHS(s));
	}/* suck in FOR statement */

   else if (h==hifc)
	{/* suck in IFC statement */
 GC_EPOPS(dbug(010L,catlist(9L,GC_PUSHS("{"),cvs(rrlevel),
        GC_PUSHS("}[RIGHTSTATEMENT].2.3.2 IFC rStatement=\'"),
        GC_PUSHS(rstatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  saiStatement=\'"),GC_PUSHS(saistatement),
        GC_PUSHS("\'"))));
	pushnumber(iscopy_toflag); iscopy_toflag= 1L;  /*  -- Don't EXPAND */
	saistatement= catlist(2L,GC_PUSHS("\7ifc"),GC_PUSHS(saistatement)); /*  -- prep with phoney
				'IFC' which is needed by COPY!EITHER
				to keep track of the ifcLevel properly.
				It will trash the BELL&IFC */
	rstatement= catlist(2L,GC_PUSHS(rstatement),copy_either(GC_PUSHS("endc"),&brkstr));
	popnumber(&iscopy_toflag);
	rstatement= catlist(2L,GC_PUSHS(rstatement),GC_PUSHS(brkstr));
GC_EPOPS(dbug(010L,catlist(9L,GC_PUSHS("{"),cvs(rrlevel),
        GC_PUSHS("}[RIGHTSTATEMENT].2.3.2.1 after IFC rStatement=\'")
        ,GC_PUSHS(rstatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  saiStatement=\'"),GC_PUSHS(saistatement),
        GC_PUSHS("\'"))));
	}/* suck in IFC statement */

   else if (h==hbegin||h==hstart_code ||h==hquick_code ||h==hc_code)
	{/* suck in BEGIN/END statement */
	saistatement= catlist(2L,GC_PUSHS(token),GC_PUSHS(saistatement)); /*put back*/
	rstatement= subst(GC_PUSHS(rstatement),1L,length(rstatement)-length(GC_PUSHS(token)));
/*  # # DBUG('10,"{"&CVS(rrLevel)&"}[RIGHTSTATEMENT].2.4 BEGIN token='"&token&CRLF&"' rStatement='"&rStatement&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
	rstatement= catlist(3L,GC_PUSHS(rstatement),copy_omit(GC_PUSHS("end")),
        GC_PUSHS("end"));
/*  # # DBUG('10,"{"&CVS(rrLevel)&"}[RIGHTSTATEMENT].2.4.1 BEGIN brkStr='"&brkStr&CRLF&"' rStatement='"&rStatement&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
	map_whitespace(&rstatement);
	if (*saistatement==*quote)
		{/* get block quoted label */
		token= GC_EPOPS(makstr(LOP(saistatement))); 		/*  -- remove it */
		pushnumber(iscopy_toflag); iscopy_toflag= 1L;
		rstatement= catlist(2L,GC_PUSHS(rstatement),map_quotes(&saistatement));
		popnumber(&iscopy_toflag);
		map_whitespace(&rstatement);
		}/* get block quoted label */
	if (*saistatement==*semicolon) rstatement= catlist(2L,GC_PUSHS(rstatement),GC_PUSHS(LOP(saistatement)));
	}/* suck in BEGIN/END statement */

   else if (h==hwhile)
	{/* suck in WHILE statement */
	rstatement= catlist(2L,GC_PUSHS(rstatement),copy_either(GC_PUSHS(";,do"),&brkstr));
	rstatement= catlist(2L,GC_PUSHS(rstatement),GC_PUSHS(brkstr));
	if (fast_equ(GC_PUSHS(brkstr),GC_PUSHS("do")))
		{/* is While be Do s1 */
		push(GC_PUSHS(rstatement));
		s= GC_EPOPS(rightstatement());
		pop(&rstatement);
		rstatement= catlist(2L,GC_PUSHS(rstatement),GC_PUSHS(s));
		}/* is While be Do s1 */
	}/* suck in WHILE statement */

   else if (h==hcomment)
	{/* suck in COMMENT statement */
/*  # # @V.52.144	rStatement_rStatement & COPY!EITHER(semiColon,brkStr) */
	rstatement= catlist(2L,GC_PUSHS(rstatement),scan(&saistatement,10L,&ch));  /*  -- to <SC> */
	rstatement= catlist(2L,GC_PUSHS(rstatement),GC_PUSHS(brkstr= GC_EPOPS(makstr(ch))));  /*  -- add on the <SC> */
	continue;
	}/* suck in COMMENT statement */

   else if (h==hquote)
	{/* suck in QUOTED string */
	pushnumber(iscopy_toflag); iscopy_toflag= 1L;
	if (length(GC_PUSHS(rstatement))==1) rstatement= GC_EPOPS(map_quotes(&saistatement)
		); else rstatement= 
        					catlist(subst(GC_PUSHS(rstatement),1L,
        length(rstatement)-1L),map_quotes(&saistatement));
	popnumber(&iscopy_toflag);
/*  # # DBUG('10,"{"&CVS(rrLevel)&"}[RIGHTSTATEMENT].2.5 QUOTE token='"&token&CRLF&"' rStatement='"&rStatement&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
	continue;
	}/* suck in QUOTED string */

   else if (h==hcolon)
	{/* suck in LABEL or RECORD class */
/*  # # DBUG('10,"{"&CVS(rrLevel)&"}[RIGHTSTATEMENT].2.6 COLON token='"&token&CRLF&"' rStatement='"&rStatement&"'"&CRLF&" saiStatement='"&saiStatement&"'") */
	continue;
	}/* suck in LABEL or RECORD class */

   else {/* suck in ';' statement */
	if (*token==';') brkstr= token; 

	else 	{/* handle non-empty statement */
GC_EPOPS(dbug(010L,catlist(15L,GC_PUSHS("{"),cvs(rrlevel),
        GC_PUSHS("}[RIGHTSTATEMENT].2.7 SEMICOLON token=\'"),
        GC_PUSHS(token),GC_PUSHS(crlf),GC_PUSHS("\' rStatement=\'"),
        GC_PUSHS(rstatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" saiStatement=\'"),GC_PUSHS(saistatement),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS(" isFRAGMENTflag="),
        pbool(isfragmentflag))));
		s2= GC_EPOPS(copy_either(GC_PUSHS(";,else,end,until"),&brkstr));
		if (*s2!='\0') rstatement= catlist(2L,GC_PUSHS(rstatement),GC_PUSHS(s2));
		if ((*brkstr!=*semicolon))
			{/* break on ELSE or END */
			if (*brkstr!='\0') saistatement= catlist(2L,GC_PUSHS(brkstr),GC_PUSHS(saistatement));
			}/* break on ELSE or END */
		else rstatement= catlist(2L,GC_PUSHS(rstatement),GC_PUSHS(brkstr));
		}/* handle non-empty statement */
	}/* suck in ';' statement */
GC_EPOPS(dbug(010L,catlist(12L,GC_PUSHS("{"),cvs(rrlevel),
        GC_PUSHS("}[RIGHTSTATEMENT].3 saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  rStatement=\'"),GC_PUSHS(rstatement),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  isFRAGMENTflag="),
        pbool(isfragmentflag))));
  break;				/*  -- Do once unless CONTINUE!!! */
  }/* munch it up to end of SAIL statement */

GC_EPOPS(dbug(010L,catlist(13L,GC_PUSHS("{"),cvs(rrlevel),
        GC_PUSHS("}[RIGHTSTATEMENT].4 saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS("  rStatement=\'"),GC_PUSHS(rstatement),
        GC_PUSHS("\'"),GC_PUSHS(crlf),GC_PUSHS("  line=\'"),
        GC_PUSHS(line),GC_PUSHS("\'"))));
/* NO-OP */;
popnumber(&cnt);
popnumber(&isrightstatementflag);

/*  --	Do input stream maintenance. If there is stuff left in
	saiStatement, we must put it away for later extraction by
	the GET!NEXT!STATEMENT procedure */
if ((*saistatement!='\0') &&(!ismacroflag) &&(rdlevel<1) &&
   (rrlevel==1))
	{/* save it for later */
	if (*line=='\0') line= saistatement; 
		else line= catlist(2L,GC_PUSHS(saistatement),GC_PUSHS(line));
	saistatement= PNULL;
GC_EPOPS(dbug(010L,catlist(5L,GC_PUSHS("{"),cvs(rrlevel),
        GC_PUSHS("}[RIGHTSTATEMENT].5 line=\'"),GC_PUSHS(line),
        GC_PUSHS("\'"))));
	}/* save it for later */

--rrlevel;			/*  -- Leaving this level */
if (spdlptr!=(*aChkI(spdlcheck,1L,rdlevel+rrlevel+1L))||
   npdlptr!=(*aChkI(npdlcheck,1L,rdlevel+rrlevel+1L))) 
	{/* fatal error */
/*  # # 	isMACROflag_FALSE */		/*  -- force it to barf! */
	err_hlr(GC_PUSHS(
        		catlist(GC_PUSHS(
        "[RIGHTSTATEMENT] DRYROT! initial sPDLptr="),
        cvs((*aChkI(spdlcheck,1L,rdlevel))),
        GC_PUSHS(" final sPDLptr="),cvs(spdlptr),GC_PUSHS(crlf),
        GC_PUSHS(" initial nPDLptr="),cvs((*aChkI(npdlcheck,1L,
        rdlevel))),GC_PUSHS(" final nPDLptr="),cvs(npdlptr),
        GC_PUSHS(crlf),GC_PUSHS(" rdLevel="),cvs(rdlevel),
        GC_PUSHS(" rrLevel="),cvs(rrlevel),GC_PUSHS(" blockLevel="),
        cvs(blocklevel),GC_PUSHS(crlf),GC_PUSHS(" saiStatement=\'"),
        GC_PUSHS(saistatement),GC_PUSHS("\'"),GC_PUSHS(crlf),
        GC_PUSHS(" cStatement=\'"),GC_PUSHS(cstatement),GC_PUSHS(
        "\'"))));
	spdlptr= (*aChkI(spdlcheck,1L,rdlevel+rrlevel+1L));    /*  -- FIX UP in case
						   continue */
	}/* fatal error */

;
GC_SRETURN(rstatement)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 's1'=<L0> string                              */
/* 'brk'=<L0> integer                            */
/*************************************************/

#undef get_this_token
}/* RIGHTSTATEMENT */
