/* FILE: run_time.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psdbug.c, being converted 12/25/87, 01:13:54PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*   --------------------------------------- */
/*INTERNAL*/  STRING run_time()
/*   --------------------------------------- */
{/* RUN!TIME */
/*  --
.LABEL [<++PSAIL PROCEDURE: RUN!TIME>]
.INDEX ++PSAIL PROCEDURE: RUN!TIME
DESCRIPTION:
	Call TOPS10 for cpu run-time and return it as
		Eg.	HH:MM:SS
If /REPORT is specified as well, then the number of times the String
Garbage Collector was called nnn is added to this as well:
		Eg.	HH:MM:SS-GCnnn

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: RUN!TIME>]
 */
extern  INTEGER /*ARRAY*/ *gogtab  /* [0:256] */ ;   /*  -- SAIL USER TABLE --- N.P. */
#define sgccnt 0112
STRING s;
INTEGER seconds, 
	time, 
	minutes, 
	hours, 
	p, 
	q;

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
time= callsys(0L,GC_PUSHS("RUNTIM"))/1000L;
                        /*  -- CPU time in Msec cvted to Seconds. */
hours= time/3600L;
minutes= (time-3600*hours)/60L;
seconds= time -3600*hours -60*minutes;

getformat(&p,&q);
setformat(-2L,2L);
s= catlist(6L,GC_PUSHS("/*"),cvs(hours),GC_PUSHS(":"),cvs(minutes),
        GC_PUSHS(":"),cvs(seconds));
setformat(p,q);
if (usereportflag)
  s= catlist(3L,GC_PUSHS(s),GC_PUSHS("-GC"),cvs((*aChkI(gogtab,1L,0112L))));
s= catlist(2L,GC_PUSHS(s),GC_PUSHS("*/"));

{aryfree(gogtab,(INTEGER *)0);  /* Free List of Dynamic Arrays */
 GC_SRETURN(s);
}
#undef sgccnt
}/* RUN!TIME */
