/* FILE: set_extensions.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psinit.c, being converted 12/25/87, 01:41:42PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ----------------------------------------------------- */
/*INTERNAL*/  void set_extensions(addthemflag)
	INTEGER addthemflag;
/*  ----------------------------------------------------- */
{/* SET!EXTENSIONS */
/*  --
.LABEL [<++PSAIL PROCEDURE: SET!EXTENSIONS>]
.INDEX ++PSAIL PROCEDURE: SET!EXTENSIONS
DESCRIPTION:
	If /EXTENSIONS flag was set, then add the L3 extensions whose
symbols are in PSEXTN.INI and also set up hash integers.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: SET!EXTENSIONS>]
 */
STRING s, 
	s1, 
	sdata;

;

GC_EPOPS(dbug(01L,catlist(3L,GC_PUSHS("[SET!EXTENSIONS] addThemFlag=\'"),
        makstr(addthemflag),GC_PUSHS("\'"))));

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(sdata); /* for G.C. */
if (!addthemflag) 
	{/* /NOEXTENSIONS */
	hc_array= -1L;
	hgeneric= -1L;
	hprocss= -1L;
	hrepeatable= -1L;
	huntyped= -1L;
	{GC_UNMARKSSTKFRAME;
	 GC_RETURN(s);}
	}/* /NOEXTENSIONS */

else 	{/* /EXTENSIONS */
	if (blocklevel>1) err_hlr(GC_PUSHS(
  catlist(3L,
          GC_PUSHS("[SET!EXTENSIONS] - sorry, you can not add /EXTENSIONS to PSAIL")
          ,GC_PUSHS(crlf),
          GC_PUSHS("from an inner block because it corrupts the symbol table."))));
	/*  -- add the symbols from the .INI file */
	s= PNULL;
	if (*((sdata= GC_EPOPS(readfile(GC_PUSHS("PSEXTN.INI")))))=='?') PSprintf("%s%s",GC_PUSHS(sdata),GC_PUSHS(crlf)); 
	else s= sdata;
	push(GC_PUSHS(lastprocedure));
	while (*((s1= GC_EPOPS(scan(&s,1L,&saibrk))))!='\0')
		add_builtin(GC_PUSHS(s1));
	pop(&lastprocedure);

	/*  -- add the L3 hash integers */
	hc_array = hash_c(GC_PUSHS("c_array"));
	hgeneric = hash_c(GC_PUSHS("generic"));
	hprocss = hash_c(GC_PUSHS("process"));
	hrepeatable = hash_c(GC_PUSHS("repeatable"));
	huntyped = hash_c(GC_PUSHS("untyped"));
	}/* /EXTENSIONS */

;
{GC_UNMARKSSTKFRAME;}
}/* SET!EXTENSIONS */
