/* FILE: simple_map.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psparse.c, being converted 12/25/87, 09:34:41PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  --------------------------------------------------- */
/*INTERNALv*/  STRING simple_map(hh)
	INTEGER hh;
/*  --------------------------------------------------- */
{/* SIMPLE!MAP */
/*  --
.LABEL [<++PSAIL PROCEDURE: SIMPLE!MAP>]
.INDEX ++PSAIL PROCEDURE: SIMPLE!MAP
DESCRIPTION:
	Do a simple map of hashed symbol indicated by is hash number
hh. If the lastType is different from declDW[idx], then set
declDW[idx] to lastType. We do this in order to pass on inherited
types to tokens with no type.

SIDE-EFFECTS:
	It will set 'lastType' to the DW of the symbol if the old type
code is NULL. Otherwise if the old code was non-null and the code of
'lastType' is null then set 'lastType' to the declDW[] of this symbol.
@V.56.114 - Note: don't do it if fsm bit is set.

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: SIMPLE!MAP>]
 */
STRING s;
INTEGER idx, 
	oldcode, 
	oldptype;

;

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
idx= (*aChkI(dwptr,1L,hh));
s= (*aChkC(declcsym,1L,idx));

oldptype= (*aChkI(decldw,1L,idx));
if (((oldcode= (((ps_itrash_= (lasttype&037))>0) ? (ps_itrash_+0140L)
				:0L))==0) &&(oldptype!=0)) lasttype= oldptype; 

else if ((oldcode!=0) &&
	(oldptype&0100L)==0 &&
        ((((ps_itrash_= (oldptype&037))>0) ? (ps_itrash_+0140L)
				:0L)!=oldcode)) pdw_ptype((*aChkI(decldw,1L,idx)),(((ps_itrash_= (lasttype&037))>0) ? (ps_itrash_+0140L)
				:0L));
/*  # # @V.56.98 (before was) 	Then PDW!pType(declDW[idx],lastType)
 */
GC_EPOPS(dbug(010000L,catlist(21L,GC_PUSHS("[SIMPLE!MAP] token=\'"),
			      GC_PUSHS(*aChkC(saisym,1L,hh)),
			      GC_PUSHS("\' s=\'"),
			      GC_PUSHS(s),GC_PUSHS("\'"),
			      GC_PUSHS(crlf),GC_PUSHS("  oldCode=\'"),
			  GC_PUSHS(ps_strash_=GC_EPOPS(makstr(oldcode))),
			      GC_PUSHS("\' oldPtype=\'"),
			  GC_PUSHS(ps_strash_=GC_EPOPS(makstr(oldptype))),
			      GC_PUSHS("\' declNargs[idx]=\'"),
			      cvs((*aChkI(declnargs,1L, idx))),
			      GC_PUSHS("\'"),GC_PUSHS(crlf),
			      GC_PUSHS("  declDW[idx]=\'"),
			      cvtypes((*aChkI(decldw,1L, idx))),
			      GC_PUSHS("\'"),GC_PUSHS(crlf),
			      GC_PUSHS("  lastType=\'"),
			      cvtypes(lasttype),GC_PUSHS("\'"))));


GC_SRETURN(s)
}/* SIMPLE!MAP */
