/* FILE: stop_time.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psdbug.c, being converted 12/25/87, 01:13:54PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------------- */ 
/*INTERNAL*/  STRING stop_time(tday1,trun1)
	INTEGER tday1;
	INTEGER trun1;
/*  ------------------------------------------------- */ 
{/* STOP!TIME */
/*  --
.LABEL [<++PSAIL PROCEDURE: STOP!TIME>]
.INDEX ++PSAIL PROCEDURE: STOP!TIME
DESCRIPTION:
	Return the time in seconds where we are given the initial
times set by START!TIME. Note: tDay1 and tRun1 are initial times in
milliSeconds.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: STOP!TIME>]
 */
STRING s;
INTEGER hours, 
	minutes, 
	seconds, 
	run, 
	cpu;

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
setformat(-2L,2L);
if ((run= (callsys(0L,GC_PUSHS("MSTIME"))-tday1)/1000L)<0)
  run = run+86400L;	/*  -- we "ROCKED AROUND THE CLOCK..."  */
hours= run/3600L;
minutes= (run-(hours*3600L))/60L;
seconds= (run-(hours*3600L)-(minutes*60L));

s= catlist(7L,GC_PUSHS("Real TIME ="),cvs(hours),GC_PUSHS(":"),
	   cvs(minutes),GC_PUSHS(":"),cvs(seconds),GC_PUSHS(" "));

cpu= (callsys(0L,GC_PUSHS("RUNTIM"))-trun1)/1000L;
hours= cpu/3600L;
minutes= (cpu-(hours*3600L))/60L;
seconds= (cpu-(hours*3600L)-(minutes*60L));
s= catlist(7L,GC_PUSHS(s),GC_PUSHS("CPU TIME  ="),cvs(hours),
	   GC_PUSHS(":"),cvs(minutes),GC_PUSHS(":"),cvs(seconds));
setformat(0L,3L);
s= catlist(5L,GC_PUSHS(s),GC_PUSHS(",  "),cvf((cpu/run)*100.0),
	   GC_PUSHS("%"),GC_PUSHS(crlf));
setformat(0L,0L);
GC_SRETURN(s)
}/* STOP!TIME */
