/* FILE: todays_date.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psdbug.c, being converted 12/25/87, 01:13:54PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*   --------------------------------------- */
/*INTERNAL*/ STRING todays_date()
/*   --------------------------------------- */
{/* TODAYS!DATE */
/*  --
.LABEL [<++PSAIL PROCEDURE: TODAYS!DATE>]
.INDEX ++PSAIL PROCEDURE: TODAYS!DATE
DESCRIPTION:
	Call TOPS10 for time and date. Return time and date strings.
Also has the side-effect of setting timeRun and timeDay in
milli-seconds.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: TODAYS!DATE>]
 */
STRING s, 
	ampm;
INTEGER tds, 
	datec, 
	seconds, 
	minutes, 
	hours, 
	hyear, 
	hmonth, 
	hday;

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(ampm); /* for G.C. */

datec= callsys(0L,GC_PUSHS("DATE"));      /*  -- DEC10 TOPS10 coded date */
timeday= callsys(0L,GC_PUSHS("MSTIME"));  /*  -- Wall time in Msec */
timerun= callsys(0L,GC_PUSHS("RUNTIM"));  /*  -- CPU time in Msec. */

tds= timeday/1000L;  		/*  -- Wall time converted to SEC */
hours= tds/3600L;
minutes= (tds-3600*hours)/60L;
seconds= tds -3600*hours -60*minutes;

hday= (datec %31L)+1L;
hmonth= (datec/7L)+1L;
hyear= (datec/372L)+1964L;

if (hours>12)
	{/* PM */
	hours -= 12;
	ampm= "PM";
	}/* PM */
	else ampm= "AM";

setformat(-2L,2L);
s= catlist(12L,cvs(hmonth),GC_PUSHS("/"),cvs(hday),GC_PUSHS("/"),
	   cvs(hyear-1900L),GC_PUSHS(", "),cvs(hours),GC_PUSHS(":"),
	   cvs(minutes),GC_PUSHS(":"),cvs(seconds),GC_PUSHS(ampm));
setformat(0L,0L);
GC_SRETURN(s)
}/* TODAYS!DATE */
