/* FILE: uniqdeclarations.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    April 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: pschek.c, being converted 12/25/87, 02:41:52PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*   --------------------------------------- */
/*INTERNAL*/  STRING uniqdeclarations(nsize)
	INTEGER nsize;
/*   --------------------------------------- */

{/* UNIQDECLARATIONS */
/*  --
.LABEL [<++PSAIL PROCEDURE: UNIQDECLARATIONS>]
.INDEX ++PSAIL PROCEDURE: UNIQDECLARATIONS
DESCRIPTION:
	Procedure to check unique length of all declared symbols and
note those longer than 'size' which are not unique.
	[1] List active declared VISIBLE symbols for EACH procedure
	    if the size is < 0.
	[2] If /Unique:n then convolve it to find if there are
	    problems between VISIBLE names.
	[3] List all problem id name pairs which are not unique
            in an upper diagonal enumeration.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:
	@V.56.02 could save string space by using a tmp file to save
accumulated non-unique declarations found in each block then read it
back at the end in the final dump.

.ENDLABEL [<++PSAIL PROCEDURE: UNIQDECLARATIONS>]
 */
INTEGER i, 
	j, 
	mins, 
	maxs, 
	brk, 
	dw, 
	hlastprocedure, 
	hmainbody,
	builtinidx, 
	dwi, 
	dwj, 
	sz, 
	lth, 
	ivar, 
	size, 
	nfound;
STRING mystars, 
	s, 
	s1, 
	s2, 
	s3, 
	suniq, 
	s1sized, 
	s2sized;

;

GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(mystars); /* for G.C. */
GC_NOTESTRING(s); /* for G.C. */
GC_NOTESTRING(s1); /* for G.C. */
GC_NOTESTRING(s2); /* for G.C. */
GC_NOTESTRING(s3); /* for G.C. */
GC_NOTESTRING(suniq); /* for G.C. */
GC_NOTESTRING(s1sized); /* for G.C. */
GC_NOTESTRING(s2sized); /* for G.C. */
size= ABS(nsize);		/*  -- note nSize<0 means list SYMBOLS */
mystars= subsr(GC_PUSHS(stars),1L,64L);	/*  -- get just what we need... */
hlastprocedure= hash_c(GC_PUSHS(lastprocedure));
hmainbody= hash_c(GC_PUSHS("<main>"));
builtinidx= (*aChkI(dcllocstkframe,1L,0L));	/*  -- i.e. end of built in symbols */
GC_EPOPS(dbug(010000000L,catlist(17L,GC_PUSHS("[UNIQDECLARATIONS] size="),cvs(size),
        GC_PUSHS(crlf),GC_PUSHS(" lastProcedure=\'"),
        GC_PUSHS(lastprocedure),GC_PUSHS("\' hLastProcedure="),
        cvs(hlastprocedure),GC_PUSHS(" saiSym[h...]=\'"),
        GC_PUSHS(*aChkC(saisym,1L,hlastprocedure)),GC_PUSHS("\'"),
        GC_PUSHS(crlf),GC_PUSHS("  dclSymPtr="),cvs(dclsymptr),
        GC_PUSHS(" prevDclSymPtr="),cvs(prevdclsymptr),
        GC_PUSHS(" builtinIdx="),cvs(builtinidx))));

if (!uniqflag ||(dclsymptr==prevdclsymptr&&blocklevel>0)) GC_SRETURN(PNULL)

suniq= catlist(11L,GC_PUSHS(crlf),GC_PUSHS("/* "),GC_PUSHS(mystars),
        GC_PUSHS(" */\15\12\
/* SYMBOLS DECLARED IN BLKLVL{"
        /*N.P.*/),cvs(blocklevel),GC_PUSHS("} IN PROC#["),
        cvs(((blocklevel==0) ? nprocedures+1L : nprocedures)),
        GC_PUSHS("] "),GC_PUSHS(lastprocedure),GC_PUSHS("() */"),
        GC_PUSHS(crlf));

douniquetest= 0L;	/*  -- disable it each time called... */


/*  ------------------------------ */
/*  --	[1] List legal symbols. */
/*  ------------------------------ */

mins= dclsymptr+1L;	/*  --  set up extrema */
maxs= -1;
if ((blocklevel==0)) suniq= catlist(2L,GC_PUSHS(suniq),
        GC_PUSHS("\15\12\
/*	L I S T   O F   G L O B A L   D E C L A R A T I O N S	*/\15\12\
"
        /*N.P.*/));

ivar= 0;			/*  -- count of variable symbols this block */
for (i=dclsymptr+1L;i<=prevdclsymptr;i++)
	{/* scan list */
/*  # # DBUG('10000000,"[UNIQDECLARATIONS].0.1 "&PRT!NODE(declHash[i])) */
	if ((hlastprocedure==(*aChkI(declinproc,1L,i))) &&(i>builtinidx)) 
		{/* list symbols */
		++ivar;
		s3= catlist(9L,GC_PUSHS("/* ["),cvs(ivar),GC_PUSHS("] "),GC_PUSHS("\'"),
        GC_PUSHS(*aChkC(saisym,1L,(*aChkI(declhash,1L,i)))),
        GC_PUSHS("\'"),GC_PUSHS(" ["),cvtypes((*aChkI(decldw,1L,i)))
        ,GC_PUSHS("]"));
		if ((lth= length(GC_PUSHS(s3)))<66) s3= catlist(2L,GC_PUSHS(s3),subsr(GC_PUSHS(ps_spaces),1L,(66-lth)));
		suniq= catlist(4L,GC_PUSHS(suniq),GC_PUSHS(s3),GC_PUSHS(" */"),GC_PUSHS(crlf));
		mins=MIN(mins,i);
		maxs=MAX(maxs,i);
		}/* list symbols */
	}/* scan list */

/*  # # DBUG('10000000,"[UNIQDECLARATIONS].1  minS="&CVS(minS)&" maxS="&CVS(maxS)) */


/*  -------------------------------------------------------------- */
/*  --	[2] If /Unique:n then convolve lists to find a problem.
# --     Test symbols against each other.  */
/*  -------------------------------------------------------------- */
nfound= 0;		/*  -- number of uniqueness problems found */
suniq= catlist(2L,GC_PUSHS(suniq),GC_PUSHS(crlf));
for (i=mins;i<=maxs;i++)
	{/* test i */
	s1= (*aChkC(saisym,1L,(*aChkI(declhash,1L,i))));
	dwi= (*aChkI(decldw,1L,i));
	if (dwi&01L) sz= (MIN(6L,size)); 
		else sz= size;
	if (length(GC_PUSHS(s1))<sz) continue;
	s1sized= subst(GC_PUSHS(s1),1L,sz);  /*  -- Get <unique-test-pattern> */
	/*  -- NOTE: we DO allow exact matches since an exact match
	is an override symbol with the same name and is no problem... */
	for (j=i+1L;j<=maxs;j++)
		{/* test symbol j */
		s2= (*aChkC(saisym,1L,(*aChkI(declhash,1L,j))));
		dwj= (*aChkI(decldw,1L,j));
	if (dwj&01L) sz= (MIN(6L,size)); 
		else sz= MIN(size,sz);
		if (length(GC_PUSHS(s2))<sz) continue;
		s2sized= subst(GC_PUSHS(s2),1L,sz);
/*  # # DBUG('10000000,"[UNIQDECLARATIONS].2 s1='"&s1&"' s1Sized='"&s1Sized&"' s2='"&s2&" s2Sized='"&s2Sized&"' sz="&CVS(sz)) */
		if (equ(GC_PUSHS(s1sized),GC_PUSHS(s2sized)) &&!equ(GC_PUSHS(s1),GC_PUSHS(s2))) 
			{/* make a different entry */
			s3= 
        				catlist(GC_PUSHS("/* NOT UNIQUE ["),subst(GC_PUSHS(
        *aChkC(saisym,1L,(*aChkI(declhash,1L,i))))),1L,sz,
        cvupcase(GC_PUSHS((subst(GC_PUSHS(*aChkC(saisym,1L,
        (*aChkI(declhash,1L,i))))),sz+1L,length(*aChkC(saisym,1L,
        (*aChkI(declhash,1L,i)))))))),GC_PUSHS("<"),
        GC_PUSHS(*aChkC(saisym,1L,(*aChkI(declinproc,1L,i)))),
        GC_PUSHS("()> : "),subst(GC_PUSHS(*aChkC(saisym,1L,
        (*aChkI(declhash,1L,j))))),1L,sz,
        cvupcase(GC_PUSHS((subst(GC_PUSHS(*aChkC(saisym,1L,
        (*aChkI(declhash,1L,j))))),sz+1L,length(*aChkC(saisym,1L,
        (*aChkI(declhash,1L,j)))))))),GC_PUSHS("<"),
        GC_PUSHS(*aChkC(saisym,1L,(*aChkI(declinproc,1L,j)))),
        GC_PUSHS("()>"),GC_PUSHS("] */"),GC_PUSHS(crlf));
		   if ((lth= length(GC_PUSHS(s3)))<66) s3= catlist(2L,GC_PUSHS(s3),subsr(GC_PUSHS(ps_spaces),1L,(lth-66L)));
		suniq= catlist(2L,GC_PUSHS(suniq),GC_PUSHS(s3));
		nouqprocedures= catlist(2L,GC_PUSHS(nouqprocedures),GC_PUSHS(s3));
		++cntunique;  /*  -- number found in file */
		++nfound;	/*  -- number found this block */
			}/* make a different entry */
		}/* test symbol j */
	}/* test i */



/*  ---------------------------------------------- */
/*  --	[3] List all PROBLEMS at the very end. */
/*  ---------------------------------------------- */
if (blocklevel==0) suniq= catlist(11L,GC_PUSHS(suniq),GC_PUSHS(crlf),GC_PUSHS("/*	Total of "),
        cvs(cntunique),GC_PUSHS(" symbol pairs not unique to "),
        cvs(size),GC_PUSHS(" characters. */"),GC_PUSHS(crlf),
        GC_PUSHS(crlf),GC_PUSHS(nouqprocedures),GC_PUSHS(crlf));

suniq= catlist(5L,GC_PUSHS(suniq),GC_PUSHS("/* "),GC_PUSHS(mystars),
        GC_PUSHS(" */"),GC_PUSHS(crlf));

GC_EPOPS(dbug(010000000L,catlist(8L,GC_PUSHS("[UNIQDECLARATIONS].3 nFound="),cvs(nfound),
        GC_PUSHS(" cntUnique="),cvs(cntunique),GC_PUSHS(crlf),
        GC_PUSHS(" sUniq=\'"),GC_PUSHS(suniq),GC_PUSHS("\'"))));
if ((nfound==0) &&(nsize>=0)) suniq= PNULL;	/*  -- OOPs, they don't want to see it! */

GC_SRETURN(suniq)
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 's'=<L0> string                               */
/* 'dw'=<L0> integer                             */
/* 'brk'=<L0> integer                            */
/*************************************************/
}/* UNIQDECLARATIONS */
