/* FILE: watch_print.c
                            Peter Lemkin 

                   Image Processing Section, DCBD
                      National Cancer Institute
                        FCRF Bld 469, Rm 150B
                         Frederick, MD 21701

			    June 7, 1987

     COPYRIGHT NOTICE - Copyright (c) 1983-1988 by Peter F. Lemkin.
                        All rights reserved.
	Permission is granted to any individual or institution to
        copy, use or modify this program, except for explicitly
        commercial purposes, provided this copyright notice is
        included in its entirety in all derived works.  No warranty
        of the software or of the accuracy of any documentation
        surrounding it is expressed or implied, and the author does
        not acknowledge any liability resulting from program or
        documentation errors.

	      Revised January 3, 1988
              Derived from PSAIL.SAI V.43.50   7-19-84
 */


/* File: psdbug.c, being converted 12/25/87, 01:13:54PM*/
/* PSAIL compiler, version: June 9, 1987 V.57.10(OPTIMIZED) 	*/

#include "pshead.h"	/* header file to include other header files */


/*  ------------------------------------------ */
/*INTERNAL*/ void watch_print(title)
	STRING title;
/*  ------------------------------------------ */
{/* WATCH!PRINT */
/* IFC EVAL(dowatch=true)=0 */
 /* THENC <<<FAILED!!!>>>

require "'WATCH!PRINT' is enabled by 'DOWATCH=TRUE'" message;
comment  --
.LABEL [<++PSAIL PROCEDURE: WATCH!PRINT>]
.INDEX ++PSAIL PROCEDURE: WATCH!PRINT
DESCRIPTION:
	If enabled, then print the profile of the procedures in
PSAIL. The other macros WATCH!ON, WATCH!OFF(name) and parameters are
defined in PSMACRO.REQ.

SIDE-EFFECTS:

PROBLEMS/KNOWN-BUGS:

.ENDLABEL [<++PSAIL PROCEDURE: WATCH!PRINT>]
;
safer string array proc[1:maxwatch];
string s;
integer i, j, k, maxprocnamelth;
real ttime, cputime, cnf;

s:=readfile("PSPRFL.TXT");	comment  -- keep titles here to save space;
i:=1;
while (s neq null) do 
	proc[(i:=i+1)-1]:=scan(s,1,j);   		comment  -- one/line;

comment  ------------------------------------------------------;
comment  	Bubble sort the list of (proc[],w!time[],w!count[]) by
#	MAXIMUM TIME!;
comment  ------------------------------------------------------;
for i:=maxwatch-1 step -1 until 1 do
	begin "outer loop"
	for j:=maxwatch-1 step -1 until 1 do
		if (w_time[j] < w_time[j+1])
			then
			begin "swap j and j+1"
			s:=proc[j+1]; proc[j+1]:=proc[j]; proc[j]:=s;
			w_time[j+1] swap w_time[j];
			w_count[j+1] swap w_count[j];
			end "swap j and j+1";
	end "outer loop";

ttime := maxprocnamelth := 0;
for i:=1 step 1 until maxwatch do 
	begin "Compute total accounted time"
	ttime:=ttime + w_time[i];  comment  -- total accounted for in TICKS;
	maxprocnamelth:=maxprocnamelth max length(proc[i]);
	end "Compute total accounted time";

cputime:=(timstoprun-timstartrun)/1000.0;
cnf:=(ttime/1000.0)/cputime;	comment  -- Complexity Nesting Factor;

s:=crlf&"--- WATCH: "&title&crlf&
   "PROCEDURE accounting system was on with the following times"&crlf&
   "given with "&crlf;

setformat(0,2);
s:=s&"	" & cvs(cputime)&" Sec. total CPU time," & crlf & 
   "	" & cvs(ttime/1000.0)&" Sec. total accounted CPU time," & 
						crlf & 
   "	" & cvf(cnf) &
	" = Complexity Nesting Factor = Accounting time/CPU time."&crlf&
							crlf;
s:=s&
"                         TOTAL ACCT  %TOTAL  AVG TIME   NUMBER "&crlf&
"RANK PROCEDURE NAME      TIME(Sec)   cpuTIME PER CALL   CALLS  "&crlf&
"---- --------------      ---------   ----------------   -----  "&crlf;

if not nuldevflag
	then out(cchan,s);

for i:=1 step 1 until maxwatch do
	begin "print entry"
	setformat(3,0);
	s:=cvs(i) & "  ";
	s:=s&proc[i] & ps_spaces[1 for maxprocnamelth-length(proc[i])];
	setformat(9,3);
	s:=s & cvf(w_time[i]/1000.0);
	setformat(7,2);
	s:=s & cvf(100.0*cnf*w_time[i]/ttime);
	setformat(12,3);
	s:=s & cvf(w_time[i]/(w_count[i]*1000.0));
	setformat(8,2);
	s:=s & cvs(w_count[i])&crlf;
	if not nuldevflag
		then out(cchan,s);
	end "print entry";

if not nuldevflag
	then out(cchan,ff&crlf);
setformat(0,0);
 */ /* ENDC */
GC_POPS(title); /* from GC string PDL */
GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
GC_NOTESTRING(title); /* for G.C. */
/*************************************************/
/*        U N U S E D    D E C L A R A T I O N S */
/* 'title'=<L0> formalArg string                 */
/*************************************************/

{GC_UNMARKSSTKFRAME;}
}/* WATCH!PRINT */
